﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


strconstant SpHrView_AtTime_DF = "root:SpHrView:AtTime:"
strconstant SpHrView_AtTime_DF_Globals = "root:SpHrView:AtTime:Globals:"

// =================================================================================================
// SpHrView_AtTime_Defaults(), defaults
// =================================================================================================
Function SpHrView_AtTime_Defaults()
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	
	SpHrView_IPDNeuron_Defaults()
	SpHrView_ILDNeuron_Defaults()
	
	// Make "SpHrView:AtTime" folder, SpHrView_df_cue
	if(!DataFolderExists(SpHrView_AtTime_DF))
		FolderStr= SpHrView_AtTime_DF[0,strlen(SpHrView_AtTime_DF)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:AtTime:Globals" folder, SpHrView_AtTime_DF_Globals
	if(!DataFolderExists(SpHrView_AtTime_DF_Globals))
		FolderStr= SpHrView_AtTime_DF_Globals[0,strlen(SpHrView_AtTime_DF_Globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_AtTime_DF_Globals
	String sval
	variable nval	
//	sval= StrVarOrDefault(SpHrView_AtTime_DF_Globals+"timeFrameStr", "")
//	string/G timeFrameStr = sval
	// Envelope weight defaults
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useAmpEnvelopeWts", 1)
	variable/G useAmpEnvelopeWts = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"EnvelopeWtActLimit", 5)
	variable/G EnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"EnvelopeWeightsdB", 1)
	variable/G EnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"usedtEnvelopeWts", 1)
	variable/G usedtEnvelopeWts = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"dtEnvelopeWtActLimit", 5)
	variable/G dtEnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"dtEnvelopeWeightsInterp", 1)
	variable/G dtEnvelopeWeightsInterp = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"dtEnvelopeWeightsdB", 1)
	variable/G dtEnvelopeWeightsdB = nval

	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useIPDs", 0)
	variable/G useIPDs = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useILDs", 1)
	variable/G useILDs = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useCarrierCues", 1)
	variable/G useCarrierCues = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useEnvelopeCues", 1)
	variable/G useEnvelopeCues = nval
	//	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"CuesPerCycle", 1)
	//	variable/G CuesPerCycle = nval
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"minEnvelopeFreq", 100)
	variable/G minEnvelopeFreq = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"maxCarrierFreq", 1500)
	variable/G maxCarrierFreq = nval
	
	NVAR lowFreq = $SpHrView_df_filter+"lowFreq"
	minEnvelopeFreq = max(minEnvelopeFreq,lowFreq)
	NVAR highFreq = $SpHrView_df_filter+"highFreq"
	maxCarrierFreq = min(maxCarrierFreq,highFreq)
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ScaledCarrierActivityLimit", 0)
	variable/G ScaledCarrierActivityLimit = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ScaledEnvelopeActivityLimit", 0)
	variable/G ScaledEnvelopeActivityLimit = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ActivityLimit", 5)
	variable/G ActivityLimit = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"InterhemiphericCoordination", 1)
	variable/G InterhemiphericCoordination = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AverageToEnd", 1)
	variable/G AverageToEnd = nval
		
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ScaleIPDToITD", 1)
	variable/G ScaleIPDToITD = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ScaleILDtoITD", 1)
	variable/G ScaleILDtoITD = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"numITDBins", 401)
	variable/G numITDBins = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"maximumITDms", 1.0)
	variable/G maximumITDms = nval
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getEdges", 1)
	variable/G getEdges = nval	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useMaximalLablesForEdges", 0)
	variable/G useMaximalLablesForEdges = nval	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getMaxima", 0)
	variable/G getMaxima = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"useEdgeLablesForMaxima", 0)
	variable/G useEdgeLablesForMaxima = nval
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getSDs", 0)
	variable/G getSDs = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getCarrierAccruals", 0)
	variable/G getCarrierAccruals = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getEnvelopeAccruals", 0)
	variable/G getEnvelopeAccruals = nval
	
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"DisplayActivitiesMode", 0)
	variable/G DisplayActivitiesMode = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"DisplayCuesMode", 0)
	variable/G DisplayCuesMode = nval
	sval= StrVarOrDefault(SpHrView_AtTime_DF_Globals+"ColorTableStr", "Turbo") // "GrayBlueGreenRed" "Turbo"
	string/G ColorTableStr = sval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"ReverseColorTable", 0)
	variable/G ReverseColorTable = nval
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"Frequencyline", 1)
	variable/G Frequencyline = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"lineFrequency", 500)
	variable/G lineFrequency = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"lineFrequencyIndex", 0)
	variable/G lineFrequencyIndex = nval
	
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"getPeaks", 1)
	variable/G getPeaks = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AppendPeaks", 1)
	variable/G AppendPeaks = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AppendPeaksOppositeHemi", 1)
	variable/G AppendPeaksOppositeHemi = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"setPointsAtLimitsToNaN", 1)
	variable/G setPointsAtLimitsToNaN = nval
	
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AlphaMask_ABL", 1)
	variable/G AlphaMask_ABL = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Min", 50) // reset by SpHrView_AtTime_Activity()
	variable/G AlphaMask_ABL_Min = nval
	nval= NumVarOrDefault(SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Max", 50) // reset by SpHrView_AtTime_Activity()
	variable/G AlphaMask_ABL_Max = nval
	
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	if(waveexists(CFs))
		lineFrequency = min(lineFrequency, wavemax(CFs))
		lineFrequency = max(lineFrequency, wavemin(CFs))
		Variable index, Hz
		[index, Hz] = SpHrView_getCFindex(CFs, lineFrequency)
		lineFrequency = Hz
		lineFrequencyIndex = index
	endif
	
	SetDataFolder saveDFR
End



// =================================================================================================
// SpHrView_AtTime(), Edge model IPD
// =================================================================================================
Function SpHrView_AtTime(variable cursorUpdate)
	DFREF saveDFR = GetDataFolderDFR()
	SpHrView_AtTime_Defaults()
	
	string globals_dfStr = SpHrView_AtTime_DF_Globals
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
	NVAR getSDs = $globals_dfStr+"getSDs"
	NVAR getCarrierAccruals = $globals_dfStr+"getCarrierAccruals"
	NVAR getEnvelopeAccruals = $globals_dfStr+"getEnvelopeAccruals"
	
	variable selectionSum = getEdges+getMaxima+getSDs+getCarrierAccruals+getEnvelopeAccruals
	
	if(selectionSum <= 0)
		DoAlert/T="Warning" 0, "Must select Edges, SD, Maxima, or a combination"
		return 0
	endif
	

	NVAR minEnvelopeFreq = $globals_dfStr+"minEnvelopeFreq"
	NVAR maxCarrierFreq = $globals_dfStr+"maxCarrierFreq"
	
	
	String AtTimeWinList = SpHrView_GroupWindowsList("AtTimeWin")
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
			
	// if At time options window is open
	DoWindow AtTimeOptionsWindow
	if(v_flag)
		if(!useEnvelopeCues)
			killwindow/Z Envelope_Activity_Accrual
		endif
		if(!useCarrierCues)
			killwindow/Z Activity_Accrual
		endif

		// kill window if option deselected but window found
		if(!getCarrierAccruals && WhichListItem("Activity_Accrual", AtTimeWinList,";",0,0) >= 0)
			killwindow/Z Activity_Accrual
		endif
		if(!getEnvelopeAccruals && WhichListItem("Envelope_Activity_Accrual", AtTimeWinList,";",0,0) >= 0)
			killwindow/Z Envelope_Activity_Accrual
		endif
	
		killwindow/Z AtTimeOptionsWindow
		
	// if At time options window is NOT open
	else
		if(WhichListItem("Activity_Accrual", AtTimeWinList,";",0,0) >= 0 )
			getCarrierAccruals= 1
		endif
		if(WhichListItem("Envelope_Activity_Accrual", AtTimeWinList,";",0,0) >= 0)
			getEnvelopeAccruals= 1
		endif
	endif
	
	// Load waveforms from SpHrViewPeaksWindow
	variable startSec, endSec, usingAxis = 0
	if(cursorUpdate)
		[startSec, endSec, usingAxis] = SpHrView_AtTime_CursorLoadFromPeaks(cursorUpdate)
	else
		[startSec, endSec, usingAxis] = SpHrView_AtTime_CursorLoadFromPeaks(cursorUpdate) // SpHrView_LoadWaveformsFromPeaks()
	endif
	wave waveforms=$SpHrView_df_files+"waveforms"
	variable numCols = dimsize(waveforms,1)
	if(numCols>2)
		DoAlert 0, "SpHrView_Cues: waveform has > 2 channels/columns"
		return 0
	endif
	if(usingAxis)
		SpHrView_DrawSelection(2, startSec, endSec)
	else
		SpHrView_DrawSelection(1, startSec, endSec)
	endif
	
	//////////////////////////////////////////
	SpHrView_AtTime_Activities(waveforms)
	
	SpHrView_AtTime_ActivityWindow()
	
	// DisplayActivitiesMode 0:Halfmaximal, 1:SD, 2: Maximal
	// DisplayCuesMode 0: Carrier, 1: Envelope, 2: Carrier and Envelope
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
	NVAR DisplayCuesMode = $globals_dfStr+"DisplayCuesMode"
	
	DoWindow At_Time_Activities
	if(V_flag)
		if(getEdges)
			CheckBox ck_DisplayEdges win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplayEdges win=At_Time_Activities#PCBar, disable=2
			if(DisplayActivitiesMode==0)
				DisplayActivitiesMode = -1
			endif
		endif
		if(getSDs)
			CheckBox ck_DisplaySD win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplaySD win=At_Time_Activities#PCBar, disable=2
			if(DisplayActivitiesMode==1)
				DisplayActivitiesMode = -1
			endif
		endif
		if(getMaxima)
			CheckBox ck_DisplayMaxima win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplayMaxima win=At_Time_Activities#PCBar, disable=2
			if(DisplayActivitiesMode==2)
				DisplayActivitiesMode = -1
			endif
		endif
		
		if(useCarrierCues)
			CheckBox ck_DisplayCarrierActivities win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplayCarrierActivities win=At_Time_Activities#PCBar, disable=2
			if(DisplayCuesMode==0)
				DisplayCuesMode = -1
			endif
		endif
		if(useEnvelopeCues)
			CheckBox ck_DisplayEnvelopeActivities win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplayEnvelopeActivities win=At_Time_Activities#PCBar, disable=2
			if(DisplayCuesMode==1)
				DisplayCuesMode = -1
			endif
		endif
		if(useCarrierCues && useEnvelopeCues)
			CheckBox ck_DisplayCombinedActivities win=At_Time_Activities#PCBar, disable=0
		else
			CheckBox ck_DisplayCombinedActivities win=At_Time_Activities#PCBar, disable=2
			if(DisplayCuesMode==2)
				DisplayCuesMode = -1
			endif
		endif
	
	endif
	
	if(getCarrierAccruals && useCarrierCues)
		SpHrView_AtTime_AccrualWindow(0)	// Carrier
	endif
	if(getEnvelopeAccruals && useEnvelopeCues)
		SpHrView_AtTime_AccrualWindow(1) // Envelope
	endif
	
	if(cursorUpdate)
		DoWindow/F SpHrViewPeaksWindow
	endif
	
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_AtTime_CursorLoadFromPeaks(), Load wave named: waveforms, from SpHrViewPeaksWindow, into datafolder: SpHrView_df_files
// =================================================================================================
function [variable startSec, variable endSec, variable usingAxis] SpHrView_AtTime_CursorLoadFromPeaks(variable cursorUpdate)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_df_files
	variable minSec, maxSec
	// get selection if SpHrViewPeaksWindow is open
	// Marquee always overrides Cursor
	// Cursor overrides DrawAction if cursorUpdate is true
	// DrawAction overrides Cursor if cursorUpdate is false
	// Axis is last option  if cursorUpdate is false or Cursor is missing
	DoWindow SpHrViewPeaksWindow
	if(v_flag)
		string traceListStr= TraceNameList("SpHrViewPeaksWindow", ";", 1)
		string wStr =  StringFromList(0,traceListStr)
		wave w = TraceNameToWaveRef("SpHrViewPeaksWindow", wStr)
		string pathAndNameStr= SpHrView_FilePath_Get(w, 0) //note(w)
		// get min and max times
		minSec = DimOffset(w, 0)
		maxSec = DimSize(w, 0)*DimDelta(w, 0) + DimOffset(w, 0)
		GetMarquee/W=SpHrViewPeaksWindow/Z bottom
		//GetMarquee/Z bottom // allow marquee from another window...
		if(V_flag)
			startSec = v_left
			endSec = v_right
		else
			if(cursorUpdate && strlen(CsrInfo(A,"SpHrViewPeaksWindow")) > 0)
				NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
				NVAR ActivityLimit = $SpHrView_AtTime_DF_Globals+"ActivityLimit"
				variable numlWavelengthsAtLowestFreq = 10
				NVAR useEnvelopeCues = $SpHrView_AtTime_DF_Globals+"useEnvelopeCues"
				if(useEnvelopeCues > 0)	// 10 seems sufficient for carrier IPDs
					numlWavelengthsAtLowestFreq = 20 // 20 to account for envelope IPDs
				endif
				variable TimeFrame = (numlWavelengthsAtLowestFreq/lowFreq)*ActivityLimit 
				endSec = hcsr(A,"SpHrViewPeaksWindow")
				startSec = endSec - TimeFrame
			else
				DrawAction/W=SpHrViewPeaksWindow/L=UserBack extractOutline
				wave/Z W_PolyX=W_PolyX, W_PolyY=W_PolyY
				killwaves W_PolyY
				if(waveexists(W_PolyX) && dimsize(W_PolyX,0)==5) // object exists and is a square/rectangle
					startSec = wavemin(W_PolyX)
					endSec = wavemax(W_PolyX)
					killwaves W_PolyX
				else
					GetAxis /W=SpHrViewPeaksWindow/Q bottom
					//GetAxis/Q bottom // allow axis from another window...
					startSec = v_min
					endSec = v_max
					usingAxis = 1
				endif
			endif
		endif
	endif
	// make sure startSec and endSec are valid, since Marquees from other windows are being allowed.
	startSec = max(startSec, minSec)
	endSec = min(endSec, maxSec)
	
	variable longSelectionTrigger = 10 // should adapt this to highest freqeuncy being modeled (which are slower)  NVAR highFreq= $SpHrView_df_filter+"highFreq"
	if(useEnvelopeCues)
		longSelectionTrigger = 5
	endif
	
	if(endSec - startSec > longSelectionTrigger)
		String WarningStr; SPrintf WarningStr, "Use %g second selection?", endSec - startSec 
		DoAlert/T="Long selection warning" 1, WarningStr
		if(V_flag > 1)
			startSec = endSec - 1 	// should do something more useful here...
		endif
	endif
	
	// load waveforms
	SpHrView_LoadSoundFromFileWave(pathAndNameStr, SpHrView_df_files, "waveforms", startSec, endSec)
	wave waveforms=$SpHrView_df_files+"waveforms"
	NVAR fs= $SpHrView_df_globals+"fs"
	SetScale/P x startSec,1/fs,"s", waveforms
	
	killStrings/Z S_info
	SetDatafolder saveDFR
	
	//Printf "startSec= %g, endSec= %g\r", startSec, endSec
	
	return [startSec, endSec, usingAxis]
End

Function SpHrView_AtTime_Activities(wave waveforms)
	DFREF saveDFR = GetDataFolderDFR()
	string globals_dfStr = SpHrView_AtTime_DF_Globals
	
	variable fs = round(1/dimdelta(waveforms,0))
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	if(!waveexists(CFs))
		SpHrView_CenterFrequencies()
		wave CFs = $SpHrView_df_filter+"CFs"
	endif
	
	wave/Z FilterBanks = $SpHrView_df_filter+"FilterBanks"	
	NVAR filterbankUpdateFlag = $SpHrView_df_filter+"filterbankUpdateFlag"
	if(SpHr_DimensionsScaleCheck(FilterBanks, waveforms) || !waveexists(FilterBanks) || filterbankUpdateFlag)
		SpHr_FilterBankBiquadCoefs/W=$SpHrView_AtTime_DF+"FilterWidths" fs, CFs, coefBank // FilterWidths used for envelope activities
		SpHr_FilterBankBiquad /RMS/Dest=$SpHrView_df_filter+"FilterBanks" CFs, coefBank, waveforms  // FilterBanks written to SpHrView_df_filter
		wave FilterBanks = $SpHrView_df_filter+"FilterBanks"
		killwaves/Z coefBank
		if(!waveexists(FilterBanks))
			DoAlert 0, "FilterBanks wave is missing"
		endif	
	endif
	
	
	NVAR useIPDs = $globals_dfStr+"useIPDs"
	NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
	NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
	NVAR useILDs = $globals_dfStr+"useILDs"
	if(!useIPDs && !ScaleIPDToITD && !useILDs)
		DoAlert/T="Warning" 0, "Must select IPD, ITD, ILD, IPD & ILD, or ITD & ILD\r"
		return 0
	endif
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	if(!useCarrierCues && !useEnvelopeCues)
		DoAlert/T="Warning" 0, "Must select Carrier waveforms, Envelope waveforms, or both options\r"
		return 0
	endif
	
	// envelope weight variables
	NVAR useAmpEnvelopeWts = $globals_dfStr+"useAmpEnvelopeWts"
	NVAR EnvelopeWtActLimit = $globals_dfStr+"EnvelopeWtActLimit"
	NVAR EnvdB = $globals_dfStr+"EnvelopeWeightsdB"
	NVAR usedtEnvelopeWts = $globals_dfStr+"usedtEnvelopeWts"
	NVAR dtEnvelopeWtActLimit = $globals_dfStr+"dtEnvelopeWtActLimit"
	NVAR dtInterp = $globals_dfStr+"dtEnvelopeWeightsInterp"
	NVAR dtEnvdB = $globals_dfStr+"dtEnvelopeWeightsdB"
	variable EnvLimit = EnvelopeWtActLimit
	variable dtEnvLimit = dtEnvelopeWtActLimit
	if(!useAmpEnvelopeWts)
		EnvLimit = 0
	endif
	if(!usedtEnvelopeWts)
		dtEnvLimit = 0
	endif
	
	// Get IPD and/or ILD neurons, shifting ILD neuron 'labels' as needed to match IPD 'labels'
	if(useIPDs || ScaleIPDToITD  || ScaleILDtoITD)
		SpHrView_IPDNeurons(1)
		wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
		wave IPDLabels = $SpHrView_df_IPDNeuron+"IPDLabels"
		//wave MaxLabels = $SpHrView_df_IPDNeuron+"MaxLabels"
		NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
		NVAR IPDLabelShift = $SpHrView_df_IPDNeuron+"IPDLabelShift" // calculated shift in IPD labels (must equal ILDLabelShift)
	endif
	
	if(useILDs)
//		wave/Z ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
//		if(!waveexists(ILDNeurons))
//			SpHrView_ILDNeurons()
//		endif
		NVAR ILDLabelShift = $SpHrView_df_ILDNeuron+"ILDLabelShift" // calculated shift in ILD labels (must equal IPDLabelShift)
		if((useIPDs || ScaleIPDToITD) && IPDLabelShift != ILDLabelShift)
			if(IPDLabelShift != ILDLabelShift)
				NVAR minIpsi = $SpHrView_df_ILDNeuron+"minIpsiHalfmaxILDLabel"
				NVAR maxContra = $SpHrView_df_ILDNeuron+"maxContraHalfmaxILDLabel"
				NVAR ILDLabelShift = $SpHrView_df_ILDNeuron+"ILDLabelShift"
				ILDLabelShift = IPDLabelShift
				SpHrView_ILDNeurons()
				
				//Variable actualMinIpsi = minIpsi - (minIpsi*ILDLabelShift)
				//Variable actualMaxContra = maxContra - (maxContra*ILDLabelShift)
				//Printf "ILD 'labels' shifted (from "+num2str(minIpsi)+" and "+num2str(maxContra)+" dB to "+num2str(actualMinIpsi)+" and "+num2str(actualMaxContra)+" dB) to match IPD 'label' shift ("+num2str(IPDLabelShift)+")\r"
				//DoAlert/T="Warning" 0, "ILD 'labels' shifted (from "+num2str(minIpsi)+" and "+num2str(maxContra)+" dB to "+num2str(actualMinIpsi)+" and "+num2str(actualMaxContra)+" dB) to match IPD 'label' shift ("+num2str(IPDLabelShift)+")\r"
			else
				SpHrView_ILDNeurons()
			endif
		else
			SpHrView_ILDNeurons()
		endif
		wave ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
		wave ILDLabels = $SpHrView_df_ILDNeuron+"ILDLabels"
	endif
	
	// Make sure IPD (cycles) and ILD (dB) neurons have the same dimensions
	if((useIPDs || ScaleIPDToITD || ScaleILDtoITD) && useILDs)
		wave ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
		wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
		if(dimsize(IPDNeurons,0) != dimsize(ILDNeurons,0))
			DoAlert/T="Warning" 0, "Waves of IPD (cycles) and ILD (dB) neurons passed using the 'IPD=' and 'ILD=' keywords must have the same number of rows."
			return 0
		endif
		if(dimsize(IPDNeurons,0) != dimsize(ILDNeurons,0))
			DoAlert/T="Warning" 0, "Waves of IPD (cycles) and ILD (dB) neurons passed using the 'IPD=' and 'ILD=' keywords must have the same number of columns."
			return 0
		endif
	endif
	
	NVAR AlphaMask_ABL = $globals_dfStr+"AlphaMask_ABL" // ActivityAlpha option
	variable bitMask // bitMask for getting various cues
	
	// make two passes in case getting both carrier and envelope activities
	int isEnv=0, CueSet
	int numCueSets = useCarrierCues + useEnvelopeCues
	for(CueSet=0;CueSet<numCueSets;CueSet++)
		isEnv=0
		if(numCueSets == 2 && CueSet == 1)
			isEnv = 1
		elseif(numCueSets == 1 && useEnvelopeCues)
			isEnv = 1
		endif
		
		
		bitMask = 0
		bitMask = SpHr_BitSetRange(bitMask,0,1) 	// Xs and Ns
		if(useIPDs || ScaleIPDToITD)
			bitMask = SpHr_BitSet(bitMask,3)				// IPD
		endif
		if(useILDs)
			bitMask = SpHr_BitSet(bitMask,4)				// ILD
		endif
		//if(AlphaMask_ABL)
			bitMask = SpHr_BitSet(bitMask,5)				// ABL
		//endif
		
		DFREF DFR= $SpHrView_AtTime_DF
		SetDataFolder DFR // set here to avoid passing datafolder paths
		
		// Using Envelope Cues
		if(isEnv)
		
			dtEnvLimit = 0 //  should always be 0 ?
			NVAR minEnvelopeFreq = $globals_dfStr+"minEnvelopeFreq"
			
			SpHr_CrossingEnvelopeCues/F=(minEnvelopeFreq)/Cues=(bitMask)/N="Env"/DF=DFR/dtdB=(dtEnvdB)/dB=(EnvdB)/AWts={EnvLimit, dtEnvLimit} CFs, FilterBanks
			wave EnvNs = $SpHrView_AtTime_DF+"EnvNs"
			wave EnvXs = $SpHrView_AtTime_DF+"EnvXs"
			wave/Z EnvIPDs = $SpHrView_AtTime_DF+"EnvIPDs"
			wave/Z EnvILDs = $SpHrView_AtTime_DF+"EnvILDs"
			wave/Z EnvAWts = $SpHrView_AtTime_DF+"EnvAWts"
			if(EnvLimit == 0 && dtEnvLimit == 0 && waveexists(EnvAWts))
				killwaves/Z EnvAWts // kill if already exists!
			endif
			wave/Z EnvABLs = $SpHrView_AtTime_DF+"EnvABLs"

		else
			// Get carrier IPDs   /N="" no prefix
			NVAR maxCarrierFreq = $globals_dfStr+"maxCarrierFreq"
			
			SpHr_CrossingCarrierCues/F=(maxCarrierFreq)/N=""/Cues=(bitMask)/DF=DFR/idt=(dtInterp)/dB=(EnvdB)/dtdB=(dtEnvdB)/AWts={EnvLimit, dtEnvLimit} CFs, FilterBanks
			wave Ns = $SpHrView_AtTime_DF+"Ns"
			wave Xs = $SpHrView_AtTime_DF+"Xs"
			wave/Z IPDs = $SpHrView_AtTime_DF+"IPDs"
			wave/Z ILDs = $SpHrView_AtTime_DF+"ILDs"
			wave/Z AWts = $SpHrView_AtTime_DF+"AWts"
			if(EnvLimit == 0 && dtEnvLimit == 0 && waveexists(AWts))
				killwaves/Z AWts // kill if already exists! ??
			endif
			wave/Z ABLs = $SpHrView_AtTime_DF+"ABLs"
		endif
			
		String SpHrOperationStr = "SpHr_ActivityAtTime"
		
		// Flag parameters
		
		SpHrOperationStr += "/Q"
		
		NVAR ActivityLimit = $globals_dfStr+"ActivityLimit"
		SpHrOperationStr += "/Lim={"+num2str(ActivityLimit)+",LimitTimes}" //, ScaledLimits}" // Activity limit (default = 5)

		NVAR IHC = $globals_dfStr+"InterhemiphericCoordination"
		if(IHC == 0)
			SpHrOperationStr += "/IHC="+num2str(IHC)		// inter-hemispheric coordination index
		endif
		
		// Using Envelope Cues
		if(isEnv)
			if(minEnvelopeFreq > CFs[0])
				SpHrOperationStr += "/F={"+num2str(minEnvelopeFreq)+",NaN}"
			endif
		else
			if(maxCarrierFreq < CFs[dimsize(CFs,0)-1])
				SpHrOperationStr += "/F={0,"+num2str(maxCarrierFreq)+"}"
			endif
		endif
		
		//SpHrOperationStr += "/T={"+num2str(startTime)+","+num2str(endTime)+"}"
		
		NVAR AverageToEnd = $globals_dfStr+"AverageToEnd"
		variable AvgToEnd = AverageToEnd // or set to 3 to always make StDev chunks
		NVAR getSDs =  $globals_dfStr+"getSDs"
		if(getSDs)
			AvgToEnd = 2		// average and standard deviation
		elseif(AverageToEnd)
			AvgToEnd = 1		// 1: average only, 3: average only but still make extra chucks in destination waves for standard deviations
		endif
		if(AvgToEnd > 0)
			SpHrOperationStr += "/Avg="+num2str(AvgToEnd)				// average model ouputs from limit to end and/or get standard deviation over smae time frame
		endif
		
		// Output flags

		NVAR getEdges = $globals_dfStr+"getEdges"
		if(getEdges)
			SpHrOperationStr += "/HM"   // +"={HalfmaximalActivity_Left, HalfmaximalActivity_Right}"  +"={EnvelopeHalfmaximalActivity_Left, EnvelopeHalfmaximalActivity_Right}"
		endif
		NVAR useMaximalLablesForEdges = $globals_dfStr+"useMaximalLablesForEdges"
		variable reflectAtHalfMaximum = 1
		if(useMaximalLablesForEdges || !reflectAtHalfMaximum)
			SpHrOperationStr += "/HMOP={"+num2str(useMaximalLablesForEdges)+","+num2str(reflectAtHalfMaximum)+"}"
		endif
		
		NVAR getMaxima = $globals_dfStr+"getMaxima"
		
		if(getMaxima)
			SpHrOperationStr += "/M"   // +"={MaximalActivity_Left, MaximalActivity_Right}"  +"={EnvelopeMaximalActivity_Left, EnvelopeMaximalActivity_Right}"
		endif
		NVAR useEdgeLablesForMaxima = $globals_dfStr+"useEdgeLablesForMaxima"
		if(useEdgeLablesForMaxima)
			SpHrOperationStr += "/MOP="+num2str(useEdgeLablesForMaxima)
		endif
		
		// Peaks
		NVAR getPeaks =  $globals_dfStr+"getPeaks"
		if(getPeaks && (getEdges || getMaxima))
			SpHrOperationStr += "/P" // +"={HalfmaximalActivityPoints, MaximalActivityPoints}  +"={EnvelopeHalfmaximalActivityPoints, EnvelopeMaximalActivityPoints}
		else
			Killwaves/Z $SpHrView_AtTime_DF+"HalfmaximalActivityPoints"
			Killwaves/Z $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivityPoints"
			Killwaves/Z $SpHrView_AtTime_DF+"MaximalActivityPoints"
			Killwaves/Z $SpHrView_AtTime_DF+"EnvelopeMaximalActivityPoints"
			Killwaves/Z $SpHrView_AtTime_DF+"CombinedHalfmaximalActivityPoints"
			Killwaves/Z $SpHrView_AtTime_DF+"CombinedMaximalActivityPoints"
		endif
		
		NVAR setPointsAtLimitsToNaN = $globals_dfStr+"setPointsAtLimitsToNaN"
		if(!setPointsAtLimitsToNaN)
			SpHrOperationStr += "/POP="+num2str(setPointsAtLimitsToNaN)
		endif
		
		// ITD		
		if(ScaleIPDToITD || ScaleILDtoITD)
			NVAR numITDBins = $globals_dfStr+"numITDBins"
			NVAR maximumITDms = $globals_dfStr+"maximumITDms"
			SpHrOperationStr += "/ITD={"+num2str(numITDBins)+","+num2str(maximumITDms/1000)+"}" // convert ms to s
		endif
		
		NVAR getCarrierAccruals = $globals_dfStr+"getCarrierAccruals"
		NVAR getEnvelopeAccruals = $globals_dfStr+"getEnvelopeAccruals"
		if( (!isEnv && getCarrierAccruals) || (isEnv && getEnvelopeAccruals) )
			SpHrOperationStr += "/ACC"  //  ={Accruals}  ={EnvelopeAccruals}
		endif
		
		// Keyword parameters
		
		SpHrOperationStr += " "
		
		SpHrOperationStr += "CFs=root:SpHrView:Filter:CFs"+", " // comma
		
		NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
		if(!useIPDs && ScaleILDtoITD)
			//DoAlert/T="Warning" 1, "If IPD values are not passed, ILD 'labels' should not be scaled with ITD 'labels'."
		endif
		
		
		// Using Envelope Cues
		if(isEnv)
		
			// Envelope weights, optional flag
			if((EnvLimit != 0 || dtEnvLimit != 0)  && waveexists(AWts))
				SpHrOperationStr += "Wts=EnvAWts"+", "
			endif
		
			SpHrOperationStr += "XsNs={EnvXs,EnvNs}"+" "
		
			if((useIPDs || ScaleIPDToITD) && waveexists(EnvIPDs))
				SpHrOperationStr += "IPD={EnvIPDs,root:SpHrView:IPDNeuron:IPDNeurons,root:SpHrView:IPDNeuron:IPDLabels}"+" "	// assuming neurons and labels are in root:SpHrView:IPDNeuron: datafolder
			endif
			
			if(useILDs && waveexists(EnvILDs))
				SpHrOperationStr += "ILD={EnvILDs,root:SpHrView:ILDNeuron:ILDNeurons,root:SpHrView:ILDNeuron:ILDLabels,"+num2str(ScaleILDtoITD)+"}"+" " // assuming neurons and labels are in root:SpHrView:ILDNeuron: datafolder
			endif
			
			// use IPDL keyword to interpolate as if IPD keyword was used with ITD flag but without passing/using IPDs
			wave IPDLabels = root:SpHrView:IPDNeuron:IPDLabels
			if(!useIPDs && waveExists(IPDLabels)) // && ScaleILDtoITD
				SpHrOperationStr += "IPDL={root:SpHrView:IPDNeuron:IPDLabels}"+" "
			endif
			
			SpHrOperationStr += "ENV={FilterWidths,"+num2str(IPDneuronWidth)+"}"+" "  // FilterWidths should be in DFR
		
		else
		
			// Envelope weights, optional flag
			if((EnvLimit != 0 || dtEnvLimit != 0)  && waveexists(AWts))
				SpHrOperationStr += "Wts=AWts"+", "
			endif
		
			SpHrOperationStr += "XsNs={Xs,Ns}"+" "
		
			wave IPDNeurons = root:SpHrView:IPDNeuron:IPDNeurons
			wave IPDLabels = root:SpHrView:IPDNeuron:IPDLabels
			if((useIPDs || ScaleIPDToITD) && waveexists(IPDs) && waveexists(IPDNeurons) && waveexists(IPDLabels))
				SpHrOperationStr += "IPD={IPDs,root:SpHrView:IPDNeuron:IPDNeurons,root:SpHrView:IPDNeuron:IPDLabels}"+" "	// assuming neurons and labels are in root:SpHrView:IPDNeuron: datafolder
			endif
			
			wave ILDNeurons = root:SpHrView:ILDNeuron:ILDNeurons
			wave ILDLabels = root:SpHrView:ILDNeuron:ILDLabels
			if(useILDs && waveexists(ILDs) && waveexists(ILDNeurons) && waveexists(ILDLabels))
				NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
				SpHrOperationStr += "ILD={ILDs,root:SpHrView:ILDNeuron:ILDNeurons,root:SpHrView:ILDNeuron:ILDLabels,"+num2str(ScaleILDtoITD)+"}"+" " // assuming neurons and labels are in root:SpHrView:ILDNeuron: datafolder
				
				// use IPDL keyword to interpolate as if IPD keyword was used with ITD flag but without passing/using IPDs
				wave IPDLabels = root:SpHrView:IPDNeuron:IPDLabels
				if(!useIPDs && waveExists(IPDLabels)) // && ScaleILDtoITD
					SpHrOperationStr += "IPDL={root:SpHrView:IPDNeuron:IPDLabels}"+" "
				endif
			endif
			
		endif

//		Print/LEN=1000 SpHrOperationStr 
	
		Execute/Q SpHrOperationStr
		
	
		if(isEnv)
			NVAR ScaledEnvelopeActivityLimit = $globals_dfStr+"ScaledEnvelopeActivityLimit"
			NVAR V_FreqAvgLimit=V_FreqAvgLimit
			ScaledEnvelopeActivityLimit = V_FreqAvgLimit		
		else
			NVAR ScaledCarrierActivityLimit = $globals_dfStr+"ScaledCarrierActivityLimit"
			NVAR V_FreqAvgLimit=V_FreqAvgLimit
			ScaledCarrierActivityLimit = V_FreqAvgLimit
		endif
		
	endfor // for(CueSet=0;CueSet<numCueSets;CueSet++)  two passes in case getting both carrier and envelope activities

		
	if(useCarrierCues && useEnvelopeCues )
	
		int ActMode = 0
		int PntMode = 0
		
		if(getEdges)
			wave carrierWave = HalfmaximalActivity_Left
			wave envelopeWave = EnvelopeHalfmaximalActivity_Left
			SpHrView_AtTime_CombineCarrierEnvelopeActivities(SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Left", carrierWave, envelopeWave, ActMode)

			wave carrierWave = HalfmaximalActivity_Right
			wave envelopeWave = EnvelopeHalfmaximalActivity_Right
			SpHrView_AtTime_CombineCarrierEnvelopeActivities(SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Right", carrierWave, envelopeWave, ActMode)
			
			wave/Z carrierPoints = HalfmaximalActivityPoints
			wave/Z envelopePoints = EnvelopeHalfmaximalActivityPoints
			if(waveexists(carrierPoints) && waveexists(envelopePoints))
				SpHrView_AtTime_CombineCarrierEnvelopePoints(SpHrView_AtTime_DF+"CombinedHalfmaximalActivityPoints", carrierPoints, envelopePoints, PntMode)
			endif
			
		endif
		if(getMaxima)
			wave carrierWave = MaximalActivity_Left
			wave envelopeWave = EnvelopeMaximalActivity_Left
			SpHrView_AtTime_CombineCarrierEnvelopeActivities(SpHrView_AtTime_DF+"CombinedMaximalActivity_Left", carrierWave, envelopeWave, ActMode)
			
			wave carrierWave = MaximalActivity_Right
			wave envelopeWave = EnvelopeMaximalActivity_Right
			SpHrView_AtTime_CombineCarrierEnvelopeActivities(SpHrView_AtTime_DF+"CombinedMaximalActivity_Right", carrierWave, envelopeWave, ActMode)			
			
			wave/Z carrierPoints = MaximalActivityPoints
			wave/Z envelopePoints = EnvelopeMaximalActivityPoints
			if(waveexists(carrierPoints) && waveexists(envelopePoints))
				SpHrView_AtTime_CombineCarrierEnvelopePoints(SpHrView_AtTime_DF+"CombinedMaximalActivityPoints", carrierPoints, envelopePoints, PntMode)
			endif
			
		endif
	endif
	
	// PeaksMindB, PeaksAvgdB, PeaksQ2dB are set by the SpHr_WavePeaks operation and reflect min and max amplitude of the entire loaded sound
	//NVAR PeaksMaxdB = $SpHrView_df_globals+"PeaksMaxdB"
	//NVAR PeaksMindB = $SpHrView_df_globals+"PeaksMindB"
	//NVAR PeaksAvgdB = $SpHrView_df_globals+"PeaksAvgdB"	
	NVAR PeaksQ2dB = $SpHrView_df_globals+"PeaksQ2dB"
	//NVAR PeaksQ1dB = $SpHrView_df_globals+"PeaksQ1dB"
	//Printf "MindB=%g, AvgdB=%g, Q1=%g, Q2=%g\r", PeaksMindB, PeaksAvgdB, PeaksQ2dB, PeaksQ1dB

	NVAR ABLmin = $SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Min"
	NVAR ABLmax = $SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Max"
 	ABLmin = PeaksQ2dB - 50
 	ABLmax = PeaksQ2dB
 			
	SpHrView_AtTime_UpdateABLMasks()
	
	if(1)
		Killwaves/Z IPDs,ILDs,AWts	// ABLs
		Killwaves/Z EnvIPDs,EnvILDs,EnvAWts // EnvABLs
		if(!getCarrierAccruals && !getEnvelopeAccruals)
			Killwaves/Z Xs,Ns
			Killwaves/Z EnvXs,EnvNs
		endif
	endif
	
	
	SetDataFolder saveDFR
	
End


Function SpHrView_AtTime_UpdateABLMasks()
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_AtTime_DF
	string globals_dfStr = SpHrView_AtTime_DF_Globals
	
	//NVAR getCarrierAccruals = $globals_dfStr+"getCarrierAccruals"
	//NVAR getEnvelopeAccruals = $globals_dfStr+"getEnvelopeAccruals"
	// Accruals // EnvelopeAccruals
	
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	
	wave/Z ABLs = $SpHrView_AtTime_DF+"ABLs"
	wave/Z EnvABLs = $SpHrView_AtTime_DF+"EnvABLs"
	
	NVAR ABLmin = $globals_dfStr+"AlphaMask_ABL_Min"
	NVAR ABLmax = $globals_dfStr+"AlphaMask_ABL_Max"
		
	if(getEdges)
		if(useCarrierCues && waveexists(ABLs))
			wave AlphaWave = $SpHrView_AtTime_DF+"HalfmaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, Halfmaximal_AlphaMask_Left} Wts={ABLs,ABLmin,ABLmax}
			wave AlphaWave = $SpHrView_AtTime_DF+"HalfmaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, Halfmaximal_AlphaMask_Right} Wts={ABLs,ABLmin,ABLmax}
		endif
		if(useEnvelopeCues && waveexists(EnvABLs))
			wave AlphaWave = $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, EnvelopeHalfmaximal_AlphaMask_Left} Wts={EnvABLs,ABLmin,ABLmax}
			wave AlphaWave = $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, EnvelopeHalfmaximal_AlphaMask_Right} Wts={EnvABLs,ABLmin,ABLmax}
		endif
	endif
	if(getMaxima)
		if(useCarrierCues && waveexists(ABLs))
			wave AlphaWave = $SpHrView_AtTime_DF+"MaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, MaximalActivity_AlphaMask_Left} Wts={ABLs,ABLmin,ABLmax}
			wave AlphaWave = $SpHrView_AtTime_DF+"MaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, MaximalActivity_AlphaMask_Right} Wts={ABLs,ABLmin,ABLmax}
		endif
		if(useEnvelopeCues && waveexists(EnvABLs))
			wave AlphaWave = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, EnvelopeMaximalActivity_AlphaMask_Left} Wts={EnvABLs,ABLmin,ABLmax}
			wave AlphaWave = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, EnvelopeMaximalActivity_AlphaMask_Right} Wts={EnvABLs,ABLmin,ABLmax}
		endif
	endif

		// useCarrierCues && useEnvelopeCues  && 
	if(waveexists(ABLs) && waveexists(EnvABLs))
		if(getEdges)
			wave AlphaWave = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_AlphaMask_Left"} Wts={ABLs,ABLmin,ABLmax}, MoreWts={EnvABLs,ABLmin,ABLmax}
			
			wave AlphaWave = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_AlphaMask_Right"} Wts={ABLs,ABLmin,ABLmax}, MoreWts={EnvABLs,ABLmin,ABLmax}
		endif
		if(getMaxima)
			wave AlphaWave = $SpHrView_AtTime_DF+"CombinedMaximalActivity_Left"
			SpHr_ActivityAlpha /AT={AlphaWave, $SpHrView_AtTime_DF+"CombinedMaximalActivity_AlphaMask_Left"} Wts={ABLs,ABLmin,ABLmax}, MoreWts={EnvABLs,ABLmin,ABLmax}
			
			wave AlphaWave = $SpHrView_AtTime_DF+"CombinedMaximalActivity_Right"
			SpHr_ActivityAlpha /AT={AlphaWave, $SpHrView_AtTime_DF+"CombinedMaximalActivity_AlphaMask_Right"} Wts={ABLs,ABLmin,ABLmax}, MoreWts={EnvABLs,ABLmin,ABLmax}
		endif
	endif
	
	SetDataFolder saveDFR
End


//+"={HalfmaximalActivityPoints, MaximalActivityPoints}  +"={EnvelopeHalfmaximalActivityPoints, EnvelopeMaximalActivityPoints}

// mode 0: envelope wave where carrier activity is NaN
// mode 1: envelope wave where carrier activity < envelope activity
// mode 2: envelope wave where carrier activity > envelope activity
Function SpHrView_AtTime_CombineCarrierEnvelopePoints(string combinedPointsStr, wave carrierPoints, wave envelopePoints, int mode)
	Duplicate/O carrierPoints, $combinedPointsStr
	wave combinedPoints = $combinedPointsStr
	if(waveexists(carrierPoints) && waveexists(envelopePoints))
		switch(mode)
			case 0: // envelope wave where carrier activity is NaN
				combinedPoints = (numtype(carrierPoints)==0) ? carrierPoints : envelopePoints
				break
			case 2: // envelope wave where carrier activity < envelope activity
				combinedPoints[][0] = (carrierPoints[p][1] < envelopePoints[p][1]) ? carrierPoints[p][0] : envelopePoints[p][0]
				combinedPoints[][1] = (carrierPoints[p][1] < envelopePoints[p][1]) ? carrierPoints[p][1] : envelopePoints[p][1]
				break
			case 3: // envelope wave where carrier activity > envelope activity
				combinedPoints[][0] = (carrierPoints[p][1] > envelopePoints[p][1]) ? carrierPoints[p][0] : envelopePoints[p][0]
				combinedPoints[][1] = (carrierPoints[p][1] > envelopePoints[p][1]) ? carrierPoints[p][1] : envelopePoints[p][1]
				break
		endswitch
	endif
End

// mode 0: envelope wave where carrier activity is NaN
// mode 1: envelope wave where carrier activity < envelope activity
// mode 2: envelope wave where carrier activity > envelope activity
Function SpHrView_AtTime_CombineCarrierEnvelopeActivities(string combinedWaveStr, wave carrierWave, wave envelopeWave, int mode)
	Duplicate/O carrierWave, $combinedWaveStr
	wave combinedWave = $combinedWaveStr
	if(waveexists(carrierWave) && waveexists(envelopeWave))
		switch(mode)
			case 0: // envelope wave where carrier activity is NaN
				combinedWave = (numtype(carrierWave)==0) ? carrierWave : envelopeWave
				break
			case 2: // envelope wave where carrier activity < envelope activity
				combinedWave = (carrierWave < envelopeWave) ? carrierWave : envelopeWave
				break
			case 3: // envelope wave where carrier activity > envelope activity
				combinedWave = (carrierWave > envelopeWave) ? carrierWave : envelopeWave
				break
		endswitch
	endif
End

// =================================================================================================
// SpHrView_AtTime_OptionsWindow(), display options for CuesS
// =================================================================================================
Function SpHrView_AtTime_OptionsWindow(variable winLeft, variable winTop)
	if(winleft < 0 || winTop < 0)
		GetMouse
		winleft=V_left
		winTop=V_top
	endif
	
	string globals_dfStr = SpHrView_AtTime_DF_Globals
		
	SpHrView_AtTime_Defaults()
	
	killwindow/Z AtTimeOptionsWindow
	//	Variable  winLeft=250, winRight, winTop=50, winBottom
	//	[winLeft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
	
	//  /FLT=1
	NewPanel /FLT=1/K=1/W=(winLeft, winTop, winLeft+213, winTop+770) as "At time Activiites"
	DoWindow/C AtTimeOptionsWindow
	variable topPos = 7
	CheckBox ck_keepWindowOpen win=AtTimeOptionsWindow, title="📌",fSize=10,pos={10,topPos},side=0
	CheckBox ck_keepWindowOpen win=AtTimeOptionsWindow, help={"Keep window open"}
	
	Button b_Display title="Display  ⏎",pos={60,topPos},size={105,20},proc=SpHrView_AtTime_ButtonProc,fSize=11
	Button b_Display help={"Display cues. Can also press 'return' key."} 
	
	// Display activity
	topPos += 27
	GroupBox group_NeuralActivities, title="Neural activities (representations)",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 45}
	topPos += 21
	CheckBox ck_Edges title="Edges",pos={25,topPos},fSize=10,variable=$globals_dfStr+"getEdges"
	CheckBox ck_Edges help={"Perception is congruous with ITD neurons evoking half-maximal activity (i.e., Activity Limit / 2)."}
	
	CheckBox ck_getSDs title="SD",pos={100,topPos},fSize=10,variable=$globals_dfStr+"getSDs"
	CheckBox ck_getSDs proc=SpHrView_AtTime_CheckProc, help={"Standard deviations from the freqeuncy-specific times that the activity limit is reached to end of the current selection."}
	
	CheckBox ck_Maxima title="Maxima",pos={140,topPos},fSize=10,variable=$globals_dfStr+"getMaxima"
	CheckBox ck_Maxima help={"Perception is congruous with ITD neurons evoking maximal activity (i.e., the Activity Limit)."}

	// Cue types
	topPos += 25
	GroupBox group_Cues, title="Cues",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 40}
	topPos += 18
	CheckBox ck_useIPDs title="IPD",pos={25,topPos},fSize=10,variable=$globals_dfStr+"useIPDs"
	CheckBox ck_useIPDs help={"Use interaural phase differences (IPD) in model"}, proc=SpHrView_AtTime_CheckProc
	NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
	if(!ScaleIPDToITD)
		CheckBox ck_ScaleIPDToITD fstyle=1
	endif
	CheckBox ck_ScaleIPDToITD title="ITD",pos={80,topPos},fSize=10,variable=$globals_dfStr+"ScaleIPDToITD"
	CheckBox ck_ScaleIPDToITD help={"Scale IPD to ITD."}, proc=SpHrView_AtTime_CheckProc
	
	CheckBox ck_useILDs title="ILD",pos={140,topPos},fSize=10,variable=$globals_dfStr+"useILDs"
	CheckBox ck_useILDs help={"Use interaural level differences (ILD) in model"}, proc=SpHrView_AtTime_CheckProc


	// Waveform type
	topPos += 25
	GroupBox group_typeOfIPD, title="Waveforms",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 75}
	topPos += 22
	
	NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
	NVAR highFreq= $SpHrView_df_filter+"highFreq"
	
	CheckBox ck_useCarrierCues title="Carrier",pos={20+0,topPos},fSize=10,variable=$globals_dfStr+"useCarrierCues" 
	CheckBox ck_useCarrierCues help={"Use Carrier IPDs in model"}, proc=SpHrView_AtTime_CheckProc
	
	SetVariable sv_maxCarrierFreq,pos={95,topPos},size={107.00,14.00},bodyWidth=50,fSize=10,title="< freq (Hz)"
	SetVariable sv_maxCarrierFreq,limits={lowFreq,highFreq,100},value= $globals_dfStr+"maxCarrierFreq"
	SetVariable sv_maxCarrierFreq, help={"Maximum frequency for which Carrier IPDs are modeled"}
	
	topPos += 25
	CheckBox ck_useEnvelopeCues title="Envelope",pos={20+0,topPos},fSize=10,variable=$globals_dfStr+"useEnvelopeCues"
	CheckBox ck_useEnvelopeCues help={"Use Envelope IPDs in model"}, proc=SpHrView_AtTime_CheckProc
	SetVariable sv_minEnvelopeFreq,pos={95,topPos},size={107.00,14.00},bodyWidth=50,fSize=10,title="> freq (Hz)"
	SetVariable sv_minEnvelopeFreq,limits={lowFreq,highFreq,100},value= $globals_dfStr+"minEnvelopeFreq"
	SetVariable sv_minEnvelopeFreq, help={"Minimum frequency for which Envelope IPDs are modeled"}
	
	// ITD image resolution & range
	topPos += 30
	GroupBox group_ScaleIPDToITD, disable=0,title="ITD or ITD & ILD resolution & range",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 50}
	topPos += 23
	SetVariable sv_numITDBins pos={30,topPos},size={65,14.00},bodyWidth=50,fSize=10,title="# bins"
	SetVariable sv_numITDBins limits={51,1001,1},value= $globals_dfStr+"numITDBins"
	SetVariable sv_numITDBins disable=0, help={"Number of ITD bins. Default = 401 (should be an odd number)"}
	SetVariable sv_maximumITDms pos={135,topPos},size={65,14.00},bodyWidth=50,fSize=10,title="range ±"
	SetVariable sv_maximumITDms limits={0.1,5,0.1},value= $globals_dfStr+"maximumITDms"
	SetVariable sv_maximumITDms disable=0, help={"Maximum range, ± ms for ITD or ITD and ILD values"}
	
	// Model parameters
	topPos += 30
	GroupBox group_ModelParams, title="Model parameters",pos={5.00,topPos},size={205.00, 45},fSize=10,fstyle=0
	topPos += 20
	SetVariable sv_ActivityLimit,pos={95,topPos},size={104.00,14.00},bodyWidth=45,fSize=10,title="Activity limit"
	SetVariable sv_ActivityLimit,limits={0.1,100,1},value= $globals_dfStr+"ActivityLimit"
	SetVariable sv_ActivityLimit, help={""}

	
	// Other display options
	topPos += 25
	GroupBox group_OtherDisplayOptions, title="",pos={5.00,topPos},size={205.00, 140}
	topPos += 5
	CheckBox ck_AverageToEnd title="Average activities over time ",pos={15,topPos},fSize=10,variable=$globals_dfStr+"AverageToEnd"
	CheckBox ck_AverageToEnd proc=SpHrView_AtTime_CheckProc
	CheckBox ck_AverageToEnd help={"Average activity from the time when frequecy-specific activity limits were first reached to end of the selection."}
	
	topPos += 20
	CheckBox ck_getPeaks title="Get 'peaks' at max/half-maxima ",pos={15,topPos},fSize=10,variable=$globals_dfStr+"getPeaks"
	CheckBox ck_AverageToEnd proc=SpHrView_AtTime_CheckProc
	CheckBox ck_AverageToEnd help={"Get halfmaximal and maximal 'peaks'."}
	
	topPos += 22
	CheckBox ck_InterhemiphericCoordination title="Hemispheric coordination",pos={15,topPos},fSize=10,variable=$globals_dfStr+"InterhemiphericCoordination"
	CheckBox ck_InterhemiphericCoordination proc=SpHrView_AtTime_CheckProc
	CheckBox ck_InterhemiphericCoordination help={"Activities in both hemispheres (left and right) are diminished when activities in either hemisphere exceed the activity limit."}
	NVAR InterhemiphericCoordination = $globals_dfStr+"InterhemiphericCoordination"
	if(!InterhemiphericCoordination)
		CheckBox ck_InterhemiphericCoordination fstyle=1
	endif	
	
	topPos += 20
	CheckBox ck_ScaleILDtoITD title="Scale ILD with ITD (vs IPD) ",pos={15,topPos},fSize=10,variable=$globals_dfStr+"ScaleILDtoITD"
	CheckBox ck_ScaleILDtoITD help={"Scale ILD so that ILD 'labels' scale with ITD 'labels' as opposed to IPD 'labels'"}, proc=SpHrView_AtTime_CheckProc
	NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
	if(!ScaleILDtoITD)
		CheckBox ck_ScaleILDtoITD fstyle=1
	endif
	
	topPos += 25
	CheckBox ck_useEdgeLablesForMaxima title="Use edge lables for Maxima",pos={15,topPos},fSize=10,variable=$globals_dfStr+"useEdgeLablesForMaxima"
	CheckBox ck_useEdgeLablesForMaxima  proc=SpHrView_AtTime_CheckProc
	NVAR useEdgeLablesForMaxima = $globals_dfStr+"useEdgeLablesForMaxima"
	if(useEdgeLablesForMaxima)
		CheckBox ck_useEdgeLablesForMaxima fstyle=1
	endif
	topPos += 20
	CheckBox ck_useMaximalLablesForEdges title="Use maximal lables for Edges",pos={15,topPos},fSize=10,variable=$globals_dfStr+"useMaximalLablesForEdges"
	CheckBox ck_useMaximalLablesForEdges  proc=SpHrView_AtTime_CheckProc
	NVAR useMaximalLablesForEdges = $globals_dfStr+"useMaximalLablesForEdges"
	if(useMaximalLablesForEdges)
		CheckBox ck_useMaximalLablesForEdges fstyle=1
	endif
	

	// Activity Accrual
	topPos += 30
	GroupBox group_Accrual, title="Activity Accrual",pos={5.00,topPos},size={205.00, 40}
	topPos += 16
	CheckBox ck_getCarrierAccruals title="Carrier",pos={15,topPos},fSize=10,variable=$globals_dfStr+"getCarrierAccruals"
	CheckBox ck_getCarrierAccruals help={"Carrier activity accrual over time prior to the end of the current selection."}
	CheckBox ck_getEnvelopeAccruals title="Envelope",pos={90,topPos},fSize=10,variable=$globals_dfStr+"getEnvelopeAccruals"
	CheckBox ck_getEnvelopeAccruals help={"Envelope activity accrual over time prior to the end of the current selection."}
	
	
	// Other parameters - via buttons 
	topPos += 30
	GroupBox group_OtherParams, title="Neuron & auditoy filter parameters",pos={5.00,topPos},size={205.00, 55},fSize=10,fstyle=0
	topPos += 23
	Button b_IPDNeuronParams pos={15,topPos},title="IPD",size={40,20},proc=SpHrView_IPDNeuron_ButtonProc,fSize=10
	Button b_ILDNeuronParams pos={65,topPos},title="ILD",size={40,20},proc=SpHrView_ILDNeuron_ButtonProc,fSize=10
	Button b_FilterBank pos={120,topPos},title="Filters",size={60,20},proc=SpHrView_AtTime_ButtonProc,fSize=10
	
	// envelope derivative weights
	topPos += 45
	GroupBox group_dtEnvWts, fSize=10,fstyle=0,title="Envelope Weights",pos={5.00,topPos-6},size={205.00, 87}
	topPos += 15
	CheckBox ck_usedtEnvelopeWts title="Derivative weights ",pos={25,topPos},fSize=10,side=0
	CheckBox ck_usedtEnvelopeWts variable=$globals_dfStr+"usedtEnvelopeWts"
	CheckBox ck_dtEnvelopeWeightsdB title="dB ",pos={165,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsdB variable=$globals_dfStr+"dtEnvelopeWeightsdB"
	topPos += 22
	SetVariable sv_dtEnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=45,title="Derivative Activity Limit"
	SetVariable sv_dtEnvelopeWtActLimit,fSize=10
	SetVariable sv_dtEnvelopeWtActLimit,limits={1,100,1},value= $globals_dfStr+"dtEnvelopeWtActLimit"
	SetVariable sv_dtEnvelopeWtActLimit, help={"Envelope derivative activity activity Limit"}
	topPos += 20
	CheckBox ck_dtEnvelopeApplyToEnvelopes title="Apply to envelope cues ",pos={35,topPos},fSize=10,side=1,disable=2
	CheckBox ck_dtEnvelopeApplyToEnvelopes variable=$globals_dfStr+"dtEnvelopeApplyToEnvelopes", proc=SpHrView_Cues_CheckProc

	// envelope amplitude weights
	topPos += 32
	GroupBox group_EnvWts,pos={5.00,topPos-6},size={205.00, 52}
	CheckBox ck_useAmpEnvelopeWts title="Amplitude weights ",pos={25,topPos},fSize=10,side=0
	CheckBox ck_useAmpEnvelopeWts variable=$globals_dfStr+"useAmpEnvelopeWts"
	CheckBox ck_EnvelopeWeightsdB title="dB ",pos={165,topPos},fSize=10,side=1
	CheckBox ck_EnvelopeWeightsdB variable=$globals_dfStr+"EnvelopeWeightsdB"
	topPos += 22
	SetVariable sv_EnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=45,title="Amplitude Activity Limit"
	SetVariable sv_EnvelopeWtActLimit,fSize=10
	SetVariable sv_EnvelopeWtActLimit,limits={1,100,1},value= $globals_dfStr+"EnvelopeWtActLimit"
	SetVariable sv_EnvelopeWtActLimit, help={"Envelope activity activity Limit"}
	
	//ColorTable
	topPos += 38
	GroupBox group_ColorTable,pos={5.00,topPos-6},size={205.00, 45}
	SetVariable sv_ColorTable,pos={15,topPos},size={160.00,14.00},bodyWidth=125,title="Colors"
	SetVariable sv_ColorTable, fSize=10
	SetVariable sv_ColorTable, value= $globals_dfStr+"ColorTableStr"
	Button b_ColorTable, pos={175.00,topPos-1},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
	Button b_ColorTable, proc=SpHrView_AtTime_ButtonProc
	topPos += 18
	CheckBox ck_ReverseColorTable title="reverse color table ",pos={65,topPos},side=1, fSize=10
	CheckBox ck_ReverseColorTable variable= $globals_dfStr+"ReverseColorTable"
	
	DoUpdate/W=AtTimeOptionsWindow // for Igor 9
	SetWindow AtTimeOptionsWindow, hook(AtTimeOptionsWindowHook)=SpHrView_AtTime_ActivityWindowHook
	SetWindow AtTimeOptionsWindow note="PACKAGE:SpHrView;GROUP:AtTimeWin"

End

Function SpHrView_AtTime_CursorUpdate()
	variable winCnt = SpHrView_CountGroupWindows("AtTimeWin")
	if(winCnt > 0)
		SpHrView_AtTime(1)
	endif
End

// =================================================================================================
// SpHrView_AtTime_ActivityWindowHook(s), Window hook for at time activity windows
// =================================================================================================
Function SpHrView_AtTime_ActivityWindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0
	switch(s.eventCode)
		//////////////
		// deactivate
		case 1:
			strswitch(s.winName)
				case "AtTimeOptionsWindow":
					//DoUpdate/W=AtTimeOptionsWindow
					ControlInfo/W=AtTimeOptionsWindow ck_keepWindowOpen
					if(!V_Value)
						Execute/Z/Q/P "killwindow/Z AtTimeOptionsWindow"
						hookResult=1
					endif
					break
					
				case "NeuronsIPDWindow":
					ControlInfo/W=NeuronsIPDWindow ck_keepWindowOpen
					if(!V_Value)
						Execute/Z/Q/P "killwindow/Z NeuronsIPDWindow"
						hookResult=1
					endif
					break
				
				case "NeuronsILDWindow":
					ControlInfo/W=NeuronsILDWindow ck_keepWindowOpen
					if(!V_Value)
						Execute/Z/Q/P "killwindow/Z NeuronsILDWindow"
						hookResult=1
					endif
					break
				
				
			endswitch
			break
			
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			strswitch(s.winName)
				case "AtTimeOptionsWindow":
					switch(s.keycode)
						case 13:		// return
							//killwindow/Z AtTimeOptionsWindow
							SpHrView_AtTime(1)
							hookResult=0
							break
					endswitch
					break
				endswitch
			break
			
		//////////////
		// kill event
		case 2:
			//Printf "-%s-", s.winName
			strswitch(s.winName)					
				case "Activity_Accrual":
				case "Envelope_Activity_Accrual":
				case "At_Time_Activities":
				
					KillWindow/Z $s.winName
					variable winCnt = SpHrView_CountGroupWindows("AtTimeWin")
					if(winCnt<=0)
						Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_AtTime_DF[0,strlen(SpHrView_AtTime_DF)-2]+"\")" // remove trailing ":"
						Execute/Z/Q/P "KillAllVariablesInDatafolder(\""+SpHrView_AtTime_DF[0,strlen(SpHrView_AtTime_DF)-2]+"\")" // remove trailing ":"
					endif
					hookResult = 1
					break
			endswitch
			break
			
		case 7:		// cursormoved
			strswitch(s.winName)				
				case "At_Time_Activities":
					wave/Z CFs = $SpHrView_df_filter+"CFs"
					if(waveexists(CFs) && s.yPointNumber > 0 && s.yPointNumber < numpnts(CFs))
						SpHrView_AtTime_FreqLine(CFs[s.yPointNumber], s.winName, 0)
					endif
					break
			endswitch
	endswitch
	return hookResult
End



Function SpHrView_AtTime_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			Variable leftCoord, topCoord
			string winStr
			strswitch(ba.ctrlName)

				case "b_Display":
					SpHrView_AtTime(0)
					killwindow/Z AtTimeOptionsWindow
					break
					
				case "b_FilterBank":
					winStr = ba.win
					if(strsearch(winStr, "#PCBar", 0))
						winStr = RemoveEnding(winStr, "#PCBar")
					endif
					GetWindow $winStr, wsize// gsize
					leftCoord = V_left + ba.mouseLoc.h
					topCoord = V_Top + ba.mouseLoc.v
					SpHrView_Settings_FilterBank(leftCoord, topCoord)
					break
			
				case "b_SpHrView_AtTime":
					string selStr= ""
					variable key= getkeystate(0)  // Print key
					if(key==2 || key==10)	// option key
						PopupContextualMenu "Edges;-;SD;Maxima;-;Carrier Accrual;Envelope Accural;-;Options;"
						selStr = S_selection
					elseif(key==1 ||key==9)		// command key
						SpHrView_AtTime(0)
						break
					else
						selStr = "Options"
					endif
					if(strlen(selStr)>1) // not command key
						SpHrView_AtTime_Defaults()
						NVAR getEdges = $SpHrView_AtTime_DF_Globals+"getEdges"
						NVAR getMaxima = $SpHrView_AtTime_DF_Globals+"getMaxima"
						NVAR getSDs = $SpHrView_AtTime_DF_Globals+"getSDs"
						NVAR getCarrierAccruals = $SpHrView_AtTime_DF_Globals+"getCarrierAccruals"
						NVAR getEnvelopeAccruals = $SpHrView_AtTime_DF_Globals+"getEnvelopeAccruals"
						strswitch(selStr)
							case "Options":
								winStr = ba.win
								if(strsearch(winStr, "#PCBar", 0))
									winStr = RemoveEnding(winStr, "#PCBar")
								endif
								GetWindow $winStr, wsize// gsize
								leftCoord = V_left + ba.mouseLoc.h
								topCoord = V_Top + ba.mouseLoc.v
								SpHrView_AtTime_OptionsWindow(leftCoord, topCoord)
								break
							case "Edges":
								getEdges= 1; getMaxima= 0; getSDs=1;
								getCarrierAccruals=0; getEnvelopeAccruals=0;
								SpHrView_AtTime(0)
								break
							case "Maxima":
								getEdges= 0; getMaxima= 1; getSDs=1;
								getCarrierAccruals=0; getEnvelopeAccruals=0;
								SpHrView_AtTime(0)
								break
							case "SD":
								getEdges= 0; getMaxima= 0; getSDs=1;
								getCarrierAccruals=0; getEnvelopeAccruals=0;
								SpHrView_AtTime(0)
							case "Carrier Accrual":
								getEdges= 0; getMaxima= 0; getSDs=0;
								getCarrierAccruals=1; getEnvelopeAccruals=0;
								SpHrView_AtTime(0)
								break
							case "Envelope Accrual":
								getEdges= 0; getMaxima= 0; getSDs=0;
								getCarrierAccruals=0; getEnvelopeAccruals=1;
								SpHrView_AtTime(0)
								break
						endswitch
					endif
					break
					
				case "b_ColorTable":
					SVAR ColorTableStr = $SpHrView_AtTime_DF_Globals+"ColorTableStr"
					String tempStr = ColorTablePopup(ColorTableStr)
					if(strlen(tempStr)>1)
						ColorTableStr = tempStr
						DoUpdate
					endif
					break
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End

Function SpHrView_AtTime_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	int ValDepUpdate = 0
	switch( sva.eventCode )
		case 6: // Value changed by dependency update
			ValDepUpdate = 1
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			String winStr
			strswitch(sva.ctrlName)
				case "sv_lineFrequency":
					SpHrView_AtTime_FreqLine(dval, sva.win, ValDepUpdate)
					break			
					
				case "sv_AlphaMask_ABL_Min":
				case "sv_AlphaMask_ABL_Max":
					SpHrView_AtTime_UpdateABLMasks()	
					break	
						
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End


// Not updated - but still seems to work somehow...
Function SpHrView_AtTime_FreqLine(variable dval, String winStr, variable ValDepUpdate)
	
	NVAR Frequencyline = $SpHrView_AtTime_DF_Globals+"Frequencyline"
	if(!Frequencyline && !ValDepUpdate)
		Frequencyline= 1
		SpHrView_AtTime(0)
		return 0
	endif
	wave CFs = $SpHrView_df_filter+"CFs"
	Variable index, Hz
	Hz = CFs[SetVarProcIndex(CFs, dval, 0)]
	[index, Hz] = SpHrView_getCFindex(CFs, Hz)
	NVAR lineFrequency = $SpHrView_AtTime_DF_Globals+"lineFrequency"
	lineFrequency = Hz
	if(Frequencyline)
		NVAR lineFrequencyIndex = $SpHrView_AtTime_DF_Globals+"lineFrequencyIndex"
		lineFrequencyIndex = index
		//String winStr = sva.win
		if(strsearch(winStr, "#PCBar", 0))
			winStr = RemoveEnding(winStr, "#PCBar")
		endif
		String ImageStr, ImageStr2, imageListStr= ImageNameList(winStr, ";")
		int64 i
		// remove AlphaMask waves
		if(itemsInList(imageListStr) > 2)
			for(i=0;i<2;++i)
				imageListStr= ImageNameList(winStr, ";")
				ImageStr = stringfromList(0,imageListStr)
				if(strsearch(ImageStr, "AlphaMask", 0))
					imageListStr = RemoveListItem(0,imageListStr) 
				endif
				ImageStr = stringfromList(1,imageListStr)
				if(strsearch(ImageStr, "AlphaMask", 0))
					imageListStr = RemoveListItem(1,imageListStr) 
				endif
			endfor
		endif
		
		if(ItemsinList(imageListStr) > 1)
			ImageStr = stringfromList(0,imageListStr)
			ImageStr2 = stringfromList(1,imageListStr)
		else
			ImageStr = stringfromList(0,imageListStr)
		endif
		String TraceStr, traceListStr= TraceNameList(winStr, ";",1)
		//TraceStr = stringfromList(0,traceListStr)
		//int64 i
		for(i=0;i<itemsInList(traceListStr);++i)
			TraceStr = stringfromList(i,traceListStr)
			if(stringmatch(TraceStr,"left") || stringmatch(TraceStr,"left_dashed") || stringmatch(TraceStr,"right") || stringmatch(TraceStr,"right_dashed") )
				wave W= TraceNameToWaveRef(winStr, TraceStr)
				variable firstLayer = 0
				String YRANGE = StringByKey("YRANGE", TraceInfo(winStr,TraceStr,0))
				int64 layer = str2num(StringFromList(3, YRANGE, "["))
				// Could also get column number as: str2num(StringFromList(2, YRANGE, "["))
				// but I think we want to compute and use index from dval
				if(strsearch(TraceStr,"left",0,2)>=0)
					ReplaceWave/W=$winStr trace=$TraceStr, W[][index][layer]
				else
					ReplaceWave/W=$winStr trace=$TraceStr, W[][index][layer]
				endif
			endif
		endfor
		
		if(strlen(CsrWave(A, winStr))>0)				// 65535/2 20000
			Cursor/W=$winStr/P/A=0/I/S=2/H=3/T=1/C=(0,0,0,20000) A $ImageStr dimsize(W,1)/2, lineFrequencyIndex
		endif
		if(strlen(CsrWave(B, winStr))>0)
			Cursor/W=$winStr/P/A=0/I/S=2/H=3/T=1/C=(0,0,0,20000) B $ImageStr2 dimsize(W,1)/2,  lineFrequencyIndex
		endif				
	endif
End

Function SpHrView_AtTime_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			int Update_At_Time_Activities=0
			strswitch(cba.ctrlName)
			
				case "ck_ScaleIPDToITD":
					CheckBox ck_ScaleIPDToITD win=AtTimeOptionsWindow, fstyle=!checked
					NVAR useIPDs = $SpHrView_AtTime_DF_Globals+"useIPDs"
					if(checked)
						useIPDs = 0
					endif
					break
				case "ck_useIPDs":
					NVAR ScaleIPDToITD = $SpHrView_AtTime_DF_Globals+"ScaleIPDToITD"
					if(checked)
						ScaleIPDToITD = 0
						CheckBox ck_ScaleIPDToITD win=AtTimeOptionsWindow, fstyle=!ScaleIPDToITD
					endif
					break
			
			
				case "ck_getPeaks":
					if(!checked)
						NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
						AppendPeaks = 0
					endif
					break
					
				case "ck_AppendPeaksOppositeHemi":
					if(checked)
						NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
						getPeaks = checked
					endif
					Update_At_Time_Activities=1
					break
					
				case "ck_AppendPeaks":
					if(checked)
						NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
						getPeaks = checked
						CheckBox ck_setPointsAtLimitsToNaN win=$cba.win, disable=0
						CheckBox ck_AppendPeaksOppositeHemi win=$cba.win, disable=0
					else
						CheckBox ck_setPointsAtLimitsToNaN win=$cba.win, disable=2
						CheckBox ck_AppendPeaksOppositeHemi win=$cba.win, disable=2
					endif
					Update_At_Time_Activities=1
					break
					
				case "ck_setPointsAtLimitsToNaN":
					SpHrView_AtTime(0)
					break
				
				case "ck_FrequencyLine":
					Update_At_Time_Activities=1
					break
					
				case "ck_AlphaMask_ABL":
					//SpHrView_AtTime_UpdateABLMasks()
					Update_At_Time_Activities=1
					break
			
				case "ck_AverageToEnd":
					NVAR AverageToEnd= $SpHrView_AtTime_DF_Globals+"AverageToEnd"
					NVAR getSDs= $SpHrView_AtTime_DF_Globals+"getSDs"
					if(!AverageToEnd)
						getSDs = 0
					endif
					break
				case "ck_getSDs":
					NVAR AverageToEnd= $SpHrView_AtTime_DF_Globals+"AverageToEnd"
					NVAR getSDs= $SpHrView_AtTime_DF_Globals+"getSDs"
					if(getSDs)
						AverageToEnd = 1
					endif
					break
					
				case "ck_useEdgeLablesForMaxima":
					CheckBox ck_useEdgeLablesForMaxima win=AtTimeOptionsWindow, fstyle=checked
					break
				case "ck_useMaximalLablesForEdges":
					CheckBox ck_useMaximalLablesForEdges win=AtTimeOptionsWindow, fstyle=checked
					break
	
				case "ck_ScaleILDtoITD":
					CheckBox ck_ScaleILDtoITD win=AtTimeOptionsWindow, fstyle=!checked
					//	if(!checked)
					//		DoAlert/T="Warning" 1, "ILD 'labels' should normally be scaled with ITD 'labels'!\rScale with IPD anyway?"
					//		NVAR  ScaleILDtoITD = $SpHrView_AtTime_DF_Globals+"ScaleILDtoITD"
					//		if(V_Flag==1)
					//			ScaleILDtoITD = 0
					//		else
					//			ScaleILDtoITD = 1
					//		endif
					//	endif
					break
					
				case "ck_DisplayEdges":
					NVAR DisplayActivitiesMode = $SpHrView_AtTime_DF_Globals+"DisplayActivitiesMode"
					if(checked)
						DisplayActivitiesMode = 0
					endif // win=$WinNameStr+"#PCBar"
					CheckBox ck_DisplayEdges win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 0
					CheckBox ck_DisplaySD win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 1
					CheckBox ck_DisplayMaxima win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 2
					Update_At_Time_Activities=1
					break
				case "ck_DisplaySD":
					NVAR DisplayActivitiesMode = $SpHrView_AtTime_DF_Globals+"DisplayActivitiesMode"
					if(checked)
						DisplayActivitiesMode = 1
					endif
					CheckBox ck_DisplayEdges win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 0
					CheckBox ck_DisplaySD win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 1
					CheckBox ck_DisplayMaxima win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 2
					Update_At_Time_Activities=1
					break
				case "ck_DisplayMaxima":
					NVAR DisplayActivitiesMode = $SpHrView_AtTime_DF_Globals+"DisplayActivitiesMode"
					if(checked)
						DisplayActivitiesMode = 2
					endif
					CheckBox ck_DisplayEdges win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 0
					CheckBox ck_DisplaySD win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 1
					CheckBox ck_DisplayMaxima win=At_Time_Activities#PCBar, value= DisplayActivitiesMode == 2
					Update_At_Time_Activities=1
					break
				
				case "ck_DisplayCarrierActivities":
					NVAR DisplayCuesMode = $SpHrView_AtTime_DF_Globals+"DisplayCuesMode"
					if(checked)
						DisplayCuesMode = 0
					endif
					CheckBox ck_DisplayCarrierActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 0
					CheckBox ck_DisplayEnvelopeActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 1
					CheckBox ck_DisplayCombinedActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 2
					Update_At_Time_Activities=1
					break
				case "ck_DisplayEnvelopeActivities":
					NVAR DisplayCuesMode = $SpHrView_AtTime_DF_Globals+"DisplayCuesMode"
					if(checked)
						DisplayCuesMode = 1
					endif
					CheckBox ck_DisplayCarrierActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 0
					CheckBox ck_DisplayEnvelopeActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 1
					CheckBox ck_DisplayCombinedActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 2
					Update_At_Time_Activities=1
					break
				case "ck_DisplayCombinedActivities":
					NVAR DisplayCuesMode = $SpHrView_AtTime_DF_Globals+"DisplayCuesMode"
					if(checked)
						DisplayCuesMode = 2
					endif
					CheckBox ck_DisplayCarrierActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 0
					CheckBox ck_DisplayEnvelopeActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 1
					CheckBox ck_DisplayCombinedActivities win=At_Time_Activities#PCBar, value= DisplayCuesMode == 2
					Update_At_Time_Activities=1
					break		
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	
	DoWindow At_Time_Activities
	if(Update_At_Time_Activities && V_flag)
		SpHrView_AtTime_ActivityWindow()
	endif
	
	return 0
End



// PNG: width= 75, height= 15
Picture SpHrView_pict_AtTime
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!$[!!!!`#R18/!1V<L=9&=$$#iF<ErZ1m,6.]r,6<%c5B[#,!#]lI=EI
	J[Aor6*Eb,5:A8bpg+A$EYB4XtP@:XY'a^mR7!"q4^6pXdsg?`*lN*PIes4t`>gtDGFp3O"(?/)c,h
	3_YBH$HT6!^T8NBgX+rjKPKg'p2%&C8[m=eJfncM(!t_IoM7=m"@o/;4F@(;B_bOMK(<eE!"\3fXpI
	i^>H,^\Td2mSo_[8H7l@pOEeI1=jBf(rpFRA1OJQYS)67#I,AQ>6%FZBrr2mCc-=K8&;XZr!eO^\+5
	D"P.o$V%IloW!@;sZ3Hg,0nR`">Rf\O,Q95A_rIC&bQ^hkZ+C78I.e+m!`\bJT9SQpH%aij_`akf_S
	ae8jo5*Nji%6m0uflp:X$B0uFCX^'kZJQgH/0`Q=O@f?oOA;s;coX4tkFJrEf`-C=Dm\9/VAa-OV(Y
	5IqI1\Ws$dfQ$b4f][Z0W`^l3,hI;a%#05_T@#X1:'j\I!1#Xle"(oF/d*N)AC]\`&6i$KE128BZs(
	,jbF!u(='G1/lU!BZTG]+XV"!g@mPj.f@S/q+C'-Wfje'`=gp5U7N5B>aXtR.ib9>108K&^0+jL\?i
	2ZIA*/8(ZhnH.03=?X,75&P+9NZ5=FLIWQctJm0qGrE5l7TEk+"JS?<*n<ZNi;@AOM7jn<Q\@3*LBV
	K?)GNR,;Rb$'@EH/\e7I\\ig#_:83HpZW+c^CD=BqE;ntY*YqkOSUSH7RiAT3=VfBKl<l[YBVe&Fbj
	F^)tROVNCbrqRRqMqc3(!`<ta$OUZMF#[]-pKZ_]B^"j!M)Bd;4r:/pDdu]"6UE!%$E.6+03AI$>R&
	0OGC]&c?JQfC(V^6OP:KcEND/]\H?P\EE=r:edls9X*>iPIMom$%Lra\$'EeY7S.B@?!]8_,4&ohA'
	IlhM<ST3U&P+9n%`?3%95_<%QMtRtKbn'/WirTJ.G$4XB.j\6M-gC;%gV.HNEs6_WiQ-V"c!R.1+pP
	$4kn^-oSqVh)G8r_?kQ7\?cPRhK36)moFA+6!lu>_5'ms[@s-Q1r/BtBg!>3SH@bTTZs?&Rhs[Quk<
	ufS73G]?iG(!3gG8(5R*$;fGR!^B$@03EEH&mLR%`o(4K081aAUcV;^Djq('Dg*,0^'p,OibdC(CC%
	h*e+LD/VU$)77L;+FXnRCrhD;JNt?K>UeTLrq>gT:!?e.b*l`"ONe_Qd4$HJ?!l,mZ"fXY.-3/H!kk
	BLqRO92C9ef"Xs^iIPf=dF:L>`2DXiWM3k5m>rr'$BoUbHhgM\0g9-fC2Wq%ao#0rXUVIOT%:?^`ZP
	"h(`OR]Cg'<44brB20A$]&-md`Gd8m+M!kT"n%XJ"D"Ae,h''cOBD06Oc7LMS;B>bttOEpJ]ccre<O
	JfeD)-fauheZFsVVH]Qq`iYTGJ7`dl#h7\/ZfAU*7ZIR,'n4=#;2D%FR#kdFDrt3;k1)S51@VEWu44
	gZ(F-9M>@Gl>g!A,bY1>6Xi>>-e]0n"sLHG@H`qWB9[0iAF8JEn+TFQ;-3AXDTr^Bara%OM-sF_#$Y
	[Ap56q1<p52`imS*3"W;II^"[,4.;(bh1#5#`\FA)9rC#[./.Ieg#526nGiY%1(!InrP'foLKH_r$%
	4tmaC%-qsFj3-RRgLWq:g_e_K$YQ,bR:)^&\s81+I<3Bh3'G$slNHf5Ne7Qm"=;HaeXZ%8E?Jd3P?R
	Vno\I3kFg7Fk3,G=I+d"bteBiYTGJK9VH'"9MG@QNFdBm0_B1_5D7.Id&j<nd=[Hh;eOJ'30rCa7AP
	>TRXhu:TgtLO8p&Yfd%<$W*N(?d#s(9DMVJ#%3I>1ks+Bc8p#-kS!2`Z7&o4\75]m."ObE:".k#Aq;
	%rDS]8V/<(NkfPDNJ($,pH_7&nAa#n.>."CmE/-FTDb\E3W`Wrjna1*orD`2Xj\.Yoq4.JaQMlYn8@
	U9THSQL%0*DQK$j<Q$Nll/XH\R6$PR'^?VW,*#\2SglQ+4;3"oSsg+-C@IkBEjHr%WrmfkQdK>YdH'
	:sgtGGpj((C)/aol.\<'<r4RLJBYBC8@`%M2Vj=Vo'Ie_m)Z[G4";nH;k#`6JFi[8pfQcDUrb50LU^
	P0'j1&Qla1IgcsFHK6+3I9.5U#ms(-/"2Q7Am3.>0*"D+uPQ9!De"W@"j8(iYR/fEYe`j#48R3Cp%!
	RXFMjaLC6ed\CAZhn?YN]XGO3:Vd\#ecFKH6aWd.=kV*:2=?NQO\lXYO^JJI0I2DZEL:2q\?C!5*,#
	epUAgp%j"]6BTqF&\MD#`XTQM)EWnbFj;9PtI4Ma0>63@*'qkE_TT_j))IUGH^57]7>rZG9E7$qsha
	df.iAOW&@/Ha+pG@SJ&u<r&<k(GM4MD\Nq=9B"4u<X!V2Q:U*#"]YV%&G^<,+/hV.4Fcgda%()8a<Z
	3HPWqcP`5AjDrP<$a`;$E&"L?-C$knKo-Z'8(M10]W*@A%\1l5<dXEG;/RWTg$.4Ki.Y5l%\>_bU`+
	e5`p_k@>3.:aV8jd8a7e<2j`Of\%c2l?nE]6`Qe2W%L-b#>,S,)KYPF;:$S:@=kMk[Y0Qj.rspOjBh
	U!@nC^/YNt\[X,MW?Qae0PW(4?1%;VgG6LK4$j7g(*<+T!#fLId<:BGK56!I>L]eIbBe(X&W?=k"!T
	+2HX+bPBfBm7P;t`HtC=Wd$=VVDaZc1PfX;D9-))JWSd6=h[#Te8mo<TOH)ajNI&1)OOGjVoj2KCl:
	22RME:V^q8+E',jF]VgU)VJr4)kPS]]ZF#-dl>[\.KI-lH/36$iS5'H!ETki+7A6f8K8GocluPl"E*
	fl1s5-'ku;Tqb*QJi[rM*3bMR)QDOt1U2h^rp+??tmb5H_H$[2bZL>_<BX,WVK'MDMG%WakP1Fg5cl
	J]9hXfr_X;-1ar`[^*)*0gb4U2rVjs#KuinB%Lfp[^#e'0OS=$j,J%H97a7+Q6-_JmpJ5hmOFgc@j@
	)Z'8*,aOU/"Z2W\mT=f4Ap?ccMjIDb873G4j!jHV#^>&DNJ)rl39%"6]K@[FL_E#\LEs?68(3GN]0L
	d<+VGQLLoq/$1$nP'1*1>78^q``:AT2q2EhNC)i_Ue9CM'Nsk/qsUZg']ZpW6/3HU`Q=]#J5OiMj%0
	7jR471STPGU_oj)O?f72T`Ce[ad4+Fp+sb`9[iIIoRD:+he*_I9d"ls81->d(`F;rG3%l7)bo)'WjN
	qhk$.6^'uKaI)*Y/ASh`%<`6+JbXEk3G4Jl!=H8tAWTMR#fULKs&;WiRP*f)1P9GCGi-bT>S[1U6d.
	28fF*)Iru-[7aYL_W:W;(I?f3f'"eoL+bj6kh!@9HLhBps:`jHnVGKUr4nfl/XH.]OY=!2:/f")Vil
	KJ]M:D>Au8UARg=J1m'N16oL6dan=+%9[ma-3-loS:-_l>"#oQj4qN8`e&@e=VroV3BM]jJR+19`q5
	ha3m%AEp'G`j!f?#0[=O'c(+C<h_iTMY7!QXYZ8_Y#g$!n3MPA.qtl-`T(Q3GQ8Tl06<7_n=,]^YUb
	>s_?b,*5Q;NfcpoW3&_1baL5A5h#.>p3MqQ!>20Vk#L,"r9NWiju])R4'HHN?LMjT!`.O;.Zu2*Pcs
	f6I!mPG:&fFN3p/-"$*(os!pScp$gcZZ/,5#C]>?"AZ?[r?%`Dis\`L&.``4/n%hHhI'qX&/1C/%SP
	Q*tac?.Nql;E6/H3)g,MHICnptV5"(S&4Y(o`)VKNb2(q\6a+.]B%.a&H8e!r2LBW%*-@d;l12[lI.
	A8K(h*0f"6`>$H\^Ql=F(9guDAEgn5;Z0=!>;L[Q5NO_2eqk:IH02NCu#X3!je#06/f3!P&+GCDB)B
	Le$2C/mCr5?mb*Fpq9n<f\H:\&OOPI?&AQN%62o-DOhNKgR2Xt"4<CFLg7ZBXm@+`;(3e^fm(3rj*1
	;/Ppp'W[BQ*1Q2YTBu(TmQB5mYMNmR&:q^7i6?S;ai+?6gN;1L%(S+sS=A(kX)g^t=PekCDm$jb`"K
	hLVI'J&#8-_4JO%*&?\Njp\L6<BI[1ZO<XAr[qOq*>WZa(AW<JljLQD&b6Oo0iE"Ne![;tJLHCCYG"
	Df_l>fra:26d(/p!f#\7g5U6)?C#l>P%(sg)eT+`Jjtb-fW(O*N=QYXV(h[404^bYZ;H#E4f(Uf;'-
	K]i#32P,M;>+O39D9;YXT`039GkQt5k.u%B^#i+&G^i^C`V]`o2V<Jd^)0U$oP)AN/[:4G=*O`,02l
	YnL0Sh7\)t+T9[`oNaJr?&>0')AM0S.I,;l[ikQ)5(Wf/[N8kAdM%Lr8<]<P!"?6AJ$1H:Uo0hG9W[
	Yc36'4?Q;nTB;-R8AmEb9s=<elkn5N^SLk0E"BeHpO$5tE,kZ;GN^jq.%iNnl*CS)*rTFm&W6Glci7
	CH.[-;C*\P-Ogo7?TbKblA`@n(P(I8p^En>3C'cT&K6C*'M4h>./Sf(;!30R@"+;<!_jqd,&j5`+jS
	#0s*=5Al+Q5@jZ@$r?6>1[.B1%J:I75C_4I_F&&`/3#WX(m"<:GE/&c;Our@nNFj'8kLVq2S6d[D6Y
	OP`SHN)g7GlE]?`>9+cp#1.0+LPhP7t0[DCiF3?6:P>BCERD^bTkncW'G&e7Qof1UcKSp1m,g*+>@A
	bmG.G]OG.ZU^I1F,E;0\!;@;1&_[/ieki6BS13fB\BXL'^`q;[*hrihWTPf:&K<%/SL5ac$f=7p`&`
	j\=GNd:sdr@ak#QoSYrZ6qO@85Fo.kI4/>=/?%TknT6r<0f0cb?[jC9dD<t=ZKQ?i3bG7Ha!)`'qRi
	CW_jW6VMI0!)07ktGjIGMtF"/>L4foDbPsC#.>te@u_Q\Rt<?O**,qW,?OH.BqZcZB-I>(ZH<b74`d
	C-k/Q%BKS1?q?<3!:.VKg&B/A*L4QDf-f.cdR$7[8LsCbF^X1#bKXY@[gpa-&_Xo*/fgp0f$_oq3kD
	Ff3E]Z?V8d#Jhl]R?9O\dCT<ae3?lnt5G_=FPpR#s0>A=(OH69uWR1MSOdIQIG#9EYj$Yq(4`HlAkc
	gp3QHP-+F&\?75[Q;OF:obn.l:,'@UW'>X]7bG%8]HgHn;WR`5mL#&YQY<11KOaa*BSho:LkH9%,GF
	9*6Ud&I8N6jF.jCo?)a3l_kAm-)M+G=>YS<1sRgeW,jD_W$nAu;A$@_%G?%K17jQNO6'`Yr4o%&D)J
	7G.%3jg//dAg3iC'!<B_dXE^qURPM8s2.dikWl6$ZHK46h_hWM,`U,J:d$1DF"0J\#Ja^l'-nq/)^7
	N]fh7H'f(s5C1s50$NX?V8d#Jhl]Rph<mR/.V-*';k4YIH0SN5@LBN<6IjM.s<O;Gk3p:qe-bpFs9D
	Wph[9r7%2HX"SH<M7578g&<2=$cU=7'@F,pqUA*k_9_^$5M2JhV0iCGK<4.%S:[dBm<#L9nW=n-7SJ
	TH0!$b@bpUG[W6m3c0Hp[a/RXPj5Bd]6(M`5uTWs:!#l$)B`F]HhfX(R6JMF`"&s1m1*oPn)RV`FM2
	Idjk(%o.Vf[#)lRY)25YOt?-A'cE2`>Km!Be[-Z1U_lX:N)XK=e8"(W:&VtHP<Q,W9=YPUTPFqWfE@
	3<oeE2?J24CK=/'4#I,;5IgRkZE:Ae"9IM%fQ-[5H^/c4ne9qI.Mg:m5!C2@CU$ER@!N:#B_^$bgYr
	#XgX\_]6^AXoF52-/pJqh2]B.9*>-gU0nNB<k7t<j*SVL/")'&^g#ql,>Mp+T_NXM9k:SN2[+6Hn."
	@,jNCP,Johi<:$!d2UETf$\n!Ioh<VXKgt'gde&IUd\(-:,S^/g&AJJR(K&<1G2$k>nu)BPZ#f*R*F
	$!jrUF.-YP=qNr?<XW,q$3ACtlDcdJNCIs!r/ij91h+0*:D!"EP8`MI0!)07qW)'E\^G!pSbKF-$%g
	p1NKj+FXoe5UXV#rJE,.GZk#FF,,d9N^o[cie\%H+&r/9RXPj5*e%s$:*:)R,[;&i"9RiK"9O->3]V
	aV+HT>n+:nfB/H/Fq!<>]P=OVCn,lI]C!!#SZ:.26O@"J
	ASCII85End
End




Function SpHrView_AtTime_ActivityWindow()
	DFREF saveDFR = GetDataFolderDFR()
	
	string globals_dfStr = SpHrView_AtTime_DF_Globals
	
	// DisplayActivitiesMode 0:Halfmaximal, 1:SD, 2: Maximal
	// DisplayCuesMode 0: Carrier, 1: Envelope, 2: Carrier and Envelope
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
	NVAR DisplayCuesMode = $globals_dfStr+"DisplayCuesMode"
	
	if(DisplayActivitiesMode < 0)
		DoAlert/T="Warning" 0, "Select Edges, SD, or Maxima"
	endif
	if(DisplayCuesMode < 0)
		DoAlert/T="Warning" 0, "Select IPD/ITD, ILD or both"
	endif
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getSDs = $globals_dfStr+"getSDs"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
	
	NVAR ScaledCarrierActivityLimit = $SpHrView_AtTime_DF_Globals+"ScaledCarrierActivityLimit"
	NVAR ScaledEnvelopeActivityLimit = $SpHrView_AtTime_DF_Globals+"ScaledEnvelopeActivityLimit"  // should be the same as above?
	variable ScaledActivityLimit
	
	NVAR AlphaMask_ABL = $globals_dfStr+"AlphaMask_ABL"
	int overlayAlpha = AlphaMask_ABL
	variable LimitScale = 1
	variable useHalfmaxLookup = 1
	
	String WinTitleStr = "At Time Activities"

	if(DisplayActivitiesMode < 2 && DisplayCuesMode==0)
		if(useCarrierCues && getEdges)
			wave leftImage = $SpHrView_AtTime_DF+"HalfmaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"HalfmaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"Halfmaximal_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"Halfmaximal_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledCarrierActivityLimit
			LimitScale = 1
			useHalfmaxLookup = 1	// should be 1 if LimitScale = 1
			wave/Z Points = $SpHrView_AtTime_DF+"HalfmaximalActivityPoints"
		else
			// ??
		endif
	endif
	// else if
	if(DisplayActivitiesMode < 2 && DisplayCuesMode==1)
		if(useEnvelopeCues && getEdges)
			wave leftImage = $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"EnvelopeHalfmaximal_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"EnvelopeHalfmaximal_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledEnvelopeActivityLimit
			LimitScale = 1
			useHalfmaxLookup = 1	// should be 1 if LimitScale = 1
			wave/Z Points = $SpHrView_AtTime_DF+"EnvelopeHalfmaximalActivityPoints"
		else
			// ??
		endif
	endif
	if(DisplayActivitiesMode < 2 && DisplayCuesMode==2)
		if(useEnvelopeCues && getEdges)
			NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
			//	if(!ScaleIPDToITD)
			//		DoAlert/T="Warning" 0, "Scale IPD to ITD (select ITD checkbox) when displaying both carrier and envelope derived activities"
			//	endif
			wave leftImage = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivity_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledCarrierActivityLimit
			LimitScale = 1
			useHalfmaxLookup = 1	// should be 1 if LimitScale = 1
			wave/Z Points = $SpHrView_AtTime_DF+"CombinedHalfmaximalActivityPoints"
		else
			// ??
		endif
	endif
	
	if(DisplayActivitiesMode == 2 && DisplayCuesMode==0)
		if(useEnvelopeCues && getEdges)
			wave leftImage = $SpHrView_AtTime_DF+"MaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"MaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"MaximalActivity_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"MaximalActivity_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledCarrierActivityLimit
			useHalfmaxLookup = 0
			wave/Z Points = $SpHrView_AtTime_DF+"MaximalActivityPoints"
		else
			// ???
		endif
	endif
	if(DisplayActivitiesMode == 2 && DisplayCuesMode==1)
		if(useEnvelopeCues && getEdges)
			wave leftImage = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"EnvelopeMaximalActivity_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledEnvelopeActivityLimit
			useHalfmaxLookup = 0
			wave/Z Points = $SpHrView_AtTime_DF+"EnvelopeMaximalActivityPoints"
		else
			// ???
		endif
	endif
	if(DisplayActivitiesMode == 2 && DisplayCuesMode==2)
		if(useEnvelopeCues && getEdges)
			NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
			if(!ScaleIPDToITD)
				DoAlert/T="Warning" 0, "Scale IPD to ITD (select ITD checkbox) when displaying both carrier and envelope derived activities"
			endif
			wave leftImage = $SpHrView_AtTime_DF+"CombinedMaximalActivity_Left"
			wave rightImage = $SpHrView_AtTime_DF+"CombinedMaximalActivity_Right"
			if(!waveexists(leftImage) || !waveexists(rightImage))
				return 0
			endif
			wave/Z leftAlpha = $SpHrView_AtTime_DF+"CombinedMaximalActivity_AlphaMask_Left"
			wave/Z rightAlpha = $SpHrView_AtTime_DF+"CombinedMaximalActivity_AlphaMask_Right"
			if(!waveexists(leftAlpha) || !waveexists(rightAlpha))
				overlayAlpha = 0
			endif
			ScaledActivityLimit = ScaledCarrierActivityLimit
			useHalfmaxLookup = 0
			wave/Z Points = $SpHrView_AtTime_DF+"CombinedMaximalActivityPoints"
		else
			// ???
		endif
	endif
	
	variable imageLayer = 0
	if(DisplayActivitiesMode == 1)  // && getSDs)
		imageLayer = 1
		useHalfmaxLookup = 0
		LimitScale = 0
	endif

	int ControlBarOnLeft = 1
	String WinNameStr = cleanupName(WinTitleStr,0)
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	Variable i
	if(WindowExists) // remove traces and images
		RemoveTraces(WinNameStr)
		RemoveImages(WinNameStr)
	else
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		//variable numWindowColumns = 5 // number of windows horizontally distributed
		//variable wdth=screenHoriz*ViewWidthProportion/numWindowColumns
		variable wdth = 500
		if(ControlBarOnLeft)
			wdth = screenHoriz*ViewWidthProportion/3
			wdth = max(500,wdth)
		else
			wdth = screenHoriz*ViewWidthProportion/4
			wdth = max(400,wdth)
		endif
		variable hgt= screenVert*ViewHeightProportion*3.2  // screenVert*ViewHeightProportion*1.69 for half
		variable leftRectPnt = (screenHoriz/6)
		variable rightRectPnt = (screenHoriz/6)
		variable topRectPnt = 240
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			GetWindow/Z SpHrViewPeaksWindow wsize // use SpHrViewPeaksWindow wsize
			leftRectPnt = V_left; topRectPnt = V_bottom+25
			rightRectPnt = V_right
		endif
		//variable winCnt = SpHrView_getWindowSlot("AtTimeWin", numWindowColumns)
		//Display /K=1/W=(leftRectPnt+(wdth*(winCnt)), topRectPnt, leftRectPnt+(wdth*(winCnt+1)), topRectPnt+hgt) as WinTitleStr
		Display /K=1/W=(leftRectPnt, topRectPnt, leftRectPnt+wdth, topRectPnt+hgt) as WinTitleStr
		DoWindow/F/C $WinNameStr
		ModifyGraph/W=$WinNameStr margin(left)=46,margin(bottom)=36,margin(top)=31,margin(right)=31
		
		NVAR Frequencyline = $SpHrView_AtTime_DF_Globals+"Frequencyline"
		NVAR lineFrequency = $SpHrView_AtTime_DF_Globals+"lineFrequency"
		NVAR lineFrequencyIndex = $SpHrView_AtTime_DF_Globals+"lineFrequencyIndex"
		wave/Z CFs = $SpHrView_df_filter+"CFs"
		if(waveexists(CFs))
			lineFrequency = min(lineFrequency, wavemax(CFs))
			lineFrequency = max(lineFrequency, wavemin(CFs))
			Variable index, Hz
			[index, Hz] = SpHrView_getCFindex(CFs, lineFrequency)
			lineFrequency = Hz
			lineFrequencyIndex = index
		endif
		
//		if(ControlBarOnLeft)// Control bar on left
			ModifyGraph/W=$WinNameStr margin(top)=36
		
			ControlBar/W=$WinNameStr /L 100
			NewPanel/HOST=$WinNameStr/FG=(FL,FT,GL,FB)/HOST=# 
			RenameWindow #,PCBar
			variable ptop=10
			Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar", pos={20,ptop},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_AtTime
			Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_ButtonProc
			ptop += 30
			
			// Cues - Carrier, Envlope, or both
			GroupBox group_Cues win=$WinNameStr+"#PCBar",title="Cues",pos={5,ptop},size={88,80}
			ptop += 17
			CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", title="Carrier",pos={15,ptop},side=0,value= DisplayCuesMode == 0
			CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 20
			CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", title="Envelope",pos={15,ptop},side=0,value= DisplayCuesMode == 1
			CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 20
			CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", title="Both",pos={15,ptop},side=0,value= DisplayCuesMode == 2
			CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 30
			
			// Activities - Edges, SD, Maxima
			GroupBox group_Activities win=$WinNameStr+"#PCBar", title="Activities",pos={5,ptop},size={88,80}
			ptop += 17
			//ptop += 25
			CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", title="Edges",pos={15,ptop},side=0,value= DisplayActivitiesMode == 0
			CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 20
			CheckBox ck_DisplaySD win=$WinNameStr+"#PCBar", title="SD",pos={15,ptop},side=0,value= DisplayActivitiesMode == 1
			CheckBox ck_DisplaySD win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 20
			CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", title="Maxima",pos={15,ptop},side=0,value= DisplayActivitiesMode == 2
			CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
			ptop += 30
			
			// Append Frequency-specific lines
			GroupBox group_Frequencyline win=$WinNameStr+"#PCBar",title="Lines",pos={5,ptop},size={88,65}
			ptop += 17
			CheckBox ck_FrequencyLine title="Frequency",pos={15,ptop},side=0,variable=$SpHrView_AtTime_DF_Globals+"Frequencyline"
			CheckBox ck_FrequencyLine proc=SpHrView_AtTime_CheckProc, help={"Append frequency-specific lines"}
			ptop += 25
			SetVariable sv_lineFrequency win=$WinNameStr+"#PCBar",title="Hz",pos={17,ptop},size={66,14},bodyWidth=45,focusRing=0,proc=SpHrView_AtTime_SetVarProc
			SetVariable sv_lineFrequency win=$WinNameStr+"#PCBar",value=lineFrequency, limits={20,20000,1}, format="%.0f"
			SetVariable sv_lineFrequency win=$WinNameStr+"#PCBar",help={"Frequency to which cursor corresponds"}
			ptop += 30
			
			// Append Peaks
			GroupBox group_AppendPeaks win=$WinNameStr+"#PCBar", title="'Peaks'",pos={5,ptop},size={88,81}
			ptop += 17
			CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", title="Append",pos={15,ptop},side=0,variable=$SpHrView_AtTime_DF_Globals+"AppendPeaks"
			CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={"Place markers at half-maximal or maximal activity'peaks'."}
			ptop += 20
			CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", title="Opposite",pos={15,ptop},side=0,variable=$SpHrView_AtTime_DF_Globals+"AppendPeaksOppositeHemi"
			CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={"Append peaks from opposite hemisphere"}	
			ptop += 20
			CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar", title="⊘ limits",pos={15,ptop},side=0,variable=$SpHrView_AtTime_DF_Globals+"setPointsAtLimitsToNaN"
			CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={"Remove 'peaks' at 'label' limits"}	
			
			NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
			if(!AppendPeaks)
				CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar", disable=2
				CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", disable=2
			endif
			
			NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
			if(!getPeaks)
				NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
				AppendPeaks = 0
				CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", disable=2
				CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar", disable=2
				CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", disable=2
				GroupBox group_AppendPeaks win=$WinNameStr+"#PCBar", disable=2
			endif
			
			//setPointsAtLimitsToNaN
			
			
			ptop += 30
			
			// Overlay Mask
			GroupBox group_AlphaMask_ABL win=$WinNameStr+"#PCBar", title="Transparancy",pos={5,ptop},size={88,90}
			ptop += 17
			CheckBox ck_AlphaMask_ABL win=$WinNameStr+"#PCBar", title="ABL (dB)",pos={15,ptop},side=0,variable=$SpHrView_AtTime_DF_Globals+"AlphaMask_ABL"
			CheckBox ck_AlphaMask_ABL win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={"Apply alpha mask so that high average binaural level (ABL) values are opaque & low ABL values are transparent"}
			ptop += 23
			SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",title="min",pos={13,ptop},size={72,14},bodyWidth=40,focusRing=0,proc=SpHrView_AtTime_SetVarProc
			SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",variable = $SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Min",format="%.0f",limits={0,120,3}
			SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",help={"ABL (dB) below which the appended masking image is opaque (white)"}
			ptop += 25
			SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar",title="max",pos={13,ptop},size={72,14},bodyWidth=40,focusRing=0,proc=SpHrView_AtTime_SetVarProc
			SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar",variable = $SpHrView_AtTime_DF_Globals+"AlphaMask_ABL_Max",format="%.0f",limits={1,120,3}
			SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar", help={"ABL (dB) above which the appended masking image is transparent"}
			
			
			
		
		
//		else // Control bar on top
//			ControlBar/W=$WinNameStr /T 55
//			NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=#  // FR and GR
//			RenameWindow #,PCBar
//			
//			Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar", pos={8,15},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_AtTime
//			Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_ButtonProc
//			GroupBox group_AlphaMask_ABL win=$WinNameStr+"#PCBar", title="",pos={42,8},size={35,40}
//			TitleBox t_ABL win=$WinNameStr+"#PCBar", title="ABL",pos={35,7},anchor=MC,frame=0
//			CheckBox ck_AlphaMask_ABL win=$WinNameStr+"#PCBar", title="",pos={52,26},side=0,variable=$SpHrView_AtTime_DF_Globals+"AlphaMask_ABL"
//			CheckBox ck_AlphaMask_ABL win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={"Apply alpha mask so that high average binaural level (ABL) values are opaque & low ABL values are transparent"}
//			// Activities
//			GroupBox group_Activities win=$WinNameStr+"#PCBar", title="",pos={75,6},size={255,23}
//			TitleBox t_Activities win=$WinNameStr+"#PCBar", title="Activities:",pos={78,6},anchor=RC,frame=0
//			CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", title="Edges",pos={135,7},side=0,value= DisplayActivitiesMode == 0
//			CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			CheckBox ck_DisplaySD win=$WinNameStr+"#PCBar", title="SD",pos={195,7},side=0,value= DisplayActivitiesMode == 1
//			CheckBox ck_DisplaySD win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", title="Maxima",pos={265,7},side=0,value= DisplayActivitiesMode == 2
//			CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			// Cues
//			GroupBox group_Cues win=$WinNameStr+"#PCBar", title="",pos={75,28},size={255,23}
//			TitleBox t_Cues win=$WinNameStr+"#PCBar", title="Cues:",pos={73,26},anchor=RC,frame=0
//			CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", title="Carrier",pos={135,28},side=0,value= DisplayCuesMode == 0
//			CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", title="Envelope",pos={195,28},side=0,value= DisplayCuesMode == 1
//			CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", title="Both",pos={265,28},side=0,value= DisplayCuesMode == 2
//			CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", proc=SpHrView_AtTime_CheckProc, help={""}
//			// Frequency-specific lines
//			GroupBox group_Frequencyline win=$WinNameStr+"#PCBar", pos={wdth-70,8},size={65,40}
//			CheckBox ck_FrequencyLine title="Hz 〰",pos={wdth-55,7},side=0,variable=$SpHrView_AtTime_DF_Globals+"Frequencyline"
//			CheckBox ck_FrequencyLine proc=SpHrView_AtTime_CheckProc, help={"Append frequency-specific lines"}
//			SetVariable sv_lineFrequency win=$WinNameStr+"#PCBar",title=" ",pos={wdth-60,30},bodyWidth=45,focusRing=0,proc=SpHrView_AtTime_SetVarProc
//			SetVariable sv_lineFrequency win=$WinNameStr+"#PCBar",value=lineFrequency, limits={20,20000,1}, help={"Frequency to which line corresponds"}
//		endif	
		
		SetActiveSubwindow $WinNameStr //##
		ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
		
		SetWindow $WinNameStr, hook(AtTimeHook)=SpHrView_AtTime_ActivityWindowHook
		SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:AtTimeWin"
		
	endif
	
	
	SVAR ColorTableStr = $SpHrView_AtTime_DF_Globals+"ColorTableStr"
	NVAR ReverseColorTable = $SpHrView_AtTime_DF_Globals+"ReverseColorTable"
	SpHr_ColorTable/R=(ReverseColorTable)/Dest=$SpHrView_AtTime_DF+"ColorTable" ColorTableStr 
	wave ColorTable=$SpHrView_AtTime_DF+"ColorTable"
	if(useHalfmaxLookup)
		SpHr_ColorTable/Dest=M_colors ColorTableStr  // ColorTab2Wave $ColorTableStr; wave M_colors=M_colors
		Make/O/N=(dimsize(M_colors,0)) $SpHrView_AtTime_DF+"ColorTableLookup" = 1; killwaves/z M_colors
		wave ColorTableLookup = $SpHrView_AtTime_DF+"ColorTableLookup"
		WindowFunction Bartlet, ColorTableLookup
	endif
	
	Variable pnt_R=0, pnt_G=0, pnt_B=0
	NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
	NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
	if(getPeaks && AppendPeaks)
		//Printf "%g, %g, %g\r", ColorTable[dimsize(ColorTable,0)-1][0], ColorTable[dimsize(ColorTable,0)-1][1], ColorTable[dimsize(ColorTable,0)-1][2]
		variable rgbSum = ColorTable[dimsize(ColorTable,0)-1][0]+ColorTable[dimsize(ColorTable,0)-1][1]+ColorTable[dimsize(ColorTable,0)-1][2]
		if(rgbSum > 30000)
			pnt_R=0; pnt_G=0; pnt_B=0
		else
			pnt_R=65535; pnt_G=65535; pnt_B=65535
		endif
		// inverse of last color
		//pnt_R = 65535 - ColorTable[dimsize(ColorTable,0)-1][0]
		//pnt_G = 65535 - ColorTable[dimsize(ColorTable,0)-1][1]
		//pnt_B = 65535 - ColorTable[dimsize(ColorTable,0)-1][2]
		//Printf "%g, %g, %g\r", pnt_R, pnt_G, pnt_B
	endif
 
	
	NVAR AlphaMask_ABL = $SpHrView_AtTime_DF_Globals+"AlphaMask_ABL"
	if(AlphaMask_ABL)
		SpHr_ColorTable/Dest=$SpHrView_AtTime_DF+"AlphaColorTable"/M=(65535)/A={0,1} "Solid"
		wave AlphaColorTable=$SpHrView_AtTime_DF+"AlphaColorTable"
	endif
	
	String XUnitsStr, imageNameStr, alphaNameStr, traceName1, traceName2
	
	if(waveexists(leftImage) && waveexists(rightImage))
		// Left
		imageNameStr = NameOfWave(leftImage)
		AppendImage/W=$WinNameStr /G=1/L=left_L/B=bottom_L leftImage // /G to suppress rgb(t)
		ModifyImage/W=$WinNameStr $imageNameStr plane=imageLayer
		if(LimitScale > 0)
			ModifyImage/W=$WinNameStr $imageNameStr ctab= {0,ScaledActivityLimit*LimitScale,ColorTable,0},ctabAutoscale=3,lookup= $""
		else
			ModifyImage/W=$WinNameStr $imageNameStr ctab= {*,*,ColorTable,0},ctabAutoscale=3,lookup= $""
		endif
		if(useHalfmaxLookup)
			ModifyImage/W=$WinNameStr $imageNameStr lookup=ColorTableLookup
		endif
		ModifyGraph/W=$WinNameStr axisEnab(left_L)={0.51,1},freePos(left_L)=0
		ModifyGraph/W=$WinNameStr freePos(bottom_L)={0.51,kwFraction}
		ModifyGraph/W=$WinNameStr userticks(left_L)={$SpHrView_df_filter+"CFs_TickVals",$SpHrView_df_filter+"CFs_TickTxt"}
		Label/W=$WinNameStr left_L "frequency (kHz),  \\f01left\\f00 hemisphere"
		ModifyGraph/W=$WinNameStr lblPos(left_L)=35
		ModifyGraph/W=$WinNameStr zero(bottom_L)=1,zeroThick(bottom_L)=0.5,gridEnab(bottom_L)={0.51,1}

		XUnitsStr = WaveUnits(leftImage, 0) // StringByKey("XUNITS", WaveInfo(w,0))
		if(stringmatch(XUnitsStr, "s") || stringmatch(XUnitsStr, "sec"))
			Label/W=$WinNameStr bottom_L "ITD (\\U)"
		elseif(stringmatch(XUnitsStr, "dB"))
			Label/W=$WinNameStr bottom_L "ILD (\\U)"
		elseif(stringmatch(XUnitsStr, "cycles"))
			Label/W=$WinNameStr bottom_L "IPD (\\U)"
		elseif(stringmatch(XUnitsStr, "s_dB"))
			ModifyGraph/W=$WinNameStr noLabel(bottom_L)=1
			Label/W=$WinNameStr bottom_L "ITD (s) ⧓ ILD (dB)\\u#2"
		elseif(stringmatch(XUnitsStr, "cycles_dB"))
			ModifyGraph/W=$WinNameStr noLabel(bottom_L)=1
			Label/W=$WinNameStr bottom_L "IPD (cycles) ⧓ ILD (dB)\\u#2"
		endif
		ModifyGraph/W=$WinNameStr lblPos(bottom_L)=28
		Label/W=$WinNameStr bottom_L "\\u#2"

		// Peaks
		NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
		NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
		if(getPeaks && AppendPeaks && waveexists(Points))
			AppendToGraph/W=$WinNameStr/L=left_L/B=bottom_L/VERT Points[][0][0]/TN=LeftHalfMaxima
			ModifyGraph/W=$WinNameStr mode(LeftHalfMaxima)=3,marker(LeftHalfMaxima)=19,msize(LeftHalfMaxima)=2
			ModifyGraph/W=$WinNameStr mrkThick(LeftHalfMaxima)=0.5, rgb(LeftHalfMaxima)=(pnt_R,pnt_G,pnt_B)
			ModifyGraph/W=$WinNameStr zmrkSize(LeftHalfMaxima)={Points[*][0][1],0,ScaledActivityLimit*LimitScale,0.5,3}
			
			NVAR AppendPeaksOppositeHemi = $SpHrView_AtTime_DF_Globals+"AppendPeaksOppositeHemi"
			if(AppendPeaksOppositeHemi)
				AppendToGraph/W=$WinNameStr/L=left_L/B=bottom_L/VERT Points[][1][0]/TN=LeftHalfMaximaOppositeHemi
				ModifyGraph/W=$WinNameStr mode(LeftHalfMaximaOppositeHemi)=3,marker(LeftHalfMaximaOppositeHemi)=8,msize(LeftHalfMaximaOppositeHemi)=2
				ModifyGraph/W=$WinNameStr mrkThick(LeftHalfMaximaOppositeHemi)=0.5, rgb(LeftHalfMaximaOppositeHemi)=(pnt_R,pnt_G,pnt_B)
				ModifyGraph/W=$WinNameStr zmrkSize(LeftHalfMaximaOppositeHemi)={Points[*][1][1],0,ScaledActivityLimit*LimitScale,0.5,3}
			endif
		endif
		
		// ABL alpha mask
		if(AlphaMask_ABL)
			alphaNameStr = NameOfWave(leftAlpha)
			AppendImage/W=$WinNameStr /G=1/L=left_L/B=bottom_L leftAlpha    //{*,CFEdges}
			ModifyImage/W=$WinNameStr $alphaNameStr ctab= {1,0,AlphaColorTable,0}
		endif
		
		// frequency band lines
		NVAR Frequencyline = $SpHrView_AtTime_DF_Globals+"Frequencyline"
		if(Frequencyline)
			traceName1 = "left"
			traceName2 = "right_dashed"
			NVAR lineFrequency = $SpHrView_AtTime_DF_Globals+"lineFrequency"
			NVAR lineFrequencyIndex = $SpHrView_AtTime_DF_Globals+"lineFrequencyIndex"
			AppendToGraph/W=$WinNameStr/R=right_L/B=bottom_L leftImage[*][lineFrequencyIndex][imageLayer]/TN=$traceName1
			AppendToGraph/W=$WinNameStr/R=right_L/B=bottom_L rightImage[*][lineFrequencyIndex][imageLayer]/TN=$traceName2
			ModifyGraph/W=$WinNameStr axisEnab(right_L)={0.51,1},freePos(right_L)=0
			ModifyGraph/W=$WinNameStr lsize($traceName1)=0.5,rgb($traceName1)=(0,0,65535)
			ModifyGraph/W=$WinNameStr lsize($traceName2)=0.5,rgb($traceName2)=(65535,0,0,32768),lstyle($traceName2)=2
			ModifyGraph/W=$WinNameStr tick(right_L)=3,noLabel(right_L)=0,axThick(right_L)=0,lowTrip(right_L)=0.0001
			ModifyGraph/W=$WinNameStr lblPos(right_L)=28
			Label/W=$WinNameStr right_L ""
			SetAxis/W=$WinNameStr right_L 0,ScaledActivityLimit*0.5 // ??
			SetAxis/W=$WinNameStr/A/E=2 bottom_L
			//XUnitsStr = WaveUnits(rightImage, 0) // StringByKey("XUNITS", WaveInfo(w,0))																
																	// 20000 65535								
			Cursor/W=$WinNameStr/P/A=0/I/S=2/H=3/T=1/C=(0,0,0,0) A $imageNameStr dimsize(leftImage,1)/2, lineFrequencyIndex
							
		endif
		
		// Right
		imageNameStr = NameOfWave(rightImage)
		AppendImage/W=$WinNameStr /G=1/L=left_R/B=bottom_R rightImage // /G to suppress rgb(t)
		ModifyImage/W=$WinNameStr $imageNameStr plane=imageLayer
		if(LimitScale > 0)
			ModifyImage/W=$WinNameStr $imageNameStr ctab= {0,ScaledActivityLimit*LimitScale,ColorTable,0},ctabAutoscale=3,lookup= $""
		else
			ModifyImage/W=$WinNameStr $imageNameStr ctab= {*,*,ColorTable,0},ctabAutoscale=3,lookup= $""
		endif
		if(useHalfmaxLookup)
			ModifyImage/W=$WinNameStr $imageNameStr lookup=ColorTableLookup
		endif
		ModifyGraph/W=$WinNameStr axisEnab(left_R)={0.0,0.49},freePos(left_R)=0
		ModifyGraph/W=$WinNameStr freePos(bottom_R)={0,kwFraction}
		ModifyGraph/W=$WinNameStr userticks(left_R)={$SpHrView_df_filter+"CFs_TickVals",$SpHrView_df_filter+"CFs_TickTxt"}
		Label/W=$WinNameStr left_R "frequency (kHz),  \\f01right\\f00 hemisphere"
		ModifyGraph/W=$WinNameStr lblPos(left_R)=35
		ModifyGraph/W=$WinNameStr zero(bottom_R)=1,zeroThick(bottom_R)=0.5,gridEnab(bottom_R)={0.0,0.49}
		XUnitsStr = WaveUnits(rightImage, 0) // StringByKey("XUNITS", WaveInfo(w,0))
		if(stringmatch(XUnitsStr, "s") || stringmatch(XUnitsStr, "sec"))
			Label/W=$WinNameStr bottom_R "ITD (\\U)"
		elseif(stringmatch(XUnitsStr, "dB"))
			Label/W=$WinNameStr bottom_R "ILD (\\U)"
		elseif(stringmatch(XUnitsStr, "cycles"))
			Label/W=$WinNameStr bottom_R "IPD (\\U)"
		elseif(stringmatch(XUnitsStr, "s_dB"))
			ModifyGraph/W=$WinNameStr noLabel(bottom_R)=1
			Label/W=$WinNameStr bottom_R "ITD (s) ⧓ ILD (dB)\\u#2"
		elseif(stringmatch(XUnitsStr, "cycles_dB"))
			ModifyGraph/W=$WinNameStr noLabel(bottom_R)=1
			Label/W=$WinNameStr bottom_R "IPD (cycles) ⧓ ILD (dB)\\u#2"
		endif
		ModifyGraph/W=$WinNameStr lblPos(bottom_R)=28

		// Peaks
		NVAR getPeaks = $SpHrView_AtTime_DF_Globals+"getPeaks"
		NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
		if(getPeaks && AppendPeaks && waveexists(Points))
			AppendToGraph/W=$WinNameStr/L=left_R/B=bottom_R/VERT Points[][1][0]/TN=RightHalfMaxima
			ModifyGraph/W=$WinNameStr mode(RightHalfMaxima)=3,marker(RightHalfMaxima)=19
			ModifyGraph/W=$WinNameStr mrkThick(RightHalfMaxima)=0.5,msize(RightHalfMaxima)=2,rgb(RightHalfMaxima)=(pnt_R,pnt_G,pnt_B)
			ModifyGraph/W=$WinNameStr zmrkSize(RightHalfMaxima)={Points[*][1][1],0,ScaledActivityLimit*LimitScale,0.5,3}
			
			NVAR AppendPeaksOppositeHemi = $SpHrView_AtTime_DF_Globals+"AppendPeaksOppositeHemi"
			if(AppendPeaksOppositeHemi)
				AppendToGraph/W=$WinNameStr/L=left_R/B=bottom_R/VERT Points[][0][0]/TN=RightHalfMaximaOppositeHemi
				ModifyGraph/W=$WinNameStr mode(RightHalfMaximaOppositeHemi)=3,marker(RightHalfMaximaOppositeHemi)=8
				ModifyGraph/W=$WinNameStr mrkThick(RightHalfMaximaOppositeHemi)=0.5,msize(RightHalfMaximaOppositeHemi)=2,rgb(RightHalfMaximaOppositeHemi)=(pnt_R,pnt_G,pnt_B)
				ModifyGraph/W=$WinNameStr zmrkSize(RightHalfMaximaOppositeHemi)={Points[*][0][1],0,ScaledActivityLimit*LimitScale,0.5,3}
			endif
		endif
		
		if(getPeaks)
			CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", disable=0
			GroupBox group_AppendPeaks win=$WinNameStr+"#PCBar", disable=0
		else
			NVAR AppendPeaks = $SpHrView_AtTime_DF_Globals+"AppendPeaks"
			AppendPeaks = 0
			CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", disable=2
			GroupBox group_AppendPeaks win=$WinNameStr+"#PCBar", disable=2
		endif
		
		// ABL alpha mask
		if(AlphaMask_ABL)
			alphaNameStr = NameOfWave(rightAlpha)
			AppendImage/W=$WinNameStr /G=1/L=left_R/B=bottom_R rightAlpha    //{*,CFEdges}
			ModifyImage/W=$WinNameStr $alphaNameStr ctab= {1,0,AlphaColorTable,0}
		endif
		
		// frequency band lines
		NVAR Frequencyline = $SpHrView_AtTime_DF_Globals+"Frequencyline"
		if(Frequencyline)
			traceName1 = "right"
			traceName2 = "left_dashed"
			NVAR lineFrequency = $SpHrView_AtTime_DF_Globals+"lineFrequency"
			NVAR lineFrequencyIndex = $SpHrView_AtTime_DF_Globals+"lineFrequencyIndex"
			AppendToGraph/W=$WinNameStr/R=right_R/B=bottom_R rightImage[*][lineFrequencyIndex][imageLayer]/TN=$traceName1
			AppendToGraph/W=$WinNameStr/R=right_R/B=bottom_R leftImage[*][lineFrequencyIndex][imageLayer]/TN=$traceName2
			ModifyGraph/W=$WinNameStr axisEnab(right_R)={0.0,0.49},freePos(right_R)=0
			ModifyGraph/W=$WinNameStr lsize($traceName1)=0.5,rgb($traceName1)=(65535,0,0)
			ModifyGraph/W=$WinNameStr lsize($traceName2)=0.5,rgb($traceName2)=(0,0,65535,32768),lstyle($traceName2)=2
			ModifyGraph/W=$WinNameStr tick(right_R)=3,noLabel(right_R)=0,axThick(right_R)=0,lowTrip(right_R)=0.0001
			ModifyGraph/W=$WinNameStr lblPos(right_R)=28
			Label/W=$WinNameStr right_R ""
			SetAxis/W=$WinNameStr right_R 0,ScaledActivityLimit*0.5 // ??
			SetAxis/W=$WinNameStr/A/E=2 bottom_R		
														// 20000 65535	
			Cursor/W=$WinNameStr/P/A=0/I/S=2/H=3/T=1/C=(0,0,0,0) B $imageNameStr dimsize(rightImage,1)/2, lineFrequencyIndex
		
		endif
	
	endif // if(waveexists(leftImage) && waveexists(rightImage))
	
	ColorScale/W=$WinNameStr/C/N=ActColorScale/F=0/B=1/M/A=MT/X=5.50/Y=0.00/E=2 vert=0,width=75,height=6,frame=0.00,image=$imageNameStr
	ColorScale/W=$WinNameStr/C/N=ActColorScale font="Arial",fsize=9,lblLatPos=70,lblMargin=15,nticks=4,tickLen=2.00,tickThick=0.50,ZisZ=1

	if(ControlBarOnLeft)// Control bar on left
		if(DisplayActivitiesMode == 0)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=7.00/Y=0.5 lblLatPos=70,"activity\\u#2"
		elseif(DisplayActivitiesMode == 1)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=11.00/Y=0.5 lblLatPos=85,"standard deviation\\u#2"
		elseif(DisplayActivitiesMode == 1)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=7.00/Y=0.5 lblLatPos=60
		endif
	else
		if(DisplayActivitiesMode == 0)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=7.00 lblLatPos=70,"activity\\u#2"
		elseif(DisplayActivitiesMode == 1)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=11.00 lblLatPos=85,"standard deviation\\u#2"
		elseif(DisplayActivitiesMode == 1)
			ColorScale/W=$WinNameStr/C/N=ActColorScale/X=7.00 lblLatPos=60
		endif
	endif
	
	ModifyGraph/W=$WinNameStr tick=2, mirror=0
	ModifyGraph/W=$WinNameStr font="Arial", fSize=10, lblMargin=2
	ModifyGraph/W=$WinNameStr standoff=0, axThick=0.5
	ModifyGraph/W=$WinNameStr ZisZ=1, zapTZ=1, zapLZ=1
	ModifyGraph/W=$WinNameStr btLen=4, btThick=0.5, stLen=2, stThick=0.5
	
	SetWindow $WinNameStr, hook(AtTimeHook)=SpHrView_AtTime_ActivityWindowHook
	SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:AtTimeWin"
	
	doupdate // update for cursor
	
	SetDataFolder saveDFR
	return 0
End


Function SpHrView_AtTime_AccrualWindow(variable EnvelopeAccrual)
	DFREF saveDFR = GetDataFolderDFR()
	if(EnvelopeAccrual)
		wave W = $SpHrView_AtTime_DF+"EnvelopeAccruals"
		wave Xs = $SpHrView_AtTime_DF+"EnvXs"
	else
		wave W = $SpHrView_AtTime_DF+"Accruals"
		wave Xs = $SpHrView_AtTime_DF+"Xs"
	endif
	if(!waveexists(W))
		DoAlert/T="Warning" 0, "wave: "+SpHrView_AtTime_DF+"Accruals or EnvelopeAccruals is missing."
		return 0
	endif
	if(!waveexists(Xs))
		DoAlert/T="Warning" 0, "wave: "+SpHrView_AtTime_DF+"Xs or EnvXs is missing."
		return 0
	endif
	String WinTitleStr, WinNameStr
	if(EnvelopeAccrual)
		WinTitleStr = "Envelope Activity Accrual"
		WinNameStr = "Envelope_Activity_Accrual"
	else
		WinTitleStr = "Activity Accrual"
		WinNameStr = "Activity_Accrual"
	endif
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	Variable i
	if(WindowExists) // remove traces and images
		RemoveTraces(WinNameStr)
		//RemoveImages(WinNameStr)
	else
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		variable wdth=screenHoriz*ViewWidthProportion
		variable hgt = screenVert*ViewHeightProportion*1 // 1.25
		variable leftRectPnt = (screenHoriz-wdth)/2
		variable topRectPnt = 240
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			GetWindow/Z SpHrViewPeaksWindow wsize // use SpHrViewPeaksWindow wsize
			leftRectPnt = V_left; topRectPnt = V_bottom+30
		endif
		variable winCnt = SpHrView_CountGroupWindows("AtTimeWin") // SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:Histogram"
		if(winCnt>4)
			winCnt -= 5
		endif
		Display /K=1/W=(leftRectPnt, topRectPnt, leftRectPnt+wdth, topRectPnt+hgt) as WinTitleStr
		
		DoWindow/F/C $WinNameStr
		ModifyGraph/W=$WinNameStr margin(left)=40+18, margin(top)=18, margin(right)=36, margin(bottom)=25
		//ControlBar/W=$WinNameStr /T 37
		//NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=# 
		//RenameWindow #,PCBar
		//Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar",pos={15,8},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_AtTime
		//Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar",proc=SpHrView_AtTime_ButtonProc
		//Button b_SpHrView_AtTime win=$WinNameStr+"#PCBar",help={""}
		//SetActiveSubwindow $WinNameStr //##
		//ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
	endif
	
	wave CFs = $SpHrView_df_filter+"CFs"
	int64 numCFs = numpnts(CFs)
	NVAR maxCarrierFreq = $SpHrView_AtTime_DF_Globals+"maxCarrierFreq"
	NVAR minEnvelopeFreq = $SpHrView_AtTime_DF_Globals+"minEnvelopeFreq"
	
	
	NVAR InterhemiphericCoordination = $SpHrView_AtTime_DF_Globals+"InterhemiphericCoordination"
	
	// display only left hemisphere accruals for all frequencies if InterhemiphericCoordination == 1
	if(InterhemiphericCoordination)
	
		SVAR ColorTableStr = $SpHrView_AtTime_DF_Globals+"ColorTableStr"
		NVAR ReverseColorTable = $SpHrView_AtTime_DF_Globals+"ReverseColorTable"
		
		variable minCF=0, maxCF=numCFs
		if(EnvelopeAccrual)
			minCF = round(binarySearchInterp(CFs,minEnvelopeFreq))
		else
			maxCF = round(binarySearchInterp(CFs,maxCarrierFreq)) 
		endif
		numCFs = maxCF-minCF
		
		// Append traces
		string tStr
		for(i=minCF;i<maxCF;++i)
			tStr = "Hz_"+num2str(CFs[i])
			Appendtograph/W=$WinNameStr W[*][i][0] /TN=$tStr vs Xs[*][i][0]
			SpHr_ColorTable/R=(ReverseColorTable)/RGB={i,minCF,maxCF} ColorTableStr
			ModifyGraph/W=$WinNameStr rgb($tStr)=(V_R, V_G, V_B, V_A)
		endfor
		// Append legend
		Legend/W=$WinNameStr/C/N=text0/J/F=0/A=LC "\\sb+12\\JCFrequency (Hz)"
		for(i=minCF;i<maxCF;++i)
			if(mod(i,9)==0  || i==maxCF-1)  // first, every 9th, last
				tStr = "Hz_"+num2str(CFs[i])
				AppendText/W=$WinNameStr "\\sb+06\\s("+tStr+") "+num2str(CFs[i])+""
			endif
		endfor
		
		
	// display select frequencies for left and right hemispheres if InterhemiphericCoordination == 0
	else
	
		int64 cf_ind = 0
		int trace1=0, trace2=0, trace3=0
	
		///////    Append traces    ///////// 
		// 1st trace
		if(EnvelopeAccrual)
			cf_ind = ceil(BinarySearch(CFs, minEnvelopeFreq ) + 1)
		else
			cf_ind = 0
		endif
		WaveStats/Q/M=1/RMD=[][cf_ind,cf_ind][] W
		if(V_npnts > 0)
			trace1 = 1
			AppendToGraph/W=$WinNameStr W[*][cf_ind][0]/TN=$"ACC_left_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			AppendToGraph/W=$WinNameStr W[*][cf_ind][1]/TN=$"ACC_right_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			ModifyGraph/W=$WinNameStr rgb($"ACC_left_"+num2str(CFs[cf_ind])+"Hz")=(0,0,65535)
			ModifyGraph/W=$WinNameStr lsize($"ACC_left_"+num2str(CFs[cf_ind])+"Hz")=2
			ModifyGraph/W=$WinNameStr lsize($"ACC_right_"+num2str(CFs[cf_ind])+"Hz")=2
		endif
		
		// 2nd trace
		if(EnvelopeAccrual)
			cf_ind = floor(( BinarySearch(CFs, minEnvelopeFreq) + (numCFs - 1 - BinarySearch(CFs, minEnvelopeFreq)) / 2))
		else
			cf_ind = floor( BinarySearch(CFs, maxCarrierFreq) / 2 )
		endif
		WaveStats/Q/M=1/RMD=[][cf_ind,cf_ind][] W
		if(V_npnts > 0)
			trace2 = 1
			AppendToGraph/W=$WinNameStr W[*][cf_ind][0]/TN=$"ACC_left_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			AppendToGraph/W=$WinNameStr W[*][cf_ind][1]/TN=$"ACC_right_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			ModifyGraph/W=$WinNameStr rgb($"ACC_left_"+num2str(CFs[cf_ind])+"Hz")=(0,0,65535)
		endif
		
		// 3rd trace
		if(EnvelopeAccrual)
			cf_ind = numCFs - 1
		else
			cf_ind = floor(BinarySearch(CFs, maxCarrierFreq))
		endif
		WaveStats/Q/M=1/RMD=[][cf_ind,cf_ind][] W
		if(V_npnts > 0)
			trace3 = 1
			AppendToGraph/W=$WinNameStr W[*][cf_ind][0]/TN=$"ACC_left_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			AppendToGraph/W=$WinNameStr W[*][cf_ind][1]/TN=$"ACC_right_"+num2str(CFs[cf_ind])+"Hz" vs Xs[*][cf_ind]
			ModifyGraph/W=$WinNameStr rgb($"ACC_left_"+num2str(CFs[cf_ind])+"Hz")=(0,0,65535)
			ModifyGraph/W=$WinNameStr lstyle($"ACC_left_"+num2str(CFs[cf_ind])+"Hz")=2
			ModifyGraph/W=$WinNameStr lstyle($"ACC_right_"+num2str(CFs[cf_ind])+"Hz")=2
		endif
		
		
		///////    Append Legend    ///////// 
		// 1st trace legend
		if(EnvelopeAccrual)
			cf_ind = ceil(BinarySearch(CFs, minEnvelopeFreq ) + 1)
		else
			cf_ind = 0
		endif
		Legend/W=$WinNameStr/C/N=text0/B=1/J/F=0/M/A=LT/X=2.00/Y=0.00 "       hemisphere\r\\sb+10left\t\tright"
		if(trace1)
			AppendText/W=$WinNameStr "\\s(ACC_left_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz\t"
			AppendText/W=$WinNameStr/NOCR "\\s(ACC_right_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz"
		else
			AppendText/W=$WinNameStr "\\f02Activitiy limit not reached at "+num2str(CFs[cf_ind])+" Hz\\f00"
		endif
		
		// 2nd trace legend
		if(EnvelopeAccrual)
			cf_ind = floor( ( BinarySearchInterp(CFs, minEnvelopeFreq) + (numCFs - 1 - BinarySearchInterp(CFs, minEnvelopeFreq)) / 2))
		else
			cf_ind = floor( BinarySearchInterp(CFs, maxCarrierFreq) / 2 )
		endif
		if(trace2)
			AppendText/W=$WinNameStr "\\s(ACC_left_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz\t"
			AppendText/W=$WinNameStr/NOCR "\\s(ACC_right_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz"
		else
			AppendText/W=$WinNameStr "\\f02Activitiy limit not reached at "+num2str(CFs[cf_ind])+" Hz\\f00"
		endif
		// 3rd trace legend
		if(EnvelopeAccrual)
			cf_ind = numCFs - 1
		else
			cf_ind = floor(BinarySearchInterp(CFs, maxCarrierFreq)) // floor?
		endif
		if(trace3)
			AppendText/W=$WinNameStr "\\s(ACC_left_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz\t"
			AppendText/W=$WinNameStr/NOCR "\\s(ACC_right_"+num2str(CFs[cf_ind])+"Hz"+") "+num2str(CFs[cf_ind])+" Hz"
		else
			AppendText/W=$WinNameStr "\\f02Activitiy limit not reached at "+num2str(CFs[cf_ind])+" Hz\\f00"
		endif
		
		AppendText/W=$WinNameStr "\rInitial vales indicate when the\rActivity Limit was first reached."
		
	endif // if(InterhemiphericCoordination)
	
	
	// set x axis to same as SpHrViewPeaksWindow
	GetAxis/W=SpHrViewPeaksWindow/Q bottom
	SetAxis/W=$WinNameStr bottom V_min,V_max
	ModifyGraph/W=$WinNameStr tick=2,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0
	ModifyGraph/W=$WinNameStr btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial"
	
	
	SetDataFolder saveDFR
End

