﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


strconstant SpHrView_df_cue = "root:SpHrView:Cues:"
strconstant SpHrView_df_cue_globals = "root:SpHrView:Cues:Globals:"


// =================================================================================================
// SpHrView_Cues_Defaults(), Binaural cues defaults
// =================================================================================================
Function SpHrView_Cues_Defaults()
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Cues" folder, SpHrView_df_cue
	if(!DataFolderExists(SpHrView_df_cue))
		FolderStr= SpHrView_df_cue[0,strlen(SpHrView_df_cue)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Cues:Globals" folder, SpHrView_df_cue_globals
	if(!DataFolderExists(SpHrView_df_cue_globals))
		FolderStr= SpHrView_df_cue_globals[0,strlen(SpHrView_df_cue_globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_cue_globals
	variable nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"CuesPerCycle", 3)
	variable/G CuesPerCycle = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"useDerivatives", 0)
	variable/G useDerivatives = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"useAmpEnvWtMarkers", 0)
	variable/G useAmpEnvWtMarkers = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"usedtEnvWtMarkers", 0)
	variable/G usedtEnvWtMarkers = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"EnvelopeWtActLimit", 5)
	variable/G EnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"EnvelopeWeightsdB", 0)
	variable/G EnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"dtEnvelopeWtActLimit", 5)
	variable/G dtEnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"dtEnvelopeApplyToEnvelopes", 0)
	variable/G dtEnvelopeApplyToEnvelopes = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"dtEnvelopeWeightsInterp", 0)
	variable/G dtEnvelopeWeightsInterp = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"dtEnvelopeWeightsdB", 0)
	variable/G dtEnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"colorWeights", 1)
	variable/G colorWeights = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"minWeightsMarker", 0.5)
	variable/G minWeightsMarker = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"maxWeightsMarker", 3)
	variable/G maxWeightsMarker = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"CuesPerCycle", 3)
	variable/G CuesPerCycle = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getITDs", 0)
	variable/G getITDs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getIPDs", 0)
	variable/G getIPDs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getILDs", 0)
	variable/G getILDs = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvITDs", 0)
	variable/G getEnvITDs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvIPDs", 0)
	variable/G getEnvIPDs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvILDs", 0)
	variable/G getEnvILDs = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvAvgs", 0)
	variable/G getEnvAvgs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvDevs", 0)
	variable/G getEnvDevs = nval
		
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvs", 0)
	variable/G getEnvs = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getEnvWts", 0)
	variable/G getEnvWts = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getAvgEnvWts", 0)
	variable/G getAvgEnvWts = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"appendExpActAccrual", 0)
	variable/G appendExpActAccrual = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"getSigmoids", 0)
	variable/G getSigmoids = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal", 0)
	variable/G ActAccrualSigmoidsSliderVal = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"AppendWaves", 0)
	variable/G AppendWaves = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"minFrequency", 200)
	variable/G minFrequency = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"maxFrequency", 1000)
	variable/G maxFrequency = nval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"FreqRange", 0)
	variable/G FreqRange = nval
	
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"DisplayLines", 1)
	variable/G DisplayLines = nval
	
	String sval
	sval= StrVarOrDefault(SpHrView_df_cue_globals+"ColorTableStr", "Turbo")	
	string/G ColorTableStr = sval
	nval= NumVarOrDefault(SpHrView_df_cue_globals+"ReverseColorTable", 1)
	variable/G ReverseColorTable = nval

	SetDataFolder saveDFR
End

// =================================================================================================
// SpHrView_CuesOptionsWindow(), display options for Cues
// =================================================================================================
Function SpHrView_CuesOptionsWindow(variable winLeft, variable winTop)
	if(winleft < 0 || winTop < 0)
		GetMouse
		winleft=V_left
		winTop=V_top
	endif
	variable getITD=0, getIPD=0, getILD=0
	DoWindow ITDs_over_time
	if(v_flag)
		getITD=1
	endif
	DoWindow IPDs_over_time
	if(v_flag)
		getIPD=1
	endif
	DoWindow ILDs_over_time
	if(v_flag)
		getILD=1
	endif
	
	SpHrView_Cues_Defaults()
	killwindow/Z CuesDisplayOptions
	//	Variable  winLeft=250, winRight, winTop=50, winBottom
	//	[winLeft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
	
	NewPanel /FLT=1/K=1/W=(winLeft, winTop, winLeft+203, winTop+680) as "Cues"
	DoWindow/C CuesDisplayOptions
	variable topPos = 6
	Button b_Display title="Display  ⏎",pos={55,topPos},size={100,20},proc=SpHrView_Cues_ButtonProc,fSize=11
	Button b_Display help={"Display cues. Can also press 'return' key."}
	// Display spatial cues
	topPos += 25
	GroupBox group_CarrierCues, title="Display Carrier cues",fSize=10,fstyle=1,pos={5.00,topPos},size={195.00, 50}
	topPos += 23
	CheckBox ck_ITD title="ITD",pos={30,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getITDs"
	CheckBox ck_IPD title="IPD",pos={30+55,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getIPDs"
	CheckBox ck_ILD title="ILD",pos={30+110,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getILDs"
	topPos += 27
	GroupBox group_EnvelopeCues, title="Display Envelope cues",fSize=10,fstyle=1,pos={5.00,topPos},size={195.00, 50}
	topPos += 23
	CheckBox ck_EnvITD title="ITD",pos={30,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getEnvITDs",disable=0
	CheckBox ck_EnvIPD title="IPD",pos={30+55,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getEnvIPDs",disable=0
	CheckBox ck_EnvILD title="ILD",pos={30+110,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getEnvILDs",disable=0
	
	topPos += 43
	GroupBox group_checks,pos={5.00,topPos-8},size={195.00, 52}
	SetVariable sv_CuesPerCycle,pos={40,topPos},size={142.00,14.00},bodyWidth=35,title="Carrier Cues per cycle"
	SetVariable sv_CuesPerCycle,fSize=10//, proc=SpHrView_CueHistogram_SetVarProc
	SetVariable sv_CuesPerCycle,limits={1,3,1},value= $SpHrView_df_cue_globals+"CuesPerCycle"
	SetVariable sv_CuesPerCycle, help={"Number of ITDs and other corresponding cues per cycle. 1: shortest ITD only, 2: include 2nd shortest ITD, 3: include 3rd shortest ITD"}
	topPos += 20
	CheckBox ck_useDerivatives title="Waveform derivatives ",pos={40,topPos},fSize=10,side=1
	CheckBox ck_useDerivatives variable=$SpHrView_df_cue_globals+"useDerivatives"
	CheckBox ck_useDerivatives help={"Use waveform envelope derivatives. Note that ABL and envelope values relative (not absolute) when derivatives are not used."}
	
	// Marker Weight Attributes
	// envelope derivative weights
	topPos += 38
	GroupBox group_dtEnvWts, fSize=10,fstyle=0,title="Markers/Color: Envelope Weights",pos={5.00,topPos-6},size={195.00, 107}
	topPos += 15
	CheckBox ck_usedtEnvWtMarkers title="\\f01Envelope derivative weights ",pos={25,topPos},fSize=10,side=1
	CheckBox ck_usedtEnvWtMarkers variable=$SpHrView_df_cue_globals+"usedtEnvWtMarkers"
	topPos += 22
	SetVariable sv_dtEnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=40,title="Derivative Limit"
	SetVariable sv_dtEnvelopeWtActLimit,fSize=10
	SetVariable sv_dtEnvelopeWtActLimit,limits={1,100,1},value= $SpHrView_df_cue_globals+"dtEnvelopeWtActLimit"
	SetVariable sv_dtEnvelopeWtActLimit, help={"Envelope derivative activity limit"}
	topPos += 20
	CheckBox ck_dtEnvelopeApplyToEnvelopes title="Apply to envelope cues ",pos={35,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeApplyToEnvelopes variable=$SpHrView_df_cue_globals+"dtEnvelopeApplyToEnvelopes", proc=SpHrView_Cues_CheckProc
	topPos += 20
	CheckBox ck_dtEnvelopeWeightsInterp title="Interpolate ",pos={45,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsInterp variable=$SpHrView_df_cue_globals+"dtEnvelopeWeightsInterp"
	CheckBox ck_dtEnvelopeWeightsInterp, help={"Should not normally be selected. Interpolate derivatives from condition when only 1 cycle per second is obtained"}
	NVAR CuesPerCycle = $SpHrView_df_cue_globals+"CuesPerCycle"
	if(CuesPerCycle<=1)
		CheckBox ck_dtEnvelopeWeightsInterp disable=2
	endif
	CheckBox ck_dtEnvelopeWeightsdB title="dB ",pos={135,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsdB variable=$SpHrView_df_cue_globals+"dtEnvelopeWeightsdB"
	
	// envelope amplitude weights
	topPos += 32
	GroupBox group_EnvWts,pos={5.00,topPos-6},size={195.00, 70}
	CheckBox ck_useAmpEnvWtMarkers title="\\f01Envelope amplitude weights ",pos={25,topPos},fSize=10,side=1
	CheckBox ck_useAmpEnvWtMarkers variable=$SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
	topPos += 22
	SetVariable sv_EnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=40,title="Amplitude Limit"
	SetVariable sv_EnvelopeWtActLimit,fSize=10
	SetVariable sv_EnvelopeWtActLimit,limits={1,100,1},value= $SpHrView_df_cue_globals+"EnvelopeWtActLimit"
	SetVariable sv_EnvelopeWtActLimit, help={"Envelope activity limit"}
	topPos += 20
	CheckBox ck_EnvelopeWeightsdB title="dB ",pos={135,topPos},fSize=10,side=1
	CheckBox ck_EnvelopeWeightsdB variable=$SpHrView_df_cue_globals+"EnvelopeWeightsdB"
	
	topPos += 32
	GroupBox group_MarkerAttributes,pos={5.00,topPos-7},size={195.00, 50}
	SetVariable sv_minWeightsMarker pos={20,topPos-1.0},size={175.00,14.00},bodyWidth=40,fSize=10,title="Marker size when weight = 0"
	SetVariable sv_minWeightsMarker limits={0,10,0.5},value= $SpHrView_df_cue_globals+"minWeightsMarker"
	SetVariable sv_minWeightsMarker help={""}, proc=SpHrView_Cues_SetVarProc,focusRing=0
	topPos += 20
	SetVariable sv_maxWeightsMarker pos={20,topPos},size={175.00,14.00},bodyWidth=40,fSize=10,title="Marker size when weight = 1"
	SetVariable sv_maxWeightsMarker limits={0,10,1},value= $SpHrView_df_cue_globals+"maxWeightsMarker"
	SetVariable sv_maxWeightsMarker help={""}, proc=SpHrView_Cues_SetVarProc,focusRing=0
	
	topPos += 28
	GroupBox group_Lines, title="",pos={5.00,topPos-5},size={195.00, 48}
	CheckBox ck_DisplayLines title="Display lines",pos={20,topPos},fSize=10,fstyle=2,variable=$SpHrView_df_cue_globals+"DisplayLines"
	topPos += 20
	CheckBox ck_colorWts title="Color when 1 frequeny band",pos={20,topPos},fSize=10,fstyle=2,side=0
	CheckBox ck_colorWts variable=$SpHrView_df_cue_globals+"colorWeights", proc=SpHrView_Cues_CheckProc
	
	
	topPos += 30
	GroupBox group_EnvsWts, title="",pos={5.00,topPos},size={195.00, 160}
	topPos += 8
	TitleBox t_EnvelopeWts title="Display Envelope weights",pos={40,topPos},frame=0,fSize=10,fstyle=1
	topPos += 20
	CheckBox ck_Envs title="Envelopes",pos={15,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getEnvs"
	CheckBox ck_EnvelopeWeightsdB_0 title="dB",pos={95,topPos},fSize=9,fstyle=0,side=1
	CheckBox ck_EnvelopeWeightsdB_0 variable=$SpHrView_df_cue_globals+"EnvelopeWeightsdB"
	topPos += 23
	CheckBox ck_EnvWts title="Weights, Left & Right",pos={15,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getEnvWts"
	topPos += 21
	CheckBox ck_AvgEnvWts title="Weights, Left & Right Average",pos={15,topPos},fSize=10,variable=$SpHrView_df_cue_globals+"getAvgEnvWts"
	topPos += 17
	CheckBox ck_dtEnvelopeWeightsInterp_0 title="interpolate derivative weights",pos={30,topPos},fSize=9,fstyle=2,side=0
	CheckBox ck_dtEnvelopeWeightsInterp_0 variable=$SpHrView_df_cue_globals+"dtEnvelopeWeightsInterp"
	topPos += 24
	CheckBox ck_appendExpActAccrual_noCues title="Activity Accrual (right axis)",pos={15,topPos},fSize=10,side=0,fSize=10,fstyle=0,disable=0
	CheckBox ck_appendExpActAccrual_noCues variable=$SpHrView_df_cue_globals+"appendExpActAccrual", proc=SpHrView_Cues_CheckProc
	topPos += 20
	CheckBox ck_Sigmoids_noCues title="Weighting sigmoids",pos={15,topPos},fSize=10,side=0,fSize=10,fstyle=0,disable=0
	CheckBox ck_Sigmoids_noCues variable=$SpHrView_df_cue_globals+"getSigmoids", proc=SpHrView_Cues_CheckProc
	CheckBox ck_EnvAvgs title="μ",pos={135,topPos},fSize=10,side=0,fSize=10,fstyle=0
	CheckBox ck_EnvAvgs variable=$SpHrView_df_cue_globals+"getEnvAvgs", proc=SpHrView_Cues_CheckProc
	CheckBox ck_EnvDevs title="σ",pos={165,topPos},fSize=10,side=0,fSize=10,fstyle=0
	CheckBox ck_EnvDevs variable=$SpHrView_df_cue_globals+"getEnvDevs", proc=SpHrView_Cues_CheckProc
	
	topPos += 35
	CheckBox ck_keepWindowOpen win=CuesDisplayOptions, title="📌 ",fSize=10,pos={30,topPos},side=0
	CheckBox ck_keepWindowOpen win=CuesDisplayOptions, help={"Keep window open"}
	
	DoUpdate/W=CuesDisplayOptions // for Igor 9
	SetWindow CuesDisplayOptions, hook(CuesOptionsHook)=SpHrView_Cues_WindowHook
	SetWindow CuesDisplayOptions note="PACKAGE:SpHrView;GROUP:Cues"
End




Function SpHrView_Cues()
	DFREF saveDFR = GetDataFolderDFR()
	SpHrView_Cues_Defaults()
	SetDataFolder $SpHrView_df_cue_globals
	
	NVAR getITDs=$SpHrView_df_cue_globals+"getITDs"
	NVAR getIPDs=$SpHrView_df_cue_globals+"getIPDs"
	NVAR getILDs=$SpHrView_df_cue_globals+"getILDs"

	NVAR getEnvITDs=$SpHrView_df_cue_globals+"getEnvITDs"
	NVAR getEnvIPDs=$SpHrView_df_cue_globals+"getEnvIPDs"
	NVAR getEnvILDs=$SpHrView_df_cue_globals+"getEnvILDs"

	NVAR getEnvs=$SpHrView_df_cue_globals+"getEnvs"
	NVAR getEnvWts=$SpHrView_df_cue_globals+"getEnvWts"
	NVAR getAvgEnvWts=$SpHrView_df_cue_globals+"getAvgEnvWts"
	
	NVAR getEnvDevs=$SpHrView_df_cue_globals+"getEnvDevs"
	NVAR getEnvAvgs=$SpHrView_df_cue_globals+"getEnvAvgs"
	
	NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
	NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
	NVAR AppendWaves = $SpHrView_df_cue_globals+"AppendWaves"
	
	// if using check boxes in CuesDisplayOptions
	doWindow CuesDisplayOptions
	if(v_flag)
		// kill window if check box not checked
		
		//Carrier cues
		DoWindow ITDs_over_time				// window "ITDs over time"
		if(v_flag && !getITDs)
			killwindow/Z ITDs_over_time
		endif
		DoWindow IPDs_over_time				// window "IPDs over time"
		if(v_flag && !getIPDs)
			killwindow/Z IPDs_over_time
		endif
		DoWindow ILDs_over_time				// window "ILDs over time"
		if(v_flag && !getILDs)
			killwindow/Z ILDs_over_time
		endif
		
		// Envelope cues
		DoWindow EnvITDs_over_time				// window "EnvITDs over time"
		if(v_flag && !getEnvITDs)
			killwindow/Z EnvITDs_over_time
		endif
		DoWindow EnvIPDs_over_time				// window "EnvIPDs over time"
		if(v_flag && !getEnvIPDs)
			killwindow/Z EnvIPDs_over_time
		endif
		DoWindow EnvILDs_over_time				// window "EnvILDs over time"
		if(v_flag && !getEnvILDs)
			killwindow/Z EnvILDs_over_time
		endif
		
		DoWindow Average_Envelope_weights_over_time	// window "Average Envelope weights over time"
		if(v_flag && !getAvgEnvWts)
			killwindow/Z Average_Envelope_weights_over_time
		endif
		
		DoWindow Envelopes_Left_and_Right
		if(v_flag && !getEnvs)
			killwindow/Z Envelopes_Left_and_Right
		endif
		DoWindow Envelope_weights_over_time
		if(v_flag && !getEnvWts)
			killwindow/Z Envelope_weights_over_time
		endif
		
		DoWindow Envelope_Averages_Left_and_Right
		if(v_flag && !getEnvAvgs)
			killwindow/Z Envelope_Averages_Left_and_Right
		endif
		DoWindow Envelope_Deviations_Left_and_Right
		if(v_flag && !getEnvDevs)
			killwindow/Z Envelope_Deviations_Left_and_Right
		endif
		
		killwindow/Z CuesDisplayOptions // kill options window
		
	// if NOT using check boxes in CuesDisplayOptions
	// update if window is open
	else
		// one layered waves
		DoWindow ITDs_over_time
		if(v_flag)
			getITDs= 1
		endif
		DoWindow IPDs_over_time
		if(v_flag)
			getIPDs= 1
		endif
		DoWindow ILDs_over_time
		if(v_flag)
			getILDs= 1
		endif
		
		DoWindow Envelope_ITDs_over_time
		if(v_flag)
			getEnvITDs= 1
		endif
		DoWindow Envelope_PDs_over_time
		if(v_flag)
			getEnvIPDs= 1
		endif
		DoWindow Envelope_ILDs_over_time
		if(v_flag)
			getEnvILDs= 1
		endif
		
		DoWindow Average_Envelope_weights_over_time
		if(v_flag)
			getAvgEnvWts= 1
		endif
		
		// two layered waves
		DoWindow Envelopes_Left_and_Right
		if(v_flag)
			getEnvs= 1
		endif
		DoWindow Envelope_weights_over_time
		if(v_flag)
			getEnvWts= 1
		endif
		
		DoWindow Envelope_Averages_Left_and_Right
		if(v_flag)
			getEnvAvgs= 1
		endif
		DoWindow Envelope_Deviations_Left_and_Right
		if(v_flag)
			getEnvDevs= 1
		endif
		
	endif
	
	// Load waveforms from SpHrViewPeaksWindow
	variable startSec, endSec, usingAxis
	[startSec, endSec, usingAxis] = SpHrView_LoadWaveformsFromPeaks()
	wave waveforms=$SpHrView_df_files+"waveforms"
	variable numCols = dimsize(waveforms,1)
	if(numCols>2)
		DoAlert 0, "SpHrView_Cues: waveform has > 2 channels/columns"
		return 0
	endif
	if(usingAxis)
		SpHrView_DrawSelection(2, startSec, endSec)
	else
		SpHrView_DrawSelection(1, startSec, endSec)
	endif
	
	// record timeframe used to obtain last histogram
	SVAR/Z timeFrameStr = $SpHrView_df_cue_globals+"timeFrameStr"
	if(SVAR_Exists(timeFrameStr))
		if(endSec-startSec < 1)
			if(startSec > 0.01)
				SPrintf timeFrameStr, "%.2f to %.2f s", startSec, endSec
			else
				SPrintf timeFrameStr, "%d to %.2f s", startSec, endSec
			endif
		else
			if(startSec > 0.01)
				SPrintf timeFrameStr, "%.1f to %.1f s", startSec, endSec
			else
				SPrintf timeFrameStr, "%d to %.1f s", startSec, endSec
			endif
		endif
	endif
	NVAR useDerivatives = $SpHrView_df_cue_globals+"useDerivatives"
	NVAR CuesPerCycle = $SpHrView_df_cue_globals+"CuesPerCycle"
	
	NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
	NVAR EnvLimit = $SpHrView_df_cue_globals+"EnvelopeWtActLimit"
	NVAR EnvdB = $SpHrView_df_cue_globals+"EnvelopeWeightsdB"
	
	NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
	NVAR dtEnvLimit = $SpHrView_df_cue_globals+"dtEnvelopeWtActLimit"
	NVAR dtInterp = $SpHrView_df_cue_globals+"dtEnvelopeWeightsInterp"
	NVAR dtEnvdB = $SpHrView_df_cue_globals+"dtEnvelopeWeightsdB"
	
	NVAR lowFreq = $SpHrView_df_filter+"lowFreq"
	NVAR highFreq = $SpHrView_df_filter+"highFreq"
	NVAR numCFs = $SpHrView_df_filter+"numCFs"
	NVAR RMSscale = $SpHrView_df_filter+"RMSscale"
	NVAR clearDelays = $SpHrView_df_filter+"clearDelays"
	variable fs = round(1/dimdelta(waveforms,0))
	
	// get filter banks
	SpHrView_CenterFrequencies()
	wave CFs = $SpHrView_df_filter+"CFs"
	SpHr_FilterBankBiquadCoefs fs, CFs, coefBank
	SpHr_FilterBankBiquad /RMS/Dest=$SpHrView_df_filter+"FilterBanks" CFs, coefBank, waveforms
	wave FilterBanks = $SpHrView_df_filter+"FilterBanks"
	killwaves/Z coefBank
	
	String cuesDF= SpHrView_df_cue // for getting all cues
	
	if( (getAvgEnvWts || getEnvWts) && !usedtEnvWtMarkers && !useAmpEnvWtMarkers)
		DoAlert/T="Invalid selection" 0, "Select envelope amplitude or derivative weights"
		return 0
	endif
	
	NVAR minFrequency = $SpHrView_df_cue_globals+"minFrequency"
	NVAR maxFrequency = $SpHrView_df_cue_globals+"maxFrequency"
	NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
	if(FreqRange && maxFrequency < minFrequency)
		variable temp = minFrequency // swap
		minFrequency = maxFrequency
		maxFrequency = temp
	endif
	
	////////////////////
	// get Carrier cues 
	// bit 0: Xs, bit 1: XNs, bit 2: ITDs, bit 3: IPDs, bit 4: ILDs, bit 5: ABLs (bit 6 is reserved)
	variable bitMask = 0
	if(getAvgEnvWts || getITDs || getIPDs || getILDs || getEnvWts || getEnvs || getAvgEnvWts || getSigmoids || appendExpActAccrual || getEnvAvgs || getEnvDevs)
		bitMask = SpHr_BitSetRange(bitMask,0,1) // Xs and Ns
		if(getITDs)
			bitMask = SpHr_BitSet(bitMask,2)	// ITD
		endif
		if(getIPDs)
			bitMask = SpHr_BitSet(bitMask,3)	// IPD
		endif
		if(getILDs)
			bitMask = SpHr_BitSet(bitMask,4)	// ILD
		endif
		if(AppendWaves)
			bitMask = SpHr_BitSet(bitMask,7)	// bit 7: Envs (bit 6 is reserved)
		endif	
	
		int usingWeightOperations = 0
		// if displaying something made only by the SpHr_CrossingEnvelopeWeights operation:
		// left & right weights, sigmoids, ExpAccruals, Averages, Deviations
		if(getEnvWts || getEnvs || getSigmoids || appendExpActAccrual || getEnvAvgs || getEnvDevs)
		
			if(getEnvs || useAmpEnvWtMarkers)
				bitMask = SpHr_BitSet(bitMask,7)	// bit 7: Envs (bit 6 is reserved)
			endif
			if(getEnvWts || usedtEnvWtMarkers)
				bitMask = SpHr_BitSet(bitMask,8)	// bit 8: dtEnvs
			endif
			
			SpHr_CrossingCarrierCues /Type=(useDerivatives)/dB=(EnvdB)/dtdB=(dtEnvdB)/idt=(dtInterp)/CPC=(CuesPerCycle)/Cues=(bitMask)/N="Carrier_"/DF=$cuesDF CFs, FilterBanks
			wave/Z Envs=$cuesDF+"Carrier_Envs"
			wave/Z dtEnvs=$cuesDF+"Carrier_dtEnvs"
			usingWeightOperations = 1
			variable EnvLimit_temp= 0, dtEnvLimit_temp= 0
			
		// if only displaying averaged envelope weights or using them as markers:
		elseif(getAvgEnvWts || usedtEnvWtMarkers || useAmpEnvWtMarkers)
	
			EnvLimit_temp = EnvLimit
			dtEnvLimit_temp = dtEnvLimit
			if(!useAmpEnvWtMarkers)
				EnvLimit_temp = 0
			endif
			if(!usedtEnvWtMarkers)
				dtEnvLimit_temp = 0
			endif
		
			SpHr_CrossingCarrierCues /Type=(useDerivatives)/dB=(EnvdB)/dtdB=(dtEnvdB)/idt=(dtInterp)/CPC=(CuesPerCycle)/Cues=(bitMask)/N="Carrier_"/DF=$cuesDF/AWts={EnvLimit_temp, dtEnvLimit_temp, Carrier_AvgEnvWts} CFs, FilterBanks
			wave Carrier_AvgEnvWts = $SpHrView_df_cue+"Carrier_AvgEnvWts"
	
		// if only displaying cues:
		else
			
			SpHr_CrossingCarrierCues /Type=(useDerivatives)/dB=(EnvdB)/dtdB=(dtEnvdB)/idt=(dtInterp)/CPC=(CuesPerCycle)/Cues=(bitMask)/N="Carrier_"/DF=$cuesDF CFs, FilterBanks
			wave/Z Carrier_AvgEnvWts=$"" // NULL weights
			
		endif
	
		// Envelope Weights
		
		if(getAvgEnvWts && !usedtEnvWtMarkers && !useAmpEnvWtMarkers)
			DoAlert/T="Warnining" 0, "Select envelope derivative and/or enevlope amplitude weighting option"
			return 0
		endif
	
		wave/Z ITDs=$cuesDF+"Carrier_ITDs"
		wave/Z IPDs=$cuesDF+"Carrier_IPDs"
		wave/Z ILDs=$cuesDF+"Carrier_ILDs"
		wave Ns=$cuesDF+"Carrier_Ns"
		wave Xs=$cuesDF+"Carrier_Xs"
		
		// Activity accrual
		
		if((getSigmoids || appendExpActAccrual) && useAmpEnvWtMarkers && usedtEnvWtMarkers)
			DoAlert/T="Warning" 0, "Cannot display accruals if both envelope derivative weights and amplitude envelope weights are selected. Choose one or the other."
			appendExpActAccrual = 0
			getSigmoids = 0
		endif
		if((getSigmoids || appendExpActAccrual) && !useAmpEnvWtMarkers && !usedtEnvWtMarkers)
			DoAlert/T="Warning" 0, "Cannot display accruals if neither envelope derivative weights nor amplitude envelope weights are selected."
			appendExpActAccrual = 0
			getSigmoids = 0
		endif
		
		//NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
		NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
		if(FreqRange)
			getSigmoids = 0
		endif
	
		// Build String(s) to execute SpHr_CrossingEnvelopeWeights operation(s)
		
		if(usingWeightOperations)
		
			String ampEnvWtFunctionStr = "SpHr_CrossingEnvelopeWeights"
			String dtEnvWtFunctionStr = "SpHr_CrossingEnvelopeWeights"
		
			if(useAmpEnvWtMarkers && !usedtEnvWtMarkers)		// envelope weights alone
				ampEnvWtFunctionStr += "/Lim="+num2str(EnvLimit)		// EnvLimit !!
				ampEnvWtFunctionStr += "/DF=$\""+SpHrView_df_cue+"\""
				
				if(getSigmoids || appendExpActAccrual)
					ampEnvWtFunctionStr += "/EAC=ExpAccrual"
				endif
				if(getAvgEnvWts || getITDs || getIPDs || getILDs)
					ampEnvWtFunctionStr += "/AWts=Carrier_AvgEnvWts"		// weights averaged for left and right channels
				endif
				if(getSigmoids || getEnvWts || getEnvs || getEnvAvgs || getEnvDevs)
					ampEnvWtFunctionStr += "/Wts=Carrier_EnvWts"				// weights for left and right channels
				endif
				if(getSigmoids || getEnvAvgs || getEnvDevs)
					ampEnvWtFunctionStr += "/Avg=Avgs/Dev=Devs"	// averages and deviations used to compute sigmoids
				endif
				ampEnvWtFunctionStr += " "+SpHrView_df_filter+"CFs,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Ns,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Xs,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Envs"
				
				Execute/Q ampEnvWtFunctionStr
			
			elseif(usedtEnvWtMarkers && !useAmpEnvWtMarkers)	// envelope derivative weights alone 
				dtEnvWtFunctionStr += "/Lim="+num2str(dtEnvLimit) // "/Lim=("+num2str(dtEnvLimit)+")"    // dtEnvLimit !!
				dtEnvWtFunctionStr += "/DF=$\""+SpHrView_df_cue+"\""
				if(getSigmoids || appendExpActAccrual)
					dtEnvWtFunctionStr += "/EAC=ExpAccrual"
				endif
				if(getAvgEnvWts || getITDs || getIPDs || getILDs)
					dtEnvWtFunctionStr += "/AWts=Carrier_AvgEnvWts"			// weights averaged for left and right channels
				endif
				if(getSigmoids || getEnvWts || getEnvs || getEnvAvgs || getEnvDevs)
					dtEnvWtFunctionStr += "/Wts=Carrier_EnvWts"				// weights for left and right channels
				endif
				if(getSigmoids || getEnvAvgs || getEnvDevs)
					dtEnvWtFunctionStr += "/Avg=Avgs/Dev=Devs"		// averages and deviations used to compute sigmoids
				endif
				dtEnvWtFunctionStr += " "+SpHrView_df_filter+"CFs,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Ns,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Xs,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_dtEnvs"
				
				Execute/Q dtEnvWtFunctionStr
				
			elseif(useAmpEnvWtMarkers && usedtEnvWtMarkers)	// envelope AND envelope derivative weights
				ampEnvWtFunctionStr += "/Lim="+num2str(EnvLimit)		// EnvLimit !!
				ampEnvWtFunctionStr += "/DF=$\""+SpHrView_df_cue+"\""
				if(getAvgEnvWts || getITDs || getIPDs || getILDs)
					ampEnvWtFunctionStr += "/AWts=Carrier_AvgEnvWts"		// weights averaged for left and right channels
				endif
				if(getEnvWts || getEnvs || getEnvAvgs || getEnvDevs)
					ampEnvWtFunctionStr += "/Wts=Carrier_EnvWts"				// weights for left and right channels
				endif
				if(getSigmoids || getEnvAvgs || getEnvDevs)
					ampEnvWtFunctionStr += "/Avg=Avgs/Dev=Devs"	// averages and deviations used to compute sigmoids
				endif
				ampEnvWtFunctionStr += " "+SpHrView_df_filter+"CFs,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Ns,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Xs,"
				ampEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Envs"
				
				
				dtEnvWtFunctionStr += "/Lim="+num2str(dtEnvLimit)   // dtEnvLimit !!
				dtEnvWtFunctionStr += "/DF=$\""+SpHrView_df_cue+"\""
				if(useAmpEnvWtMarkers || usedtEnvWtMarkers)
					dtEnvWtFunctionStr += "/AWts=dtAvgEnvWts"			// weights averaged for left and right channels
				endif
				if(getEnvWts || getEnvs || getEnvAvgs || getEnvDevs)
					dtEnvWtFunctionStr += "/Wts=dtEnvWts"				// weights for left and right channels
				endif
				if(getSigmoids || getEnvAvgs || getEnvDevs)
					dtEnvWtFunctionStr += "/Avg=Avgs/Dev=Devs"		// averages and deviations used to compute sigmoids
				endif
				dtEnvWtFunctionStr += " "+SpHrView_df_filter+"CFs,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Ns,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_Xs,"
				dtEnvWtFunctionStr += SpHrView_df_cue+"Carrier_dtEnvs"
				
				Execute/Q ampEnvWtFunctionStr
				Execute/Q dtEnvWtFunctionStr
			
				wave/Z Carrier_AvgEnvWts = $SpHrView_df_cue+"Carrier_AvgEnvWts"
				wave/Z dtAvgEnvWts = $SpHrView_df_cue+"dtAvgEnvWts"
				if(waveexists(Carrier_AvgEnvWts) && waveexists(dtAvgEnvWts))
					Carrier_AvgEnvWts *= dtAvgEnvWts
					killwaves/Z dtAvgEnvWts
				elseif(getAvgEnvWts || getITDs || getIPDs || getILDs)
					DoAlert 0, "Carrier_AvgEnvWts or dtAvgEnvWts wave is missing"
				endif
				
				wave/Z Carrier_EnvWts = $SpHrView_df_cue+"Carrier_EnvWts"
				wave/Z dtEnvWts = $SpHrView_df_cue+"dtEnvWts"
				if(waveexists(Carrier_EnvWts) && waveexists(dtEnvWts))
					Carrier_EnvWts *= dtEnvWts
					killwaves/Z dtEnvWts
				elseif(getEnvWts || getEnvs || getEnvAvgs || getEnvDevs)
					DoAlert 0, "Carrier_EnvWts or dtEnvWts wave is missing"
				endif
			
			else
				wave Carrier_AvgEnvWts=$"" // NULL weights
			endif
		endif
	endif
	
	
	////////////////////
	// get Envelope cues 
	if(getEnvITDs || getEnvIPDs || getEnvILDs)
		bitMask = 0
		bitMask = SpHr_BitSetRange(bitMask,0,1) // Xs and Ns
		if(getEnvITDs)
			bitMask = SpHr_BitSet(bitMask,2)	// ITD
		endif
		if(getEnvIPDs)
			bitMask = SpHr_BitSet(bitMask,3)	// IPD
		endif
		if(getEnvILDs)
			bitMask = SpHr_BitSet(bitMask,4)	// ILD
		endif
		
		EnvLimit_temp = EnvLimit
		dtEnvLimit_temp = dtEnvLimit
		if(!useAmpEnvWtMarkers)
			EnvLimit_temp = 0
		endif
		if(!usedtEnvWtMarkers)
			dtEnvLimit_temp = 0
		endif
		
		NVAR dtEnvelopeApplyToEnvelopes = $SpHrView_df_cue_globals+"dtEnvelopeApplyToEnvelopes"
		if(!dtEnvelopeApplyToEnvelopes)
			dtEnvLimit_temp = 0
		endif
		
		SpHr_CrossingEnvelopeCues /Tr=1/dB=(EnvdB)/dtdB=(dtEnvdB)/CPC=(CuesPerCycle)/Cues=(bitMask)/N="Envelope_"/DF=$cuesDF/AWts={EnvLimit_temp,dtEnvLimit_temp,Envelope_AvgEnvWts}/SPks={pks, pkXs} CFs, FilterBanks

		wave/Z EnvITDs=$cuesDF+"Envelope_ITDs"
		wave/Z EnvIPDs=$cuesDF+"Envelope_IPDs"
		wave/Z EnvILDs=$cuesDF+"Envelope_ILDs"
		wave EnvNs=$cuesDF+"Envelope_Ns"
		wave EnvXs=$cuesDF+"Envelope_Xs"
		
		NVAR AppendWaves = $SpHrView_df_cue_globals+"AppendWaves"
		wave/Z Carrier_Envs = $SpHrView_df_cue+"Carrier_Envs"
		if(AppendWaves && !waveExists(Carrier_Envs))	// Envelope_Envs
			if(EnvdB)
				SpHr_CrossingEnvelope/CFs=CFs /X=$SpHrView_df_cue+"Envelope_EnvXs" /dB=$SpHrView_df_cue+"Envelope_Envs" FilterBanks
			else
				SpHr_CrossingEnvelope/CFs=CFs /X=$SpHrView_df_cue+"Envelope_EnvXs" /Pa=$SpHrView_df_cue+"Envelope_Envs" FilterBanks
			endif
		endif
	
	endif
	
		// one layered waves
	if(getITDs)
		SpHrView_CuesWindow("ITD")
	endif
	if(getIPDs)
		SpHrView_CuesWindow("IPD")
	endif
	if(getILDs)
		SpHrView_CuesWindow("ILD")
	endif
	
	if(getEnvITDs)
		SpHrView_CuesWindow("EnvITD")
	endif
	if(getEnvIPDs)
		SpHrView_CuesWindow("EnvIPD")
	endif
	if(getEnvILDs)
		SpHrView_CuesWindow("EnvILD")
	endif
	
	if(getAvgEnvWts)
		SpHrView_CuesWindow("Carrier_AvgEnvWts")
	endif
	
	// two layered waves
	if(getEnvs)
		SpHrView_CuesWindow("Envs")
	endif
	if(getEnvWts)
		SpHrView_CuesWindow("Carrier_EnvWts")
	endif
	
	if(getEnvAvgs)
		SpHrView_CuesWindow("Avgs")
	endif
	if(getEnvDevs)
		SpHrView_CuesWindow("Devs")
	endif
	
	if(getSigmoids)
		//SpHrView_Cues_SigmasWindow(1)
	else
		SpHrView_Cues_SigmasWindow(0)
	endif

		
//	killWaves/Z FilterBanks
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_CuesWindow(), Binaural cues Windows
// =================================================================================================
Function SpHrView_CuesWindow(String CueStr)//, wave image)
	DFREF saveDFR = GetDataFolderDFR()
	
	SpHrView_Cues_Defaults() // ??
	
	String WinTitleStr, WinNameStr
	variable leftAxisRangeMax=0, leftAxisMax=0
	String wStr
	int displayingEnvelopeCues= 0
	
	strswitch(CueStr)
		// one layered waves
		case "ITD":
			WinTitleStr = "ITDs over time"
			leftAxisRangeMax = 0.001 // sec
			wave Cues = $SpHrView_df_cue+"Carrier_ITDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: ITDs do not exists"; return 0
			endif
			wStr = "Carrier_ITDs"
			break
		case "IPD":
			WinTitleStr = "IPDs over time"
			leftAxisRangeMax = 1	// phase
			wave Cues = $SpHrView_df_cue+"Carrier_IPDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: IPDs do not exists"; return 0
			endif
			wStr = "Carrier_IPDs"
			break
		case "ILD":
			WinTitleStr = "ILDs over time"
			leftAxisRangeMax = 18		// dB
			wave Cues = $SpHrView_df_cue+"Carrier_ILDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: ILDs do not exists"; return 0
			endif
			wStr = "Carrier_ILDs"
			break
			
		case "EnvITD":
			WinTitleStr = "Envelope ITDs over time"
			leftAxisRangeMax = 0.001 // sec
			wave Cues = $SpHrView_df_cue+"Envelope_ITDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Envelope ITDs do not exists"; return 0
			endif
			wStr = "Envelope_ITDs"
			displayingEnvelopeCues = 1
			break
		case "EnvIPD":
			WinTitleStr = "Envelope IPDs over time"
			leftAxisRangeMax = 1	// phase
			wave Cues = $SpHrView_df_cue+"Envelope_IPDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Envelope IPDs do not exists"; return 0
			endif
			wStr = "Envelope_IPDs"
			displayingEnvelopeCues = 1
			break
		case "EnvILD":
			WinTitleStr = "Envelope ILDs over time"
			leftAxisRangeMax = 18		// dB
			wave Cues = $SpHrView_df_cue+"Envelope_ILDs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Envelope ILDs do not exists"; return 0
			endif
			wStr = "Envelope_EnvILDs"
			displayingEnvelopeCues = 1
			break
				
		case "Carrier_AvgEnvWts":
			WinTitleStr = "Average Envelope weights over time"
			leftAxisMax = 1
			wave Cues = $SpHrView_df_cue+"Carrier_AvgEnvWts"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Carrier_AvgEnvWts do not exists"; return 0
			endif
			wStr = "Carrier_AvgEnvWts"
			break
			
		// two layered waves
		case "Envs":
			WinTitleStr = "Envelopes Left and Right"
			leftAxisMax = 0
			wave Cues = $SpHrView_df_cue+"Carrier_Envs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Carrier_Envs do not exists"; return 0
			endif
			wStr = "Carrier_Envs"
			break
		case "Carrier_EnvWts":
			WinTitleStr = "Envelope weights over time"
			leftAxisMax = 1
			wave Cues = $SpHrView_df_cue+"Carrier_EnvWts"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Carrier_EnvWts do not exists"; return 0
			endif
			wStr = "Carrier_EnvWts"
			break
			
		case "Avgs":
			WinTitleStr = "Envelope Averages Left and Right"
			leftAxisMax = 0
			wave Cues = $SpHrView_df_cue+"Avgs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Avgs do not exists"; return 0
			endif
			wStr = "Avgs"
			break
		case "Devs":
			WinTitleStr = "Envelope Deviations Left and Right"
			leftAxisMax = 0
			wave Cues = $SpHrView_df_cue+"Devs"
			if(!waveexists(Cues))
				DoAlert 0, "SpHrView_CuesWindow: Devs do not exists"; return 0
			endif
			wStr = "Devs"
			break
			
	endswitch
	WinNameStr = cleanupName(WinTitleStr,0)
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	if(WindowExists) // remove traces and images
		GetAxis /W=$WinNameStr/Q left
		leftAxisRangeMax = max(abs(V_min),V_max)
		RemoveTraces(WinNameStr)
		RemoveImages(WinNameStr)
	else
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		variable wdth=screenHoriz*ViewWidthProportion
		variable hgt=screenVert*ViewHeightProportion*1.25
		Variable  winleft=(screenHoriz/6), winRight, winTop=400, winBottom=270
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			[winleft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
			winleft = winleft
			winTop = winBottom+30
			Variable marginleft, marginRight, marginTop, marginBottom
			[marginleft, marginRight, marginTop, marginBottom] = getWindowMargins("SpHrViewPeaksWindow")	
		endif
		
		variable winN, winCnt = SpHrView_CountGroupWindows("Cues") // SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:Cues"
		winN = winCnt
		if(winCnt >= 1)
			winN = 1
		endif
		if(winN >= 1)
			winTop += (winN*hgt)
			if(winCnt > 0)
				winTop += 25*winCnt
			endif
		endif
		
		Display /K=1/W=(winleft, winTop, winleft+wdth, winTop+hgt) as WinTitleStr
		DoWindow/C $WinNameStr
		ModifyGraph/W=$WinNameStr margin(left)=marginleft, margin(top)=25, margin(right)=marginRight, margin(bottom)=25
		ControlBar/W=$WinNameStr /T 37
		NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		
		// controls
		Variable topPos = 10.75
		Variable leftPos = 13
		
		Button b_SpHrView_Cues win=$WinNameStr#PTop, pos={leftPos,7}, title="", picture=ProcGlobal#SpHrView_pict_Cues, size={(25/15)*20,20}, proc=SpHrView_Cues_ButtonProc
		Button b_SpHrView_Cues win=$WinNameStr#PTop, help={"View binaural cues. Option-click for pop-up menu. Command-click to update."}
		leftPos += 50
		GroupBox group_CPC win=$WinNameStr#PTop, pos={leftPos-6,6.5},size={135,23}
		SetVariable sv_CuesPerCycle, win=$WinNameStr#PTop, pos={leftPos,topPos},size={112.00,14.00},bodyWidth=32,fSize=10,title="\\f01Cues per cycle"
		SetVariable sv_CuesPerCycle, win=$WinNameStr#PTop, limits={1,3,1},value= $SpHrView_df_cue_globals+"CuesPerCycle",focusRing=0
		SetVariable sv_CuesPerCycle, win=$WinNameStr#PTop, proc=SpHrView_Cues_SetVarProc
		SetVariable sv_CuesPerCycle, win=$WinNameStr#PTop, help={"Number of ITDs and other corresponding cues per cycle. 1: shortest ITD only, 2: include 2nd shortest ITD, 3: include 3rd shortest ITD"}
		
		leftPos += 145
		GroupBox group_Freq win=$WinNameStr#PTop, pos={leftPos-5,6.5},size={275,23}
		SetVariable sv_minFreq, win=$WinNameStr#PTop, pos={leftPos,topPos},size={132,14.00},bodyWidth=50,fSize=10,title="\\f01Frequency\\f00 (Hz)"
		SetVariable sv_minFreq, win=$WinNameStr#PTop, limits={0,20000,1},value= $SpHrView_df_cue_globals+"minFrequency"
		SetVariable sv_minFreq, win=$WinNameStr#PTop, help={""}, proc=SpHrView_Cues_SetVarProc,focusRing=0
		leftPos += 135
		//if(dimsize(Cues,2) < 1)
		SetVariable sv_maxFreq, win=$WinNameStr#PTop, pos={leftPos,topPos},size={69.00,14.00},bodyWidth=55,fSize=10,title="to"
		SetVariable sv_maxFreq, win=$WinNameStr#PTop, limits={0,20000,1},value= $SpHrView_df_cue_globals+"maxFrequency"
		SetVariable sv_maxFreq, win=$WinNameStr#PTop, help={""}, proc=SpHrView_Cues_SetVarProc,focusRing=0
		//endif
		leftPos += 77
		//if(dimsize(Cues,2) < 1)
		CheckBox ck_FreqRange win=$WinNameStr#PTop, title="range",pos={leftPos,topPos-1},side=0, fSize=10
		CheckBox ck_FreqRange win=$WinNameStr#PTop, variable= $SpHrView_df_cue_globals+"FreqRange"
		CheckBox ck_FreqRange win=$WinNameStr#PTop, proc=SpHrView_Cues_CheckProc,focusRing=0
		//endif
		leftPos += 80
		GroupBox group_ColorTable win=$WinNameStr#PTop, pos={leftPos-5,6.5},size={150,23}
		TitleBox t_ColorTable title="🎨",pos={leftPos,topPos-0.5},frame=0,fstyle=1,fSize=13
		leftPos += 25
		SetVariable sv_ColorTable, win=$WinNameStr#PTop, pos={leftPos,topPos},size={65,14.00},bodyWidth=65,title=" "
		SetVariable sv_ColorTable, win=$WinNameStr#PTop, fSize=10,focusRing=0
		SetVariable sv_ColorTable, win=$WinNameStr#PTop, value= $SpHrView_df_cue_globals+"ColorTableStr"
		leftPos += 65
		Button b_ColorTable, win=$WinNameStr#PTop, pos={leftPos,topPos-1},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
		Button b_ColorTable, win=$WinNameStr#PTop, proc=SpHrView_Cues_ButtonProc,focusRing=0
		leftPos += 18
		CheckBox ck_ReverseColorTable win=$WinNameStr#PTop, title="⤵︎",pos={leftPos,topPos-1},side=1, fSize=12
		CheckBox ck_ReverseColorTable win=$WinNameStr#PTop, variable= $SpHrView_df_cue_globals+"ReverseColorTable"
		CheckBox ck_ReverseColorTable win=$WinNameStr#PTop, proc=SpHrView_Cues_CheckProc,focusRing=0
		
		leftPos += 55
		GroupBox group_Wts win=$WinNameStr#PTop, pos={leftPos-10,6.5},size={350,23}
		TitleBox t_weights win=$WinNameStr#PTop, title="\\f01Envelope weight markers:",pos={leftPos,topPos+1.0},frame=0,fstyle=1,fSize=10
		leftPos += 145
		CheckBox ck_dtEnvWts win=$WinNameStr#PTop, title="derivative",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10
		CheckBox ck_dtEnvWts win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"usedtEnvWtMarkers", proc=SpHrView_Cues_CheckProc
		leftPos += 73
		CheckBox ck_ampEnvWts win=$WinNameStr#PTop, title="amplitude",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10
		CheckBox ck_ampEnvWts win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"useAmpEnvWtMarkers", proc=SpHrView_Cues_CheckProc
		leftPos += 78
		CheckBox ck_colorWts win=$WinNameStr#PTop, title="\\Z13🎨  ",pos={leftPos,topPos-1.0},fSize=10,side=1
		CheckBox ck_colorWts win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"colorWeights", proc=SpHrView_Cues_CheckProc
		
		leftPos += 70
		GroupBox group_WtExpAccrua win=$WinNameStr#PTop, pos={leftPos-10,6.5},size={350,23}
		CheckBox ck_appendExpActAccrual win=$WinNameStr#PTop, title="e^ accrued activity",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10,fstyle=0
		CheckBox ck_appendExpActAccrual win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"appendExpActAccrual", proc=SpHrView_Cues_CheckProc
		leftPos += 115
		CheckBox ck_Sigmoids win=$WinNameStr#PTop, title="sigmoids",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10,fstyle=0
		CheckBox ck_Sigmoids win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"getSigmoids", proc=SpHrView_Cues_CheckProc
		leftPos += 70
		Slider sl_actAccrualMax win=$WinNameStr#PTop, pos={leftPos,12},size={140,6},vert=0,side=0,proc=SpHrView_Cues_SliderProc
		Slider sl_actAccrualMax win=$WinNameStr#PTop, limits={0,1,0}, variable=$SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
		Slider sl_actAccrualMax win=$WinNameStr#PTop, help={"e^activity accrual maximum"}
		
		NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
		if(dimsize(Cues,2) > 1)
			FreqRange = 0
		endif
		if(!FreqRange)
			if(dimsize(Cues,2) < 1)
				SetVariable sv_maxFreq win=$WinNameStr#PTop, disable=2
			endif
			NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
			NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
			if(!useAmpEnvWtMarkers && !usedtEnvWtMarkers)
				SetVariable sv_ColorTable win=$WinNameStr#PTop, disable=2
				Button b_ColorTable win=$WinNameStr#PTop, disable=2
				CheckBox ck_ReverseColorTable win=$WinNameStr#PTop, disable=2
			endif
		else
			CheckBox ck_colorWts, win=$WinNameStr#PTop, title="      ", disable=2
		endif
		
		leftPos += 170
		GroupBox group_AppendWaves win=$WinNameStr#PTop, pos={leftPos-10,6.5},size={125,23}
		if(displayingEnvelopeCues)
			CheckBox ck_AppendWaves win=$WinNameStr#PTop, title="Append Envelopes",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10
		else
			CheckBox ck_AppendWaves win=$WinNameStr#PTop, title="Append Carriers",pos={leftPos,topPos-1.0},fSize=10,side=0,fSize=10
		endif
		CheckBox ck_AppendWaves win=$WinNameStr#PTop, variable=$SpHrView_df_cue_globals+"AppendWaves", proc=SpHrView_Cues_CheckProc
		
		SetActiveSubwindow $WinNameStr //##
		ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
		
		ControlBar/W=$WinNameStr /L 20
		if(leftAxisRangeMax > 0)
			// left axis range slider
			Slider sl_leftAxisRange win=$WinNameStr, pos={0,65},size={3,hgt-90},side=0,proc=AxisSliderProc
			Slider sl_leftAxisRange win=$WinNameStr, limits={leftAxisRangeMax/120,leftAxisRangeMax*3,0}, value=leftAxisRangeMax
			Slider sl_leftAxisRange win=$WinNameStr, help={"Adjust axis range"}
		endif
		
		
	endif
	
	if(displayingEnvelopeCues)
		wave Xs = $SpHrView_df_cue+"Envelope_Xs"
	else
		wave Xs = $SpHrView_df_cue+"Carrier_Xs"
	endif
	
	wavestats/Q/M=1 Xs
	Variable XsRange = v_max-v_min
	
	Variable r,g,b,a,err
	SVAR ColorTableStr =  $SpHrView_df_cue_globals+"ColorTableStr"
	NVAR ReverseColorTable = $SpHrView_df_cue_globals+"ReverseColorTable"
	wave CFs = $SpHrView_df_filter+"CFs"
	NVAR minFrequency = $SpHrView_df_cue_globals+"minFrequency"
	NVAR maxFrequency = $SpHrView_df_cue_globals+"maxFrequency"
	minFrequency = max(minFrequency, wavemin(CFs))
	maxFrequency = min(maxFrequency, wavemax(CFs))
	variable maxHz = maxFrequency
	NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
	if(!FreqRange)
		maxHz = minFrequency
	endif
	int64 minIndex = binarySearchInterp(CFs,minFrequency)
	int64 maxIndex = binarySearchInterp(CFs,maxHz)
	minFrequency = CFs[minIndex]
	if(FreqRange)
		maxFrequency = CFs[maxIndex]
	endif
	
	NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
	NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
	wave/Z Carrier_AvgEnvWts=$SpHrView_df_cue+"Carrier_AvgEnvWts"
	wave/Z Carrier_EnvWts=$SpHrView_df_cue+"Carrier_EnvWts"
	wave/Z Envelope_AvgEnvWts=$SpHrView_df_cue+"Envelope_AvgEnvWts"
	//wave/Z Carrier_EnvWts=$SpHrView_df_cue+"Carrier_EnvWts"
	int useMarkerSizes = 0
	if((useAmpEnvWtMarkers || usedtEnvWtMarkers) && (waveexists(Carrier_AvgEnvWts) || waveexists(Envelope_AvgEnvWts)))
		useMarkerSizes = 1
	endif
	NVAR minWeightsMarker = $SpHrView_df_cue_globals+"minWeightsMarker"
	NVAR maxWeightsMarker = $SpHrView_df_cue_globals+"maxWeightsMarker"
	
	if(displayingEnvelopeCues)
		wave/Z EnvWts = $SpHrView_df_cue+"Envelope_EnvWts"
		wave/Z AvgEnvWts = $SpHrView_df_cue+"Envelope_AvgEnvWts"
	else
		wave/Z EnvWts = $SpHrView_df_cue+"Carrier_EnvWts"
		wave/Z AvgEnvWts = $SpHrView_df_cue+"Carrier_AvgEnvWts"
	endif
	
	// Append Traces
	int64 i, cnt=0
	// one layered waves
	if(dimsize(Cues,2) < 1)
	
		//for(i=minIndex;i<=maxIndex;++i)	// low to high frequencies (high on top)
		for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			AppendToGraph/W=$WinNameStr Cues[][i] vs Xs[][i]
			
			if(minIndex == maxIndex)
				ModifyGraph/W=$WinNameStr rgb($wStr)=(0,0,0)
			else
				SpHr_ColorTable/R=(ReverseColorTable)/RGB={i, minIndex, maxIndex+1} ColorTableStr // /Dest=ColorTable
		
				if(cnt==0)
					ModifyGraph/W=$WinNameStr rgb($wStr)=(V_R,V_G,V_B,V_A)
					if(useMarkerSizes && waveexists(AvgEnvWts))
						ModifyGraph/W=$WinNameStr zmrkSize($wStr)={AvgEnvWts[*][i],*,1,minWeightsMarker,maxWeightsMarker}
					endif
				else
					ModifyGraph/W=$WinNameStr rgb($wStr+"#"+num2str(cnt))=(V_R,V_G,V_B,V_A)
					if(useMarkerSizes&& waveexists(AvgEnvWts))
						ModifyGraph/W=$WinNameStr zmrkSize($wStr+"#"+num2str(cnt))={AvgEnvWts[*][i],*,1,minWeightsMarker,maxWeightsMarker}
					endif
				endif
				cnt += 1
			endif
		endfor
		
	// two layered waves
	else
		
		//for(i=minIndex;i<=maxIndex;++i)	// low to high frequencies (high on top)
		for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			AppendToGraph/W=$WinNameStr Cues[][i][0] vs Xs[][i]
			AppendToGraph/W=$WinNameStr Cues[][i][1] vs Xs[][i]
			
			if(FreqRange)
				SpHr_ColorTable/R=(ReverseColorTable)/RGB={i, minIndex, maxIndex}/Dest=ColorTable	ColorTableStr
				if(cnt==0)
					ModifyGraph/W=$WinNameStr rgb($wStr)=(V_R,V_G,V_B,V_A)
					ModifyGraph/W=$WinNameStr rgb($wStr+"#1")=(V_R,V_G,V_B,V_A)
				else
					ModifyGraph/W=$WinNameStr rgb($wStr+"#"+num2str(cnt))=(r,g,b)
					ModifyGraph/W=$WinNameStr rgb($wStr+"#"+num2str(cnt+1))=(r,g,b)
				endif
				cnt += 2
			else
				ModifyGraph/W=$WinNameStr rgb($wStr)=(0,0,65535)
				ModifyGraph/W=$WinNameStr rgb($wStr+"#1")=(65535,0,0)
			endif
		endfor
	
	endif
		
	if(dimsize(Cues,2) < 1)
		ModifyGraph/W=$WinNameStr mode=3,marker=8,msize=2,mrkThick=1.5
		ModifyGraph/W=$WinNameStr zero(left)=1,zeroThick(left)=0.5
	else
		ModifyGraph/W=$WinNameStr mode=3,marker=8,msize=2,mrkThick=1.5
	endif
	
	ModifyGraph/W=$WinNameStr tick=2,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial"
	ModifyGraph/W=$WinNameStr axisOnTop=1
	
	ModifyGraph/W=$WinNameStr lblMargin(bottom)=0
	ModifyGraph/W=$WinNameStr lblMargin(left)=10
	strswitch(CueStr)
		case "ITD":
		case "EnvITD":
			Label/W=$WinNameStr left "interaural time difference, ITD (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			//Printf "%g, %g\r", -leftAxisRangeMax,leftAxisRangeMax
			SetAxis/W=$WinNameStr/A=2/E=2 left -leftAxisRangeMax,leftAxisRangeMax
			break
		case "IPD":
		case "EnvIPD":
			Label/W=$WinNameStr left "interaural phase difference, IPD (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			SetAxis/W=$WinNameStr/A=2/E=2 left -leftAxisRangeMax,leftAxisRangeMax
			break
		case "ILD":
		case "EnvILD":
			Label/W=$WinNameStr left "interaural level difference, ILD (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			SetAxis/W=$WinNameStr/A=2/E=2 left -leftAxisRangeMax,leftAxisRangeMax
			break
			
		case "Carrier_AvgEnvWts":
			Label/W=$WinNameStr left "envelope weights, left/right average (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			SetAxis/W=$WinNameStr/A=2/E=2 left 0,leftAxisMax
			NVAR DisplayLines = $SpHrView_df_cue_globals+"DisplayLines"
			if(DisplayLines)
				if(XsRange > 1) // Seconds
					ModifyGraph/W=$WinNameStr mode=0 // plot with lines
				else
					ModifyGraph/W=$WinNameStr mode=4 // plot with markers and lines
				endif
			endif
			break
			
		case "Carrier_EnvWts":
			Label/W=$WinNameStr left "envelope weights (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			//SetAxis/A=2/E=2 left 0,leftAxisMax
			NVAR DisplayLines = $SpHrView_df_cue_globals+"DisplayLines"
			if(XsRange > 1) // Seconds
					ModifyGraph/W=$WinNameStr mode=0 // plot with lines
				else
					ModifyGraph/W=$WinNameStr mode=4 // plot with markers and lines
				endif
			break
			
		case "Envs":
			Label/W=$WinNameStr left "amplitude (\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			//SetAxis/A=2/E=2 left 0,leftAxisMax
			NVAR DisplayLines = $SpHrView_df_cue_globals+"DisplayLines"
			if(XsRange > 1) // Seconds
					ModifyGraph/W=$WinNameStr mode=0 // plot with lines
				else
					ModifyGraph/W=$WinNameStr mode=4 // plot with markers and lines
				endif
			break
			
		case "Avgs":
			Label/W=$WinNameStr left "amplitude averages(\\U)"
			Label/W=$WinNameStr bottom "time (\\U)"
			//SetAxis/A=2/E=2 left 0,leftAxisMax
			NVAR DisplayLines = $SpHrView_df_cue_globals+"DisplayLines"
			if(XsRange > 1) // Seconds
					ModifyGraph/W=$WinNameStr mode=0 // plot with lines
				else
					ModifyGraph/W=$WinNameStr mode=4 // plot with markers and lines
				endif
			break
		case "Devs":
			Label left "amplitude deviations(\\U)"
			Label bottom "time (\\U)"
			//SetAxis/A=2/E=2 left 0,leftAxisMax
			NVAR DisplayLines = $SpHrView_df_cue_globals+"DisplayLines"
			if(XsRange > 1) // Seconds
					ModifyGraph/W=$WinNameStr mode=0 // plot with lines
				else
					ModifyGraph/W=$WinNameStr mode=4 // plot with markers and lines
				endif
			break
			
	endswitch
	
	wave/Z ColorTable = $SpHrView_df_cue_globals+"ColorTable"
	
	NVAR colorWeights = $SpHrView_df_cue_globals+"colorWeights"
	if(!FreqRange && (useAmpEnvWtMarkers || usedtEnvWtMarkers) && colorWeights)
	
		if(dimsize(Cues,2) <= 1 && waveexists(AvgEnvWts))
			ModifyGraph/W=$WinNameStr zColor($wStr)={AvgEnvWts[*][minIndex],*,*,ctableRGB,ReverseColorTable,ColorTable}
		endif
		if(dimsize(Cues,2) > 1)
			// not sure when this might occue but pretty sure the line below with throw errors (see above line)
			if(waveexists(EnvWts))
				ModifyGraph/W=$WinNameStr zColor($wStr)={EnvWts[*][minIndex][0],*,*,ColorTable,0}
				ModifyGraph/W=$WinNameStr zColor($wStr+"#1")={EnvWts[*][minIndex][1],*,*,ColorTable,0}
			elseif(waveexists(AvgEnvWts))
				ModifyGraph/W=$WinNameStr zColor($wStr)={AvgEnvWts[*][minIndex],*,*,ColorTable,0}
				ModifyGraph/W=$WinNameStr zColor($wStr+"#1")={AvgEnvWts[*][minIndex],*,*,ColorTable,0}
			endif
		endif
		
		ColorScale/W=$WinNameStr/C/N=WeightColorsTxt/F=0/B=1/A=RT/E=2/X=3.00/Y=0.00 vert=0,width=100,height=4,frame=0.00,log=0
		ColorScale/W=$WinNameStr/C/N=WeightColorsTxt side=1, ctab={0,1,ColorTable,0},font="Arial",fsize=9,nticks=5
		ColorScale/W=$WinNameStr/C/N=WeightColorsTxt tickLen=2.00,tickThick=0.5,ZisZ=1,lblMargin=18, lblLatPos=-100, tickLblRot=35
		ColorScale/W=$WinNameStr/C/N=WeightColorsTxt "\\F'Arial'\\Z10envelope weight"
	else
		ColorScale/W=$WinNameStr/K/N=WeightColorsTxt
	endif
	
	if(FreqRange)
		CheckBox ck_colorWts, win=$WinNameStr#PTop, title="      ", disable=2
		CheckBox ck_AppendWaves win=$WinNameStr#PTop, disable=2
		CheckBox ck_Sigmoids win=$WinNameStr#PTop, disable=2
	else
		CheckBox ck_colorWts, win=$WinNameStr#PTop, title="\\Z13🎨  ", disable=0
		CheckBox ck_AppendWaves win=$WinNameStr#PTop, disable=0
		CheckBox ck_Sigmoids win=$WinNameStr#PTop, disable=0
	endif
	
	// Append e^accrual to Right axis
	NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
	NVAR ActAccrualSigmoidsSliderVal = $SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
	wave/Z ExpAccrual= $SpHrView_df_cue+"ExpAccrual"
	if(appendExpActAccrual && waveexists(ExpAccrual))
		wave/Z ExpAccrual= $SpHrView_df_cue+"ExpAccrual"
		string append_wStr = "ExpAccrual"
		//wavestats/Q/M=1 ExpAccrual
		//ExpAccrual /= v_max
		variable maxVal, minVal
		wavestats/Q/M=1/RMD=[][minIndex,minIndex][] ExpAccrual
		maxVal = v_max
		minVal = V_min
		if(ActAccrualSigmoidsSliderVal <= 0 || ActAccrualSigmoidsSliderVal > log(maxVal))
			ActAccrualSigmoidsSliderVal = log(maxVal)/2
		endif
		variable append_cnt = 0
		for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			if(FreqRange)
				// normalize columns...
				wavestats/Q/M=1/RMD=[][i,i][] ExpAccrual
				maxVal = v_max
				ExpAccrual[][i][0] /= maxVal
				ExpAccrual[][i][1] /= maxVal
			endif
			AppendToGraph/W=$WinNameStr/R ExpAccrual[][i][0] vs Xs[][i]
			AppendToGraph/W=$WinNameStr/R ExpAccrual[][i][1] vs Xs[][i]
			if(FreqRange)
				SpHr_ColorTable/R=(ReverseColorTable)/RGB={i, minIndex, maxIndex}	ColorTableStr
				if(append_cnt==0)
					ModifyGraph/W=$WinNameStr rgb($append_wStr)=(V_R,V_G,V_B,V_A)
					ModifyGraph/W=$WinNameStr rgb($append_wStr+"#1")=(V_R,V_G,V_B,V_A)
				else
					ModifyGraph/W=$WinNameStr rgb($append_wStr+"#"+num2str(append_cnt))=(r,g,b)
					ModifyGraph/W=$WinNameStr rgb($append_wStr+"#"+num2str(append_cnt+1))=(r,g,b)
				endif
				append_cnt += 2
			else
				ModifyGraph/W=$WinNameStr rgb($append_wStr)=(0,0,65535)
				ModifyGraph/W=$WinNameStr rgb($append_wStr+"#1")=(65535,0,0)
			endif
		endfor
		ModifyGraph/W=$WinNameStr lsize($append_wStr)=0.75,lsize($append_wStr+"#1")=0.75
		ModifyGraph/W=$WinNameStr tick=2,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,btLen(right)=3,btThick=0.5,stLen(right)=1.5,stThick=0.5
		if(FreqRange)
			Label/W=$WinNameStr right "e^ activity accruals re: last maximum"
			SetAxis/W=$WinNameStr/A=2 right
		else
			Label/W=$WinNameStr right "e^ activity accrual"
			SetAxis/W=$WinNameStr/A=2 right, minVal, 10^ActAccrualSigmoidsSliderVal
		endif
		ModifyGraph/W=$WinNameStr tkLblRot(right)=-90,lblMargin(right)=5
		
		if(FreqRange)
			Slider sl_actAccrualMax win=$WinNameStr#PTop, disable=2
			CheckBox ck_Sigmoids win=$WinNameStr#PTop, disable=2
		else		
			Slider sl_actAccrualMax win=$WinNameStr#PTop, limits={minVal*0.25,log(maxVal),0}, disable=0
			CheckBox ck_Sigmoids win=$WinNameStr#PTop, disable=0
		endif
	else
		Slider sl_actAccrualMax win=$WinNameStr#PTop, disable=2
	endif
	
	
	NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
	if(getSigmoids) // getSigmoids
		SpHrView_Cues_ComputeSigmas(WinNameStr)
		SpHrView_Cues_SigmasWindow(1)
	else
		SpHrView_Cues_SigmasWindow(0)
	endif
	
	
	NVAR AppendWaves = $SpHrView_df_cue_globals+"AppendWaves"
	if(AppendWaves && !FreqRange && !appendExpActAccrual)
		if(displayingEnvelopeCues)
			wave/Z Carrier_Envs = $SpHrView_df_cue+"Carrier_Envs"
			wave/Z Carrier_Xs = $SpHrView_df_cue+"Carrier_Xs"
			if(waveexists(Carrier_Envs))
				appendtograph/W=$WinNameStr/R Carrier_Envs[][minIndex][0] vs Carrier_Xs[][minIndex][0]
				appendtograph/W=$WinNameStr/R Carrier_Envs[][minIndex][1] vs Carrier_Xs[][minIndex][1]
				SetAxis/W=$WinNameStr/A=2/E=1 right
				ModifyGraph/W=$WinNameStr rgb(Carrier_Envs)=(0,0,65535,32768),rgb(Carrier_Envs#1)=(65535,0,0,32768)
				ModifyGraph/W=$WinNameStr lsize(Carrier_Envs)=0.5,lsize(Carrier_Envs#1)=0.5
				ModifyGraph/W=$WinNameStr fSize=10,axThick=0.5,lblMargin(right)=5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen(right)=3,btThick=0.5,stLen(right)=1.5,stThick=0.5,font="Arial"
				Label/W=$WinNameStr right "filterbank envelope (\\U)"
			else
				killwaves/Z Carrier_Envs // ?
			
				wave/Z  Envelope_Envs = $SpHrView_df_cue+"Envelope_Envs"
				wave/Z  Envelope_EnvXs = $SpHrView_df_cue+"Envelope_EnvXs"
				if(waveexists(Envelope_Envs))
					appendtograph/W=$WinNameStr/R Envelope_Envs[][minIndex][0] vs Envelope_EnvXs[][minIndex][0]
					appendtograph/W=$WinNameStr/R Envelope_Envs[][minIndex][1] vs Envelope_EnvXs[][minIndex][1]
					SetAxis/W=$WinNameStr/A=2/E=1 right
					ModifyGraph/W=$WinNameStr rgb(Envelope_Envs)=(0,0,65535,32768),rgb(Envelope_Envs#1)=(65535,0,0,32768)
					ModifyGraph/W=$WinNameStr lsize(Envelope_Envs)=0.5,lsize(Envelope_Envs#1)=0.5
					ModifyGraph/W=$WinNameStr fSize=10,axThick=0.5,lblMargin(right)=5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen(right)=3,btThick=0.5,stLen(right)=1.5,stThick=0.5,font="Arial"
					Label/W=$WinNameStr right "filterbank envelope (\\U)"
				endif
			endif
			
		else
			wave/Z FilterBanks = $SpHrView_df_filter+"FilterBanks"
			if(waveexists(FilterBanks))
				appendtograph/W=$WinNameStr/R FilterBanks[][minIndex][0]
				appendtograph/W=$WinNameStr/R FilterBanks[][minIndex][1]
				SetAxis/W=$WinNameStr/A=2/E=2 right
				ModifyGraph/W=$WinNameStr rgb(FilterBanks)=(0,0,65535,32768),rgb(FilterBanks#1)=(65535,0,0,32768)
				ModifyGraph/W=$WinNameStr lsize(FilterBanks)=0.5,lsize(FilterBanks#1)=0.5
				ModifyGraph/W=$WinNameStr fSize=10,axThick=0.5,lblMargin(right)=5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen(right)=3,btThick=0.5,stLen(right)=1.5,stThick=0.5,font="Arial"
				Label/W=$WinNameStr right "filterbank carrier (\\U)"
			else
				killwaves/Z FilterBanks
			endif
		endif
	endif
	
	
	// Vertical LEFT axis  Color scale bar or Legend
	if(cnt > 6) // Color scale bar
		ColorScaleLookUp(SpHrView_df_cue_globals, "CuesColorScaleLookUp", minFrequency, maxFrequency, CFs)
		wave CuesColorScaleLookUp = $SpHrView_df_cue_globals+"CuesColorScaleLookUp"
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt/F=0/B=1/A=LT/E=2/X=0.50/Y=0.00 vert=0,width=200,height=4,frame=0.00,log=0
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt side=1, ctab={minFrequency,maxFrequency,ColorTable,0},font="Arial",fsize=9,nticks=5, lookup=$SpHrView_df_cue_globals+"CuesColorScaleLookUp"
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt tickLen=2.00,tickThick=0.5,ZisZ=1,lblMargin=18, lblLatPos=-150, tickLblRot=35
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt "\\F'Arial'\\Z10frequency (Hz)"
	else	// Legend
		String LegendStr = "frequency (Hz)  "
		cnt = 0 
		for(i=minIndex;i<=maxIndex;++i)	// low to high frequencies (high on top)
		//for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			if(cnt==0)
				LegendStr += "\\s("+wStr+")"+num2str(CFs[i]) // ModifyGraph mode=3,marker=19,msize=2,rgb($wStr)=(r,g,b)
			else
				LegendStr += "\\s("+wStr+"#"+num2str(cnt)+")"+num2str(CFs[i])
			endif
			cnt += 1			
		endfor
		Legend/W=$WinNameStr/C/N=TraceColorsTxt/J/F=0/B=1/E=0/A=LT/X=1.00/Y=-10.00 LegendStr
	endif
	
	DoUpdate/W=$WinNameStr // for Igor 9
	SetWindow $WinNameStr, hook(CuesHook)=SpHrView_Cues_WindowHook
	SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:Cues"

	SetDataFolder saveDFR
End



Function SpHrView_Cues_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	switch( ba.eventCode )
		case 1: // mouse down
			// click code here
			strswitch(ba.ctrlName)
				case "b_CuesPopUp":
				case "b_SpHrView_Cues":
					string selStr= ""
					variable key= getkeystate(0)  // Print key
					if(key==2 || key==10)	// option key
						PopupContextualMenu "ITD;IPD;ILD;-;Envelope ITD;Envelope IPD;Envelope ILD;-;Weights;Average Weights;Envelopes;-;Options;"
						selStr = S_selection
					elseif(key==1 ||key==9)		// command key
						SpHrView_Cues()
					else
						selStr = "Options"
					endif
					if(strlen(selStr)>1) // not command key
						SpHrView_Cues_Defaults()
						NVAR getITDs=$SpHrView_df_cue_globals+"getITDs"
						NVAR getIPDs=$SpHrView_df_cue_globals+"getIPDs"
						NVAR getILDs=$SpHrView_df_cue_globals+"getILDs"
						NVAR getEnvITDs=$SpHrView_df_cue_globals+"getEnvITDs"
						NVAR getEnvIPDs=$SpHrView_df_cue_globals+"getEnvIPDs"
						NVAR getEnvILDs=$SpHrView_df_cue_globals+"getEnvILDs"
						NVAR getEnvWts=$SpHrView_df_cue_globals+"getEnvWts"
						NVAR getAvgEnvWts=$SpHrView_df_cue_globals+"getAvgEnvWts"
						NVAR getEnvs=$SpHrView_df_cue_globals+"getEnvs"
						strswitch(selStr)
							case "Options":
								Variable leftCoord, topCoord
								string winStr = ba.win
								if(strsearch(winStr, "#PTop", 0))
									winStr = RemoveEnding(winStr, "#PTop")
								endif
								GetWindow $winStr, wsize// gsize
								leftCoord = V_left + ba.mouseLoc.h
								topCoord = V_Top + ba.mouseLoc.v
								SpHrView_CuesOptionsWindow(leftCoord, topCoord)
								break
								
							case "ITD":
								getITDs= 1; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
							case "IPD":
								getITDs= 0; getIPDs= 1; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
							case "ILD":
								getITDs= 0; getIPDs= 0; getILDs= 1;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
								
							case "Envelope ITD":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 1; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
							case "Envelope IPD":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 1; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
							case "Envelope ILD":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 1;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
								
							case "Weights":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 1; getEnvs= 0;
								SpHrView_Cues()
								break
							case "Average Weights":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=1; getEnvWts= 0; getEnvs= 0;
								SpHrView_Cues()
								break
							case "Envelopes":
								getITDs= 0; getIPDs= 0; getILDs= 0;
								getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
								getAvgEnvWts=0; getEnvWts= 0; getEnvs= 1;
								SpHrView_Cues()
								break
									
						endswitch
					endif
					break
					
				case "b_Display":
					SpHrView_Cues()
					killwindow/Z CuesDisplayOptions
					break
					
				case "b_ColorTable":
					SVAR ColorTableStr = $SpHrView_df_cue_globals+"ColorTableStr"
					String tempStr = ColorTablePopup(ColorTableStr)
					if(strlen(tempStr)>1)
						ColorTableStr = tempStr
						SpHrView_Cues()
					endif
//					PopupContextualMenu/N "SpHrView_ColorTablesPopup" //"*COLORTABLEPOP*"
//					if(V_flag>0) // && V_kind==13)
//						SVAR ColorTableStr = $SpHrView_df_cue_globals+"ColorTableStr"
//						ColorTableStr = S_selection
//						SpHrView_Cues()
//					endif
					break

			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End

Function SpHrView_Cues_PopUpMenu()
	PopupContextualMenu "ITD;IPD;ILD;-;Envelope ITD;Envelope IPD;Envelope ILD;-;Options;"
	if(strlen(S_selection)>1) // not command key
		NVAR getITDs=$SpHrView_df_cue_globals+"getITDs"
		NVAR getIPDs=$SpHrView_df_cue_globals+"getIPDs"
		NVAR getILDs=$SpHrView_df_cue_globals+"getILDs"
		NVAR getEnvITDs=$SpHrView_df_cue_globals+"getEnvITDs"
		NVAR getEnvIPDs=$SpHrView_df_cue_globals+"getEnvIPDs"
		NVAR getEnvILDs=$SpHrView_df_cue_globals+"getEnvILDs"
		strswitch(S_selection)
			case "Options":
				GetMouse
				Variable leftCoord=V_left, topCoord=V_top
				SpHrView_CuesOptionsWindow(leftCoord, topCoord)
				break
				
			case "ITD":
				getITDs= 1; getIPDs= 0; getILDs= 0;
				getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
				SpHrView_Cues()
				break
			case "IPD":
				getITDs= 0; getIPDs= 1; getILDs= 0;
				getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
				SpHrView_Cues()
				break
			case "ILD":
				getITDs= 0; getIPDs= 0; getILDs= 1;
				getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 0;
				SpHrView_Cues()
				break
				
//			case "ITD":
//				getITDs= 0; getIPDs= 0; getILDs= 0;
//				getEnvITDs= 1; getEnvIPDs= 0; getEnvILDs= 0;
//				SpHrView_Cues()
//				break
//			case "IPD":
//				getITDs= 0; getIPDs= 0; getILDs= 0;
//				getEnvITDs= 0; getEnvIPDs= 1; getEnvILDs= 0;
//				SpHrView_Cues()
//				break
//			case "ILD":
//				getITDs= 0; getIPDs= 0; getILDs= 0;
//				getEnvITDs= 0; getEnvIPDs= 0; getEnvILDs= 1;
//				SpHrView_Cues()
//				break
		endswitch
	endif
end

Function SpHrView_Cues_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			Variable index, Hz, temp
			wave CFs = $SpHrView_df_filter+"CFs"
			strswitch(sva.ctrlName)
				case "sv_CuesPerCycle":
					SpHrView_Cues()
					break
					
				case "sv_minFreq":
					//Print sva.win
					Hz = CFs[SetVarProcIndex(CFs, dval, 0)]
					[index, Hz] = SpHrView_getCFindex(CFs, Hz)
					NVAR minFrequency = $SpHrView_df_cue_globals+"minFrequency"
					NVAR maxFrequency = $SpHrView_df_cue_globals+"maxFrequency"
					minFrequency = Hz
					NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
					if(FreqRange && minFrequency > maxFrequency)
						temp = minFrequency // swap
						minFrequency = maxFrequency
						maxFrequency = temp
					else
						minFrequency = Hz
					endif
					SpHrView_Cues()
					break
					
				case "sv_maxFreq":
					Hz = CFs[SetVarProcIndex(CFs, dval, 0)]
					[index, Hz] = SpHrView_getCFindex(CFs, Hz)
					NVAR maxFrequency = $SpHrView_df_cue_globals+"maxFrequency"
					NVAR minFrequency = $SpHrView_df_cue_globals+"minFrequency"
					maxFrequency = Hz
					NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
					if(FreqRange && minFrequency > maxFrequency)
						temp = minFrequency // swap
						minFrequency = maxFrequency
						maxFrequency = temp
					else
						maxFrequency = Hz
					endif
					SpHrView_Cues()
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SpHrView_Cues_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			String winStr = cba.win
			strswitch(cba.ctrlName)
				
				case "ck_FreqRange":
					NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
					NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
					if(FreqRange)// && getSigmoids)
						getSigmoids = 0
						CheckBox ck_Sigmoids win=$winStr, disable=2
					else
						CheckBox ck_Sigmoids win=$winStr, disable=0
					endif
				case "ck_ReverseColorTable":
				case "ck_colorWts":
					NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
					int FreqRangeDisable
					if(!FreqRange)
						FreqRangeDisable=2
						//CheckBox ck_colorWts, win=$winStr, disable=0
					else
						FreqRangeDisable=0
						//CheckBox ck_colorWts, win=$winStr, disable=2
					endif
					SetVariable sv_maxFreq, win=$winStr, disable=FreqRangeDisable
					NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
					NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
					if(!useAmpEnvWtMarkers && !usedtEnvWtMarkers)
						SetVariable sv_ColorTable, win=$winStr, disable=FreqRangeDisable
						Button b_ColorTable, win=$winStr, disable=FreqRangeDisable
						CheckBox ck_ReverseColorTable, win=$winStr, disable=FreqRangeDisable
					endif
					SpHrView_Cues()
					break
				
				case "ck_dtEnvWts":
					NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
					NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
					NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
					if(appendExpActAccrual && useAmpEnvWtMarkers)
						useAmpEnvWtMarkers = 0 // toggle
					endif
					SpHrView_Cues()
					break
					
				case "ck_ampEnvWts":
					NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
					NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
					NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
					if(appendExpActAccrual && usedtEnvWtMarkers)
						usedtEnvWtMarkers = 0 // toggle
					endif
					SpHrView_Cues()
					break
					
				case "ck_dtEnvelopeApplyToEnvelopes":
					if(checked)
						DoAlert/T="Warning" 0, "Envelope derivative weights should generally NOT be applied to envelope cues"
					endif
					break
					
				case "ck_appendExpActAccrual":
				case "ck_appendExpActAccrual_noCues":
					NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
					NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
					NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
					NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
					if((getSigmoids || appendExpActAccrual) && useAmpEnvWtMarkers && usedtEnvWtMarkers)
						DoAlert/T="Warning" 0, "Cannot display accruals for both envelope derivative and amplitude envelope weights. Choose one or the other."
						appendExpActAccrual = 0
						getSigmoids = 0
					endif
					if((getSigmoids || appendExpActAccrual) && !useAmpEnvWtMarkers && !usedtEnvWtMarkers)
						DoAlert/T="Warning" 0, "Cannot display accruals if neither envelope derivative weights or amplitude envelope weights are being used."
						appendExpActAccrual = 0
						getSigmoids = 0
					endif
					if(stringmatch(cba.ctrlName, "ck_appendExpActAccrual_noCues"))
						break
					endif
					SpHrView_Cues()
					if(!appendExpActAccrual)
						NVAR getSigmoids = $SpHrView_df_cue_globals+"getSigmoids"
						getSigmoids = 0
						SpHrView_Cues_SigmasWindow(0)
					endif
					break
					
				case "ck_Sigmoids":
				case "ck_Sigmoids_noCues":
					NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
					if(checked) // getSigmoids==1
						NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
						if(FreqRange)
							DoAlert/T="Warning" 0, "Sigmoids are not obtained when cues for a range of freqeuncies are displayed."
							getSigmoids = 0
							return 0
						endif
						NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
						NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
						NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
						if((getSigmoids || appendExpActAccrual) && useAmpEnvWtMarkers && usedtEnvWtMarkers)
							DoAlert/T="Warning" 0, "Cannot display accruals for both envelope derivative and amplitude envelope weights. Choose one or the other."
							appendExpActAccrual = 0
							getSigmoids = 0
						endif
						if((getSigmoids || appendExpActAccrual) && !useAmpEnvWtMarkers && !usedtEnvWtMarkers)
							DoAlert/T="Warning" 0, "Cannot display accruals if neither envelope derivative weights or amplitude envelope weights are being used."
							appendExpActAccrual = 0
							getSigmoids = 0
						endif
						if(stringmatch(cba.ctrlName, "ck_Sigmoids_noCues"))
							break
						endif
						if(!appendExpActAccrual)
							appendExpActAccrual = 1
							SpHrView_Cues()
						endif
						SpHrView_Cues_SigmasWindow(1)
					else
						SpHrView_Cues_SigmasWindow(0)
					endif
					break
					
				case "ck_AppendWaves":
					NVAR AppendWaves = $SpHrView_df_cue_globals+"AppendWaves"
					if(AppendWaves)
						if(FreqRange)
							DoAlert/T="Warning" 0, "Waves are not displayed when cues for a range of freqeuncies are displayed."
							AppendWaves = 0
							break
						endif
					endif
					SpHrView_Cues()
					break
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

// =================================================================================================
// SpHrView_Cues_WindowHook(s), Window hook for Cues windows
// =================================================================================================
Function SpHrView_Cues_WindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0	
	switch(s.eventCode)
		//////////////
		// deactivate
		case 1:
			strswitch(s.winName)
				case "CuesDisplayOptions":
					ControlInfo/W=CuesDisplayOptions ck_keepWindowOpen
					if(!V_Value)
						killwindow/Z CuesDisplayOptions // close window when deactivted
						hookResult=1
					endif
					break
			endswitch
			break
			
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			strswitch(s.winName)
				case "CuesDisplayOptions":
					switch(s.keycode)
						case 13:		// return
							killwindow/Z CuesDisplayOptions
							SpHrView_Cues()
							hookResult=1
							break
					endswitch
					break
				case "ITDs_over_time":
				case "IPDs_over_time":
				case "ILDs_over_time":
				case "Envelope_ITDs_over_time":
				case "Envelope_IPDs_over_time":
				case "Envelope_ILDs_over_time":
				case "Average_Envelope_weights_over_time":
				case "Envelopes_Left_and_Right":
				case "Envelope_weights_over_time":
				case "Envelope_Averages_Left_and_Right":
				case "Envelope_Deviations_Left_and_Right":
					//Print s.keycode
					switch(s.keycode)
						case 29:		// right arrow
							NVAR ActAccrualSigmoidsSliderVal = $SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
							ActAccrualSigmoidsSliderVal += ActAccrualSigmoidsSliderVal*0.005
							SetAxis/W=$s.winName right 0, 10^ActAccrualSigmoidsSliderVal
							NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
							if(getSigmoids) // getSigmoids
								SpHrView_Cues_ComputeSigmas(s.winName)
							else
								SetDrawLayer/W=$s.winName/K UserFront
							endif
							hookResult=1
							break
							
						case 28:		// let arrow
							NVAR ActAccrualSigmoidsSliderVal = $SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
							ActAccrualSigmoidsSliderVal -= ActAccrualSigmoidsSliderVal*0.005
							SetAxis/W=$s.winName right 0, 10^ActAccrualSigmoidsSliderVal
							NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
							if(getSigmoids) // getSigmoids
								SpHrView_Cues_ComputeSigmas(s.winName)
							else
								SetDrawLayer/W=$s.winName/K UserFront
							endif
							hookResult=1
							break
							break
					endswitch
					break
				endswitch
			break
			
		//////////////
		// kill event
		case 2:
			//Printf "-%s-", s.winName
			strswitch(s.winName)					
				case "ITDs_over_time":
				case "IPDs_over_time":
				case "ILDs_over_time":
				case "Envelope_ITDs_over_time":
				case "Envelope_IPDs_over_time":
				case "Envelope_ILDs_over_time":
				case "Average_Envelope_weights_over_time":
				case "Envelopes_Left_and_Right":
				case "Envelope_weights_over_time":
				case "Envelope_Averages_Left_and_Right":
				case "Envelope_Deviations_Left_and_Right":
					KillWindow/Z $s.winName
					variable winCnt = SpHrView_CountGroupWindows("Cues")
					if(winCnt<=0)
						Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_df_cue[0,strlen(SpHrView_df_cue)-2]+"\")" // remove trailing ":"
						Execute/Z/Q/P "SpHrView_Cues_SigmasWindow(0)"
					endif
					hookResult = 1
					break
			endswitch
			break
			
	endswitch
	return hookResult
End

Function SpHrView_Cues_SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa
	switch( sa.eventCode )
		case -3: // Control received keyboard focus
		case -2: // Control lost keyboard focus
		case -1: // Control being killed
			break
		case 2:
		case 3:
		case 8:
		case 9:
			Variable curval = sa.curval
			strswitch(sa.ctrlName)	
				case "sl_actAccrualMax":
					string winStr = RemoveEnding(sa.win, "#PTop")
					SetAxis/W=$winStr right 0, 10^curval
					
					NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
					if(getSigmoids) // getSigmoids
						NVAR ActAccrualSigmoidsSliderVal = $SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
						ActAccrualSigmoidsSliderVal = curval
						SpHrView_Cues_ComputeSigmas(winStr)
					else
						SetDrawLayer/W=$winStr/K UserFront
					endif
					break
			endswitch
		default:
			break
	endswitch

	return 0
End

Function SpHrView_Cues_ComputeSigmas(string winStr)

	NVAR getSigmoids=$SpHrView_df_cue_globals+"getSigmoids"
	if(!getSigmoids)
		if(strlen(winStr)>1)
			Dowindow $winStr
			if(v_flag)
				SetDrawLayer/W=$winStr/K UserFront
				return 0
			endif
		endif
	endif

	NVAR SliderVal = $SpHrView_df_cue_globals+"ActAccrualSigmoidsSliderVal"
	NVAR appendExpActAccrual = $SpHrView_df_cue_globals+"appendExpActAccrual"
	NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
	wave CFs = $SpHrView_df_filter+"CFs"
	wave/Z Avgs = $SpHrView_df_cue+"Avgs"
	wave/Z Devs = $SpHrView_df_cue+"Devs"
	wave/Z ExpAccrual= $SpHrView_df_cue+"ExpAccrual"
	wave Xs = $SpHrView_df_cue+"Carrier_Xs"
	
	if(!waveexists(ExpAccrual) || !waveexists(Avgs) || !waveexists(Devs))
		SpHrView_Cues()
	endif
	
	if(!FreqRange && appendExpActAccrual && waveexists(ExpAccrual) && waveexists(Avgs) && waveexists(Devs))
	
		NVAR minFrequency = $SpHrView_df_cue_globals+"minFrequency"
		minFrequency = max(minFrequency, wavemin(CFs))
		minFrequency = min(minFrequency, wavemax(CFs))
		NVAR FreqRange = $SpHrView_df_cue_globals+"FreqRange"
		int64 minIndex = binarySearchInterp(CFs,minFrequency)
		Make/D/Free/O/N=(dimsize(ExpAccrual,0)) temp
		temp = ExpAccrual[p][minIndex][0]
		variable Xpnt = (BinarySearch(temp, 10^SliderVal))
		temp = ExpAccrual[p][minIndex][1]
		variable Xpnt2 = (BinarySearch(temp, 10^SliderVal))
		Xpnt = min(Xpnt, Xpnt2)
		if(Xpnt < 0 || numtype(Xpnt)!=0)
			if(10^SliderVal > wavemax(temp))
				wave Carrier_Ns= $SpHrView_df_cue+"Carrier_Ns"
				Xpnt = Carrier_Ns[minIndex]-1
			else
				Xpnt = 0
			endif
		endif
		Make/O/N=50 $SpHrView_df_cue+"Sigmoid_L", $SpHrView_df_cue+"Sigmoid_R"
		wave Sigmoid_L= $SpHrView_df_cue+"Sigmoid_L", Sigmoid_R= $SpHrView_df_cue+"Sigmoid_R"
		variable avg_L = Avgs[Xpnt][minIndex][0], dev_L = Devs[Xpnt][minIndex][0]
		variable avg_R = Avgs[Xpnt][minIndex][1], dev_R = Devs[Xpnt][minIndex][1]
		NVAR useAmpEnvWtMarkers = $SpHrView_df_cue_globals+"useAmpEnvWtMarkers"
		NVAR usedtEnvWtMarkers = $SpHrView_df_cue_globals+"usedtEnvWtMarkers"
		NVAR EnvdB = $SpHrView_df_cue_globals+"EnvelopeWeightsdB"
		NVAR dtEnvdB = $SpHrView_df_cue_globals+"dtEnvelopeWeightsdB"
		
		wave Carrier_EnvWts = $SpHrView_df_cue+"Carrier_EnvWts"
		string unitsStr
		if(usedtEnvWtMarkers)
			wave Envs= $SpHrView_df_cue+"Carrier_dtEnvs"
			if(dtEnvdB)
				unitsStr = "dtdB"
			else
				unitsStr = "dtPa"
			endif
		elseif(useAmpEnvWtMarkers)
			wave Envs= $SpHrView_df_cue+"Carrier_Envs"
			if(EnvdB)
				unitsStr = "dB"
			else
				unitsStr = "Pa"
			endif
		endif
		variable dev = max(dev_L,dev_R)*3
		variable env = max(abs(Envs[Xpnt][minIndex][0]), abs(Envs[Xpnt][minIndex][1]))
		SetScale/I x, -env-dev, env+dev, unitsStr, Sigmoid_L
		SetScale/I x, -env-dev, env+dev, unitsStr, Sigmoid_R
		SetScale d 0,0,"Wt", Sigmoid_L, Sigmoid_R
		Sigmoid_L = 1 / (1 + exp(-(x - avg_L) / dev_L))
		Sigmoid_R = 1 / (1 + exp(-(x - avg_R) / dev_R))
		
		Make/O/N=(2,2) $SpHrView_df_cue+"Sigmoid_Vals"
		wave Sigmoid_Vals= $SpHrView_df_cue+"Sigmoid_Vals"
		Sigmoid_Vals[0][0] = Carrier_EnvWts[Xpnt][minIndex][0]
		Sigmoid_Vals[1][0] = Envs[Xpnt][minIndex][0]
		Sigmoid_Vals[0][1] = Carrier_EnvWts[Xpnt][minIndex][1]
		Sigmoid_Vals[1][1] = Envs[Xpnt][minIndex][1]
		
		// draw vertical line at Xpnt
		if(strlen(winStr)>1)
			Dowindow $winStr
			if(v_flag)
				SetDrawLayer/W=$winStr/K UserFront
				SetDrawLayer/W=$winStr UserFront
				SetDrawEnv/W=$winStr xcoord= bottom,linethick= 0.75,dash= 0
				DrawLine/W=$winStr Xs[Xpnt][minIndex],-0.05,Xs[Xpnt][minIndex],1
				//Printf "%g, %g\r", Xpnt,  Xs[Xpnt][minIndex]
			endif
		endif
	endif
end

Function SpHrView_Cues_SigmasWindow(variable DisplayWindow)
	if(!DisplayWindow)
		killWindow/Z Envelope_Weight_Sigmoids
		return 0
	endif
	doWindow Envelope_Weight_Sigmoids
	if(v_flag)
		doWindow/F Envelope_Weight_Sigmoids
		return 0
	endif
	Wave/Z Sigmoid_L = $SpHrView_df_cue+"Sigmoid_L"
	Wave/Z Sigmoid_R = $SpHrView_df_cue+"Sigmoid_R"
	Wave/Z Sigmoid_Vals = $SpHrView_df_cue+"Sigmoid_Vals"
	if(!waveexists(Sigmoid_L) || !waveexists(Sigmoid_R) || !waveexists(Sigmoid_Vals) )
		SpHrView_Cues_ComputeSigmas("")
	endif
	Wave/Z Sigmoid_L = $SpHrView_df_cue+"Sigmoid_L"
	Wave/Z Sigmoid_R = $SpHrView_df_cue+"Sigmoid_R"
	Wave/Z Sigmoid_Vals = $SpHrView_df_cue+"Sigmoid_Vals"
	if(!waveexists(Sigmoid_L) || !waveexists(Sigmoid_R) || !waveexists(Sigmoid_Vals) )
		DoAlert 0, "Wave Sigmoid_L or Sigmoid_R or Sigmoid_Vals is missing"
		return 0
	endif
	killWindow/Z Envelope_Weight_Sigmoids
	Display/K=1/W=(616,45,954,257) Sigmoid_L,Sigmoid_R as "Envelope Weight Sigmoids"
	DoWindow/C Envelope_Weight_Sigmoids
	AppendToGraph/W=Envelope_Weight_Sigmoids Sigmoid_Vals[0,0][0] vs Sigmoid_Vals[1,1][0]
	AppendToGraph/W=Envelope_Weight_Sigmoids Sigmoid_Vals[0,0][1] vs Sigmoid_Vals[1,1][1]
	ModifyGraph/W=Envelope_Weight_Sigmoids margin(left)=30,margin(bottom)=30,margin(top)=14,margin(right)=14,width=288
	ModifyGraph/W=Envelope_Weight_Sigmoids height=162
	ModifyGraph/W=Envelope_Weight_Sigmoids mode(Sigmoid_Vals)=3,mode(Sigmoid_Vals#1)=3
	ModifyGraph/W=Envelope_Weight_Sigmoids marker(Sigmoid_Vals)=41,marker(Sigmoid_Vals#1)=41
	ModifyGraph/W=Envelope_Weight_Sigmoids rgb(Sigmoid_L)=(0,0,65535),rgb(Sigmoid_Vals)=(0,0,65535)
	ModifyGraph/W=Envelope_Weight_Sigmoids msize(Sigmoid_Vals)=4,msize(Sigmoid_Vals#1)=4
	ModifyGraph/W=Envelope_Weight_Sigmoids mrkThick(Sigmoid_Vals)=1,mrkThick(Sigmoid_Vals#1)=1
	ModifyGraph/W=Envelope_Weight_Sigmoids opaque(Sigmoid_Vals)=1,opaque(Sigmoid_Vals#1)=1
	ModifyGraph/W=Envelope_Weight_Sigmoids tick=2
	ModifyGraph/W=Envelope_Weight_Sigmoids font="Arial",fSize=10
	ModifyGraph/W=Envelope_Weight_Sigmoids lblMargin=2,standoff=0,axThick=0.5
	ModifyGraph/W=Envelope_Weight_Sigmoids ZisZ=1,zapTZ=1,zapLZ=1
	ModifyGraph/W=Envelope_Weight_Sigmoids btLen=4,btThick=0.5
	ModifyGraph/W=Envelope_Weight_Sigmoids stLen=2,stThick=0.5
	ModifyGraph/W=Envelope_Weight_Sigmoids manTick(left)={0,0.25,0,2},manMinor(left)={0,50}
	Label/W=Envelope_Weight_Sigmoids left "Weight\\u#2"
	SetAxis/W=Envelope_Weight_Sigmoids left 0,1
	
	//DoUpdate/W=Envelope_Weight_Sigmoids // for Igor 9
	//SetWindow Envelope_Weight_Sigmoids, hook(CuesHook)=SpHrView_Cues_WindowHook
	//SetWindow Envelope_Weight_Sigmoids note="PACKAGE:SpHrView;GROUP:Cues"
End


// PNG: width= 75, height= 15
Picture SpHrView_pict_Cues
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!$[!!!!`#Qau+!#2O`%fcS4^1gPKFBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2
	D(fIFBkB"Q/heq&$6UH6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<V
	dLG\q87F#n8RDffo=BQ%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>D
	K@j`D/_W^BQS?83\N.(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3
	a/n&:/@V%0%Df%.P@;mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06
	goE0/5(506:*<E+L\#ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^1GL[0$6UH6
	AU%p$3`'O8ASbL;Bl.F!F(oQ14X)d?+poG8+D#e3Ai`:tCi=>mE+*6f4X)U)$6UH6FD5?!3_=0sB4Y
	.YA9;KJ+u:r0+poG8+EV=0Ai`M#@:s.FASu.&BK[Ot1Em/K+<Yc?AnF)%ATMd+F`_>9DH1RgF?Lg'+
	poG8+EV=0Aia$lATMd+F`_>9DET1"0JG+5+poG8+EV=0Aia'mATMd+F`_>9DET1"0JG+5+poG8+E2"
	4FDl56Df@a)Des?49lFQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+
	k:*$6UH6G\qC\9lFQVApHdQFCdTZ1,(FC/MSq20Jufa1-.6H3\iEA0JkgE0HpiH+<YoGE&p^)FCA]g
	FC@RGFCdTZ1,(FC/MSq20Jufa1-.6H3\iEA0JkgE0Hr[f+<VdhG\qCo9fbgZF*)>@Gs2QX+<VdhEb&
	cC;e9r4$6UH6+<WdeA7dl=BaPt*+<VdLF*'ioF?3i?FD5Z24X+icDe+!#ARltl+<VdL+<Y`I7<Wc6F
	)PZ4G@>N'6"abHF?Lg6AnGapBlnVC6tLFRB5V:$+=L0"E$-nk+>PW*3@Q-Z+<VdL+<Y`I7<Wc6GA(Q
	*4X)X80f^g?0J+t9<&$-h1bh$H0eG(93\W6300T^c+<Vdh061T83`BU04piDT+?V<%D/`3D3_3t+FD
	l2F4piDT4>1_cAi`=kF(96)E-,f4DE\CM4>1_cAi`gX7Qq/A06fO&D/a?'FC@??4?n(0@:O(aF<G.4
	A3D,W,!S7L\IAoH!!.[c6UO[k;Fa%r8OZ!)0f_-M/M\q5!!"F0Fck!#_dOP*?T+XP.1Qgt9>e_*;i?
	PhC"/;Xb&H%Jqka#Hg\8=Vjf2Q#,qaWep^=S]B;LEK>[3eU$i9^I\(-f2oCR;lYNPjHT23f)H,(%b.
	iH%J%@M$=$i5:3`UK%cq#q^3fWd1C;06qiDD"1[qn/iCN41FG<rI+>>&,[l/'uWe4KbVd??fX5Ya/?
	bh@]0R;N[@9RIHjr(DOS>ok9b#9hq#MgLMlMS-2K?YTm;gd2H%`>"2V#N\ckO.$a[s056>W(Zm%;MY
	EbW`/bE61JBN[QXRmEp>Ws,OK>CEmk3_JP*9->AsFPYX!C9!B2I*0<0'[GL`VnFVJ,]'DdW1ULo4Lk
	bm-thL@O+*c.h`oAJecEL@K<negIuO<qCBf0_ush<`O2^J:.OFYGtcJ(G7V>qb`>dOcj5i[j2UUFpd
	VFke$rNEk,hJI81h+Zn>^.%=A!!0B_^Q^CP0o^/jMLQN.!c$#iF<ErZ1m,6.]r,6<%c5B[#,+94u$5
	u`*!m<s2''\2(?B?HNVG11e/DhJ`G1au<kR\2&Y7F>nehXuJ&Y$T;bepA.8?5,e(3_5Ac85l<U+JC)
	t)X2ZK[SH_u0q4S&ZCC3<^@1N=T)Ccsnsl+.T6&<%c?IPohf92M#QfDC_2&'Z62kd]^]ts/n-D3\ot
	cF`)k]@?b4E^!"3Y.m2@./EMBF&1!pk(=)=.sSCc5Y1E1s_KempP(9W%Z4X%$Si:(@a@$Asn*:JXca
	Boa/`#e4soXfWEu'Vq(f,=0-,.kmAFHl+9S40Dd)o?l3@ls]Cbr;]Z9't#n9Ee>_RNoLHR$;*ra9dW
	e[F#-Zk'[#(1I0Tn.L.4R!o]t+)YLe,)DeTf`.Zce%C5o,*$"]q]01GRgBXD)eIHUujkO[5bre6oT!
	+>BB=Su6]-qjSmn$`A6K^j<S't;k42V[c^a)c9A$47,bSp-OGcd+6p.r4@qTikN$7(8o*EYVW)$NS)
	!ih,[cqIL8DAhB<u%02"bihI$sj1<7Un+"q+!(bGSqu?2b`4\8%`P2Bq3=R)/fA60j&;7^/][NcSkN
	:o1//Ibd^RF^B"m5nCkR=Mt8+QjT&4ChjqOg-,7ZJJQkNCH&]giUmj*)UOLlTI&Pu+Hm\BP]-nD5,B
	Gsk'[5HB6oW;Fpn4I+I?=7H!Ko&7==:oer9>W$!LU[mBH*RO%3kM\DgfWepJG3imZD=sj@!.^l@UtN
	(eVl-H)]NS0`"b2(Knf-.(,/VflCMPZn?>uG+nCqm.X-`#:EeS*=*kE:#L\(#m?Qgl+#>/2N*kVk=S
	+H-%c]OgP24)^(gq7oR@:>l#Umbd83H\09ZJshtX:]#p+jsB(?9_r>N%nh^\/q5$m!/#;ZnsiTs7RM
	>L\5b9m9gb^S;YAkkMaU&iJ,aOEddEcSdrk#Cm<CW@6FuJJ;p&ZFC66&IaC_[8sV,;?;jdt4R)>'T9
	>AsE!4g0#*MkG*3G0p7AjoL/M37!gu@>Q%mKbrd%E]!hg`DDb6MGHpTgH,1^FD=kP0Lq/>tCbYV7`?
	Y-E>C/>shN0Fp>dH[!P_8e;8hlu_&u[B<iLqTP?`b*+)BVPL!rXXo;=#bWT'kBW*JH4:qD<*e80egB
	NnCMR.`DV]jG#9J9^_3C1KcLi76.gmhWW#-%`&HIh2O9H@aZo;534G0Q;HMNGg^29`;PUlQMqUV(*L
	OQ-sT3f'K-,VF^G0ol[;5:G&Z4[c_"@:\HQYUEuG_$NQ/hN@3aP^kmS'bonbKDCb.1n!h3B<@iPtsR
	9<+KNp\+toUWRIbj0gc(_q6HN^1)\g3T6=L?ZtArT(]q@FN49J9*BlB(F`g?D0!2.RP0RTKA.0J>1c
	$r:cd,Dcl$HBKY]u`Y2"])6T=fg>91qq(T0Ii'pi2U2`=bB4nA>D;(5s(b_JQsgZ4Z-ALdK5.m"^7)
	0=X2j#3q1,hXDdt5llk#!?`QfIso_>Iar+bd0K_\@9EG/BGC')SND%u?+X/&-\i3SrnrD>%N$lB+<Z
	3tH'W"\S%+1WL?CR^MA_Mp&Hp/GHpBq^C2.L*FEBl;K/c"MS'<<US4H4C#n7?/$GTVr9:#W$0G$km_
	;F.F#9fh9&p\a&T\!\q@MfM[E*]6A#.\@I^s<P;/O<c@c]j01S3$fQ)@`9f"[TuQQ,:DT%mTurZ*@.
	gN/<D%qsM'D:7N.5&ODR*a)Ndjd3;YgZ97t7CBtWH>?Y4aO<Hu-2Oc,U4O<3OjR>:(Oc^g5r**BFl5
	'GnBfu9u7md7_<XX@>$31coB3n%qPS[RH4G0R'<O3Rt[_lpt/^k9kf`9'%_=em_BuT_D*G0`?NZD?;
	HF9-kC:+R7n3D;G3m4fK`sI@5E?*#=FusIrZ5+tB/!eZK"S&JtLVprJ>Y\&>KaS^86?G9EOsNbshUQ
	MaNZV*TJB9_p3Q^;/!<@'uY]CV\CG>!"V"HRJoE["+K6qR>"QLgPXgb3m6i0\XKGu;3G@0TV?!Z9un
	%L:]BLe+)4_`=iZD6,Fi&Jub8*JB1qiDc,N5"M-U8"CTldo@C<q1/.r;#BmNH8FdGoSu'r(@ke#5nd
	PGFO27T+Bmi/oDMcJO@*1qVW6;QIYm7Ct]:^5:j;LiSbgmC+R="%FAdmi#Zt[T>G7uIe_lW*6/'c%h
	F0biJ0cf6cI.^a)NZRRS<XE.icU9BrRV'bDT7Jaf7*n>$?77bSd\a;,L1`Q7T#=p\Sh[!8KZnCRn:%
	'io_jNl/R%&KgH^f/;i/Z0iR`mC75OVdmT`#-:r.Wthu(+ZW8B`FcITo:Q&aW2K\]P2qQ>1U=<lPSo
	;.B)U9iKZ.bq16YH!1)Eqkdb)'YrVD8'#-k,iSpRVaC^e$`NYW:?bs=f@mr$V0L2WEre;0N:U/-:-\
	3>.i*b;[X$26R_;+E]q)#j>KcR$$,i4]G(1',1`Jb]"-q3'EIIdOPp7$Xr^YCH9!B*/5<,sgWPc=UR
	94NL_Y*6U(Q62](QXE^"A=]%d/L(O[4ilUc^o%`#*Z1%brZB$#UXL8lEdSd@:$ST^U%L;EO&E4Z`.1
	sb<o\(eL)(^\Y+$s*Z!(=fa5HB+%2tK/'?\m].!!nY$(Z-Z9-Hh`/5C)gqR%?KiHG=q-3cW&%GXGJ7
	"Fq!gWd42'Tj%n;92!IneZ6r,1B;oqmX:?f/P\8-!qGAUpiY!9GD!ZDj;bH%lga(?kc]Kii.Gh;n4I
	Tt*g/8>>+%l,I_X,VW*Lj!p?W@pPpFHT$PjQf#'!>[0FZ.1%Yph;.Ut1p=Ot<0N61,l@CP"YG.YX8+
	%lRN_SY<e42LOOcaGZ;or=u(p?mR/X=5[oNp@V(IW>cFJEfbr>dq6E!5BRt$7^S;=tgHN8o\jU,cKD
	LfkG/7p5U9ASt_+$4NI%5O/>B:98gJfBJc.q1M0Gt"X(J;Rd$.`cC.q*dH6/Q$l<uUJdT<K##g^%>T
	^UH&$ic^\")mDc[@u9PUse@W3NVti5(%THGY=AnaZ-#bM)?,Q=Uqg&LFlqQsj,&a#SD$@5'YeP@5;_
	@3g[E'21K6p$1YrY!*1#f`DFg]jCLgm+rtbqt@Sg:)1PF`D]=PnAm=ls"6=&QjfPWV?B3;Z=Sr]%Li
	jf5('k-!V'n!rGkF/0E*su_lRU44"6GN+X&#HL(+73^ZJ^`ai'!iV2.ZqH8a(]nY;i'+edb\H$o)oh
	$qRF#479V!18+Wcc,E:RM@0\\T?j(mbPKDRt4nL+$"?e__BN_;]=4j/1eiH*67S3(DG%I$ni'<V3/!
	L?\BO-Jfl<c-=4?0&V*ndW7,(Wf_R,ao`Ru93UJEM24>7+hD*V,8rJ:A]1fbUj[t!9e,2(6a:O-ETd
	5In(o#^%F&&QXc01#XNd2mlEqW+$:Hs@.]T-ts5XT$K<)b\dc113hV7b&Wn++afk(B#amY=Z=0W/2?
	mpCU`6k>/"ER-a[HN$$0Q-/^2A@ipBDB)62@UJD>35j4JLq#DLj)At-,:;.'kN>ZbUc+]:fsOH#.gS
	I<:f'uMdh\Z:S@Whi"qL.j.EnFMHpsr._6BWiEF%UbGtr#3)^f%3(lp)OjuD8k&N=1kGj4kbe#1/QA
	7T4qGdu6jg2&\3R8f._bE8U9$`;G1[=&:klVq`g&.a&XccXBk*Lk99A4p\WT9YC-e%NB<>OQ[fiqa,
	"Zs16(qVW[2dk.!4:odH!%@TacPXhK@MZkqsg0.<P#>.9J_$;'0!.Z2JQX4u0X]A(e>u=nGELbS%n2
	tKkEZE9MZr7[8mT8[T-*&R_&0shF'LgJmD/K75b813Sq>('V?QW42(S-3B,LkKWL-]YB+5m4dY_1tD
	0uI`p9J;HQ.OW1:M]&d>&k*@b(LMQpV54@2d%Nf?',/dMQc`\U,gVYa#A#dI66k8cf;V[`%lp,%f=#
	N1cg)GF4c>WumAO7W!A"Vj%31/CHLsi!FfKpL>X)R]^j@/2hgU65iiP/%l%*,:&Ff5)Z#^^J6L`"\S
	L:o0cCGU^M2@''7>Wp#&Y`b!i[+<P23+KBbRE'1i#E4r)Z!(C/./C"#UE!),Y>K*g,6193YJq*#Ze"
	ZBY9drOl>9tY?6Xhleq5m`IGkJ&O#=G)4T5cc.C<Un^L2K29mGh[Z+Cs$lTQrHQH[8;I1e%.M;oM+G
	eCk:qPO9SsRAQlKjA'K=cAc.[kTT:&f%>+8m[#<D5oQ5Fo)u7qu8o^=\\Ad0]",o":(76i6E,#9X<-
	pBYBdi@2s*l[\;>nGXN7Da+4Y1gnjKNs[pifGTClfSGgMFM:p`>V%4bP*2WgY;i1d(oF%E;,Y98N88
	6Rk8-+B_d,!6Ze;E\/&O'8TMcK#<i]4M'i!.//Q?SX7]"\bFBGHPHGmAcphgOc*j)R>Ek-t$DILc0\
	')VZYZe:%$]c\^Kin-SGTKm9^Abe:`HI#/K>AZ9JoVE<Ze:/Wo#1L]"dU=u[Y08pD6>"@I]ZYOeS:A
	Z6?Q;VSui(7BF/-QnRYVV4b%?_W5E6iJ7ZPN=T'NcG#*rY>R+O+X+GkE)rs@^g^+,bCY*]!0t!Kj!W
	rNnrN/t!A1Ws+:PN@^]A70q'kak9cS.db"@7il.7I+.XObtM'I=e)Y\Y>1Au0[O>BFPb2rS+]Z$D>'
	7*gJ%[O<*BR3FdQX]?rqWa_#=.b.El*8rna4Mu]R8KRo7T_*1I8M]hs&V4Eq&0s^8"<e>PkKaUl2k`
	C!#6Y'm#Hrpof*rP%>$$L-;Yb:[9jP)IL<5+c,.A7P&>XMFUX;U:<Dd"<2R]TA@p+QL3K@U$JiLB5;
	<iUUSu6:k,Y=7n--f8^"@]:@(0[OI-!)aGc:N/$&!"PGB>(q%*Zta03@u>5S)b1Im&=kNd_4!a/Uk$
	ZFoVds0hSeHCWRIB#e:To.92C]6V@c3?6BLS+>-+$$:&ZR1XGZg-aRUMD2t%Z7niH$kSZ!`<NV!F"7
	^S2:;Z3l!:X4Gq9P(M/I94W@icI"5Ho2X1itd7dEZ`O(cN31c<"9KjN(CRa$)>%526&S(>h,L<^e\N
	_t.>-b,SEG?m+cSYbnkk_Ra32A`?('L$D#nq,I'dU:?@3mAEmf/4G\c7]T#e!*%QO5IBi=.q<p:jFT
	+cDWd[EJ<1>lf)n97&8mmG!/:(lmi>NaAiDq6@fF=<)ng]j5p<20"9?+9dr#7ag0"@#".qJS9_T'i1
	F7*oMadgQ45CGFFL^FU!9L*#GP?U8?uEQ"kabUY8(4hUUQT$6qPi6'!.gnFq3_=%L+tEbq\kO'EL(E
	hhgpO=U1=mB!5PK)o4r%Q"@AdG1U/A/XKXpo@8X_Gl)m<.mi9ho/<pp#5guHQWR51$C[Xc)VTLt)gb
	O*C/?b\8%j&MTS;gR-KERO+,:+52]`Pkg->W2d)].+q)k(Uq3TV&h&%na&;Gj2T;Bj9,Od(ONQ67jm
	XnK3D2_M7MX)"uJT!,f*X)NNie'cYiK2&tHQdr#PZ^IXi9O`T@&/`$sSm-Zkiii_7/?C]]1fg_V92M
	Teid[4cV,jXKK2`>93\Z'o$EC50/-A^%1mb/A>4$1)8onTU9iFol8%0b#hAI^l6VK=CGo;a,?o[<=9
	oI1g'lA-cajRN)Akg\"hMgk.!pQ,O/4W)RSmI);?6%9S[<Y>`6`JaI3E^BGHJ_:T[9mQ=7NYTq+Y3[
	jr=s;Y]YHb<j],f=Z.WPG<I-PE;,+HX!"9'aA=&HeMMTY=2q\'<k==FZ)B&VXgZj9iFYkcR;s(%DX\
	[NqI\IlYe<rt88s5u!,"CI!Ep3FB7o$^)@fW#s>r6?a<n;HVgA,`&UOrF!L[V)66$4IT!jV6/0tLc7
	&+?$h\6rmL^Qk?3PrpVI5M.R>LYn$8rG"n1:7Xjd-GKD]HuehhSMo%Z(U?$%"?HhR[;.aI$L-gMn)s
	7TB^>KMAqsM_Ri+kN5"5qlBk_8n]2l18D/3YIl<'=/8PNdNNAOm/@l4c_UK1;M78f@>X\l.Lb+Z!EL
	P)V-Vh0P#UIW]G73+V\CnZi1l9[(]Kd'g+QrI@Nj1ccb#"q1CgV!"GiOZID0l:R:e<`#AiPa%J%ECR
	1Q:a8U4C6G%oNc!QQ5;S7:XdsH'?:Y(K"!q0$nX[[Sh+`!H:W&XV`-Te8`D^)F9rY.<40[b=d3jVpm
	mg5(F1F8Jk?T3/D'0S-DJ1%8k#f2C31Hl&d4o:>,$l^=LIkhN&dOZZe:<&qKfHXR5.9/,QIjsgY6X^
	`UP0LC[fJ.P*+lneWk1j(SiU*f!R-aL[.>5=Y2)='2L]FZL>FPgG"X)O%Xaf,RmUoWb#adib><;e)+
	JQNd_!K<`![)*)+pd-!AdaoqJOVc.ol$N7H'k*1N>2"pa`>`t8I%`gYF-'h)%H8VQA\Zs'S8XemL=*
	;tcp)2:2=9CX!-9$g^DFAa;/`He_qe+n/`YPp.9`eF[[orN6,qpZ:h]m[u!]Zn/f^%H-$,@=YZnFAB
	6W<.Ts+2[C?cA-B3(F`!l=AkO$,&5ogL0's8AN9b7\IWcMn+tfPK&`#G&oqt%!5gK/NCKG8P'5TASK
	%JGlN*4Y*ap$K!Iu9uKhZ,h]4!^e%Z&\+;C%*ZQ;rh&L@3ckDl<h9hH4iAlkIi7]8E\f<R-pS66Dd=
	QJga\)$YS;$-%>m\<Mol?g)g*+hHV(M!h!bI/)O]TL`1i'(%2ciFhu^G;-bW)fiQRZ>u5sLY*&)M?U
	2cXd-P`MMiKe1W-L,a)Z=q*!"A'UXlAX'i!)_8kl3O-Yp+nPtIn'C,Hoh>-/S?Q^+Us:.(1ZP#O:qW
	)P73(bZ)D;*/@^SftFGhXgT':-n:&B#ni'BB\^MQXB'/m@0Vt$K/kK/g%t.+WUsGq7T^'!M"7+R5a4
	#YkD(->$>+*HV_;;CG7W'KA5UQ6>\etMP^YWr#6S<gg?rmcYG?U.8N8r?9hH&aGhT&C,?jVILAD04!
	tD[BAZ=FXpjcSp,N9k^e+@<.A,@cK4_.>9KIR2:<9_E<Rp'I9hLZ!:QKo`e3?@!dQK\[OlT@7Md'PL
	,=c$<SfI>eR")',b3t0++397/mGHgc`EubN.=)8gc&Tpr#L>+ea7B@N0Mj6a8u'dI1n'Yb7(l@!eS<
	R-;o/qdii=E?W?MU7<ElN$BGEt8BNc,b6oR"^9(/8n-:gL>r\Ak=G+8r`^<MBSFt24I#Y';gj?9c!d
	2H1EJ&q!8$/(n66C,TnXn#nP>iGi1k/@T";GjGU#L4<ie8bisIb5hd`ljVDLX/O#M5NrA[f4`&AW6$
	2\$%4=%Yqr2Z"Ps4X[WtjF-:?p/Lj5Q`_#]1@e>d4MB3g!BOo<uXXh>^4&(k`8Wb8e3[/&j)ND8`<@
	ZTN4Yh^<l'm$\].IfulT<q-g#[(r*IN5&a>AdI-D]HWHf-KI4uXRrK`(Ws]dBB%kqI5e!3eST?W.eM
	#[;fY15__cFZ$#I3ikXpW_u8XYV'VfrQ@``'Ia+g%/B8&mf;#-p;Y*ASPEfUF$.bT&3rKL;pj!G36J
	Z#%\950ACrS-jkF[EEE[-KOu/XWP,([4,Y4@Nl1?glbSb%M>\%[#Rh*1u&-PS7[QRSk6S`M?,]:@+!
	!GS9W%/"TqVKO$6#\d+FcFCe=Np?pbh6HV`qj/!A&"H3.511]$Z'QGCQ!Rbl^\[-_(oBDq_omA@aAX
	?(fF70N(,%Bg=k8ZW$pA7eQU2Fr3gV;"EA6_D5hT<lq?#m\u;bP,g5CT9G4gCe-*D>DDmtg#n',)h^
	nOR3&K91Ns^Et:n\.PSDbHoPW"gd=\YOGq4?)J+9!P,&%@$Q"9_!VS0%S9oQkI=p\M&eIk<Yii2JFA
	h*.L<@s=P=":(^$#lsC#JA=DUK(/NJ*uujo!T:61pYRjLl-C@a'U4uP.!jj:Pa#]hAGGujC)%]s8Pq
	lB4DiGD1eecEPVcK:,Y=eb-`09YM:,$I+<G:*P[7/>C_TH=]mJ43/T^3Adn4nB/R!:3_ZMjAK,_bJ+
	[-t!XoZ<Y[j*dH!'WF6eb6X=!:CnMgS:P4oBm3F7j9r&799Ltnh&i6&BfN*]ch#-J6VnHI<OD_cBR5
	uUh?F[1&t"8N0JDa?_:Hph3gt;VIiU$lV6sHXoen='P5g.1_(?VJ-lXh-E$[+(]cJfb@]4LCBS'Ql&
	f8j562T@g&Jc[f->cs+98N(4k!fO!h^hqbE:KHo$O4$<5iF[<391Q4oP'2V_)q9RhURM,Fh-Y5smBf
	"oqkKGCOr".fdI##6/1fqZWX@p`n/%GJBgP593(<4GF@KJ:e$GhVS"3GUXsnC<Zer:32DS3;=.r@kl
	sI&-S".Sp5\XHfCl@IFuQSHmRl:ET4oo'e@4E^OH+i"p<$]NK'`/7tlYZ1ekI3gTK%3,q4_G.1NBsR
	m'0GWCj>.P3A&San'Uc-)L2\j5['?#7__7F9mC^$7-QaC7Stg,AXlYD76n4`rcSR_:UIb#[FIRIrb-
	inIeREq]F_Z`Cs9b`Jh]!6>s['nK:D5?1GhuT6EJ+&:5I&mm>!)[G^P8d.q2$37)b]A,6(=Srt_oHt
	85O>1_Wbeg3tTLd"C5=]lt=N$.K\J=Mh99%>t1Ld9@1QA30Qne'20J&h<(^Cm2_]?3=rE!56l!_p-6
	(gP\Jo%j%U&#k$lJB5gQTV0(0pO<odE50\u_iCJs6')pH%N92Z`AHbIKad/:.f8qrs7?Zh`NT8tkV-
	ZV%E4lqO7J%3gSAqEhXsY]'%2?:hE>HFnDX9=mk61A"&N0)R['/7e'S@%,me"^WC3R[;^;[42#-r`[
	9?/r.uLCu5=JG_HW(VI2)I-04*F<!U++U7WV?aI=SK[E0Z^h4!:.tRZct3(&?c6PJBhNoHk<P+B=jB
	<oF#VTV"N2FWZ4F(I+13B:8a9"YQf_go&RpI[r2Ljn`%N:rVD5&L0DXQ"@+O4aOLqH5Z.^b'r_Q1&*
	e$@YL2"B9E[WNr3(JAPu(H^TN8)p!s32"%d_34$:(`0:",o5Xljn$Jk?YdLsBX3rH$rKU!1eCY1C^D
	K/<C#l*2e"kH<<><DY"mY7^tX`uWHUN7QS2U7rjRX$NN.W)P5SCSN;8Ua`]TPo-)8SeSe;V$hr[!JY
	$sq;rXD.>jnqV?e]&)?"IHl4I:&Or#nIj>MA'V.rGMr?c`P;aDj/Zse!Qn&;(oP6(de!,rpeCY(2!j
	-1(J\@IPD8F^UbdO7>^T@sAe5CU8NZEf=#"V;Fb:6:j+3Pd6'O,MQZR_UjnN9T]kiPQ`H\$E$.kiC)
	Y0qB)O4P%3PSm3$sVM7+]K1VaC'@Ju2P0g+&+)1];WiE)inoF!Fd;$'4J\c)\8u5E'r!Wm?EAUCJ>$
	oBE8V/oIk'?s\DniETWtPlRG2cT3W@^.REdD*=*-'^Vf`T.b@@b+c^CTSfc2rXsK"=_J>p:NA8I<lN
	FS5+OBJfJ?H`rfSDJn=AF!j6bd\BGE:Eg(-+@s18IqtZ*Sd9(KDJi3E%Y-f1ce7XpZWX3SFgB$[gu\
	n*8ci1"lcqWT_]K/nCO$Qr0e?`Ea7K7>17oNcM"@Z][34Whlo#!%\u0NGU3f*hr_^AK*rp+XS37=^"
	X.:W61jKpn'\%*U.]f\I6GVjEH,um1e%V$P8"lM(cj@RY>2,sWDk]?d*59A"I1,q'N+Bb78[['H.fK
	777GLn^H*a?4ssE[g%<j&5E:YY#6;@VkC5k*$";fK4-pJ<b9@3I/Nij^E=8?*$4[;]c_@ZFi=WiB0g
	.V$5=psY@>W<h>8S(d!J"aDEre.@LiUt1J\CnW"J$ABs7Fs!@KWAnb.3G/X?gq2#Qdk#;%uH)\T.j=
	F)uDBEH1I(^&@p..>mC0RA$?SZ%5a_%%.bN*(s-C#V*U9YHC/+'g]4Q0]]54TgOTq*-!Tck#]m[S^0
	0[<%f4TJ)#iO&9e5hK[OnZ7.tTcrM"Z9WO1'(OcSDpQaH6mLt_u;7e&?(8,a*9<r()SY1JBKXh;%(d
	_XSOkh-&NBN=GN>';u6GnpQb!9!D10Vu\Ms$G8$h%pSi"[pQU3("_s0aqB6%Tb7a^r&s*6-1I;l(*%
	TOWm>jUSG/M$tp;*ITjM9n0G,*92Upe!i4/6,T7S7MBr(2d2@@GRO/;lU8Y+oYHD$77e1=RQ';t)4:
	"4Q&=noem-ru$piu^b1!Z?pJ@Vse:aZr7P\rY!>HdRhPC8o_<>,MJo.!KU#Cnnuik@$K>k]X`/H>_I
	/e+qS4*Xf1/k@J\m=4/oT)i?N<':+U#>2P+Eq?i4.Z0g]4\Kgj'a4GU.J=haJ6OAZKh'+G_H1)m,q\
	AUfB^IP)kUcT8eKRSIT&TKe&D?if'PPn"u'qjj-^-(deW%fk&&k]'bh>^YS)+(?W(qg0-IGeA`64DI
	!a,,S*/#klt^Fj"T[RPibpK[^<Hk'e(W]fYT,T7n86PRncI0FIYW&M!FXtb]Y2B&Ie*f^7DE$S=SBt
	)=7^3e3TYP!^^lH@?bGU\?L207mRdHZ'otpS5udg!R5Qp2Z>B1d2cW&LH-)?*X61rb3&ns_K_AF#Nu
	Ys\G0N`k]r4ZQC:/[!&'iMI(VLX=g=hFe(7Hd+2DkT*kS5#rlp#9dl-^aj7B&h@[bFcpqbRu,;cC#?
	h7>arp.4^\%JfhONZLXd(T4CGq=(h0j-/L4]A'_NeWlj0ZP/cYVC+8RcE4a$U$>6EC]2o8Oj4?tc="
	oKc?)JmDYJ7TZrVP.j-pgTX2qnPSU[c@EajbZ9]okK56&WjVt_1u;2c8B%dW-o(S<9DJ#U#PW4qodh
	W)QGq1\UN4nd]6Jd$@M+@$LV^juU4B!Z1IZ8uf/?!Vr_nmZ<K=_UOJjPJq8&P$!#C?[[+U(;3W3Bd*
	p<i)PXG5Hgm#<$JT-r(Y)n3>sBZBc,]T!sF%JL(dl&.WR5l5u;ih-T9-)C8t)CSm"q*BB^<HHRhZMb
	iNf)KX%Sbij8W34l>m_j_`.o9<87[].XMG'3^MiPKj<mAWgClh8k479Jj3*HJaOb*:eShCL\].lC51
	C]as,.A<H/M\[mJZ!rDHCD$cDV7`e8daSt;9+O?]8kNK!TW5;f-:i_6*?<tXYZLPeccaM4XK7Wo'SQ
	%@-gND+?K3608kTuWs595218FfTSa'3ao=:D=CU<2@mLe2opGA6V],(1ZIQ:2Ka/Qt:$i=\nlFNmHK
	ub8K78`[=c&7F8=gr9S#uP7Wm'*4Y_V.u@[%ADn^OQ9fYco41"d/ugn3$WVNguUqH$OZ="U,knY>JQ
	OGc@:5'EfJ-4j^/bk'?rk(\Rt?)AWqt$,BmQ5?I0%s&AK/;+$2-/oE*!GYW?IhK;*[?p^oFhOF2RII
	IB1A[U(FG1\4T)YT#&hr@ZIjHZSC9U,4H<lT;*s/:OD=R2p<k`Q!4UX;3tfOMsN5.5M!.[hXa#eXQF
	C"g1CY;68PBM$XrnZ8cg\mVpPrUECa\BKC<<100sq;pCuUBX3`BedGXC0(t"+"loD%f:S'k3fMG_N/
	_gd;jfX&in:&NY/?S0??JZU_G:-j3\1n`f3Vb9Y>H"K4nV8>A$kV3,mfkJHGmI>aj-sQH0FRcO20VV
	`/KUU?&=g](#4Jr9-`rfK#YT2Tddk-'K9#?RA#@7mp#lkB[]Oo:gW%kn,@BaC1cOI=ds.pf:#aj3_!
	3ct$jV6FSeYB%?t8Sqba<\P5a5h,Zq2XNd9nr4Q*plAblPO3j,78mDFPG?,(b"OT0?Iq_ANI?^-E4)
	\bLkCmN6lRJj<Z*@(enO0+DT0#=R;/*Ei4FY#u56,1@G.hX'*GouQ0lW..4BcK@BGea9CB!1::?kdZ
	bfQ0qXm,5"f`VId\mk==5nN;rPduEX2/IScUe6.<1L4^l',)%SP+lGr@l5/^J.sV:\eLg<AN?(>"e)
	_E7--u&FZS@&R5=<#2Q\,eTCnDE0Vgs?q*iJ4Kn,o@Qcu>lgYF9^V6E5cb-:HDFpDH8)RFie_1)MIc
	W:4UL+>,N1$\>_Z&`G7[dQUP&BGms&EqRb$_L=7>@PtCNHN3OV@!<!h"\ZmV8rM,Tccp;oYJDB>])^
	);u9iV<EusK2M]t')Ep?k=%5hUM\Oto\!!Hu&e`3F+$X]#]N]9a,s")5`0;^j]Y)\jr2sU'BP#g@Xg
	X(-kP>F*Y*u6O7Z/_1ed,[_OP(Yu9*;Jn;B[Im%mSTeT43!e$.A1E>cc3UE;P1M9"WKd^<gVVcjNYK
	"YknJ%LI`kZ1biQ9)rStRrYRHZoap6r3YZ&N@,f5S/YfXQ=DSujTbqmboAG5[XM0BG'ckTM]`9K!Tc
	0"ctT!H,T\l-)F?bWL(>@iCY#S4oB'UrAgV,#7)d+craCR.Jd,U2A!F:aa'PEl2AKRdQb5>#=@?%/(
	].#@"ECI6/:\[<DRaW;h3'4sD[$7O#S4nL$]sn6CpE.j7s*;a1E8cGFC*MZ&7(Ca1=k$6rO]j)0R8C
	n4&@6b6Ih>d^OZ+;p(+gTN;^@rZf:+O&E:RBUZ>a]0$nD3'1/3n]<Q4T/N^G09MO(=6NVSQ"U,(op%
	kiZ6rof=Q+Q/urS`MaV05,-Pa!h^*/TK2<M!`HQ6N:*>,.Ne-\]K#$YL=CqZ0EN\9U+ZUUr1f'3LhP
	$.;pW9G1l.=JAn?b@9'(e2C_""SCtW*li=%MAf(fUkU0U([U7fq]MnR0kEK,@lmUMED)eD=cQ2c:D*
	aEG[C/oQd&WKbO/T$RR@Ab"pP89dTm'P]YJGiZ2AMn4>'IWQoMtYq\.5C.1Rgk_#C*`.fqu`oKP9P*
	'\4>-S@(A'rG^r@ndD.&tS\!!C%Vo;(3iP7[e7Zj?F*ZXKjtcf%uI;/ioC9T)A:60?\poJq2HZ5].&
	3o^7Y3Q:g`cNp#9Ts2e^00.C=dDbXRYBaC%SDnV)c-NP>I*?TaXe_J.Pr-J[7*m?j7&/+`goL1KcMB
	:q&YN+5E!0ES,O-b![q?V]Bd@i5e>s8t_+/)tInCtYZh;;aJC?i+BLIH1t"Q>Oh?gYH"@rsus)q/+k
	LA9`VpMjRO!(97cl,jLJ41g7j#g7["^#f1;#Xd81;dPPJ"9<h\**`.;5\MiP087\IVQ;b^G%8hk:gN
	R+;dPQN!l,VQY]0mJ"9i3+;A`Y!p9$TeEQsn'6%4Bg9R\lM7dg+RXMoBf!5P8JlD4c,jY+.Cm'^h-X
	uC%d2mgQ+Hfbe%I&#R^omRDQ+9bDIo)bA!!'ns(H^cpQ]?N@-hf<Vt=203^fD**;nHidNi5Qf4@MJl
	V2-BN#,2>6oqf"][7;0Tlm7.P6jTRi_eu3[d`MG\pTE;WD;-n&OfQ)H(:KNVI!e7V\B\dTa(s]0`S:
	V*`=9,sk[4lgcmG!-P0ILg.%40o&<Wkl-)kDQfTVMkU[]\CKQOiMqp`mtgf30\7St%W`H4R_UAOb^T
	j2]bO<WY6_E,9mX*gUH^9GQHT>VB`iWPUs!=prk\W:+UZXMcd2V`*UP@sPMg\U+'kH-O`k->_QeV^n
	cXb,K/:CX-a.32X9pp<2LeqTG`OI(rl\?`S-C>u#\%b*2-2S>3NpmYd^POj:G(Z)N/)dFs?7CG*+5X
	7DVUZHCJHlcfm*_G!Ug/JHJ%KO:KtDL5Q"Vjs@uNb'$_H0:=WgAtQ]/,JVb$9N$A0K4H(FG3\kK5l>
	_!8-YZ=6L`Spg`9I<BKO!Hqk_VFpS*F;6f4c<4$1U@lS(1c41#3E(pWHLUOOe.*JqhO80:O>TQ`.fb
	PFSFdC2Y]^i["X4?ZWfeR<r1j"Xk=0FeCIXGF4jkAV+QVM^+39oF.g#h5ULTlU&$PX`i_O<9$e@>'=
	IQSeZpSq2K<m5sCSrqd#I+/C^a^7Al6EI4r\<9JsZB,!Y?XReZkD1BhO.Y&'-9%26akIUaI//[R!48
	_Dj9aMZU?5uP(WH(2NZIQQ4an<OMU-!GS;V]Apd<te;(gH78B++!j3pK>=fN2`c,hc;A3k'p;Y)n4D
	6t8)/R<N!`=:F6>3gL;mcNb>#LDM/WcF;nB7/D][79c(Q7X>ZoO)%:<`&;4fJ,f`ZBr5Y2NO?gi;gC
	@etNRS:u4`3[@D+38EeeEDmD@(\Wmt:[\6Sb\T,-;6*,]KcBOl@=^>TuSF)'I#ji8s_@-:`&pZcRZ/
	.P`I<>#BT/38offJ8SMQ]nj=b_39p?^V5jR;R4FP"!ie]4d=b_PM>;\G<\=G,W<oSuV/Z]#sg9Z4k!
	I?j`[ZDBZ6VJlL%9Eh9K-5[VsN;SjL.]q3moSuVgm\N`#9AHajQQ)d".@%hG%S[q*3!=b8X8R#'ee(
	(4nQ''LZn2/YBXS#!&+2;%<OP$3o`bPF\dK`J&u:8*8p-@Aihd-09=T!/ISg#)goKq6&g6C;c;#q75
	BLqCCd/rp*Zq*I_gQa>W/g%dK>op*%Ism+C7E8(E./EWCAc'$m[G3B)73/A6)0d@'P9T'f^h`_!'C5
	_9UKrk="_ZO`mZrFL'@W=Q#9Wg4Gk">bc+C2BftH7_V^,5!)B"XW.0V(V7kGZOVsS\lK%-8.YYo8>&
	X$TLd(dB@%k5h1D$VqnlP-L)_9>];I5jjI#!f^PV`fi7dn($muac!@fQO56_H?1\D^U`=OQM6?>t5d
	Mb$N2p/%PtikC+!(!(]\J#Fuq\=k`.1uW@O?]a,/MPb='kFRT%%[VCOX1;V]i(AF[c(k;fgWLVS2.P
	Z#F9GLiE8O".Q,";A'-.p(X=oSCMLKurMop0^@j3XR(fD!NnD4XI?o=eG'bkMd08VGP]KYG2E4pX[O
	l7-u"-V^7n3'>+je=f)U>plQ?*,W;1k`V%q0=\K5X\][`f3AQ*$2g!afZC&Udusa2#_6,EO\4)Q-%A
	F$Bj.#Hq[Q`HR/@DW\DV:/SFFm,lgXq>KnuN`M^Fua/b%?njk\f!#'9=>V$qdMr&/RWBU5gk\a0dfW
	83F3@`3,m8d#l4L<eIndA\Q_3>fSj2)+r4#e3^[1#Jn9U^\B?H/kI/670*A%mB@\E?'Or7$9=1rIF`
	qY^)cT0a_H!J'5"m;h8p_O(W^7fhI5&Ff?RjBfic_`dZ"&-T)gLn"hi0c5,llCHP=+Q0j`3--.Y#%?
	@>YIWu.iP\k-c@W(eduU)KVYg9@[JIeC>:&[PVB>=!.1GEmqsJKB2s\AR#IcF-!3l(t*8$2'C7P&:@
	j\^-B'>1,re5b^;-SYd5@_VKQ^t-\/H6,?\"^#0-\&u%OY4Q>gu=f7fY.Z72=tf7-iW0)$c^&@DKe6
	ZWiQ#.c^p!"BD_N%A*lm)?AlB5S2l.L!tcF$%FGijh26,/TV`3sc_5P4H?h2ugUn3Cf:\uN^Z?Xcd<
	2AP%QjCCMcH^T_q@0EMK[gT]#3AlpiH[Sl>Z.m-;5MQSK7WD]8rj_n/QXkoB&5(LW60f*^#1<rem4+
	jBb/l&:46O+9#f\O#!f?_i]Ss1rl;`hJH!oVC!9tGAuYh1jVELd+0[^Ns,Q,Ssi=Q^hU\L=c'7tC\`
	4qNhI,tC`_%;72IU@2K<2)70Rib$rh@,mMR'sA[+\/VJ/bqqlK2C38*'gT\>l>(BePNKN-HGo>h(9)
	s#O]:fE.[cTLgs`ufNO@N:CEDnGE3hL1s)55a)Q0<;i-m]`?tOp?oEs*@YQ3RBUG]pZU)pfZJ:QR%^
	U_=l(c:B([C/Wh0;SuL9)rq4/>6cO=iHgcd-$Psj'1T%.V8NrEu_Q1s4jBOs6@W01Kl0bmd,OZ!))W
	\fMT'l1Y!10m`9(@2sUcJfNV'mp^%n5p!kFR%gUQ=2-6oaQ,Ve/)@k)=*[n>]e:INR@gWmV2^oQ[27
	YZnKCb3;c5Q&;N3dAGh3+4Z?T@Lq81_[mC`5SVi:Z")Uq!!($5U)-V78(D/[6L=C!#F3<KhPhRlgaO
	[$M9,>O';sp2`F*(\Dn([)NM@[OX?Gclrq"H#o>([fF7$';n7&!F@Kd;]N0-K?W7Qg^#PYNMo.<^G$
	Ob"g&%Tr^`2%*B)%-rEC,lFtQnTE:&HE@RL^,!mN]Zq]6q%3._17=%Q$*''rBJuC.soJW[mU3]Q(7p
	USIQ%"p9%_'(cBMtA(7IIg`mk;DTHu*WMid@iDK'.6\D_8I2Yi?`Q,XOAn<0e%fh]%BC<Gd^A.?tmr
	u\"ZBtOVV\tdD8\F]*:U0OV!V^nJ5lefqZj6u[*pmes;HO\\KnrOqd$LC-QfCnY]KU3W1nE[%/T#@N
	9Uh?s^+O,$N5+bg&)R<kiY&j!=8`U7!X&N-7>R"i*IrL4!%96^YA!]X)58^'Y8/?0;KfP=MJFb4<.o
	&-j&PQ][rh.L2f'Zd4T+U6\X@jj"$P!kqJcCPeZV"RGkX)N2&5SpM>/?W"I3QgrgUE5.fSrViY&m;2
	NG[FDr\""GjAqZ`d,VdH$o0(m[B"lrefplY(@!GVq6F(HhY>'SYKgdg^k@sG$6F@U97j""T_7t@/<$
	2qGi1QHR,PAJH)dl/be7]QP!p#>#8;%`JatFC_:c<?46&`9pg2J(;9pZg9mRT\8Tch-i`^tY3-b3F%
	[bP"AcWB*pjWjs#ITpfrSJ9rO\TsQNRGIS)O'k:#BC22K0Wc/"lQ&?Pf1q\])":fY.Y3L[%LY2#7aJ
	R3H(k<bu(MN^HMu"9AU1:Rb<uohBYeH1pILR^*E@'#VV=58r*KgJAEH_;O9YeE[H+rJY=FJn7g2!4)
	j(HLRU0J7Btsg"0V6e2O+u'fY!r1I]0;hsdg&_(]P96=Z5G-KPP_bJjAYJV-7`$.X1.ao)G3"%SELe
	`tUJr?Rr=df&H`hb4tCS3]Dc'df"5U0\qE#@71+L;CTp*=dE!b@6OLDSWOFZZZAqG;,GhhJ`Xl_Zju
	6euLSDQL<Fi2,\muLW.5[1q^S(oJcKD?8pN:#WhIZ]WI&.#KFq6.')s*]?QhB5-SS>@rK%,*EkhmV[
	XL$VtUG3EpdX*r6a`6.SdfkZm]`#6Tk.n(L9J)_WKb_77(]CC)&W3YIIRIW)2+dHK'hA](iG?b)F@$
	eC8[kMcL/nn>]erBPGFS`>TIM%.9Nm[GdYB_iGDdW)?b6Ve$s!gu.],PQ1ge^](+gHI1.H?[\1^L`J
	!IWjQ#9dM%l!n2oq.iB#@T<g@YVIJP29".Oq+P27.WhUi'ugr*`6p@Em:<*[H:6<;DcNdj=0;UI.q^
	(q7(FW->dUTT(HbR:'lLe@o+"Q;f\b2YJ.['NsE0Z]:OSq,pq<]Pfjr,nCjILthN?F:,@%KNjSgt[N
	^bD?I1H0'TY?4d=a]FSjk!)T^MeOqPn+0GiSk,[GQ0XmasLtF[<I`!D:C.K3.Fqb]7.L(ggoZ.bE6;
	T@\*l`Rq7Ua]6hYAE8!^KW(^P)(^/:Q&0T1#57e/ICT6:`L?^#@MqU+W.i5jsaA<tH(%f:VLCXm-C2
	21bmKi<g!>]_\^Rd:>(nck,8EL0fW]:Eq=F$SG!p+q2#KU!mJuPOb/SSq%pp'8c;sU"/)?a*iDjs.a
	OCZXI"?(QJ>5PlK3;2s!o$G=Km862=mNEZ@Wu\#fT/1qJ[Qn\GGPrkF#&LEI[dpqMC[#L+WI)W%/e1
	&q:S!(fUS7'8jaJc
	ASCII85End
End


