﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

strconstant SpHrView_df_histogram = "root:SpHrView:Histograms:"
strconstant SpHrView_df_histogram_globals = "root:SpHrView:Histograms:Globals:"

// =================================================================================================
// SpHrView_CueHistogram_Defaults(), Binaural cue histogram defaults
// =================================================================================================
Function SpHrView_CueHistogram_Defaults()
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Histogram" folder, SpHrView_df_histogram
	if(!DataFolderExists(SpHrView_df_histogram))
		FolderStr= SpHrView_df_histogram[0,strlen(SpHrView_df_histogram)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Histograms:Globals" folder, SpHrView_df_histogram_globals
	if(!DataFolderExists(SpHrView_df_histogram_globals))
		FolderStr= SpHrView_df_histogram_globals[0,strlen(SpHrView_df_histogram_globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_histogram_globals
	variable nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"CuesPerCycle", 3)
	variable/G CuesPerCycle = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"useDerivatives", 0)
	variable/G useDerivatives = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"useEnvelopeWeights", 0)
	variable/G useEnvelopeWeights = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"usedtEnvelopeWeights", 0)
	variable/G usedtEnvelopeWeights = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"EnvelopeWtSaturation", 5)
	variable/G EnvelopeWtSaturation = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"EnvelopeWeightsdB", 0)
	variable/G EnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"dtEnvelopeWtSaturation", 5)
	variable/G dtEnvelopeWtSaturation = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"dtEnvelopeApplyToEnvelopes", 0)
	variable/G dtEnvelopeApplyToEnvelopes = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"dtEnvelopeWeightsInterp", 0)
	variable/G dtEnvelopeWeightsInterp = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"dtEnvelopeWeightsdB", 0)
	variable/G dtEnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"CuesPerCycle", 3)
	variable/G CuesPerCycle = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ITD_Dist", 0)
	variable/G ITD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"EnvITD_Dist", 0)
	variable/G EnvITD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ITD_max_ms", 1.5)
	variable/G ITD_max_ms = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ITD_numBins", 200)
	variable/G ITD_numBins = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"IPD_Dist", 0)
	variable/G IPD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"EnvIPD_Dist", 0)
	variable/G EnvIPD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"IPD_max_cycles", 1.5)
	variable/G IPD_max_cycles = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"IPD_numBins", 200)
	variable/G IPD_numBins = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ILD_Dist", 0)
	variable/G ILD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"EnvILD_Dist", 0)
	variable/G EnvILD_Dist = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ILD_max_dB", 24)
	variable/G ILD_max_dB = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ILD_numBins", 200)
	variable/G ILD_numBins = nval
	
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"Frequencyline", 1)
	variable/G Frequencyline = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"lineFrequency", 500)
	variable/G lineFrequency = nval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"lineFrequencyIndex", 0)
	variable/G lineFrequencyIndex = nval
	
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	if(waveexists(CFs))
		lineFrequency = min(lineFrequency, wavemax(CFs))
		lineFrequency = max(lineFrequency, wavemin(CFs))
		Variable index, Hz
		[index, Hz] = SpHrView_getCFindex(CFs, lineFrequency)
		lineFrequency = Hz
		lineFrequencyIndex = index
	endif
	
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"normalizeHists", 1)
	variable/G normalizeHists = nval
	
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"normalizeHists", 1)
	variable/G normalizeHists = nval

	String sval
	sval= StrVarOrDefault(SpHrView_df_histogram_globals+"ColorTableStr", "SeaLandAndFire")	
	string/G ColorTableStr = sval
	nval= NumVarOrDefault(SpHrView_df_histogram_globals+"ReverseColorTable", 0)
	variable/G ReverseColorTable = nval

	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_CueHistogramOptionsWindow(), display options for Cue Histograms
// =================================================================================================
Function SpHrView_CueHistogramOptionsWindow(variable winLeft, variable winTop)
	if(winleft < 0 || winTop < 0)
		GetMouse
		winleft=V_left
		winTop=V_top
	endif
	variable getITD=0, getIPD=0, getILD=0
	DoWindow ITD_Distributions
	if(v_flag)
		getITD=1
	endif
	DoWindow IPD_Distributions
	if(v_flag)
		getIPD=1
	endif
	DoWindow ILD_Distributions
	if(v_flag)
		getILD=1
	endif
	
	SpHrView_CueHistogram_Defaults()
	killwindow/Z CueHistogramDisplayOptions
//	Variable  winLeft=250, winRight, winTop=50, winBottom
//	[winLeft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
	
	NewPanel /FLT=1/K=1/W=(winLeft, winTop, winLeft+203, winTop+445) as "Distributions"
	DoWindow/C CueHistogramDisplayOptions
	variable topPos = 6
	Button b_Display title="Display  ⏎",pos={55,topPos},size={100,20},proc=SpHrView_CueHistogram_ButtonProc,fSize=11
	Button b_Display help={"Display distributions. Can also press 'return' key."}
	topPos += 25
	GroupBox group_CarrierCues fSize=10,title="\\f01Display Carrier cues",pos={5.00,topPos},size={195.00, 50}
	topPos += 23
	CheckBox ck_ITD title="ITD",pos={30,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"ITD_Dist"
	CheckBox ck_IPD title="IPD",pos={30+55,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"IPD_Dist"
	CheckBox ck_ILD title="ILD",pos={30+110,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"ILD_Dist"
	topPos += 27
	GroupBox group_EnvelopeCues fSize=10,title="\\f01Display Envelope cues",pos={5.00,topPos},size={195.00, 50}
	topPos += 23
	CheckBox ck_ITDEnv title="ITD",pos={30,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"EnvITD_Dist"
	CheckBox ck_IPDEnv title="IPD",pos={30+55,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"EnvIPD_Dist"
	CheckBox ck_ILDEnv title="ILD",pos={30+110,topPos},fSize=10,variable=$SpHrView_df_histogram_globals+"EnvILD_Dist"
	
	topPos += 45
	GroupBox group_checks,pos={5.00,topPos-8},size={195.00, 75}
	SetVariable sv_CuesPerCycle,pos={40,topPos},size={142.00,14.00},bodyWidth=35,title="\\f01Cues per cycle\\f00 (1-3)"
	SetVariable sv_CuesPerCycle,fSize=10//, proc=SpHrView_CueHistogram_SetVarProc
	SetVariable sv_CuesPerCycle,limits={1,3,1},value= $SpHrView_df_histogram_globals+"CuesPerCycle"
	SetVariable sv_CuesPerCycle, help={"Number of ITDs and other corresponding cues per cycle. 1: shortest ITD only, 2: include 2nd shortest ITD, 3: include 3rd shortest ITD"}
	
	topPos += 22
	CheckBox ck_useDerivatives title="Waveform derivatives",pos={49,topPos},fSize=10,side=1
	CheckBox ck_useDerivatives variable=$SpHrView_df_histogram_globals+"useDerivatives"
	CheckBox ck_useDerivatives help={"Use waveform envelope derivatives. Note that ABL and envelope values relative (not absolute) when derivatives are not used."}
	
	
	topPos += 20
	CheckBox ck_normalize title="Normalize re: maximum(f) ",pos={25,topPos},fSize=10,side=1
	CheckBox ck_normalize variable=$SpHrView_df_histogram_globals+"normalizeHists"
	
	// envelope derivative weights
	topPos += 35
	GroupBox group_dtEnvWts,pos={5.00,topPos-6},size={195.00, 90}
	CheckBox ck_usedtEnvelopeWeights title="\\f01Envelope derivative weights ",pos={25,topPos},fSize=10,side=1
	CheckBox ck_usedtEnvelopeWeights variable=$SpHrView_df_histogram_globals+"usedtEnvelopeWeights"
	topPos += 22
	SetVariable sv_dtEnvelopeWtSaturation,pos={20,topPos},size={165.00,14.00},bodyWidth=40,title="Derivative Saturation"
	SetVariable sv_dtEnvelopeWtSaturation,fSize=10
	SetVariable sv_dtEnvelopeWtSaturation,limits={1,100,1},value= $SpHrView_df_histogram_globals+"dtEnvelopeWtSaturation"
	SetVariable sv_dtEnvelopeWtSaturation, help={"Envelope derivative activity saturation level"}
	topPos += 20
	CheckBox ck_dtEnvelopeApplyToEnvelopes title="Apply to envelope cues ",pos={35,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeApplyToEnvelopes variable=$SpHrView_df_histogram_globals+"dtEnvelopeApplyToEnvelopes", Proc=SpHrView_CueHistogram_CheckProc
	topPos += 20
	CheckBox ck_dtEnvelopeWeightsInterp title="Interpolate ",pos={35,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsInterp variable=$SpHrView_df_histogram_globals+"dtEnvelopeWeightsInterp"
	SetVariable sv_dtEnvelopeWtSaturation, help={"Should not normally be selected. Interpolate derivatives from condition when only 1 cycle per second is obtained"}
	NVAR CuesPerCycle = $SpHrView_df_histogram_globals+"CuesPerCycle"
	if(CuesPerCycle<=1)
		CheckBox ck_dtEnvelopeWeightsInterp disable=2
	endif
	CheckBox ck_dtEnvelopeWeightsdB title="dB ",pos={135,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsdB variable=$SpHrView_df_histogram_globals+"dtEnvelopeWeightsdB"
	
	// envelope amplitude weights
	topPos += 35
	GroupBox group_EnvWts,pos={5.00,topPos-6},size={195.00, 70}
	CheckBox ck_useEnvelopeWeights title="\\f01Envelope amplitude weights ",pos={25,topPos},fSize=10,side=1
	CheckBox ck_useEnvelopeWeights variable=$SpHrView_df_histogram_globals+"useEnvelopeWeights"
	topPos += 22
	SetVariable sv_EnvelopeWtSaturation,pos={20,topPos},size={165.00,14.00},bodyWidth=40,title="Amplitude Saturation"
	SetVariable sv_EnvelopeWtSaturation,fSize=10
	SetVariable sv_EnvelopeWtSaturation,limits={1,100,1},value= $SpHrView_df_histogram_globals+"EnvelopeWtSaturation"
	SetVariable sv_EnvelopeWtSaturation, help={"Envelope activity saturation level"}
	topPos += 20
	CheckBox ck_EnvelopeWeightsdB title="dB ",pos={135,topPos},fSize=10,side=1
	CheckBox ck_EnvelopeWeightsdB variable=$SpHrView_df_histogram_globals+"EnvelopeWeightsdB"
	
	//ColorTable
	topPos += 35
	GroupBox group_ColorTable,pos={5.00,topPos-6},size={195.00, 45}
	SetVariable sv_ColorTable,pos={15,topPos},size={160.00,14.00},bodyWidth=125,title="Colors"
	SetVariable sv_ColorTable, fSize=10
	SetVariable sv_ColorTable, value= $SpHrView_df_histogram_globals+"ColorTableStr"
	Button b_ColorTable, pos={175.00,topPos-1},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
	Button b_ColorTable, proc=SpHrView_CueHistogram_ButtonProc
	topPos += 18
	CheckBox ck_ReverseColorTable title="reverse color table ",pos={65,topPos},side=1, fSize=10
	CheckBox ck_ReverseColorTable variable= $SpHrView_df_histogram_globals+"ReverseColorTable"
	
	topPos += 28
	CheckBox ck_keepWindowOpen win=CueHistogramDisplayOptions, title="📌 ",fSize=10,pos={30,topPos},side=0
	CheckBox ck_keepWindowOpen win=CueHistogramDisplayOptions, help={"Keep window open"}	

	DoUpdate/W=CueHistogramDisplayOptions // for Igor 9
	SetWindow CueHistogramDisplayOptions, hook(HistogramHook)=SpHrView_CueHistogram_WindowHook
	SetWindow CueHistogramDisplayOptions note="PACKAGE:SpHrView;GROUP:Histogram"
End




function SpHrView_CueHistogram()//String CueStr)
	DFREF saveDFR = GetDataFolderDFR()
	SpHrView_CueHistogram_Defaults()
	
	NVAR ITD_Dist=$SpHrView_df_histogram_globals+"ITD_Dist"
	NVAR IPD_Dist=$SpHrView_df_histogram_globals+"IPD_Dist"
	NVAR ILD_Dist=$SpHrView_df_histogram_globals+"ILD_Dist"
	
	NVAR EnvITD_Dist=$SpHrView_df_histogram_globals+"EnvITD_Dist"
	NVAR EnvIPD_Dist=$SpHrView_df_histogram_globals+"EnvIPD_Dist"
	NVAR EnvILD_Dist=$SpHrView_df_histogram_globals+"EnvILD_Dist"

	
	// if using check boxes in CueHistogramDisplayOptions
	doWindow CueHistogramDisplayOptions
	if(v_flag)
		// kill window if check box not checked
		DoWindow ITD_Distributions
		if(v_flag && !ITD_Dist)
			killwindow/Z ITD_Distributions
		endif
		DoWindow IPD_Distributions
		if(v_flag && !IPD_Dist)
			killwindow/Z IPD_Distributions
		endif
		DoWindow ILD_Distributions
		if(v_flag && !ILD_Dist)
			killwindow/Z ILD_Distributions
		endif
		
		killwindow/Z CueHistogramDisplayOptions
		
	// if NOT using check boxes in CueHistogramDisplayOptions
	// update if window is open
	else
		DoWindow ITD_Distributions
		if(v_flag)
			ITD_Dist= 1
		endif
		DoWindow IPD_Distributions
		if(v_flag)
			IPD_Dist= 1
		endif
		DoWindow ILD_Distributions
		if(v_flag)
			ILD_Dist= 1
		endif
	endif
	

	// Load waveforms from SpHrViewPeaksWindow
	variable startSec, endSec, usingAxis
	[startSec, endSec, usingAxis] = SpHrView_LoadWaveformsFromPeaks()
	wave waveforms=$SpHrView_df_files+"waveforms"
	variable numCols = dimsize(waveforms,1)
	if(numCols>2)
		DoAlert 0, "SpHrView_CueHistogram: waveform has > 2 channels/columns"
		return 0
	endif
	if(usingAxis)
		SpHrView_DrawSelection(2, startSec, endSec)
	else
		SpHrView_DrawSelection(1, startSec, endSec)
	endif
	
	// record timeframe used to obtain last histogram
	SVAR/Z timeFrameStr = $SpHrView_df_histogram_globals+"timeFrameStr"
	if(SVAR_Exists(timeFrameStr))
		if(endSec-startSec < 1)
			if(startSec > 0.01)
				SPrintf timeFrameStr, "%.2f to %.2f s", startSec, endSec
			else
				SPrintf timeFrameStr, "%d to %.2f s", startSec, endSec
			endif
		else
			if(startSec > 0.01)
				SPrintf timeFrameStr, "%.1f to %.1f s", startSec, endSec
			else
				SPrintf timeFrameStr, "%d to %.1f s", startSec, endSec
			endif
		endif
	endif
	NVAR CuesPerCycle = $SpHrView_df_histogram_globals+"CuesPerCycle"
	NVAR useDerivatives = $SpHrView_df_histogram_globals+"useDerivatives"
	
	NVAR useEnvelopeWeights = $SpHrView_df_histogram_globals+"useEnvelopeWeights"
	NVAR EnvSat = $SpHrView_df_histogram_globals+"EnvelopeWtSaturation"
	NVAR EnvdB = $SpHrView_df_histogram_globals+"EnvelopeWeightsdB"
	
	NVAR usedtEnvelopeWeights = $SpHrView_df_histogram_globals+"usedtEnvelopeWeights"
	NVAR dtEnvSat = $SpHrView_df_histogram_globals+"dtEnvelopeWtSaturation"
	NVAR dtInterp = $SpHrView_df_histogram_globals+"dtEnvelopeWeightsInterp"
	NVAR dtEnvdB = $SpHrView_df_histogram_globals+"dtEnvelopeWeightsdB"
	
	NVAR lowFreq = $SpHrView_df_filter+"lowFreq"
	NVAR highFreq = $SpHrView_df_filter+"highFreq"
	NVAR numCFs = $SpHrView_df_filter+"numCFs"
	NVAR RMSscale = $SpHrView_df_filter+"RMSscale"
	NVAR clearDelays = $SpHrView_df_filter+"clearDelays"
	variable fs = round(1/dimdelta(waveforms,0))
	NVAR normalizeHists = $SpHrView_df_histogram_globals+"normalizeHists"
	
	// get filter banks
	SpHrView_CenterFrequencies()
	wave CFs = $SpHrView_df_filter+"CFs"
	SpHr_FilterBankBiquadCoefs fs, CFs, coefBank
	SpHr_FilterBankBiquad /RMS/Dest=$SpHrView_df_filter+"FilterBanks" CFs, coefBank, waveforms
	wave FilterBanks = $SpHrView_df_filter+"FilterBanks"
	killwaves/Z coefBank
	
	String histDF= SpHrView_df_histogram // for getting all cues
	
	variable EnvSat_temp = EnvSat
	variable dtEnvSat_temp = dtEnvSat
	if(!useEnvelopeWeights)
		EnvSat_temp = 0
	endif
	if(!usedtEnvelopeWeights)
		dtEnvSat_temp = 0
	endif
	
	variable bitMask = 0
	if(ITD_Dist || IPD_Dist || ILD_Dist)
		// bit 0: Xs, bit 1: XNs, bit 2: ITDs, bit 3: IPDs, bit 4: ILDs, bit 5: ABLs (bit 6 is reserved)
		bitMask = SpHr_BitSetRange(bitMask,0,1) // Xs and Ns
		if(ITD_Dist)
			bitMask = SpHr_BitSet(bitMask,2)	// ITD
		endif
		if(IPD_Dist)
			bitMask = SpHr_BitSet(bitMask,3)	// IPD
		endif
		if(ILD_Dist)
			bitMask = SpHr_BitSet(bitMask,4)	// ILD
		endif
//		if(useEnvelopeWeights)
//			bitMask = SpHr_BitSet(bitMask,7)	// bit 7: Envs (bit 6 is reserved)
//		endif
//		if(usedtEnvelopeWeights)
//			bitMask = SpHr_BitSet(bitMask,8)	// bit 8: dtEnvs
//		endif
		
		
		if(useEnvelopeWeights || usedtEnvelopeWeights) 
			SpHr_CrossingCarrierCues /Type=(useDerivatives)/dB=(EnvdB)/dtdB=(dtEnvdB)/idt=(dtInterp)/CPC=(CuesPerCycle)/Cues=(bitMask)/DF=$histDF/AWts={EnvSat_temp,dtEnvSat_temp,EnvWts} CFs, FilterBanks		// /idt=0
		else
			SpHr_CrossingCarrierCues /Type=(useDerivatives)/dB=(EnvdB)/dtdB=(dtEnvdB)/idt=(dtInterp)/CPC=(CuesPerCycle)/Cues=(bitMask)/DF=$histDF CFs, FilterBanks		// /idt=0
			wave/Z EnvWts=$"" // NULL weights
		endif
		wave/Z ITDs=$histDF+"FilterBanksITDs"
		wave/Z IPDs=$histDF+"FilterBanksIPDs"
		wave/Z ILDs=$histDF+"FilterBanksILDs"
		wave/Z Ns=$histDF+"FilterBanksNs"
		wave/Z Xs=$histDF+"FilterBanksXs"
		
//		return 0
		

//		wave Envs=$histDF+"FilterBanks_Envs"
//		wave dtEnvs=$histDF+"FilterBanks_dtEnvs"
//	
//		if(useEnvelopeWeights && !usedtEnvelopeWeights) 		// envelope weights alone 
//			SpHr_CrossingEnvelopeWeights /S=(EnvSat)/DF=$histDF/AWts=EnvWts CFs, Ns, Xs, Envs
//		
//		elseif(usedtEnvelopeWeights && !useEnvelopeWeights)	// envelope derivative weights alone 
//			SpHr_CrossingEnvelopeWeights /S=(dtEnvSat)/DF=$histDF/AWts=EnvWts CFs, Ns, Xs, dtEnvs
//		
//		elseif(useEnvelopeWeights && usedtEnvelopeWeights)	// envelope and envelope derivative weights 
//			SpHr_CrossingEnvelopeWeights /S=(dtEnvSat)/DF=$histDF/AWts=dtEnvWts CFs, Ns, Xs, dtEnvs
//			SpHr_CrossingEnvelopeWeights /S=(EnvSat)/DF=$histDF/AWts=EnvWts CFs, Ns, Xs, Envs
//			EnvWts *= dtEnvWts
//			killwaves/Z dtEnvWts
//		else
//			wave EnvWts=$"" // NULL weights
//		endif
		
		if(ITD_Dist)
			NVAR ITD_max_ms = $SpHrView_df_histogram_globals+"ITD_max_ms"
			NVAR ITD_numBins = $SpHrView_df_histogram_globals+"ITD_numBins"
			//SpHr_CrossingCarrierCues/CPC=(CuesPerCycle) /ITD=ITDs /DF=$histDF CFs, FilterBanks
			if(WaveExists(EnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ITD_max_ms*0.001,ITD_numBins}/DF=$histDF/PkX=ITDs_PeakXs/Wt=EnvWts ITDs, ITDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ITD_max_ms*0.001,ITD_numBins}/DF=$histDF/PkX=ITDs_PeakXs ITDs, ITDs_Hist
			endif
		endif
		if(IPD_Dist)
			NVAR IPD_max_cycles = $SpHrView_df_histogram_globals+"IPD_max_cycles"
			NVAR IPD_numBins = $SpHrView_df_histogram_globals+"IPD_numBins"
			//SpHr_CrossingCarrierCues/CPC=(CuesPerCycle) /IPD=IPDs /DF=$histDF CFs, FilterBanks
			if(WaveExists(EnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-IPD_max_cycles,IPD_numBins}/DF=$histDF/PkX=IPDs_PeakXs/Wt=EnvWts IPDs, IPDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-IPD_max_cycles,IPD_numBins}/DF=$histDF/PkX=IPDs_PeakXs IPDs, IPDs_Hist
			endif
		endif
		if(ILD_Dist)
			NVAR ILD_max_dB = $SpHrView_df_histogram_globals+"ILD_max_dB"
			NVAR ILD_numBins = $SpHrView_df_histogram_globals+"ILD_numBins"
			//SpHr_CrossingCarrierCues/CPC=(CuesPerCycle) /ILD=ILDs /DF=$histDF CFs, FilterBanks
			if(WaveExists(EnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ILD_max_dB,ILD_numBins}/DF=$histDF/PkX=ILDs_PeakXs/Wt=EnvWts ILDs, ILDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ILD_max_dB,ILD_numBins}/DF=$histDF/PkX=ILDs_PeakXs ILDs, ILDs_Hist
			endif
		endif
		
		if(ITD_Dist)
			SpHrView_CueHistogramWindow("ITD")
		endif
		if(IPD_Dist)
			SpHrView_CueHistogramWindow("IPD")
		endif
		if(ILD_Dist)
			SpHrView_CueHistogramWindow("ILD")
		endif
	endif
	
	if(EnvITD_Dist || EnvIPD_Dist || EnvILD_Dist)
		bitMask = 0
		bitMask = SpHr_BitSetRange(bitMask,0,1) // Xs and Ns
		if(EnvITD_Dist)
			bitMask = SpHr_BitSet(bitMask,2)	// ITD
		endif
		if(EnvIPD_Dist)
			bitMask = SpHr_BitSet(bitMask,3)	// IPD
		endif
		if(EnvILD_Dist)
			bitMask = SpHr_BitSet(bitMask,4)	// ILD
		endif
		//if(useEnvelopeWeights)
		//	bitMask = SpHr_BitSet(bitMask,7)	// bit 7: Envs (bit 6 is reserved)
		//endif
		//if(usedtEnvelopeWeights)
		//	bitMask = SpHr_BitSet(bitMask,8)	// bit 8: dtEnvs
		//endif
		
		NVAR dtEnvelopeApplyToEnvelopes = $SpHrView_df_histogram_globals+"dtEnvelopeApplyToEnvelopes"
		if(!dtEnvelopeApplyToEnvelopes)
			dtEnvSat_temp = 0
		endif
		
		if(useEnvelopeWeights || usedtEnvelopeWeights) 
			SpHr_CrossingEnvelopeCues /Tr=1/dB=(EnvdB)/dtdB=(dtEnvdB)/CPC=(CuesPerCycle)/Cues=(bitMask)/DF=$histDF/AWts={EnvSat_temp,dtEnvSat_temp,EnvEnvWts} CFs, FilterBanks
		else
			SpHr_CrossingEnvelopeCues /Tr=1/dB=(EnvdB)/dtdB=(dtEnvdB)/CPC=(CuesPerCycle)/Cues=(bitMask)/DF=$histDF CFs, FilterBanks
			wave/Z EnvWts=$"" // NULL weights
		endif
		wave/Z Env_ITDs=$histDF+"FilterBanksEnvITDs"
		wave/Z Env_IPDs=$histDF+"FilterBanksEnvIPDs"
		wave/Z Env_ILDs=$histDF+"FilterBanksEnvILDs"
		wave/Z Env_Ns=$histDF+"FilterBanksEnvNs"
		wave/Z Env_Xs=$histDF+"FilterBanksEnvXs"
		
//	return 0;
		
		if(EnvITD_Dist)
			NVAR ITD_max_ms = $SpHrView_df_histogram_globals+"ITD_max_ms"
			NVAR ITD_numBins = $SpHrView_df_histogram_globals+"ITD_numBins"
			if(WaveExists(EnvEnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ITD_max_ms*0.001,ITD_numBins}/DF=$histDF/PkX=Envelope_ITDs_PeakXs/Wt=EnvEnvWts Env_ITDs, Envelope_ITDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ITD_max_ms*0.001,ITD_numBins}/DF=$histDF/PkX=Envelope_ITDs_PeakXs Env_ITDs, Envelope_ITDs_Hist
			endif
		endif
		if(EnvIPD_Dist)
			NVAR IPD_max_cycles = $SpHrView_df_histogram_globals+"IPD_max_cycles"
			NVAR IPD_numBins = $SpHrView_df_histogram_globals+"IPD_numBins"
			if(WaveExists(EnvEnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-IPD_max_cycles,IPD_numBins}/DF=$histDF/PkX=Envelope_IPDs_PeakXs/Wt=EnvEnvWts Env_IPDs, Envelope_IPDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-IPD_max_cycles,IPD_numBins}/DF=$histDF/PkX=Envelope_IPDs_PeakXs Env_IPDs, Envelope_IPDs_Hist
			endif
		endif
		if(EnvILD_Dist)
			NVAR ILD_max_dB = $SpHrView_df_histogram_globals+"ILD_max_dB"
			NVAR ILD_numBins = $SpHrView_df_histogram_globals+"ILD_numBins"
			if(WaveExists(EnvEnvWts))
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ILD_max_dB,ILD_numBins}/DF=$histDF/PkX=Envelope_ILDs_PeakXs/Wt=EnvEnvWts Env_ILDs, Envelope_ILDs_Hist
			else
				SpHr_Histogram/Norm=(normalizeHists)/Sym={-ILD_max_dB,ILD_numBins}/DF=$histDF/PkX=Envelope_ILDs_PeakXs Env_ILDs, Envelope_ILDs_Hist
			endif
		endif
		
		if(EnvITD_Dist)
			SpHrView_CueHistogramWindow("Envelope ITD")
		endif
		if(EnvIPD_Dist)
			SpHrView_CueHistogramWindow("Envelope IPD")
		endif
		if(EnvILD_Dist)
			SpHrView_CueHistogramWindow("Envelope ILD")
		endif
	endif
	

	killWaves/Z FilterBanks
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_CueHistogramWindow(), Binaural cue histogram Windows
// =================================================================================================
Function SpHrView_CueHistogramWindow(String CueStr)//, wave image)
	DFREF saveDFR = GetDataFolderDFR()
	String WinTitleStr, WinNameStr, wStr, pksStr
	strswitch(CueStr)
		case "ITD":
			WinTitleStr = "ITD Distributions"
			wStr = "ITDs_Hist"
			pksStr = "ITDs_PeakXs"
			break
		case "IPD":
			WinTitleStr = "IPD Distributions"
			wStr = "IPDs_Hist"
			pksStr = "IPDs_PeakXs"
			break
		case "ILD":
			WinTitleStr = "ILD Distributions"
			wStr = "ILDs_Hist"
			pksStr = "ILDs_PeakXs"
			break
			
		case "Envelope ITD":
			WinTitleStr = "Envelope ITD Distributions"
			wStr = "Envelope_ITDs_Hist"
			pksStr = "Envelope_ITDs_PeakXs"
			break
		case "Envelope IPD":
			WinTitleStr = "Envelope IPD Distributions"
			wStr = "Envelope_IPDs_Hist"
			pksStr = "Envelope_IPDs_PeakXs"
			break
		case "Envelope ILD":
			WinTitleStr = "Envelope ILD Distributions"
			wStr = "Envelope_ILDs_Hist"
			pksStr = "Envelope_ILDs_PeakXs"
			break
	endswitch
	WinNameStr = cleanupName(WinTitleStr,0)
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	Variable i
	if(WindowExists) // remove traces and images
		RemoveTraces(WinNameStr)
		RemoveImages(WinNameStr)
	else
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		variable wdth=screenHoriz*ViewWidthProportion/4
		variable hgt=screenVert*ViewHeightProportion*2
		variable leftRectPnt = (screenHoriz/6)
		variable rightRectPnt = (screenHoriz/6)
		variable topRectPnt = 240
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			GetWindow/Z SpHrViewPeaksWindow wsize // use SpHrViewPeaksWindow wsize
			leftRectPnt = V_left; topRectPnt = V_bottom+30
			rightRectPnt = V_right
		endif
		//DoWindow/K $WinNameStr
		variable winCnt = SpHrView_CountGroupWindows("Histogram") // SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:Histogram"
		if(winCnt>3)
			winCnt -= 4
		endif
		Display /K=1/W=(leftRectPnt+(wdth*(winCnt)), topRectPnt, leftRectPnt+(wdth*(winCnt+1)), topRectPnt+hgt) as WinTitleStr
		DoWindow/F/C $WinNameStr
		ControlBar/W=$WinNameStr /T 37
		NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		
		Button b_CueDistribitionPopUp win=$WinNameStr+"#PTop",pos={15,8},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_Distribution //picture=ProcGlobal#pict_PopUpList
		Button b_CueDistribitionPopUp win=$WinNameStr+"#PTop",proc=SpHrView_CueHistogram_ButtonProc
		Button b_CueDistribitionPopUp win=$WinNameStr+"#PTop",help={"Binaural cue distributions"}
		
		
		strswitch(CueStr)
			case "ITD":
			case "Envelope ITD":
				NVAR ITD_max_ms = $SpHrView_df_histogram_globals+"ITD_max_ms"
				NVAR ITD_numBins = $SpHrView_df_histogram_globals+"ITD_numBins"
				SetVariable sv_ITD_max_ms win=$WinNameStr+"#PTop",title="max ITD (ms)",pos={130,11},bodyWidth=40,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_ITD_max_ms win=$WinNameStr+"#PTop",value=ITD_max_ms, limits={0.1,10,0.1}
				SetVariable sv_ITD_numBins win=$WinNameStr+"#PTop",title="# bins",pos={210,11},bodyWidth=40,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_ITD_numBins win=$WinNameStr+"#PTop",value=ITD_numBins, limits={50,1000,50}
				break
			case "IPD":
			case "Envelope IPD":
				NVAR IPD_max_cycles = $SpHrView_df_histogram_globals+"IPD_max_cycles"
				NVAR IPD_numBins = $SpHrView_df_histogram_globals+"IPD_numBins"
				SetVariable sv_IPD_max_cycles win=$WinNameStr+"#PTop",title="max IPD (cycles)",pos={130,11},bodyWidth=35,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_IPD_max_cycles win=$WinNameStr+"#PTop",value=IPD_max_cycles, limits={0.1,10,0.1}
				SetVariable sv_IPD_numBins win=$WinNameStr+"#PTop",title="# bins",pos={210,11},bodyWidth=40,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_IPD_numBins win=$WinNameStr+"#PTop",value=IPD_numBins, limits={50,1000,50}
				break
			case "ILD":
			case "Envelope ILD":
				NVAR ILD_max_dB = $SpHrView_df_histogram_globals+"ILD_max_dB"
				NVAR ILD_numBins = $SpHrView_df_histogram_globals+"ILD_numBins"
				SetVariable sv_ILD_max_dB win=$WinNameStr+"#PTop",title="max ILD (dB)",pos={130,11},bodyWidth=40,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_ILD_max_dB win=$WinNameStr+"#PTop",value=ILD_max_dB, limits={3,72,3}
				SetVariable sv_ILD_numBins win=$WinNameStr+"#PTop",title="# bins",pos={210,11},bodyWidth=40,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
				SetVariable sv_ILD_numBins win=$WinNameStr+"#PTop",value=ILD_numBins, limits={50,1000,50}
				break
		endswitch
		

		NVAR Frequencyline = $SpHrView_df_histogram_globals+"Frequencyline"
		NVAR lineFrequency = $SpHrView_df_histogram_globals+"lineFrequency"
		NVAR lineFrequencyIndex = $SpHrView_df_histogram_globals+"lineFrequencyIndex"
		wave/Z CFs = $SpHrView_df_filter+"CFs"
		if(waveexists(CFs))
			lineFrequency = min(lineFrequency, wavemax(CFs))
			lineFrequency = max(lineFrequency, wavemin(CFs))
			Variable index, Hz
			[index, Hz] = SpHrView_getCFindex(CFs, lineFrequency)
			lineFrequency = Hz
			lineFrequencyIndex = index
		endif
		CheckBox ck_FrequencyLine title="〰",pos={290,9},side=1,variable=$SpHrView_df_histogram_globals+"Frequencyline"
		CheckBox ck_FrequencyLine proc=SpHrView_CueHistogram_CheckProc
		SetVariable sv_lineFrequency win=$WinNameStr+"#PTop",title="Hz",pos={330,11},bodyWidth=45,focusRing=0,proc=SpHrView_CueHistogram_SetVarProc
		SetVariable sv_lineFrequency win=$WinNameStr+"#PTop",value=lineFrequency, limits={20,20000,1}
		
		SetActiveSubwindow $WinNameStr //##
		ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
		
	endif
	
	wave W = $SpHrView_df_histogram+wStr
	if(!waveexists(W))
		DoAlert/T="Warning" 0, "wave: "+SpHrView_df_histogram+wStr+" is missing."
		return 0
	endif
	wave pksW = $SpHrView_df_histogram+pksStr
	
	SVAR ColorTableStr = $SpHrView_df_histogram_globals+"ColorTableStr"
	NVAR ReverseColorTable = $SpHrView_df_histogram_globals+"ReverseColorTable"
	SpHr_ColorTable/R=(ReverseColorTable)/Dest=ColorTable ColorTableStr
	
	AppendImage/W=$WinNameStr W
	ModifyGraph/W=$WinNameStr margin(left)=31,margin(bottom)=31,margin(top)=16,margin(right)=31
	NVAR normalizeHists = $SpHrView_df_histogram_globals+"normalizeHists"
	if(normalizeHists)
		ModifyImage/W=$WinNameStr $wStr ctab= {0,1,ColorTable,0},ctabAutoscale=3,lookup= $""
	else
		ModifyImage/W=$WinNameStr $wStr ctab= {*,*,ColorTable,0},ctabAutoscale=3,lookup= $""
	endif
	ModifyGraph/W=$WinNameStr userticks(left)={$SpHrView_df_filter+"CFs_TickVals",$SpHrView_df_filter+"CFs_TickTxt"}
	ModifyGraph/W=$WinNameStr tick=2, mirror=0
	ModifyGraph/W=$WinNameStr font="Arial", fSize=10, lblMargin=2, lblMargin(bottom)=1
	ModifyGraph/W=$WinNameStr standoff=0, axThick=0.5
	ModifyGraph/W=$WinNameStr ZisZ=1, zapTZ=1, zapLZ=1
	ModifyGraph/W=$WinNameStr btLen=4, btThick=0.5, stLen=2, stThick=0.5
	Label/W=$WinNameStr left "frequency (kHz)"
	
	// frequency-specific peaks
	if(waveexists(pksW))
		AppendToGraph/W=$WinNameStr/VERT $SpHrView_df_histogram+pksStr
		ModifyGraph/W=$WinNameStr mode=3,marker=8,msize=3,mrkThick=1.5,rgb=(0,0,0,32768)
	endif
	
	NVAR Frequencyline = $SpHrView_df_histogram_globals+"Frequencyline"
	if(Frequencyline)
		NVAR lineFrequency = $SpHrView_df_histogram_globals+"lineFrequency"
		NVAR lineFrequencyIndex = $SpHrView_df_histogram_globals+"lineFrequencyIndex"
		AppendToGraph/R/W=$WinNameStr W[*][lineFrequencyIndex]
		ModifyGraph/W=$WinNameStr lsize($wStr)=0.5,rgb($wStr)=(0,0,0)
		ModifyGraph/W=$WinNameStr tick(right)=3,noLabel(right)=2,axThick(right)=0
	endif
	
	strswitch(CueStr)
		case "ITD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,0.2,-3,1},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR ITD_max_ms = $SpHrView_df_histogram_globals+"ITD_max_ms"
			SetAxis/W=$WinNameStr bottom -ITD_max_ms*0.001, ITD_max_ms*0.001
			Label/W=$WinNameStr bottom "ITD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=ITDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
		case "Envelope ITD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,0.2,-3,1},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR ITD_max_ms = $SpHrView_df_histogram_globals+"ITD_max_ms"
			SetAxis/W=$WinNameStr bottom -ITD_max_ms*0.001, ITD_max_ms*0.001
			Label/W=$WinNameStr bottom "Envelope ITD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=Envelope_ITDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
		case "IPD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,0.2,0,1},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR IPD_max_cycles = $SpHrView_df_histogram_globals+"IPD_max_cycles"
			SetAxis/W=$WinNameStr bottom -IPD_max_cycles, IPD_max_cycles
			Label/W=$WinNameStr bottom "IPD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=IPDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
		case "Envelope IPD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,0.2,0,1},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR IPD_max_cycles = $SpHrView_df_histogram_globals+"IPD_max_cycles"
			SetAxis/W=$WinNameStr bottom -IPD_max_cycles, IPD_max_cycles
			Label/W=$WinNameStr bottom "Envelope IPD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=Envelope_IPDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
		case "ILD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,6,0,0},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR ILD_max_dB = $SpHrView_df_histogram_globals+"ILD_max_dB"
			SetAxis/W=$WinNameStr bottom -ILD_max_dB, ILD_max_dB
			Label/W=$WinNameStr bottom "ILD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=ILDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
		case "Envelope ILD":
			//ModifyGraph/W=$WinNameStr manTick(bottom)={0,6,0,0},manMinor(bottom)={1,50}
			ModifyGraph/W=$WinNameStr nticks(bottom)=10,manTick=0
			NVAR ILD_max_dB = $SpHrView_df_histogram_globals+"ILD_max_dB"
			SetAxis/W=$WinNameStr bottom -ILD_max_dB, ILD_max_dB
			Label/W=$WinNameStr bottom "Envelope ILD (\\U)"
			ColorScale/W=$WinNameStr/C/N=Legend_Colors/F=0/B=1/D=0.5/A=RT/X=-7.00/Y=0.00 lblLatPos=85, width=6,height=70,frame=0.00
			ColorScale/W=$WinNameStr/C/N=Legend_Colors image=Envelope_ILDs_Hist,font="Arial",fsize=9,lblMargin=10,nticks=2,tickLen=2.00,tickThick=0.50,tickLblRot=-90,ZisZ=1
			ColorScale/W=$WinNameStr/C/N=Legend_Colors "# crossings re: max.\\u#2"
			break
	endswitch
	
	SVAR/Z timeFrameStr = $SpHrView_df_histogram_globals+"timeFrameStr"
	if(SVAR_Exists(timeFrameStr))
		TextBox/W=$WinNameStr/C/N=text_timeFrame/F=0/B=1/D=0.5/A=MT/X=0.00/Y=0.50/E=2 "\\F'Arial'\\Z09Time frame: "+timeFrameStr
	endif
	
	ModifyGraph/W=$WinNameStr zero(bottom)=3,zeroThick(bottom)=1
	
	DoUpdate/W=$WinNameStr // for Igor 9
	SetWindow $WinNameStr, hook(HistogramHook)=SpHrView_CueHistogram_WindowHook
	SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:Histogram"

	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_CueHistogram_WindowHook(s), Window hook for *_Hist windows
// =================================================================================================
Function SpHrView_CueHistogram_WindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0	
	switch(s.eventCode)
		//////////////
		// deactivate
		case 1:
			strswitch(s.winName)
				case "CueHistogramDisplayOptions":
					ControlInfo/W=CueHistogramDisplayOptions ck_keepWindowOpen
					if(!V_Value)
						killwindow/Z CueHistogramDisplayOptions // close window when deactivted
						hookResult=1
					endif
					break
			endswitch
			break
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			strswitch(s.winName)
				case "CueHistogramDisplayOptions":
					switch(s.keycode)
						case 13:		// return
							//killwindow/Z CueHistogramDisplayOptions
							SpHrView_CueHistogram()
							hookResult=1
							break
					endswitch
					break
				endswitch
			break
			
		//////////////
		// kill event
		case 2:
			strswitch(s.winName)					
				case "ITD_Distributions":
				case "IPD_Distributions":
				case "ILD_Distributions":
				case "Envelope_ITD_Distributions":
				case "Envelope_IPD_Distributions":
				case "Envelope_ILD_Distributions":
					variable winCnt = SpHrView_CountGroupWindows("Histogram")
					if(winCnt<=1) // <= 1 because last window is being killed
						Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_df_histogram[0,strlen(SpHrView_df_histogram)-2]+"\")" // remove trailing ":"
					endif
					hookResult = 1
					break
					
			endswitch
			break
			
	endswitch
	return hookResult
End

Function SpHrView_CueHistogram_PopUpMenu()
	PopupContextualMenu "ITD;IPD;ILD;-;Options;-;Envelope ITD;Envelope IPD;Envelope ILD;"
	if(strlen(S_selection)>1) // not command key
		NVAR ITD_Dist=$SpHrView_df_histogram_globals+"ITD_Dist"
		NVAR IPD_Dist=$SpHrView_df_histogram_globals+"IPD_Dist"
		NVAR ILD_Dist=$SpHrView_df_histogram_globals+"ILD_Dist"
		NVAR EnvITD_Dist=$SpHrView_df_histogram_globals+"EnvITD_Dist"
		NVAR EnvIPD_Dist=$SpHrView_df_histogram_globals+"EnvIPD_Dist"
		NVAR EnvILD_Dist=$SpHrView_df_histogram_globals+"EnvILD_Dist"
		strswitch(S_selection)
			case "Options":
				GetMouse
				Variable leftCoord=V_left, topCoord=V_top
				SpHrView_CueHistogramOptionsWindow(leftCoord, topCoord)
				break
			case "ITD":
				ITD_Dist= 1; IPD_Dist= 0; ILD_Dist= 0;
				EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
				SpHrView_CueHistogram()
				break
			case "IPD":
				ITD_Dist= 0; IPD_Dist= 1; ILD_Dist= 0;
				EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
				SpHrView_CueHistogram()
				break
			case "ILD":
				ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 1;
				EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
				SpHrView_CueHistogram()
				break
			case "Envelope ITD":
				ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
				EnvITD_Dist= 1; EnvIPD_Dist= 0; EnvILD_Dist= 0;
				SpHrView_CueHistogram()
				break
			case "Envelope IPD":
				ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
				EnvITD_Dist= 0; EnvIPD_Dist= 1; EnvILD_Dist= 0;
				SpHrView_CueHistogram()
				break
			case "Envelope ILD":
				ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
				EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 1;
				SpHrView_CueHistogram()
				break
		endswitch
	endif
end


Function SpHrView_CueHistogram_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	switch( ba.eventCode )
		case 1: // mouse down
			// click code here
			strswitch(ba.ctrlName)
				case "b_CueDistribitionPopUp":
				case "b_SpHrView_Distributions":
					string selStr= ""
					variable key= getkeystate(0)  // Print key
					if(key==2 || key==10)	// option key
						PopupContextualMenu "ITD;IPD;ILD;-;-;Envelope ITD;Envelope IPD;Envelope ILD;-;Options;"
						selStr = S_selection
					elseif(key==1 ||key==9)		// command key
						SpHrView_CueHistogram()
					else
						selStr = "Options"
					endif
					if(strlen(selStr)>1) // not command key
						SpHrView_CueHistogram_Defaults()
						NVAR ITD_Dist=$SpHrView_df_histogram_globals+"ITD_Dist"
						NVAR IPD_Dist=$SpHrView_df_histogram_globals+"IPD_Dist"
						NVAR ILD_Dist=$SpHrView_df_histogram_globals+"ILD_Dist"
						NVAR EnvITD_Dist=$SpHrView_df_histogram_globals+"EnvITD_Dist"
						NVAR EnvIPD_Dist=$SpHrView_df_histogram_globals+"EnvIPD_Dist"
						NVAR EnvILD_Dist=$SpHrView_df_histogram_globals+"EnvILD_Dist"
						strswitch(selStr)
							case "Options":
								Variable leftCoord, topCoord
								string winStr = ba.win
								if(strsearch(winStr, "#PTop", 0))
									winStr = RemoveEnding(winStr, "#PTop")
								endif
								GetWindow $winStr, wsize
								leftCoord = V_left + ba.mouseLoc.h
								topCoord = V_Top + ba.mouseLoc.v
								SpHrView_CueHistogramOptionsWindow(leftCoord, topCoord)
								break
							
							case "ITD":
								ITD_Dist= 1; IPD_Dist= 0; ILD_Dist= 0;
								EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
								SpHrView_CueHistogram()
								break
							case "IPD":
								ITD_Dist= 0; IPD_Dist= 1; ILD_Dist= 0;
								EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
								SpHrView_CueHistogram()
								break
							case "ILD":
								ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 1;
								EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 0;
								SpHrView_CueHistogram()
								break
								
							case "Envelope ITD":
								ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
								EnvITD_Dist= 1; EnvIPD_Dist= 0; EnvILD_Dist= 0;
								SpHrView_CueHistogram()
								break
							case "Envelope IPD":
								ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
								EnvITD_Dist= 0; EnvIPD_Dist= 1; EnvILD_Dist= 0;
								SpHrView_CueHistogram()
								break
							case "Envelope ILD":
								ITD_Dist= 0; IPD_Dist= 0; ILD_Dist= 0;
								EnvITD_Dist= 0; EnvIPD_Dist= 0; EnvILD_Dist= 1;
								SpHrView_CueHistogram()
								break
						
						endswitch
					endif
					break
					
				case "b_Display":
					SpHrView_CueHistogram()
					killwindow/Z CueHistogramDisplayOptions
					break
					
				case "b_ColorTable":
					SVAR ColorTableStr = $SpHrView_df_histogram_globals+"ColorTableStr"
					String tempStr = ColorTablePopup(ColorTableStr)
					if(strlen(tempStr)>1)
						ColorTableStr = tempStr
						DoUpdate
					endif
					
//					SVAR ColorTable = $SpHrView_df_histogram_globals+"ColorTable"
//					PopupContextualMenu/N "SpHrView_ColorTablesPopup" //"*COLORTABLEPOP*"
//					if(V_flag>0)// && V_kind==13)
//						ColorTable = S_selection
//						DoUpdate
//					endif
					break
					
//				case "b_Settings":
//					DoWindow CueHistogramSettings
//					if(v_flag)
//						KillWindow/Z CueHistogramSettings
//					else
//						SpHrView_Settings_CueHistogram()
//					endif
//					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End


Function SpHrView_CueHistogram_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	int ValDepUpdate = 0
	switch( sva.eventCode )
		case 6: // Value changed by dependency update
			ValDepUpdate = 1
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			strswitch(sva.ctrlName)
				case "sv_lineFrequency":
					NVAR Frequencyline = $SpHrView_df_histogram_globals+"Frequencyline"
					wave CFs = $SpHrView_df_filter+"CFs"
					Variable index, Hz
					Hz = CFs[SetVarProcIndex(CFs, dval, 0)]
					[index, Hz] = SpHrView_getCFindex(CFs, Hz)
					NVAR lineFrequency = $SpHrView_df_histogram_globals+"lineFrequency"
					lineFrequency = Hz
					if(Frequencyline)
						NVAR lineFrequencyIndex = $SpHrView_df_histogram_globals+"lineFrequencyIndex"
						lineFrequencyIndex = index
						String winStr = sva.win
						if(strsearch(winStr, "#PTop", 0))
							winStr = RemoveEnding(winStr, "#PTop")
						endif
						String TraceStr, traceListStr= ImageNameList(winStr, ";") // TraceNameList(winStr, ";", 1) // ImageNameList(winStr, ";")
						TraceStr = stringfromList(0,traceListStr)
						//int64 i
						//for(i=0;i<itemsInList(traceListStr);++i)
						//	TraceStr = stringfromList(i,traceListStr)
						//	if(dimsize($SpHrView_df_histogram+TraceStr,1) > 0)
								ReplaceWave/W=$winStr trace=$TraceStr, $SpHrView_df_histogram+TraceStr[][index]
						//	endif
						//endfor
					endif
					break
					
				case "sv_ITD_max_ms":
				case "sv_ITD_numBins":
					if(!ValDepUpdate)
						SpHrView_CueHistogram()
					endif
					break
				case "sv_IPD_max_cycles":
				case "sv_IPD_numBins":
					if(!ValDepUpdate)
						SpHrView_CueHistogram()
					endif
					break
				case "sv_ILD_max_dB":
				case "sv_ILD_numBins":
					if(!ValDepUpdate)
						SpHrView_CueHistogram()
					endif
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SpHrView_CueHistogram_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			strswitch(cba.ctrlName)
				case "ck_FrequencyLine":
					SpHrView_CueHistogram()
					break
					
				case "ck_dtEnvelopeApplyToEnvelopes":
					if(checked)
						DoAlert/T="Warning" 0, "Envelope derivative weights should generally NOT be applied to envelope cues"
					endif
					break
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


// PNG: width= 75, height= 15
Picture SpHrView_pict_Distribution
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!"b!!!!?#Qau+!'u-S!!!!%^1gPKFBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2
	D(fIFBkB"Q/heq&$6UH6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<V
	dLG\q87F#n8RDffo=BQ%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>D
	K@j`D/_W^BQS?83\N.(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3
	a/n&:/@V%0%Df%.P@;mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06
	goE0/5(506:*<E+L\#ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^0f:X/$6UH6
	AU%p$3`'O8ASbL;Bl.F!F(oQ14X)[9+poG8+D#e3Ai`:tCi=>mE+*6f4X)U)$6UH6FD5?!3_=0sB4Y
	.YA9;KJ+u(r/+poG8+EV=0Ai`M#@:s.FASu.&BK[Oq0HpiH+<Yc?AnF)%ATMd+F`_>9DH1RgF?Lg'+
	poG8+EV=0Aia$lATMd+F`_>9DET0u1c-g=+poG8+EV=0Aia'mATMd+F`_>9DET0u1c-g=+poG8+E2"
	4FDl56Df@a)Des?49lFQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+
	k:*$6UH6G\qC\9lFQVApHdQFCdTZ1,(FC/MSq20K2rc0KM'O3]/]F0JkgE0HpiH+<YoGE&p^)FCA]g
	FC@RGFCdTZ1,(FC/MSq20K2rc0KM'O3]/]F0JkgE0Hr[f+<VdhG\qCo9fbgZF*)>@Gs2QX+<VdhEb&
	cC;e9r4$6UH6+<WdeA7dl=BaPt*+<VdLF*'ioF?3i?FD5Z24X+icDe+!#ARltl+<VdL+<Y`I7<Wc6F
	)PZ4G@>N'6"abHF?Lg6AnGapBlnVC6tLFRB5V:$+=L0"E$-nk+>PW*3@Q-Z+<VdL+<Y`I7<Wc6GA(Q
	*4X)X80f^g?0J+t;<&$'f2*!]T1G(:;3\W6300T^c+<Vdh061T83`BU04piDT+?V<%D/`3D3_3t+FD
	l2F4piDT4>1_cAi`=kF(96)E-,f4DE\CM4>1_cAi`gX7Qq/A06fO&D/a?'FC@??4?n(0@:O(aF<G.4
	A3D,W,!S7JrHW#U!!.[c6UO[k;Fa%r8OZ!)0f_-M/M\q5!!"F0Fck!#6r=Z=56d,F)TBS1@M2^Tr+K
	Q7N.d?N7esH;o4Hj<RNJa-7ZsmZ<Ku/2[GW]GX/qR1;R3R4-8t'JG@kS:R<(IaI.$acF1V*NE.npNd
	]W(*16o+r@fc&Rr.<Q!68`ZG)5LWgD0'rJHBOHbGu'ic[p?"7l#Zl.9dFK>:f\l)UmkCSG[,K62.J,
	m&T6%W>"&-Z\C6TK$K!9qSE!\iYoJ6D[R.eBE&@oJ@mq@i@QeTTL#qF',nheTr]]Tn[F*LjN5Sce(2
	SS]&\uQmUQ"-/8,D53d7#_EZD'b$0:P0p>&nbR:"HON-:XL6SYE8Xor(8GoVd]OCT@Daqe@'u]t*F9
	!N:BhSG.2GDo9nej*Vk-cHe505J^p2OIn^iJIg/;$<l0bGW+LXWh>&iiF3Ih+&1#.Z;S6Cb:qlA'^F
	hSnHQ!0F$7_8F7K=)Fnr%Qf\;/k3U^,I"f16n!\=2NL]@DT$#iF<ErZ1U,ldo\,lpS8,k(d6%JNF^5
	u_NKeQ[<<>K;$HI1Pe`5lr/8&-P9rPUK/$Aa;*_MQ.Y!Z6UO@_epicHKm=]dqP^sVG4-K[bUXM>IUc
	aAE'skin>I:ZH(FSUY$X`W"k5bFjYAC7hdD/'EsX25nJ:V]8qBPrSs"O$'>of;hojt)3Of>^[JZ/mI
	>V^/g2A@PQO5XScg2>63na1.#Oat@Q=G(/Ym*LU8YBYc]`n>3.qj0^]G4\&feq@ZDD9hj7+Z]gFE8"
	\IBP!d</`\AQ;_B652ipK&HD#=dCoR6^D<$0F/gCO2p_`=&`-)Jj@fW@aQKTfX@o^WiHD8m.#=J5$o
	EDR(ji(Z"7'1+e'9:QS$Cdra8_[(ufgi&_UJ.^p6ua``Ui8p"2(:j,[X8&-<sS_\Jf-eiacW"s`Tn/
	]];t!kXft8*u:[7\`hPk95M:6J$2s=dJ"c?XUpdZ/ZB\-jY0g*j/]F]<7n(/0fh0.#O9CY@=VMZ1,Q
	/QPs)_UX:L5ZAZ]qb+QCqK+ML\VBfbU8)f@T!0me(DDX@-0JGOKC?Z@*/.\u@J#?)7b%*8nAX0l/cN
	0!0WiC5N6pTcr,5OmfMoC6G-e%=eBq"Y[JiaJs6;u))qYIMNXDQ^M7J2P3]T&-eJe0[G@qq^3.-'@J
	Jfp`NK9FJk'h**QX[QVY8\d/W\l@(%8=&GBa;'<)<urG*f6,mao%@3#AY4[Z2c9K1.<Bi_q;[6;1(:
	iJ(:^h6crM[/T5;\o?(OJ0>BH_JE<uKYDsBe+mbX4CdkhY';d!C(Lg_,r*N;)jX'6ImrdN\-i5)j=c
	X4OHKhpf\FcKFMq5kEe,$T!AqXs`0YD_(p*,^/'0B.F,J1Rl%VW,XgeFr%;)e7;T3h'#-^"a;"W@+;
	l&[cu'O@.r-pFeHG$35&@fNqUC]aB\m=`<A6-_oS0V>n1C4r(6kHG*OKlT8S=rqbG_fqQ6eqYVPC/A
	Xh*lLf_.(O,P,Ggoi(I(b`uW9\>[0m+eQ!K[,!d6*)D2dZM!+lo-[@t(Ab<iOt=f_"dl#cPIbHnR,g
	\-h+bL0j;+]We_dFgX9<4Q`uA]rga)"',5RK'jI.#0CSp)#r2rp6#'b&<?eklQSs6ML0-r)iiqqL7r
	=MU*tnnkdkY7(.&9MA6G44RYG5fL,"uh5Pq2thY4uRUEBO::_<Q\g>QE27SN-SkK(.]@hfb,nk_gOm
	]j^Z\"8G$BBXN+8,p6tm+6^"XF8?))3j!A4an0JO"/,322r>hpC&&,I(*s(6rd791b"=AHpM,@eaN6
	BN"nc^'ub/("i9fV^MqBZDN35uP+INmFae+!IK%Idn]ScB$K)ODFT%>rnM%tG,X&iMp\kUh/Knu><n
	CEPpKa-b8WUXHpDbmOK=F8+,SnW!@-<(m9:`%.1^/'XIclcAoZXc27hXU1Z^Rb[HIk=sO2h>MT2(pU
	Sm2!;R/`B<Pn-(PPc@L54RQ=?qo7U=BCmaFFX&KX&!A2pU*tn.Thph^q-Tb=@XW=jc6_K*ErUAqRUr
	EVp[(<RBpr'N'O2fE,e:Yd_WVnmd=(BFQH!W)"X0\E0"u4'j!0>Fi(5H?Wm]e^T?1UN"j&>^(d?WD\
	766k9rBjC"&nQoVFGPFS4\blN7HItXK0]B`+U5U?c_C]dj,(&/G#'8(h;asNWq3/Y&e#N-j\O-7eV?
	(iVNlZYH9.P.#M_A&44AUi`=i7;cD`LH5D[)I)"uTe$<O.D[oI/!tYOSEOK_#H)^hr:JXIK].ONmYY
	?p?bA!F-2'tZhQVZ."][d][)(QE6?LLju'Ems[l48mq]D_Fbb,'410s_2B'S[l)FkpD_:6*o>_=3SY
	2%T,#La6>qO(ajLgjSo[5PWQ;2K(h8,#"Mb,,d[0>?I3Q3,SaDloNePeoijS\kC\enbBRT#/BeBbDe
	CENAV%i"<lhcNZ5irC!;JudJprJ<4CA-&A!,4N7V*SJ(VHmmGTO(ej4CV=iHDm(58YMW5#l["%%gf0
	*EVT,T7RZD-6a5f2@At*.Fbn$k<b"/8KkL3ca<Ng@ZCWb):7,e8+I)G]$;Yj7/(Xl?CLM*^8*KLX"l
	P!L&ru>4m1:b0%kuSeG[4\e[!O=_QQugKDXmGBYt4hCo'</h?+A1#CWuRYKnV:MS\uj>_i[_7&_7p^
	SAfs%P%F(CGlYW7+Tk4j]LBi8E&`kmNE[*($SWV>\[<k![#_o(AcA4e(,^Xf\Y9%X+/]lDe?sXc*em
	+N+D1li"gTon=DZ7#[\BZ;?2c#iO_`K>6cV4usS^!+8J9S2K[rn6SW*k"Ab@W0:Q?fkWS:_[hbkrl@
	=<H6g1F8a_/<,R"K&0%lZ>\pF%CpU`V1Id&.R,6GZe^Pur`rp#pa!!"0`k<*DT7&kM/dItD3%lIr.B
	#-kA+e>//3]>;t_G\&ZYC5l>m.MI/J*YL#s2."ET5Vgc/I,oaqpj69Z%E;XcRbIE<Pa=p?2k(&U):m
	mN<ESTYPsm5B0F`Gk,(4X"9<C>Xo&FI`ujS]F=s(gUuVQl`?SU"TLT9YlK^gG]khsM!!&)uf?t'94W
	_qg;SapK:^CM,VG.<PHZ*e&f,?%;J=E!jAQ]_dCc3f$U+FKRAW;_1rmTj&-T2K7nIto_Vb*6Rq=UK_
	J62TI_;r;?Hhf9cP+)t4\Z5c3=I,d38j8j`7<.cL?eobG<m.d\E#Qh,`u>$j!!"/fE8"&C>8LNN)fK
	VDkO#`h=dEWE2HJEJ49,B11t@e:Q.-+G;m:lk&*5'[8?hC:TDZ1%gb<ohPUu#"Ot+Ed'I8`X)SC"Gb
	*[-_gU:tA\YH$dedN3*k[?Hb[P\b)&e9\p[Zq(.CWW?O+sG-WGMg76s6:!FCt>mCn&9&(+onP@3pXY
	gD0otb:o.F[hWGOA>2$m`iC%7aWMZPi*/.H4*WU_jWq>hZQfbo;V*?%uT6komkH8+*:VSirp,p6LBh
	c[&-Im_HB`#?r7tRqZp=eCNp=2f+Mk@R)%p8/tUr7rM`%N#5Ig?&L+RQ@@l9f'"%Lq70o6dbn#1Mbk
	CpVJ_AU$t_GY`b6a056peWp=<I-eU<^1knNDF+[1?l4W9>41h^J9R0MBD*D(^4#lQ2mnoE=88aJeZ-
	<]A+T./3HFnAqb>2DnBgCc?o!qfPZ1\jM<=p:#/e%kF(8_EdEtfs0>/C=`84>]H'[J"@r*!:.SFtCj
	n92g24FXIN1<\A;Q4qcmco<(!$HrVK)ktM7,]fU?Lcg-g25I;QT)*e*9SNdJH,\kbarGr8BLmqi-G<
	[J,1IMnK5HqqS-[Ch9YnKXQt1(9a`*EJE9VB*Y.&86o9$d;&"]1N(0;]O9EdC'tQD6gGZ*WH[SkBlW
	b8,+NoWnbB%gs)F2[pV#UM!S>s,@C$qn2H6WIK`dahcn5Gj2'8cbi!:W,NQYjb:\"5cC;OLEB!!%%O
	#Zk83)4fHLaO^\U_+m!$A;XI&,po.i3Q;nD#6=8h'q'+u#6:tK;H=cb<T!lX5R7BZ!<Dh09Y.(mKeT
	OF(N?Qt9*Sti$R?'W&AjT50VpO2&^nF89E4&XHA3@eM?3drrT8`L8H?OoCjo5=C*rn`=?>7_V.R8oV
	C2d<#RL\8XGnWD,Dn#5g4()9!LGr,mJX(.E%K0f$r\p8]j?7uR$,Lq%)_QscS,cthHRfHYUmtBVIe1
	)MXl),%)^H@7tq\i/Ba?@UHR((!?B:%*60`A24Z<Pn/TJoVCSAi=qCgk@7l2,N/-SAQ=V4>dPW\uE?
	9F0+iEjja+8"F*WQ2\EFNVKDe6I%aYn/VQ=m7&_VoH&7E)KL;^!rkC)Y*FkCqW76SK@QSX/-fL3u1'
	R\kk;-/Wj-8>NPs10_#'-s`gn$HAIn\57$@-km:*3lA>fE`l]".14dVD(HG1KgN>mS'R/l<*:C^nJk
	aF?!^B*;9CN(W\;%DT.fCDU1oZ(BW\85#m:<ME5T^F+A3>f*0t)_OlgUBbi=H,@iIj6e.%%^;!/M>B
	J^8+:uUQNbW7Ic0MRJ"4d*Q;&r?aD_3D-/apb8LMD=5s4q_W:KgMZEk*+bo,iu:JYm_)Y/T[h#Y6@0
	XLb-`K<,-AkE,9@7Z7J9QlK[XIM$1k=@q0#jA5X+1N,]sO80ehQ=:??01,>"bV0$!U(oFmU3fus4<)
	e[J3&EIVc"7PSI_S)gO2p:#MP="JeF;t3,Y8\=KgMJfL5&MQ,g5cJnF65J\8Bu,YID6[^9OptO[r.l
	GP:CV_8/E=&]\mR8AnMmcf^M6A1!L[gW!^-]"0qkVUOf%aN0/gb7mC!_r6?)L.ES!(rjqL:b%aY1lZ
	'LQYdiVaQ7HaA29Lp\Qt-6j3_Pi[dB3>O`WX$(^A$#[C*E%NK)3-bu`(No)WrO,]m<n'ZDn'N%n&UJ
	fo<O?CI`cdr\rl!!!jjnTqm#+CL-c9f!3qrL4.Sj4q>qZ7J`!9[e+`VSX&L+k1X?dkpfm1s<0gT9!P
	dpGUpZkZ7ESr?XD-`J7-Ij%pH/o=WE4Etu6eVQtme]$I!bgP-9NMKk_:*(SI7:"*>j;q\1Nl<_,J4J
	%_=\WpH$JO&/Y(h\<mJ$FYo.qc(9_uKc;!(fUS7'8jaJc
	ASCII85End
End


