﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


strconstant SpHrView_df_IPDNeuron = "root:SpHrView:IPDNeuron:"

// =================================================================================================
// SpHrView_IPDNeuron_Defaults()
// =================================================================================================
Function SpHrView_IPDNeuron_Defaults()
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:IPDNeuron" folder, SpHrView_df_cue
	if(!DataFolderExists(SpHrView_df_IPDNeuron))
		FolderStr= SpHrView_df_IPDNeuron[0,strlen(SpHrView_df_IPDNeuron)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_IPDNeuron
	String sval
	variable nval
	// IPD neuron defaults
	sval= StrVarOrDefault(SpHrView_df_IPDNeuron+"neuronSelectShape", "Log-Normal 2.0")
	string/G neuronSelectShape = sval
	if(strlen(neuronSelectShape)<1)
		neuronSelectShape = "Log-Normal 2.0"
	endif
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"NumIPDneurons", 401)
	variable/G NumIPDneurons = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"numIPDbins", 401)
	variable/G numIPDbins = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel", -0.2)
	variable/G minIpsiHalfmaxIPDLabel = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel", 0.2)
	variable/G maxContraHalfmaxIPDLabel = nval
//	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"symmetricHalfmaxIPDLabels", 0)
//	variable/G symmetricHalfmaxIPDLabels = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"minIpsiMaximumIPDLabel", -0.02975)
	variable/G minIpsiMaximumIPDLabel = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"maxContraMaximumIPDLabel", 0.3703)
	variable/G maxContraMaximumIPDLabel = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"IPDrange", 1.25)
	variable/G IPDrange = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"IPDneuronWidth", 0.428404610648)
	variable/G IPDneuronWidth = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"addLogNormIPDCycles", 0) // should be 0
	variable/G addLogNormIPDCycles = nval
	nval= NumVarOrDefault(SpHrView_df_IPDNeuron+"IPDLabelShift", 0) 
	variable/G IPDLabelShift = nval
	
	SetDataFolder saveDFR
End

Function SpHrView_IPDNeurons(variable useHalfmaximumLables)
	SVAR neuronSelectShape = $SpHrView_df_IPDNeuron+"neuronSelectShape"
	NVAR IPDrange = $SpHrView_df_IPDNeuron+"IPDrange"
	NVAR NumNeurons = $SpHrView_df_IPDNeuron+"NumIPDneurons"
	NVAR numBins = $SpHrView_df_IPDNeuron+"numIPDbins"
	NVAR HM_minIpsi = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
	NVAR HM_maxContra = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
	NVAR M_minIpsi = $SpHrView_df_IPDNeuron+"minIpsiMaximumIPDLabel"
	NVAR M_maxContra = $SpHrView_df_IPDNeuron+"maxContraMaximumIPDLabel"
	NVAR addCycles = $SpHrView_df_IPDNeuron+"addLogNormIPDCycles"
	DFREF DFR= $SpHrView_df_IPDNeuron
	
	if(useHalfmaximumLables)
		SpHr_NeuronsIPD/R=(IPDrange)/EC=(addCycles)/F=(neuronSelectShape)/DF=DFR/HML={HM_minIpsi,HM_maxContra}/N={NumNeurons,numBins} IPDLabels, MaxLabels, IPDNeurons
		M_minIpsi = V_Maxima_Min
		M_maxContra = V_Maxima_Max
	else
		SpHr_NeuronsIPD/R=(IPDrange)/EC=(addCycles)/F=(neuronSelectShape)/DF=DFR/ML={M_minIpsi,M_maxContra}/N={NumNeurons,numBins} IPDLabels, MaxLabels, IPDNeurons
		HM_minIpsi = V_HalfMaxima_Min
		HM_maxContra = V_HalfMaxima_Max
	endif
	//killwaves/Z MaxLabels  // kill !! 
	
	NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
	IPDneuronWidth = V_NeuronWidth
	
	// ILD 'labels' may be shifted to match IPD
	NVAR IPDLabelShift = $SpHrView_df_IPDNeuron+"IPDLabelShift" // calculated shift in IPD labels (must equal ILDLabelShift)
	IPDLabelShift = V_IPDLabelShift
	
End


Function SpHrView_IPDNeuron_AppendImpulse(String winStr, variable useFilterImpulseEnvelope, variable removeToggle)
	String traceListStr= TraceNameList(winStr, ";",1)
	int ImpulseRemoved = removeToggle
	if(removeToggle && FindListItem("Impulse", traceListStr)>0)
		RemoveFromGraph/Z/W=$winStr Impulse
		ImpulseRemoved = 1
	elseif(removeToggle && FindListItem("ImpulseEnvelope", traceListStr)>0) 
		RemoveFromGraph/Z/W=$winStr ImpulseEnvelope
		ImpulseRemoved = 1
	else
		wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
		NVAR IPDrange = $SpHrView_df_IPDNeuron+"IPDrange"
		variable CF = 500, fs = 25000
		if(useFilterImpulseEnvelope)
			ControlInfo/W=$winStr+"#PTop" sv_filterFreqForImpulseEnvelope
		else
			ControlInfo/W=$winStr+"#PTop" sv_filterFreqForImpulse
		endif
		if(V_flag)
			CF = V_Value
			fs = CF*50
		endif
		if(useFilterImpulseEnvelope)
			// get impulse envelope
			SpHr_FilterBiquadCoefs /N/IE={$SpHrView_df_IPDNeuron+"ImpulseEnvelope", 1}/W fs, CF // , Coefs (optional) // /W flag sets V_FilterWidth
			wave ImpulseEnvelope = $SpHrView_df_IPDNeuron+"ImpulseEnvelope"
			
			// multiply offset IPDNeurons (preserve x-scale)
			NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth" // set by SpHrView_IPDNeurons()
			
			variable EnvIPDScale = (V_FilterWidth/IPDneuronWidth)
			//SetScale/I x -EnvIPDScale,EnvIPDScale,"cycles", IPDNeurons // preserve x-scale
			// skip traces that are not IPDNeurons
			int64 i; string TraceStr
			for(i=0;i<ItemsinList(traceListStr);++i)
				TraceStr = stringfromList(i,traceListStr)
				if(strsearch(TraceStr,"IPDNeurons",0) >= 0)
					ModifyGraph/W=$winStr muloffset($TraceStr)={EnvIPDScale,0}
				endif
			endfor		
				
			wavestats/Q/M=1 ImpulseEnvelope
			FindLevel/EDGE=1/Q/R=(v_maxloc,0) ImpulseEnvelope, 0.5 // find zero crossing looking backwards from X at peak to 0.5
			// set crossing at 0.5 to 0 IPD (cycles)
			SetScale/P x -V_LevelX, deltax(ImpulseEnvelope),"cycles", ImpulseEnvelope // phase (cycles)  deltax(ImpulseEnvelope) = (1/fs)*CF
			if(ImpulseRemoved && strsearch(traceListStr,"ImpulseEnvelope",0) <= 0)
				appendtograph/R/W=$winStr ImpulseEnvelope
				SetAxis/E=3/W=$winStr right 0,1		
				ModifyGraph manTick(bottom)=0
				ModifyGraph/W=$winStr rgb(ImpulseEnvelope)=(0,0,65535)
				ModifyGraph/W=$winStr tick(right)=2,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial"
			endif
			SetAxis/W=$winStr bottom -IPDrange*EnvIPDScale, IPDrange*EnvIPDScale
			
		else
			// get impulse
			SpHr_FilterBiquadCoefs /N/I={$SpHrView_df_IPDNeuron+"Impulse", 1, 7} fs, CF // , Coefs (optional)
			wave Impulse = $SpHrView_df_IPDNeuron+"Impulse"
			// shift impulse x-scale to align with IPD selectivity curve having a half-maximum passing through 0.0 IPD
			wavestats/Q/M=1 Impulse
			variable maxloc = v_maxloc
			// invert Impulse if -minimum value > maximum value
			if( -v_min > v_max )
				Impulse = -Impulse
				maxloc = v_minloc
			endif
			FindLevel/EDGE=1/Q/R=(maxloc,0) Impulse, 0.0 // find zero crossing looking backwards from X at peak to 0
			// set zero-crossing to 0 IPD (cycles)
			SetScale/P x -V_LevelX, deltax(Impulse),"cycles", Impulse // phase (cycles)  deltax(Impulse) = (1/fs)*CF
			//if(ImpulseRemoved && strsearch(traceListStr,"Impulse",0) <= 0)
			if(strsearch(traceListStr,"Impulse",0) <= 0) // append Impulse if not already appended
				appendtograph/R/W=$winStr Impulse
				SetAxis/A=2/E=2/W=$winStr right
				ModifyGraph/W=$winStr rgb(Impulse)=(0,0,65535)
				ModifyGraph/W=$winStr tick(right)=2,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial"
			endif
			//SetAxis/W=$winStr bottom -IPDrange, IPDrange
		endif
	endif
End



// =================================================================================================
// SpHrView_IPDNeuron_OptionsWindow(), display options for Cues
// =================================================================================================
Function SpHrView_IPDNeuron_OptionsWindow(variable winLeft, variable winTop)
	if(winLeft == 0 || winTop == 0)
		GetMouse
		winLeft=V_left; winTop=V_top
	endif
	SpHrView_IPDNeuron_Defaults()
	killwindow/Z NeuronsIPDWindow
	NewPanel /FLT=1/K=1/W=(winLeft, winTop, winLeft+360, winTop+280) as "IPD neurons"
	DoWindow/C NeuronsIPDWindow
	//string globals_dfStr = SpHrView_AtTime_DF_Globals
	variable topPos = 15
	GroupBox group_Shape win=NeuronsIPDWindow, pos={180,topPos-6},size={176,100}, fstyle=0,fSize=10, title="Curve shape"
	topPos += 15
	SetVariable sv_neuronSelectShape win=NeuronsIPDWindow, fSize=10,title="Type",pos={190,topPos},size={133,20},bodyWidth=107
	SetVariable sv_neuronSelectShape win=NeuronsIPDWindow, noedit=1,value=$SpHrView_df_IPDNeuron+"neuronSelectShape"
	Button b_neuronSelectShape, win=NeuronsIPDWindow, pos={325,topPos-1},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
	Button b_neuronSelectShape, win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_ButtonProc,focusRing=0
	topPos += 30
	CheckBox ck_addLogNormIPDCycles win=NeuronsIPDWindow, pos={200,topPos},title="add Log-Normal ± cycles"
	CheckBox ck_addLogNormIPDCycles win=NeuronsIPDWindow, variable=$SpHrView_df_IPDNeuron+"addLogNormIPDCycles",proc=SpHrView_IPDNeuron_CheckProc

	topPos = 15 // restart topPos
	GroupBox group_Num win=NeuronsIPDWindow, pos={6,topPos-6},size={170,100}, fstyle=0,fSize=10, title="Resolution of 'lookup table'"
	topPos += 15
	SetVariable sv_NumIPDneurons win=NeuronsIPDWindow, pos={20,topPos},size={145.00,14.00},bodyWidth=40,fSize=10,title="number of neurons"
	SetVariable sv_NumIPDneurons win=NeuronsIPDWindow, limits={3,10001,0},value= $SpHrView_df_IPDNeuron+"NumIPDneurons",focusRing=0
	SetVariable sv_NumIPDneurons win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	topPos += 25
	SetVariable sv_numIPDbins win=NeuronsIPDWindow, pos={20,topPos},size={145.00,14.00},bodyWidth=40,fSize=10,title="samples per neuron"
	SetVariable sv_numIPDbins win=NeuronsIPDWindow, limits={3,10001,0},value= $SpHrView_df_IPDNeuron+"numIPDbins",focusRing=0
	SetVariable sv_numIPDbins win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	topPos += 25
	SetVariable sv_IPDrange win=NeuronsIPDWindow, pos={20,topPos},size={145.00,14.00},bodyWidth=40,fSize=10,title="IPD range (cycles)"
	SetVariable sv_IPDrange win=NeuronsIPDWindow, limits={0.25,2,0},value= $SpHrView_df_IPDNeuron+"IPDrange",focusRing=0
	SetVariable sv_IPDrange win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	
	topPos += 40
	GroupBox group_IPDLabels win=NeuronsIPDWindow, pos={6,topPos-6},size={350,100}, fstyle=0,fSize=10, title="IPD 'label' limits (cycles) for left hemisphere (right is mirrored)"
	//topPos += 15
	//TitleBox t_Halfmax frame=0,fSize=10,fstyle=0,title="Half-maximal edges",pos={140,topPos}
	topPos += 15
	SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, pos={15,topPos},size={191.00,14.00},bodyWidth=65,fSize=10,title="Half-maximal:  ipsilateral"
	SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, limits={-1,1,0.01},value= $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel",focusRing=0, format="%.4f"
	SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	//CheckBox ck_symmetricHalfmaxLabels, win=NeuronsIPDWindow, pos={202,topPos}, side=1, title="🔗 ", variable= $SpHrView_df_IPDNeuron+"symmetricHalfmaxIPDLabels"
	SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, pos={215,topPos},size={130.00,14.00},bodyWidth=65,fSize=10,title="contralateral"
	SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, limits={-1,1,0.01},value= $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel",focusRing=0, format="%.4f"
	SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	// make half-max label limits red if no equal
	NVAR HM_minIpsi = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
	NVAR HM_maxContra = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
	if(0)
		if(HM_maxContra != -HM_minIpsi)
			SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
			SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
		else
			SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
			SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
		endif
	endif
	topPos += 25
	SetVariable sv_minIpsiMaximumIPDLabel win=NeuronsIPDWindow, pos={25,topPos},size={181.00,14.00},bodyWidth=65,fSize=10,title="Maximal:                  "
	SetVariable sv_minIpsiMaximumIPDLabel win=NeuronsIPDWindow, limits={-1,1,0.01},value= $SpHrView_df_IPDNeuron+"minIpsiMaximumIPDLabel",focusRing=0, format="%.4f"
	SetVariable sv_minIpsiMaximumIPDLabel win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	SetVariable sv_maxContraMaximumIPDLabel win=NeuronsIPDWindow, pos={215,topPos},size={130.00,14.00},bodyWidth=65,fSize=10,title=" "
	SetVariable sv_maxContraMaximumIPDLabel win=NeuronsIPDWindow, limits={-1,1,0.01},value= $SpHrView_df_IPDNeuron+"maxContraMaximumIPDLabel",focusRing=0, format="%.4f"
	SetVariable sv_maxContraMaximumIPDLabel win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={""}
	
	topPos += 27
	SetVariable sv_IPDLabelShift win=NeuronsIPDWindow, pos={60,topPos},size={130.00,14.00},bodyWidth=50,title="ipsi/contra 'label' shift",disable=2,fSize=10
	SetVariable sv_IPDLabelShift win=NeuronsIPDWindow, limits={-inf,inf,0},noedit=1,value= $SpHrView_df_IPDNeuron+"IPDLabelShift",focusRing=0, format="%.4g"
	SetVariable sv_IPDLabelShift win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_SetVarProc, help={"Label shift (offset). Must be the same as ILD label shift."}
	
	
	topPos += 35
	TitleBox t_DisplayIPDNeurons  win=NeuronsIPDWindow, title="Display:",pos={15,topPos+4},frame=0,fSize=10,fstyle=0
	Button b_DisplayIPDNeurons win=NeuronsIPDWindow, pos={65,topPos}, size={130.00,20.00}, fSize=10,title="Carrier IPD neurons"
	Button b_DisplayIPDNeurons win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_ButtonProc,focusRing=0
	Button b_DisplayEnvelopeNeurons win=NeuronsIPDWindow, pos={210,topPos}, size={130.00,20.00}, fSize=10,title="Envelope IPD neurons"
	Button b_DisplayEnvelopeNeurons win=NeuronsIPDWindow, proc=SpHrView_IPDNeuron_ButtonProc,focusRing=0
	doupdate/W=NeuronsIPDWindow
	
	topPos += 30
	CheckBox ck_keepWindowOpen win=NeuronsIPDWindow, title="📌 ",fSize=10,pos={30,topPos},side=0
	CheckBox ck_keepWindowOpen win=NeuronsIPDWindow, help={"Keep window open"}
	
	DoUpdate/W=NeuronsIPDWindow // for Igor 9
	SetWindow NeuronsIPDWindow hook(NeuronsIPDWindowHook)=SpHrView_AtTime_ActivityWindowHook   // Why setting this hook and not another?
	//SetWindow NeuronsIPDWindow note="PACKAGE:SpHrView;GROUP:IPD" 
End


Function SpHrView_IPDNeuron_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			Variable leftCoord, topCoord
			string winStr
			strswitch(ba.ctrlName)
					
				case "b_IPDNeuronParams":
					winStr = ba.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					GetWindow $winStr, wsize// gsize
					leftCoord = V_left + ba.mouseLoc.h
					topCoord = V_Top + ba.mouseLoc.v
					SpHrView_IPDNeuron_OptionsWindow(leftCoord, topCoord)
					break
			
				case "b_neuronSelectShape":
					PopupContextualMenu "Log-Normal 1.5;Log-Normal 2.0;Log-Normal 2.5;Raised-Cosine ^4;Raised-Cosine ^3;"
					if(strlen(S_selection)>1)
						SVAR neuronSelectShape = $SpHrView_df_IPDNeuron+"neuronSelectShape"
						neuronSelectShape = S_selection
						SpHrView_IPDNeurons(1)
					endif
					break
					
				case "b_DisplayIPDNeurons":
					SpHrView_IPDNeuron_Window(0) // carrier IPD neurons
					break
				case "b_DisplayEnvelopeNeurons":
					SpHrView_IPDNeuron_Window(1) // envelope IPD neurons
					break
					
				case "b_appendFilterImpulseToNeurons":
					winStr = ba.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_AppendImpulse(winStr, 0, 1 ) // append filter impulse, remove toggle
					break
				case "b_appendFilterImpulseEnvelopeToNeurons":
					winStr = ba.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_AppendImpulse(winStr, 1, 1 )	// append filter impulse envelope, remove toggle
					break
				
				case "b_switchToImpulseEnvelope":
					winStr = ba.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_Window(1)
					break
				case "b_switchToImpulse":
					winStr = ba.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_Window(0)
					break
						
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End

Function SpHrView_IPDNeuron_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			strswitch(cba.ctrlName)						
				case "ck_addLogNormIPDCycles":
					if(checked)
						DoAlert/T="Warning" 2, "Cycles should not be added when modeling representations. Add anyway?"
						if(V_flag == 1)
							SpHrView_IPDNeurons(1) // using Half-maximal lables
						else
							NVAR addLogNormIPDCycles = $SpHrView_df_IPDNeuron+"addLogNormIPDCycles"
							addLogNormIPDCycles = 0
						endif
					else
						SpHrView_IPDNeurons(1) // using Half-maximal lables
					endif
					break	
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function SpHrView_IPDNeuron_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	int ValDepUpdate = 0
	switch( sva.eventCode )
		case 6: // Value changed by dependency update
			ValDepUpdate = 1
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			String winStr
			strswitch(sva.ctrlName)
			
				case "sv_NumIPDneurons":
				case "sv_numIPDbins":
				case "sv_IPDrange":
					if(!ValDepUpdate)
						SpHrView_IPDNeurons(1)
						dowindow IPD_selectivity_curves
						if(v_flag)
							SpHrView_IPDNeuron_Window(0)
						endif
					endif
					break
				case "sv_minIpsiHalfmaxIPDLabel":
				case "sv_maxContraHalfmaxIPDLabel":
					if(!ValDepUpdate)
						SpHrView_IPDNeurons(1)
						NVAR HM_minIpsi = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
						NVAR HM_maxContra = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
						dowindow NeuronsIPDWindow
						if(v_flag)
							//SpHrView_IPDNeuron_Window(0)
						endif
//						NVAR symmetricHalfmaxIPDLabels = $SpHrView_df_IPDNeuron+"symmetricHalfmaxIPDLabels"
//						if(symmetricHalfmaxIPDLabels)
//							strswitch(sva.ctrlName)
//								case "sv_minIpsiHalfmaxIPDLabel":
//									HM_maxContra = -HM_minIpsi
//									break
//									
//								case "sv_maxContraHalfmaxIPDLabel":
//									HM_minIpsi = -HM_maxContra
//									break
//							endswitch
//						endif
						// make half-max label limits red if no equal
						if(0)
							if(HM_maxContra != -HM_minIpsi)
								SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
								SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
							else
								SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
								SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
							endif
						endif
						
						//dowindow IPD_selectivity_curves
						//if(v_flag)
						
						//endif
						
					endif
					
					break
				case "sv_minIpsiMaximumIPDLabel":
				case "sv_maxContraMaximumIPDLabel":
					if(!ValDepUpdate)
						SpHrView_IPDNeurons(0)
						NVAR HM_minIpsi = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
						NVAR HM_maxContra = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
						// make half-max label limits red if no equal
						if(0)
							if(HM_maxContra != -HM_minIpsi)
								SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
								SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(52428,1,1)
							else
								SetVariable sv_minIpsiHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
								SetVariable sv_maxContraHalfmaxIPDLabel win=NeuronsIPDWindow, valueColor=(0,0,0)
							endif
						endif
					endif
					break
					
				case "sv_filterFreqForImpulse":
					winStr = sva.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_AppendImpulse(winStr, 0, 0) // append filter impulse, no remove toggle
					break
				case "sv_filterFreqForImpulseEnvelope":
					winStr = sva.win
					if(strsearch(winStr, "#PTop", 0))
						winStr = RemoveEnding(winStr, "#PTop")
					endif
					SpHrView_IPDNeuron_AppendImpulse(winStr, 1, 0)	// append filter impulse envelope, no remove toggle
					break
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End


Function SpHrView_IPDNeuron_Window(variable viewEnvelopeScaledNeurons)
	SpHrView_IPDNeurons(1)
	wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
	if(!waveexists(IPDNeurons))
		DoAlert 0, "wave "+SpHrView_df_IPDNeuron+"IPDNeurons is missing"
		return 0
	endif
	wave IPDLabels = $SpHrView_df_IPDNeuron+"IPDLabels"
	if(!waveexists(IPDLabels))
		DoAlert 0, "wave "+SpHrView_df_IPDNeuron+"IPDLabels is missing"
		return 0
	endif
	string titleNameStr
	if(viewEnvelopeScaledNeurons)
		titleNameStr = "Envelope IPD selectivity curves"		
	else
		titleNameStr = "Carrier IPD selectivity curves"
	endif
	string windowNameStr = "IPD_selectivity_curves"
	string traceNameStr = "IPDNeurons"
	
	dowindow $windowNameStr
	if(v_flag)
		dowindow/F $windowNameStr
		DoWindow/T $windowNameStr, titleNameStr
		RemoveTraces(windowNameStr)
		Legend/K/N=IPDNeuronLegend
		if(viewEnvelopeScaledNeurons)
			ControlInfo /W=$windowNameStr+"#PTop" sv_filterFreqForImpulse
			if(V_flag)
				SetVariable sv_filterFreqForImpulse win=$windowNameStr+"#PTop", rename=sv_filterFreqForImpulseEnvelope, fstyle=1
			endif
			ControlInfo /W=$windowNameStr+"#PTop" b_appendFilterImpulseToNeurons
			if(V_flag)
				Button b_appendFilterImpulseToNeurons win=$windowNameStr+"#PTop", rename=b_appendFilterImpulseEnvelopeToNeurons, title="Append impulse envelope"
			endif
			ControlInfo /W=$windowNameStr+"#PTop" b_switchToImpulseEnvelope
			if(V_flag)
				Button b_switchToImpulseEnvelope win=$windowNameStr+"#PTop", rename=b_switchToImpulse, title=Char_swapArrow10_9_Str+" Carrier IPDs"
			endif
		else
			ControlInfo /W=$windowNameStr+"#PTop" sv_filterFreqForImpulseEnvelope
			if(V_flag)
				SetVariable sv_filterFreqForImpulseEnvelope win=$windowNameStr+"#PTop", rename=sv_filterFreqForImpulse, fstyle=0
			endif
			ControlInfo /W=$windowNameStr+"#PTop" b_appendFilterImpulseEnvelopeToNeurons
			if(V_flag)
				Button b_appendFilterImpulseEnvelopeToNeurons win=$windowNameStr+"#PTop", rename=b_appendFilterImpulseToNeurons, title="Append impulse"
			endif
			ControlInfo /W=$windowNameStr+"#PTop" b_switchToImpulse
			if(V_flag)
				Button b_switchToImpulse win=$windowNameStr+"#PTop", rename=b_switchToImpulseEnvelope, title=Char_swapArrow10_9_Str+" Envelope IPDs"
			endif
		endif
	else
		killwindow/Z NeuronsIPDWindow // Display messes up if this window isn't killed
		Display /K=1/W=(300,50,300+600,50+300) as titleNameStr
		DoWindow/C $windowNameStr
		ModifyGraph/W=$windowNameStr margin(left)=36,margin(bottom)=36,margin(right)=36,margin(top)=25
		ControlBar/W=$windowNameStr/T 35
		NewPanel/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		if(viewEnvelopeScaledNeurons)
			SetVariable sv_filterFreqForImpulseEnvelope win=$windowNameStr+"#PTop", pos={15,11}, size={152,12}, bodyWidth=45, limits={50,20000,100}, value=_NUM:500
			SetVariable sv_filterFreqForImpulseEnvelope win=$windowNameStr+"#PTop", fstyle=1,title="center frequency (Hz)", proc=SpHrView_IPDNeuron_ButtonProc
			Button b_appendFilterImpulseEnvelopeToNeurons win=$windowNameStr+"#PTop", pos={180,7},size={140,20}, fSize=9, title="Append impulse envelope"
			Button b_appendFilterImpulseEnvelopeToNeurons win=$windowNameStr+"#PTop", proc=SpHrView_IPDNeuron_ButtonProc
			Button b_switchToImpulse win=$windowNameStr+"#PTop", pos={370,8},size={95,18}, fSize=9, title=Char_swapArrow10_9_Str+" Carrier IPDs"
			Button b_switchToImpulse win=$windowNameStr+"#PTop", proc=SpHrView_IPDNeuron_ButtonProc
		else
			SetVariable sv_filterFreqForImpulse win=$windowNameStr+"#PTop", pos={15,11}, size={152,12}, bodyWidth=45, limits={50,20000,100}, value=_NUM:500
			SetVariable sv_filterFreqForImpulse win=$windowNameStr+"#PTop", title="center frequency (Hz)", proc=SpHrView_IPDNeuron_ButtonProc
			Button b_appendFilterImpulseToNeurons win=$windowNameStr+"#PTop", pos={180,8},size={140,18}, fSize=9, title="Append impulse"
			Button b_appendFilterImpulseToNeurons win=$windowNameStr+"#PTop", proc=SpHrView_IPDNeuron_ButtonProc			
			Button b_switchToImpulseEnvelope win=$windowNameStr+"#PTop", pos={370,8},size={95,18}, fSize=9, title=Char_swapArrow10_9_Str+"Envelope IPDs"
			Button b_switchToImpulseEnvelope win=$windowNameStr+"#PTop", proc=SpHrView_IPDNeuron_ButtonProc
		endif	
		Button b_IPDNeuronParams win=$windowNameStr+"#PTop", pos={475,8},title=Char_swapArrow10_9_Str+" Parameters",size={100,18},proc=SpHrView_IPDNeuron_ButtonProc,fSize=10
		SetActiveSubwindow $windowNameStr //##
		ModifyGraph/W=$windowNameStr cbRGB=(65534,65534,65534)
	endif
	int64 traceCnt = 0, i
	int64 traceSkip = round(dimsize(IPDNeurons,1)/20)
	for(i=1;i<dimsize(IPDNeurons,1);i+=traceSkip)
		AppendToGraph/W=$windowNameStr IPDNeurons[*][i]
		traceCnt += 1
	endfor
	ModifyGraph/W=$windowNameStr lsize=0.5,rgb=(52428,52428,52428)
	ModifyGraph/W=$windowNameStr tick=2, nticks(bottom)=10
	ModifyGraph/W=$windowNameStr tick(bottom)=0
	ModifyGraph/W=$windowNameStr font="Arial", fSize=10
	ModifyGraph/W=$windowNameStr lblMargin=5
	ModifyGraph/W=$windowNameStr standoff=0, axThick=0.5
	ModifyGraph/W=$windowNameStr ZisZ=1, zapTZ=1, zapLZ=1
	ModifyGraph/W=$windowNameStr btLen=4, btThick=0.5
	ModifyGraph/W=$windowNameStr stLen=2, stThick=0.5, tlOffset=2
	ModifyGraph/W=$windowNameStr manTick(left)={0,0.5,0,1},manMinor(left)={1,50}
	if(viewEnvelopeScaledNeurons)
		ModifyGraph/W=$windowNameStr manTick(bottom)=0
	else
		ModifyGraph/W=$windowNameStr manTick(bottom)={0,0.25,0,2},manMinor(bottom)={1,50}
	endif
	Label/W=$windowNameStr left "response probability\\u#2" // override units
	SetAxis/W=$windowNameStr left 0,*
	Label/W=$windowNameStr bottom "IPD (\\U)"
	// append first neuron, last neuron, and neuron where half-maximum activities correspond to 0 cycles (IPD)
	variable lastNeuron = dimsize(IPDNeurons,1)-1
	FindLevel/P/Q IPDLabels, 0
	variable centerNeuron = round(V_LevelX) 
	AppendToGraph/W=$windowNameStr IPDNeurons[*][0], IPDNeurons[*][centerNeuron], IPDNeurons[*][lastNeuron]
	ModifyGraph/W=$windowNameStr mode($traceNameStr+"#"+num2str(traceCnt))=3, mode($traceNameStr+"#"+num2str(traceCnt+1))=3, mode($traceNameStr+"#"+num2str(traceCnt+2))=3
	ModifyGraph/W=$windowNameStr marker($traceNameStr+"#"+num2str(traceCnt))=19, marker($traceNameStr+"#"+num2str(traceCnt+1))=19, marker($traceNameStr+"#"+num2str(traceCnt+2))=19
	ModifyGraph/W=$windowNameStr msize($traceNameStr+"#"+num2str(traceCnt))=1, msize($traceNameStr+"#"+num2str(traceCnt+1))=1, msize($traceNameStr+"#"+num2str(traceCnt+2))=1
	ModifyGraph/W=$windowNameStr rgb($traceNameStr+"#"+num2str(traceCnt))=(0,0,0), rgb($traceNameStr+"#"+num2str(traceCnt+1))=(0,0,0), rgb($traceNameStr+"#"+num2str(traceCnt+2))=(0,0,0)
	NVAR IPDrange = $SpHrView_df_IPDNeuron+"IPDrange" 
	SetAxis/W=$windowNameStr bottom -IPDrange,IPDrange
	SetDrawLayer/W=$windowNameStr/K UserFront
	SetDrawEnv/W=$windowNameStr ycoord= left, linefgc= (65535,16385,16385),dash= 0,linethick= 0.75
	DrawLine/W=$windowNameStr 0,0.5,1,0.5
	SetDrawEnv/W=$windowNameStr xcoord= bottom,linefgc= (65535,16385,16385),dash= 0,linethick= 0.75
	DrawLine/W=$windowNameStr 0,-0.02,0,1
	TextBox/W=$windowNameStr/C/N=IPDNeuronLegend/J/M/B=1/F=0/A=LT/E/X=10.00/Y=2.00 "\\JL\\s("+traceNameStr+") \\F'Arial'\\Z10left hemisphere neurons \\s("+traceNameStr+"#"+num2str(traceCnt)+")sample"

	// Envelope - multiply offset IPDNeurons to width of filter at selected frequency (preserve x-scale)
	if(viewEnvelopeScaledNeurons)
		variable CF=500, fs=CF*50//, filterWidth
		NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
		ControlInfo/W=$windowNameStr+"#PTop" sv_filterFreqForImpulseEnvelope
		if(V_flag)
			CF = V_Value
			fs = CF*50
			SpHr_FilterBiquadCoefs /W fs, CF // , Coefs (optional)  // /W flag sets V_FilterWidth
			NVAR IPDrange = $SpHrView_df_IPDNeuron+"IPDrange" // should equal -DimOffset(IPDNeurons,0)
			variable EnvIPDScale = (V_FilterWidth/IPDneuronWidth)  // IPDrange     (1/IPDrange)
			//SetScale/I x -EnvIPDScale,EnvIPDScale,"cycles", IPDNeurons // preserve x-scale
			ModifyGraph/W=$windowNameStr muloffset={EnvIPDScale,0}
			SetAxis/W=$windowNameStr/A bottom
			ModifyGraph/W=$windowNameStr manTick(bottom)=0
		endif
	endif

End
