﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// SpHrView_IR

StrConstant SpHrView_HRIR_df = "root:SpHrView:Signals:HRIR:"
StrConstant SpHrView_HRIR_Cues_df = "root:SpHrView:Signals:HRIR:Cues:"

//StrConstant SpHrView_BRIR_df = "root:SpHrView:Signals:BRIR:"

StrConstant HPFClistStr = "No headphone compensation;Beyerdynamic DT250;Beyerdynamic DT770;Beyerdynamic DT880;Beyerdynamic DT990;AudioTechnica ATH M50;Sennheiser HD430;Sennheiser HD480;Sennheiser HD560ovationII;Sennheiser HD565;Sennheiser HD600;Sennheiser HD650;Presonus HD7;Shure SRH940;AKG K141MK2;AKG K240DF;AKG K240MK2;KG K271MK2;AKG K271 Studio;AKG K601;AKG K701;AKG K702;AKG K1000 Closed;AKG K1000 Open;"




//   DataSet must = 1
Function SpHrView_HRIR_Displaylocations(variable SigIndex)
	
	int DataSet
	wave/T HRIR_DataSet = root:SpHrView:Signals:Globals:HRIR_DataSet	// HRIR_DataSet[SigIndex]
	//Printf "[%s]\r" HRIR_DataSet[SigIndex]
	strswitch(HRIR_DataSet[SigIndex])
		case "2° - NeumannKU100":
			DataSet = 1
			break
		case "360° microphone stand - NeumannKU100":
			DataSet = 2
			break
		case "360° full rotation mount - NeumannKU100":
			DataSet = 3
			break
		case "Lebedev 2354 - NeumannKU100":
			DataSet = 4
			break
		case "Lebedev 2702 - NeumannKU100":
			DataSet = 5
			break
		case "No HRIR":
			DoAlert/T="Warning" 0, "No HRIR Data set is selected"
			return 0
		default:
			return 0
	endswitch
	
	string titleStr = HRIR_DataSet[SigIndex]
	
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_df_signals))
		FolderStr= SpHrView_df_signals[0,strlen(SpHrView_df_signals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals:HRIR" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_HRIR_df))
		FolderStr= SpHrView_HRIR_df[0,strlen(SpHrView_HRIR_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_HRIR_df
		
	SpHr_HRIR/Az={Azimuths,2}/El={Elevations,2} DataSet=(DataSet)// Azimuths -π to π,  Elevations -π/2 to π/2
	Elevations = -Elevations // negate elevations for scatter
	Variable distance = 1 // normalized radius
	// Coordinates
	Make/O/N=(dimsize(Azimuths,0),3) ScatterCoordinates
	ScatterCoordinates[][0] = distance * cos(Elevations[p]) * cos(-Azimuths[p])
	ScatterCoordinates[][1] = distance * cos(Elevations[p]) * sin(-Azimuths[p])
	ScatterCoordinates[][2] = distance * sin(Elevations[p])
	// Coordinate Colors
	Make/O/N=(dimsize(Azimuths,0),4) SphericalCoordinateColors
	SphericalCoordinateColors = 0.3
	// Coordinate Sizes
	Make/O/N=(dimsize(Azimuths,0),3) SphericalCoordinateSizes
	SphericalCoordinateSizes = 0.08
	SetDataFolder saveDFR

	variable gzLeft = 360, gzTop = 380, gzSize = 300 // winWidth	
	Killwindow/Z HRIR_Coordinates
	NewGizmo/K=1/W=(gzLeft,gzTop,gzLeft+gzSize,gzTop+gzSize)
	DoWindow/C/T HRIR_Coordinates, titleStr
	//SetWindow HRIR_Coordinates userdata="SigIndex:"+num2istr(SigIndex)
	SetWindow HRIR_Coordinates userdata(HRIRlocationsData)="SigIndex:"+num2istr(SigIndex)+";"+"DataSet:"+num2istr(DataSet)
	ModifyGizmo stopUpdates
	// Display inner sphere
	if(1)
		ModifyGizmo scalingMode=34
		ModifyGizmo scalingOption=63
		if(1) // Top light
			AppendToGizmo light=Positional,name=lightTop
			ModifyGizmo modifyObject=lightTop,objectType=light,property={ position,0.000000,0.000000,6.283000,0.000000}
			ModifyGizmo modifyObject=lightTop,objectType=light,property={ direction,0.000000,0.000000,0.000000}
			ModifyGizmo modifyObject=lightTop,objectType=light,property={ ambient,1.000000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightTop,objectType=light,property={ specular,1.000000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightTop,objectType=light,property={ diffuse,0.733300,0.733300,0.733300,1.000000}
		endif
		if(1) // left/blue & right/red lights
			AppendToGizmo light=Positional,name=lightBlue
			ModifyGizmo modifyObject=lightBlue,objectType=light,property={ position,0.000000,6.28319,0.000000,5.000000}
			ModifyGizmo modifyObject=lightBlue,objectType=light,property={ direction,1.000000,0.000000,1.000000}
			ModifyGizmo modifyObject=lightBlue,objectType=light,property={ specular,1.000000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightBlue,objectType=light,property={ diffuse,0.250000,0.2500000,1.0000,1.000000}
			AppendToGizmo light=Positional,name=lightRed
			ModifyGizmo modifyObject=lightRed,objectType=light,property={ position,0.000000,-6.28319,0.000000,5.000000}
			ModifyGizmo modifyObject=lightRed,objectType=light,property={ direction,0.000000,0.000000,-1.000000}
			ModifyGizmo modifyObject=lightRed,objectType=light,property={ specular,1.0000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightRed,objectType=light,property={ diffuse,1.0000,0.50000,0.50000,1.000000}
			ModifyGizmo setDisplayList=3, object=lightRed
			ModifyGizmo setDisplayList=4, object=lightBlue
		endif
		if(1) // Front light
			AppendToGizmo light=Positional,name=lightFront
			ModifyGizmo modifyObject=lightFront,objectType=light,property={ position,6.28319,0.000000,0.000000,0.000000}
			ModifyGizmo modifyObject=lightFront,objectType=light,property={ direction,0.000000,0.000000,0.000000}
			ModifyGizmo modifyObject=lightFront,objectType=light,property={ specular,1.000000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightFront,objectType=light,property={ diffuse,0.600000,0.600000,0.600000,1.000000}
		endif
		if(1) // Back light
			AppendToGizmo light=Positional,name=lightBack
			ModifyGizmo modifyObject=lightBack,objectType=light,property={ position,6.28319,0.000000,0.000000,-1.000000}
			ModifyGizmo modifyObject=lightBack,objectType=light,property={ direction,0.000000,0.000000,0.000000}
			ModifyGizmo modifyObject=lightBack,objectType=light,property={ specular,1.000000,1.000000,1.000000,1.000000}
			ModifyGizmo modifyObject=lightBack,objectType=light,property={ diffuse,0.400000,0.400000,0.400000,1.000000}
		endif
		// InnerSphere
		AppendToGizmo sphere={0.9,100,100},name=InnerSphere	// normalized radius
		ModifyGizmo modifyObject=InnerSphere,objectType=Sphere,property={useGlobalAttributes,0}
		ModifyGizmo modifyObject=InnerSphere,objectType=Sphere,property={normals,100000}
		ModifyGizmo modifyObject=InnerSphere,objectType=Sphere,property={orientation,100021}
		//ModifyGizmo modifyObject=InnerSphere,objectType=Sphere,property={color,0.4,0.4,0.4,0.000000}
		ModifyGizmo setDisplayList=0, object=lightTop
		ModifyGizmo setDisplayList=1, object=lightBack
		ModifyGizmo setDisplayList=2, object=lightFront
		ModifyGizmo setDisplayList=5, object=InnerSphere
		ModifyGizmo autoscaling=1
		ModifyGizmo aspectRatio=1
		ModifyGizmo currentGroupObject=""
		ModifyGizmo zoomFactor=0.550000
		ModifyGizmo ModifyObject=Sphere,objectType=scatter, euler={90, 0, 0} // front
	endif
	if(1)
		// Coordinate Labels Scatter
		ModifyGizmo scalingMode=34
		ModifyGizmo scalingOption=63
		AppendToGizmo scatter=ScatterCoordinates,name=LocScatter
		ModifyGizmo ModifyObject=LocScatter,objectType=scatter,property={ sizeWave,SphericalCoordinateSizes}
		ModifyGizmo ModifyObject=LocScatter,objectType=scatter,property={ size,0.1}
		ModifyGizmo ModifyObject=LocScatter,objectType=scatter,property={ scatterColorType,1}
		ModifyGizmo ModifyObject=LocScatter,objectType=scatter,property={ colorWave, SphericalCoordinateColors}
		AppendToGizmo axes=defaultAxes,name=axes0
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,visible,0}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ -1,axisType,1048576}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,axisRange,-1,-1,-1,1,-1,-1}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,axisType,1052672}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,axisMinValue,-186.211}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,axisMaxValue,186.211}
		ModifyGizmo ModifyObject=axes0,objectType=Axes,property={ 0,ticks,0}
		ModifyGizmo setDisplayList=2, object=LocScatter
		ModifyGizmo zoomFactor=0.550000
		ModifyGizmo autoscaling=1
		ModifyGizmo aspectRatio=1
	endif
	//  Set to front
	ModifyGizmo ModifyObject=InnerSphere,objectType=sphere, euler={-90, -90, 0} // front
	ModifyGizmo resumeUpdates

	TextBox/C/N=text0/F=0/B=1/M/H={15,0,5}/A=LT/X=3.00/Y=2.00 "\\Z12\\K(65535,32768,32768)☀︎\\K(0,0,0)\\Z10 right ear";DelayUpdate
	AppendText "\\Z12\\K(32768,32768,65535)☀︎\\K(0,0,0)\\Z10 left ear"
	
	// External Az & El slider panels
	wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"						// HRIR_Az[SigIndex]
	wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"						// HRIR_El[SigIndex]
	variable Az = HRIR_Az[SigIndex]
	variable El = HRIR_El[SigIndex] 
	
	ExternalControlPanel("HRIR_Coordinates", "ControlPanel", "", 3, 22, 2, -1,-1,-1,-1)
	SetVariable sv_Az,pos={30,2},size={55.00,16.00},bodyWidth=55,proc=SpHrView_IR_SetVarProc,title="Az"
	SetVariable sv_Az,fSize=11,format="%.1f"
	SetVariable sv_Az,limits={-180,180,2},value= HRIR_Az[SigIndex],live= 1
	SetVariable sv_El,pos={105,2},size={55.00,16.00},bodyWidth=55,proc=SpHrView_IR_SetVarProc,title="El"
	SetVariable sv_El,fSize=11,format="%.1f"
	SetVariable sv_El,limits={-90,90,2},value= HRIR_El[SigIndex],live= 1
	Button b_play title="▶︎",pos={190,1},size={23,20},valueColor=(2,39321,1),fSize=13, proc=SpHrView_IR_ButtonProc
	Button b_make title="Make",pos={220,1},size={45,20},fSize=10, proc=SpHrView_IR_ButtonProc

	ExternalControlPanel("HRIR_Coordinates", "AzimuthPanel", "Azimuth", 2, 45, 2, -1,-1,-1,-1)
	Slider slider_Azimuth win=HRIR_Coordinates#AzimuthPanel, pos={10,3},size={280,20},vert=0,side=1,limits={180,-180,2},ticks=20,fsize=9
	Slider slider_Azimuth win=HRIR_Coordinates#AzimuthPanel, live=1, value=Az , proc=SpHrView_IR_SliderProc	
	
	ExternalControlPanel("HRIR_Coordinates", "ElevationPanel", "", 1, 60, 2, -1,-1,-1,-1)
	Slider slider_Elevation win=HRIR_Coordinates#ElevationPanel, pos={1,10},size={20,280},vert=1,side=2,limits={-90, 90,2},ticks=20,fsize=9
	Slider slider_Elevation win=HRIR_Coordinates#ElevationPanel, live=1, value=El, proc=SpHrView_IR_SliderProc	
	
	SpHrView_HRIR_DisplaylocationsUpdate()
	SetDataFolder saveDFR
End

//   DataSet must = 1

Function SpHrView_HRIR_DisplaylocationsUpdate()//Variable DataSet)//, Variable Az, Variable El)
	DoWindow HRIR_Coordinates
	if(!v_flag)
		return 0
	endif
	
	variable SigIndex = NumberByKey("SigIndex", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
	variable DataSet = NumberByKey("DataSet", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))

	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_HRIR_df
	String dfStr = SpHrView_HRIR_df
	
	wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"						// HRIR_Az[SigIndex]
	wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"						// HRIR_El[SigIndex]
	variable Az = HRIR_Az[SigIndex]
	variable El = HRIR_El[SigIndex]
	
	SpHr_HRIR/Deg={HRIR_Az[SigIndex],HRIR_El[SigIndex]} DataSet=(DataSet) // Assumes Azimuths -180 to 180,  Elevations -90 to 90
	Az = V_Az
	El = V_El
	//Printf "...Update()= %g\r", V_Index
	HRIR_Az[SigIndex] = V_Az		// Az
	HRIR_El[SigIndex] = V_El //El
	
	Slider slider_Azimuth win=HRIR_Coordinates#AzimuthPanel, value=V_Az
	Slider slider_Elevation win=HRIR_Coordinates#AzimuthPanel, value=V_El
	
	Variable Index = V_Index
	Variable AzElOffset = V_AzElOffset
	//Printf "Index= %d, Az= %.2f, El= %.2f, AzElOffset= %f\r" Index, Az, El, AzElOffset

	Variable distance = 1  // normalized radius
	// Coordinate Sizes
	wave SphericalCoordinateSizes = $dfStr+"SphericalCoordinateSizes"
	// Coordinate Colors
	wave SphericalCoordinateColors = $dfStr+"SphericalCoordinateColors"
	
	ModifyGizmo stopUpdates
	SphericalCoordinateSizes = 0.08
	SphericalCoordinateSizes[Index][] = 0.25
	ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter,property={ sizeType,1}
	ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter,property={ sizeWave, SphericalCoordinateSizes}
	
	SphericalCoordinateColors = 0.3
	SphericalCoordinateColors[Index][] = 0
	
	// Rotate to keep Coordinate in view
	// use to find Coordinates:
	//GetGizmo/N=HRIR_Coordinates curRotation; Printf "%g, %g, %g\r", GizmoEulerA, GizmoEulerB, GizmoEulerC
	if((Az <= 45 && Az >= -45) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={-90, -90, 0} 		// front
	elseif((Az <= 45 && Az >= -45) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={0, -40, -90} 		// front down
	elseif((Az <= 45 && Az >= -45) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={180, -40, 90} 		// front up
		
	elseif((Az > 45 && Az <= 90) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={-90, -40, 0} 		// right front
	elseif((Az > 45 && Az <= 90) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={0, -40, -90} 		// ?? right front down
	elseif((Az > 45 && Az <= 90) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={180, -40, 90} 		// ?? right front up
	
	elseif((Az > 90 && Az <= 135) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={-90, 0, 0} // right back
	elseif((Az > 90 && Az <= 135) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={-40, 0, 0} // right back down
	elseif((Az > 90 && Az <= 135) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={-135, 0, 0} // right back up
	
	elseif((Az < -45 && Az >= -90) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={90, -40, 180} // left front
	elseif((Az < -45 && Az >= -90) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={0, -40, -90} //  ?? left front down
	elseif((Az < -45 && Az >= -90) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={180, -40, 90} // ?? left front up
	
	elseif((Az < -90 && Az >= -135) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={90, 0, -180} // left back
	elseif((Az < -90 && Az >= -135) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={40, 0, 180} // left back down
	elseif((Az < -90 && Az >= -135) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={135, 0, 180} // left back up
	
	elseif((Az > 135 || Az < -135) && (El <= 45 && El >= -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={90, 90, -180} // back
	elseif((Az > 135 || Az <  -135) && (El > 45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={40, 0, 180}} // back down
	elseif((Az > 135 || Az < -135) && (El < -45))
		ModifyGizmo/N=HRIR_Coordinates ModifyObject=LocScatter,objectType=scatter, euler={180, 40, -90}} // back down
	endif
	ModifyGizmo resumeUpdates
	SetDataFolder saveDFR
End


Function SpHrView_IR_SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa
	Variable curval = sa.curval
	variable SigIndex//, DataSet
	strswitch( sa.ctrlName )
		case "slider_Azimuth": 
			switch( sa.eventCode )
				case -1: // control being killed
					break
				case 3: // Value set by mouse down
				case 9: // Value set by dragging the mouse or by arrow key
					SigIndex = NumberByKey("SigIndex", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					//DataSet = NumberByKey("DataSet", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"						// HRIR_Az[SigIndex]
					HRIR_Az[SigIndex] = curval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				default:
					break
			endswitch // sa.eventCode
			break
		case "slider_Elevation": 
			switch( sa.eventCode )
				case -1: // control being killed
					break
				case 3: // Value set by mouse down
				case 9: // Value set by dragging the mouse or by arrow key
					SigIndex = NumberByKey("SigIndex", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					//DataSet = NumberByKey("DataSet", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"						// HRIR_Az[SigIndex]
					HRIR_El[SigIndex] = curval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				default:
					break
			endswitch // sa.eventCode
			break
			
		case "slider_CuesFrequencyIndex":
			switch( sa.eventCode )
				case -1: // control being killed
					break
				case 3: // Value set by mouse down
				case 9: // Value set by dragging the mouse or by arrow key
					string winNameStr = ReplaceString("#FrequencyPanel", sa.win, "")
					NVAR FrequencyIndex = $SpHrView_HRIR_Cues_df+"FrequencyIndex"
					NVAR Frequency = $SpHrView_HRIR_Cues_df+"Frequency"
					FrequencyIndex = curval
					if(strsearch(sa.win,"Sphere",0) >= 0)
						SpHrView_CuesSphereWindowUpdate(FrequencyIndex)
					elseif(strsearch(sa.win,"Azimuth",0) >= 0)
						SpHrView_CuesAzimuthWindowUpdate(FrequencyIndex)
					endif
					break
				default:
					break
			endswitch // sa.eventCode
			break
	endswitch
End

Function SpHrView_IR_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	string str="", popupListStr="", suffixStr=""
	switch( ba.eventCode )
		case 1: // mouse down
			int index
			strswitch( ba.ctrlName )
				case "b_00":
					str = ba.win
					str = ReplaceString("#FrequencyPanel", str, "")
					ModifyGizmo/N=$str ModifyObject=CueSurface,objectType=surface euler={-90, -90, -180} // front
					break
				case "b_HRIRCues":
					SpHrView_HRIRCuesPopUp()
					break
					
				case "b_HRIRDataSetPopup_Noise1":
				case "b_HRIR_HPCFStrPopup_Noise1":
				case "b_BRIR_LocationPopup_Noise1":
				case "b_BRIR_SourcePopup_Noise1":
				case "b_BRIR_OptionPopup_Noise1":
					suffixStr = "Noise1"
					index = 1
					break
				case "b_HRIRDataSetPopup_Noise2":
				case "b_HRIR_HPCFStrPopup_Noise2":
				case "b_BRIR_LocationPopup_Noise2":
				case "b_BRIR_SourcePopup_Noise2":
				case "b_BRIR_OptionPopup_Noise2":
					suffixStr = "Noise2"
					index = 2
					break
				case "b_HRIRDataSetPopup_Tones":
				case "b_HRIR_HPCFStrPopup_Tones":
				case "b_BRIR_LocationPopup_Tones":
				case "b_BRIR_SourcePopup_Tones":
				case "b_BRIR_OptionPopup_Tones":
					suffixStr = "Tones"
					index = 3
					break
			endswitch
			
			strswitch( ba.ctrlName )
				case "b_play":
					SpHrView_SignalMakeSound(1)
					break
				case "b_make":
					SpHrView_SignalMakeSound(0)
					break
					
				case "b_HRIRDataSetPopup_Noise1":
				case "b_HRIRDataSetPopup_Noise2":
				case "b_HRIRDataSetPopup_Tones":
					wave/T HRIR_DataSet = $SpHrView_df_signalGlobals+"HRIR_DataSet"
					PopupContextualMenu "No HRIR;-;Display Locations;Display Cues;-;2° - NeumannKU100;360° microphone stand - NeumannKU100;360° full rotation mount - NeumannKU100;Lebedev 2354 - NeumannKU100;Lebedev 2702 - NeumannKU100;"
					if(V_flag>=1)
						strswitch(S_selection)
							case "Display Locations":
								SpHrView_HRIR_Displaylocations(index)
								break
							case "Display Cues":
								SpHrView_HRIRCuesPopUp()
								break
							default:
								HRIR_DataSet[index] = S_selection
								wave/T BRIR_Location = $SpHrView_df_signalGlobals+"BRIR_Location"
								BRIR_Location = "No BRIR"
								break
						endswitch
					endif
					
					wave/T HRIR_DataSet = $SpHrView_df_signalGlobals+"HRIR_DataSet"
					variable azInc = 2, elInc = 2
					variable elRange = 90
					// color selection if not "No HRIR"
					strswitch(HRIR_DataSet[index])
						case "2° - NeumannKU100":
						case "360° microphone stand - NeumannKU100":
						case "360° full rotation mount - NeumannKU100":
						case "Lebedev 2354 - NeumannKU100":
						case "Lebedev 2702 - NeumannKU100":
							// also have sv_HRIRDataSet_Tones !!
							ControlInfo /W=$ba.win $"sv_HRIRDataSet_Noise"+num2str(index)
							if(v_flag)
								SetVariable $"sv_HRIRDataSet_Noise"+num2str(index) win=$ba.win,valueBackColor=(2,39321,1,13107)
							endif
							break
						default:
							// also have sv_HRIRDataSet_Tones !!
							ControlInfo /W=$ba.win $"sv_HRIRDataSet_Noise"+num2str(index)
							if(v_flag)
								SetVariable $"sv_HRIRDataSet_Noise"+num2str(index) win=$ba.win,valueBackColor=(65535,65535,65535)
							endif
							break
					endswitch
					strswitch(HRIR_DataSet[index])
						case "2° - NeumannKU100":
							azInc = 2
							elInc = 2
							elRange = 90
							ControlInfo /W=$ba.win $"sv_HRIRDataSet_Noise"+num2str(index)
							if(v_flag)
								SetVariable $"sv_HRIRDataSet_Noise"+num2str(index) win=$ba.win,valueBackColor=(2,39321,1,13107)
							endif
							break
						case "360° microphone stand - NeumannKU100":
							azInc = 1
							elInc = 0
							elRange = 0
							break
						case "360° full rotation mount - NeumannKU100":
							azInc = 1
							elInc = 0
							elRange = 0
							break
						case "Lebedev 2354 - NeumannKU100":
							azInc = 5 // ?
							elInc = 5 // ?
							elRange = 90
							break
						case "Lebedev 2702 - NeumannKU100":
							azInc = 5 // ?
							elInc = 5 // ?
							elRange = 90
							break
						default:
							break
					endswitch
					SetVariable $"sv_HRIR_Az_"+suffixStr win=SpHrView_BinauralSignal_Window, limits={-180,180,azInc}
					SetVariable $"sv_HRIR_El_"+suffixStr win=SpHrView_BinauralSignal_Window, limits={-elRange,elRange,elInc}
					break
						
				case "b_BRIR_LocationPopup_Noise1":
				case "b_BRIR_LocationPopup_Noise2":
				case "b_BRIR_LocationPopup_Tones":
					wave/T BRIR_Location = $SpHrView_df_signalGlobals+"BRIR_Location"
					String BRIR_LocationListStr = "No BRIR;-;Control Room 1 - NeumannKU100;Control Room 7 - NeumannKU100;Small Broadcast Studio - NeumannKU100;Large Broadcast Studio - NeumannKU100;"
					if(DataFolderExists("root:SpHrView:Transfer:ImpulseWaves"))
						BRIR_LocationListStr += "-;Select BRIR wave;"
					endif
					PopupContextualMenu BRIR_LocationListStr
					if(V_flag>=1)
						BRIR_Location[index] = S_selection
						SpHrView_BRIR_Defaults(index)
						wave/T HRIR_DataSet = $SpHrView_df_signalGlobals+"HRIR_DataSet"
						HRIR_DataSet = "No HRIR"
						wave OffsetBuffers_sec = $SpHrView_df_signalGlobals+"OffsetBuffers_sec"
						strswitch(S_selection)
							case "Control Room 1 - NeumannKU100":
								OffsetBuffers_sec[1] = max(0.35,OffsetBuffers_sec[1])
								OffsetBuffers_sec[2] = max(0.35,OffsetBuffers_sec[2])
								OffsetBuffers_sec[3] = max(0.35,OffsetBuffers_sec[3])
								break
							case "Control Room 7 - NeumannKU100":
								OffsetBuffers_sec[1] = max(0.5,OffsetBuffers_sec[1])
								OffsetBuffers_sec[2] = max(0.5,OffsetBuffers_sec[2])
								OffsetBuffers_sec[3] = max(0.5,OffsetBuffers_sec[3])
								break
							case "Small Broadcast Studio - NeumannKU100":
								OffsetBuffers_sec[1] = max(1.6,OffsetBuffers_sec[1])
								OffsetBuffers_sec[2] = max(1.6,OffsetBuffers_sec[2])
								OffsetBuffers_sec[3] = max(1.6,OffsetBuffers_sec[3])
								break
							case "Large Broadcast Studio - NeumannKU100":
								OffsetBuffers_sec[1] = max(2.8,OffsetBuffers_sec[1])
								OffsetBuffers_sec[2] = max(2.8,OffsetBuffers_sec[2])
								OffsetBuffers_sec[3] = max(2.8,OffsetBuffers_sec[3])
								break
								
							case "Select BRIR wave":
							
								wave/T BRIR_Source = $SpHrView_df_signalGlobals+"BRIR_Source"
								BRIR_Source[index] = ""
								wave BRIR_Az = $SpHrView_df_signalGlobals+"BRIR_Az"
								BRIR_Az[index] = NaN
								wave/T BRIR_Option = $SpHrView_df_signalGlobals+"BRIR_Option"
								BRIR_Option[index] = "Select a wave"
								
								if(DataFolderExists("root:SpHrView:Transfer:ImpulseWaves"))
									DFREF saveDFR = GetDataFolderDFR()
									SetDataFolder $"root:SpHrView:Transfer:ImpulseWaves"
									popupListStr = WaveList("*",";","")
									PopupContextualMenu popupListStr
									if(V_flag>=1)
										BRIR_Option[index] = S_selection
									endif
									SetDataFolder saveDFR
								endif
								break
							
							default:
								popupListStr = ""
								break
						endswitch
						// color selection if not "No BRIR"
						strswitch(BRIR_Location[index])
							case "Control Room 1 - NeumannKU100":
							case "Control Room 7 - NeumannKU100":
							case "Small Broadcast Studio - NeumannKU100":
							case "Large Broadcast Studio - NeumannKU100":
							case "Select BRIR wave":
								// also have sv_BRIR_Location_Tones !!
								ControlInfo /W=$ba.win $"sv_BRIR_Location_Noise"+num2str(index)
								if(v_flag)
									SetVariable $"sv_BRIR_Location_Noise"+num2str(index) win=$ba.win,valueBackColor=(2,39321,1,13107)
								endif
								break
							default:
								// also have sv_BRIR_Location_Tones !!
								ControlInfo /W=$ba.win $"sv_BRIR_Location_Noise"+num2str(index)
								if(v_flag)
									SetVariable $"sv_BRIR_Location_Noise"+num2str(index) win=$ba.win,valueBackColor=(65535,65535,65535)
								endif
								break
						endswitch
					endif
					break
				case "b_BRIR_SourcePopup_Noise1":
				case "b_BRIR_SourcePopup_Noise2":
				case "b_BRIR_SourcePopup_Tones":
					wave/T BRIR_Source = $SpHrView_df_signalGlobals+"BRIR_Source"
					wave/T BRIR_Location = $SpHrView_df_signalGlobals+"BRIR_Location"
					str = BRIR_Location[index]
					strswitch(str)
						case "Control Room 1 - NeumannKU100":
							popupListStr = "Right - Genelec8260a;Left - Genelec8260a;"
							break
						case "Control Room 7 - NeumannKU100":
							popupListStr = "Right - B&W803D;Left - B&W803D;"
							break
						case "Small Broadcast Studio - NeumannKU100":
							popupListStr = "Center - Sonic Ball;Center - AD Systems;Right - AD Systems;Left - AD Systems;"
							break
						case "Large Broadcast Studio - NeumannKU100":
							popupListStr = "Center - Sonic Ball;Left - Sonic Ball;Center - AD Systems;Left - AD Systems;"
							break
						default:
							popupListStr = ""
							break
					endswitch
					PopupContextualMenu popupListStr
					if(V_flag>=1)
						BRIR_Source[index] = S_selection
					endif
					break
				case "b_BRIR_OptionPopup_Noise1":
				case "b_BRIR_OptionPopup_Noise2":
				case "b_BRIR_OptionPopup_Tones":
					wave/T BRIR_Option = $SpHrView_df_signalGlobals+"BRIR_Option"
					wave/T BRIR_Location = $SpHrView_df_signalGlobals+"BRIR_Location"
					str = BRIR_Location[index]
					strswitch(str)
						case "Control Room 1 - NeumannKU100":
						case "Control Room 7 - NeumannKU100":
						case "Small Broadcast Studio - NeumannKU100":
						case "Large Broadcast Studio - NeumannKU100":
							popupListStr = "Microphone stand;Rotation mount;"
							break
							
						case "Select BRIR wave":
							if(DataFolderExists("root:SpHrView:Transfer:ImpulseWaves"))
								DFREF saveDFR = GetDataFolderDFR()
								SetDataFolder $"root:SpHrView:Transfer:ImpulseWaves"
								popupListStr = WaveList("*",";","")
								SetDataFolder saveDFR
							endif
							break	
							
						default:
							popupListStr = ""
							break
					endswitch
					PopupContextualMenu popupListStr
					if(V_flag>=1)
						BRIR_Option[index] = S_selection
					endif
					break
					
				case "b_HRIR_HPCFStrPopup_Noise1":
				case "b_HRIR_HPCFStrPopup_Noise2":
				case "b_HRIR_HPCFStrPopup_Tones":
					wave/T HRIR_HPCFStr = $SpHrView_df_signalGlobals+"HRIR_HPCFStr"
						PopupContextualMenu HPFClistStr// "No headphone compensation;Beyerdynamic DT770;Beyerdynamic DT880;Beyerdynamic DT990;AudioTechnica ATH M50;Sennheiser HD430;"
						if(V_flag>=1)
							HRIR_HPCFStr[index] = S_selection
						endif
					break
			endswitch
	endswitch
End

Function SpHrView_BRIR_Defaults(int index)
	wave/T BRIR_Location = $SpHrView_df_signalGlobals+"BRIR_Location"
	wave/T BRIR_Option = $SpHrView_df_signalGlobals+"BRIR_Option"
	wave/T BRIR_Source = $SpHrView_df_signalGlobals+"BRIR_Source"
	string str = BRIR_Location[index]
	strswitch(str)
		case "Control Room 1 - NeumannKU100":
			BRIR_Source[index] = "Right - Genelec8260a"
			BRIR_Option[index] = "Microphone stand"
			break
		case "Control Room 7 - NeumannKU100":
			BRIR_Source[index] = "Right - B&W803D"
			BRIR_Option[index] = "Microphone stand"
			break
		case "Small Broadcast Studio - NeumannKU100":
			BRIR_Source[index] = "Center - Sonic Ball"
			BRIR_Option[index] = "Microphone stand"
			break
		case "Large Broadcast Studio - NeumannKU100":
			BRIR_Source[index] = "Center - Sonic Ball"
			BRIR_Option[index] = "Microphone stand"
			break
		default:
			break
	endswitch

End

Function SpHrView_IR_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	variable down, forceUpdate=0
	switch( sva.eventCode )
		case 9: // mouse down
			down = 1
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			variable SigIndex
			if(sva.eventMod == 5)  // option key: Set to zero
				dval = 0
				forceUpdate=1
			elseif(sva.eventMod == 9)  // command key: Reverse sign
				dval = -dval
				forceUpdate=1
			elseif(down)
				return 0
			endif
			strswitch( sva.ctrlName )
				case "sv_Az":
					wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"
					SigIndex = NumberByKey("SigIndex", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					HRIR_Az[SigIndex] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_EL":
					wave HRIR_EL = $SpHrView_df_signalGlobals+"HRIR_EL"
					SigIndex = NumberByKey("SigIndex", GetUserData("HRIR_Coordinates", "", "HRIRlocationsData"))
					HRIR_EL[SigIndex] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
					
				case "sv_HRIR_Az_Noise1":
					wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"
					HRIR_Az[1] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_HRIR_El_Noise1":
					wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"
					HRIR_El[1] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_HRIR_Az_Noise2":
					wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"
					HRIR_Az[2] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_HRIR_El_Noise2":
					wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"
					HRIR_El[2] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_HRIR_Az_Tones":
					wave HRIR_Az = $SpHrView_df_signalGlobals+"HRIR_Az"
					HRIR_Az[3] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
				case "sv_HRIR_El_Tones":
					wave HRIR_El = $SpHrView_df_signalGlobals+"HRIR_El"
					HRIR_El[3] = dval
					SpHrView_HRIR_DisplaylocationsUpdate()
					break
					
				case "sv_BRIR_Az_Noise1":
					wave BRIR_Az = $SpHrView_df_signalGlobals+"BRIR_Az"
					BRIR_Az[1] = dval
					break
				case "sv_BRIR_Az_Noise2":
					wave BRIR_Az = $SpHrView_df_signalGlobals+"BRIR_Az"
					BRIR_Az[2] = dval
					break
				case "sv_BRIR_Az_Tones":
					wave BRIR_Az = $SpHrView_df_signalGlobals+"BRIR_Az"
					BRIR_Az[3] = dval
					break
					
				
			endswitch
			if(forceUpdate)	
				ControlUpdate/W=$sva.win $sva.ctrlName
			endif
	endswitch
End

Function SpHrView_IR_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			strswitch( cba.ctrlName )
				case "ck_unwrap":
				case "ck_getIREnvelopes":
					strswitch( cba.win )
						case "ITD_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("ITD")
							break
						case "IPD_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("IPD")
							break
						case "ILD_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("ILD")
							break
						case "ABL_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("ABL")
							break
						case "MagL_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("MagL")
							break
						case "MagR_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("MagR")
							break
						case "PhiL_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("PhiL")
							break
						case "PhiR_Sphere#FrequencyPanel":
							SpHrView_CuesSphereWindow("PhiR")
							break
						
						case "ITD_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("ITD")
							break
						case "IPD_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("IPD")
							break
						case "ILD_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("ILD")
							break
						case "ABL_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("ABL")
							break
						case "MagL_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("MagL")
							break
						case "MagR_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("MagR")
							break
						case "PhiL_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("PhiL")
							break
						case "PhiR_Azimuth#FrequencyPanel":
							SpHrView_CuesAzimuthWindow("PhiR")
							break
				endswitch
				break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End



Function SpHrView_CuesSphereWindow( String cuesStr)
	DFREF saveDFR = GetDataFolderDFR()
	
	SpHrView_FilterDefaults()
	SpHrView_CenterFrequencies()
	wave CFs = $SpHrView_df_filter+"CFs"

	// Defaults
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_df_signals))
		FolderStr= SpHrView_df_signals[0,strlen(SpHrView_df_signals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals:HRIR" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_HRIR_df))
		FolderStr= SpHrView_HRIR_df[0,strlen(SpHrView_HRIR_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals:HRIR:Cues" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_HRIR_Cues_df))
		FolderStr= SpHrView_HRIR_Cues_df[0,strlen(SpHrView_HRIR_Cues_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_HRIR_Cues_df
	
	variable nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"FrequencyIndex", round(numpnts(CFs)/2	))
	variable/G FrequencyIndex = nval
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"Frequency", CFs[FrequencyIndex])
	variable/G Frequency = nval	
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"unWrapPhase", 1)
	variable/G unWrapPhase = nval	
	
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"getEnvelopes", 0)
	variable/G getEnvelopes = nval	
	// end defaults
	
	String winTitleStr = cuesStr
	String winStr = winTitleStr+"_Sphere"
	winStr = cleanupName(winStr,0)
	//killwindow/Z $winStr
	DoWindow $winStr
	if(v_flag)
		RemoveFromGizmo/Z /N=$winStr object= CueSurface
		RemoveFromGizmo/Z /N=$winStr object= scatterAxes
	else
		variable winCnt = SpHrView_CountGroupWindows("HRIRCuesWin")
		variable winWidth = 350
		variable winHeight = 350
		variable winLeft = 340
		variable winTop = 250
		
		NewGizmo/K=1/W=(winLeft+(winCnt*winWidth), winTop, winLeft+((winCnt+1)*winWidth), winTop+winHeight)/T=winTitleStr/N=$winStr
		
		ExternalControlPanel(winStr, "FrequencyPanel", "", 3, 43, 2, -1,-1,-1,-1)
		variable top = 5
		TitleBox t_View title="View",pos={15, top+3},frame=0
		Button b_HRIRCues title="",picture= ProcGlobal#SpHrView_pict_PopUpList,pos={40,top},size={14,15},fSize=10,proc=SpHrView_IR_ButtonProc
		strswitch(cuesStr)
			case "ITD":
			case "IPD":
			case "PhiL":
			case "PhiR":
				CheckBox ck_unwrap win=$winStr+"#FrequencyPanel",fSize=9, title="unwrap φ",pos={135,top},variable=unWrapPhase, proc=SpHrView_IR_CheckProc, help={"unwrap phase measures"}
				break	
		endswitch
		CheckBox ck_getIREnvelopes win=$winStr+"#FrequencyPanel", fSize=9,title="IR envelopes",pos={205, top},variable=getEnvelopes, proc=SpHrView_IR_CheckProc

		Button b_00 title="0°,0°",pos={300,2},size={35,20},fSize=9,proc=SpHrView_IR_ButtonProc
		
		top = 25
		SetVariable sv_Frequency win=$winStr+"#FrequencyPanel", title="Frequency (Hz)",pos={10,top},size={110,20},noedit=1,value=Frequency,limits={-inf,inf,0}
		Slider slider_CuesFrequencyIndex win=$winStr+"#FrequencyPanel", pos={130,top+2},size={200,20},vert=0,side=0,proc=SpHrView_IR_SliderProc
		Slider slider_CuesFrequencyIndex win=$winStr+"#FrequencyPanel", limits={0,numpnts(CFs)-1,1},value= FrequencyIndex
	endif
	
	// sphere shape data
	SpHrView_CuesSphereShapeData(SpHrView_HRIR_Cues_df, "SphereToBeSurfaced", 180, 88, 180, 89, 1 )
	wave SphereToBeSurfaced = $SpHrView_HRIR_Cues_df+"SphereToBeSurfaced"	
	
	string ColorTableStr = "RedWhiteBlue"
	variable CTmin, CTmax, CTreverse = 1
	string unitsStr =""
	
	strswitch(cuesStr)
		case "ITD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ITD={ITDs, unWrapPhase} DataSet=1
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={ITDs, FrequencyIndex, ColorTableStr, CTreverse, ITDSurfaceColors, -0.001, 0.001}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ITD (s)"
			if(max(CTmax,-CTmin) < 0.1)
				CTmin *= 1000
				CTmax *= 1000
				unitsStr = "ITD (ms)"
			elseif(max(CTmax,-CTmin) < 0.001)
				CTmin *= 1000*1000
				CTmax *= 1000*1000
				unitsStr = "ITD (µs)"
			endif
			wave SurfaceColors = ITDSurfaceColors
			break
			
		case "IPD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /IPD={IPDs, unWrapPhase} DataSet=1
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={IPDs, FrequencyIndex, ColorTableStr, CTreverse, IPDSurfaceColors, -1, 1}
			CTmin = V_min; CTmax = V_max
			unitsStr = "IPD (cycles)"
			wave SurfaceColors = IPDSurfaceColors
			break
			
		case "ILD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ILD=ILDs DataSet=1
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={ILDs, FrequencyIndex, ColorTableStr, CTreverse, ILDSurfaceColors, -24, 24}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ILD (dB)"

			wave SurfaceColors = ILDSurfaceColors
			break
			
		case "ABL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ABL=ABLs DataSet=1
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={ABLs, FrequencyIndex, ColorTableStr, CTreverse, ABLSurfaceColors, 2}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ABL (dB)"
			wave SurfaceColors = ABLSurfaceColors
			break
						
		case "MagL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /MagL=MagLs DataSet=1
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={MagLs, FrequencyIndex, ColorTableStr, CTreverse, MagLSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Mag left (dB)"
			wave SurfaceColors = MagLSurfaceColors
			break
		case "MagR":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /MagR=MagRs DataSet=1
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={MagRs, FrequencyIndex, ColorTableStr, CTreverse, MagRSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Mag left (dB)"
			wave SurfaceColors = MagRSurfaceColors
			break
			
		case "PhiL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /PhiL={PhiLs, unWrapPhase} DataSet=1
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={PhiLs, FrequencyIndex, ColorTableStr, CTreverse, PhiLSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Phi left (dB)"
			wave SurfaceColors = PhiLSurfaceColors
			break
		case "PhiR":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /PhiR={PhiRs, unWrapPhase} DataSet=1
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={PhiRs, FrequencyIndex, ColorTableStr, CTreverse, PhiRSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Phi left (dB)"
			wave SurfaceColors = PhiRSurfaceColors
			break
			
	endswitch
	
	ModifyGizmo/N=$winStr stopUpdates
	AppendToGizmo/N=$winStr surface=SphereToBeSurfaced,name=CueSurface
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface,property={ lineColorType,0}
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface,property={ fillMode,2}
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface,property={ srcMode,4}

	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface,property={ surfaceColorType,3}
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface,property={ surfaceColorWave, SurfaceColors}
	ModifyGizmo/N=$winStr displayLastObject

	//ModifyGizmo/N=$winStr setOuterBox={-180,180,-90,90,-1,1}
	//ModifyGizmo/N=$winStr scalingOption=0	
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface, zoomFactor=.57
	ModifyGizmo/N=$winStr resumeUpdates
	
	ModifyGizmo/N=$winStr ModifyObject=CueSurface,objectType=surface euler={-90, -90, -180} // front
	
	SpHrView_CuesSphereLabels(SpHrView_HRIR_Cues_df, winStr)
	ModifyGizmo autoScale
	
	ColorScale /W=$winStr/C/N=SphereColorScale/F=0/B=1/M/H={15,0,5}/A=RT/X=0/Y=-1.00 width=6,height=130,frame=0.00,lblMargin=35,tickLblRot=-90
	ColorScale /W=$winStr/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse},nticks=4,tickLen=3.00,tickThick=0.50,ZisZ=1,font="Arial",fsize=9
	ColorScale /W=$winStr/C/N=SphereColorScale unitsStr
	
	DoUpdate/W=$winStr // for Igor 9
	SetWindow $winStr, hook(HRIRCuesWindowHook)=SpHrView_HRIRCuesWindowHook
	SetWindow $winStr note="PACKAGE:SpHrView;GROUP:HRIRCuesWin"

	SetDataFolder saveDFR
end

Function SpHrView_CuesAzimuthWindow( String cuesStr)
	DFREF saveDFR = GetDataFolderDFR()
	
	SpHrView_FilterDefaults()
	SpHrView_CenterFrequencies()
	wave CFs = $SpHrView_df_filter+"CFs"

	// Defaults
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_df_signals))
		FolderStr= SpHrView_df_signals[0,strlen(SpHrView_df_signals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals:HRIR" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_HRIR_df))
		FolderStr= SpHrView_HRIR_df[0,strlen(SpHrView_HRIR_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:Signals:HRIR:Cues" folder, SpHrView_df_signals
	if(!DataFolderExists(SpHrView_HRIR_Cues_df))
		FolderStr= SpHrView_HRIR_Cues_df[0,strlen(SpHrView_HRIR_Cues_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_HRIR_Cues_df
	
		variable nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"FrequencyIndex", round(numpnts(CFs)/2	))
	variable/G FrequencyIndex = nval
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"Frequency", CFs[FrequencyIndex])
	variable/G Frequency = nval	
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"unWrapPhase", 1)
	variable/G unWrapPhase = nval	
	
	nval= NumVarOrDefault(SpHrView_HRIR_Cues_df+"getEnvelopes", 0)
	variable/G getEnvelopes = nval	
	// end defaults
	
	String winTitleStr = cuesStr
	String winStr = winTitleStr+"_Azimuth"
	winStr = cleanupName(winStr,0)
	//killwindow/Z $winStr
	DoWindow $winStr
	if(v_flag)
		RemoveTraces(winStr)
		RemoveImages(winStr)
	else
		variable winCnt = SpHrView_CountGroupWindows("HRIRCuesWin")
		variable winWidth = 350
		variable winHeight = 350
		variable winLeft = 340
		variable winTop = 250
		Display/K=1/W=(winLeft+(winCnt*winWidth), winTop, winLeft+((winCnt+1)*winWidth), winTop+winHeight)/T=winTitleStr/N=$winStr as winTitleStr
		ExternalControlPanel(winStr, "FrequencyPanel", "", 3, 43, 2, -1,-1,-1,-1)
		variable top = 4
		TitleBox t_View title="View",pos={15, top+3},frame=0
		Button b_HRIRCues title="",picture= ProcGlobal#SpHrView_pict_PopUpList,pos={40,top},size={14,15},fSize=10,proc=SpHrView_IR_ButtonProc
		strswitch(cuesStr)
			case "ITD":
			case "IPD":
			case "PhiL":
			case "PhiR":
				CheckBox ck_unwrap win=$winStr+"#FrequencyPanel", title="unwrap φ",pos={140, top},variable=unWrapPhase, proc=SpHrView_IR_CheckProc
				break	
		endswitch
		CheckBox ck_getIREnvelopes win=$winStr+"#FrequencyPanel", title="IR envelopes",pos={220, top},variable=getEnvelopes, proc=SpHrView_IR_CheckProc

//		Button b_00 title=" 0°, 0°",pos={305,top},size={35,20},fSize=10,proc=SpHrView_IR_ButtonProc
		top = 27
		SetVariable sv_Frequency win=$winStr+"#FrequencyPanel", title="Frequency (Hz)",pos={10,top-2},size={110,20},noedit=1,value=Frequency,limits={-inf,inf,0}
		Slider slider_CuesFrequencyIndex win=$winStr+"#FrequencyPanel", pos={130,top},size={200,20},vert=0,side=0,proc=SpHrView_IR_SliderProc
		Slider slider_CuesFrequencyIndex win=$winStr+"#FrequencyPanel", limits={0,numpnts(CFs)-1,1},value= FrequencyIndex
	endif
	
	string ColorTableStr = "RedWhiteBlue"
	variable CTmin, CTmax, CTreverse = 1
	string CuesWaveStr, unitsStr =""
	
	strswitch(cuesStr)
		case "ITD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ITD={ITDs, unWrapPhase}	 DataSet=2
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			CuesWaveStr = "ITDs"
			unitsStr = "ITD"
			break
			
		case "IPD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /IPD={IPDs, unWrapPhase}	 DataSet=2
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			CuesWaveStr = "IPDs"
			unitsStr = "IPD"
			break
			
		case "ILD":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ILD=ILDs DataSet=2
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			CuesWaveStr = "ILDs"
			unitsStr = "ILD"
			break
			
		case "ABL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /ABL=ABLs DataSet=2
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			CuesWaveStr = "ABLs"
			unitsStr = "ABL"
			break
			
		case "MagL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /MagL=MagLs DataSet=2
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			CuesWaveStr = "MagLs"
			unitsStr = "left magnitude"
			break
		case "MagR":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /MagR=MagRs DataSet=2
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			CuesWaveStr = "MagRs"
			unitsStr = "right magnitude"
			break
			
		case "PhiL":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /PhiL={PhiLs, unWrapPhase} DataSet=2
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			CuesWaveStr = "PhiLs"
			unitsStr = "left phase"
			break
		case "PhiR":
			SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=2048/Oct=24 /XWAV=CFs /PhiR={PhiRs, unWrapPhase} DataSet=2
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			CuesWaveStr = "PhiRs"
			unitsStr = "right phase"
			break
			
	endswitch
	
	AppendImage/W=$winStr $CuesWaveStr
	ModifyImage/W=$winStr  $CuesWaveStr ctab= {*,*,$ColorTableStr,CTreverse}
	AppendToGraph/W=$winStr /R $CuesWaveStr[][FrequencyIndex]
	ModifyGraph/W=$winStr margin(left)=36,margin(bottom)=36,margin(right)=36,margin(top)=10

	ModifyGraph/W=$winStr  lsize=0.5,rgb=(0,0,0)
	Label left "frequency (kHz)"
	Label bottom "azimuth (\\U)"
	Label right unitsStr+" (\\U)"
	SetAxis/A/N=0/E=2 right
	
	ModifyGraph/W=$winStr standoff=0,tick=2,fSize=10,font="Arial",axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,btLen=4,btThick=0.5,stLen=2,stThick=0.5,lblMargin=4
	ModifyGraph/W=$winStr userticks(left)={$SpHrView_df_filter+"CFs_TickVals", $SpHrView_df_filter+"CFs_TickTxt"}
	
	ModifyGraph/W=$winStr manTick(bottom)={0,45,0,0},manMinor(bottom)={0,50},mirror(bottom)=1
	
	DoUpdate/W=$winStr // for Igor 9
	SetWindow $winStr, hook(HRIRCuesWindowHook)=SpHrView_HRIRCuesWindowHook
	SetWindow $winStr note="PACKAGE:SpHrView;GROUP:HRIRCuesWin"


	SetDataFolder saveDFR
end

Function SpHrView_CuesAzimuthWindowUpdate(variable FrequencyIndex)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_HRIR_Cues_df
	wave CFs = $SpHrView_df_filter+"CFs"
	NVAR Frequency = $SpHrView_HRIR_Cues_df+"Frequency"
	Frequency = CFs[FrequencyIndex]
	
	DoWindow ITD_Azimuth
	if(v_flag)
	 	wave ITDs=ITDs
	 	if(waveexists(ITDs))
	 		ReplaceWave/W=ITD_Azimuth trace=ITDs, ITDs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"ITD_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow IPD_Azimuth
	if(v_flag)
	 	wave IPDs=IPDs
	 	if(waveexists(IPDs))
	 		ReplaceWave/W=IPD_Azimuth trace=IPDs, IPDs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"IPD_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow ILD_Azimuth
	if(v_flag)
	 	wave ILDs=ILDs
	 	if(waveexists(ILDs))
	 		ReplaceWave/W=ILD_Azimuth trace=ILDs, ILDs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"ILD_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow ABL_Azimuth
	if(v_flag)
	 	wave ABLs=ABLs
	 	if(waveexists(ABLs))
	 		ReplaceWave/W=ABL_Azimuth trace=ABLs, ABLs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"ABL_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow MagL_Azimuth
	if(v_flag)
	 	wave MagLs=MagLs
	 	if(waveexists(MagLs))
	 		ReplaceWave/W=MagL_Azimuth trace=MagLs, MagLs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"MagL_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow MagR_Azimuth
	if(v_flag)
	 	wave MagRs=MagRs
	 	if(waveexists(MagRs))
	 		ReplaceWave/W=MagR_Azimuth trace=MagRs, MagRs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"MagR_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow PhiL_Azimuth
	if(v_flag)
	 	wave PhiLs=PhiLs
	 	if(waveexists(PhiLs))
	 		ReplaceWave/W=PhiL_Azimuth trace=PhiLs, PhiLs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"PhiL_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	DoWindow PhiR_Azimuth
	if(v_flag)
	 	wave PhiRs=PhiRs
	 	if(waveexists(PhiRs))
	 		ReplaceWave/W=PhiR_Azimuth trace=PhiRs, PhiRs[][FrequencyIndex]
	 		Slider slider_CuesFrequencyIndex win=$"PhiR_Azimuth"+"#FrequencyPanel", value= FrequencyIndex
	 	endif
	endif
	
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_HRIRCuesWindowHook(s), Window hook for HRIR cues sphere windows
// =================================================================================================
Function SpHrView_HRIRCuesWindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0	
	switch(s.eventCode)
		//////////////
		// deactivate
		case 1:
			strswitch(s.winName)
				case "":
					break
			endswitch
			break
			
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			strswitch(s.winName)
				case "":
					break
				endswitch
			break
			
		//////////////
		// kill event
		case 2:
			//Printf "-%s-", s.winName
			strswitch(s.winName)					
				case "ITD_Sphere":
				case "IPD_Sphere":
				case "ILD_Sphere":
				case "ABL_Sphere":
				case "MagL_Sphere":
				case "MagR_Sphere":
				case "PhiL_Sphere":
				case "PhiR_Sphere":
					KillWindow/Z $s.winName
					variable winCnt = SpHrView_CountGroupWindows("HRIRCuesWin")
					if(winCnt<=0) //  if(winCnt<=1) if not calling KillWindow/Z $s.winName beforehand
						Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_HRIR_Cues_df[0,strlen(SpHrView_HRIR_Cues_df)-2]+"\")" // remove trailing ":"
					endif
					hookResult = 1
					break
			endswitch
			break
	endswitch
	return hookResult
End

Function SpHrView_CuesSphereWindowUpdate(variable FrequencyIndex)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_HRIR_Cues_df
	wave CFs = $SpHrView_df_filter+"CFs"
	NVAR Frequency = $SpHrView_HRIR_Cues_df+"Frequency"
	Frequency = CFs[FrequencyIndex]
	variable CTmin, CTmax, CTreverse
	string unitsStr, ColorTableStr
	DoWindow ITD_Sphere
	if(v_flag)
	 	wave ITDs=ITDs
	 	if(waveexists(ITDs))
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={ITDs, FrequencyIndex, ColorTableStr, CTreverse, ITDSurfaceColors, -0.001, 0.001}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ITD (s)"
			if(max(CTmax,-CTmin) < 0.1)
				CTmin *= 1000
				CTmax *= 1000
				unitsStr = "ITD (ms)"
			elseif(max(CTmax,-CTmin) < 0.001)
				CTmin *= 1000*1000
				CTmax *= 1000*1000
				unitsStr = "ITD (µs)"
			endif
			ColorScale /W=ITD_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"ITD_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	DoWindow IPD_Sphere
	if(v_flag)
	 	wave IPDs=IPDs
	 	if(waveexists(IPDs))
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={IPDs, FrequencyIndex, ColorTableStr, CTreverse, IPDSurfaceColors, -1, 1}
			CTmin = V_min; CTmax = V_max
			unitsStr = "IPD (cycles)"
			ColorScale /W=IPD_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"IPD_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	DoWindow ILD_Sphere
	if(v_flag)
		wave ILDs=ILDs
	 	if(waveexists(ILDs))
			ColorTableStr = "RedWhiteBlue"
			CTreverse = 1
			SpHr_HRIRMeasures ColorsWave={ILDs, FrequencyIndex, ColorTableStr, CTreverse, ILDSurfaceColors, -24, 24}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ILD (dB)"
			ColorScale /W=ILD_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"ILD_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	DoWindow ABL_Sphere
	if(v_flag)
		wave ABLs=ABLs
	 	if(waveexists(ABLs))
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={ABLs, FrequencyIndex, ColorTableStr, CTreverse, ABLSurfaceColors, 2}
			CTmin = V_min; CTmax = V_max
			unitsStr = "ABL (dB)"
			ColorScale /W=ABL_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"ABL_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	
	DoWindow MagL_Sphere
	if(v_flag)
		wave MagLs=MagLs
	 	if(waveexists(MagLs))
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={MagLs, FrequencyIndex, ColorTableStr, CTreverse, MagLSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Mag left (dB)"
			ColorScale /W=MagL_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"MagL_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	DoWindow MagR_Sphere
	if(v_flag)
		wave MagRs=MagRs
	 	if(waveexists(MagRs))
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={MagRs, FrequencyIndex, ColorTableStr, CTreverse, MagRSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Mag left (dB)"
			ColorScale /W=MagR_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"MagR_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
		
	DoWindow PhiL_Sphere
	if(v_flag)
		wave PhiLs=PhiLs
	 	if(waveexists(PhiLs))
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={PhiLs, FrequencyIndex, ColorTableStr, CTreverse, PhiLSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Phi left (dB)"
			ColorScale /W=PhiL_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"PhiL_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	DoWindow PhiR_Sphere
	if(v_flag)
		wave PhiRs=PhiRs
	 	if(waveexists(PhiRs))
			ColorTableStr = "SeaLandAndFire"
			CTreverse = 0
			SpHr_HRIRMeasures ColorsWave={PhiRs, FrequencyIndex, ColorTableStr, CTreverse, PhiRSurfaceColors, 0}
			CTmin = V_min; CTmax = V_max
			unitsStr = "Phi left (dB)"
			ColorScale /W=PhiR_Sphere/C/N=SphereColorScale ctab={CTmin,CTmax,$ColorTableStr,CTreverse} unitsStr
			Slider slider_CuesFrequencyIndex win=$"PhiR_Sphere"+"#FrequencyPanel", value= FrequencyIndex
		endif
	endif
	SetDataFolder saveDFR
End

// Generate sphere to be surface
// SpHrView_CuesSphereShapeData(dfStr, "SphereToBeSurfaced", 180, 180/2, 180, 90, 1 )
Function SpHrView_CuesSphereShapeData(dfStr, wStr, Xpnts, Ypnts, Xrange, Yrange, Zrange)
	String dfStr, wStr
	Variable Xpnts, Ypnts, Xrange, Yrange, Zrange
	Variable i,j,rad
	Make/O/n=(Xpnts,Ypnts,3) $dfStr+wStr
	wave sphereData=$dfStr+wStr
	Variable anglePhi,angleTheta
	Variable dPhi,dTheta
	dPhi=2*pi/(Xpnts-1)
	dTheta=pi/(Ypnts-1)
	Variable xx,yy,zz
	Variable sig
	for(j=0;j<Ypnts;j+=1)
		angleTheta=j*dTheta
		zz=sin(angleTheta)
		if(angleTheta>pi/2)
			sig=-1
		else
			sig=1
		endif
		for(i=0;i<Xpnts;i+=1)
			anglePhi=i*dPhi
			xx=zz*cos(anglePhi)
			yy=zz*sin(anglePhi)
			sphereData[i][j][0]=xx * Xrange
			sphereData[i][j][1]=yy * Yrange
			sphereData[i][j][2]=sig*sqrt(1-xx*xx-yy*yy) * Zrange
		endfor
	endfor
End

Function SpHrView_CuesSphereLabels(String dfStr, String winStr)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $dfStr
	// Coordinate labels
	wave/Z/T AxesLabels=AxesLabels
	if(!waveexists(AxesLabels))
		Make/O/N=6 AxesAzimuths, AxesElevations, AxesRadii
		Make/T/O/N=6 AxesLabels
		AxesElevations = 0
		AxesElevations[4] = -pi/2
		AxesElevations[5] = pi/2
		AxesAzimuths[0] = 0
		AxesAzimuths[1] = pi/2
		AxesAzimuths[2] = pi
		AxesAzimuths[3] = pi + pi/2
		AxesAzimuths[4] = 0
		AxesAzimuths[5] = 0
		AxesRadii[0] = 1.2
		AxesRadii[1] = 0.6
		AxesRadii[2] = 1.2
		AxesRadii[3] = 0.6
		AxesRadii[4] = 0.0064
		AxesRadii[5] = 0.0064
		AxesLabels[0] = "0°,0°"
		AxesLabels[1] = "90°,0°"
		AxesLabels[2] = "180°,0°"
		AxesLabels[3] = "-90°,0°"
		AxesLabels[4] = "0°,90°"
		AxesLabels[5] = "0°,-90°"
	endif
	// Coordinates
	wave/Z AxisLabelCoordinates=AxisLabelCoordinates
	if(!waveexists(AxisLabelCoordinates))
		Make/O/N=(dimsize(AxesAzimuths,0),3) AxisLabelCoordinates
		AxisLabelCoordinates[][0] = AxesRadii[p] * cos(AxesElevations[p]) * cos(-AxesAzimuths[p])
		AxisLabelCoordinates[][1] = AxesRadii[p] * cos(AxesElevations[p]) * sin(-AxesAzimuths[p])
		AxisLabelCoordinates[][2] = AxesRadii[p] * sin(AxesElevations[p])
		AxisLabelCoordinates *= 180
		killwaves AxesAzimuths, AxesElevations, AxesRadii
	endif
	SetDataFolder saveDFR
	AppendToGizmo/N=$winStr scatter=AxisLabelCoordinates,name=scatterAxes
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ scatterColorType,0}
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ color,0,0,0,1}
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ sizeType,0}
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ size,0.8}
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ Shape,8}
	ModifyGizmo/N=$winStr ModifyObject=scatterAxes,objectType=scatter,property={ TextWave,AxesLabels}
	ModifyGizmo/N=$winStr displayLastObject

End


Function SpHrView_HRIR_EquationForITD2Az()
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_HRIR_Cues_df
	variable DataSet = 2
	variable DFTpnts = 2048, numLogHz = 30
	variable getEnvelopes = 1
	SpHr_HRIRMeasures /Env=(getEnvelopes) /Pnts=(2048)/Oct=24/Xlog={numLogHz,logHz} /ITD={ITDs,1} DataSet=(dataset)
	wave logHz=logHz
	int useWts = 1
	
	Make/O/N=(numLogHz) Amplitudes
	SetScale d, 0, 0, "°", Amplitudes
	if(useWts)
		Make/O/N=(dimsize(ITDs,0)) Wts
		SetScale/I x, -1, 1, "", Wts
		Wts = abs(sin(x*pi)^2)
		//Wts = abs(cos(x*pi)^2)
	else
		Make/O/N=(numLogHz) Confidence = NaN
	endif
	K0 = 0;K3 = 0;
	k2 = (pi*2)/360
	variable i
	for(i=0;i<numLogHz;++i)
		MatrixOp/O/S/FREE selectITDs = col(ITDs, i) 	// can make /FREE
		copyscales ITDs, selectITDs
		
		if(0) // limit Azimuths to forward direction 
			selectITDs = (x < -90 || x > 90) ? NaN : selectITDs
		elseif(0) // limit Azimuths to backward direction 
			selectITDs = (x > -90 && x < 90) ? NaN : selectITDs
		endif
		
		if(useWts)
			CurveFit/Q/W=2/B=180 /H="1011" sin selectITDs /W=Wts
			wave W_coef=W_coef
			Amplitudes[i] = W_coef[1] 	// amplitude
		else
			CurveFit/Q/W=2/B=180 /H="1011" sin selectITDs
			wave W_coef=W_coef
			Amplitudes[i] = W_coef[1] 	// amplitude
			wave W_sigma=W_sigma
			Confidence[i] = W_sigma[1] // Confidence
		endif
	endfor
	//killwaves/Z W_coef, W_sigma
	
	DoWindow MaximumAzimuth
	if(!v_flag)
		Display /K=1/W=(200,300,200+500,300+200) Amplitudes vs logHz as "Maximum Azimuth"
		DoWindow/C MaximumAzimuth
		ModifyGraph mode=4,marker=8,rgb=(0,0,0),msize=2,opaque=1,lsize=0.5
		ModifyGraph grid(left)=1,log(bottom)=1,loglinear(bottom)=1
		ModifyGraph tick=2,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial",lblMargin=5
		Label left "maximum azimuth (\\U)"
		Label bottom "frequency"
	endif
	
	String nb = "NeumannKU100_maximum_azimuths"
	killwindow/Z $nb
	NewNotebook/N=$nb/K=1/F=0/W=(200,50,200+600,50+200) as "NeumannKU100 maximum azimuths"
	Notebook $nb text= "copy/paste code\r\r"
	if(getEnvelopes)
		Notebook $nb text= "const CountInt NeumannKU100_Envelope_IPDtoAzimuthNumRows = 30;\r"
		Notebook $nb text= "const float NeumannKU100_Envelope_IPDtoAzimuthScales[60] = {"
	else
		Notebook $nb text= "const CountInt NeumannKU100_Carrier_IPDtoAzimuthNumRows = 30;\r"
		Notebook $nb text= "const float NeumannKU100_Carrier_IPDtoAzimuthScales[60] = {"
	endif
	for(i=0;i<numLogHz;++i)
		Notebook $nb text= num2istr(Amplitudes[i]*1000*1000)+","
	endfor
	for(i=0;i<numLogHz;++i)
		Notebook $nb text= num2istr(logHz[i])+","
	endfor
	Notebook $nb findText={",", 16 } // remove last ","
	Notebook $nb text= "};"
	Notebook $nb selection={startOfPrevParagraph,endOfChars}
	
	SetDataFolder saveDFR
End

Function SpHrView_EquationCheckForITD2Az(variable Hz)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_HRIR_Cues_df
	wave ITDs = ITDs, logHz = logHz
	int64 numHz = numpnts(logHz)
	variable index
	if(Hz > wavemax(logHz))
		index = numHz-1
	elseif(Hz < wavemin(logHz))
		index = 0
	else
		index = round(binarySearchInterp(logHz,Hz))
	endif
	wave Amplitudes = Amplitudes
	Make/O/N=(151) $"fit_Hz"+num2istr(logHz[index])
	wave fit = $"fit_Hz"+num2istr(logHz[index])
	SetScale/I x, -180, 180, "°", fit
	variable pi2Over360 = (pi*2)/360
	fit = Amplitudes[index] * sin(pi2Over360*x)
	
	string ITDsStr = "Hz"+num2istr(logHz[index])
	KillWindow/Z ITDs_FitWindow
	Display/K=1/W=(300,300,300+800,300+400) ITDs[][index] /TN=$ITDsStr as "ITDs Fit"
	DoWindow/C ITDs_FitWindow
	// SpHr_ColorTable/R=(ReverseColorTable)/RGB={i, minIndex, maxIndex}	ColorTable
	// (V_R,V_G,V_B,V_A)
	ModifyGraph rgb($ITDsStr)=(65535,0,0)
	ModifyGraph marker($ITDsStr)=8,mode($ITDsStr)=3,msize($ITDsStr)=1.5
	string fitStr = "fit_Hz"+num2istr(logHz[index])
	AppendToGraph fit
	ModifyGraph marker($fitStr)=19,msize($fitStr)=1.5,rgb($fitStr)=(0,0,0)
	ModifyGraph mode=3,lsize=0.5
	ModifyGraph tick=2,zero=1,fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4,btThick=0.5,stLen=2,stThick=0.5,font="Arial",lblMargin=5
	Label left "ITD (\\U)"
	Label bottom "azimuth (\\U)"
	SetAxis/A left
	ModifyGraph manTick(bottom)={0,45,0,0},manMinor(bottom)={0,50}
	Legend/C/N=text0/J/A=LT/F=0/M=0/H={15,0,5}/B=1/X=10.00/Y=0.00 "\\s("+ITDsStr+") "+num2istr(logHz[index])+"\r\\s("+fitStr+") fit"
	SetDataFolder saveDFR
End


function SpHrView_HRIRCuesPopUp()
	PopupContextualMenu "ITD Sphere;IPD Sphere;ILD Sphere;ABL Sphere;Left Magnitude Sphere;Right Magnitude Sphere;Left Phase Sphere;Right Phase Sphere;-;ITD Azimuth;IPD Azimuth;ILD Azimuth;ABL Azimuth;Left Magnitude Azimuth;Right Magnitude Azimuth;Left Phase Azimuth;Right Phase Azimuth;"
	if(V_flag>0)
		strswitch(S_selection)
			case "ITD Sphere":
				SpHrView_CuesSphereWindow("ITD")
				Break
			case "IPD Sphere":
				SpHrView_CuesSphereWindow("IPD")
				Break
			case "ILD Sphere":
				SpHrView_CuesSphereWindow("ILD")
				Break
			case "ABL Sphere":
				SpHrView_CuesSphereWindow("ABL")
				Break
			case "Left Magnitude Sphere":
				SpHrView_CuesSphereWindow("MagL")
				Break
			case "Right Magnitude Sphere":
				SpHrView_CuesSphereWindow("MagR")
				Break
			case "Left Phase Sphere":
				SpHrView_CuesSphereWindow("PhiL")
				Break
			case "Right Phase Sphere":
				SpHrView_CuesSphereWindow("PhiR")
				Break
			
			case "ITD Azimuth":
				SpHrView_CuesAzimuthWindow("ITD")
				Break
			case "IPD Azimuth":
				SpHrView_CuesAzimuthWindow("IPD")
				Break
			case "ILD Azimuth":
				SpHrView_CuesAzimuthWindow("ILD")
				Break
			case "ABL Azimuth":
				SpHrView_CuesAzimuthWindow("ABL")
				Break
			case "Left Magnitude Azimuth":
				SpHrView_CuesAzimuthWindow("MagL")
				Break
			case "Right Magnitude Azimuth":
				SpHrView_CuesAzimuthWindow("MagR")
				Break
			case "Left Phase Azimuth":
				SpHrView_CuesAzimuthWindow("PhiL")
				Break
			case "Right Phase Azimuth":
				SpHrView_CuesAzimuthWindow("PhiR")
				Break
		endswitch
	endif
	
End