﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// SpHrView_Realtime

strconstant SpHrView_df_realtime = "root:SpHrView:Realtime:"
strconstant SpHrView_df_realtime_globals = "root:SpHrView:Realtime:Globals:"


function SpHrView_Realtime_Init()
	//variable rt_Mode
	DFREF saveDFR = GetDataFolderDFR()
	Variable nval
	String sval, FolderStr
	if(!DataFolderExists(SpHrView_df))	// Make "SpHrView" folder if it doesn't exist
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	if(!DataFolderExists(SpHrView_df_realtime))	// Make "SpHrView:Realtime" folder if it doesn't exist
		FolderStr= SpHrView_df_realtime[0,strlen(SpHrView_df_realtime)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_realtime
	// init global variables and FIFO2Wave waves
	if(!DataFolderExists(SpHrView_df_realtime_globals))	// Make "SpHrView:Realtime:Globals" folder and global variables
		FolderStr= SpHrView_df_realtime_globals[0,strlen(SpHrView_df_realtime_globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_realtime_globals
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"Snd_fs", 48000)
	Variable/G Snd_fs = nval
	QuerySoundManager(SpHrView_df_realtime+"Globals") // no trailing ":"	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"doFIFO", 0)
	Variable/G doFIFO = nval
	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"framePnts", SpHr_DFTClosestSize(8192,2)) // closest DFT-compatible size
	Variable/G framePnts = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"frameDurationMS", (framePnts/Snd_fs)*1000) // closest DFT-compatible duration
	Variable/G frameDurationMS = nval
	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"desiredFPS", 10)
	Variable/G desiredFPS = nval
	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"RecChs_12_Only", 1)
	Variable/G RecChs_12_Only = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"RecChs_34_as_12", 1)
	Variable/G RecChs_34_as_12 = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"useChs34", 0)
	Variable/G useChs34 = nval
	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"spectraOctaveDenom", 24)
	Variable/G spectraOctaveDenom = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"spectraFramePnts", 4096)
	Variable/G spectraFramePnts = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"spectraCnt", 0)
	Variable/G spectraCnt = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"spectraAvgHold", 0)
	Variable/G spectraAvgHold = nval
	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITD_CF", 1000)
	Variable/G ITD_CF = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_Type", 0)
	Variable/G ITDdist_Type = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_CPC", 2)
	Variable/G ITDdist_CPC = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_MinHz", 100)
	Variable/G ITDdist_MinHz = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_MaxHz", 2000)
	Variable/G ITDdist_MaxHz = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_RangeMS", 1) // ms
	Variable/G ITDdist_RangeMS = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_NumBins", 500)
	Variable/G ITDdist_NumBins = nval
		nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_Smooth", 0)
	Variable/G ITDdist_Smooth = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ITDdist_Norm", 1)
	Variable/G ITDdist_Norm = nval

	
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILD_CF", 1000)
	Variable/G ILD_CF = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_Type", 0)
	Variable/G ILDdist_Type = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_CPC", 2)
	Variable/G ILDdist_CPC = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_MinHz", 500)
	Variable/G ILDdist_MinHz = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_MaxHz", 5000)
	Variable/G ILDdist_MaxHz = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_RangeMS", 24) // dB
	Variable/G ILDdist_RangeMS = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_NumBins", 500)
	Variable/G ILDdist_NumBins = nval
		nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_Smooth", 0)
	Variable/G ILDdist_Smooth = nval
	nval = NumVarOrDefault(SpHrView_df_realtime_globals+"ILDdist_Norm", 1)
	Variable/G ILDdist_Norm = nval

	Variable/G lastWaveChunk= framePnts
	Variable/G FIFOFrameCnt= 0
	Variable/G recFrameNumber = 0
			
	string infoStr= IgorInfo(0)
	//variable numScreens = NumberByKey("NSCREENS", infoStr)	// Number of active displays
	string screenInfo = StringByKey("SCREEN1", infoStr)	// Number of active displays
	variable/G screenVert = str2num(ParseFilePath(0, screenInfo, ",", 1, 0))
	variable/G screenHoriz = str2num(ParseFilePath(0, screenInfo, ",", 1, 1))
	
	SetDataFolder saveDFR
end

function SpHrView_Realtime_FIFO_Start()
	if(strlen(GetBrowserSelection(-1))>1)
		ModifyBrowser clearSelection
	endif
	FIFOStatus/Q FIFO_Realtime
	if( V_FLag )
		KillFIFO FIFO_Realtime
		DoUpdate
	endif
	SpHrView_Realtime_MakeSndWaves()
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	wave Snd_ch1=$SpHrView_df_realtime+"Snd_ch1"
	//wave Snd_ch2=$SpHrView_df_realtime+"Snd_ch2"
	NVAR Snd_fs= $SpHrView_df_realtime_globals+"Snd_fs"
	NVAR desiredFPS = $SpHrView_df_realtime_globals+"desiredFPS"
	NVAR lastWaveChunk = $SpHrView_df_realtime_globals+"lastWaveChunk";	lastWaveChunk = numpnts(Snd_ch1)
	NVAR FIFOFrameCnt = $SpHrView_df_realtime_globals+"FIFOFrameCnt"; 		FIFOFrameCnt = 0
	//NVAR bufferUsage = $SpHrView_df_realtime_globals+"bufferUsage"; 		bufferUsage = 0
	NVAR recFrameNumber= $SpHrView_df_realtime_globals+"recFrameNumber";	recFrameNumber = 0
	NVAR doFIFO= $SpHrView_df_realtime_globals+"doFIFO";		doFIFO = 0
	
	NewFIFO FIFO_Realtime
	NewFIFOChan/S FIFO_Realtime,ch1  0,1,-1,1,"Pa"
	if(SoundInChannels>1)
		NewFIFOChan/S FIFO_Realtime,ch2  0,1,-1,1,"Pa"
	endif
	if(SoundInChannels>2)
		NewFIFOChan/S FIFO_Realtime,ch3  0,1,-1,1,"Pa"	
	endif
	if(SoundInChannels>3)
		NewFIFOChan/S FIFO_Realtime,ch4  0,1,-1,1,"Pa"
	endif
	NVAR framePnts = $SpHrView_df_realtime_globals+"framePnts"
	CtrlFIFO FIFO_Realtime,deltaT= 1.0/Snd_fs,size= framePnts//400000
	FIFOStatus/Q FIFO_Realtime
	CtrlFIFO FIFO_Realtime, start
	SoundInStartChart framePnts*2, FIFO_Realtime
	if( GetRTError(0) == 0 )
		CtrlNamedBackground Bkgrnd_Realtime_FIFO, proc=SpHrView_Realtime_getFIFOWaves, period=60/desiredFPS, start
		ControlInfo/W=RealTimePanel b_start
		if(V_flag) //  /Z
			Button b_start win=RealTimePanel, rename=b_stop,picture=ProcGlobal#SpHrView_pict_circleStop
		endif
		return 1
	else
		DoAlert 0, "Error starting realtime background task"
		return 0
	endif
	return 0
end

function SpHrView_Realtime_FIFO_Stop()
	SoundInStopChart/Z
	CtrlNamedBackground Bkgrnd_Realtime_FIFO, stop
	FIFOStatus/Q FIFO_Realtime // FIFO_Realtime
	if(V_FIFORunning)
		CtrlFIFO FIFO_Realtime, stop // // FIFO_Realtime  - need to kill in window hook
	endif
	NVAR/Z doFIFO = $SpHrView_df_realtime_globals+"doFIFO"
	if(NVAR_Exists(doFIFO))
		doFIFO = 0
	endif
	ControlInfo/W=RealTimePanel b_stop
	if(V_flag) //  /Z
		Button b_stop win=RealTimePanel, rename=b_start,picture=ProcGlobal#SpHrView_pict_circlePlay
	endif
	return 1 // return 1 if no errors
end


function SpHrView_Realtime_getFIFOWaves(s)
	STRUCT WMBackgroundStruct &s
	

	NVAR desiredFPS= $SpHrView_df_realtime_globals+"desiredFPS"
	CtrlNamedBackground Bkgrnd_Realtime_FIFO, status
	variable fps = 60/NumberByKey("PERIOD", S_Info) // actual fps
	if(fps < desiredFPS)
		desiredFPS = fps
	endif
	
	// always get ch1?
	wave/Z Snd_ch1=$SpHrView_df_realtime+"Snd_ch1"
	if(!waveexists(Snd_ch1))
		SpHrView_Realtime_FIFO_Stop()
		Print "Snd_ch1 is missing"
		return 0
	endif
	
	FIFO2Wave/S=0 FIFO_Realtime,ch1, Snd_ch1
	
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(SoundInChannels > 1)
		wave Snd_ch2=$SpHrView_df_realtime+"Snd_ch2"
		FIFO2Wave/S=0 FIFO_Realtime,ch2, Snd_ch2
	endif
	if(SoundInChannels > 2)
		wave Snd_ch3=$SpHrView_df_realtime+"Snd_ch3"
		FIFO2Wave/S=0 FIFO_Realtime,ch3, Snd_ch3
	endif
	if(SoundInChannels > 3)
		wave Snd_ch4=$SpHrView_df_realtime+"Snd_ch4"
		FIFO2Wave/S=0 FIFO_Realtime,ch4, Snd_ch4
	endif
	
	SpHrView_Realtime_WinSpectra(2) // pass 2 to update, returns if Realtime_SpectraWindow not open
	
	SpHrView_Realtime_WinITD(2) // pass 2 to update, returns if Realtime_ITDWindow not open
	SpHrView_Realtime_WinITDDists(2) // pass 2 to update, returns if Realtime_ITDWindow not open
	
	SpHrView_Realtime_WinILD(2) // pass 2 to update, returns if Realtime_ITDWindow not open
	SpHrView_Realtime_WinILDDists(2) // pass 2 to update, returns if Realtime_ITDWindow not open


	return 0
end

Function SpHrView_Realtime_CuesOneBand()


End

Function SpHrView_Realtime_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 1: // mouse down
			strswitch(ba.ctrlName)
				case "b_help":
					SpHrView_Realtime_WinHelp()
					break
					
				case "b_start":
					SpHrView_Realtime_FIFO_Start()
					break
				case "b_stop":
					SpHrView_Realtime_FIFO_Stop()
					break
					
				case "b_FS":
					SVAR rateList= $SpHrView_df_realtime_globals+"rateList"
					PopupContextualMenu rateList
					if(V_flag)
						NVAR Snd_fs = $SpHrView_df_realtime_globals+"Snd_fs"
						Snd_fs = str2num(S_selection)
					endif
					break
				case "b_FramePoints":
					SpHrView_Realtime_FIFO_Stop()
					NVAR Snd_fs = $SpHrView_df_realtime_globals+"Snd_fs"
					SpHr_DFTSizeList /SMSP=(Snd_fs) // /S 2^10, 2^16
					PopupContextualMenu S_RateList_ms_pnts //S_RateList
					if(V_flag)
						NVAR framePnts = $SpHrView_df_realtime_globals+"framePnts"
						framePnts = str2num(StringFromList(1, S_selection,","))
						NVAR frameDurationMS = $SpHrView_df_realtime_globals+"frameDurationMS"
						frameDurationMS = (framePnts/Snd_fs)*1000
						NVAR desiredFPS = $SpHrView_df_realtime_globals+"desiredFPS"
						desiredFPS = ceil(Snd_fs/(framePnts/5))
						desiredFPS = limit(desiredFPS,5,60)
						SpHrView_Realtime_MakeSndWaves()
					endif
					break
				case "b_spectraFramePnts":
					SpHr_DFTSizeList /S 2^10, 2^14
					PopupContextualMenu S_RateList
					if(V_flag)
						variable Pnts = str2num(S_selection)
						NVAR framePnts = $SpHrView_df_realtime_globals+"framePnts"
						NVAR spectraFramePnts = $SpHrView_df_realtime_globals+"spectraFramePnts"
						if(Pnts > framePnts)
							spectraFramePnts = framePnts
						else
							spectraFramePnts = Pnts
						endif
						wave/Z Spectra= $SpHrView_df_realtime+"Spectra"
						wave/Z SpectraAvg= $SpHrView_df_realtime+"SpectraAvg"
						wave/Z SpectraSum= $SpHrView_df_realtime+"SpectraSum"
						if(waveexists(SpectraAvg) && waveexists(SpectraSum))
							if(dimsize(SpectraAvg,0) != dimsize(Spectra,0))
								Redimension/N=(dimsize(Spectra,0),-1) SpectraAvg
								copyscales Spectra, SpectraAvg
							endif
							if(dimsize(SpectraSum,0) != dimsize(Spectra,0))
								Redimension/N=(dimsize(Spectra,0),-1) SpectraSum
								copyscales Spectra, SpectraAvg
							endif
						endif
					endif
					break
				case "b_resetSpectraAvg":
					wave/Z SpectraSum= $SpHrView_df_realtime+"SpectraSum"
					NVAR spectraCnt= $SpHrView_df_realtime_globals+"spectraCnt"
					if(waveexists(SpectraSum))
						SpectraSum = 0
						spectraCnt = 0
						NVAR spectraAvgHold = $SpHrView_df_realtime_globals+"spectraAvgHold"
						spectraAvgHold = 0
						Button b_holdSpectraAvg win=$"Realtime_SpectraWindow#PTop",title="🖐🏼",valueColor=(0,0,0)
					endif
					break
				case "b_holdSpectraAvg":
					NVAR spectraAvgHold = $SpHrView_df_realtime_globals+"spectraAvgHold"
					if(spectraAvgHold)
						spectraAvgHold = 0
						Button b_holdSpectraAvg win=$"Realtime_SpectraWindow#PTop",title="🖐🏼",valueColor=(0,0,0)
					else
						spectraAvgHold = 1
						Button b_holdSpectraAvg win=$"Realtime_SpectraWindow#PTop",title=" ✍🏼",valueColor=(2,39321,1)
					endif
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SpHrView_Realtime_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 9: // mouse down
			strswitch(sva.ctrlName)
				case "sv_InputDevice":
						DoAlert/T="Warning" 1, "Close window and reset?"
						if(v_flag==1)
							// re-draw window
							killwindow/Z RealTimePanel
							SpHrView_Realtime_Window() 
						endif
						return 0
					break	
			endswitch
			break
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			strswitch(sva.ctrlName)
				case "sv_desiredFPS":
					NVAR desiredFPS=$SpHrView_df_realtime_globals+"desiredFPS"
					desiredFPS = 60/trunc(60/dval)
					CtrlNamedBackground Bkgrnd_Realtime_FIFO, period=60/desiredFPS
					break
					
				case "sv_ITD_CF":
					wave/Z ITD_CFw = $SpHrView_df_realtime+"ITD_CFw"
					if(!waveexists(ITD_CFw))
						Make/D/O/N=1 $SpHrView_df_realtime+"ITD_CFw"
						wave ITD_CFw = $SpHrView_df_realtime+"ITD_CFw"
					endif
					NVAR ITD_CF = $SpHrView_df_realtime_globals+"ITD_CF"
					ITD_CFw = ITD_CF
					NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
					SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ITD_CFw, coefBank_ITD	
					SetAxis/E=2/W=Realtime_ITDWindow bottom -0.5/ITD_CF,0.5/ITD_CF
					Slider sl_bottomAxisRange win=Realtime_ITDWindow#PTop, limits={1/ITD_CF, 0.01/ITD_CF, 0.01/ITD_CF}, value=0.5/ITD_CF
					break
					
				case "sv_ILD_CF":
					wave/Z ILD_CFw = $SpHrView_df_realtime+"ILD_CFw"
					if(!waveexists(ILD_CFw))
						Make/D/O/N=1 $SpHrView_df_realtime+"ILD_CFw"
						wave ILD_CFw = $SpHrView_df_realtime+"ILD_CFw"
					endif
					NVAR ILD_CF = $SpHrView_df_realtime_globals+"ILD_CF"
					ILD_CFw = ILD_CF
					NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
					SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ILD_CFw, coefBank_ILD
					break
					
				case "sv_ITDdist_MinHz":
				case "sv_ITDdist_MaxHz":
					NVAR ITDdist_MinHz = $SpHrView_df_realtime_globals+"ITDdist_MinHz"
					NVAR ITDdist_MaxHz = $SpHrView_df_realtime_globals+"ITDdist_MaxHz"		
					// get CFs and coefBank
					SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/E=ITDDistribution_CFedges/R/Type=(2) ITDdist_MinHz, ITDdist_MaxHz, 64, CFs_ITD_Dist // log
					NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
					SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, CFs_ITD_Dist, coefBank_ITD_Dist
					break
					
				case "sv_ITDdist_RangeMS":
					NVAR ITDdist_RangeMS = $SpHrView_df_realtime_globals+"ITDdist_RangeMS"
					SetAxis/E=2/W=Realtime_ITDDistWindow bottom -ITDdist_RangeMS*0.001, ITDdist_RangeMS*0.001
					Slider sl_bottomAxisRange win=Realtime_ITDDistWindow#PTop, limits={0.00001, ITDdist_RangeMS*0.001, 0}, value=ITDdist_RangeMS*0.001
					break
					
				case "sv_ILDdist_MinHz":
				case "sv_ILDdist_MaxHz":
					NVAR ILDdist_MinHz = $SpHrView_df_realtime_globals+"ILDdist_MinHz"
					NVAR ILDdist_MaxHz = $SpHrView_df_realtime_globals+"ILDdist_MaxHz"		
					// get CFs and coefBank
					SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/E=ILDDistribution_CFedges/R/Type=(2) ILDdist_MinHz, ILDdist_MaxHz, 64, CFs_ILD_Dist // log
					NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
					SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, CFs_ILD_Dist, coefBank_ILD_Dist
					break
					
				case "sv_ILDdist_RangeMS":
					NVAR ILDdist_RangeMS = $SpHrView_df_realtime_globals+"ILDdist_RangeMS"
					SetAxis/E=2/W=Realtime_ILDDistWindow bottom -ILDdist_RangeMS, ILDdist_RangeMS
					Slider sl_bottomAxisRange win=Realtime_ILDDistWindow#PTop, limits={3, ILDdist_RangeMS, 1}, value=ILDdist_RangeMS*0.001
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SpHrView_Realtime_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			strswitch(cba.ctrlName)
				case "ck_Waveforms":
					SpHrView_Realtime_WinWaveforms(checked)
					break
					
				case "ck_Spectra":
					SpHrView_Realtime_WinSpectra(checked)
					break
					
				case "ck_ITD":
					SpHrView_Realtime_WinITD(checked)
					break
				case "ck_ITDdistributions":
					SpHrView_Realtime_WinITDDists(checked)
					break
					
				case "ck_ILD":
					SpHrView_Realtime_WinILD(checked)
					break
				case "ck_ILDdistributions":
					SpHrView_Realtime_WinILDDists(checked)
					break
					
				case "ck_grid":
					ModifyGraph grid=checked
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

//Menu "JustColorPop", contextualmenu
//	"*COLORPOP*(65535,0,0)", ;	// initially red, no execution command
//End

Function SpHrView_Realtime_Window() 
	SpHrView_RealTime_FIFO_Stop()
	//killwindow/Z RealTimePanel
	SpHrView_Realtime_Init()
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	NVAR screenHoriz = $SpHrView_df_realtime_globals+"screenHoriz"
	NVAR useChs34 = $SpHrView_df_realtime_globals+"useChs34"
	if(SoundInChannels <= 2)
		useChs34 = 0;
	endif
	
	DoWindow RealTimePanel
	if(v_flag)
		return 0
	endif
	
	NewPanel /FLT=0/K=1/W=(5,40,5+143,40+480) as "Realtime" //  /FLT=1
	DoWindow/C RealTimePanel

	variable svWidth = 115
	variable top = 5
	
	Button b_help,pos={10.00,top+3},size={13,13},title="",picture=ProcGlobal#SpHrView_pict_Help
	Button b_help,proc=SpHrView_Realtime_ButtonProc
	Button b_help,help={"Help for Realtime Procedures."}
	
	Button b_start,pos={60.00,top},size={25,25},title="",picture=ProcGlobal#SpHrView_pict_circlePlay
	Button b_start,proc=SpHrView_Realtime_ButtonProc
	Button b_start,help={"Start and Stop. Can also press the space bar."}
	
	// input device
	top += 35
	GroupBox g_InputDevice pos={5,top-4},size={135,95},fstyle=1,fSize=10,title="Input Device"
	top += 20
	SetVariable sv_InputDevice pos={8,top},size={125,14},bodyWidth=125,fSize=10,title=" ",frame=1,valueBackColor=(61166,61166,61166)
	SetVariable sv_InputDevice value=$SpHrView_df_realtime_globals+"InputDeviceName"
	SetVariable sv_InputDevice proc=SpHrView_Realtime_SetVarProc, help={"Input Device. Click to reset Realtime window."}
	top += 25
	SetVariable sv_FS pos={5,top},size={svWidth,14},bodyWidth=50,fSize=10,title="fs (Hz)"
	SetVariable sv_FS value=$SpHrView_df_realtime_globals+"Snd_fs",limits={22050,192000,0}
	SetVariable sv_FS proc=SpHrView_Realtime_SetVarProc
	SetVariable sv_FS help={"Input Sampling rate (Hz)"}
	Button b_FS,pos={120.00,top-1},size={15.00,17.00},title="",picture=ProcGlobal#SpHrView_pict_PopUpList
	Button b_FS,proc=SpHrView_Realtime_ButtonProc
	top += 20
	SetVariable sv_numChs pos={5,top},size={svWidth-20,14},bodyWidth=30,fSize=10,title="# inputs"
	SetVariable sv_numChs value=$SpHrView_df_realtime_globals+"SoundInChannels",limits={0,4,0}
	SetVariable sv_numChs proc=SpHrView_Realtime_SetVarProc
	SetVariable sv_numChs help={"Number of sound input channels"}
	
	top += 33
	GroupBox g_FIFO pos={5,top-7},size={135,83},fstyle=1,title="Input Frames"
	top += 12
	SetVariable sv_desiredFPS pos={10,top},size={svWidth-20,14},bodyWidth=30,fSize=10,title="Frames/s" // "FPS"
	SetVariable sv_desiredFPS value=$SpHrView_df_realtime_globals+"desiredFPS",limits={1,60,0}
	SetVariable sv_desiredFPS proc=SpHrView_Realtime_SetVarProc
	SetVariable sv_desiredFPS help={"Frames per second"}
	top += 20
	SetVariable sv_FrameDurationMS pos={5,top},size={svWidth,14},bodyWidth=45,fSize=10,title="Length (ms)",format="%.1f"
	SetVariable sv_FrameDurationMS value=$SpHrView_df_realtime_globals+"FrameDurationMS",limits={-inf,inf,0},noedit=1
	SetVariable sv_FrameDurationMS help={"FIFO frame duration in milliseconds"}
	Button b_FramePoints,pos={120.00,top-1},size={15.00,17.00},title="",picture=ProcGlobal#SpHrView_pict_PopUpList
	Button b_FramePoints,proc=SpHrView_Realtime_ButtonProc
	top += 20
	SetVariable sv_FramePoints pos={5,top},size={svWidth,14},bodyWidth=45,fSize=10,title="Points",valueBackColor=(61166,61166,61166)
	SetVariable sv_FramePoints value=$SpHrView_df_realtime_globals+"framePnts",limits={-inf,inf,0},noedit=1
	SetVariable sv_FramePoints help={"FIFO frame points"}
	
	
	// waveforms
	top += 33
	GroupBox g_Waveforms pos={5,top-4},size={135,41},fstyle=1,fSize=10,title="Display"
	top += 15
	CheckBox ck_Waveforms title="Waveforms",pos={15,top},proc=SpHrView_Realtime_CheckProc
	// spectra
	top += 30
	GroupBox g_Spectra pos={5,top-4},size={135,27}
	CheckBox ck_Spectra title="Amplitude Spectra",pos={15,top},proc=SpHrView_Realtime_CheckProc
	// ITD
	top += 30
	GroupBox g_ITD pos={5,top-4},size={135,41},fstyle=1,title="ITD"
	top += 15
	CheckBox ck_ITD title="\\Z13\\f01⫶",pos={15,top},proc=SpHrView_Realtime_CheckProc
	CheckBox ck_ITD help={"Interaural time differences (ITD) for single frequency band"}
	CheckBox ck_ITDdistributions title="Distributions",pos={50,top},proc=SpHrView_Realtime_CheckProc
	CheckBox ck_ITDdistributions help={"Interaural time difference (ITD) Distributions"}
	// ILD
	top += 30
	GroupBox g_ILD pos={5,top-4},size={135,41},fstyle=1,title="ILD"
	top += 15
	CheckBox ck_ILD title="\\Z13⫶",pos={15,top},proc=SpHrView_Realtime_CheckProc
	CheckBox ck_ILD help={"Interaural level differences (ILD) for single frequency band"}
	CheckBox ck_ILDdistributions title="Distributions",pos={50,top},proc=SpHrView_Realtime_CheckProc
	CheckBox ck_ILDdistributions help={"Interaural level difference (ILD) Distributions"}
	
	if(SoundInChannels < 2)
		GroupBox g_ITD disable=2
		CheckBox ck_ITD disable=2
		CheckBox ck_ITDdistributions disable=2
		
		GroupBox g_ILD disable=2
		CheckBox ck_ILD disable=2
		CheckBox ck_ILDdistributions disable=2
	endif
	
	DoUpdate/W=RealTimePanel // for Igor 9
	SetWindow RealTimePanel, hook(RealtimeHook)=SpHrView_Realtime_WinHook
	SetWindow RealTimePanel note="PACKAGE:SpHrView;GROUP:Realtime"
	
	FIFOStatus/Q FIFO_Realtime
	if(!V_FIFORunning)
		SpHrView_Realtime_FIFO_Start()
		
		//CheckBox ck_Waveforms value=1
		//SpHrView_Realtime_WinWaveforms(1)
	endif
	
	return 0
End

function SpHrView_Realtime_WinHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0
	switch(s.eventCode)
		case 2:	// Kill
			Variable i
			string traceListStr, NameStr
			strswitch(s.winName)
				case "RealTimePanel":
					CtrlNamedBackground Bkgrnd_Realtime_FIFO, kill
					FIFOStatus/Q FIFO_Realtime
					if(V_FIFORunning)
						SpHrView_Realtime_FIFO_Stop()
					endif
					if(V_flag)
						KillFIFO FIFO_Realtime
					endif
					//Execute/Z/Q/P "Killwindow/Z RealtimeHelp"
					//Execute/Z/Q/P "Killwindow/Z RealTimePanel"
					Execute/Z/Q/P "Killwindow/Z Realtime_WaveformsWindow"
					Execute/Z/Q/P "Killwindow/Z Realtime_SpectraWindow"
					Execute/Z/Q/P "Killwindow/Z Realtime_ITDWindow"
					Execute/Z/Q/P "Killwindow/Z Realtime_ITDDistWindow"
					Execute/Z/Q/P "Killwindow/Z Realtime_ILDWindow"
					Execute/Z/Q/P "Killwindow/Z Realtime_ILDDistWindow"
					Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_df_realtime[0,strlen(SpHrView_df_realtime)-2]+"\")" // remove trailing ":"
					hookResult = 1
					break
				case "Realtime_WaveformsWindow":
					CheckBox/Z ck_Waveforms win=RealTimePanel,value=0
					break
				case "Realtime_SpectraWindow":
					CheckBox/Z ck_Spectra win=RealTimePanel,value=0
					break
				case "Realtime_ITDWindow":
					CheckBox/Z ck_ITD win=RealTimePanel,value=0
					break
				case "Realtime_ITDDistWindow":
					CheckBox/Z ck_ITDdistributions win=RealTimePanel,value=0
					break
				case "Realtime_ILDWindow":
					CheckBox/Z ck_ILD win=RealTimePanel,value=0
					break
				case "Realtime_ILDDistWindow":
					CheckBox/Z ck_IlDdistributions win=RealTimePanel,value=0
					break
			endswitch
			break
			
		case 11:	// keyboard
			if(s.keycode == 32) // space bar
				FIFOStatus/Q FIFO_Realtime
				if(V_FIFORunning)
					SpHrView_Realtime_FIFO_Stop()
				else
					SpHrView_Realtime_FIFO_Start()
				endif				
				hookResult = 1
			endif
			break
		
	endswitch
	return hookResult		// 0 if nothing done, else 1
End
	
Function SpHrView_Realtime_MakeSndWaves()
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	NVAR Snd_fs = $SpHrView_df_realtime_globals+"Snd_fs"
	NVAR framePnts = $SpHrView_df_realtime_globals+"framePnts"
	//NVAR desiredFPS = $SpHrView_df_realtime_globals+"desiredFPS"
	//desiredFPS = ceil(Snd_fs/framePnts)
	// ch 1
	wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1"
	if(!waveexists(Snd_ch1))
		Make/O/N=(framePnts) $SpHrView_df_realtime+"Snd_ch1"=0
		wave Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1"
		SetScale/P x,0,1/Snd_fs,"s" Snd_ch1
	else
		Redimension/N=(framePnts) Snd_ch1
		SetScale/P x,0,1/Snd_fs,"s" Snd_ch1
	endif
	// ch 2
	if(SoundInChannels > 1)
		wave/Z Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		if(!waveexists(Snd_ch2))
			Make/O/N=(framePnts) $SpHrView_df_realtime+"Snd_ch2"=0
			wave Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch2
		else
			Redimension/N=(framePnts) Snd_ch2
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch2
		endif
	endif
	// ch 3
	if(SoundInChannels > 2)
		wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3"
		if(!waveexists(Snd_ch3))
			Make/O/N=(framePnts) $SpHrView_df_realtime+"Snd_ch3"=0
			wave Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3"
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch3
		else
			Redimension/N=(framePnts) Snd_ch3
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch3
		endif
	endif
	// ch 4
	if(SoundInChannels > 3)
		wave/Z Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
		if(!waveexists(Snd_ch4))
			Make/O/N=(framePnts) $SpHrView_df_realtime+"Snd_ch4"=0
			wave Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch4
		else
			Redimension/N=(framePnts) Snd_ch4
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch4
		endif
	endif
end


Function SpHrView_Realtime_WinWaveforms(int doDisplay)
	KillWindow/Z Realtime_WaveformsWindow
	if(!doDisplay)
		return 0
	endif
	Display/K=1/W=(160,45,160+502,45+194) as "Waveforms"
	DoWindow/C Realtime_WaveformsWindow
	ModifyGraph width=432,height=144
	ModifyGraph margin(left)=36,margin(bottom)=36,margin(right)=14,margin(top)=14
	
	variable maxPa = 0.01 // 0.01*1.5 = 0.015
	wave/Z Snd_ch1= $SpHrView_df_realtime+"Snd_ch1"
	if(!waveexists(Snd_ch1))
		SpHrView_Realtime_MakeSndWaves()
	else
		AppendToGraph Snd_ch1
		SpHr_Extrema /MaxM /PMax=(maxPa) Snd_ch1
		maxPa = V_MaxMag
		ModifyGraph rgb(Snd_ch1)=(0,0,65535)
		ModifyGraph lsize(Snd_ch1)=0.5
	endif
	wave/Z Snd_ch2= $SpHrView_df_realtime+"Snd_ch2"
	if(waveexists(Snd_ch2))
		AppendToGraph Snd_ch2
		SpHr_Extrema /MaxM /PMax=(maxPa) Snd_ch2
		maxPa = V_MaxMag
		ModifyGraph rgb(Snd_ch2)=(65535,0,0)
		ModifyGraph lsize(Snd_ch2)=0.5
	endif
	wave/Z Snd_ch3= $SpHrView_df_realtime+"Snd_ch3"
	if(waveexists(Snd_ch3))
		AppendToGraph Snd_ch3
		SpHr_Extrema /MaxM /PMax=(maxPa) Snd_ch3
		maxPa = V_MaxMag
		ModifyGraph rgb(Snd_ch3)=(0,43690,65535)
		ModifyGraph lsize(Snd_ch3)=0.5
	endif
	wave/Z Snd_ch4= $SpHrView_df_realtime+"Snd_ch4"
	if(waveexists(Snd_ch4))
		AppendToGraph Snd_ch4
		SpHr_Extrema /MaxM /PMax=(maxPa) Snd_ch4
		maxPa = V_MaxMag
		ModifyGraph rgb(Snd_ch4)=(65535,43690,0)
		ModifyGraph lsize(Snd_ch4)=0.5
	endif
	
	ModifyGraph tick=2
	ModifyGraph font="Arial",fSize=10
	ModifyGraph lblMargin=3,standoff=0,axThick=0.5
	ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1,axisOnTop=1
	ModifyGraph btLen=4,btThick=0.5,stLen=2,stThick=0.5
	Label left "amplitude (\\U)"
	//ModifyGraph zero(left)=1,zeroThick(left)=0.5
	SetDrawLayer UserBack
	SetDrawEnv ycoord= left,linefgc= (34952,34952,34952),linethick= 0.50
	DrawLine 0,0,1,0
	Label bottom "time (\\U)"
	
	ControlBar/W=Realtime_WaveformsWindow/L 20
	ModifyGraph/W=Realtime_WaveformsWindow cbRGB=(65534,65534,65534)

	// left axis slider
	Slider sl_leftAxisRangeLog win=Realtime_WaveformsWindow, pos={0,15},size={5,160},side=0,proc=AxisSliderProc	
	Slider sl_leftAxisRangeLog win=Realtime_WaveformsWindow, limits={log(1),log(0.0001),0.0001}, value=log(maxPa)
	SetAxis left -maxPa*1.5,maxPa*1.5
	
	DoUpdate/W=Realtime_WaveformsWindow // for Igor 9
	SetWindow Realtime_WaveformsWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
	SetWindow Realtime_WaveformsWindow note="PACKAGE:SpHrView;GROUP:Realtime"
End


Function SpHrView_Realtime_WinSpectra(int winMode) // winMode 0: Kill Window, 1: Display window, 2: Update
	DoWindow Realtime_SpectraWindow
	int winOpen = V_flag
	if(winMode==2 && !winOpen)
		return 0
	endif
	if(winMode==0)
		KillWindow/Z Realtime_SpectraWindow
		return 0
	endif
	int doAppend = 0
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(!winOpen && winMode==1) // Display Window
		Display/K=1/W=(160,265,160+502,265+312) as "Amplitude Spectra"
		DoWindow/C Realtime_SpectraWindow
		ModifyGraph width=432,height=216
		ModifyGraph margin(left)=36,margin(bottom)=36,margin(right)=14,margin(top)=28
		doAppend = 1
	endif
	if((winOpen && winMode==2) || doAppend)
		wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1", Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		NVAR spectraOctaveDenom = $SpHrView_df_realtime_globals+"spectraOctaveDenom"
		NVAR spectraFramePnts = $SpHrView_df_realtime_globals+"spectraFramePnts"
		int doDFTFrame = 1
		if(spectraFramePnts == numpnts(Snd_ch1))
			doDFTFrame = 0
		endif
		if(SoundInChannels == 1)
			if(waveExists(Snd_ch1))
				if(doDFTFrame)
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra/dB/Oct=(spectraOctaveDenom) /F=(spectraFramePnts) Snd_ch1
				else
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra/dB/Oct=(spectraOctaveDenom) Snd_ch1
				endif
			endif
			
		elseif(SoundInChannels >= 2)
			if(waveExists(Snd_ch1) && waveExists(Snd_ch2))
				if(doDFTFrame)
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra/dB/Oct=(spectraOctaveDenom) /F=(spectraFramePnts) Snd_ch1, Snd_ch2
				else
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra/dB/Oct=(spectraOctaveDenom) Snd_ch1, Snd_ch2
				endif
			endif
		
		elseif(SoundInChannels > 2) // combining 3 & 4
			wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3", Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
			if(waveExists(Snd_ch3) && waveExists(Snd_ch4))
				if(doDFTFrame)
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra/dB/Oct=(spectraOctaveDenom) /F=(spectraFramePnts) Snd_ch3, Snd_ch4
				else
					SpHr_DFTSpectrum/DF=$SpHrView_df_realtime /Mag=Spectra34/dB/Oct=(spectraOctaveDenom) Snd_ch3, Snd_ch4
				endif
			endif
		endif
		NVAR spectraAvgHold = $SpHrView_df_realtime_globals+"spectraAvgHold"
		if(!spectraAvgHold)
			wave/Z SpectraAvg= $SpHrView_df_realtime+"SpectraAvg"
			wave/Z SpectraSum= $SpHrView_df_realtime+"SpectraSum"
			NVAR spectraCnt= $SpHrView_df_realtime_globals+"spectraCnt"
			if(waveexists(SpectraAvg) && waveexists(SpectraSum))
				if(dimsize(SpectraAvg,0) != dimsize(Spectra,0))
					Redimension/N=(dimsize(Spectra,0),-1) SpectraAvg
					copyscales Spectra, SpectraAvg
				endif
				if(dimsize(SpectraSum,0) != dimsize(Spectra,0))
					Redimension/N=(dimsize(Spectra,0),-1) SpectraSum
					copyscales Spectra, SpectraAvg
				endif
				spectraCnt += 1
				SpectraSum += Spectra
				SpectraAvg = SpectraSum / spectraCnt
			endif
		endif
	endif
	if(doAppend)
	
		wave/Z Spectra= $SpHrView_df_realtime+"Spectra"
		variable maxHz = 20000
		variable maxVal = 0
		
		if(waveexists(Spectra))
			AppendToGraph Spectra[][0] /TN=Ch1
			ModifyGraph rgb(Ch1)=(0,0,65535)
			maxVal = max(maxVal, wavemax(Spectra))
			maxHz = DimSize(Spectra,0)*DimDelta(Spectra,0) + DimOffset(Spectra,0)
			if(dimsize(Spectra,1)>1)
				AppendToGraph Spectra[][1] /TN=Ch2
				ModifyGraph rgb(Ch2)=(65535,0,0)
			endif
			
			if(1) // append average
				Duplicate/O Spectra, $SpHrView_df_realtime+"SpectraAvg", $SpHrView_df_realtime+"SpectraSum"
				wave SpectraAvg = $SpHrView_df_realtime+"SpectraAvg"
				wave SpectraSum = $SpHrView_df_realtime+"SpectraSum"
				//SpectraAvg = 0
				//SpectraSum = 0
				AppendToGraph SpectraAvg[][0] /TN=Ch1_avg
				ModifyGraph rgb(Ch1_avg)=(49151,49151,65535)
				if(dimsize(SpectraAvg,1)>1)
					AppendToGraph SpectraAvg[][1] /TN=Ch2_avg
					ModifyGraph rgb(Ch2_avg)=(65535,49151,49151)
				endif
				NVAR spectraCnt= $SpHrView_df_realtime_globals+"spectraCnt"
				spectraCnt = 0
			endif
			
		endif
		if(SoundInChannels > 2) // combining 3 & 4
			wave/Z Spectra34= $SpHrView_df_realtime+"Spectra34"
			if(waveexists(Spectra34))
				AppendToGraph Spectra34[][0] /TN=Ch3
				maxVal = max(maxVal, wavemax(Spectra34))
				ModifyGraph rgb(Ch3)=(0,43690,65535)
				if(dimsize(Spectra34,1)>1)
					AppendToGraph Spectra34[][1] /TN=Ch4
					ModifyGraph rgb(Ch4)=(65535,43690,0)
				endif
			endif
		endif
		maxVal *= 1.25
		ModifyGraph lsize=0.75
		ModifyGraph tick=2
		ModifyGraph font="Arial",fSize=10
		ModifyGraph lblMargin=3,standoff=0,axThick=0.5
		ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1,axisOnTop=1
		ModifyGraph btLen=4,btThick=0.5,stLen=2,stThick=0.5
		Label left "amplitude (\\U)"
		SetAxis left maxVal-72, maxVal+18
		Label bottom "frequency (\\U)"
		SetAxis bottom 20,*
		if(1)
			ModifyGraph log(bottom)=1
		endif
	
		// left axis sliders	
		ControlBar/W=Realtime_SpectraWindow/L 20
		ModifyGraph/W=Realtime_SpectraWindow cbRGB=(65534,65534,65534)
		variable maxSliderVal = maxVal	+ 18 + 48
		variable minSliderVal = maxVal + 18 - 48
		Slider sl_leftAxisMax win=Realtime_SpectraWindow, pos={0,50},size={5,70},side=0,proc=AxisSliderProc	
		Slider sl_leftAxisMax win=Realtime_SpectraWindow, limits={maxSliderVal,minSliderVal,1}, value=maxVal+18
		
		maxSliderVal = maxVal - 72 + 48
		minSliderVal = maxVal - 72 - 48
		Slider sl_leftAxisMin win=Realtime_SpectraWindow, pos={0,230},size={5,70},side=0,proc=AxisSliderProc	
		Slider sl_leftAxisMin win=Realtime_SpectraWindow, limits={maxSliderVal,minSliderVal,1}, value=maxVal-72
		
		// top axis sliders	
		ControlBar/W=Realtime_SpectraWindow/T 32
		NewPanel/HOST=Realtime_SpectraWindow/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		string pns = "Realtime_SpectraWindow#PTop"
		
		// min frequeny slider
		Slider sl_bottomAxisMinLog win=$pns, vert=0,pos={10,10},size={100,5},side=0,proc=AxisSliderProc	
		Slider sl_bottomAxisMinLog win=$pns, limits={log(900),log(10),0}, value=log(20)
		
		// average(s)
		TitleBox tb_average win=$pns,fSize=10,title="μ:",pos={120,9},frame=0
		Button b_resetSpectraAvg win=$pns,pos={135,5},size={20,20},fSize=12,title=" "+Char_swapArrowStr // "Reset"
		Button b_resetSpectraAvg win=$pns,proc=SpHrView_Realtime_ButtonProc
		Button b_resetSpectraAvg win=$pns,help={"Rest average(s)"}
		
		Button b_holdSpectraAvg win=$pns,pos={160,5},size={22,20},fSize=11,title="🖐🏼",valueColor=(0,0,0)
		Button b_holdSpectraAvg win=$pns,proc=SpHrView_Realtime_ButtonProc
		Button b_holdSpectraAvg win=$pns,help={"Hold average(s)"}
		NVAR spectraAvgHold = $SpHrView_df_realtime_globals+"spectraAvgHold"
		if(spectraAvgHold)
			Button b_holdSpectraAvg win=$pns,title=" ✍🏼",valueColor=(2,39321,1)
		endif
	
		SetVariable sv_spectraFramePnts win=$pns,pos={195,9},size={76,14},bodyWidth=45,fSize=9,title="Points"
		SetVariable sv_spectraFramePnts win=$pns,value=$SpHrView_df_realtime_globals+"spectraFramePnts",limits={-inf,inf,0},noedit=1
		SetVariable sv_spectraFramePnts win=$pns,help={"DFT points"}
		Button b_spectraFramePnts,win=$pns,pos={270,9-1},size={15.00,15.00},title="",picture=ProcGlobal#SpHrView_pict_PopUpList
		Button b_spectraFramePnts,win=$pns,proc=SpHrView_Realtime_ButtonProc
		
		SetVariable sv_spectraOctaveDenom win=$pns,pos={295,9},size={80,14},bodyWidth=45,fSize=9,title="Octave"
		SetVariable sv_spectraOctaveDenom win=$pns,value=$SpHrView_df_realtime_globals+"spectraOctaveDenom",limits={0,96,3}
		SetVariable sv_spectraOctaveDenom win=$pns,help={"Octave denomenator"}
		TitleBox t_neg1 win=$pns,pos={352,9},frame=0,fstyle=0,fSize=9,title="-1"
		
		// max frequeny slider
		Slider sl_bottomAxisMaxLog win=$pns, vert=0,pos={390,10},size={100,5},side=0,proc=AxisSliderProc	
		Slider sl_bottomAxisMaxLog win=$pns, limits={log(maxHz),log(1100),0}, value=log(maxHz)
		
		SetActiveSubwindow Realtime_SpectraWindow //##
		ModifyGraph/W=Realtime_SpectraWindow cbRGB=(65534,65534,65534)

		ModifyGraph width=0,height=0 // make expandable
		DoUpdate/W=Realtime_SpectraWindow // for Igor 9
		SetWindow Realtime_SpectraWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
		SetWindow Realtime_SpectraWindow note="PACKAGE:SpHrView;GROUP:Realtime"
		

	endif // if(doAppend)
	
End




Function SpHrView_Realtime_WinITD(int winMode) // winMode 0: Kill Window, 1: Display window, 2: Update
	DoWindow Realtime_ITDWindow
	int winOpen = V_flag
	if(winMode==2 && !winOpen)
		return 0
	endif
	// need > 2 channels for ITD
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(SoundInChannels < 2)
	return 0
	endif
	if(winMode==0)
		KillWindow/Z Realtime_ITDWindow
		return 0
	endif
	int doAppend = 0
	if(!winOpen && winMode==1) // Display Window
		Display/K=1/W=(160,265,160+502,265+308) as "ITD"
		DoWindow/C Realtime_ITDWindow
		ModifyGraph width=432,height=244
		ModifyGraph margin(left)=36,margin(bottom)=36,margin(right)=13,margin(top)=10
		
		// get CFs and coefBank_ITD
		//SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/R/Type=(2) 500, 500, 1, CFs // log
		Make/D/O/N=1 $SpHrView_df_realtime+"ITD_CFw"
		wave ITD_CFw = $SpHrView_df_realtime+"ITD_CFw"
		NVAR ITD_CF = $SpHrView_df_realtime_globals+"ITD_CF"
		ITD_CFw = ITD_CF
		NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ITD_CFw, coefBank_ITD
		
		doAppend = 1
	endif
	if((winOpen && winMode==2) || doAppend)
		wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1", Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		//NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		if(SoundInChannels == 2)
			if(waveExists(Snd_ch1) && waveExists(Snd_ch2))
				//SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/R/Type=(2) 500, 500, 1, ITD_CFw // log
				//SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ITD_CFw, coefBank_ITD	
				wave ITD_CFw = $SpHrView_df_realtime+"ITD_CFw"
				wave coefBank_ITD = $SpHrView_df_realtime+"coefBank_ITD"
						
				SpHr_FilterBankBiquad /DF=$SpHrView_df_realtime/RMS/Dest=FilterBanks ITD_CFw, coefBank_ITD, Snd_ch1, Snd_ch2

				SpHr_CrossingCarrierCues/DF=$SpHrView_df_realtime /CPC=2 /ITD=ITD/X=ITDXs ITD_CFw, FilterBanks
			endif
		
		//elseif(SoundInChannels == 4) // combining 3 & 4
		//	wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3", Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
		//	if(waveExists(Snd_ch3) && waveExists(Snd_ch4))
		//		
		//	endif
		endif
	endif
	if(doAppend)
		wave/Z ITD= $SpHrView_df_realtime+"ITD"
		wave/Z ITDXs= $SpHrView_df_realtime+"ITDXs"
		if(waveexists(ITD))
			AppendToGraph/Vert ITD vs ITDXs // /TN=$"Hz_"+num2str(ITD_CFw[0])  [][0]
			 
			
			ModifyGraph mode=3,marker=8,msize=2,rgb=(0,0,0)
			
			ModifyGraph lsize=0.75
			ModifyGraph tick=2
			ModifyGraph font="Arial",fSize=10
			ModifyGraph lblMargin=3,standoff=0,axThick=0.5
			ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1,axisOnTop=1
			ModifyGraph btLen=4,btThick=0.5,stLen=2,stThick=0.5
			Label left "time (\\U)"
			ModifyGraph lblMargin(left)=5
			Label bottom "interaural time difference (\\U)"
			SetAxis/A/E=2 bottom
			ModifyGraph zero(bottom)=1,zeroThick(bottom)=1
			NVAR ITD_CF = $SpHrView_df_realtime_globals+"ITD_CF"
			SetAxis/E=2 bottom -0.5/ITD_CF,0.5/ITD_CF
			SetAxis/E=1 left 0,*
			
			ControlBar/W=Realtime_ITDWindow/T 32
			NewPanel/HOST=Realtime_ITDWindow/FG=(FL,FT,GR,GT)/HOST=# 
			RenameWindow #,PTop
			string pns = "Realtime_ITDWindow#PTop"
			
			SetVariable sv_ITD_CF win=$pns,pos={15,9},size={156,14},bodyWidth=55,fSize=9,title="Center Frequency (Hz)"
			SetVariable sv_ITD_CF win=$pns,value=$SpHrView_df_realtime_globals+"ITD_CF",limits={20,20000,100}
			SetVariable sv_ITD_CF win=$pns,proc=SpHrView_Realtime_SetVarProc
			SetVariable sv_ITD_CF win=$pns,help={"Center frequency (Hz) of ITD auditory filter"}
			
			Slider sl_bottomAxisRange win=$pns, vert=0,pos={196,10},size={150,5},side=0,proc=AxisSliderProc	
			Slider sl_bottomAxisRange win=$pns, limits={1/ITD_CF, 0.01/ITD_CF, 0.01/ITD_CF}, value=0.5/ITD_CF
			
			SetActiveSubwindow Realtime_ITDWindow //##
			ModifyGraph/W=Realtime_ITDWindow cbRGB=(65534,65534,65534)
		
			ModifyGraph width=0,height=0 // make expandable
			DoUpdate/W=Realtime_ITDWindow // for Igor 9
			SetWindow Realtime_ITDWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
			SetWindow Realtime_ITDWindow note="PACKAGE:SpHrView;GROUP:Realtime"
	
		endif
	endif
End

Function SpHrView_Realtime_WinITDDists(int winMode) // winMode 0: Kill Window, 1: Display window, 2: Update
	DoWindow Realtime_ITDDistWindow
	int winOpen = V_flag
	if(winMode==2 && !winOpen)
		return 0
	endif
	// need > 2 channels for ITD
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(SoundInChannels < 2)
	return 0
	endif
	if(winMode==0)
		KillWindow/Z Realtime_ITDDistWindow
		return 0
	endif
	int doAppend = 0
	if(!winOpen && winMode==1) // Display Window
		Display/K=1/W=(160,265,160+502,265+328) as "ITD Distributions"
		DoWindow/C Realtime_ITDDistWindow
		ModifyGraph width=432,height=244
		ModifyGraph margin(left)=46,margin(bottom)=36,margin(right)=13,margin(top)=10
		
		NVAR ITDdist_MinHz = $SpHrView_df_realtime_globals+"ITDdist_MinHz"
		NVAR ITDdist_MaxHz = $SpHrView_df_realtime_globals+"ITDdist_MaxHz"		
		// get CFs and coefBank
		SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/E=ITDDistribution_CFedges/R/Type=(2) ITDdist_MinHz, ITDdist_MaxHz, 64, CFs_ITD_Dist // log
		NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, CFs_ITD_Dist, coefBank_ITD_Dist
		
		doAppend = 1
	endif
	if((winOpen && winMode==2) || doAppend)
		wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1", Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		//NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		if(SoundInChannels == 2)
			if(waveExists(Snd_ch1) && waveExists(Snd_ch2))

				wave CFs_ITD_Dist = $SpHrView_df_realtime+"CFs_ITD_Dist"
				wave coefBank_ITD_Dist = $SpHrView_df_realtime+"coefBank_ITD_Dist"
				
				SpHr_FilterBankBiquad /DF=$SpHrView_df_realtime/RMS/Dest=ITDDistributionFilterBanks CFs_ITD_Dist, coefBank_ITD_Dist, Snd_ch1, Snd_ch2
						
				NVAR ITDdist_CPC = $SpHrView_df_realtime_globals+"ITDdist_CPC"																				
				NVAR ITDdist_Type = $SpHrView_df_realtime_globals+"ITDdist_Type"
				SpHr_CrossingCarrierCues/DF=$SpHrView_df_realtime /Type=(ITDdist_Type) /CPC=(ITDdist_CPC) /ITD=DistributionITDs CFs_ITD_Dist, ITDDistributionFilterBanks

				NVAR ITDdist_Norm = $SpHrView_df_realtime_globals+"ITDdist_Norm"
				NVAR ITDdist_RangeMS = $SpHrView_df_realtime_globals+"ITDdist_RangeMS"
				NVAR ITDdist_NumBins = $SpHrView_df_realtime_globals+"ITDdist_NumBins"	//  /PkX=ITDDistributionsPeakXs
				variable ITDdist_Range = -ITDdist_RangeMS*0.001
				SpHr_Histogram/Norm=(ITDdist_Norm)/Sym={ITDdist_Range,ITDdist_NumBins}/DF=$SpHrView_df_realtime DistributionITDs, ITDDistributions
				
				NVAR ITDdist_Smooth = $SpHrView_df_realtime_globals+"ITDdist_Smooth"
				if(ITDdist_Smooth)
					MatrixFilter /N=4 gauss ITDDistributions
				endif
			endif
		
		//elseif(SoundInChannels == 4) // combining 3 & 4
		//	wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3", Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
		//	if(waveExists(Snd_ch3) && waveExists(Snd_ch4))
		//		
		//	endif
		endif
	endif
	if(doAppend)
	
		wave ITDDistribution_CFedges=$SpHrView_df_realtime+"ITDDistribution_CFedges"
		AppendImage ITDDistributions vs {*,ITDDistribution_CFedges}
		ModifyGraph log(left)=1
		ModifyImage ITDDistributions ctab= {*,*,SeaLandAndFire,0}
		//ModifyGraph userticks(left)={:SpHrView:Realtime:CFs_TickVals,:SpHrView:Realtime:CFs_TickTxt}
		ModifyGraph tick=2,zero(bottom)=1,mirror=0
		ModifyGraph font="Arial",fSize=10
		ModifyGraph standoff=0,axThick=0.5,zeroThick(left)=0.5
		ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1
		ModifyGraph btLen=4,btThick=0.5
		ModifyGraph stLen=2,stThick=0.5
		ModifyGraph lblMargin=5
		Label left "frequency (\\U)"
		Label bottom "interaural time difference (\\U)"
		NVAR ITDdist_RangeMS = $SpHrView_df_realtime_globals+"ITDdist_RangeMS"
		SetAxis/E=2 bottom -ITDdist_RangeMS*0.001, ITDdist_RangeMS*0.001
	
		ControlBar/W=Realtime_ITDDistWindow/T 52 // 32
		NewPanel/HOST=Realtime_ITDDistWindow/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		string pns = "Realtime_ITDDistWindow#PTop"
		
		SetVariable sv_ITDdist_MinHz win=$pns,pos={15,9},size={119,14},bodyWidth=40,fSize=9,title="Frequencies (Hz)"
		SetVariable sv_ITDdist_MinHz win=$pns,value=$SpHrView_df_realtime_globals+"ITDdist_MinHz",limits={20,20000,100}
		SetVariable sv_ITDdist_MinHz win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ITDdist_MinHz win=$pns,help={"Minimum frequency of auditory filter bank"}
		SetVariable sv_ITDdist_MaxHz win=$pns,pos={139,9},size={63,14},bodyWidth=50,fSize=9,title="to"
		SetVariable sv_ITDdist_MaxHz win=$pns,value=$SpHrView_df_realtime_globals+"ITDdist_MaxHz",limits={20,20000,100}
		SetVariable sv_ITDdist_MaxHz win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ITDdist_MaxHz win=$pns,help={"Maximum frequency of auditory filter bank"}
		
		SetVariable sv_ITDdist_CPC win=$pns,pos={200,9},size={63,14},bodyWidth=25,fSize=9,title="CPC"
		SetVariable sv_ITDdist_CPC win=$pns,value=$SpHrView_df_realtime_globals+"ITDdist_CPC",limits={1,3,1}
		SetVariable sv_ITDdist_CPC win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ITDdist_CPC win=$pns,help={"Cues per cycle (1-3)"}
		
		SetVariable sv_ITDdist_RangeMS win=$pns,pos={325,9},size={89,14},bodyWidth=35,fSize=9,title="±ITD (ms)"
		SetVariable sv_ITDdist_RangeMS win=$pns,value=$SpHrView_df_realtime_globals+"ITDdist_RangeMS",limits={0.1,5,0.1}
		SetVariable sv_ITDdist_RangeMS win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ITDdist_RangeMS win=$pns,help={"ITD range (maximum)"}
		
		SetVariable sv_ITDdist_NumBins win=$pns,pos={415,9},size={71,14},bodyWidth=40,fSize=9,title="Bins"
		SetVariable sv_ITDdist_NumBins win=$pns,value=$SpHrView_df_realtime_globals+"ITDdist_NumBins",limits={20,20000,100}
		SetVariable sv_ITDdist_NumBins win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ITDdist_NumBins win=$pns,help={"Number of distribution bins"}
		
		CheckBox ck_ITDdist_Type title="Zero\\f01\\Z12'",pos={25,27},variable=ITDdist_Type,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ITDdist_Type help={"Zero crossings computed using waveform derivatives"}
		
		CheckBox ck_grid title="Grid",pos={80,27},proc=SpHrView_Realtime_CheckProc
		CheckBox ck_grid help={"Display grid lines"}
		
		CheckBox ck_ITDdist_Norm title="Normalize",pos={350,27},variable=ITDdist_Norm,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ITDdist_Norm help={"Normalize distributions re: maximum of 1"}
		
		CheckBox ck_ITDdist_Smooth title="Smooth",pos={425,27},variable=ITDdist_Smooth,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ITDdist_Smooth help={"Apply a 4X4 gaussian filter"}
				
		Slider sl_bottomAxisRange win=$pns, vert=0,pos={213,30},size={100,5},side=0,proc=AxisSliderProc	
		Slider sl_bottomAxisRange win=$pns, limits={0.00001, ITDdist_RangeMS*0.001, 0}, value=ITDdist_RangeMS*0.001
		
		SetActiveSubwindow Realtime_ITDDistWindow //##
		ModifyGraph/W=Realtime_ITDDistWindow cbRGB=(65534,65534,65534)
	
		ModifyGraph width=0,height=0 // make expandable
		DoUpdate/W=Realtime_ITDDistWindow // for Igor 9
		SetWindow Realtime_ITDDistWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
		SetWindow Realtime_ITDDistWindow note="PACKAGE:SpHrView;GROUP:Realtime"

	endif

End


Function SpHrView_Realtime_WinILD(int winMode) // winMode 0: Kill Window, 1: Display window, 2: Update
	DoWindow Realtime_ILDWindow
	int winOpen = V_flag
	if(winMode==2 && !winOpen)
		return 0
	endif
	// need > 2 channels for ILD
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(SoundInChannels < 2)
	return 0
	endif
	if(winMode==0)
		KillWindow/Z Realtime_ILDWindow
		return 0
	endif
	int doAppend = 0
	if(!winOpen && winMode==1) // Display Window
		Display/K=1/W=(160,265,160+502,265+308) as "ILD"
		DoWindow/C Realtime_ILDWindow
		ModifyGraph width=432,height=244
		ModifyGraph margin(left)=36,margin(bottom)=36,margin(right)=13,margin(top)=10
		
		// get CFs and coefBank_ILD
		//SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/R/Type=(2) 500, 500, 1, CFs // log
		Make/D/O/N=1 $SpHrView_df_realtime+"ILD_CFw"
		wave ILD_CFw = $SpHrView_df_realtime+"ILD_CFw"
		NVAR ILD_CF = $SpHrView_df_realtime_globals+"ILD_CF"
		ILD_CFw = ILD_CF
		NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ILD_CFw, coefBank_ILD
		
		doAppend = 1
	endif
	if((winOpen && winMode==2) || doAppend)
		wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1", Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		//NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		if(SoundInChannels == 2)
			if(waveExists(Snd_ch1) && waveExists(Snd_ch2))
				//SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/R/Type=(2) 500, 500, 1, ILD_CFw // log
				//SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, ILD_CFw, coefBank_ILD	
				wave ILD_CFw = $SpHrView_df_realtime+"ILD_CFw"
				wave coefBank_ILD = $SpHrView_df_realtime+"coefBank_ILD"
						
				SpHr_FilterBankBiquad /DF=$SpHrView_df_realtime/RMS/Dest=FilterBanks ILD_CFw, coefBank_ILD, Snd_ch1, Snd_ch2

				SpHr_CrossingCarrierCues/DF=$SpHrView_df_realtime /CPC=2 /ILD=ILD/X=ILDXs ILD_CFw, FilterBanks
			endif
		
		//elseif(SoundInChannels == 4) // combining 3 & 4
		//	wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3", Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
		//	if(waveExists(Snd_ch3) && waveExists(Snd_ch4))
		//		
		//	endif
		endif
	endif
	if(doAppend)
		wave/Z ILD= $SpHrView_df_realtime+"ILD"
		wave/Z ILDXs= $SpHrView_df_realtime+"ILDXs"
		if(waveexists(ILD))
			AppendToGraph/Vert ILD vs ILDXs // /TN=$"Hz_"+num2str(ILD_CFw[0])  [][0]
			ModifyGraph mode=3,marker=8,msize=2,rgb=(0,0,0)
			ModifyGraph lsize=0.75
			ModifyGraph tick=2
			ModifyGraph font="Arial",fSize=10
			ModifyGraph standoff=0,axThick=0.5
			ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1,axisOnTop=1
			ModifyGraph btLen=4,btThick=0.5,stLen=2,stThick=0.5
			Label left "time (\\U)"
			ModifyGraph lblMargin=5
			Label bottom "interaural level difference (\\U)"
			SetAxis/A/E=2 bottom
			ModifyGraph zero(bottom)=1,zeroThick(bottom)=1
			NVAR ILD_CF = $SpHrView_df_realtime_globals+"ILD_CF"
			SetAxis/E=2 bottom -15, 15
			SetAxis/E=1 left 0,*
			
			ControlBar/W=Realtime_ILDWindow/T 32
			NewPanel/HOST=Realtime_ILDWindow/FG=(FL,FT,GR,GT)/HOST=# 
			RenameWindow #,PTop
			string pns = "Realtime_ILDWindow#PTop"
			
			SetVariable sv_ILD_CF win=$pns,pos={15,9},size={156,14},bodyWidth=55,fSize=9,title="Center Frequency (Hz)"
			SetVariable sv_ILD_CF win=$pns,value=$SpHrView_df_realtime_globals+"ILD_CF",limits={20,20000,100}
			SetVariable sv_ILD_CF win=$pns,proc=SpHrView_Realtime_SetVarProc
			SetVariable sv_ILD_CF win=$pns,help={"Center frequency (Hz) of ILD auditory filter"}
			
			Slider sl_bottomAxisRange win=$pns, vert=0,pos={196,10},size={150,5},side=0,proc=AxisSliderProc	
			Slider sl_bottomAxisRange win=$pns, limits={3, 36, 1}, value=12
			
			SetActiveSubwindow Realtime_ILDWindow //##
			ModifyGraph/W=Realtime_ILDWindow cbRGB=(65534,65534,65534)
		
			ModifyGraph width=0,height=0 // make expandable
			DoUpdate/W=Realtime_ILDWindow // for Igor 9
			SetWindow Realtime_ILDWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
			SetWindow Realtime_ILDWindow note="PACKAGE:SpHrView;GROUP:Realtime"
	
		endif
	endif
End

Function SpHrView_Realtime_WinILDDists(int winMode) // winMode 0: Kill Window, 1: Display window, 2: Update
	DoWindow Realtime_ILDDistWindow
	int winOpen = V_flag
	if(winMode==2 && !winOpen)
		return 0
	endif
	// need > 2 channels for ILD
	NVAR SoundInChannels = $SpHrView_df_realtime_globals+"SoundInChannels"
	if(SoundInChannels < 2)
	return 0
	endif
	if(winMode==0)
		KillWindow/Z Realtime_ILDDistWindow
		return 0
	endif
	int doAppend = 0
	if(!winOpen && winMode==1) // Display Window
		Display/K=1/W=(160,265,160+502,265+328) as "ILD Distributions"
		DoWindow/C Realtime_ILDDistWindow
		ModifyGraph width=432,height=244
		ModifyGraph margin(left)=46,margin(bottom)=36,margin(right)=13,margin(top)=10
		
		NVAR ILDdist_MinHz = $SpHrView_df_realtime_globals+"ILDdist_MinHz"
		NVAR ILDdist_MaxHz = $SpHrView_df_realtime_globals+"ILDdist_MaxHz"		
		// get CFs and coefBank
		SpHr_FilterCenterFreqs/DF=$SpHrView_df_realtime/E=ILDDistribution_CFedges/R/Type=(2) ILDdist_MinHz, ILDdist_MaxHz, 64, CFs_ILD_Dist // log
		NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		SpHr_FilterBankBiquadCoefs/DF=$SpHrView_df_realtime fs, CFs_ILD_Dist, coefBank_ILD_Dist
		
		doAppend = 1
	endif
	if((winOpen && winMode==2) || doAppend)
		wave/Z Snd_ch1 = $SpHrView_df_realtime+"Snd_ch1", Snd_ch2 = $SpHrView_df_realtime+"Snd_ch2"
		//NVAR fs= $SpHrView_df_realtime_globals+"Snd_fs"
		if(SoundInChannels == 2)
			if(waveExists(Snd_ch1) && waveExists(Snd_ch2))

				wave CFs_ILD_Dist = $SpHrView_df_realtime+"CFs_ILD_Dist"
				wave coefBank_ILD_Dist = $SpHrView_df_realtime+"coefBank_ILD_Dist"
				
				SpHr_FilterBankBiquad /DF=$SpHrView_df_realtime/RMS/Dest=ILDDistributionFilterBanks CFs_ILD_Dist, coefBank_ILD_Dist, Snd_ch1, Snd_ch2
						
				NVAR ILDdist_CPC = $SpHrView_df_realtime_globals+"ILDdist_CPC"																				
				NVAR ILDdist_Type = $SpHrView_df_realtime_globals+"ILDdist_Type"
				SpHr_CrossingCarrierCues/DF=$SpHrView_df_realtime /Type=(ILDdist_Type) /CPC=(ILDdist_CPC) /ILD=DistributionILDs CFs_ILD_Dist, ILDDistributionFilterBanks

				NVAR ILDdist_Norm = $SpHrView_df_realtime_globals+"ILDdist_Norm"
				NVAR ILDdist_RangeMS = $SpHrView_df_realtime_globals+"ILDdist_RangeMS"
				NVAR ILDdist_NumBins = $SpHrView_df_realtime_globals+"ILDdist_NumBins"	//  /PkX=ILDDistributionsPeakXs
				variable ILDdist_Range = -ILDdist_RangeMS
				SpHr_Histogram/Norm=(ILDdist_Norm)/Sym={ILDdist_Range,ILDdist_NumBins}/DF=$SpHrView_df_realtime DistributionILDs, ILDDistributions
				
				NVAR ILDdist_Smooth = $SpHrView_df_realtime_globals+"ILDdist_Smooth"
				if(ILDdist_Smooth)
					MatrixFilter /N=4 gauss ILDDistributions
				endif
			endif
		
		//elseif(SoundInChannels == 4) // combining 3 & 4
		//	wave/Z Snd_ch3 = $SpHrView_df_realtime+"Snd_ch3", Snd_ch4 = $SpHrView_df_realtime+"Snd_ch4"
		//	if(waveExists(Snd_ch3) && waveExists(Snd_ch4))
		//		
		//	endif
		endif
	endif
	if(doAppend)
	
		wave ILDDistribution_CFedges=$SpHrView_df_realtime+"ILDDistribution_CFedges"
		AppendImage ILDDistributions vs {*,ILDDistribution_CFedges}
		ModifyGraph log(left)=1
		ModifyImage ILDDistributions ctab= {*,*,SeaLandAndFire,0}
		//ModifyGraph userticks(left)={:SpHrView:Realtime:CFs_TickVals,:SpHrView:Realtime:CFs_TickTxt}
		ModifyGraph tick=2,zero(bottom)=1,mirror=0
		ModifyGraph font="Arial",fSize=10
		ModifyGraph standoff=0,axThick=0.5,zeroThick(left)=0.5
		ModifyGraph ZisZ=1,zapTZ=1,zapLZ=1
		ModifyGraph btLen=4,btThick=0.5
		ModifyGraph stLen=2,stThick=0.5
		ModifyGraph lblMargin=5
		Label left "frequency (\\U)"
		Label bottom "interaural level difference (\\U)"
		NVAR ILDdist_RangeMS = $SpHrView_df_realtime_globals+"ILDdist_RangeMS"
		SetAxis/E=2 bottom -ILDdist_RangeMS, ILDdist_RangeMS
	
		ControlBar/W=Realtime_ILDDistWindow/T 52 // 32
		NewPanel/HOST=Realtime_ILDDistWindow/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PTop
		string pns = "Realtime_ILDDistWindow#PTop"
		
		SetVariable sv_ILDdist_MinHz win=$pns,pos={15,9},size={119,14},bodyWidth=40,fSize=9,title="Frequencies (Hz)"
		SetVariable sv_ILDdist_MinHz win=$pns,value=$SpHrView_df_realtime_globals+"ILDdist_MinHz",limits={20,20000,100}
		SetVariable sv_ILDdist_MinHz win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ILDdist_MinHz win=$pns,help={"Minimum frequency of auditory filter bank"}
		SetVariable sv_ILDdist_MaxHz win=$pns,pos={139,9},size={63,14},bodyWidth=50,fSize=9,title="to"
		SetVariable sv_ILDdist_MaxHz win=$pns,value=$SpHrView_df_realtime_globals+"ILDdist_MaxHz",limits={20,20000,100}
		SetVariable sv_ILDdist_MaxHz win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ILDdist_MaxHz win=$pns,help={"Maximum frequency of auditory filter bank"}
		
		SetVariable sv_ILDdist_CPC win=$pns,pos={200,9},size={63,14},bodyWidth=25,fSize=9,title="CPC"
		SetVariable sv_ILDdist_CPC win=$pns,value=$SpHrView_df_realtime_globals+"ILDdist_CPC",limits={1,3,1}
		SetVariable sv_ILDdist_CPC win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ILDdist_CPC win=$pns,help={"Cues per cycle (1-3)"}
		
		SetVariable sv_ILDdist_RangeMS win=$pns,pos={325,9},size={89,14},bodyWidth=35,fSize=9,title="±ILD (dB)"
		SetVariable sv_ILDdist_RangeMS win=$pns,value=$SpHrView_df_realtime_globals+"ILDdist_RangeMS",limits={3,60,3}
		SetVariable sv_ILDdist_RangeMS win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ILDdist_RangeMS win=$pns,help={"ILD range (maximum)"}
		
		SetVariable sv_ILDdist_NumBins win=$pns,pos={415,9},size={71,14},bodyWidth=40,fSize=9,title="Bins"
		SetVariable sv_ILDdist_NumBins win=$pns,value=$SpHrView_df_realtime_globals+"ILDdist_NumBins",limits={20,20000,100}
		SetVariable sv_ILDdist_NumBins win=$pns,proc=SpHrView_Realtime_SetVarProc
		SetVariable sv_ILDdist_NumBins win=$pns,help={"Number of distribution bins"}
		
		CheckBox ck_ILDdist_Type title="Zero\\f01\\Z12'",pos={25,27},variable=ILDdist_Type,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ILDdist_Type help={"Zero crossings computed using waveform derivatives"}
		
		CheckBox ck_grid title="Grid",pos={80,27},proc=SpHrView_Realtime_CheckProc
		CheckBox ck_grid help={"Display grid lines"}
		
		CheckBox ck_ILDdist_Norm title="Normalize",pos={350,27},variable=ILDdist_Norm,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ILDdist_Norm help={"Normalize distributions re: maximum of 1"}
		
		CheckBox ck_ILDdist_Smooth title="Smooth",pos={425,27},variable=ILDdist_Smooth,proc=SpHrView_Realtime_CheckProc
		CheckBox ck_ILDdist_Smooth help={"Apply a 4X4 gaussian filter"}
				
		Slider sl_bottomAxisRange win=$pns, vert=0,pos={213,30},size={100,5},side=0,proc=AxisSliderProc	
		Slider sl_bottomAxisRange win=$pns, limits={3, ILDdist_RangeMS, 1}, value=ILDdist_RangeMS
		
		SetActiveSubwindow Realtime_ILDDistWindow //##
		ModifyGraph/W=Realtime_ILDDistWindow cbRGB=(65534,65534,65534)
	
		ModifyGraph width=0,height=0 // make expandable
		DoUpdate/W=Realtime_ILDDistWindow // for Igor 9
		SetWindow Realtime_ILDDistWindow, hook(RealtimeHook)=SpHrView_Realtime_WinHook
		SetWindow Realtime_ILDDistWindow note="PACKAGE:SpHrView;GROUP:Realtime"

	endif

End


Function SpHrView_Realtime_WinHelp()
	String nb = "SpHrView_Realtime_Help"
	KillWindow/Z $nb
	NewNotebook/K=1/N=$nb/F=1/V=1/K=0/ENCG={2,1}/W=(153,45,690,493) as "SpHrView_Realtime Help"
	Notebook $nb defaultTab=36, magnification=100
	Notebook $nb showRuler=0, rulerUnits=1, updating={1, 1}
	Notebook $nb newRuler=Normal, justification=0, margins={0,0,468}, spacing={0,0,0}, tabs={}, rulerDefaults={"Helvetica",11,0,(0,0,0)}
	Notebook $nb ruler=Normal, fStyle=1, text="\r"
	Notebook $nb text="SpHrView_Realtime Help\r"
	Notebook $nb fStyle=-1, text="\r"
	Notebook $nb text="Opening a realtime window initiates all operations required to generate displayed data. If a fast frame "
	Notebook $nb text="rate is desired, one should therefore minimize the number of open windows.\r"
	Notebook $nb text="\r"
End