﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// SpHrView_Record

strconstant SpHrView_df_record = "root:SpHrView:Record:"
strconstant SpHrView_df_record_globals = "root:SpHrView:Record:Globals:"


///////////////////////////////////////////////////////////////////////////////

Function SpHrView_Rec_Window()
	Killwindow/Z PeaksWindow
	SpHrView_Rec_FIFO_Stop()
	//close analysis windows
	Killwindow/Z RecordWindow
	SpHrView_Rec_Init()
	NVAR screenHoriz = $SpHrView_df_record_globals+"screenHoriz"
	NVAR SoundInChannels = $SpHrView_df_record_globals+"SoundInChannels"
	NVAR useChs34 = $SpHrView_df_record_globals+"useChs34"
	if(SoundInChannels <= 2)
		useChs34 = 0;
	endif
	variable floatingWindow = 1
	variable groupboxHeight = 40
	if(floatingWindow)
		if(SoundInChannels<=2)
			NewPanel /FLT=1/K=1 /W=(screenHoriz/2-270,35,screenHoriz/2+300,80) as "Record"
			groupboxHeight = 40
		else
			NewPanel /FLT=1/K=1 /W=(screenHoriz/2-270,35,screenHoriz/2+300,115) as "Record"
			groupboxHeight = 73
		endif
	else
		if(SoundInChannels<=2)
			NewPanel /K=1 /W=(screenHoriz/2-270,45,screenHoriz/2+300,88) as "Record"
			groupboxHeight = 40
		else
			NewPanel /K=1 /W=(screenHoriz/2-270,45,screenHoriz/2+300,123) as "Record"
			groupboxHeight = 73
		endif
	endif
	DoWindow/C RecordWindow
	
	Button b_startRecording pos={20,8}, picture= ProcGlobal#SpHrView_pict_circleRecord,size={27.00,27.00}, proc=SpHrView_Rec_ButtonProc,title=" "
	//Button b_startRecording pos={15,12.5},fSize=12,size={80.00,21.00},proc=record_ButtonProc,title="   Record\\K(65535,0,0)\\k(65535,0,0)\\W519"
	Button b_startRecording disable=0	, help={"Start recording. Can also use the space bar to start and stop recording"}
	
	Button b_ViewWaves pos={65, 12},size={(20/15)*20,20},proc=SpHrView_Rec_ButtonProc,title=""
	Button b_ViewWaves picture= ProcGlobal#SpHrView_pict_Wave, help={"View  waves in datafolder root:SpHrView:Waves:"}
	GroupBox Group0 pos={10, 2}, size={95, groupboxHeight}
	
	if(SoundInChannels >= 3)
		NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
		NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
		CheckBox ck_RecChs_12_Only title="Channels 1 & 2",pos={425,42},proc=SpHrView_Rec_CheckProc,variable=$SpHrView_df_record_globals+"RecChs_12_Only"
		CheckBox ck_RecChs_34_as_12 title="Channels 3 & 4",pos={425,56},proc=SpHrView_Rec_CheckProc,variable=$SpHrView_df_record_globals+"RecChs_34_as_12"
	endif
	
	// peak meter for channels 1 & 2 
	variable meterLeft = 110
	variable meterTop = 0
	GroupBox meterGroup_Chs12 pos={meterLeft+4, 2}, size={290, groupboxHeight}
	SetDrawLayer UserBack
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -42 line
	DrawLine meterLeft+51, meterTop+16,meterLeft+51, meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -36 line
	DrawLine meterLeft+83, meterTop+16, meterLeft+83,meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -30 line
	DrawLine meterLeft+114, meterTop+16,meterLeft+114, meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -24 line
	DrawLine meterLeft+145, meterTop+16,meterLeft+145, meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -18 line
	DrawLine meterLeft+176, meterTop+16,meterLeft+176, meterTop+32
	SetDrawEnv linethick= 6,linefgc= (43690,65535,43690) 		// -12 green bar
	DrawLine meterLeft+209, meterTop+16,meterLeft+209, meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690) 	// -12 line
	DrawLine meterLeft+208, meterTop+16,meterLeft+208, meterTop+32
	SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690) 	// -6 line
	DrawLine meterLeft+238, meterTop+16,meterLeft+238, meterTop+32
	SetDrawEnv linethick= 5,linefgc= (65535,43690,43690) 		// 0 red bar
	DrawLine meterLeft+268, meterTop+15,meterLeft+268, meterTop+32
	
	ValDisplay vd_Peak_ch1,pos={meterLeft+7.00, meterTop+12.00},size={262.00,13.00},bodyWidth=250,title="1"
	ValDisplay vd_Peak_ch1,frame=0,limits={46,94,0},barmisc={0,0},mode= 3
	ValDisplay vd_Peak_ch1,value= #SpHrView_df_record_globals+"Peak_ch1"
	ValDisplay vd_Peak_ch2,pos={meterLeft+7.00, meterTop+22.00},size={263.00,13.00},bodyWidth=250,title="2"
	ValDisplay vd_Peak_ch2,frame=0,limits={46,94,0},barmisc={0,0},mode= 3
	ValDisplay vd_Peak_ch2,value= #SpHrView_df_record_globals+"Peak_ch2"
	
	TitleBox tickTxt_0,pos={meterLeft+267.00, meterTop+5.00},size={25.00,9.00},title="0 dB",fSize=9
	TitleBox tickTxt_0,frame=0,fixedSize=1
	TitleBox tickTxt_6,pos={meterLeft+231.00, meterTop+5.00},size={15.00,9.00},title="-6",fSize=9
	TitleBox tickTxt_6,frame=0,fixedSize=1
	TitleBox tickTxt_12,pos={meterLeft+199.00, meterTop+5.00},size={15.00,9.00},title="-12",fSize=9
	TitleBox tickTxt_12,frame=0,fixedSize=1
	TitleBox tickTxt_18,pos={meterLeft+167.00, meterTop+5.00},size={15.00,9.00},title="-18",fSize=9
	TitleBox tickTxt_18,frame=0,fixedSize=1
	TitleBox tickTxt_24,pos={meterLeft+136.00, meterTop+5.00},size={17.00,9.00},title="-24",fSize=9
	TitleBox tickTxt_24,frame=0,fixedSize=1
	TitleBox tickTxt_30,pos={meterLeft+104.00, meterTop+5.00},size={17.00,9.00},title="-30",fSize=9
	TitleBox tickTxt_30,frame=0,fixedSize=1
	TitleBox tickTxt_36,pos={meterLeft+73.00, meterTop+5.00},size={17.00,9.00},title="-36",fSize=9
	TitleBox tickTxt_36,frame=0,fixedSize=1
	TitleBox tickTxt_42,pos={meterLeft+40.00, meterTop+5.00},size={17.00,9.00},title="-42",fSize=9
	TitleBox tickTxt_42,frame=0,fixedSize=1
	
	// peak meter for channels 3 & 4 
	if(SoundInChannels >= 3)
		SetDrawLayer UserBack
		meterLeft = 110
		meterTop = 30
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -42 line
		DrawLine meterLeft+51, meterTop+16,meterLeft+51, meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -36 line
		DrawLine meterLeft+83, meterTop+16, meterLeft+83,meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -30 line
		DrawLine meterLeft+114, meterTop+16,meterLeft+114, meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -24 line
		DrawLine meterLeft+145, meterTop+16,meterLeft+145, meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690)		// -18 line
		DrawLine meterLeft+176, meterTop+16,meterLeft+176, meterTop+32
		SetDrawEnv linethick= 6,linefgc= (43690,65535,43690) 		// -12 green bar
		DrawLine meterLeft+209, meterTop+16,meterLeft+209, meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690) 	// -12 line
		DrawLine meterLeft+208, meterTop+16,meterLeft+208, meterTop+32
		SetDrawEnv linethick= 0.5,linefgc= (43690,43690,43690) 	// -6 line
		DrawLine meterLeft+238, meterTop+16,meterLeft+238, meterTop+32
		SetDrawEnv linethick= 5,linefgc= (65535,43690,43690) 		// 0 red bar
		DrawLine meterLeft+268, meterTop+15,meterLeft+268, meterTop+32
		ValDisplay vd_Peak_ch3,pos={meterLeft+7.00, meterTop+12.00},size={262.00,13.00},bodyWidth=250,title="3"
		ValDisplay vd_Peak_ch3,frame=0,limits={46,94,0},barmisc={0,0},mode= 3
		ValDisplay vd_Peak_Ch3,value= #SpHrView_df_record_globals+"Peak_ch3"
		ValDisplay vd_Peak_ch4,pos={meterLeft+7.00, meterTop+22.00},size={262.00,13.00},bodyWidth=250,title="4"
		ValDisplay vd_Peak_ch4,frame=0,limits={46,94,0},barmisc={0,0},mode= 3
		ValDisplay vd_Peak_ch4,value= #SpHrView_df_record_globals+"Peak_ch4"
	endif
	
	variable inputControlsLeft = 418
	SetVariable sv_InputDeviceName pos={inputControlsLeft+0, 5.00},size={130.00, 14.00},bodyWidth=130,proc=SpHrView_Rec_SetVariableProc,title=" "
	SetVariable sv_InputDeviceName limits={44100,96000,1},value= $SpHrView_df_record_globals+"InputDeviceName", noedit=0,focusRing=0
	SetVariable sv_SamplingRate pos={inputControlsLeft+2, 23.00},size={95.00, 14.00},title="rate (Hz)"
	SetVariable sv_SamplingRate limits={8000,19200,0},value= $SpHrView_df_record_globals+"Snd_fs",focusRing=0, noedit=1
	Button b_samplingRate pos={inputControlsLeft+92, 22.00},size={14.00,14.00},proc=SpHrView_Rec_ButtonProc,title=""
	Button b_samplingRate picture= ProcGlobal#SpHrView_pict_PopUpList
	
	Button b_recordingHelp pos={535,23},size={12,12},title="",picture= ProcGlobal#SpHrView_pict_Help,proc=SpHrView_Rec_ButtonProc
	GroupBox inputControlsGroup pos={inputControlsLeft-10, 2}, size={150, groupboxHeight}
		
	DoUpdate/W=RecordWindow // for Igor 9
	SetWindow RecordWindow, hook(RecordWindowHook)=SpHrView_Rec_WinHook
	
	if(floatingWindow)
		SetActiveSubwindow _endfloat_
	endif
	
	NVAR Snd_fs = $SpHrView_df_record_globals+"Snd_fs"
	NVAR framePnts = $SpHrView_df_record_globals+"framePnts"
	NVAR desiredFPS = $SpHrView_df_record_globals+"desiredFPS"
	desiredFPS = 45//30//45
	framePnts = round(Snd_fs / desiredFPS)
	wave/Z Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
	if(!waveexists(Snd_ch1) || !waveexists(Snd_ch2))
		Make/O/N=(framePnts) $SpHrView_df_record+"Snd_ch1"=0, $SpHrView_df_record+"Snd_ch2"=0
		wave Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
		SetScale/P x,0,1/Snd_fs,"s" Snd_ch1, Snd_ch2
	else
		Redimension/N=(framePnts) Snd_ch1, Snd_ch2
		SetScale/P x,0,1/Snd_fs,"s" Snd_ch1, Snd_ch2
	endif
	if(SoundInChannels>2)
		wave/Z Snd_ch3 = $SpHrView_df_record+"Snd_ch3", Snd_ch4 = $SpHrView_df_record+"Snd_ch4"
		if(!waveexists(Snd_ch3) || !waveexists(Snd_ch4))
			Make/O/N=(framePnts) $SpHrView_df_record+"Snd_ch3"=0, $SpHrView_df_record+"Snd_ch4"=0
			wave Snd_ch3 = $SpHrView_df_record+"Snd_ch3", Snd_ch4 = $SpHrView_df_record+"Snd_ch4"
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch3, Snd_ch4
		else
			Redimension/N=(framePnts) Snd_ch3, Snd_ch4
			SetScale/P x,0,1/Snd_fs,"s" Snd_ch3, Snd_ch4
		endif
	endif
	FIFOStatus/Q FIFO_SoundRecord
	if(!V_FIFORunning)
		SpHrView_Rec_FIFO_Start()
	endif
End

function SpHrView_Rec_Init()
	//variable rt_Mode
	DFREF saveDFR = GetDataFolderDFR()
	Variable nval
	String sval, FolderStr
	if(!DataFolderExists(SpHrView_df))	// Make "SpHrView" folder if it doesn't exist
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	if(!DataFolderExists(SpHrView_df_record))	// Make "SpHrView:Record" folder if it doesn't exist
		FolderStr= SpHrView_df_record[0,strlen(SpHrView_df_record)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_record
	// init global variables and FIFO2Wave waves
	if(!DataFolderExists(SpHrView_df_record_globals))	// Make "SpHrView:Record:Globals" folder and global variables
		FolderStr= SpHrView_df_record_globals[0,strlen(SpHrView_df_record_globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_df_record_globals
	nval = NumVarOrDefault(SpHrView_df_record_globals+"Snd_fs", 48000)
	Variable/G Snd_fs = nval
	QuerySoundManager(SpHrView_df_record+"Globals") // no trailing ":"	
	nval = NumVarOrDefault(SpHrView_df_record_globals+"doRecording", 0)
	Variable/G doRecording = nval
	nval = NumVarOrDefault(SpHrView_df_record_globals+"desiredFPS", 45) //30//45
	Variable/G desiredFPS = nval
	nval = NumVarOrDefault(SpHrView_df_record_globals+"framePnts", Snd_fs/desiredFPS)
	Variable/G framePnts = nval
	nval = NumVarOrDefault(SpHrView_df_record_globals+"RecChs_12_Only", 1)
	Variable/G RecChs_12_Only = nval
	nval = NumVarOrDefault(SpHrView_df_record_globals+"RecChs_34_as_12", 1)
	Variable/G RecChs_34_as_12 = nval
	nval = NumVarOrDefault(SpHrView_df_record_globals+"useChs34", 0)
	Variable/G useChs34 = nval

	//nval = NumVarOrDefault(SpHrView_df_record_globals+"triggerFrame", 0)
	//Variable/G triggerFrame = nval
	
//	Make/O/N=(framePnts, 2) $SpHrView_df_record+"untitled" = 0
//	wave untitled=$SpHrView_df_record+"untitled"
//	SetScale/P x 0, 1/Snd_fs, untitled
//	Make/O/N=(100, 2) $SpHrView_df_record+"untitled_peaks" = NaN
//	wave untitled_peaks = $SpHrView_df_record+"untitled_peaks"
//	SetScale/P x 0, framePnts/Snd_fs, untitled_peaks

	Variable/G lastWaveChunk= framePnts
	Variable/G FIFOFrameCnt= 0
	Variable/G recFrameNumber = 0
	Variable/G Peak_ch1=0, Peak_ch2=0
	Variable/G Peak_ch3=0, Peak_ch4=0
	
	Variable/G maxPeak_ch1=0, maxPeak_ch2=0
	Variable/G maxPeak_ch3=0, maxPeak_ch4=0
		
	string infoStr= IgorInfo(0)
	//variable numScreens = NumberByKey("NSCREENS", infoStr)	// Number of active displays
	string screenInfo = StringByKey("SCREEN1", infoStr)	// Number of active displays
	variable/G screenVert = str2num(ParseFilePath(0, screenInfo, ",", 1, 0))
	variable/G screenHoriz = str2num(ParseFilePath(0, screenInfo, ",", 1, 1))
	
	SetDataFolder saveDFR
end


Function SpHrView_Rec_helpNotebook()
	String nb = "RecordHelp"
	killwindow/Z $nb
	NewNotebook/K=1/N=$nb/F=1/V=1/K=1/ENCG={2,1}/W=(5,46,309,445) as "Record Help"
	Notebook $nb defaultTab=36, magnification=100
	Notebook $nb showRuler=0, rulerUnits=1, updating={1, 1}
	Notebook $nb newRuler=Normal, justification=0, margins={0,0,468}, spacing={0,0,0}, tabs={}, rulerDefaults={"Helvetica",11,0,(0,0,0)}
	Notebook $nb ruler=Normal, fStyle=1, text="Record Help\r"
	Notebook $nb fStyle=-1, text="\r"
	Notebook $nb text="Procedures in: SpHrView_Record.ipf\r"
	Notebook $nb text="\r"
	Notebook $nb text="General binaural/stereo sound recording procedures.\r"
	Notebook $nb text="\r"
	Notebook $nb ruler=Normal; Notebook $nb  margins={0,0,286}
	Notebook $nb text="The DataBrowser window will close if Igor's background task can't keep up.\r"
	Notebook $nb ruler=Normal, text="\r"
	Notebook $nb text="\r"
End


Function SpHrView_Rec_PeaksWindow()
	Killwindow/Z PeaksWindow
	NVAR screenHoriz = $SpHrView_df_record_globals+"screenHoriz"
	Display/K=1/W=(screenHoriz/2-300,150,screenHoriz/2+300,110+350) as "Untitled"
	DoWindow/C PeaksWindow
	ModifyGraph margin(left)=36,margin(bottom)=36,margin(right)=14,margin(top)=14
	ControlBar/T 37
	NewPanel/FG=(FL,FT,GR,GT)/HOST=# 
	RenameWindow #,PTop // PeaksWindow#PTop
	//TitleBox title0 title="Save:",pos={33,11.5},frame=0,fSize=11
	
	Button b_RecPeaks_View pos={30, 8}, size={60,21},fSize=12,title="View" // size={(15/15)*19,19}, picture=ProcGlobal#SpHrView_pict_GlassZoom
	Button b_RecPeaks_View win=PeaksWindow#PTop, proc=SpHrView_Rec_ButtonProc, help={"View sounds (and save as 'untitled' wave in Signals)"}
	
	Button b_RecPeaks_Play pos={110, 7}, picture=ProcGlobal#SpHrView_pict_circlePlay, size={(15/15)*21,21}, title=" "
	Button b_RecPeaks_Play win=PeaksWindow#PTop, proc=SpHrView_Rec_ButtonProc, help={"Play recorded sound"}
	Button b_RecPeaks_StopPlay pos={135, 7}, picture=ProcGlobal#SpHrView_pict_circleStop, size={(15/15)*21,21}, title=" "
	Button b_RecPeaks_StopPlay win=PeaksWindow#PTop, proc=SpHrView_Rec_ButtonProc, help={"Stop playing recorded sound"}
	
	Button b_RecPeaks_SaveFile pos={180, 8}, size={70,21},fSize=12,title="Save file" // , picture=ProcGlobal#pict_Filebox, size={(20/15)*19,19}
	Button b_RecPeaks_SaveFile win=PeaksWindow#PTop, proc=SpHrView_Rec_ButtonProc, help={"Save sounds to a File"}

	Button b_RecPeaks_SaveWave pos={260, 8}, size={70,21},fSize=12,title="Save wave" // picture=ProcGlobal#SpHrView_pict_Wave, size={(20/15)*19,19}
	Button b_RecPeaks_SaveWave win=PeaksWindow#PTop, proc=SpHrView_Rec_ButtonProc, help={"Save sounds to a Wave in Signals"}
	
	CheckBox ck_ViewAfterSaving fSize=10, title="View after saving",pos={340,10},value=1

	
	wave untitled_peaks = $SpHrView_df_record+"untitled_peaks"
	if(0 || dimsize(untitled_peaks,1)>=3)
		CheckBox ck_ViewPlayChs34 title="Chs 3 & 4",pos={490,10},variable=$SpHrView_df_record_globals+"useChs34"
	endif
	
	SetActiveSubwindow PeaksWindow //##
	
	//wave untitled_peaks = $SpHrView_df_record+"untitled_peaks"
	wave untitled_clips = $SpHrView_df_record+"untitled_clips"
	AppendToGraph/L=Left_Ch1/B=Bottom_Ch1 untitled_peaks[][0]; AppendToGraph/L=Left_Ch2/B=Bottom_Ch2 untitled_peaks[][1]
	if(1)
		ModifyGraph live(untitled_peaks)=1
		ModifyGraph live(untitled_peaks#1)=1
	endif
	ModifyGraph axisEnab(Left_Ch1)={0.54,1},axisEnab(Left_Ch2)={0,0.46}
	ModifyGraph freePos(Bottom_Ch1)={0.54,kwFraction},freePos(Bottom_Ch2)={0,kwFraction}
	ModifyGraph freePos(Left_Ch1)=0, freePos(Left_Ch2)=0
	ModifyGraph rgb(untitled_peaks)=(65535,0,0), rgb(untitled_peaks#1)=(0,0,65535)
	if(0) // lines
		ModifyGraph lsize=1
		ModifyGraph mode(untitled_peaks)=0,RGB(untitled_peaks)=(0,0,65535,19661)
		ModifyGraph mode(untitled_peaks#1)=0,RGB(untitled_peaks#1)=(65535,0,0,19661)
	else // lines filled from zero
		ModifyGraph lsize=0.5
		ModifyGraph mode(untitled_peaks)=7,usePlusRGB(untitled_peaks)=1
		ModifyGraph hbFill(untitled_peaks)=2,plusRGB(untitled_peaks)=(65535,0,0,19661)
		ModifyGraph mode(untitled_peaks#1)=7,usePlusRGB(untitled_peaks#1)=1
		ModifyGraph hbFill(untitled_peaks#1)=2,plusRGB(untitled_peaks#1)=(0,0,65535,19661)
	endif
	ModifyGraph fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4
	ModifyGraph btThick=0.5,stLen=2,stThick=0.5,font="Arial"
	ModifyGraph tick(Bottom_Ch1)=0, tick(Bottom_Ch2)=0
	ModifyGraph tick(Left_Ch1)=2,tick(Left_Ch2)=2
	SetAxis Left_Ch1 0,0.5
	SetAxis Left_Ch2 0,0.5
	ModifyGraph nticks(Left_Ch1)=2, nticks(Left_Ch2)=2
	ModifyGraph minor(Bottom_Ch1)=1, minor(Bottom_Ch2)=1
	ModifyGraph lblPos(Left_Ch1)=30, lblPos(Left_Ch2)=30
	Label Left_Ch1 "left (\\U)"
	Label Left_Ch2 "right (\\U)"
	Label Bottom_Ch2 "time (\\U)"
	Label Bottom_Ch1 "\\u#2"
	ModifyGraph lblPos(Bottom_Ch2)=30
	AppendToGraph /L=Left_Ch1/B=Bottom_Ch1 untitled_clips[][0]
	AppendToGraph /L=Left_Ch2/B=Bottom_Ch2 untitled_clips[][1]
	ModifyGraph mode(untitled_clips)=3, Marker(untitled_clips)=17
	ModifyGraph msize(untitled_clips)=3, rgb(untitled_clips)=(65535,0,0)
	ModifyGraph mode(untitled_clips#1)=3, Marker(untitled_clips#1)=17
	ModifyGraph msize(untitled_clips#1)=3, rgb(untitled_clips#1)=(65535,0,0)
	//Legend/C/N=ClipLegend/J/F=0/B=1/M/X=2.00/Y=2.00/E "\\s(untitled_clips)clip\r"
	TextBox/C/N=ClipText/V=0/F=0/B=1/M/E "\\s(untitled_clips)clip"
	
	if(dimsize(untitled_peaks,1)>=3)
		AppendToGraph/L=Left_Ch3/B=Bottom_Ch3 untitled_peaks[][2]; AppendToGraph/L=Left_Ch4/B=Bottom_Ch4 untitled_peaks[][3]
	
		ModifyGraph axisEnab(Left_Ch1)={0.77,1},axisEnab(Left_Ch2)={0.52,0.75}
		ModifyGraph axisEnab(Left_Ch3)={0.25,0.48},axisEnab(Left_Ch4)={0,0.23}
		ModifyGraph freePos=0
		ModifyGraph freePos(Bottom_Ch1)={0.77,kwFraction},freePos(Bottom_Ch2)={0.52,kwFraction}
		ModifyGraph freePos(Bottom_Ch3)={0.25,kwFraction},freePos(Bottom_Ch4)={0.0,kwFraction}
		
		ModifyGraph lsize=0.5
		ModifyGraph tickZap(Left_Ch1)={0},tickZap(Bottom_Ch1)={0},tickZap(Left_Ch2)={0},tickZap(Bottom_Ch2)={0},tickZap(Left_Ch3)={0},tickZap(Bottom_Ch3)={0},tickZap(Left_Ch4)={0},tickZap(Bottom_Ch4)={0}

		ModifyGraph rgb(untitled_peaks#2)=(65535,0,0), rgb(untitled_peaks#3)=(0,0,65535)
		ModifyGraph mode(untitled_peaks#2)=7,usePlusRGB(untitled_peaks#2)=1
		ModifyGraph hbFill(untitled_peaks#2)=2,plusRGB(untitled_peaks#2)=(65535,0,0,19661)
		ModifyGraph mode(untitled_peaks#3)=7,usePlusRGB(untitled_peaks#3)=1
		ModifyGraph hbFill(untitled_peaks#3)=2,plusRGB(untitled_peaks#3)=(0,0,65535,19661)
		
		ModifyGraph fSize=10,axThick=0.5,ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen=4
		ModifyGraph btThick=0.5,stLen=2,stThick=0.5,font="Arial"
		ModifyGraph tick(Bottom_Ch1)=0, tick(Bottom_Ch2)=0
		ModifyGraph tick(Left_Ch1)=2,tick(Left_Ch2)=2
		SetAxis Left_Ch3 0,0.5
		SetAxis Left_Ch4 0,0.5
		
		ModifyGraph nticks(Left_Ch3)=2, nticks(Left_Ch4)=2
		ModifyGraph minor(Bottom_Ch3)=1, minor(Bottom_Ch4)=1
		ModifyGraph lblPos(Left_Ch3)=30, lblPos(Left_Ch4)=30
		Label Left_Ch1 "1 (\\U)"
		Label Left_Ch2 "2\\u#2"
		Label Left_Ch3 "3\\u#2"
		Label Left_Ch4 "4\\u#2"
		Label Bottom_Ch3 "\\u#2"
		Label Bottom_Ch4 "\\u#2"
		ModifyGraph lblPos(Bottom_Ch3)=30
		ModifyGraph lblPos(Bottom_Ch4)=30
		AppendToGraph /L=Left_Ch3/B=Bottom_Ch3 untitled_clips[][2]
		AppendToGraph /L=Left_Ch4/B=Bottom_Ch4 untitled_clips[][3]
		ModifyGraph mode(untitled_clips#2)=3, Marker(untitled_clips#2)=17
		ModifyGraph msize(untitled_clips#2)=3, rgb(untitled_clips#2)=(65535,0,0)
		ModifyGraph mode(untitled_clips#3)=3, Marker(untitled_clips#3)=17
		ModifyGraph msize(untitled_clips#3)=3, rgb(untitled_clips#3)=(65535,0,0)
	endif
	
	DoUpdate/W=PeaksWindow // for Igor 9
	SetWindow PeaksWindow, hook(PeaksWindowHook)=SpHrView_Rec_WinHook
End

Function SpHrView_Rec_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	variable restart
	strswitch(ba.ctrlName)
		case "b_recordingHelp":
			switch( ba.eventCode )
				case 1: // mouse down
					SpHrView_Rec_helpNotebook()
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_StartRecording":
			switch( ba.eventCode )
				case 1: // mouse down
					Button b_startRecording win=RecordWindow, rename=b_PauseRecording, picture= ProcGlobal#SpHrView_pict_circlePause //title="   Pause\\K(0,0,65535)\\k(0,0,65535)\\W516"
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 1
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_PauseRecording":
			switch( ba.eventCode )
				case 1: // mouse down
					Button b_PauseRecording win=RecordWindow, rename=b_startRecording, picture= ProcGlobal#SpHrView_pict_circleRecord //title="   Record\\K(65535,0,0)\\k(65535,0,0)\\W519"
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 0
					//dowindow PeaksWindow
					//if(V_flag)
					//endif
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_RecPeaks_View":
			switch( ba.eventCode )
				case 1: // mouse down
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 0
					//record_FIFO_Stop()
					wave untitled=$SpHrView_df_record+"untitled"
					Duplicate/O untitled, $SpHrView_df_waves+"untitled"
					//Killwindow/Z PeaksWindow
					//Killwindow/Z RecordWindow
					SpHrView_LoadPeaksFromWave("untitled", -1, -1, 0, 0)
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_RecPeaks_SaveFile":
			switch( ba.eventCode )
				case 1: // mouse down
					restart=0
					FIFOStatus/Q FIFO_SoundRecord
					if(V_FIFORunning)
						restart = 1
					endif
					SpHrView_Rec_FIFO_Stop()
					wave untitled=$SpHrView_df_record+"untitled"
					String FileNameStr = ""
					PathInfo StereoSoundsPath
					if(V_flag && strlen(S_path)>1)
						SoundSaveWave/I/P=StereoSoundsPath "WAVE", untitled, "untitled.wav" // or "AIFC"
					else
						SoundSaveWave/I "WAVE", untitled, "untitled.wav" // or "AIFC"
						if(V_flag)
							NewPath/O/Q/Z StereoSoundsPath, S_path
						endif
					endif
					return 0
					//Print V_flag
					if(V_flag>=0)
						FileNameStr = S_path+S_fileName
					else
						Killwindow/Z RecordWindow
						break
					endif
					ControlInfo /W=PeaksWindow#PTop ck_ViewAfterSaving
					if(V_flag == 2 && V_Value)
						// view in model
						Killwindow/Z PeaksWindow
						Killwindow/Z RecordWindow
						SpHrView_LoadPeaksFromFile(FileNameStr, -1 , -1, 0, 0, 0, 0)
					else
						if(restart)
							SpHrView_Rec_FIFO_Start()
						endif
					endif
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_RecPeaks_SaveWave":
			switch( ba.eventCode )
				case 1: // mouse down
					restart=0
					FIFOStatus/Q FIFO_SoundRecord
					if(V_FIFORunning)
						restart = 1
					endif
					SpHrView_Rec_FIFO_Stop()
					String WaveNameStr = "untitled"
					Prompt WaveNameStr, "Enter name of wave: "		// Set prompt for y param
					DoPrompt "Save as wave", WaveNameStr
					if (V_Flag)
						break
					else
						if(!DataFolderExists(SpHrView_df_waves))	// Make "RealTime" folder if it doesn't exist
							String FolderStr= SpHrView_df_waves[0,strlen(SpHrView_df_waves)-2] // remove trailing ":"
							NewDataFolder/O $FolderStr
						endif
						wave untitled=$SpHrView_df_record+"untitled"
						Duplicate/O untitled, $SpHrView_df_waves+WaveNameStr
					endif
					ControlInfo /W=PeaksWindow#PTop ck_ViewAfterSaving
					if(V_flag == 2 && V_Value)
						// view in model
						Killwindow/Z PeaksWindow
						Killwindow/Z RecordWindow
						SpHrView_LoadPeaksFromWave(WaveNameStr, -1, -1, 0, 0)
					else
						if(restart)
							SpHrView_Rec_FIFO_Start()
						endif
					endif
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_RecPeaks_Play":
			switch( ba.eventCode )
				case 1: // mouse down
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 0
					//restart=0
					//FIFOStatus/Q FIFO_SoundRecord
					//if(V_FIFORunning)
					//	restart = 1
					//endif
					//SpHrView_Rec_FIFO_Stop()
					wave/Z untitled = $SpHrView_df_record+"untitled"
					if(dimsize(untitled,1)>2 && waveexists(untitled))
						NVAR useChs34 = $SpHrView_df_record_globals+"useChs34"
						GetMarquee/W=PeaksWindow/Z Bottom_Ch1
						if(V_flag)
							variable leftPnt = ScaleToIndex(untitled, V_left, 0)
							variable rightPnt = ScaleToIndex(untitled, V_right, 0)
							if(useChs34)
								Duplicate/O/RMD=[leftPnt,rightPnt][2,3] untitled, temp
								PlaySound/A=2 temp
								Killwaves/Z temp
							else
								Duplicate/O/RMD=[leftPnt,rightPnt][0,1] untitled, temp
								PlaySound/A=2 temp
								Killwaves/Z temp
							endif
						else
							if(useChs34)
								Duplicate/O/RMD=[0,dimsize(untitled,0)-1][2,3] untitled, temp
								PlaySound/A=2 temp
								Killwaves/Z temp
							else
								Duplicate/O/RMD=[0,dimsize(untitled,0)-1][0,1] untitled, temp
								PlaySound/A=2 temp
								Killwaves/Z temp
							endif
						endif
					else
						if(waveexists(untitled))
							GetMarquee/W=PeaksWindow/Z Bottom_Ch1
							if(V_flag)
								Duplicate/O/R=(V_left,V_right) untitled, temp
								PlaySound/A=2 temp
								Killwaves temp
							else
								PlaySound/A=2 untitled
							endif
						endif
					endif
					//if(restart)
					//	SpHrView_Rec_FIFO_Start()
					//endif
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_RecPeaks_StopPlay":
			switch( ba.eventCode )
				case 1: // mouse down
					StopPlaySound()
					break
				case -1: // control being killed
					break
			endswitch
			break

			
		case "b_samplingRate":
			switch( ba.eventCode )
				case 2: // mouse up
					Killwindow/Z PeaksWindow
					restart=0
					FIFOStatus/Q FIFO_SoundRecord
					if(V_FIFORunning)
						restart = 1
					endif
					SpHrView_Rec_FIFO_Stop()
					SVAR rateList = $SpHrView_df_record_globals+"rateList"
					PopupContextualMenu rateList
					if(v_flag)
						NVAR Snd_fs = $SpHrView_df_record_globals+"Snd_fs"
						Snd_fs = str2num(StringFromList(v_flag-1, rateList))
					endif
					wave/Z Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
					NVAR Snd_fs = $SpHrView_df_record_globals+"Snd_fs"
					NVAR framePnts = $SpHrView_df_record_globals+"framePnts"
					NVAR desiredFPS = $SpHrView_df_record_globals+"desiredFPS"
					desiredFPS = 45//30//45
					framePnts = round(Snd_fs / desiredFPS)
					if(!waveexists(Snd_ch1) || !waveexists(Snd_ch2))
						Make/O/N=(framePnts) $SpHrView_df_record+"Snd_ch1"=0, $SpHrView_df_record+"Snd_ch2"=0
						wave Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
						SetScale/P x,0,1/Snd_fs,"s" Snd_ch1, Snd_ch2
					else
						Redimension/N=(framePnts) Snd_ch1, Snd_ch2
						SetScale/P x,0,1/Snd_fs,"s" Snd_ch1, Snd_ch2
					endif
					if(restart)
						SpHrView_Rec_FIFO_Start()
					endif
					break
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_ViewWaves":
			switch( ba.eventCode )
				case 2: // mouse up
					SpHrView_WaveListWindow(SpHrView_df_waves, 1)
					break
				case -1: // control being killed
					break
			endswitch
			break
			
	endswitch
	return 0
End

//Function SpHrView_Rec_PopMenuProc(pa) : PopupMenuControl
//	STRUCT WMPopupAction &pa
//	strswitch(pa.ctrlName)
//		case "":
//			switch( pa.eventCode )
//				case 2: // mouse up
//					Variable popNum = pa.popNum
//					String popStr = pa.popStr
//					strswitch(popStr)
//						case "":
//							break
//					endswitch
//					break
//				case -1: // control being killed
//					break
//			endswitch
//		break
//	endswitch
//	return 0
//End

Function SpHrView_Rec_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			strswitch(cba.ctrlName)		
				case "ck_RecChs_12_Only":
					NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
					NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
					if(RecChs_34_as_12 && RecChs_12_Only)
						RecChs_34_as_12 = 0
					endif
					break
				case "ck_RecChs_34_as_12":
					NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
					NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
					if(RecChs_12_Only && RecChs_34_as_12)
						RecChs_12_Only = 0
					endif
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SpHrView_Rec_SetVariableProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	Variable dval = sva.dval
	String sval = sva.sval
	strswitch(sva.ctrlName)			
		case "sv_InputDeviceName":
			switch( sva.eventCode )
				case 1: // mouse up
				case 2: // enter key
				case 3: // live update
					QuerySoundManager(SpHrView_df_record+"Globals") // no trailing ":"
					break
			endswitch
			break
	endswitch
	return 0
End

function SpHrView_Rec_WinHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0
	switch(s.eventCode)
		case 2:	// Kill
			Variable i
			string traceListStr, NameStr
			strswitch(s.winName)
				case "RecordWindow":
					CtrlNamedBackground Bkgrnd_record_FIFO, kill
					FIFOStatus/Q FIFO_SoundRecord
					if(V_FIFORunning)
						SpHrView_Rec_FIFO_Stop()
					endif
					if(V_flag)
						KillFIFO FIFO_SoundRecord
					endif
					Execute/Z/Q/P "Killwindow/Z RecordHelp"
					Execute/Z/Q/P "KillWaves/Z "+SpHrView_df_record+"Snd_ch1, "+SpHrView_df_record+"Snd_ch2"
					Execute/Z/Q/P "KillWaves/Z "+SpHrView_df_record+"Snd_ch3, "+SpHrView_df_record+"Snd_ch4"
					hookResult = 1
					break
					
				case "PeaksWindow":
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 0
					NVAR recFrameNumber= $SpHrView_df_record_globals+"recFrameNumber"
					recFrameNumber = 0
					ControlInfo/W=RecordWindow b_PauseRecording
					if(V_flag)
						Button b_PauseRecording win=RecordWindow, rename=b_startRecording, picture= ProcGlobal#SpHrView_pict_circleRecord //, title="   Record\\K(65535,0,0)\\k(65535,0,0)\\W519"
					endif
					Execute/Z/Q/P "KillWaves/Z $"+SpHrView_df_record+"untitled, $"+SpHrView_df_record+"untitled_peaks, $"+SpHrView_df_record+"untitled_clips"
					hookResult = 1
					break
			endswitch
			break
			
		case 11:	// keyboard
			if(s.keycode == 32) // space bar
				if(1)
					NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
					doRecording = 0
					ControlInfo/W=RecordWindow b_startRecording
					if(V_flag)
						Button/Z b_startRecording win=RecordWindow, rename=b_PauseRecording, picture= ProcGlobal#SpHrView_pict_circlePause //, title="   Pause\\K(0,0,65535)\\k(0,0,65535)\\W516"
						doRecording = 1
					else
						Button/Z b_PauseRecording win=RecordWindow, rename=b_startRecording, picture= ProcGlobal#SpHrView_pict_circleRecord //, title="   Record\\K(65535,0,0)\\k(65535,0,0)\\W519"
						doRecording = 0
					endif
					
				else
					FIFOStatus/Q FIFO_SoundRecord
					if(V_FIFORunning)
						SpHrView_Rec_FIFO_Stop()
					else
						SpHrView_Rec_FIFO_Start()
					endif
				endif
				hookResult = 1
			endif
			break
		
	endswitch
	return hookResult		// 0 if nothing done, else 1
End

function SpHrView_Rec_FIFO_Start()
	if(strlen(GetBrowserSelection(-1))>1)
		ModifyBrowser clearSelection
	endif
	FIFOStatus/Q FIFO_SoundRecord
	if( V_FLag )
		KillFIFO FIFO_SoundRecord
		DoUpdate
	endif
	NVAR SoundInChannels = $SpHrView_df_record_globals+"SoundInChannels"
	wave Snd_ch1=$SpHrView_df_record+"Snd_ch1"
	//wave Snd_ch2=$SpHrView_df_record+"Snd_ch2"
	NVAR Snd_fs= $SpHrView_df_record_globals+"Snd_fs"
	NVAR desiredFPS = $SpHrView_df_record_globals+"desiredFPS"
	NVAR lastWaveChunk = $SpHrView_df_record_globals+"lastWaveChunk";	lastWaveChunk = numpnts(Snd_ch1)
	NVAR FIFOFrameCnt = $SpHrView_df_record_globals+"FIFOFrameCnt"; 				FIFOFrameCnt = 0
	//NVAR bufferUsage = $SpHrView_df_record_globals+"bufferUsage"; 		bufferUsage = 0
	NVAR recFrameNumber= $SpHrView_df_record_globals+"recFrameNumber";		recFrameNumber = 0
	NVAR doRecording= $SpHrView_df_record_globals+"doRecording";		doRecording = 0
	
	NewFIFO FIFO_SoundRecord
	NewFIFOChan/S FIFO_SoundRecord,ch1  0,1,-1,1,"Pa"	
	NewFIFOChan/S FIFO_SoundRecord,ch2  0,1,-1,1,"Pa"
	if(SoundInChannels>2)
		NewFIFOChan/S FIFO_SoundRecord,ch3  0,1,-1,1,"Pa"	
		NewFIFOChan/S FIFO_SoundRecord,ch4  0,1,-1,1,"Pa"
	endif
	CtrlFIFO FIFO_SoundRecord,deltaT= 1/Snd_fs,size= 400000
	FIFOStatus/Q FIFO_SoundRecord
	CtrlFIFO FIFO_SoundRecord, start
	SoundInStartChart 200000, FIFO_SoundRecord
	if( GetRTError(0) == 0 )
		CtrlNamedBackground Bkgrnd_record_FIFO, proc=SpHrView_Rec_getFIFOWaves, period=60/desiredFPS, start
		return 1
	else
		DoAlert 0, "Error starting peaks meter & recording background task"
		return 0
	endif
end

function SpHrView_Rec_FIFO_Stop()
	SoundInStopChart/Z
	CtrlNamedBackground Bkgrnd_record_FIFO, stop
	FIFOStatus/Q FIFO_SoundRecord
	if(V_FIFORunning)
		CtrlFIFO FIFO_SoundRecord, stop
	endif
	NVAR/Z doRecording = $SpHrView_df_record_globals+"doRecording"
	if(NVAR_Exists(doRecording))														//08/15/17
		doRecording = 0
	endif
	return 1 // return 1 if no errors
end


function SpHrView_Rec_getFIFOWaves(s)
	STRUCT WMBackgroundStruct &s
	NVAR SoundInChannels = $SpHrView_df_record_globals+"SoundInChannels"
	if(SoundInChannels > 2)
		wave Snd_ch1=$SpHrView_df_record+"Snd_ch1"
		wave Snd_ch2=$SpHrView_df_record+"Snd_ch2"
		wave Snd_ch3=$SpHrView_df_record+"Snd_ch3"
		wave Snd_ch4=$SpHrView_df_record+"Snd_ch4"
	else
		wave Snd_ch1=$SpHrView_df_record+"Snd_ch1"
		wave Snd_ch2=$SpHrView_df_record+"Snd_ch2"
	endif
	NVAR Snd_fs = $SpHrView_df_record_globals+"Snd_fs"
	NVAR desiredFPS = $SpHrView_df_record_globals+"desiredFPS"
	NVAR framePnts = $SpHrView_df_record_globals+"framePnts"
	NVAR FIFOFrameCnt = $SpHrView_df_record_globals+"FIFOFrameCnt"
	NVAR lastWaveChunk=$SpHrView_df_record_globals+"lastWaveChunk"
	FIFOStatus/Q FIFO_SoundRecord
	variable currentChunk = V_FIFOChunks
	if(currentChunk > lastWaveChunk)
		if(currentChunk - lastWaveChunk > framePnts*10) // fraction of FIFO buffer = (currentChunk - lastWaveChunk)/framePnts*4
			if(currentChunk - lastWaveChunk > Snd_fs*2) //~Snd_fs
				SpHrView_Rec_FIFO_Stop()
				Killwindow/Z RecordWindow
				DoAlert 0, "Recording interupted and stopped."
				//Print "Recording interupted and stopped."
				return 1
			else
				desiredFPS += 1
				desiredFPS = min(45, desiredFPS)
				CtrlNamedBackground Bkgrnd_record_FIFO, period=60/desiredFPS, burst=1
				ControlInfo/W=RecordWindow b_startRecording
				if(V_flag)
					Button b_startRecording win=RecordWindow, disable=2
				endif

					string dbStr = GetBrowserSelection(-1)
					if(strlen(dbStr)>1)
						if(1)
							ModifyBrowser close
							//ModifyBrowser collapseAll
						elseif(0)
							ModifyBrowser clearSelection
							ModifyBrowser showPlot=0
							ModifyBrowser showInfo=0
						endif
				endif
			endif
		else
			desiredFPS = 45//30//45
			CtrlNamedBackground Bkgrnd_record_FIFO, period=60/desiredFPS, burst=1
			ControlInfo/W=RecordWindow b_startRecording
			if(V_flag)
				Button b_startRecording win=RecordWindow, disable=0
			endif
		endif
		if(SoundInChannels >= 3 )
			NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
			NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
			if(RecChs_12_Only)
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch1, Snd_ch1
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch2, Snd_ch2
			elseif(RecChs_34_as_12)
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch1, Snd_ch1
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch2, Snd_ch2
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch3, Snd_ch1
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch4, Snd_ch2
			else
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch1, Snd_ch1
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch2, Snd_ch2
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch3, Snd_ch3
				FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch4, Snd_ch4
			endif
		else
			FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch1, Snd_ch1
			FIFO2Wave/S=0/R=[lastWaveChunk-framePnts+1, lastWaveChunk] FIFO_SoundRecord,ch2, Snd_ch2
		endif
		
		SpHrView_Rec_PeaksMeter_Update()
		NVAR doRecording = $SpHrView_df_record_globals+"doRecording"
		if(doRecording) // recording
			SpHrView_Rec_insertFramePnts()
		endif
		lastWaveChunk += framePnts // increment to beginning of next frame
		FIFOFrameCnt += 1
	endif
	return 0
end

function SpHrView_Rec_PeaksMeter_Update()
	dowindow RecordWindow
	if(V_flag) // peaks -- try turning off if having trouble updating... 

		wave Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
		NVAR Peak_ch1= $SpHrView_df_record_globals+"Peak_ch1"
		NVAR Peak_ch2= $SpHrView_df_record_globals+"Peak_ch2"
		
		SpHr_Extrema /MaxM /PMax=(0.00399052) Snd_ch1		// 10^( 46 dB/20)*0.00002 = 0.00399052
		Peak_ch1 = 20*log(V_MaxMag*50000)// /0.00002)
		SpHr_Extrema /MaxM /PMax=(0.00399052) Snd_ch2		// 10^( 46 dB/20)*0.00002 = 0.00399052
		Peak_ch2 = 20*log(V_MaxMag*50000)// /0.00002)
		
		NVAR SoundInChannels = $SpHrView_df_record_globals+"SoundInChannels"
		if(SoundInChannels >= 3)
			NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
			NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
			if(RecChs_12_Only || RecChs_34_as_12)
				NVAR Peak_ch3= $SpHrView_df_record_globals+"Peak_ch3"
				NVAR Peak_ch4= $SpHrView_df_record_globals+"Peak_ch4"
				Peak_ch3 = 0
				Peak_ch4 = 0
			else
				wave Snd_ch3 = $SpHrView_df_record+"Snd_ch3", Snd_ch4 = $SpHrView_df_record+"Snd_ch4"
				NVAR Peak_ch3= $SpHrView_df_record_globals+"Peak_ch3"
				NVAR Peak_ch4= $SpHrView_df_record_globals+"Peak_ch4"
				
				SpHr_Extrema /MaxM /PMax=(0.00399052) Snd_ch3		// 10^( 46 dB/20)*0.00002 = 0.00399052
				Peak_ch3 = 20*log(V_MaxMag*50000)// /0.00002)
				SpHr_Extrema /MaxM /PMax=(0.00399052) Snd_ch4		// 10^( 46 dB/20)*0.00002 = 0.00399052
				Peak_ch4 = 20*log(V_MaxMag*50000)// /0.00002)
		
			endif
		endif
	endif
end

function SpHrView_Rec_insertFramePnts()
	NVAR framePnts= $SpHrView_df_record_globals+"framePnts"
	NVAR Snd_fs= $SpHrView_df_record_globals+"Snd_fs"
	NVAR recFrameNumber= $SpHrView_df_record_globals+"recFrameNumber"
	NVAR FIFOFrameCnt = $SpHrView_df_record_globals+"FIFOFrameCnt"
	//NVAR triggerFrame= $SpHrView_df_record_globals+"triggerFrame"
	wave/Z untitled=$SpHrView_df_record+"untitled"
	wave/Z untitled_peaks=$SpHrView_df_record+"untitled_peaks"
	wave/Z untitled_clips=$SpHrView_df_record+"untitled_clips"
	variable defaultPeakNum = ceil((Snd_fs/framePnts)*2+1)
	
	variable NumChs = 2
	NVAR SoundInChannels = $SpHrView_df_record_globals+"SoundInChannels"
	NVAR RecChs_12_Only = $SpHrView_df_record_globals+"RecChs_12_Only"
	NVAR RecChs_34_as_12 = $SpHrView_df_record_globals+"RecChs_34_as_12"
	if(SoundInChannels <= 2 || RecChs_12_Only || RecChs_34_as_12)
		NumChs = 2
	else
		NumChs = 4
	endif
	variable untitled_NumChs = dimsize(untitled,1)
	
	if(recFrameNumber== 0 || !waveexists(untitled) || !waveexists(untitled_peaks) || NumChs != untitled_NumChs)	
		Make/O/N=(framePnts, NumChs) $SpHrView_df_record+"untitled" = 0
		wave untitled=$SpHrView_df_record+"untitled"
		SetScale/P x 0, 1/Snd_fs, "s", untitled
		Make/O/N=(defaultPeakNum, NumChs) $SpHrView_df_record+"untitled_peaks" = NaN
		wave untitled_peaks = $SpHrView_df_record+"untitled_peaks"
		SetScale/P x 0, framePnts/Snd_fs, "s", untitled_peaks
		Make/O/N=(defaultPeakNum, NumChs) $SpHrView_df_record+"untitled_clips" = NaN
		wave untitled_clips = $SpHrView_df_record+"untitled_clips"
		SetScale/P x 0, framePnts/Snd_fs, "s", untitled_clips
		SetScale d 0,0,"Pa", untitled_peaks, untitled_clips, untitled
		
		NVAR maxPeak_ch1 = $SpHrView_df_record_globals+"maxPeak_ch1"
		NVAR maxPeak_ch2 = $SpHrView_df_record_globals+"maxPeak_ch2"
		NVAR maxPeak_ch3 = $SpHrView_df_record_globals+"maxPeak_ch3"
		NVAR maxPeak_ch4 = $SpHrView_df_record_globals+"maxPeak_ch4"
		maxPeak_ch1 = 0
		maxPeak_ch2 = 0
		maxPeak_ch3 = 0
		maxPeak_ch4 = 0
	endif
	
	wave Snd_ch1 = $SpHrView_df_record+"Snd_ch1", Snd_ch2 = $SpHrView_df_record+"Snd_ch2"
	variable numRows = dimsize(untitled, 0)
	Redimension/N=((recFrameNumber+1)*framePnts,-1) untitled
	untitled[((recFrameNumber+0)*framePnts),((recFrameNumber+1)*framePnts)-1][0] = Snd_ch1[p-((recFrameNumber+0)*framePnts)]
	untitled[((recFrameNumber+0)*framePnts),((recFrameNumber+1)*framePnts)-1][1] = Snd_ch2[p-((recFrameNumber+0)*framePnts)]
	
	wave/Z Snd_ch3 = $SpHrView_df_record+"Snd_ch3", Snd_ch4 = $SpHrView_df_record+"Snd_ch4"
	if(untitled_NumChs >= 3 )//&& waveexists(Snd_ch3) && waveexists(Snd_ch4))
		untitled[((recFrameNumber+0)*framePnts),((recFrameNumber+1)*framePnts)-1][2] = Snd_ch3[p-((recFrameNumber+0)*framePnts)]
		untitled[((recFrameNumber+0)*framePnts),((recFrameNumber+1)*framePnts)-1][3] = Snd_ch4[p-((recFrameNumber+0)*framePnts)]
	endif
	
	
	if(recFrameNumber >= defaultPeakNum) // intial number of points is 100
		Redimension/N=((recFrameNumber+1),-1) untitled_peaks, untitled_clips
	endif
	
	NVAR maxPeak_ch1 = $SpHrView_df_record_globals+"maxPeak_ch1"
	NVAR maxPeak_ch2 = $SpHrView_df_record_globals+"maxPeak_ch2"

	variable peak_Ch1, peak_Ch2
	peak_Ch1 = wavemax(Snd_ch1)
	maxPeak_ch1 = max(maxPeak_ch1,peak_Ch1)
	untitled_peaks[recFrameNumber][0] = peak_Ch1 // 20*log(peak/0.00002)
	peak_Ch2 = wavemax(Snd_ch2)
	maxPeak_ch2 = max(maxPeak_ch1,peak_Ch2)
	untitled_peaks[recFrameNumber][1] = peak_Ch2 // 20*log(peak/0.00002)
	if(peak_Ch1 > 1)
		untitled_clips[recFrameNumber][0] = 0.25
		TextBox/W=PeaksWindow/C/N=ClipText/V=1
	else
		untitled_clips[recFrameNumber][0] = NaN
	endif
	if(peak_Ch2 > 1)
		untitled_clips[recFrameNumber][1] = 0.25
		TextBox/W=PeaksWindow/C/N=ClipText/V=1
	else
		untitled_clips[recFrameNumber][1] = NaN
	endif
	
	if(untitled_NumChs >= 3 )//&& waveexists(Snd_ch3) && waveexists(Snd_ch4))
		NVAR maxPeak_ch3 = $SpHrView_df_record_globals+"maxPeak_ch3"
		NVAR maxPeak_ch4 = $SpHrView_df_record_globals+"maxPeak_ch4"
		
		variable peak_Ch3, peak_Ch4
		peak_Ch3 = wavemax(Snd_ch3)
		maxPeak_ch3 = max(maxPeak_ch1,peak_Ch3)
		untitled_peaks[recFrameNumber][2] = peak_Ch3 // 20*log(peak/0.00002)
		peak_Ch4= wavemax(Snd_ch4)
		maxPeak_ch4 = max(maxPeak_ch1,peak_Ch4)
		untitled_peaks[recFrameNumber][3] = peak_Ch4 // 20*log(peak/0.00002)
		if(peak_Ch3 > 1)
			untitled_clips[recFrameNumber][2] = 0.25
			TextBox/W=PeaksWindow/C/N=ClipText/V=1
		else
			untitled_clips[recFrameNumber][2] = NaN
		endif
		if(peak_Ch4 > 1)
			untitled_clips[recFrameNumber][3] = 0.25
			TextBox/W=PeaksWindow/C/N=ClipText/V=1
		else
			untitled_clips[recFrameNumber][3] = NaN
		endif
	endif
	
	if(recFrameNumber==0)
		SpHrView_Rec_PeaksWindow()
	endif
	
	// scale amplitude axes and modify plot for longer recordings
	if(recFrameNumber == 2000)
		ModifyGraph/Z/W=PeaksWindow lsize=0
		ModifyGraph/Z/W=PeaksWindow rgb(untitled_peaks)=(65535,0,0), rgb(untitled_peaks#1)=(0,0,65535)
	endif
	
	if(1)
		variable MaxPeak_Chs12 = max(maxPeak_ch1, maxPeak_ch1)
		SetAxis/W=PeaksWindow/Z Left_Ch1 0, MaxPeak_Chs12
		SetAxis/W=PeaksWindow/Z Left_Ch2 0, MaxPeak_Chs12
		if(untitled_NumChs >= 3 )
			variable MaxPeak_Chs34 = max(maxPeak_ch3, maxPeak_ch4)
			SetAxis/W=PeaksWindow/Z Left_Ch3 0, MaxPeak_Chs34
			SetAxis/W=PeaksWindow/Z Left_Ch4 0, MaxPeak_Chs34
		endif
	else
	
	endif
	
	recFrameNumber += 1
end 


Function SpHrView_Rec_PlaySignalMenu()
	String PopUpListStr = "Gaussian Noise;Spectrum Noise" //"Current Signal;"
	PopupContextualMenu/ASYN=record_PlaySignalSelect PopUpListStr
End
Function SpHrView_Rec_PlaySignalSelect(popupStr, selectedText, menuItemNum)
	String popupStr, selectedText
	Variable menuItemNum
	strswitch(selectedText)
//		case "Current Signal":
//			wave Signal= $ksBV_Record_playRec_dfStr+"Signal"
//			if(waveexists(Signal))
//				PlaySound/A Signal
//			endif
//			break
			
		case "Gaussian Noise":
			//playRec_GaussNoisePanel()
			break
		case "Spectrum Noise":
			//playRec_SpectrumNoisePanel()
			break
	
	endswitch
	//Printf "%s, %s, %g\r", popupStr, selectedText, menuItemNum
End

// PNG: width= 45, height= 15
Picture SpHrView_pict_circleRecord
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!#3!!!!`#Qau+!7_T;M?!V[CM?aMFBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TA7IbHBQS?83\N.*F`M:NDfTJDA7I9(
	Ch7HpDKKqQ0eP16+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2D(fIFBkB"Q/heq&$6U
	H6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<VdLG\q87F#n8RDffo=B
	Q%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>DK@j`D/_W^BQS?83\N.
	(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3a/n&:/@V%0%Df%.P@;
	mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06goE0/5(506:*<E+L\#
	ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^0fV-:$6UH6AU%p$3`'O8ASbL;Bl.
	F!F(oQ14X)d?+poG8+D#e3Ai`:tCi=>mE+*6f4X)U)$6UH6FD5?!3_=0sB4Y.YA9;KJ+u)&:+poG8+
	EV=0Ai`M#@:s.FASu.&BK[Ot1Em/K+<Yc?AnF)%ATMd+F`_>9DH1RgF?Lg'+poG8+EV=0Aia$lATMd
	+F`_>9DET1"0JG+5+poG8+EV=0Aia'mATMd+F`_>9DET1"0JG+5+poG8+E2"4FDl56Df@a)Des?49l
	FQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+k:*$6UH6G\qC\9lFQV
	ApHdQFCdTZ1,(I;/MK"50eu]_1-.*E3\rKB0JkgE0HpiH+<YoGE&p^)FCA]gFC@RGFCdTZ1,(I;/MK
	"50eu]_1-.*E3\rKB0JkgE0Hr[f+<VdhA7IZBBln0&4piDT+<WdeA7dkgCihiJ+<VdL+?X[TAiaaB+
	F%a>3c&5BB0@G`/S&F)@<HC.,!KIYFEDG=+EV13E,8s)AKW]bGVM(#1H[=2A7dl=Bg)kH+<Vdh061T
	83^IS(4piDT+?V;f@le^GFDPMP$6UH64Et^^9hdZ>BleB7Ed9hU+<VdL4E=tE3`BU04piDT+<VdhEb
	&cCChX5!+<VdL+EMWnG'#cR@ruF'DET1_Ec5K2@qB0p$6UH6+<VeJF@C@p3cf4OFE_/6AO0s?DKJ#c
	6"X_CDJ=3<+@Kd^BkM<pEZcc)@<*JH0d&5*1,(.$$6UH6+<VeJF@C@p3d57KDET1!0JY=60Jk@91/o
	t`3\W<M1GLI81cd<E+tl+e+<VdL4>1_cAi`k%EBX^P+<Wd"G\qCo9fbgZF*)>@Gs2QX+?V;tA7dkjA
	TM@%BlJ0.Df.`G+?V;tA7dl#6q0?I4>1q?G\qD:ATV?E$9UOtE+*6lATT&+DIbmSE[!_3CPhP<!!!%
	NBgY6aF&GLp+A#!h2DI3M2D$[:0`V2%O`cf4.n!5Ka$40l(l`!5@5/(h)%B36P`\e+VD65sc-/%`7a
	6nDHR$X5fhPCRj4AmtJ??+XMFbk3_OB+24m.**,]dkdT$RAlHVX=,$a*T$A^/@?A93#@3Z@Q`ccl6c
	T;]\\QN8#bb1)1jOYCA6rK[dP?3fh#jj3m@FULc>5t-e&T[Jh4n<e0>-*Q(9-/><EnHIkb@D<s%'Y^
	jFKYu+oV]>]Cfn`(P_:9[p9E!kg032d3.kE?O/XomD5PMEii^r:0-7-*X[pTh[PRp$u).An=]',KkQ
	N5i`b).tM_=.:.Q6]PRXL!f#+t:t$nVat0eWUV'd??=@XP3XQgK.>>l#s(R6;[>g=g.3h]a;Z0AUPP
	#<q-aV%re*jjY-!ghj`h`P1I&HhK:fk-u"NT388uGHTc8b^EpA!9@Mh\)!Yb,nHs$oS=]]GF*%Yl2>
	O7Ff\(rg3U`O=!b3TjjN.?2>6"X'$#iF<ErZ1m,6.]r,6<%c5B[#,+#?JV5u`*!m9Nk2*(P=XlCRme
	8Bu06*-+T4*(i>(9-bf]11eAS)EIM&JOL?4%1iZ#/-5r?neM@a?NUEsnrfmnH.YPl!^@qLf^S11AW'
	a7U1Dq$.>l0iOE5F0]6jCSb!W:#'\PVhOu)D5ipT0`f[W-7=9%snJ,T$^&7Z-__fn'HW,J/Un*kf;h
	_EB"3&+AQH7hO?kBW#k8u5FdeK+LO:&ncT#_FI^&42@G6W"PNnCo:i<FCc2SsL_%UVsWmBd?9mj`7n
	:Y#$P-oD)"T_D$ok#RtR+VJ2SrB/CO/<ia-sE&sObVpf<9r[rR,L1.C@/0V`0/68h%HG(q&;Ib5LV(
	rkr-BlP`ZT0!8LVr(k\[5Q-[n&:U`jepG1l*fObCoZ1ZpP,LC:1lc0Up=1]A7A6]3HtD_kBu!oqTF2
	(rE!q5(!!>D/G9m\-A9BKGp%LfRj#odkpkFOZdTkqr5SQh;-oE(@1&Qq'St0`*tI,1][Rn@tYC[W%j
	%R7Ssjg;<5K&!=TDH9he>"NQ,mjEf=unR=+r-E@-k]"G%,3Lj01KKFhWedraV%BUUgtNT9'Z@q0"]i
	VV(X%E:AobAD*54b*I$j#D]'+\nraR7ns.eS;?k$jM>RUJ\!i(h6DW=dEV9VGaBmX4:CU7d^<XGeMs
	A0\G"/Vq:61r=13,+:.L^r;#sId:cJn7>+KI79V5XX4:r?RIkg=>-4YM$6^Z#!lH]#_iU^"X4<$[eS
	$dj5[\,5`9h`?II4HKL1-h(kkb.%.[;2/6;`t:UG3[HKQs9>W71"\C,LZ@OsHX^)2>-@C6_Df;Q6lO
	.gQ1V^h>Qr4*PReGhD+uSRU!<Qt\O?Hhd)=3#lNIL<QX9@e'?orVc[iVpf$-W)TdO.OE;6DT!BUf;M
	`NWDmVVG;kdZnN=!QWU+g*jia"hIXe8l:-+qP>$B)1E]h[+U51OI]A8*lK>"t3<i]6$e^?9KKZYItM
	>6-kY#Hmij7,Yc;CE4blZg,".p&lUXk&M1%KM;Q+qGbZ//F-L+cbU4C:2[Z*?6&@]A4ft8YaZiKF7O
	A&<AP`XP73h(l_"/GB^+<.`PSof*;A.9:%7K%#,EmEWW,#,UnjHgqS?2bSS:OB!VYn_4dPGZe=-\4t
	VBLq/e[2\[`T=a/d`?78[Q)A(/oU*L_DBAY22:roD07U5[0P#D9kLhHmm%Ij/LD(c)R6O2j1<2q."J
	cgr'7AnGXeA7S*'d<(!8Ek2,Cn`,Ug%3f*MHG/5)*uuBhl06T/1aaIg+]PRE,E^(0k%:;`&4Oua\'N
	=Dp%A!c/h^F?)MHK.nhST_*65TpY0"f-_8/F$ajaF]Vgolqq0[X$@q0k4>7^qLh*+%fn+D"].rt4Vr
	"i^fO\@*Y"V:qB-71(pDRWZI4nT=oN&cnk-BkL2X0Gc#V,DS$SqVk%S'BMRat^n_H[?8E4=HIe6n47
	XNfK0]]3HtR8p+n.&OJ%lmd9Cio?B5iHsWpUO,f6,^3j(]e$X4C92*5Wbagh>U<tAD7)m6d/mZ&![9
	D>XBdH?.6m@[54Xu^h(usr6YE+^(SlBgR!b7bFAj?+PPB+2bMP@pp\9-u`f[s;aZdT8;$sR"CXjq/=
	Qg;YN)c!<;/Mi"j$ACg=J,X`,?5Ea\iGd#cbln0"[`f.GV,DU0j9\toI_UA]Ibnm!+%n`p_$;&=+2P
	8LmG#)`M1cuW-Bi.mIXZThg12tH;&E+DA[gEB5+`r'\QgbT9O`sm]"60N45k/Rp?gV"8js;Err2m92
	f8a"JbCQ*[9DDBh<f6nMT'$OPDMc((5p.DZ^l)b,Y<=Yo]br;1<Ztd,b7/LIW9ATj70L=@fQL4Xd7U
	\\Qj$%Im9FIG'.pJCZ6>O1b?h!pu.!r9SVRe]A<JCHg_+>JPJ2j+G;eHY-5#>!0Bl$A$Hk>;/Wl?/@
	mL$bC0<Ya2AuP5!H]j\EJ#qcgj=I:_[KK>5`o"5+g/5ZcQa`Vl/^:lY9p>j5In2A>_=A1G_*SgYRY<
	!):p;VmEG)/"'(CZe8#!j7R_f9B'PW,>$>>]6@2QPUME,\,2_?hJp0`*SoZ#2!sgX<%:m'RET1s)ND
	buEh2VS-PD8s55M3aYOak@4["5Tb*>`6<AYVRg[2.EX6F^e*fmp<Y#[sh;.,>A2`I(hQ8jo"C&7,FX
	4,PH*AXl=0H,olO!gRGVpjmH2X>OuS+'-.VR_3VroW>idAAj@hJC^SLJU,H.=_2.q6SBs92"po0+c=
	,S5-(Aq*\(ZGBYu7;1!Y:nT`jJE7jROP>8e>MRRKZ.[S=@cVI80?+kQl<Bh&7TN20V1+nhWXTn'5$i
	k*HZ>-dN^Yb[*A29QH/sl2*I&HJ-AMT[cGOO,KF\rhh()A5D-<_/O#iTeA<[tUa"q1TY*^^3;gCljY
	NCIDR:JWecc/j!=HJS&a.kOiA-baiq@WcfnOsI_IJ,T4dLVqO#-a=pOc^n/)h(.Bn;u,uW0qANPgXf
	9"e"8jC^4+o/p=na*H*uJbjCpGF:JXbB%(![^roh`SX4?KU\XL8'CQKh+Zd1g.VpcX+NJrh?cH[L&j
	Y-n8&h'(IR;7`^!"C9/!+:Zc7O,?DJAhRa-J2;gWR^:7=0LJlFXrg%XfSVJcd/5>DZi@NnDF>jZ3[/
	IQS2^UE8d1TYUC.DEOcMDFnh-^=2_/iYD>+SRP-n;h1#>!ofIBcKYq61h**tb/c4l)P,;QhJ,8E-*6
	1>Nhg+CUJUrA!3W_$0ps8pjp:#NUr9sYt2`=L7-Mq[I10Igf0)X=N('!HHW.=uecqooBTI@tEE^cbN
	6D;27>^q6QlNZ:e`l;(eIDtfjh/7`>mC/-rr05B4Etb@uTMbfB+?K^8%!`mp.^2a2MFCCGVjm7.?E`
	h^l.OqMc=A[7K;#?HX*%!Zs8Mt93*`Z=LPCPd?G5(:[_N_jZX@DNA@%q0K;'bi4@68YLZL;4j[=j>7
	O+bRKb-S/`F:YB,EYMDPNhAtP+=`RVSO*6I/%Z)GF.@"WMukrW@=YSL3PoZMdO-lrSOe2/KpD`Xgi`
	]6/:ADs2TW=+qa5;\AmK(RS\u5j)d=LThmA.1DgNP3kSU]?!:E@(e1:J]^sE1*fih]/rg%=(tdRFK$
	Y.l!!%s,Sqm,(-O<hPUQoJaCd8Vi7&a/VGW[RH;i*p%iPUG&+BYbs`Pk8m'7%eU+;+_Pq`o^6NWNZ`
	ZRd^CGQ=C37k&ga#bfpf-9FMfUlGd$)>UPP^V@4c-:sB<iL$.*<9+m^%K5O`7fN>3`H8[[\duM?l/t
	:gr4V"B^N8Sr!T>3oo^kgP:1B/`='*T,E[srBf\":,EZE,ZNfNi-pG_-"btX9l!TdZi![UFlrI&BqX
	'VbRNI_Y$NK)V-[W8pkZ*A<<fXqOAf@L0lJ.U#Mb]J&Q.ul+o^l'#%:hZ-G%tNefD)>GRfb"q:.KD`
	/d9O8)8Yo;sYP6ETFI6bf8UC*sR3Y?<7Es-'.eu$B@WCR,rZq70T?Aa[<e-:A]cI(ANtWUbXMd%/_K
	4nc=Y,kZ\Jts1NqGcjC:0=l'hOS0=g"JkXjt5@)ISq2;@W[05fYS,elK1\<2.NC0YI5DRfIu@XfZ[Q
	l`+&<L-d%\'RP1R#6tJKftCJj4$.uU:JX*mL/Nk2?`tu04,:`D`Z&i(N1W:^H??\=T%6N1P"6iP`a5
	i-&.$@?N[8E6YPtQkiJ4>.qphH>WPm,3(;"cdM/Op\bOG#*,Y;3E>LdJrq9rAG<s:mO,jF=-Mi*gI]
	ad@P-1g4d0F@jeKkdHIdXXS*i:VCVN['37Gne9nhS"91-q]YEiPGae;l3@kgY8AY\^^fo!%Z7D6QqK
	MPf<iY6*&O>X]E?un=bPUQt\m\&BhAR-n67P@7a)jj$./UrSMTVjrFGPUXB%4r\V7#/UJ4!3&s!ud:
	`l@66m1X,&HQ;H7Tg6!8-]4Z*?$/Xbm[G7*Zud%`-6X[;`W^YKL7K-u*4#Ju7d#,#Km,RllK$_'M\D
	q0YAu:L;8$,)A_7c8!'7KU,dnq;R)@2s^/5rr.?H^u!r)TeW`*%75kQ1KLR,lh/CaMd9]Is6"lL&)A
	mi_r8:YqBqS?AZtB@]!8LpN:HW8[aO=>!0k[g6D8o@)Aj;f1d$snTI^pT!=5B_j7YDj70S=nj`4KTQ
	?p4cO2m_P-Q7u-R%t*+0$%tY0a?Sj:me!+JV(+m@</W?lr&KJ"p+f*!-&[eG2pF=,a6>b[44brnF3[
	(A<J6%nb7Md1k#DQ5a''8qmXg?O-GmYd*N=udtL,^:ad_T@s<-`/-n]AQY""TD>%J5K!:/AEj&8S"%
	K'5j`2Mt@^2:5@j-O!p\+[g(5kWOKYL=`q0`(<rXC[q_K;5H&A@-YK]i0%SXkDAr+etnjM+0Z)&sW\
	(%9\<Q2H.2B7&kiJ/hYdi.F?K-[XB[2Hq^J5nGdYhZa'G<3OPYF#ol_,79.2fT/b""+X)mAN:eu3&i
	l'!6AcY8fL#eP-Wal6E%N.>MaF\&BJJ<9(FK7,UpI>.k>EaME67d49/c-Dss>?Gf;LmF9$jIDHE;$j
	?NPEm``<G!9f1KpK(C+0Br.UPKAIh8uL.DYK&=j/sd5?dHgHTSf$h_[uoBsTHU,RAL/ehoD&@d/Ban
	g.G4_IOAlboO2iK[itFl.R`FA$d*jfbM^`Ku7RorTKr"ldr=t/?b7\]53h<Q'0HZ;*'L$89!:0=;]m
	I%?S>)sbXtB]>Ths\/\<_qp#bg7j(Q3.`0e'r8<en,mAVH+5UZq(/,15>S%\(/F4[@49V*LPu^2<SI
	*!UMrA0N2/)Ke*3fk`!4iJdlAk*P7VEc,9ogL]Q]^9]%6CPT4u,/es'<Ct#'-,QidX"eW%31%g>QVM
	(:2h?S?CDRC/'q<;ng$.S!2j__0DH-t_)i[=43t_PCa_:t[=LHjd2ClttjC!P5W8[i=e8%`F?HHZ]a
	?H&N7&8j*-"d>hLQuC03<\;#:0*I>O?\B6+<Nk%&3R?6Z=VZ3<"ec?Bga]oNaBuno*?Lt`?N'8OsI&
	U4p!%/?[hr@+K+)sJ82LGOJB"H7MJ9g'Ieo;Z3ff#>GpspT*X^e/tGb\$@0Jt,VJrW<?cnaHG+^]M(
	"tT\DX0%BXJS/K*<Gc"@8,\)Nl%I[9@.&Pd.N\ToIDA,jXY=_/TI*7b//2a>>0sN?ePH5$.*<!T/Eb
	@>`$uXILQ:&0Z-LM3+BmSu:+RjUE,]3mI'm!4,-n;ikX&h@W(E/N/c="TV@kMGQ@JDD*DsQ#nP8#NB
	Luc/?T!69<6+PJ(,a]T@f@=Kg=f,u'#lUJd?;df9@^"8">I/MN0QV@P!u*s<aYA:>Q16sc1T?HZP_S
	X5H=!"&]P2\MgAUdR*F^V&sDW(O(<&c>6d1u7)?_j=]Th9i8K"Vn[t4W-Kj3hQ=#Ln`<H7jE*Kk^[0
	@]m7h']-&R:hak=or8eYZ,aT/apcO>)3_B,%kof85,TlaD-"7=F1),Kr;%uIu-qTU"Ro@gTJS@^rV^
	1OGP5hHpVeMUt;2KPq>KQ\P,tU\G&.-igRG]4:W)P78VF_,mm*46LT\ZCb#%t7k-#4,l(IBO>iC5@>
	'"`Yc?E@&`cEGi!V4t>P+LVc5n0l=E#g$@'bK=o(Dl#ch<>9$=DYU'16aEi9+((3g`8jcNLie1Je_u
	&X]#W:MeKl_[M#X?W"$?^L\OVh*Na@DRKf`XL@'<fnS'A7*o(bBJ5c%B#DXJJS#DB<ZWQ9EY<%?CCi
	[^1f'TYO>T&bcm^V'D*)N@4]d3++,[K)bIJW=In$m?\u-tUN]o6H;">-4+`J.Y:B]j=c&#&e:clqu7
	9Tn&4;dq#dfN%q<pE:dm@:CgkP`L*-lEVO0:Q/a-l<^%-#A)\(S*!f/d`ABWH:9W7oKSZDikl!QW?U
	$Eu+h@[S8>DjnJu9/HjBRW`66.(3k+1[\`NU)h*HeY1="'[_(`8?7:ZS$GOsHmq)3Q2bZE2Jp"\r]#
	ea&u4bj4rE=p=SF]j*1R1jaN@jD[(Lo!>E#"')Ah^\l7bd1$((%1]s%?'5qcom32(c"o;-XQh[4buU
	lFP,+njBeuS`+f3ZV1IFJWc7l#gUU&aeA2;gdCEiXa*"Ia1YEpMk8CO=9TN6t4Af+K-0$3]KT24#f#
	_bTUZgB`6!q=o'&rBL;(6oC"m>Hn"pYTmNh#IFPX%iNM#D9q3Z<+*WC8FfO$/VuV"sFs'(k</EP=_S
	^7d+rgcKmsi/1[,^4Ztqu04BeY!@LL.Q_nJ[CQZ_LjI(b"43-lb6D8mB82_;)A%]OiNY!r_$jT]U?M
	a_NI=5;$Q5$#hMWXL/c/2?7[qm0\cHZ1BH:o[i58oLo<cG\,9$d#(rA74bMaaHe:Wd(,3agW3(k3H\
	"@bjkm?N"2Sk>j#8lZ4&VC7<U*3"*+5K;sK:KVqA'o3._0[*WQ-n>?j.7Fl&HI+-dNG1qS&d[IAcAk
	flV0R78qF?%b?FNG,X%W<gpYUAi9j*`7MB_#'Ze;Ds?j2)*B!^0,U*q?$$/#?@U9N7m[l#TQ@Ji)#1
	OD50SG"B%q)i*F^:le-Hu''s?XFn;nOcYjPY-W6#K=-;N"@9!P8>mb6UOK$*"%B"!%O7KG^0"Vjuk9
	\7n,tT>&CNH<6DeFea!.Kq`EUUraD9E#FroCqr8bogq9VN0!hgf6"6(5LPM?u_9hN@]tM)b+d1t84%
	?!o+hqAthpf](`<61IZa3:$e[;eB5nGH%;@F?H!!#9AQ1-oNZ*C"0LXI*#]\D8F1Bia-f?#:Y3gF`6
	Gb3gKh$!d\Xk)@chLh.)O1*_Xh;-n=+:noOp@iZ(kKq!AMu)_hZ]d!Y$p-]MdF\tYE:2LA-!r,61Ie
	-ZA7VK-E\<$,]RMu5hGoA="9<-&G,D0-3jYX#(oOCa]CG[8bEnJpC-%pBg"?r?_<lE0+>P7)l4=LnO
	q0')#"#9]GR@L;g%bgq'J:(DP'$[!Fep4P]tM*q2Tt^)hsWe:<Y%!G>-/8=K;<7K;J6F<_!(:sr9M+
	trnn=&)-/?LE(#0GPHgbXjGc+T:c_bjLVr3.H['eF=dgf?!!'Xe4u"dC&:43FWD\r^K[A6'>P<<oZg
	l:`/pBOF>'T?bZ=,p(T')H,QSHJo74I@9*.Z)inbIR,-pE.[>Y3Sp1i46S/ifK>)9uS8N#sD[:F_Y*
	CY+d`h5f)kK*MoXEPg\niBup67P4iG!M@]YZL%/QZBDC"6Ke[Z7t:%:e^&\f)A`I.-(f,IYQ+Is:Od
	[n\Z19)#g:E7Jfn_`R\58;G)30?a[rhlSBpABG'9+'%8G<[^:mK`D[E+9be8hZ;E4TY:q3g@3'9=)7
	+L_n0%k%O$k/5gh6FnZO,qaHh0cc5<%?)L@,0^K:.78m8Y9g8,h;2S^@sdOa!3YMA,PE0P?P(8MW3^
	XjA?dD;ZHeaf[\N[]=V8q'M&6-`>j<.f)!s%_SqF,WJ'=%(*c&d5%!mC:&#NS1&q7MkK]Vs.]"9o_V
	MhJe*44^#h.8O,9nG8<&[^UeWM2s@^/P%iq7V_C`j"Wd;5tT9R2BO=]X-X3I":5\$F]-R>f;K=]ed>
	;@]F!WI4R,Vkag=_SSY267iY69Vt.MOND%UjYGN2apt0pb$qiH24@FFL,_r_)Y$gf>>(ld'FI!uUGF
	\^9$V2P5U)=m=]lp033QW"G1:"N?YW!,e+#Pm80eOr6=4),'D#.td5ZbEe+^RX>Z`E*C?iJq8sshm6
	UTTmr#u("5G%YtO"O_KicI5N#`jt)NGlQ,7MNh5SfV%_AH<rr\QjgJZe=]\^jqU-K+R>?H@s[LeS;Q
	K)3JLTb2lV`;1':Chi#HA]7"F+Apf!=8XY#n&3fsS,>oFnEcR>aO&h(7BtCLODeE^<'Pm+%lVgt7&4
	2#kV!I<g?lVe:BgFGc$rT%lL?"Tnp3rQ))>j7_?+D^I1t4opZ7Pmr?iH4"=e=g>kN>Dd`Sk0*P2Z([
	rE$c1<BM>kmd>Q$mC/.a-P/Uu66X(T>?P+ff%4mcJ]_OTMNUFRfkci'Mh=<"+Q2keghsTpBltGTE@_
	m;IJYq?0P\#lh07a&WC*e_:ag_`d7:$2BkhBtAnL2X8l?YLj`7n:.KsQEMW\],+@6>W*[+"9=H%NoG
	'%m&Hp3n?ebj+uj'Vi_f?^$Oj#F3N\+dT1hG]<B<l4S(p:YhI!!%(]F2;7g\U5^$d-5Y`PYP..9*kZ
	R&B%Z`732Fu'H)iUXk)n0GeIFqh;4ZM=dHaBk75VO%0hGWCUI;:fP7hjn])`8ot%ZCfZIB9PU.^=L.
	OH<PtIn%kqj:fM3U)%QH%tT>ISL40^NT,Xsqn2C/2e"f%-BRGA*GZI/.fHJggpj_F=k%,eB,8Bsh-H
	eS<2Dn$2_OPkOq8Rr<PC2])tl^]2$2h9Z:f,X$VSG\(GTVpeqdIXS//or!G\Mk\iH*[*o]eHm/5baT
	8qldi17.)b_)Df>*hRl?U3fJ.N%A$O\B]6>-I)'0ijSXjVl#hoE>EB9Z)IJ\2e<0AM@@Ue?>Pq/bJr
	?+\[f3a%+eQ6)aJhT8JHf;hq:3R79#X*J(K[`&V-u*aAEHH<pFB'YV;-[:.g=Y')l#[:@$\O(aSL@*
	V&1l#]^OL`KCJ0g9MoG8T]C-g3boFYV-"5&1ZchH&,SJ4017ulO0D]o_OK+Ujn(t1sC@un$I!g<ZDX
	Q#62FtYSP+oD"^J>3$[^QP261@#:q<+BRYHO.KNjmkkX1;<23=,/_=tQ"3`T(s$cdb%iBkSei'MTq'
	N>jgF(QCY6Bh5CkeS6C!Au!a%l'g#n(Z7:@fs><%*]tQ;/JnoAcd+-;SQ\E+09an!/X8q'Vt2I9m:C
	i'/f'A;IJ+Njlk%$fKnWngGfJ;cC:1X^\!L[ZCc8o7[tbN83h:+(Q5F+04#`^*MkXlCRr@)ldA3om_
	=88`!<<mn`U.i88u5cF(PtQFp%krei/&#+a$9V%F5k\9#eg&rRr`XlD(5?Tdkn>A;lN_CPDR7f1efK
	sOIcNLj4/be%nJEPS'?-:`f2<oKG/q/>C[9^dqL#m8W00`0g3E.bKJ(i+$V+7@rH;Sio4F2/R&<)ke
	^4MQ^=&*,EW82:Nl-Z2:B(r/8ZCEL07Y^H2d_%!'h(uK>DNgaq^bgPZ%Z-PY.d<QBk&eQd=h>c$%C,
	X[kn[0>@45'RUH\dGsb%]6<QUQ>^h8Oq\7W^ARQF8u2S4*$$&Jj,H"CfZ/[?;srPX:L[!d;&gMoCV9
	brane/?*4N8\Zb!`:bN6fr5&ke<[(-D2^I9?/h;-mjXX4;T:"+R+s5M"UMAc>)7]B?j?XJ<QiW[N2U
	e_ZoI@o#*WmtkCE&\JeOL?cn+;g*X$PtFc5C^C7Q0??h@!-TL*"J1)oD*cb5bPTqpI+Qn@pCDr6D4s
	13g4_m/sg?gC2/!<\Fk,,EK`'h2#?ms?U'&>]Fj)bnTZZk\D[,YO*udmZ+.N^^:(I>mNia7/sg?kDJ
	j-$W7*?P0ZL(klHu@sUsL"[5cn&l!eF`5894>5->FO5Mp,'U)I6QO,A4dLAKp`eaN2TL9LfOl!n+.3
	b:gVHKX?m\@:NeW6p_k>^6,]H#XTdL=^,)T#8H5P1egb>9UqitegYrJMP?J5VaI.S//Bb$9&r*>V,E
	F^KLV_6X47j-7G=E>/6f5W9;POg<l5c<#XZu9@!Hp@E,b;gD$3T=;Tp[+$71m-dN=N\/2qke2BqUHk
	CYTh/<rgQJW`!b$jM@9lQ$i\nT[0egJK!nkteb"],M68e*1u7A<8X52&_IMOWmNK6t:6W=0'lmb`f[
	hiXW1p/H,PGkK]Xamd<9X69S9-;j+_R80l7]+Rd\<gIm\tJkPHRqnU!4+;!c%l8iWt[!"_L`Ccs>M*
	uN1G4PHV,:-$,0M)KoVnO45B4ttW^VBf-<mdm4Lrnb!6q\/IOHkrfnRREKfB`>1qM'`Z]O(&0XJ.L*
	9`oti<3+Ps5#2[C(ks2.,0;#5!"coFfk_ueQL/jB-hcr*!,3!G/sgXi*9du.\q<V<7#34]7J1u?`F<
	gJSIUFmC:/LpN.)%#\X,pbCc5KG'M+-n69GRrBXC49>-3I&Ze9_l]aI,QR&0o4A5SL81?mlYUo6Q=h
	qs.P4pkc/*$cR*5a[:f9dp%4,p'aQ'(KgDU2=M2n*p>XhnF^;%fb_]^VXo*!K!gEBE/#4!(fUS7'8j
	aJc
	ASCII85End
End



// PNG: width= 45, height= 15
Picture SpHrView_pict_circlePause
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!#3!!!!`#Qau+!7_T;M?!V[CM?aMFBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TA7IbHBQS?83\N.*F`M:NDfTJDA7I9(
	Ch7HpDKKqQ0eP16+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2D(fIFBkB"Q/heq&$6U
	H6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<VdLG\q87F#n8RDffo=B
	Q%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>DK@j`D/_W^BQS?83\N.
	(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3a/n&:/@V%0%Df%.P@;
	mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06goE0/5(506:*<E+L\#
	ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^0fV-:$6UH6AU%p$3`'O8ASbL;Bl.
	F!F(oQ14X)d?+poG8+D#e3Ai`:tCi=>mE+*6f4X)U)$6UH6FD5?!3_=0sB4Y.YA9;KJ+u)&:+poG8+
	EV=0Ai`M#@:s.FASu.&BK[Ot1Em/K+<Yc?AnF)%ATMd+F`_>9DH1RgF?Lg'+poG8+EV=0Aia$lATMd
	+F`_>9DET1"0JG+5+poG8+EV=0Aia'mATMd+F`_>9DET1"0JG+5+poG8+E2"4FDl56Df@a)Des?49l
	FQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+k:*$6UH6G\qC\9lFQV
	ApHdQFCdTZ1,(I;/MK"50eu]_1-.0K3\`?@0JkgE0HpiH+<YoGE&p^)FCA]gFC@RGFCdTZ1,(I;/MK
	"50eu]_1-.0K3\`?@0JkgE0Hr[f+<VdhA7IZBBln0&4piDT+<WdeA7dkgCihiJ+<VdL+?X[TAiaaB+
	F%a>3c&5BB0@G`/S&F)@<HC.,!KIYFEDG=+EV13E,8s)AKW]bGVM(#1H[=2A7dl=Bg)kH+<Vdh061T
	83^IS(4piDT+?V;f@le^GFDPMP$6UH64Et^^9hdZ>BleB7Ed9hU+<VdL4E=tE3`BU04piDT+<VdhEb
	&cCChX5!+<VdL+EMWnG'#cR@ruF'DET1_Ec5K2@qB0p$6UH6+<VeJF@C@p3cf4OFE_/6AO0s?DKJ#c
	6"X_CDJ=3<+@Kd^BkM<pEZcc)@<*JH0d&5*1,(.$$6UH6+<VeJF@C@p3d57KDET1!0JY=60Jk@91/o
	t`3\iTS0ek761cd<E+tl+e+<VdL4>1_cAi`k%EBX^P+<Wd"G\qCo9fbgZF*)>@Gs2QX+?V;tA7dkjA
	TM@%BlJ0.Df.`G+?V;tA7dl#6q0?I4>1q?G\qD:ATV?E$9UOtE+*6lATT&+DIbmSE[!_3'j)gl!!!%
	NBgY6aF&GLp+A#!h2DI3M2D$[:0`V2%O`cf4.n!5Ka$40l(l`!5@5/(h)%B36P`\e+VD65sc-/%`7a
	6nDHR$X5fhPCRj4AmtJ??+XMFbk3_OB+24m.**,]dkdT$RAlHVX=,$a*T$A^/@?A93#@3Z@Q`ccl6c
	T;]\\QN8#bb1)1jOYCA6rK[dP?3fh#jj3m@FULc>5t-e&T[Jh4n<e0>-*Q(9-/><EnHIkb@D<s%'Y^
	jFKYu+oV]>]Cfn`(P_:9[p9E!kg032d3.kE?O/XomD5PMEii^r:0-7-*X[pTh[PRp$u).An=]',KkQ
	N5i`b).tM_=.:.Q6]PRXL!f#+t:t$nVat0eWUV'd??=@XP3XQgK.>>l#s(R6;[>g=g.3h]a;Z0AUPP
	#<q-aV%re*jjY-!ghj`h`P1I&HhK:fk-u"NT388uGHTc8b^EpA!9@Mh\)!Yb,nHs$oS=]]GF*%Yl2>
	O7Ff\(rg3U`O=!b3TjjN.?2>6"X'$#iF<ErZ1m,6.]r,6<%c5B[#,(j8J=5u`*!m9Njn)bIK@78'>N
	ZqCZJJ_5Z2`Ya[/#'\f81I#=)k%Xfa8'FbsLO#C/d1NhA0lDb`gu5ATgW"c^+uW#+7nZF]B&8;!/Ro
	rW=JZtg?haX<Wm\qePF3fEQ6aJ;pkE]H$E.PMpkJfqpnfn*E+Gomkd^sB8WkdI1ek%$l8/:&1BKm6'
	LdTrBUVu$<$Y$nS'_h@.#K9A"@8tc.[B9mhX;mU'Hr^cAokLf3h9$De%&_d==f'D^^"PADJO#D(^sH
	GeS_jcc"=<8XOHE;iFU*9SBYYiGB_O#F=*3nkOYNJ8JK,NH'M"@0T=Cm1n2`ThI<as#^J]I.cdqh/<
	C*r!N=Q6[^J)[AbV@#)!6M/9:j'5<YT+bEH,u<YuE4C4HC$t#QeM;-ji'P,YO:G8Wje\hka/Ed4c!h
	Ek+Y07i`(0Z_T5[_U?k10Gl@+8qJ/cGstRA69lAt]U(iJX]B5Fg@k76Z*?$Qc.4H:*66=Mc\KDHck;
	!C`Y]j%Imo&L`gEJKO??*t+F0U*GOaZ]PK@q5Da091@#T0;h!41iVb`r-j`6'R<iZD;2OR6b]j@bid
	PQq<Q=[U3/or"6-knY$/!nGR.)NU\m-G]0)0*:E-Wg>fOi_-7='%V9rX@jr%Fo,KHG/0G19iC2e*1V
	10,BI.c\nNr-ji\t*fjrEA>HoPrS5IEMNU`4Q^3q(Tb'nQ(h8h'V9rt87O-*^5[LQn"*mJ$8u9sBab
	,>IeS;kV*s`">:?O?jLEe=/.#N(eF/u@BKgJ(&'NpapHG.qrom4;0S'>=p!9;57!e<L2Q=W>no(dYW
	OkACA8g]ar.&tg4]A5Y7548%<c?eF>4TFj*]5T`7//D[]B3EgKo)X-M?4Z+tBN3'2U'Tg=2`DD,KIk
	;'9tOZ5.p&lu4J&l+?Rut"]m@)o[8eiGAQd"i>:^P^ce$k'Bsh.!g=k%k2+:C>aWlHQ7H&MUT?kPeZ
	&Oa&Cc8=BMFO@\]A8[7PBOS:8E>i)1^KdC,4YU,o5m#&"&uJU#6KI-JH;'JO(r`mU)8s3Q^3r3d:g'
	q-:r6&G^+%@b\/gSkrB2>;3XHmna+pbO;C7)@^-=N%JBGgRS5&sVN:@+5nFZc`7!)^p@bp;#T2ULdF
	$.(0C*_k1EsTB[eA_"$a9Xc`_NEf&.!B%G8lO],JA#S1!fIGgY9PP0Ten^U8Uth-7:/CJUg4bC%*:*
	.Le^XDJnn&a,_o=S'C('(G>@Qos$&p</L't.#P!'.MrSsXf[GSk\rMa?bbIFd;cam<g'8&n(oWI/-p
	hM#_LlM*uPsdqu&(h<m?H@+MY:j['Huh0t,bO=0Gs'HG-4LT&[=fJ,OM<I9i!]=dE>Gf>WXaI6O90Y
	<V^s@>k@Uf\+q\=BO52ga#J>j7,f;9fX2R7W*-8B`p_HqXeJ]*(C4UZJ=?pJ*krIMoB^?dSU])*"K`
	0or;+F&d0pP4ZtJQE0Ah`(SW<AIJS&.FVQJ"_83sEM$]ZrFt+"M#XXj=NK&oVDr0jKmP52lqtBEKSt
	=CTch%'e#7oha\1Gf+6!V-OH#.<@?ne+n_[1o+755Vf^460Sj#Eg]GlRbk]A7oaH2>Q'Ilrtie#,u#
	2E#)KAf0\,p$38)'.h=uicq1Gb$qVtF`e"BOND%-d3q9lG.[\uEu:QH-p2eG"GWmNVn76Gk/>3Vl)o
	P%hX,L(_ug,9<64Oplo][j0U58H*'?#5F5aui[^NVCTadZ/g2=C3>cqP@QqjQsiNQXl[p#p,?g](0,
	DtKqs8DDWSK1QAFZS@WqtC=##9.%J)@&is%)[>'?ArkL'%u-uVJ3WT^&94VM%G"&i'An0P@`EVZ2Ei
	^J*QFg4UZ`U8Wl-*Y,eT2+V]jR@^2;$X*(sX-QuhLQQJD=R*4Ro61B+]p[6l/GW[?T`;Q>Wb%NX.I(
	ii<QV8a8\$m@f8,Z#QT$ea7SiqE9NCIJ^[b5I]r:#?Zj#O5u[l,1oG.ZQe:%.H8,SCEc<bo%pNq\Op
	Er!h@-]pqf'LeqKH2$a_;`BuA5Z&6*S`90a1`AL`q-5QHi5(%^2Tt]>?XM^H]6CAXl_tQS$aj1*G.R
	oD8>T3')]KQN`G@FS,d)GcoD8.GKnT[aHgfk,mrl=h<+>nCd;Nl=`F:Q[`H"*$l2CMR91qp@,h_SYH
	hZs!E83AXPtL.]]*X(F6mD/GghO6cc/tcb7$=?Yc^r*b0gQA^]"2KcArcDC@mHg:FEVhZ:Ec9(GBS-
	NZkOQ@=0Ja.c-=K^MS_'kX]r9):+&VrWK\A2QKs%pa9Z92eaOA,/s\:2\^$1L2*!k';lM1Q>!5&5?7
	qQ\(DkuCI;:U+lumaS0ATG'pYUIe,fs^VhRR\42?gB[PRl_J0FUj[CCCWC-h_fJCOi-u>8ok*,XkQT
	,9sh4]:i%,aBL3],E[a%N?h(9*?B@mh?DN5-k_,.mk0dAD/GZ;X3"jFPfn`Se@SeY64EHmJ+qKo=*(
	oW,*A7`SXl1:WG-J+<Z9VcK(&`jX]o(:>qetPq9S+drXl:,r<2ZNO.*i`I6aj`<aGak?^E]0l3Y2,N
	VK.GYt[u:'*LVMoT^q.iph7SSUUV<rUf`(j,V==h;-c;=U9IN9hfbPFMRQCL=k:_Ik+uq80H9ahfRN
	+,kCbWG@Fft3d6"d%PZ22?b`2SA5]DVldr=QAnLa0iul9LYr?UXJC!i@[;2$fAnQli,jO8:)[u$7"2
	.^8JYE_7n0+P1U"uk(alROT"MqD1]mKL&qWXnK,VhSK5<1a7?Q->=S%6)?<%>lYr8?L@It)t0[X9--
	ZZ?"obKF*PcgQ?q,&t\`WK\50DcL$BHG0=/X]oPJH>RLN'FI.1U(MePr0cS)K[AB(fO"-+Jea!<o1t
	M\%.X;BPiY:#/JLh3gL$)XIJYq?0O%aciGc:mk+X9<H1M4G>e>1(j7+s$5S0_fBGl!UH\(_GpLZ1k8
	0h(Vca)oifGI2CbKJ)NA9'o\)G62a,X-VNTI:0&I+6dO6MPdk:lG^6^:LS_^&?BU9,Q\bT0DB&O7YY
	5-kqu5Q4ucmfkd!->rjq8E:;Z`3h=R1^-5\c(D[e/LTZO<5nHF@)GMIiMPBnErX0Mp*,2U0&CL9_WW
	L+1p0R"Pmru<I*68$WqsVD9Fg5+a&43!RIo[8;,g!$bWDdnj*<RQY%L`c59Vu&I\$i_gkj*ohSfe<5
	.#s=JZ7L>d4DTPGkt@?qBf)8H,14J*M%G"-m[YUp1ej$kNh1r3UN's(RbP;idknbCZ*D!U>p];]V;X
	BD51JHGhUgB2oW/Y"dFd4.M\'&u?KO5MreD/D6mNCB'ZK8,q>L;iP@n$A@Uc(JR5,`l6Njm%Y7Jj8k
	/(`:p%S2*KGG@?X!X<NV-./40,BJ?-k6XoS7fFM5p/a>FECKa<bJblp%A"SPKit#3^SXsW(WI0l1Om
	o,?Y6_bq0]hqoA#/.#RTcj%#%___;l[?>SD95#_+JpT)j0A29QJVtXNt8nei'+$Y3R'ZF`BHG/2,AU
	#=7L)CmJ_AJ%pTpd;d5Z&5?0ik?_Z=@W1Zs%<:7gI%YH[AsWGiQEJ]:7.00ucDLn#65>Z\.(OB3A7H
	K[%cd]c-p9d_t29Hp3T&lL!tUY!Gm<JUmijVR+rl2Ockn1SmtuR7p59jRmgp2aDEs:_X)N09Jd>$AF
	*rQ;4>NV%Q'*I_WX?;Q@-.Xl&Tf(pC-Hn$V8l;OX_i/V5+pC3<<JcWPo]NX^WW?oFKc=cUP_#CU30H
	'oc\KMZ;ok;ddi)[CW99;PN;(-?2`MF8Wk5qi`-F?7a7h')"Nn#%Q`T?lu^H[cX1U+",o&n>`5R2X;
	M3&a*;2aSpX8f]2Oe^[ZQOND$JmZ)3MoQn4,DFXtLDJgN&6:$.JC:0XBg;Blinm<,#M+48*%H&&!&H
	i-C-W[:U71?F..#NVA5+Be`ECglfdY9K"]A9Tq2H9`]\O7W=dj?T18miC@\$rilg&rNidd;4A,RI+.
	>l:<QU+!n(b%ruFeFX6$0Q43uKXJQ%\QfVnBQ%g-WJ)&e^>2\d<0KGgr/cW]Js(oJ$@?NtnqEe`8Nb
	=_,^GR4L9nc>EBCG&3=.-a1ef'\5h$K5TO*pqi)p5fmaZ&p95QjBJ2Cf.k:>DXYA>+r"Lm=]:(RQ4;
	A>t)ggSo<WDkJ/SuDccdorjh@pCXQpY05t@M*)Y"[GeU=!&??L8J[<:^s8#e3l4HJUJ(ZAl_X:"*pg
	F3d5=o"0rDE]^GeO]F9chF%00:-Nm/mTJSNl-a8RZMJ>GHJ09XTX-un!fTifpH%I03((BJnWdY,FBd
	gN,#.6fpWAgqqrM[EEX*gX%m-:<Co34$A=/e;FDd!SPC1_8X$X-J1.]C;$/*+Gn%EtFIEVp+>R0)M?
	N,d*:.J.dC8>TJj:_-d:#6k#o#H:\O!O[VX]F7lU.#giqU*p@PKJ\Nl4b+Ij.`V5_(1O>0/fUns-r'
	lfB)ccY"p7G[U+#G*TkXbPZ4&gj$Mgli#->m,6,=lLG1n35euUEU9p7-OX[t^CbJEaKF+70Z-L=NPC
	'?j@,W)'B.pjl(0OANUTULmW2@KDWR\amEG=>@Y?G;^l//Ej[C2,lLRh##K1`_Yo!BjKAaqplT564)
	!QclejiefHcV,@F^5]`b"+407oE'58'f?$9k(,e'/+BPG;)p)bMK&e_U9WLaV+GcSZ*J>!2?\'_7/P
	fEJ'k<b/Vd""XKcV<=6*Mne:gC*"VhZCN==dK/37UEQU:@V=V'q5=iMa:LOX(7@UsQj:r#+&dch#7h
	'$/\/Bh4D?NX(XWe0L3b_/UI=Is#M%.ma)6,7c#a+:,1&H][\.dQ*trnpK+2!bdAjOl..i-\<I%3]a
	WO/^O#gR9E>*f%(VDAnc1%5Njm=MoB3^5rEfNON/2*Q4h\#*oon53#iirL?#d;-?Hm(lTnC4jlL'4Z
	-d7?>?CiidV(J+_8/Eh+BDND)Q^M0#9\]^kN=S>3h<EKU<h\Zf[cJO78\`$,.#s-V]OT/2R=qb8Q,L
	dic@RMS_i2Y70pH[m_-Hdl9P:*i1O,Oh;-m]**1F1DHL4OcKFe^,k^p+f83"\,h_#0%@J;<M9nsb,S
	GYJ+J6t]-SD:HCA[o*0ub.O)m-HZDJX+pJj<14<@2@dd[89kVphUn$7*KZ0?G+D7<*d**]tE06UUN6
	HC^Ut7\d4n/h\e.[DHIL.*CoCX=VO/73,Q01H[eTf%-/1jd)7">=%hc/C2YgbHf?tCfR3Y[F2!QW^%
	[,.rh,5giLBqk%5s(5m[/UoGj=?8^m=&4*PA,?<LEf7\e5!k:t!JoCEsB.>flC4FAQ&BR<!A<%o0Eh
	;(49Op;"21cmeBo=Q>?K7eeV]``-3M>@+!O2k0OQX@FPeQcTjQK;J'rDf"+MP:0'5U1hCYLi+3q'8P
	#T:^%>8>0!4/M&G\N"$!/q"T(YH(;R]]k4U]==f1nU#p*;//DGm=cm:KiG]28%TZ08L=/m4Fo1lL]j
	;eAa+M4dhPmfC"BLu22<SD-k)^-28RdSR+t6Z\T0IhNEL\G7_o'BOVs08$N+b&:==dL\_B,.:M)!!e
	eKfWXpq3UH>#?!t_C%q'd*PUAh*uKIh8mYC`]+eDm]FQKKE+:XW+6@!s(XDj']lg]IY.^\naZ/J0)4
	-IK%Xr]*Zfe-p?ebRT0+/jV0qTIJ$W$P.$9<-1_*'>\9_.^e+3:c^H-i?kuF8kKiX,FhS.-^f@JM<f
	ptn$ji`u0ca`E,kSP0TR@B[mrVEqPC9<`1ZE."VI]-c7,D7T`:!G4pP:<iFoR#Cl4n6CCmY\l0r:hu
	`$qc[nZe:(gLE"Ij+A$TeBP;$k-PQp4cHcFbc[W*nhQgs;If=c#G[TWtU.?>$NT=uB$8Y@dEUcsJ4%
	Y`2I=7I?B8eRP58+0nYHP.-Ve86i"1rpN4TFWmUKB)0F?72:rqf<_'TV5=a46jUp\o*J(`*O5qXuB1
	3QDuWj7,X#*cW/i;:H+@r,C/cE`n\M4aOKK^$U!TB4ba`]8/1rEt8a,^]-?jRF[K^[,$B5dH9TR0>I
	E_.[<s_e\->(?r,B6q*LeEnDV8Y-8R>0E;T@r9&]uoEV60K0MG3%ZQr-8UKSp7)@Qh88d0CjbEjk.8
	^cqtJ,.8pC-'B"[=g+IMpPb8]=WE9HMZDP=QArHj2[2gKn:_1;c?U.',/D7lq!sN5QCY&Tht7UrR96
	Ek>mhRZa98pcT`5(79PpphRj0'm?*t?]9#OD*YAMe#R%;9]68(7/`C[DQX>4#H(Lntn%\n:\$rq;&t
	iRW4cMp@17>S[[o98*WDmoK>j%3"S&o344F*+5jV1,i"9MM#;oa7BD/F,*MZnFaE?'0djJ1,dj2[3h
	9"8j!_NcWQNq&qk8[9m_1`@U$82M6=aOF@Z[NL6(<`U8+IOn'R,Y;(@?EM[!kE)"6E8D)33R)0B/sk
	lt>=kouXo7EIs2jAC4O<crpYWW/o@Oe5+F9>bA$K,[OkALGFh?IBW]-VJkf&Gr*61X6'F4hZgph@jY
	4j25=tCGs>.qV_SP1Ag`T!<:d:%tuI/*4-okR*,SsYl^)]Ph&X$`,+,Y9te.2n2C;CQ97HPWM"8Wjb
	r#+n&*`q);L7DEp,c3`feJ3;#\d:bA-:2arbf^3iQP<1AM!(i>;I/*4%ji_\T/-s,>d*PA6*<8O)3h
	7l=Ma?etLVpq^bc-dZPtJBhZQDAY&4KG1`JKG.WMulnU[.E0jTIlR/F.77i%QYErb]&H:JpZBnMp$(
	,Y:jtdF$>\2f>-X?ZE%CF#Y/-9I?<*_tb+H90NuF]Qirj(^u:r85[n3q"W@ge>\[CKAIFRL1E%GD4s
	OaZs'T0Q&#q5FNi%UDJa5^P/K&uN>jepBu5"G;cjB\_TS9!TsKheYFhDX55F.LU+!a(q\K&(.#O`sW
	G^M$0g%RGl;M[dT*OU'KZn'"GMdi3Ek+phI5oO5mG#,._36-9X]F>jFXn"/S9k!/3h:a!r-:CG`u)E
	nY4'+%c=4&K`6,n5Euar6`='`s'*Nktg$.bc#2=nRmCXg<k<kriio4E*Rt];[St7",f6c#B&emdfg"
	G'6gk9aD+?J!!d4mgKme(nPaQN`sT0Ig[PYdF]"6>MhqMd&LYukgjI3#nRag)>[d`[t1T3Wag5+c1e
	>RZ<Q*65$X.^.Iip\R$64-+,7$%`_F7)IpPqYIcG#dQ!s1n).m^9OptX4>psjH"[Z(reP%bC06Z$%d
	b*T@VlU5!1soom..>+`b+5W#a4U:`I7B][^bfS=Js7mm$,t1&-X_^OI=6"sLl*&h3s6JC!C?FG@kKZ
	b^$gBk[m60*Li@VfQm!ddQq&"8QI_q:fi&D/O5XQT17&e^`1b#Qu(1i#e$#(Ddn>f%-L]"tDPo*m`B
	;=$&K*O#/p>o*e8pQ?RLq<``?IOU)p]#;6'4To;Gc__=nXV'q3D#gc9jS'=:U14Z69MoF,rf*CJ.SQ
	iu78Wo7YjRVjsO9_+XKtP60ct]s'QPtr='FNN0QK,I^H'M!5Ze>3OqYYfWa^dHA3^#b?U=&2Ib"=3#
	/!W_l3WZ;3b-ERC7mR5Bnf5]$jE[>P\hM3+[bL2%K7dH8?,rmm5LI<FO?anI7`42(4<=_\HQDXmnV%
	ZG_'+?bh;']MX0&M+.K),a6ls8UjNV:X='(aGn$h'=D/F.Q?e1&gQ=W(KcU2@2F?0k"<HZAMG6^*OU
	:\%LX/jEUZY;7bj,lQgdSq?H@^0$/V,E.<U2ilrhR[:+=q-7.>-1h\_dTn)F?3]cPbUj6PgAMkWDk@
	4b2mY_0'hA(F")uU(rfr;fPEI$_Z:!3[K:`5YpbL6X%fEgq0X7/rI^p[aK&8iX]EWNXPIc<3#lP:R:
	2HrNmcBRR`aLfM^?RqQ%PB2oqh[R$his2rWlHS,S*DV"7qg)^K:!1#(aA7HZ3/Pib9me2uGm+.up*;
	BQ<r'l_J]6OdiS=z8OZBBY!QNJ
	ASCII85End
End
