﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// SpHrView_Waves

// =================================================================================================
// SpHrView_WavesButtonProc, Button procedure for SpHrViewPeaksWindow
// =================================================================================================
Function SpHrView_WavesButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	String PopUpListStr, NameStr="", dfStr, traceListStr, wStr
	variable minX, maxX, rangeX, keyPressed, i
	
	strswitch( ba.ctrlName )

		case "b_LoadWave":  // wave button on main SpHrView window
			switch( ba.eventCode )
				case 1: // mouse down
					DFREF saveDFR = GetDataFolderDFR()
					SetDataFolder $SpHrView_df_waves
					Variable refNum
					String message = "Select Sound file"
					String fileFilters = "Sound or Movie files (*.wav,*.mov,*.aif,*.aiff):.wav,.mov,.aif,.aiff;"
					fileFilters += "All Files:.*;"
					// check SoundsPath
					PathInfo SoundsPath
					if(V_flag && strlen(S_path)>1) // SoundsPath exists
						Open/D/R/F=fileFilters/P=SoundsPath /M=message refNum
					else
						Open/D/R/F=fileFilters /M=message refNum
					endif
					String FilePathNameStr = S_fileName
					if(strlen(FilePathNameStr)<1)
						return 0
					endif
					string fileNameStr = ParseFilePath(0, FilePathNameStr, ":", 1, 0)
					String filePathStr = ParseFilePath(1, FilePathNameStr, ":", 1, 0)
					// set SoundsPath
					NewPath/C/O/Q SoundsPath, filePathStr
					string filePathAndName = filePathStr+fileNameStr
					
					string WaveNameStr = ParseFilePath(3, fileNameStr, ":", 0, 0)
					WaveNameStr = cleanupname(WaveNameStr,0)
					
					SoundLoadWave/P=SoundsPath/O/Q loadedFile, filePathAndName
					if(V_flag)
						SoundLoadWave_Error(V_Error)
						wave loadedFile=loadedFile
						SetScale/P x DimOffset(loadedFile,0), DimDelta(loadedFile,0),"s", loadedFile
						killwaves/Z $WaveNameStr
						rename loadedFile, $WaveNameStr
						SpHrView_WaveListWindow(SpHrView_df_waves, 0)
						
						// Save to recent files lists
						SVAR RecentFileNames = $SpHrView_df_globals+"RecentFileNames"
						SVAR RecentFilePaths = $SpHrView_df_globals+"RecentFilePaths"
						if(WhichListItem(fileNameStr, RecentFileNames)<0)
							RecentFileNames = AddListItem(fileNameStr, RecentFileNames, ";", 0)
							RecentFilePaths = AddListItem(filePathAndName, RecentFilePaths, ";", 0)
							if(ItemsInList(RecentFileNames)>5)
								RecentFileNames = RemoveListItem(5, RecentFileNames)
								RecentFilePaths = RemoveListItem(5, RecentFilePaths)
							endif
						endif
					endif
					SetDataFolder saveDFR
				break
			endswitch
			break
	
		case "b_SpHrView_LoadWave":  // wave button on main SpHrView window
			switch( ba.eventCode )
				case 1: // mouse down
					//PopUpListStr = "Select Wave...;\M1-;Load File to Wave;"//\M1-;BRIR Noise;One spatialized Noise source;Two spatialized Noise sources;One Spatialized Tone source;Two Spatialized Tone sources;"
					//PopupContextualMenu PopUpListStr
					//strswitch(S_selection)
					//	case "Select Wave...":
							SpHrView_WaveListWindow(SpHrView_df_waves, 1)
					//		break
					//	case "Load File to Wave":
					//		SpHrView_LoadPeaksFromFile("", -1 , -1, 0, 0, 1, 0) // second to last flag: write file to an Igor wave
					//		break
					//	default:
					//		break
					//endswitch
					break
				case 2:
					return 0
				case -1: // control being killed
					break
			endswitch
			break
			
		case "b_WaveListSelect":
			switch( ba.eventCode )
				case 2: // mouse up
					ControlInfo/W=WaveSelection_window lb_WaveSelect
					wave/T tw = $S_DataFolder+S_Value
					NameStr = tw[V_Value][0]
					NVAR PlayWaveSelection = $SpHrView_df_waves_globals+"PlayWaveSelection"
					if(PlayWaveSelection)
						SpHrView_PlayWave(NameStr)
					else
						//String datafolderStr = GetUserData("WaveSelection_window", "lb_WaveSelect", "datafolderStr" )
						killWindow/Z SpHrViewPeaksWindow
						//KillWindow/Z WaveSelection_window
						if(strlen(NameStr)>0)
							SpHrView_LoadPeaksFromWave(NameStr, -1 , -1, 0, 0)
						endif
					endif
					break
			endswitch
			break
			
		case "b_WavePlay":
			switch( ba.eventCode )
				case 2: // mouse up
					ControlInfo/W=WaveSelection_window lb_WaveSelect
					wave/T tw = $S_DataFolder+S_Value
					NameStr = tw[V_Value][0]
					SpHrView_PlayWave(NameStr)
					break
			endswitch
			break
			
		case "b_WaveStopPlay":
			switch( ba.eventCode )
				case 2: // mouse up
					StopPlaySound()
			endswitch
			break
			
		case "b_WaveListDelete":
			switch( ba.eventCode )
				case 1: // mouse down
				//case 5: // mouse enter
					ControlInfo/W=WaveSelection_window lb_WaveSelect
					wave/T w_txt = $S_DataFolder+S_Value
					if(dimsize(w_txt,0)<1)
						return 0
					endif
					NameStr = w_txt[V_Value][0]
					//String datafolderStr = GetUserData("WaveSelection_window", "lb_WaveSelect", "datafolderStr" )
					wave/Z w = $SpHrView_df_waves+NameStr
					if(!waveexists(w))
						return 0
					else
						string DeleteOptionsStr = "Delete \""+NameStr+"\";-;Delete All Waves in Folder"
						PopupContextualMenu DeleteOptionsStr
						if(strlen(S_selection)<1)
							return 0
							
						elseif(stringmatch(S_selection,"Delete All Waves in Folder"))
							dfStr = GetUserData("WaveSelection_window", "lb_WaveSelect", "datafolderStr" )
							SetDataFolder $dfStr
							//KillWindow/Z WaveSelection_window
							String WaveListStr = WaveList("*", ";", "" )	// "MINCOLS:2,MAXCOLS:2,SP:1" // single precision waves with 2 columns
							getwindow kwTopWin, title
							for(i=0;i<ItemsInList(WaveListStr);++i)
								NameStr = StringFromList(i, WaveListStr)
								if(stringmatch(NameStr, S_value))
									killWindow/Z SpHrViewPeaksWindow
								endif
								wave w = $dfStr+NameStr
								killwaves/Z w
							endfor
							SpHrView_WaveListWindow(SpHrView_df_waves, 0)		
							break								
						else // delete selected wave
							getwindow/Z SpHrViewPeaksWindow, title
							if(stringmatch(NameStr, S_value))
								killWindow/Z SpHrViewPeaksWindow
							endif
							killwaves/Z w
							doupdate
							SpHrView_WaveListWindow(SpHrView_df_waves, 0)								
						endif
					endif
					break
					
			endswitch
			break

	
	endswitch
End

function SpHrView_PlayWave(String NameStr)
	if(strlen(NameStr)>0)
		wave/Z waveforms= $SpHrView_df_waves + NameStr
		if(waveexists(waveforms))
			wavestats/Q/M=1 waveforms
			variable maxAmp = max(v_max, -v_min)
			if(maxAmp > 1.1)	// Prompt to normalize if: maximum amplitude > 1.1
				DoAlert/T="Warning" 1, "Maximum amplitude = "+num2str(maxAmp)+" exceeds 1.0.  Normalize to maximum of 1 and play?"
				if(V_flag==0)
					return 0
				else
					Duplicate/O/FREE waveforms, temp
					temp /= maxAmp
				endif
			elseif(maxAmp > 1) // normalize automatically if: 1 < maximum amplitude < 1.1
				Duplicate/O/FREE waveforms, temp
				temp /= maxAmp
			else					// amplitude < 1
				wave temp = waveforms
			endif
			PlaySound/A=2 temp
		else
			DoAlert/T="Warning" 0, "Wave "+SpHrView_df_waves + NameStr + " does not exist"
			return 0
		endif
	endif
end

// =================================================================================================
// SpHrView_WaveListWindow(dfStr, newWindow)
// Window for choosing a previously loaded or generated waveform,
// =================================================================================================
function SpHrView_WaveListWindow(dfStr, newWindow)
	string dfStr
	variable newWindow
	SpHrView_Defaults()
	//checkSignalsParams()
	string dfSav = GetDataFolder(1)
	if(!DataFolderExists(dfStr))
		DoAlert 0, "Data folder  "+dfStr+"  is missing"
		return 0
	endif
	SetDataFolder $dfStr
	//String WaveListStr = WaveList("*", ";", "MINCOLS:2,MAXCOLS:2,SP:1" ) // 2 columns
	String WaveListStr = WaveList("*", ";", "SP:1" )
	//Print WaveListStr
	variable numWaves = ItemsInList(WaveListStr)
	//if(numWaves<1)
	//	DoAlert 0, "No waves were found in  "+dfStr+"  data folder"
	//	return 0
	//endif
	if(newWindow)
		KillWindow/Z WaveSelection_window
	endif

	SetDataFolder $dfStr
	Make/T/O/N=(numWaves,3) $SpHrView_df_waves_globals+"ListOfWaves"
	wave/T ListOfWaves= $SpHrView_df_waves_globals+"ListOfWaves"
	Make/T/O/N=(3) $SpHrView_df_waves_globals+"ListColumnLabels" = {"Name","length","fs"}
	wave/T ListColumnLabels= $SpHrView_df_waves_globals+"ListColumnLabels"
	variable i, len
	string wStr, Str
	for(i=0;i<numWaves;++i)
		wStr = StringFromList(i, WaveListStr)
		wave w = $dfStr+wStr
		//if(dimsize(w,1)==2)								// list only if 2 columns
			ListOfWaves[i][0] = wStr							// wave name
			len = dimsize(w,0)*dimdelta(w,0)
			if(len < 1)
				SPrintf Str, "%.1f ms", len*1000		// length (ms)
				ListOfWaves[i][1] = Str
			else
				SPrintf Str, "%.2f s", len				// length (s)
				ListOfWaves[i][1] = Str
			endif
			SPrintf Str, "%.1f kHz", (1/dimdelta(w,0))/1000	// sampling rate
			ListOfWaves[i][2] = Str
		//endif
	endfor
	if(newWindow)
		Variable winLeft=15, winRight, winTop, winBottom
		[winLeft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
		winBottom = max(winBottom,30)
		winTop=winBottom+30
		winRight=winLeft+320; winBottom=winTop+390
		NewPanel /K=1 /W=(winLeft,winTop,winRight,winBottom) as "Wave list"
		DoWindow/C WaveSelection_window
		ListBox lb_WaveSelect,win=WaveSelection_window,pos={6.00,35.00},size={305.00,325.00},proc=SpHrView_WaveListWindowListBoxProc,fSize=10
		ListBox lb_WaveSelect,win=WaveSelection_window,frame=2,listWave=ListOfWaves, focusRing=0
		ListBox lb_WaveSelect,win=WaveSelection_window,titleWave=ListColumnLabels,mode= 2,selRow= 0
		ListBox lb_WaveSelect,win=WaveSelection_window,widths={100,35,35},userColumnResize= 1
		ListBox lb_WaveSelect,win=WaveSelection_window,userdata(datafolderStr)=dfStr
		// Select wave
		Button b_WaveListSelect,win=WaveSelection_window,pos={10.00,5.00},title="Select",size={50,22}
		Button b_WaveListSelect,win=WaveSelection_window,fSize=11,proc=SpHrView_WavesButtonProc
		Button b_WaveListSelect,win=WaveSelection_window,help={"Select wave. Can also double click a wave or select a wave and press return"}
		
		CheckBox ck_PlayWaveSelection,pos={70.00,8},size={100.00,17.00},fSize=10,title="Play selection"
		CheckBox ck_PlayWaveSelection,variable= $SpHrView_df_waves_globals+"PlayWaveSelection",side= 0
		CheckBox ck_PlayWaveSelection,help={"Play wave when selection double clicked instead of viewing"}
		
//		CheckBox ck_LoadAsIgorWave,pos={140.00,7},size={100.00,16.00},fSize=10,title="Load files to waves"
//		CheckBox ck_LoadAsIgorWave,variable= $SpHrView_df_globals+"LoadAsIgorWaveForSpeed",side= 0
//		CheckBox ck_LoadAsIgorWave,help={"Load files to Igor waves to improve access times (esp. for movies)"}

		Button b_WavePlay,win=WaveSelection_window,pos={170.00,5.00},title="",size={23,23}
		Button b_WavePlay,win=WaveSelection_window,picture=ProcGlobal#SpHrView_pict_circlePlay,proc=SpHrView_WavesButtonProc
		Button b_WavePlay,win=WaveSelection_window,help={"Play selected wave"}
		
		Button b_WaveStopPlay,win=WaveSelection_window,pos={200.00,5.00},title="",size={23,23}
		Button b_WaveStopPlay,win=WaveSelection_window,picture=ProcGlobal#SpHrView_pict_circleStop,proc=SpHrView_WavesButtonProc
		Button b_WaveStopPlay,win=WaveSelection_window,help={"Stop playing selected wave"}

		Button b_LoadWave,win=WaveSelection_window,pos={232.00,5.00},fSize=11,title="Load",size={45,22}
		Button b_LoadWave,win=WaveSelection_window,proc=SpHrView_WavesButtonProc
		Button b_LoadWave,win=WaveSelection_window,help={"Load from file"}
		
		// Delete waves button
		Button b_WaveListDelete,win=WaveSelection_window,pos={287.00,5.00},title="",size={22,22},picture=ProcGlobal#SpHrView_pict_TrashBasket
		Button b_WaveListDelete,win=WaveSelection_window,fSize=13,proc=SpHrView_WavesButtonProc
		Button b_WaveListDelete,win=WaveSelection_window,help={"Delete wave, Delete all waves in folder, or view signal generation parameters"}
		
		DoUpdate/W=WaveSelection_window // for Igor 9
		SetWindow WaveSelection_window, hook(WaveListWindowHook)=SpHrView_WaveListWindowHook
	endif
	SetDataFolder $dfSav
end

// =================================================================================================
// SpHrView_WaveListWindowListBoxProc
// ListBoxControl for SpHrView_WaveListWindow
// =================================================================================================
Function SpHrView_WaveListWindowListBoxProc(lba) : ListBoxControl
	STRUCT WMListboxAction &lba
	Variable row = lba.row
	//Variable col = lba.col
	WAVE/T/Z listWave = lba.listWave
	//WAVE/Z selWave = lba.selWave
	String NameStr
	
	// NVAE  PlayWaveSelection = $SpHrView_df_waves_globals+"PlayWaveSelection"
	
	switch( lba.eventCode )
		case 4: // select
			if(row > dimsize(listWave,0)-1) 
				SpHrView_WaveListWindow(SpHrView_df_waves, 0)	
			else
				//NVAR PlayWaveSelection = $SpHrView_df_waves_globals+"PlayWaveSelection"
				//if(PlayWaveSelection)
				//	NameStr = listWave[row][0] // assuming wave is in SpHrView_df_waves
				//	SpHrView_PlayWave(NameStr)
				//endif
			endif
			
			break
		case 3: // double click
			if(row > dimsize(listWave,0)-1)
				NameStr = listWave[row][0] // assuming wave is in SpHrView_df_waves
				NVAR PlayWaveSelection = $SpHrView_df_waves_globals+"PlayWaveSelection"
				if(PlayWaveSelection)
					SpHrView_PlayWave(NameStr)
				else
					SpHrView_WaveListWindow(SpHrView_df_waves, 0)	
				endif
			else
				NameStr = listWave[row][0] // assuming wave is in SpHrView_df_waves
				NVAR PlayWaveSelection = $SpHrView_df_waves_globals+"PlayWaveSelection"
				if(PlayWaveSelection)
					SpHrView_PlayWave(NameStr)
				else
					//KillDataFolder/Z root:WavelistTemp
					//KillWindow/Z WaveSelection_window
					NVAR preserveWaveTemporarily = $SpHrView_df_globals+"preserveWaveTemporarily"
					preserveWaveTemporarily = 1
					killWindow/Z SpHrViewPeaksWindow
					SpHrView_LoadPeaksFromWave(NameStr, -1 , -1, 0, 0)
				endif
			endif
			break
	endswitch
	return 0
End


// =================================================================================================
// SpHrView_WaveListWindowHook(s), Window hook for SpHrView_WaveListWindow
// =================================================================================================
Function SpHrView_WaveListWindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0	
	switch(s.eventCode)
		//////////////
		// kill event
		case 2:
			strswitch(s.winName)					
				case "WaveSelection_window":
					//Execute/Z/Q/P "KillDataFolder/Z root:WavelistTemp"
					//hookResult = 1
					break
			endswitch
			break
			
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			switch(s.keycode)
				case 13:		// return
					strswitch(s.winName)
						case "WaveSelection_window":
							ControlInfo/W=WaveSelection_window lb_WaveSelect
							wave/T/Z waveOfWaves = $S_DataFolder+S_Value
							if(!waveexists(waveOfWaves))
								hookResult = 1 
								return 0
							else
								if(dimsize(waveOfWaves,0)<1)
									hookResult = 1 
									return 0
								endif
							endif
							String NameStr = waveOfWaves[V_Value][0]
							if(strlen(NameStr)<1)
								KillWindow/Z WaveSelection_window
								hookResult = 1 
							else
								NVAR preserveWaveTemporarily = $SpHrView_df_globals+"preserveWaveTemporarily"
								preserveWaveTemporarily = 1
								killWindow/Z SpHrViewPeaksWindow
								KillWindow/Z WaveSelection_window
								SpHrView_LoadPeaksFromWave(NameStr, -1 , -1, 0, 0)
								hookResult = 1
							endif
							break
					endswitch
					break
			endswitch
			break
	endswitch
	return 0
End


// PNG: width= 45, height= 15
Picture SpHrView_pict_TrashBasket
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!#3!!!!`#R18/!*X66h#IET$#iF<ErZ1m,6.]r,6<%c5B[#,!#]lI=EI
	J[Aor6*Eb,5:A8bpg+A$EYB4XtP@:XY'a^mR7!%:Q56pXdsg?`)M=;=?XSpT]B1]^Gf'h+*ZUBX[SG
	#>N;fRdDqMC>DGfWc6oW!'2pTV:"t@`;)>m'-[$`K#W^(V'Kl`a,2/Ieit-q%D)&s4t_8AnU9Z4#?>
	qo:@bEZSJ@Tajc+Bq#>BUeP2]#r]_Ell6c:QNY<d8aR\om7b4_J48@7CM_Z:n*VTEM$`.F28hrb$6Y
	98t(8LZdbEpH.gml'+qtA-UhgJR3h/_V(a?DJX!>+DZlK\'H!%]ra29kXbj>*-^'c.Z:95kR\(-Y6Q
	?BAM*kg[jkf0?MP6UF+K;GpE(VPg8qdZRL6"%*0fUTMH+o^nNZ[PlU^dq.6:>"flf5YG%>Bd$7[k@S
	=<XE!:?/0cD"%a%s6D;*K9%EX):i8`kXY>hN$WC]i[%SKGf;ndVQ:8X_Y_#SeYX+QGad:NAB,71<PY
	KoL#!s%H8PK/`P*+^]R/P-QZ3B9*Zs3_j*UmkT^m9@%.9hilWI12)D5L`D'TBUC3C[ntL^aWUmFf.N
	uM0`pb+@)SXcp8Q!];W*D<#^HTVM=4L$M]:-KIE]sp,RKn/>IPhB2YC_V,!mQ*DW.W"[(mfl%aX\!<
	eLEGTt.lV+P&(C7h%\I@AjBfeJ1InU9`SXfm+DNAnbqkABRj=Ao;("(l:_o'kSr_`$&G<niU,rWk/!
	Vkq,)El]KM[0u.fk^<!ac%@/B6I>um*RpP_L9s*sG#RJbk:7Ml*":=NrQKdf9MC+_eg]Al(<41i$^E
	</@M6I,?T`gXc)-fOHq<dSIJ``OMpBqp/Y(2`;=sU$gpka!/seNCc->o<s4U^Z"?aXKq<>tS[K,u/0
	ekE,Z#f)k2Jq/q&[o`;'eA.C=g^:$*3CCLYT;&:)YFFK5^j_N$\Vj-$Q&@l+[$n:*,7rrLBo?P<j",
	21GsN\UT7lQ'a>B$?qO-fV-"5MUNWW%\'Z*1(K^:SRl@<:%NjhJRlX%#fJJ&oKF'sMf0BR*69GPD?/
	^*F!^#sB+l;"Y@D`1<]->!*_CO[^4aQn%8Wfb22"#33hA"Cu[;OHJ,pt'U4FR(5eCE+BZ[8'[ZEm>=
	4F>e[=r")cJA!.u4\r"8EUh]fa-"tOnrp&_k(c'K0a$UP#7MHRQeG%K+=9s4@feB89G"_bZa$cD8Vr
	;#R@0IU*??0TW*rn*')qh)o;+aB2AM+(R/m"E89j1!*MF]Sj8d%bKOkEYkh$]7NbscS!-nm6]W$]>,
	O^5'?Bmd,YSLXJ_@qU\>nQ%DnXM+NEc]p?N2J3Y4cLc--a6?O3oB]$n>Pq=)@f_63H!W^@_WepRH[L
	'.cK&:;3-Tjmg+RB2:>Kd?APfpi=YY/OCs8,?.&r7+JJn"K`"`<=$lhTY!Mrq)]Ka"V_n(1QDPEZIQ
	Wp!<3#SOY]'NgJD\%eGA6PB5KO=AQl-bZZNh!^]Qj,?jaM<s=99spVPFksAXami9/pi`65kCZJ.h\H
	O@MQaKJ3iYJi&$Tp+Rp.S1b](NKMM\['`oaE)/.5^2MlBeOiV1B8B^^(<r2lQncLV]Gp9o<iqVChVP
	>(c^loN3D&8,i`WCZjcI4ld2:p\9Ch3X;a]D6iOhD'5>//+id<WC#b:1N3Hqn:H+/$*iLc^U*bdY>d
	&W/\5C63Ora2@gPETmJmi!_2[:uE&mc9T6i%5PE+[$?ENoYSp,Wu^4L$JVu2alb4NmJbSVBi@1,TVf
	I;*;$u;9=4(Yi/3@hS#27*BKMcOZNEr!=#p:O,Jqe_M&AOTJX.JHu4O_>Sj"-R,n)A<SGV+_-3#"M-
	qL&]b&C:8?Qm*39@U`AP,RPnfblVB?ug)Ocdf4;>5Q\pd70R[]SqB5nbdq:B]\/P07-%Z9]CSLn73.
	Jmb\5WCT-a6jF<JOH_7a1^EOp8PqFocpMmf_*W20Q`]#OalH-eQ'\-C=eqRBL;l5/bdVEFXM$^dB<"
	=h:lcB:jtNSm9BnHkUcQ@hUurn__-0.O$DK-&:+3^]i?aYF-%F4+rbLE"X]G<WD*,P%BA$EjXDXRiC
	mNsPASc2L/@F^@)_'$raci!&j3GZYHM+S?>UD+KP+MB4!(Pu*c%S!"?NLi%,O^JNf*U^%!i7'89F'_
	m'(A[2N7B?9nUaDpe:/7^FC,)ED6Z2Kh#mRlIVrk.&W0(s!/%H5KhE4>b.HVKD/HWHmHkA)MZRY0XK
	8Llp?C+S$SJt4Ca9N"Sp_gJ;4$QBe-+__d5aesLELo$E!#h=3:AABY;er`#*;CIW[!T1BO?af2=#)f
	g2t'%TRbF;a2=-sbf%FZXB4lI6e.:thiBuIiNHS$b-#&DmL9(c*RKTN1uaiGfS-(9c:KLL@C?fbS\Q
	jKX^pG`#eDLp[O,lF)QegF6pq5%PtrO,,J?Pt9OP&-`MuFn8sX#;D*W>"B&)%DT1Qo/fsu1%N$aW=S
	3P?FT0%6#P(#(;+p_IO6m'bS'B8mK^Q*7NBi!fX,)d>648J"L&_MflSs.e/]b)>RR#1.baL@4T/&Ic
	G%j0)u=0J3s=A`=n$U\5r:R>A"E,it5IJYkNOT$1!&!G/FDV[pJk:;'8K=he,\"PT/Karu.h@0cS;'
	=AQ8@!5k[c?("_-99P/i`SpEXgI_,_'\HJsIh@&5U.8[=X&j#(Hs)GlFemZPP9N3pj4,2\.P07Y>5Y
	/!nF"3>^)mlpoPP1G]]a][?ZCf<:On<3NPKQUW2:MtIXA<!5#<O[$QZnB-RS6+#d$J\mN_+<'c+Old
	hD,Iu-2qTmID:912#`%NK"LX5HZ7n4Ar+oO>rRMIJYjEBnB;86,3<rG('mS#h:Vs&ZRK"j;UTrYsj\
	Q;+ZoT\d!k\H],<8m@7O;FdW7s$-aq(m]qMb#o8kmE5ai`R9Ui1=%R<^*#PltPd]UnmpFj2UE)-RG'
	/O%4OJc-+;"#]La1\Z`3?>Xr#1KGK?jnq(c8].:"cXgMqJ=19b5/LAZ-9A0jJM3h*TTl+BS2%\Q+l(
	l^?O@ubF_>+'SI=`fOKJp#ep)rhSF)N.m[P)"$@__m8)f+32Xm,&sUYi,Gr>-`,YsMlbOH;^`SWTR(
	MTD1K.`*K0h0mD[Nm9UPIWZ7h_Elt"]-tWD]KT"+$t:9#YTH3C`6`QjrWn2SjO5J$:*u0ETZ!EaZ*7
	;*B-h@%h3-47Ec!Kl4$0Q;QS-M_V7@c3/QoBT1r#^A.&CW%/ibppG4FQ\`MJ7_P8,QHkUo]#GYnR;:
	'2a]re]R59p]P#5foY"L3%.(*Jad.U.eM(9ecA.+gbIZGk'Vf]Y$T!4q<WuUPAHV5Q9#'CLU1>;>^(
	Scb4]"mY;7&JXVmjQDH:d8d4mX-$11G?SlOjhA1UZN=bOmDK-HT1_?6LG^ZAq[+7`nJl"'2H'`JFSr
	Q>[/-r]f,BuRDGkfos4*LnJ7)s7VNO2VU8P-J<\:VTEHC.G-I-(r(r/_A<)^(]MV5:#8q!_]pk`-ZU
	=qZDLU'5M$cC?sX,<\3'5E+<"&oEn.+;V@)dRR=:N.isPn\*9bU_.HtZ;$&HHQdA\k?1igCm+?CV4a
	W[=T+8t?NiP4n)(m`;6aS!!kFi:()@Z4O,AdC%r#'J\T29HbSfVt%&i\EKQ63tipkWsFrj4*Q.sa2W
	iCmCKMJAs`SJ&]@IjEQ]6DR)K.Si%5$n6Vm5r&%7KA]to(?e[]"S:]j`.%bN>-\bH;2J"4aHTDQc;1
	8p>cV!L(5.LqrPn]/JnJ*.*M&9^Ft4JB`lYaFD061$UsW"&K,:9p0e/k^fuWdj[+Hm+H.!<M/^i.ZU
	b+`;B'W'DcLpKC3nTUfJH;Sbq8S&\$pii;Gq84L@sF(G]^)hA7Qt[!_i=Wi#k+'kRaldQCF>14PUed
	cI,Th)>J;.J@O6]^Ai0ZAYHLg+[ULBd!9+II!lCN,DG-0[tX7s"p^0GNf%9J#7k8e_834OY_X#1.g4
	%J?$MNug)FFG<Se/h&GH6MfA_8Lp?aL>Y#lTm)oOL;SX`/=6q!"/k*p:"`Pof$g>BD[K<=%@5loq0B
	lZRaP5+#!#R9R/8Xh$c>b&]NQ97L@BY[!B%tHgl%()$fs29SD&WWD&pT%a$(QDHVRPelh)j:0RmG#+
	:8e!Y(W<%N^'e36pVP^4Qd/%X66G^`S7Z5"ES.%IKKa<je,lNUXMYM>B(f)rZZHUPE!-JTs>K!^B+M
	dJ'!<;Kc3u/_M->V8,60aH!2li3f@lZM.aKsa<^N/Z6D44O6NfK-t@Uip&Mq81B)":qZSiqIm^s1+U
	$W>g%e^]onbViE*C(kRe:`Id)+.8ObdJ!;-I0G`(eW`Ch]NW3!"2GQ^fg93Wf]/EYo[t^^>MNPn@eo
	<QaJb1&LCU>N*;igPUJlO@9]E2qDVi%JJ(2#MB-f,7mb4Lq_Q6'-Xa^S#8lI*9B8_Oi/m_Hj.6,]S%
	H%bu$j^fihRpB&b!3FWjbiKhBWO+/g)NPPH7$J*&bC>@kgAYQ_1Q!^%<NVheBl]Q!.+'n*BOZ1HKE_
	[><2KPmFsQ9q=CQ!@[ki>Vn,5/cu1[8SiBU%cJH9PbEaaS$9$4P"I_bB0"?%0"RuGG1q*dk<3ha@dZ
	g=dHa[mnVjDSdPpA6>rshYR:5Z`+kK]5;9q'ES;9KFi3g@F1ZUT`+*C!ta^0#:ImbR3peu_"<jg@b]
	6OudiG'<T.Vb`eXVP`33ET0C>ABO#WQXACug%g7f.mY[r2/:Y9p<fX*\&tbVTUjZR`Pn*n*PC2<"$R
	JuS;c-CJ@tu"Rp-L-pSO>GeZ7="dA'35J6(lhG-QSUOGiEd:`!/1>[1-5?iLSG(?qZWP@mY>X+*'):
	*0RgAtBs*/VCfN[:It='mK-'-,4hmKhE1C$m.N(L3!cpi^,Mus!A%**WWj,JUtZ/F6Ci68J2gUQbtO
	41#9chP&-6(AtbolA^fl,m'Vpm94?$R%LEGE+m+h&0d7;,;ZN[#8Ad1ti8is@$hs,jAN2!u[;+5aH2
	d_ercd\YX*5Z#WssTDRm_mpq[0!4BqVZE:\2Is)X@CgG2VZqs4qU`SXj?hp[;1X9e:F0Fc"s[h7.GL
	bpYCGmN')],1U]6/Mrn59.1gW'd(k'4teQ*+eP82/AE="($$0-=oIYFDrds-r>5G%i_dI>rCCnRkNF
	0u($YafQl\;1-s,F/_HU^lJ:',Jdo.^J79:bWL.];-+&";:N"FaC@jaKl:0bWmOhU7,+6SLBfiS7@+
	b73+m$8:bYma,"A6#j0Qn[Ko8Y7J4Wm%%kBi6EohJ<2J(@B^H]EZVg3bZk_)73NE7h6]]Pa%IJP?(X
	490(i(&<ol<PbgLWKF\7j[fnGc'RV%)\WV>?V?Zo>UFLaQ1hb6$92'Qpe>Z8jc1OS.jhQEL5?b3NG3
	mkn'U*VX5CP`0k3h[:8A%-(gc2E5UIItToT14`Sr!2jqXc4@nd>e$"/*E,nf0F3-FliFRiCIsX;(BN
	))9s^J,e!GCYcUHQ\fE@5<fTj4;i\<2eC-r6A-=m=b,BKoemN1U#@QY7Z@,/A\R!3FZW%^TRd24-fS
	H2]tF&7RckePAFO!gn0(/SJ,AWBh<NLhj2.-U=0B2.^%D&[Kg/QS')n:k7sC\P^jlG5+g$J/)`B6Ko
	eumI*-D0hBc]M^Jj3;)&(&'/4F$?WeU%;ge(_?MYCr.lV/t"`UD2J8fISVXL?dL#lP/UZnDV8HM!9a
	0-b^/-gsO<gl_15Sk8iX6(U)9fOT$$IPo^tf$W4VHkR\N[<<S*^lMX3F3LVg@7_9RL@F04oF"8cAF_
	W'!c0O?-j4:>:QJf"c'&'#eBr<dF20B<<%hIL1ICfNUqIB%V3o(Zq`<^ra]!e*1?G0N#IJS'IqXs.p
	<G!u1E6jU%ddQ"mGJUOoa&\]mH'2i=;!Z]7hd<p7V$m>#13pG+S<"XMZ3H'HDM\D[.=#fP!+!-Qh7=
	7#!<G&Dh<G+I#2U-!f</DkN35mE2Q\@?W"%%d$KYi^q`QF0F77rln$CjiK)QT[T:n]3(=\YG0oSA=p
	eldPZnr:N:\dBu^153DQ=t*[6//e_7fYZETqQH^-n)#^1'kN=5hLccSIPX19CFZH`f+/eZ\5+r-0@M
	<]=rR^7_WBQ%P=sg-kCs0E::NSAM-Mm?1LY'K9YDFCRJFN[6,B94M8\TOWuHuN#=Dd`cno6P:%jmWi
	fL2L4F%iRAA#&)9C'MI=5C6c^nFHEokFGbEjl[[W><6cl*EDs!-fVE:;Ysp4j/#IXh"R;,'kWV.dbO
	\o]A_5!E;Bf'8q+YN2NX6hh=8GVoC*J^5g:SXj7:lM[!*at=jF0$OL>J#.D@XB>^iEqLRnHQolui#>
	82%g2%qKiW<[nm##WFeR@ob=`<<ldtSb.%>8LW)60#XhCB@SNo\MUh+/`S>fIJ%i=48oB4FQ=Kl2L8
	*p<dVi]OlY2Jm:0[LQLe)n^*[qiHK2'4`8%05k!VCA.!_ft=kiAA(LTlN$e\@?q)Bd*.1$R"RsK^'%
	FrOot\s1a($P4*p^O3^>SKooRSp4*01$%V.b(p`\[1>dNSh(Rm?89fmb^R(!IHqR/ZRl;udV62*EqE
	)fEM!FHV7fB%BZ8("6"MrJdHG*sPSi;@H02f'OZ>FGq)l`r:M)d[XAc;Q)I!JCZ9SnM$VR+F@bSG:A
	q3a=mq2,n;`^-%X&[+R=j[,fe&4`e(d6[C,,lJjBqsP]pJQr<egikI]=eDXkW+P&^[VacFJchp9)t0
	!6;oCL<Es49-W`Dnhc^d/LI`[a!Va4CK$PtEXNN@kUk0,QFd$g$(e\F$gBMgJM)5Boq2K:ppD;2KT0
	\hp1?ktG<6h_\Th`tkMg9=lX$T1YJ2E_COb,D\C1dK;]4u&lWf,VS<.$;Fc6EKS5iLtdD5G\,pW:ZK
	U8[is7@SHhi.7h--(T"UMG6@d"&&9i[rZ9c]#0F=Yr3jiB#!Qf'$"%R&8P%c58U[IoBaj3?W'aqAk:
	qLY$@Z;4r>c=!O*4K)[VV?5p!8>(W(cC$Cs>f>5q:T*56c@il8,e_gK*Rsi383h0S7?DV=f<Rrm]5'
	O>P>j['G`3VH^KFW<,h!BP;(hII5arHj(ZY5SB*(+/%aR@H`]$J^ml8#:L"+/7^"48`G[(!5hMq5JJ
	Jt9N95WGB^6#@;`>j;p_B_0G\d3"D(>'cL!E#c@"BR8^klE+V;YS+!6>#S<IK#_#QA\4%qoQlU0ul@
	B`cKZs"[hbn)LPV.u\DXfQo0qHJj/QS)P^&+Ge&gBF'S;*dLaBsaiq#'c!s5#+jJ.Aoq5QI4hj1c^P
	BF[mFQ(>#1'BgIe$4mF"LGjlbRDPk.^rjSOABaTP\ce-lp&>\'(YoKQAE`#]]0[PqB!-)@rGmr2P(J
	l.hU%<1IXTJls4*Bgf"+g$-%01oD#r'F#Jj/MPYE,!nib!^=`<#UVY@"t,OI28Wi);QGGd\uM4d]K6
	>-us-A%uJL\cLmI6aU:>#4f<So6\6kZTDQ&S1Z?D*!AjYG9`4#=eJ=Ycj'f6Mi6o(=gP!LI>Pf=$hA
	>bNio%:4MQ15k&kYsh;mYXCMN)4B?-X-n-!o#E]MN&!H^4)-r`"9<4lK\g$W?8>QlN4L$QS=bgqB3\
	./:%YPur'O%pN3Np(G@)hkObo#W!\a\Q9@!FQVf_r'em)B*q0>ISM5jVm^#T=T"h:S)A3l.ur#[lL[
	A!8sbV)B#p80gqRd\V?0\^3/bm4P1JAcj$ffqVudF'.-D/'!L=6IsD,qL_c,`5V'@=I;F]L8_,61+@
	OrPgpp?RjcSDnS`lo4Y%m0d",@[PFl&4r6\YXN+1WTokPOjR<oUFclrOl$nqtjN5Q16'^NaHhjp@j?
	7p[)NFM!6@H6o@q]g78TaiBD^X"Re'G'7b&hV9b<0^smo*_3$XJqATgV&4jT%Lg[,!.EP'@5(6aY?S
	K=Wd)6eq22@Q?fe"NM^jX1,S2*_TDnWGO0g1kSn.Q&XM&"'jgAdLU7Rg/Q_RcJqo=I$RjrD,*Ym/BC
	E]N<!]2raQ2l^QRl>92U,4iEXpBQ;)`O@P!5F1r:n(LqQU]Z^'OSVX^,(-Y9CE5pkYrU_K7UL%!o,]
	^CB4#CJ:#e+*BV[o+sN9+[r3p@.IPotla0:;q]R++#8*2P1&Keq\2Xk(YV/jVC9_QiJ,p!j[#KYfp4
	aKmjli!EAcua;W6<;nF6A!JB`eHi2oIAsR5MqKi8=u7`ImJ0JC2IfMjp3*JWZ)B6dQ`JH!-<Kj_;8?
	eZ,1McX$URb\5JTde&^EAaqt@hX5JLHM$ESkih4Tje;Xgh(M-aNtGuUirJ-S!8ED)ImG+11c7./^oj
	n.S*YeN3$WE/4r;[V@:;5`M/&(i26$l_Ve?)(2$aH$iY7Q)+H61Hd#>P>RT_:C*hb1>jmAa/L\OO1i
	9h')S>;Z(%Cl$^GB`ee8Z.7M(Ik+i@O.+UJ40'75m#&\LPK5<]asn;nonc"+/F?grpo0oo-=sq"KK5
	l2@frk.gn2q.dGAA.On&qGOOD\Unjg>#Rg@phqqXA*qi<rlOr<dG449N&HbB,hCfQ-qpE>"m#shN[0
	NY*M*tj2Ms;e@<nq/uPEV3YhTgST>!i8^n>BUniGL\^]s1&H7])8f^YZSH:UacML<h!e.u@g["]Jg!
	D2+k0JE.*7]RB\N.=:aQ,m+]lRU!b\e[<HD5Q@hOhnQp"peAWpiPY%3NId6m:f+A,G/@(t`(iO1&>Q
	nN]]O.h]WhZk3e'af!'i`'iHPRH\+A.G.iPC$WEM8o)KH;$bEnor&MlaYULqcPb*=J-l17"k:udFjM
	H]$X=2?j<eY>VFC[ll%\tXY[@Bc(`6S:]PIe3]"e?(5B?+Y9NM`Pd:O,qU`Ms,3Rda3P?4b4)m%dK/
	dkp:Wf.KQcW!8+K/RF7N2Ku+B@1fXAnJXtZq+i@!t,61,$7[@M&A;\,:N])3p\k<(8()TT/KYNuVDG
	N't>@BLHI-QHc;Pf7g`3/TI-)Dp!Ka!1S`70IT87&33*<u$'QSe!WX\7Df(lP#`H2@/I:S_?$>?als
	92"Rn]cYc>TJ+R3ag$L"^-EN7AXb%Bqtgo?!8%Wen2$$r]Z#dFlO1J^RZj<628DC_%G/o+GY"uQOA6
	7u]tNm;?G5(Le'jM1dA*MIUbdt>/Wbc56r67qk<mD>Y.4t*TW5H/FpQTF]0:Z>S<b]t-j8I&UjiIK-
	5N'/CDaQATLe&"Z,7^[F<lL!<_JJP</n1rcQ3aMg>qe!8'J&$"m.hqMerq1i@;+h2rCiHk]8ubqY[`
	`)@QU)hi4=QX]d8-4l-#JIYVRM'cS*mXAGV-9+6J41+'%&NE6N-k(UanJNY)CY<s)ADP?ps]k:s'T)
	Dcu="m23eM-r\J-X0=p4(]3&KDcQ)8(F#Y+@7?cA]ijcaT!0<9YDbFt<fLUmej)Gre3b#F40W5VNBR
	?G1gdg)P2W(m6H\]_=!'[i+^BJ=R2f(qPG%rD*:)9ImooHOc-c;Ul7b^,pf1)#lj*?>_AW&KAnC=]h
	oZD;-fR`17kgfg>]BCi=DPCXq\T(3emLIgp>ccloKFNK%V)e*gib$l587?X&ncR2&]);55A7>s>Wd?
	:727!SZOa>UGB*M('1[^ckq/*tf21CYul)nPc>\F](U"1X*4`7mK=)`mgtdWsHlV/58i51LS:<o^1D
	b+4ABn@7gn$aO$M9p$:5m46t=$k4H>fqG8",c*+kXMNK0[I!U(KTHKk"c`HkDN5gQOeZ,[A4F&]U?b
	_%pqEoUo5da*WnsK&Z+.#1WU19o^fo$Bg;,PJ1)`Ii66]'OdX[b8RDIC4BGefrb>.(BsiPQ2pCFic*
	N(s&8._K\'b*E88n3)#0&6,c4NF'A0p[?r$04*-$,IMB*92JBTSXo.4B[EDt66#(6i"dZqP$t"Bp@.
	PWcHXTsO)(G(R/VNSJ$]_03in)jX%7TbUdCW=6=La#rquAhUr4Ng!j8cKM5@#DE:m#T;EP6OY?nnO+
	(je&*"<iE@PA;f)u.NVPI7l<h)5@_f/PB8Nk6q4gps2ZUT;jbd@s)$0Q<1=AY[$PB:`F9lq1_2>J2e
	Bc(6qZdi/.4?B8ea5%WVMh6qGFUCY!H*&NIghR8E+@6;ZaO%&Ki_cABoc;k1Oi]nmf;n$'rMD[)dA[
	Q:'.f1&%,^iZ`o4O:7YZ&2Ph7><pIOD*<qO&cA*Rgo^^C$R5['I!["]&46J+l^E710?[(XJ^0_Y*S;
	f3#'qIUJj2G-L;Sf2u))HY.#%b!3o-^M"2u4)u$:q:7E<0RZ)Ik0gFd4)t0X1GUfH?aJ+0(?j,E,MO
	$JQi0g,V!1[EJs<rRHJaDWVa#(S3#O])KhpAM2fIP`G4tWGe<hrjq^cWXVYp-,#<;)pE:usF#J"oZ?
	E@_]QMg(-j2[*iqtBI<;LY5;Hp1(LrA5aOJ^,uk:a)"uoF5!0$go%Fqr=7%[g-S]C"8!T3si:66Y0E
	<KtQ3R[;(MH!L*f\K!pl94jT)u*B:in+Os/E9pfFWc7Ipp4Pp83kV']T+;fD<!!L:Z\;^,^A@)5H@K
	9pF=Y^c&Bd8snSfSrc$k7lXF(U%Ha06Wj]!@Ej?oH5G3*X+-.B?UpL2G\ZrKH\;6TYCsf<K*n>I2@G
	T!1/ADp#N5+E*5=6LJAmSs(P._SRMjUT5p"'c+fme+5M6hOK'1AE;rO["C%o%N>C7JR<?BYS!d(*?@
	4]RR;18`/#!\OgZF80mE'@qq%"7(%"5i?i:>hQN6fJR$`(j(+q?S4W&5`"UVhWeurQq]>@][6@9Yqr
	>.%roSH/_b*Hk[]_SX#djE;LGAfBhc5a89.#>EpT>1]MW\nSE1f$oUFN"ULlg7V_q"`1+`@bK,^ePq
	8_=I0gfa'Mq2IYTu:C?rLY-'9K9MD<`Y?mdK&>Cg8TT/_eK3>OjPUC?D?c_C,a<3ILC<=c@`PG$k?t
	76:jVoI^gTn5GgJe&54nsdoR#djmM`lBF%s2i3g=k8dq$[+3TJc8$oX=2UmUg3IIR+qp`Y:?Wq)XoQ
	)]7tZ[:.N2m^_Q0[0tI5eDfbchTe?0p+4X\$j21'6l/Uh36Br!dAK\/i8s0T]/-=2ZW1emZ<;X*[%)
	[0%iI9im0jFK6P#kKql8XWgcbG3O77s]l""%_ST3c6(&$sa4)E<]KrbsgV7P*]]m0),_m<9)&c24ea
	4:CuEl1$#VdKr"VL5'#kiad-"<%]^qt/hLA,4QLlrrs[#+A$L>ZM_sEH#m$EqJSCc-WmN#7hlg6Oh9
	n#k.tID]=)I'LbI7WI&h[jlO^!qK,a<$+pU7?LX9*]X,^SpDT]%.#M0brr%*);eXds4o=p(?[5._:r
	!nV=L4IfhDt2i0jS'JAm<<Ad>&7h5in3\Yc1W\:%WDfDSks(1c.)QMI%V"Z2XfnAG)tQD"QpG+,j9S
	<I!XT?Cl!$r-9i4h0KjF,ID7ed(l_[ZR.nD*jCh!IYX4!!;\Q:!49.VfNR'K]__gI',Ac8@:10;Eho
	guO3\iW9^\a3jqgF"eu`5YK^,DI(>7\9Mi#]_JCU^R1bUL+1*>`)]!^J+;tr5mPK@D&qsWo30;%AaQ
	.)"e2Dl)ifanQ#J'a_s+$*f2?&&o[-H#p1FKV=2ag[N[^8qhT]mJ)nEnO7:ce$dcaN3R*!iodA`N"I
	.cld`Hj4r)2P4S-mPq1%ds+W7(CN0'Te(;aUBDCs^6A@#PC$TH=r;6UkANG#$aIYPAarW]lbkHf:C/
	_$:*=VR$\\>elL2(CN5n]dEG-o5pW8<Aob^qQ1+-_NN!b%V%$<Y9,4&OuLBSiJYqY1=q5a0UIlG:No
	/^PIh:1H+@*GQ)od'uX\<WP)[rH=Y(F?YLOi\kT'XP=_,nWG1O0YkO6$k9acSW;=*?ZT_@r:HI:Ch*
	ni/LmMRRm?<+m-N@eIt'B4a."Yd]S&:gG(djZNM+Hc[ZKD'GGZI[3;;jtj7<dfe%?N6#!O,[4F]4>^
	G#uObLtRLAZJi4QXEK>>eHFCE[8\bNK#(2AsAjMj:ch6$E/)c83gO$oV4p;ZKoWSCaR;eL="H"?u@2
	ZE>gNXmMp*POJ8tZ>*WEG@*??2$"R>4S2eSB`Et7d4j`l]io9OQbfn3ni]n/h<'SfQ^Do8NR^Zrr4+
	m)$2:-N@=/SjO^22-`h9=a$SpR`n5iS!Np;$Y</kj[rSGHY:KqY%IW]t+bjT/\0h3"`+d^:Sa?5nCG
	Qj'X"a'PJ"Lr(Qt'g/X6?&a!kdY2N]@oLCh%JRn=SMlHHJcm">,;XZV^qO3-5`6JOr!@mJd&U5$p/B
	<bQ3Ys4S!2[p14<'io,MW-j5WoKi!JW,2V04F1I,.s?b421U27;G%VR*L5%tZ$T0L),&<MtQo#6N7W
	C$NZbFBJ.CYk#Y11\#6_ps;;dO:+-RFJdF:7Yj<DVo%bDVh#s)=VDunY.=SC>@V"Gc*K6e>Q(6f<hg
	AP#+9=i!l^X;c"$p$_ru#%(QISks=.:FWgKH3O%^cIR^QjE<_ZMTX:NUV'm`?-N6`Z[mS?)bc+f*m[
	'h4P;]2POI);8k..4,[)gJ3f9a5.c#RiGQs<#(%J=)sgeiPmqb*4DFGq4r7\Ql\VeHE(OuP(:Z6]pk
	W\EpU*=Y`S&6G^9ij?@k@`=4@f^RiRjAp9\D;_(<Cj/8Mcb"Af)RHPOS%[.j@L;SpOQ<tMgJ@Y@Gq:
	HrS)rep]S\jlif!Y"?".9;6X![I"nLa$LC6Z<QO"ZeT`*W'E,K&kaQF\ErYatbh"HS`MW/Dn$uq7Ri
	@^Wba&5eVG"]DmjbOh<?SLEWA#>l*4ohcZlU\$Y>;HY.F%1m*F_3h5>ESD00Ca[$,cUV6SV/Y#Lu9D
	kd+9oVj90`(I3-fs3P#!A%NkPA2u=*l$0_ssn"DcWQ@5mq"7>%TjQN(7W"\:?\$)a5oZ?kJZqk+=!P
	<=@U707&;ZJHlWMuk(JVRR7=J:<U/N:`T`Q<guQ3*Ym8.18FC0hYE":P>oUj6s'<jph=9cO,;qld),
	ZfX+0dZtZ/OZ'!2jl?I+8<`0[^usk-!%9<[',RRD1B0bX9+G,HguQ;(#:%\q;]Pm`EtRn`OF**N>m*
	9mk7e[GKE2541OOUlrnA@Ea4jg:g%+7icdDY,"($DSO8ggcNVZHnC;?k\p$m_Xs!,;ZqjI8fIuOLUz
	8OZBBY!QNJ
	ASCII85End
End


// PNG: width= 60, height= 15
Picture SpHrView_pict_HeadPhones
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!#q!!!!`#R18/!6N@53WK-[$#iF<ErZ1m,6.]r,6<%c5B[#,!#]lI=EI
	J[Aor6*Eb,5:A8bpg+A$EYB4XtP@:XY'a^mR7!!T2j6pXdsg?`*>87P^8Shql1-DE7d,BcmS,mtIJa
	p_f(\<o\gB-B[iL!W-o,&o&60Oga!AeE*.$TB:T3(%9hd=j7^8$o<F._9lO8-BZ].ZHtjK70(!E%Ea
	4kMGt$chG93kf^ZMkFD!hkM3^oYNP?AmKijnEoROp!!#9+!!#9+G$%sQHg1'FmN/fU31PWUW^G7Bi'
	X!aqFp"^^:q=Ba^d.:/'8*X)`;pfq"1gS7]q(H[JE]'%1Nbr?=.%u=Kt^\42\L'FNXeG6=)0j&g^K(
	JO`4#+Ys(4,c>)*@^5\B<.Ub_<cD57",6acJO&/cr;8ZRlakj*gTP_sD:d'0GUPUQZALK1CNjH?Sjl
	7Gn/09lNi?dU"JXL=.3H06EH*];ZAUTTp@`Y]T?juu3eDpYm^1a-iF.OaD59>GcgpYtG=MHagUF,@K
	cR8eRE]=KA[JYBNCf+I7WDP[knSHVhLBWpWOe8!Z8$*;Ki<2edcPS\m$#Cc@q0$?-m8T6^7qUj/69l
	,"Hs8:A&f'1D4Jf2_E)j+,t/N=e\W6?[rV37o^'@\$7WR:@*E5hYB5/"*TSEF\m68ZcC.S1/#)6NlG
	q<"dFW>ifQAln7NS.!5g`^a_SEt&o#f+tJDKZBC+\\g)?n\X5kLMT]Y&XCeC8T^.S-_FY3HrF)m<48
	ha)@7$_iOlL`ea7NZ+I0O<BG$j%7dke(3+DLD'eaVpdk]$;bir($@dYIfEb62`H1#<6+7$!a5M'%k+
	UEAcni2/CnAfR31@ul51Tb:K_u8(M&5oF/K)1SXk*4#7$erFSbU91@ET=dZBK5TG32WSTJJa<e9Hkk
	"'Z[WN3'M+r`f4D@=9g:nuFal02m^0)W@7VpUR_n%XE26$1l.1p*<<5Cl)X>\:sCS"'<.bk3f"a]7k
	4%]&M4VO(o8(H&Urq/3r<@fr5MH:poSM451Bn*aV=)r1ZgXoQjF:/7Cm3Itj#qT6g$B4kja_qjt4gY
	9=L/"f@UU>Gq$aE>bPc"A6GYIhE9lhA*%\$o^p7Z%bJenVB'/1`?2)SK1ih+Ms8G'_p\GB.`p2pao5
	\?bXX)iJ\[f98\e3&<@ScnXkIR&J>n\lZl#eC:[>:"\Y#Psf[kI=8f&f5tY<B+qr7KE+RXh$m@cBq&
	QZD6$!h"@[M?jRc50T3kr4mtV7t#MIMFlt=E%+KujKE:Y=eYLd!!o#-^g/X+;(0@EE2(Ddn6bfk!DD
	m.(F(kk;MjU"]$Og7jQ0V(u=a>-:e='&b_-+TtjBm+s1=R;#G2boG@7ktq`GsS:XZg0GHDA=4L2)8O
	k'K*Is%OVdoOJ!hXC`f0<,\G,9\WsqW$HW&=q(WTdo"H,YgD!J#eXbk,03JcijI)N7F9Pb%H#riOnF
	3.\%\'&]rWQ^<E22V"WDmV[@U^Mb`K=BTNNB;`&eghFTENYN9;M!=#K53E<Wqgp5]k*[M*ufZ@3.DT
	&-1+Y?t<e9RM/osq0X-u(>u>bkFnc;WLi1E4t#*?\\5<\^nIL3[^P=,C3]fBKBN;&co?+Zfb'%c%*-
	E/Y1Al,V?LOMQJ6R&*#s>:b+M5e[]V0H8j48,eE6IT#@jFj>XNUr7j='I*ko\Ad*Pun7SjT95/E5<N
	MtboWD^93k/'o`S"!8O#)_h^b"3A&8B^+8iE.Z)faB=(;!=iS.""D]+,r`K78DH[+aM&hTF>T-s'^D
	,^S@j1CEEStVij9OUOH.sW2A;0L8n`"PQB/P<HBIV_fu1l$B<Q+lQAnKPAq>-;^kK`2M<ZtNM8e"pf
	Dst:`]=!,WT8&[."77]LE/$c2aO$+?BK&&cjYn!!%fb!.YLQ=+C;OpDIIl`EG??z8OZBBY!QNJ
	ASCII85End
End
