﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


strconstant SpHrView_OverTime_DF = "root:SpHrView:OverTime:"
strconstant SpHrView_OverTime_DF_Globals = "root:SpHrView:OverTime:Globals:"

// =================================================================================================
// SpHrView_OverTime_Defaults(), defaults
// =================================================================================================
Function SpHrView_OverTime_Defaults()
	DFREF saveDFR = GetDataFolderDFR()
	String FolderStr
	// Make "SpHrView" folder, SpHrView_df
	if(!DataFolderExists(SpHrView_df))
		FolderStr= SpHrView_df[0,strlen(SpHrView_df)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	
	SpHrView_IPDNeuron_Defaults()
	SpHrView_ILDNeuron_Defaults()
	
	// Make "SpHrView:OverTime" folder, SpHrView_df_cue
	if(!DataFolderExists(SpHrView_OverTime_DF))
		FolderStr= SpHrView_OverTime_DF[0,strlen(SpHrView_OverTime_DF)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	// Make "SpHrView:OverTime:Globals" folder, SpHrView_OverTime_DF_Globals
	if(!DataFolderExists(SpHrView_OverTime_DF_Globals))
		FolderStr= SpHrView_OverTime_DF_Globals[0,strlen(SpHrView_OverTime_DF_Globals)-2] // remove trailing ":"
		NewDataFolder/O $FolderStr
	endif
	SetDataFolder $SpHrView_OverTime_DF_Globals
	String sval
	variable nval	
	// Envelope weight defaults
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useAmpEnvelopeWts", 1)
	variable/G useAmpEnvelopeWts = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"EnvelopeWtActLimit", 5)
	variable/G EnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"EnvelopeWeightsdB", 1)
	variable/G EnvelopeWeightsdB = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"usedtEnvelopeWts", 1)
	variable/G usedtEnvelopeWts = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useAmpEnvelopeWts", 1)
	variable/G useAmpEnvelopeWts = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"dtEnvelopeWtActLimit", 5)
	variable/G dtEnvelopeWtActLimit = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"dtEnvelopeWeightsInterp", 1)
	variable/G dtEnvelopeWeightsInterp = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"dtEnvelopeWeightsdB", 1)
	variable/G dtEnvelopeWeightsdB = nval

	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useIPDs", 0)
	variable/G useIPDs = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ScaleIPDToITD", 1)
	variable/G ScaleIPDToITD = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useILDs", 1)
	variable/G useILDs = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useCarrierCues", 1)
	variable/G useCarrierCues = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useEnvelopeCues", 1)
	variable/G useEnvelopeCues = nval

	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"DisplayActivitiesMode", 1)
	variable/G DisplayActivitiesMode = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"DisplayWaveformMode", 1)
	variable/G DisplayWaveformMode = nval

	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ScaleILDtoITD", 1)
	variable/G ScaleILDtoITD = nval

	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useEnvelopeAndOrCarrierIPDs", 0)  // used?
	variable/G useEnvelopeAndOrCarrierIPDs = nval
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"minEnvelopeFreq", 100)
	variable/G minEnvelopeFreq = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"maxCarrierFreq", 1500)
	variable/G maxCarrierFreq = nval
	
	// Filterbank low and high Hz
	NVAR lowFreq = $SpHrView_df_filter+"lowFreq"
	minEnvelopeFreq = max(minEnvelopeFreq,lowFreq)
	NVAR highFreq = $SpHrView_df_filter+"highFreq"
	maxCarrierFreq = min(maxCarrierFreq,highFreq)
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"minPointFrequency", 100)
	variable/G minPointFrequency = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"maxPointFrequency", 500)
	variable/G maxPointFrequency = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"setPointsAtLimitsToNaN", 1)
	variable/G setPointsAtLimitsToNaN = nval
	
	sval= StrVarOrDefault(SpHrView_OverTime_DF_Globals+"PeaksColorTableStr", "Turbo")	
	string/G PeaksColorTableStr = sval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ReversePeaksColorTable", 0)
	variable/G ReversePeaksColorTable = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"PeaksColorTableAlpha", 0.5)
	variable/G PeaksColorTableAlpha = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"PeaksSolidMarker", 1)
	variable/G PeaksSolidMarker = nval
	
	sval= StrVarOrDefault(SpHrView_OverTime_DF_Globals+"PeaksSizeModeStr", "ABL")	
	string/G PeaksSizeModeStr = sval

	// must set to a filter bank center frequency
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"Frequency", 500) // refined to CF below
	variable/G Frequency = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"FrequencyIndex", 0) // set below
	variable/G FrequencyIndex = nval
//	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"EnvelopeFrequency", 1000)
//	variable/G EnvelopeFrequency = nval
//	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"EnvelopeFrequencyIndex", 0)
//	variable/G EnvelopeFrequencyIndex = nval
	

	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ActivityLimit", 5)
	variable/G ActivityLimit = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ScaledCarrierActivityLimit", 0)
	variable/G ScaledCarrierActivityLimit = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ScaledEnvelopeActivityLimit", 0)
	variable/G ScaledEnvelopeActivityLimit = nval
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"InterhemiphericCoordination", 1)
	variable/G InterhemiphericCoordination = nval
	
		
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"getEdges", 1)
	variable/G getEdges = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useMaximalLablesForEdges", 0)
	variable/G useMaximalLablesForEdges = nval	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"getMaxima", 0)
	variable/G getMaxima = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"useEdgeLablesForMaxima", 0)
	variable/G useEdgeLablesForMaxima = nval
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"getCarrierAccruals", 0)
	variable/G getCarrierAccruals = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"getEnvelopeAccruals", 0)
	variable/G getEnvelopeAccruals = nval
		
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"DisplayActivityPeaks", 0)
	variable/G DisplayActivityPeaks = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"appendPeaksToImage", 1)
	variable/G appendPeaksToImage = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"appendPeaksToImageOppositeHemi", 1)
	variable/G appendPeaksToImageOppositeHemi = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"PeaksAreABLSized", 0)
	variable/G PeaksAreABLSized = nval
	
		
	sval= StrVarOrDefault(SpHrView_OverTime_DF_Globals+"ColorTableStr", "Turbo")	
	string/G ColorTableStr = sval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ReverseColorTable", 0)
	variable/G ReverseColorTable = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"minColorTableValue", 0)
	variable/G minColorTableValue = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"symmetricScaleRange", 0)
	variable/G symmetricScaleRange = nval
		
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"holdYAxisRange", 0)
	variable/G holdYAxisRange = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"heldYAxisRange", NaN)
	variable/G heldYAxisRange = nval
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"AppendWaves", 0)
	variable/G AppendWaves = nval
	
	sval= StrVarOrDefault(SpHrView_OverTime_DF_Globals+"PointTypeStr", "uniform")
	string/G PointTypeStr = sval
	
	
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"AlphaMask_ABL", 1)
	variable/G AlphaMask_ABL = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ABL_Min", 50)	// reset by SpHrView_OverTime_Activity()
	variable/G ABL_Min = nval
	nval= NumVarOrDefault(SpHrView_OverTime_DF_Globals+"ABL_Max", 50) // reset by SpHrView_OverTime_Activity()
	variable/G ABL_Max = nval
	
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	if(waveexists(CFs))
		Variable index, Hz
		[index, Hz] = SpHrView_getCFindex(CFs, Frequency)
		Frequency = Hz
		FrequencyIndex = index
	endif
	
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_OverTime(), Edge model IPD
// =================================================================================================
Function SpHrView_OverTime()//variable cursorUpdate)
	DFREF saveDFR = GetDataFolderDFR()
	SpHrView_OverTime_Defaults()
	
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
		
	NVAR DisplayActivityPeaks= $globals_dfStr+"DisplayActivityPeaks"

	NVAR getCarrierAccruals = $globals_dfStr+"getCarrierAccruals"
	NVAR getEnvelopeAccruals = $globals_dfStr+"getEnvelopeAccruals"
	
	variable selectionSum = getEdges + getMaxima + DisplayActivityPeaks + getCarrierAccruals + getEnvelopeAccruals
	if(selectionSum < 1)
		DoAlert/T="Warning" 0, "Must select Edges, Maxima, and/or Display activity 'peaks'"
	endif
	
	// DisplayActivitiesMode 1:Halfmaximal, 2: Maximal
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
//	if( getEdges && !getMaxima)
//		DisplayActivitiesMode = 1
//	elseif( !getEdges && getMaxima)
//		DisplayActivitiesMode = 2
//	else // default
//		DisplayActivitiesMode = 1
//	endif
	
	NVAR minEnvelopeFreq = $globals_dfStr+"minEnvelopeFreq"
	NVAR maxCarrierFreq = $globals_dfStr+"maxCarrierFreq"
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	
	// DisplayWaveformMode 1: Carrier, 2: Envelope
	NVAR DisplayWaveformMode = $globals_dfStr+"DisplayWaveformMode"
	if(useCarrierCues && !useEnvelopeCues)
		DisplayWaveformMode = 1
	elseif(!useCarrierCues && useEnvelopeCues)
		DisplayWaveformMode = 2
	endif
	
	String OverTimeWinList = SpHrView_GroupWindowsList("OverTimeWin")
	String OverTimePointsWinList = SpHrView_GroupWindowsList("OverTimePointsWin")
		
		
	doWindow OverTimeOptionsWindow
	if(v_flag)
		killwindow/Z OverTimeOptionsWindow
	else
	endif
	
	// Load waveforms from SpHrViewPeaksWindow
	variable startSec, endSec, usingAxis = 0
	[startSec, endSec, usingAxis] = SpHrView_OverTime_LoadFromPeaks() // SpHrView_LoadWaveformsFromPeaks()
	wave waveforms=$SpHrView_df_files+"waveforms"
	variable numCols = dimsize(waveforms,1)
	if(numCols>2)
		DoAlert 0, "SpHrView_Cues: waveform has > 2 channels/columns"
		return 0
	endif
	if(usingAxis)
		//SpHrView_DrawSelection(2, startSec, endSec)
	else
		SpHrView_DrawSelection(1, startSec, endSec)
	endif
	
	if(endSec - startSec > 30)
		DoAlert/T="Warning" 1, "Time selection is "+num2str(endSec - startSec)+" seconds long!\rGet activities over time anyway?"
		if(v_flag != 1)
			return 0
		endif
	endif
	
	//////////////////////////////////////////
	SpHrView_OverTime_Activities(waveforms)
	
	if(getEdges || getMaxima)
		SpHrView_OverTime_FreqImageWindow()
	endif
		
	NVAR DisplayActivityPeaks= $globals_dfStr+"DisplayActivityPeaks"
	if(DisplayActivityPeaks)
		SpHrView_OverTime_PeaksWindow()
	endif
	
	
	DoWindow Over_Time_Activities
	if(V_flag)
		if(getEdges)
			CheckBox/Z ck_DisplayEdges win=Over_Time_Activities#PCBar, disable=0
		else
			CheckBox/Z ck_DisplayEdges win=Over_Time_Activities#PCBar, disable=2
			if(!getMaxima)
				DisplayActivitiesMode = 0
			endif
		endif
		if(getMaxima)
			CheckBox/Z ck_DisplayMaxima win=Over_Time_Activities#PCBar, disable=0
		else
			CheckBox/Z ck_DisplayMaxima win=Over_Time_Activities#PCBar, disable=2
			if(!getEdges)
				DisplayActivitiesMode = 0
			endif
		endif
		
		if(useCarrierCues)
			CheckBox/Z ck_DisplayCarrierActivities win=Over_Time_Activities#PCBar, disable=0
		else
			CheckBox/Z ck_DisplayCarrierActivities win=Over_Time_Activities#PCBar, disable=2
			if(!useEnvelopeCues)
				DisplayWaveformMode = 0
			endif
		endif
		if(useEnvelopeCues)
			CheckBox/Z ck_DisplayEnvelopeActivities win=Over_Time_Activities#PCBar, disable=0
		else
			CheckBox/Z ck_DisplayEnvelopeActivities win=Over_Time_Activities#PCBar, disable=2
			if(!useCarrierCues)
				DisplayWaveformMode = 0
			endif
		endif	
	endif
	
	
	SetDataFolder saveDFR
End


// =================================================================================================
// SpHrView_OverTime_LoadFromPeaks(), Load wave named: waveforms, from SpHrViewPeaksWindow, into datafolder: SpHrView_df_files
// =================================================================================================
function [variable startSec, variable endSec, variable usingAxis] SpHrView_OverTime_LoadFromPeaks() // variable cursorUpdate)
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_df_files
	variable minSec, maxSec
	NVAR useEnvelopeAndOrCarrierIPDs = $SpHrView_OverTime_DF_Globals+"useEnvelopeAndOrCarrierIPDs"
	// get selection if SpHrViewPeaksWindow is open
	// use Marquee if drawn
	// otherwise use Axis
	DoWindow SpHrViewPeaksWindow
	if(v_flag)
		string traceListStr= TraceNameList("SpHrViewPeaksWindow", ";", 1)
		string wStr =  StringFromList(0,traceListStr)
		wave w = TraceNameToWaveRef("SpHrViewPeaksWindow", wStr)
		string pathAndNameStr= SpHrView_FilePath_Get(w, 0) //note(w)
		// get min and max times
		minSec = DimOffset(w, 0)
		maxSec = DimSize(w, 0)*DimDelta(w, 0) + DimOffset(w, 0)
		GetMarquee/W=SpHrViewPeaksWindow/Z bottom
		//GetMarquee/Z bottom // allow marquee from another window...
		if(V_flag)
			startSec = v_left
			endSec = v_right
		else
//			if(cursorUpdate && strlen(CsrInfo(A,"SpHrViewPeaksWindow")) > 0)
//				NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
//				NVAR ActivityLimit = $SpHrView_OverTime_DF_Globals+"ActivityLimit"
//				variable numlWavelengthsAtLowestFreq = 10
//				if(useEnvelopeAndOrCarrierIPDs > 0)	// 10 seems sufficient for carrier IPDs
//					numlWavelengthsAtLowestFreq = 20 // 20 to account for envelope IPDs
//				endif
//				variable TimeFrame = (numlWavelengthsAtLowestFreq/lowFreq)*ActivityLimit 
//				endSec = hcsr(A,"SpHrViewPeaksWindow")
//				startSec = endSec - TimeFrame
//			else
//				DrawAction/W=SpHrViewPeaksWindow/L=UserBack extractOutline
//				wave/Z W_PolyX=W_PolyX, W_PolyY=W_PolyY
//				killwaves W_PolyY
//				if(waveexists(W_PolyX) && dimsize(W_PolyX,0)==5) // object exists and is a square/rectangle
//					startSec = wavemin(W_PolyX)
//					endSec = wavemax(W_PolyX)
//					killwaves W_PolyX
//				else
					GetAxis /W=SpHrViewPeaksWindow/Q bottom
					//GetAxis/Q bottom // allow axis from another window...
					startSec = v_min
					endSec = v_max
					usingAxis = 1
//				endif
//			endif
		endif
	endif
	// make sure startSec and endSec are valid, since Marquees from other windows are being allowed.
	startSec = max(startSec, minSec)
	endSec = min(endSec, maxSec)
	
	variable longSelectionTrigger = 10 // should adapt this to highest freqeuncy being modeled (which are slower)  NVAR highFreq= $SpHrView_df_filter+"highFreq"
	if(useEnvelopeAndOrCarrierIPDs > 0)
		longSelectionTrigger = 10
	endif
	
	if(endSec - startSec > longSelectionTrigger)
		String WarningStr; SPrintf WarningStr, "Use %g second selection?", endSec - startSec 
		DoAlert/T="Long selection warning" 1, WarningStr
		if(V_flag > 1)
			startSec = endSec - 1 	// should do something more useful here...
		endif
	endif
	
	// load waveforms
	SpHrView_LoadSoundFromFileWave(pathAndNameStr, SpHrView_df_files, "waveforms", startSec, endSec)
	wave waveforms=$SpHrView_df_files+"waveforms"
	NVAR fs= $SpHrView_df_globals+"fs"
	SetScale/P x startSec,1/fs,"s", waveforms
	
	killStrings/Z S_info
	SetDatafolder saveDFR
	
	//Printf "startSec= %g, endSec= %g\r", startSec, endSec
	
	return [startSec, endSec, usingAxis]
End


Function SpHrView_OverTime_Activities(wave waveforms)
	DFREF saveDFR = GetDataFolderDFR()
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	
	variable fs = round(1/dimdelta(waveforms,0))
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	if(!waveexists(CFs))
		SpHrView_CenterFrequencies()
		wave CFs = $SpHrView_df_filter+"CFs"
	endif
	
	// find frequency and FrequencyIndex if missing or not found in selectCFs
	NVAR Frequency = $SpHrView_OverTime_DF_Globals+"Frequency"
	NVAR FrequencyIndex = $SpHrView_OverTime_DF_Globals+"FrequencyIndex"
	FindValue /T=0.1 /V=(Frequency)/Z CFs
	if(V_value < 0)
		FrequencyIndex = SetVarProcIndex(CFs, Frequency, 1)
		Frequency = CFs[FrequencyIndex]
	endif
	
	// check to see if FilterBanks must be updated
	wave/Z FilterBanks = $SpHrView_df_filter+"FilterBanks"	
	NVAR filterbankUpdateFlag = $SpHrView_df_filter+"filterbankUpdateFlag"
	// FilterBanks written to SpHrView_df_filter
	if(SpHr_DimensionsScaleCheck(FilterBanks, waveforms) || filterbankUpdateFlag)
		SpHr_FilterBankBiquadCoefs/W=$SpHrView_OverTime_DF+"FilterWidths" fs, CFs, coefBank	// FilterWidths used for envelope activities
		SpHr_FilterBankBiquad /RMS/Dest=$SpHrView_df_filter+"FilterBanks" CFs, coefBank, waveforms // FilterBanks written to SpHrView_df_filter
		wave FilterBanks = $SpHrView_df_filter+"FilterBanks"
		killwaves/Z coefBank
		if(!waveexists(FilterBanks))
			DoAlert 0, "FilterBanks wave is missing"
		endif	
	endif
	
	NVAR useIPDs = $globals_dfStr+"useIPDs"
	NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
	NVAR useILDs = $globals_dfStr+"useILDs"
	if(!useIPDs  && !ScaleIPDToITD && !useILDs)
		DoAlert/T="Warning" 0, "Must select IPD, ITD, ILD, IPD & ILD, or ITD & ILD\r"
		return 0
	endif
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	if(!useCarrierCues && !useEnvelopeCues)
		DoAlert/T="Warning" 0, "Must select Carrier waveforms, Envelope waveforms, or both options\r"
		return 0
	endif
	
	// envelope weight variables
	NVAR useAmpEnvelopeWts = $globals_dfStr+"useAmpEnvelopeWts"
	NVAR EnvelopeWtActLimit = $globals_dfStr+"EnvelopeWtActLimit"
	NVAR EnvdB = $globals_dfStr+"EnvelopeWeightsdB"
	NVAR usedtEnvelopeWts = $globals_dfStr+"usedtEnvelopeWts"
	NVAR dtEnvelopeWtActLimit = $globals_dfStr+"dtEnvelopeWtActLimit"
	NVAR dtInterp = $globals_dfStr+"dtEnvelopeWeightsInterp"
	NVAR dtEnvdB = $globals_dfStr+"dtEnvelopeWeightsdB"
	variable EnvLimit = EnvelopeWtActLimit
	variable dtEnvLimit = dtEnvelopeWtActLimit
	if(!useAmpEnvelopeWts)
		EnvLimit = 0
	endif
	if(!usedtEnvelopeWts)
		dtEnvLimit = 0
	endif
	
	// Get IPD and/or ILD neurons, shifting ILD neuron 'labels' as needed to match IPD 'labels'
	if(useIPDs || ScaleIPDToITD)
		SpHrView_IPDNeurons(1)
		wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
		wave IPDLabels = $SpHrView_df_IPDNeuron+"IPDLabels"
		//wave MaxLabels = $SpHrView_df_IPDNeuron+"MaxLabels"
		NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
		NVAR IPDLabelShift = $SpHrView_df_IPDNeuron+"IPDLabelShift" // calculated shift in IPD labels (must equal ILDLabelShift)
	endif
	
	if(useILDs)
//		wave/Z ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
//		if(!waveexists(ILDNeurons))
//			SpHrView_ILDNeurons()
//		endif
		
		NVAR ILDLabelShift = $SpHrView_df_ILDNeuron+"ILDLabelShift" // calculated shift in ILD labels (must equal IPDLabelShift)
		if((useIPDs || ScaleIPDToITD) && IPDLabelShift != ILDLabelShift)
			if(IPDLabelShift != ILDLabelShift)
				NVAR minIpsi = $SpHrView_df_ILDNeuron+"minIpsiHalfmaxILDLabel"
				NVAR maxContra = $SpHrView_df_ILDNeuron+"maxContraHalfmaxILDLabel"
				NVAR ILDLabelShift = $SpHrView_df_ILDNeuron+"ILDLabelShift"
				ILDLabelShift = IPDLabelShift
				SpHrView_ILDNeurons()
				
				//Variable actualMinIpsi = minIpsi - (minIpsi*ILDLabelShift)
				//Variable actualMaxContra = maxContra - (maxContra*ILDLabelShift)
				//Printf "ILD 'labels' shifted (from "+num2str(minIpsi)+" and "+num2str(maxContra)+" dB to "+num2str(actualMinIpsi)+" and "+num2str(actualMaxContra)+" dB) to match IPD 'label' shift ("+num2str(IPDLabelShift)+")\r"
				//DoAlert/T="Warning" 0, "ILD 'labels' shifted (from "+num2str(minIpsi)+" and "+num2str(maxContra)+" dB to "+num2str(actualMinIpsi)+" and "+num2str(actualMaxContra)+" dB) to match IPD 'label' shift ("+num2str(IPDLabelShift)+")\r"
			else
				SpHrView_ILDNeurons()
			endif
		else
			SpHrView_ILDNeurons()
		endif
		wave ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
		wave ILDLabels = $SpHrView_df_ILDNeuron+"ILDLabels"
	endif
	
	// Make sure IPD (cycles) and ILD (dB) neurons have the same dimensions
	if((useIPDs || ScaleIPDToITD) && useILDs)
		wave ILDNeurons = $SpHrView_df_ILDNeuron+"ILDNeurons"
		wave IPDNeurons = $SpHrView_df_IPDNeuron+"IPDNeurons"
		if(dimsize(IPDNeurons,0) != dimsize(ILDNeurons,0))
			DoAlert/T="Warning" 0, "Waves of IPD (cycles) and ILD (dB) neurons passed using the 'IPD=' and 'ILD=' keywords must have the same number of rows."
			return 0
		endif
		if(dimsize(IPDNeurons,0) != dimsize(ILDNeurons,0))
			DoAlert/T="Warning" 0, "Waves of IPD (cycles) and ILD (dB) neurons passed using the 'IPD=' and 'ILD=' keywords must have the same number of columns."
			return 0
		endif
	endif
	
	NVAR AlphaMask_ABL = $globals_dfStr+"AlphaMask_ABL" // ActivityAlpha option
	variable bitMask // bitMask for getting various cues
	
	// make two passes in case getting both carrier and envelope activities
	int isEnv=0, CueSet
	int numCueSets = useCarrierCues + useEnvelopeCues
	for(CueSet=0;CueSet<numCueSets;CueSet++)
		isEnv=0
		if(numCueSets == 2 && CueSet == 1)
			isEnv = 1
		elseif(numCueSets == 1 && useEnvelopeCues)
			isEnv = 1
		endif
		
		
		bitMask = 0
		bitMask = SpHr_BitSetRange(bitMask,0,1) 	// Xs and Ns
		if(useIPDs || ScaleIPDToITD)
			bitMask = SpHr_BitSet(bitMask,3)				// IPD
		endif
		if(useILDs)
			bitMask = SpHr_BitSet(bitMask,4)				// ILD
		endif
		//if(AlphaMask_ABL)
			bitMask = SpHr_BitSet(bitMask,5)				// ABL
		//endif
		
		DFREF DFR= $SpHrView_OverTime_DF
		SetDataFolder DFR // set here to avoid passing datafolder paths
		
		// Using Envelope Cues
		if(isEnv)
		
			dtEnvLimit = 0 //  should always be 0 ?
			NVAR minEnvelopeFreq = $globals_dfStr+"minEnvelopeFreq"
			
			SpHr_CrossingEnvelopeCues/F=(minEnvelopeFreq)/Cues=(bitMask)/N="Env"/DF=DFR/dtdB=(dtEnvdB)/dB=(EnvdB)/AWts={EnvLimit, dtEnvLimit} CFs, FilterBanks
			wave EnvNs = $SpHrView_OverTime_DF+"EnvNs"
			wave EnvXs = $SpHrView_OverTime_DF+"EnvXs"
			wave/Z EnvIPDs = $SpHrView_OverTime_DF+"EnvIPDs"
			wave/Z EnvILDs = $SpHrView_OverTime_DF+"EnvILDs"
			wave/Z EnvAWts = $SpHrView_OverTime_DF+"EnvAWts"
			if(EnvLimit == 0 && dtEnvLimit == 0 && waveexists(EnvAWts))
				killwaves/Z EnvAWts // kill if already exists!
			endif
			wave/Z EnvABLs = $SpHrView_OverTime_DF+"EnvABLs"

		else
			// Get carrier IPDs   /N="" no prefix
			NVAR maxCarrierFreq = $globals_dfStr+"maxCarrierFreq"
			
			SpHr_CrossingCarrierCues/F=(maxCarrierFreq)/N=""/Cues=(bitMask)/DF=DFR/idt=(dtInterp)/dB=(EnvdB)/dtdB=(dtEnvdB)/AWts={EnvLimit, dtEnvLimit} CFs, FilterBanks
			wave Ns = $SpHrView_OverTime_DF+"Ns"
			wave Xs = $SpHrView_OverTime_DF+"Xs"
			wave/Z IPDs = $SpHrView_OverTime_DF+"IPDs"
			wave/Z ILDs = $SpHrView_OverTime_DF+"ILDs"
			wave/Z AWts = $SpHrView_OverTime_DF+"AWts"
			if(EnvLimit == 0 && dtEnvLimit == 0 && waveexists(AWts))
				killwaves/Z AWts // kill if already exists! ??
			endif
			wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
		endif
			
		String SpHrOperationStr = "SpHr_ActivityOverTime"
		
		// Flag parameters
		
		//SpHrOperationStr += "/Q"
		
		NVAR ActivityLimit = $globals_dfStr+"ActivityLimit"
		SpHrOperationStr += "/Lim={"+num2str(ActivityLimit)+",LimitTimes}" //, ScaledLimits}" // Activity limit (default = 5)

		NVAR IHC = $globals_dfStr+"InterhemiphericCoordination"
		if(IHC == 0)
			SpHrOperationStr += "/IHC="+num2str(IHC)		// inter-hemispheric coordination index
		endif
		
		// Using Envelope Cues
		if(isEnv)
			if(minEnvelopeFreq > CFs[0])
				SpHrOperationStr += "/F={"+num2str(minEnvelopeFreq)+",NaN}"
			endif
		else
			if(maxCarrierFreq < CFs[dimsize(CFs,0)-1])
				SpHrOperationStr += "/F={0,"+num2str(maxCarrierFreq)+"}"
			endif
		endif
		
		//SpHrOperationStr += "/T={"+num2str(startTime)+","+num2str(endTime)+"}"
		
		// Output flags

		NVAR getEdges = $globals_dfStr+"getEdges"
		if(getEdges)
			SpHrOperationStr += "/HM"   // +"={ActivityHalfMaxima}"  +"={EnvelopeActivityHalfMaxima}"
		endif
		NVAR useMaximalLablesForEdges = $globals_dfStr+"useMaximalLablesForEdges"
		variable reflectAtHalfMaximum = 1
		if(useMaximalLablesForEdges || !reflectAtHalfMaximum)
			SpHrOperationStr += "/HMOP={"+num2str(useMaximalLablesForEdges)+","+num2str(reflectAtHalfMaximum)+"}"
		endif
		
		NVAR getMaxima = $globals_dfStr+"getMaxima"
		if(getMaxima)
			SpHrOperationStr += "/M"   // +"={ActivityMaxima}"  +"={EnvelopeActivityMaxima}"
		endif
		NVAR useEdgeLablesForMaxima = $globals_dfStr+"useEdgeLablesForMaxima"
		if(useEdgeLablesForMaxima)
			SpHrOperationStr += "/MOP="+num2str(useEdgeLablesForMaxima)
		endif
		
		// Always get Peaks/Points so they can be appended
		SpHrOperationStr += "/P" // +"={HalfmaximalActivityPoints, MaximalActivityPoints}  +"={EnvelopeHalfmaximalActivityPoints, EnvelopeMaximalActivityPoints}
		
		NVAR setPointsAtLimitsToNaN = $globals_dfStr+"setPointsAtLimitsToNaN"
		if(!setPointsAtLimitsToNaN)
			SpHrOperationStr += "/POP="+num2str(setPointsAtLimitsToNaN)
		endif
		
		// ITD
		NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
		if(ScaleIPDToITD)
			SpHrOperationStr += "/ITD=("+num2str(ScaleIPDToITD)+")"
		endif
		
//		NVAR getCarrierAccruals = $globals_dfStr+"getCarrierAccruals"
//		NVAR getEnvelopeAccruals = $globals_dfStr+"getEnvelopeAccruals"
//		if( (!isEnv && getCarrierAccruals) || (isEnv && getEnvelopeAccruals) )
//			SpHrOperationStr += "/ACC"  //  ={Accruals}  ={EnvelopeAccruals}
//		endif
		
		SpHrOperationStr += "/X"  	// defaults:  \"XEdges\""  \"EnvelopeXEdges\"
		
		// IPD and ILD neuron 'labels' are currently all linearly spaced
		//SpHrOperationStr += "/Y" 	// defaults:  \"YEdges\""	\"EnvelopeYEdges\"
		
		// Keyword parameters
		
		SpHrOperationStr += " "
		
		SpHrOperationStr += "CFs=root:SpHrView:Filter:CFs"+", " // comma
		
		// Using Envelope Cues
		if(isEnv)
		
			// Envelope weights, optional flag
			if((EnvLimit != 0 || dtEnvLimit != 0)  && waveexists(AWts))
				SpHrOperationStr += "Wts=EnvAWts"+", "
			endif
		
			SpHrOperationStr += "XsNs={EnvXs,EnvNs}"+" "
		
			if((useIPDs || ScaleIPDToITD) && waveexists(EnvIPDs))
				SpHrOperationStr += "IPD={EnvIPDs,root:SpHrView:IPDNeuron:IPDNeurons,root:SpHrView:IPDNeuron:IPDLabels}"+" "	// assuming neurons and labels are in root:SpHrView:IPDNeuron: datafolder
			endif
			if(useILDs && waveexists(EnvILDs))
				NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
				SpHrOperationStr += "ILD={EnvILDs,root:SpHrView:ILDNeuron:ILDNeurons,root:SpHrView:ILDNeuron:ILDLabels,"+num2str(ScaleILDtoITD)+"}"+" " // assuming neurons and labels are in root:SpHrView:ILDNeuron: datafolder
			endif
			
			SpHrOperationStr += "ENV={FilterWidths,"+num2str(IPDneuronWidth)+"}"+" "  // FilterWidths should be in DFR
		
		else
		
			// Envelope weights, optional flag
			if((EnvLimit != 0 || dtEnvLimit != 0)  && waveexists(AWts))
				SpHrOperationStr += "Wts=AWts"+", "
			endif
		
			SpHrOperationStr += "XsNs={Xs,Ns}"+" "
		
			if((useIPDs || ScaleIPDToITD) && waveexists(IPDs))
				SpHrOperationStr += "IPD={IPDs,root:SpHrView:IPDNeuron:IPDNeurons,root:SpHrView:IPDNeuron:IPDLabels}"+" "	// assuming neurons and labels are in root:SpHrView:IPDNeuron: datafolder
			endif
			if(useILDs && waveexists(ILDs))
				NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
				SpHrOperationStr += "ILD={ILDs,root:SpHrView:ILDNeuron:ILDNeurons,root:SpHrView:ILDNeuron:ILDLabels,"+num2str(ScaleILDtoITD)+"}"+" " // assuming neurons and labels are in root:SpHrView:ILDNeuron: datafolder
			endif
			
		endif
		
		if(0)	// Print operation string 
			Print/LEN=1000 SpHrOperationStr 
		endif
		
		if(1) // Execute operation string 
		
			Execute/Q SpHrOperationStr
			
			if(isEnv)
				NVAR ScaledEnvelopeActivityLimit = $globals_dfStr+"ScaledEnvelopeActivityLimit"
				NVAR V_FreqAvgLimit=V_FreqAvgLimit
				ScaledEnvelopeActivityLimit = V_FreqAvgLimit		
			else
				NVAR ScaledCarrierActivityLimit = $globals_dfStr+"ScaledCarrierActivityLimit"
				NVAR V_FreqAvgLimit=V_FreqAvgLimit
				ScaledCarrierActivityLimit = V_FreqAvgLimit
			endif
		endif
	
	endfor // for(CueSet=0;CueSet<numCueSets;CueSet++)  two passes in case getting both carrier and envelope activities


	// PeaksMindB, PeaksAvgdB, PeaksQ2dB are set by the SpHr_WavePeaks operation and reflect min and max amplitude of the entire loaded sound
	NVAR PeaksMindB = $SpHrView_df_globals+"PeaksMindB"
	//NVAR PeaksMaxdB = $SpHrView_df_globals+"PeaksMaxdB"
	//NVAR PeaksAvgdB = $SpHrView_df_globals+"PeaksAvgdB"
	//NVAR PeaksQ1dB = $SpHrView_df_globals+"PeaksQ1dB"
	//NVAR PeaksQ2dB = $SpHrView_df_globals+"PeaksQ2dB"
	NVAR PeaksQ3dB = $SpHrView_df_globals+"PeaksQ3dB"
	NVAR ABLmin = $SpHrView_OverTime_DF_Globals+"ABL_Min"
	NVAR ABLmax = $SpHrView_OverTime_DF_Globals+"ABL_Max"
 	ABLmin = PeaksMindB - 12
 	ABLmax = PeaksQ3dB
	
	SpHrView_OverTime_UpdateABLMasks()

	if(1)
		Killwaves/Z IPDs,ILDs, AWts
		Killwaves/Z EnvIPDs,EnvILDs, EnvAWts
	endif
	
	SetDataFolder saveDFR
End




// =================================================================================================
// SpHrView_OverTime_WindowHook(s), Window hook for Over time representation windows
// =================================================================================================
Function SpHrView_OverTime_WindowHook(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult = 0	
	switch(s.eventCode)
		//////////////
		// deactivate
		case 1:
			strswitch(s.winName)
				case "OverTimeOptionsWindow":
					ControlInfo/W=OverTimeOptionsWindow ck_keepWindowOpen
					if(!V_Value)
						Execute/Z/Q/P "killwindow/Z OverTimeOptionsWindow"
						hookResult=1
					endif
					break
					
				case "NeuronsIPDWindow":
					ControlInfo/W=NeuronsIPDWindow ck_keepWindowOpen
					if(!V_Value)
						Execute/Z/Q/P "killwindow/Z NeuronsIPDWindow"
						hookResult=1
					endif
					break
			endswitch
			break
			
		//////////////
		// keyboard event
		case 11:
			variable key= getkeystate(0) 
			strswitch(s.winName)
				case "OverTimeOptionsWindow":
					switch(s.keycode)
						case 13:		// return
							//killwindow/Z OverTimeOptionsWindow
							SpHrView_OverTime()//1)
							hookResult=0
							break
					endswitch
					break
				endswitch
			break
			
		//////////////
		// kill event
		case 2:
			//Printf "-%s-", s.winName
			strswitch(s.winName)					
				case "Over_Time_Activities":
				case "Peaks_Over_Time_Activities":	
					KillWindow/Z $s.winName
					variable winCnt = SpHrView_CountGroupWindows("OverTimeWin")
					if(winCnt<=0)
						Execute/Z/Q/P "KillAllWavesInDatafolder(\""+SpHrView_OverTime_DF[0,strlen(SpHrView_OverTime_DF)-2]+"\")" // remove trailing ":"
						Execute/Z/Q/P "KillAllVariablesInDatafolder(\""+SpHrView_OverTime_DF[0,strlen(SpHrView_OverTime_DF)-2]+"\")" // remove trailing ":"
						Execute/Z/Q/P "SpHrView_OverTime_KillDataFolders()"
					endif
					hookResult = 1
					break
			endswitch
			break
			
		//case 7:		// cursormoved
			//strswitch(s.winName)
				//case "Edge_representations_over_time":
				//case "Standard_deviations_over_time":
				//case "Differences_of_left_and_right_derivatives_over_time":
				//case "Maximal_representations_over_time":
				//case "Activities_in_left_hemisphere_equal_right_over_time":
				//case "Envelope_Edge_representations_over_time":
				//case "Envelope_Standard_deviations_over_time":
				//case "Envelope_Differences_of_left_and_right_derivatives_over_time":
				//case "Envelope_Maximal_representations_over_time":
				//case "Envelope_Activities_in_left_hemisphere_equal_right_over_time":
				//	wave/Z CFs = $SpHrView_df_filter+"CFs"
				//	if(waveexists(CFs) && s.yPointNumber > 0 && s.yPointNumber < numpnts(CFs))
				//		//SpHrView_RepOverTime_FreqLine(CFs[s.yPointNumber], s.winName, 0)
				//	endif
				//	break
			//endswitch
	endswitch
	return hookResult
End

Function SpHrView_OverTime_KillDataFolders()
	KillDataFolder/Z $SpHrView_OverTime_DF+"ActivityHalfMaxima"
	KillDataFolder/Z $SpHrView_OverTime_DF+"ActivityMaxima"
	KillDataFolder/Z $SpHrView_OverTime_DF+"EnvelopeActivityHalfMaxima"
	KillDataFolder/Z $SpHrView_OverTime_DF+"EnvelopeActivityMaxima"
	KillDataFolder/Z $SpHrView_OverTime_DF+"XEdges"
	KillDataFolder/Z $SpHrView_OverTime_DF+"YEdges"
	KillDataFolder/Z $SpHrView_OverTime_DF+"EnvelopeXEdges"
	KillDataFolder/Z $SpHrView_OverTime_DF+"EnvelopeYEdges"
End

Function SpHrView_OverTime_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			int Update_Over_Time_Activities = 0
			int Update_Peaks_Over_Time_Activities = 0
			strswitch(cba.ctrlName)
				case "ck_ScaleIPDToITD":
					CheckBox ck_ScaleIPDToITD win=OverTimeOptionsWindow, fstyle=!checked
					NVAR useIPDs = $SpHrView_OverTime_DF_Globals+"useIPDs"
					if(checked)
						useIPDs = 0
					endif
					break
				case "ck_useIPDs":
					NVAR ScaleIPDToITD = $SpHrView_OverTime_DF_Globals+"ScaleIPDToITD"
					if(checked)
						ScaleIPDToITD = 0
						CheckBox ck_ScaleIPDToITD win=OverTimeOptionsWindow, fstyle=!ScaleIPDToITD
					endif
					break
					
					
				case "ck_ScaleILDtoITD":
					CheckBox ck_ScaleILDtoITD win=OverTimeOptionsWindow, fstyle=!checked
					if(!checked)
						DoAlert/T="Warning" 1, "ILD 'labels' should normally be scaled with ITD 'labels'!\rScale with IPD anyway?"
						NVAR  ScaleILDtoITD = $SpHrView_OverTime_DF_Globals+"ScaleILDtoITD"
						if(V_Flag==1)
							ScaleILDtoITD = 0
						else
							ScaleILDtoITD = 1
						endif
					endif
					break
				case "ck_useEdgeLablesForMaxima":
					CheckBox ck_useEdgeLablesForMaxima win=OverTimeOptionsWindow, fstyle=checked
					break
				case "ck_useMaximalLablesForEdges":
					CheckBox ck_useMaximalLablesForEdges win=OverTimeOptionsWindow, fstyle=checked
					break
			
			
				case "ck_DisplayEdges":
					NVAR DisplayActivitiesMode = $SpHrView_OverTime_DF_Globals+"DisplayActivitiesMode"
					if(checked)
						DisplayActivitiesMode = 1
					endif 					// win=$cba.win includes "#PCBar"
					CheckBox ck_DisplayEdges win=$cba.win, value= DisplayActivitiesMode == 1
					CheckBox ck_DisplayMaxima win=$cba.win, value= DisplayActivitiesMode == 2
					Update_Over_Time_Activities=1
					Update_Peaks_Over_Time_Activities=1
					break
				case "ck_DisplayMaxima":
					NVAR DisplayActivitiesMode = $SpHrView_OverTime_DF_Globals+"DisplayActivitiesMode"
					if(checked)
						DisplayActivitiesMode = 2
					endif
					CheckBox ck_DisplayEdges win=$cba.win, value= DisplayActivitiesMode == 1
					CheckBox ck_DisplayMaxima win=$cba.win, value= DisplayActivitiesMode == 2
					Update_Over_Time_Activities=1
					Update_Peaks_Over_Time_Activities=1
					break
			
				case "ck_DisplayCarrierActivities":
					NVAR DisplayWaveformMode = $SpHrView_OverTime_DF_Globals+"DisplayWaveformMode"
					if(checked)
						DisplayWaveformMode = 1
					endif
					CheckBox ck_DisplayCarrierActivities win=$cba.win, value= DisplayWaveformMode == 1
					CheckBox ck_DisplayEnvelopeActivities win=$cba.win, value= DisplayWaveformMode == 2
					CheckBox ck_DisplayCombinedActivities win=$cba.win, value= DisplayWaveformMode == 3
					Update_Over_Time_Activities=1
					Update_Peaks_Over_Time_Activities=1
					break
				case "ck_DisplayEnvelopeActivities":
					NVAR DisplayWaveformMode = $SpHrView_OverTime_DF_Globals+"DisplayWaveformMode"
					if(checked)
						DisplayWaveformMode = 2
					endif
					CheckBox ck_DisplayCarrierActivities win=$cba.win, value= DisplayWaveformMode == 1
					CheckBox ck_DisplayEnvelopeActivities win=$cba.win, value= DisplayWaveformMode == 2
					CheckBox ck_DisplayCombinedActivities win=$cba.win, value= DisplayWaveformMode == 3
					Update_Over_Time_Activities=1
					Update_Peaks_Over_Time_Activities=1
					break
					
				case "ck_DisplayCombinedActivities":
					NVAR DisplayWaveformMode = $SpHrView_OverTime_DF_Globals+"DisplayWaveformMode"
					if(checked)
						DisplayWaveformMode = 3
					endif
					CheckBox ck_DisplayCarrierActivities win=$cba.win, value= DisplayWaveformMode == 1
					CheckBox ck_DisplayEnvelopeActivities win=$cba.win, value= DisplayWaveformMode == 2
					CheckBox ck_DisplayCombinedActivities win=$cba.win, value= DisplayWaveformMode == 3
					Update_Over_Time_Activities=1
					Update_Peaks_Over_Time_Activities=1
					break		
			
				
				case "ck_holdYAxisRange":
					CheckBox/Z ck_holdYAxisRange win=$cba.win, title=""
					ModifyGraph/Z/W=$cba.win fStyle(left_L)=0,fStyle(left_R)=0
					NVAR heldYAxisRange = $SpHrView_OverTime_DF_Globals+"heldYAxisRange"
					NVAR holdYAxisRange = $SpHrView_OverTime_DF_Globals+"holdYAxisRange" // ck_holdYAxisRange variable= holdYAxisRange
					if(holdYAxisRange) // (checked)
						GetAxis/W=$cba.win/Q left
						if(!V_flag)
							heldYAxisRange = V_max
						else
							GetAxis/W=$cba.win/Q left_L
							if(!V_flag)
								heldYAxisRange = V_max
								SetAxis left_L -heldYAxisRange,heldYAxisRange
							else
								heldYAxisRange = NaN
							endif
							GetAxis/W=$cba.win/Q left_R
							if(!V_flag)
								heldYAxisRange = V_max
								SetAxis left_R -heldYAxisRange,heldYAxisRange
							endif
						endif
					else
						GetAxis/W=$cba.win/Q left_L
						if(!V_flag)
							SetAxis/W=$cba.win/A/E=2 left_L
						endif
						GetAxis/W=$cba.win/Q left_R
						if(!V_flag)
							SetAxis/W=$cba.win/A/E=2 left_R
						endif
						GetAxis/W=$cba.win/Q left
						if(!V_flag)
							SetAxis/W=$cba.win/A/E=2 left
						endif
					endif
					break
					
					
				case "ck_AppendPeaks": 
					NVAR appendPeaksToImage = $SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
					if(appendPeaksToImage)
						CheckBox/Z ck_setPointsAtLimitsToNaN win=$cba.win,disable=0
						CheckBox/Z ck_AppendPeaksOppositeHemi win=$cba.win,disable=0
						CheckBox/Z ck_PeaksAreABLSized win=$cba.win,disable=0
					else
						CheckBox/Z ck_setPointsAtLimitsToNaN win=$cba.win,disable=2
						CheckBox/Z ck_AppendPeaksOppositeHemi win=$cba.win,disable=2
						CheckBox/Z ck_PeaksAreABLSized win=$cba.win,disable=2
					endif
					Update_Over_Time_Activities = 1
					break
					
				case "ck_AppendPeaksOppositeHemi": 
				case "ck_PeaksAreABLSized":
					Update_Over_Time_Activities = 1
					break
					
				case "ck_setPointsAtLimitsToNaN": 
					SpHrView_OverTime()
					break
					
				case "ck_DisplayActivityPeaks":
					NVAR DisplayActivityPeaks = $SpHrView_OverTime_DF_Globals+"DisplayActivityPeaks"
					if(DisplayActivityPeaks)
						CheckBox/Z ck_setPointsAtLimitsToNaN win=$cba.win,disable=0
					else
						CheckBox/Z ck_setPointsAtLimitsToNaN win=$cba.win,disable=2
					endif
					break
					
					
				case "ck_AlphaMask":
					Update_Over_Time_Activities = 1
					break
					
				case "ck_AppendWaves":
					Update_Over_Time_Activities = 1
					break
					
				case "ck_ReverseColorTable":
					Update_Over_Time_Activities = 1
					break
					
				case "ck_ReversePeaksColorTable":
					Update_Peaks_Over_Time_Activities = 1
					break
					
				case "ck_PeaksSolidMarker":
					Update_Peaks_Over_Time_Activities = 1
					break
					
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	
	DoWindow Over_Time_Activities
	if(Update_Over_Time_Activities && V_flag)
		SpHrView_OverTime_FreqImageWindow()
	endif
	
	
	DoWindow Peaks_Over_Time_Activities
	if(Update_Peaks_Over_Time_Activities && V_flag)
		SpHrView_OverTime_PeaksWindow()
	endif
	

	return 0
End

Function SpHrView_OverTime_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			Variable leftCoord, topCoord
			string winStr, tempStr, str
			strswitch(ba.ctrlName)
			
//				case "b_updateCursor":
//					// place cursor at same position as cursor in SpHrViewPeaksWindow window
//					Variable xval
//					winStr = ba.win
//					if(strsearch(winStr, "#PCBar", 0))
//						winStr = RemoveEnding(winStr, "#PCBar")
//					endif
//					variable updateSpHrViewPeaksWindow = 0 // update winStr (default)
//					variable keys = GetKeyState(0)
//					if(keys != 0 && keys != 8)
//						updateSpHrViewPeaksWindow = 1			// update SpHrViewPeaksWindow if option or command keys are down
//					endif
//					str = CsrInfo(A, winStr) 			// place cursor on winStr if it isn't already placed
//					if(strlen(str)<=0) 
//						updateSpHrViewPeaksWindow = 0
//					endif
//					if(updateSpHrViewPeaksWindow)	// place Cursor in SpHrViewPeaksWindow at same position as in winStr
//						xval= hcsr(A, winStr)
//						Cursor/S=2/L=0/H=2/C=(0,65535/2,0,32767)/W=SpHrViewPeaksWindow A, $stringfromlist(0,TraceNameList("SpHrViewPeaksWindow", ";", 1)), xval
//					else									// place Cursor in winStr at same position as in SpHrViewPeaksWindow
//						xval= hcsr(A, "SpHrViewPeaksWindow")			// placement on this image is inaccurate (many things to evaluate...)
//						String imagesStr = ImageNameList(winStr, ";")
//						if(strlen(imagesStr) > 1)
//							Cursor/W=$winStr/I/S=2/L=0/H=2/C=(0,65535/2,0,65535/2 )  A, $stringfromlist(0,ImageNameList(winStr, ";" )), xval, 0
//						else
//							// find first trace (should be highest frequency)
//							String firstTrace =  stringfromlist(0,TraceNameList(winStr, ";", 1))
//							// find indicies of wave proving x-axis values
//							String IndexStr =  StringByKey("YRANGE", TraceInfo(winStr,firstTrace,0))
//							// extract column index
//							variable index
//							sscanf IndexStr, "[*][%f]", index
//							wave Xwave = XWaveRefFromTrace(winStr,firstTrace)
//							Make/O/N=(dimsize(Xwave,0))/FREE tempXs
//							tempXs = Xwave[p][index]
//							// find x-axis value
//							xval = binarySearchInterp(tempXs,xval)
//							Cursor/S=2/L=0/H=2/C=(0,65535/2,0,32767)/W=$winStr A, $firstTrace, xval
//						endif
//					endif
//					break
					
				case "b_Display":
					SpHrView_OverTime()
					killwindow/Z OverTimeOptionsWindow
					break
					
				case "b_FilterBank":
					winStr = ba.win
					if(strsearch(winStr, "#PCBar", 0))
						winStr = RemoveEnding(winStr, "#PCBar")
					endif
					GetWindow $winStr, wsize// gsize
					leftCoord = V_left + ba.mouseLoc.h
					topCoord = V_Top + ba.mouseLoc.v
					SpHrView_Settings_FilterBank(leftCoord, topCoord)
					break
			
				case "b_SpHrView_OverTime":
					string selStr= ""
					variable key= getkeystate(0)  // Print key
										
					if(key==2 || key==10)	// option key
						PopupContextualMenu "Edges;Edge 'Peaks';-;Maxima;Maximal 'peaks';-;Options;"
						selStr = S_selection
					elseif(key==1 ||key==9)		// command key
						SpHrView_OverTime()
						break
					else
						selStr = "Options"
					endif
					if(strlen(selStr)>1) // not command key
						SpHrView_OverTime_Defaults()
						NVAR getEdges = $SpHrView_OverTime_DF_Globals+"getEdges"
						NVAR getMaxima = $SpHrView_OverTime_DF_Globals+"getMaxima"
						NVAR DisplayActivityPeaks= $SpHrView_OverTime_DF_Globals+"DisplayActivityPeaks"
						strswitch(selStr)
							case "Options":
								winStr = ba.win
								if(strsearch(winStr, "#PCBar", 0))
									winStr = RemoveEnding(winStr, "#PCBar")
								endif
								GetWindow $winStr, wsize// gsize
								leftCoord = V_left + ba.mouseLoc.h
								topCoord = V_Top + ba.mouseLoc.v
								SpHrView_OverTime_OptionsWindow(leftCoord, topCoord)
								break

							case "Edges":
								getEdges= 1; getMaxima= 0;
								DisplayActivityPeaks = 0
								SpHrView_OverTime()
								break
					
							case "Maxima":
								getEdges= 0; getMaxima= 1;
								DisplayActivityPeaks = 0
								SpHrView_OverTime()
								break
								
							case "getEdgePoints":
								getEdges= 0; getMaxima= 0;
								DisplayActivityPeaks = 1
								SpHrView_OverTime()
								break
							case "getMaximalPoints":
								getEdges= 0; getMaxima= 0;
								DisplayActivityPeaks = 1
								SpHrView_OverTime()
								break
								
						endswitch
					endif
					break
			
				case "b_InterhemiphericCoordination_zero_or_one":
					NVAR InterhemiphericCoordination = $SpHrView_OverTime_DF_Globals+"InterhemiphericCoordination"
					if(InterhemiphericCoordination == 1)
						InterhemiphericCoordination = 0
					elseif(InterhemiphericCoordination == 0)
						InterhemiphericCoordination = 1
					else
						InterhemiphericCoordination = round(InterhemiphericCoordination)
					endif
					break
					
				case "b_ColorTable":
					SVAR ColorTableStr = $SpHrView_OverTime_DF_Globals+"ColorTableStr"
					tempStr = ColorTablePopup(ColorTableStr)
					if(strlen(tempStr)>1)
						ColorTableStr = tempStr
						doupdate
						SpHrView_OverTime_FreqImageWindow()
					endif
					break
					
				case "b_PeaksColorTable":
					SVAR PeaksColorTableStr = $SpHrView_OverTime_DF_Globals+"PeaksColorTableStr"
					tempStr = ColorTablePopup(PeaksColorTableStr)
					if(strlen(tempStr)>1)
						PeaksColorTableStr = tempStr
						doupdate
						SpHrView_OverTime_PeaksWindow()
					endif
					break
					
				case "b_PeaksSizeMode":
					SVAR PeaksSizeModeStr = $SpHrView_OverTime_DF_Globals+"PeaksSizeModeStr"
					String PeaksSizeModeListStr = "ABL;Activity;-;1 point;1.5 points;2 points"
					Variable SelectedNum = WhichListItem(PeaksSizeModeStr, PeaksSizeModeListStr)
					PeaksSizeModeListStr = RemoveListItem(SelectedNum, PeaksSizeModeListStr)
					PeaksSizeModeListStr = AddListItem(PeaksSizeModeStr+"!", PeaksSizeModeListStr, ";", SelectedNum)
					PopupContextualMenu PeaksSizeModeListStr
					if(V_flag)
						doupdate
						PeaksSizeModeStr = S_selection
						SpHrView_OverTime_PeaksWindow()
					endif
					break
										
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End


Function SpHrView_OverTime_SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa

	switch( sa.eventCode )			
		case -3: // Control received keyboard focus
		case -2: // Control lost keyboard focus
		case -1: // Control being killed
			break
		default:
			if( sa.eventCode & 1 ) // value set
				Variable curval = sa.curval
				Variable index, Hz
				
				strswitch(sa.ctrlName)
					case "sl_Frequency":
						NVAR Frequency = $SpHrView_OverTime_DF_Globals+"Frequency"
						NVAR FrequencyIndex = $SpHrView_OverTime_DF_Globals+"FrequencyIndex"
						wave/Z CFs = $SpHrView_df_filter+"CFs"
						[index, Hz] = SpHrView_getCFindex(CFs, floor(10^(curval)))
						FrequencyIndex = index
						Frequency = Hz
						SpHrView_OverTime_FreqImageReplace(RemoveEnding(sa.win, "#PCBar"))
						break
							
	
					case "sl_minPointFrequency":
						NVAR minPointFrequency =  $SpHrView_OverTime_DF_Globals+"minPointFrequency"
						minPointFrequency = round(10^(curval))
						wave/Z CFs = $SpHrView_df_filter+"CFs"
						Hz = minPointFrequency
						[index, Hz] = SpHrView_getCFindex(CFs, round(10^(curval)))
						if(Hz != minPointFrequency)
							minPointFrequency = Hz
						endif			
						NVAR maxPointFrequency = $SpHrView_OverTime_DF_Globals+"maxPointFrequency"
						if(minPointFrequency >= maxPointFrequency) 
							maxPointFrequency = minPointFrequency
						endif
						SpHrView_OverTime_PeaksWindow()
						break
						
					case "sl_maxPointFrequency":
						NVAR maxPointFrequency = $SpHrView_OverTime_DF_Globals+"maxPointFrequency"
						maxPointFrequency = round(10^(curval))
						wave/Z CFs = $SpHrView_df_filter+"CFs"
						Hz = maxPointFrequency
						[index, Hz] = SpHrView_getCFindex(CFs, round(10^(curval)))
						if(Hz != maxPointFrequency)
							maxPointFrequency = Hz
						endif			
						NVAR minPointFrequency =  $SpHrView_OverTime_DF_Globals+"minPointFrequency"		
						if(maxPointFrequency <= minPointFrequency)
							minPointFrequency = maxPointFrequency
						endif
						SpHrView_OverTime_PeaksWindow()
						break
					
					
					case "sl_YAxisRange":
						if( sa.eventCode & 3 ) // & 1?
							String AxisStr, AxesListStr = AxisList(sa.win)
							int64 i
							for(i=0;i<ItemsInList(AxesListStr);++i)
								AxisStr = StringFromList(i,AxesListStr)
								if(strsearch(AxisStr, "left", 0, 2) >=0) // any axis with "left" in name
									GetAxis/W=$sa.win/Q $AxisStr
									if(!V_flag)
										SetAxis/W=$sa.win/Z $AxisStr -curval,curval
										NVAR heldYAxisRange = $SpHrView_OverTime_DF_Globals+"heldYAxisRange"
										heldYAxisRange = curval
									endif
								endif
							endfor
						endif // sa.eventCode & 3
						break
							
				endswitch
			endif
			break
	endswitch

	return 0
End



// =================================================================================================
// SpHrView_OverTime_OptionsWindow(), display options for CuesS
// =================================================================================================
Function SpHrView_OverTime_OptionsWindow(variable winleft, variable winTop)
	if(winleft < 0 || winTop < 0)
		GetMouse
		winleft=V_left
		winTop=V_top
	endif
	
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	
	SpHrView_OverTime_Defaults()
	
	killwindow/Z OverTimeOptionsWindow
	//	Variable  winleft=250, winRight, winTop=50, winBottom
	//	[winleft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
	
	//  /FLT=1
	NewPanel /FLT=1/K=1/W=(winleft, winTop, winleft+213, winTop+620) as "Over time Activiites"
	DoWindow/C OverTimeOptionsWindow
	variable topPos = 7
	CheckBox ck_keepWindowOpen win=OverTimeOptionsWindow, title="📌 ",fSize=10,pos={10,topPos},side=0
	CheckBox ck_keepWindowOpen win=OverTimeOptionsWindow, help={"Keep window open"}

	Button b_Display title="Display  ⏎",pos={60,topPos},size={105,20},proc=SpHrView_OverTime_ButtonProc,fSize=11
	Button b_Display help={"Display cues. Can also press 'return' key."} 
	
	// Display activity
	topPos += 27
	GroupBox group_NeuralActivities, title="Neural activities (representations)",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 45}
	topPos += 20
	CheckBox ck_Edges title="Edges",pos={25,topPos},fSize=10,variable=$globals_dfStr+"getEdges"
	CheckBox ck_Edges help={"Perception is congruous with ITD neurons evoking half-maximal activity (i.e., Activity Limit / 2)."}
	
	CheckBox ck_Maxima title="Maxima",pos={120,topPos},fSize=10,variable=$globals_dfStr+"getMaxima"
	CheckBox ck_Maxima help={"Perception is congruous with ITD neurons evoking maximal activity (i.e., the Activity Limit)."}
	
	// Frequency-specific activity 'peaks'
	topPos += 25
	GroupBox group_DisplayActivityPeaks, title="",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 30}
	topPos += 5
	CheckBox ck_DisplayActivityPeaks title="Display activity 'peaks'",pos={25,topPos},fSize=10,variable=$globals_dfStr+"DisplayActivityPeaks"
	CheckBox ck_DisplayActivityPeaks help={"Display frequency-specific activity peaks"}, proc=SpHrView_OverTime_CheckProc
	//topPos += 20
	//CheckBox ck_setPointsAtLimitsToNaN title="remove peaks at 'label' limits",pos={35,topPos},fSize=10,variable=$globals_dfStr+"setPointsAtLimitsToNaN"
	//CheckBox ck_setPointsAtLimitsToNaN  proc=SpHrView_OverTime_CheckProc
	//NVAR DisplayActivityPeaks = $globals_dfStr+"DisplayActivityPeaks"
	//if(DisplayActivityPeaks)
	//	CheckBox ck_setPointsAtLimitsToNaN  disable=0
	//else
	//	CheckBox ck_setPointsAtLimitsToNaN  disable=2
	//endif
	
	// Cue types
	topPos += 27
	GroupBox group_Cues, title="Cues",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 40}
	topPos += 18
	CheckBox ck_useIPDs title="IPD",pos={25,topPos},fSize=10,variable=$globals_dfStr+"useIPDs"
	CheckBox ck_useIPDs help={"Use interaural phase differences (IPD) in model"}, proc=SpHrView_OverTime_CheckProc
	
	CheckBox ck_ScaleIPDToITD title="ITD",pos={80,topPos},fSize=10,variable=$globals_dfStr+"ScaleIPDToITD"
	CheckBox ck_ScaleIPDToITD help={"Scale IPD to ITD"}, proc=SpHrView_OverTime_CheckProc
	NVAR ScaleIPDToITD = $globals_dfStr+"ScaleIPDToITD"
	if(!ScaleIPDToITD)
		CheckBox ck_ScaleIPDToITD fstyle=1
	endif
	CheckBox ck_useILDs title="ILD",pos={140,topPos},fSize=10,variable=$globals_dfStr+"useILDs"
	CheckBox ck_useILDs help={"Use interaural level differences (ILD) in model"}, proc=SpHrView_OverTime_CheckProc
	
	// Waveform type
	topPos += 25
	GroupBox group_typeOfIPD, title="Waveforms",fSize=10,fstyle=0,pos={5.00,topPos},size={205.00, 75}
	topPos += 22
	
	NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
	NVAR highFreq= $SpHrView_df_filter+"highFreq"
	
	CheckBox ck_useCarrierCues title="Carrier",pos={20+0,topPos},fSize=10,variable=$globals_dfStr+"useCarrierCues" 
	CheckBox ck_useCarrierCues help={"Use Carrier IPDs in model"}, proc=SpHrView_OverTime_CheckProc
	
	SetVariable sv_maxCarrierFreq,pos={95,topPos},size={107.00,14.00},bodyWidth=50,fSize=10,title="< freq (Hz)"
	SetVariable sv_maxCarrierFreq,limits={lowFreq,highFreq,100},value= $globals_dfStr+"maxCarrierFreq"
	SetVariable sv_maxCarrierFreq, help={"Maximum frequency for which Carrier IPDs are modeled"}
	
	topPos += 25
	CheckBox ck_useEnvelopeCues title="Envelope",pos={20+0,topPos},fSize=10,variable=$globals_dfStr+"useEnvelopeCues"
	CheckBox ck_useEnvelopeCues help={"Use Envelope IPDs in model"}, proc=SpHrView_OverTime_CheckProc
	SetVariable sv_minEnvelopeFreq,pos={95,topPos},size={107.00,14.00},bodyWidth=50,fSize=10,title="> freq (Hz)"
	SetVariable sv_minEnvelopeFreq,limits={lowFreq,highFreq,100},value= $globals_dfStr+"minEnvelopeFreq"
	SetVariable sv_minEnvelopeFreq, help={"Minimum frequency for which Envelope IPDs are modeled"}
	
	// Model parameters
	topPos += 30
	GroupBox group_ModelParams, title="Model parameters",pos={5.00,topPos},size={205.00, 45},fSize=10,fstyle=0
	topPos += 20
	SetVariable sv_ActivityLimit,pos={95,topPos},size={104.00,14.00},bodyWidth=45,fSize=10,title="Activity limit"
	SetVariable sv_ActivityLimit,limits={0.1,100,1},value= $globals_dfStr+"ActivityLimit"
	SetVariable sv_ActivityLimit, help={""}

	
	// Other display options	
	topPos += 27
	GroupBox group_OtherDisplayOptions, title="",pos={5.00,topPos},size={205.00, 95},fSize=10,fstyle=0
	topPos += 5
	CheckBox ck_InterhemiphericCoordination title="Coordinate hemispheric activity",pos={15,topPos},fSize=10,variable=$globals_dfStr+"InterhemiphericCoordination"
	CheckBox ck_InterhemiphericCoordination proc=SpHrView_OverTime_CheckProc
	CheckBox ck_InterhemiphericCoordination help={"Activities in both hemispheres (left and right) are diminished when activities in either hemisphere exceed the activity limit."}
	NVAR InterhemiphericCoordination = $globals_dfStr+"InterhemiphericCoordination"
	if(!InterhemiphericCoordination)
		CheckBox ck_InterhemiphericCoordination fstyle=1
	endif
	topPos += 20
	CheckBox ck_ScaleILDtoITD title="Scale ILD with ITD (vs IPD) ",pos={15,topPos},fSize=10,variable=$globals_dfStr+"ScaleILDtoITD"
	CheckBox ck_ScaleILDtoITD help={"Scale ILD so that ILD 'labels' scale with ITD 'labels' as opposed to IPD 'labels'"}, proc=SpHrView_OverTime_CheckProc
	NVAR ScaleILDtoITD = $globals_dfStr+"ScaleILDtoITD"
	if(!ScaleILDtoITD)
		CheckBox ck_ScaleILDtoITD fstyle=1
	endif
	topPos += 20
	CheckBox ck_useEdgeLablesForMaxima title="Use edge lables for Maxima",pos={15,topPos},fSize=10,variable=$globals_dfStr+"useEdgeLablesForMaxima"
	CheckBox ck_useEdgeLablesForMaxima  proc=SpHrView_OverTime_CheckProc
	NVAR useEdgeLablesForMaxima = $globals_dfStr+"useEdgeLablesForMaxima"
	if(useEdgeLablesForMaxima)
		CheckBox ck_useEdgeLablesForMaxima fstyle=1
	endif
	topPos += 20
	CheckBox ck_useMaximalLablesForEdges title="Use maximal lables for Edges",pos={15,topPos},fSize=10,variable=$globals_dfStr+"useMaximalLablesForEdges"
	CheckBox ck_useMaximalLablesForEdges  proc=SpHrView_OverTime_CheckProc
	NVAR useMaximalLablesForEdges = $globals_dfStr+"useMaximalLablesForEdges"
	if(useMaximalLablesForEdges)
		CheckBox ck_useMaximalLablesForEdges fstyle=1
	endif
	
	

//	// Activity Accrual
//	topPos += 30
//	GroupBox group_Accrual, title="Activity Accrual",pos={5.00,topPos},size={205.00, 40}
//	topPos += 16
//	CheckBox ck_getCarrierAccruals title="Carrier",pos={15,topPos},fSize=10,variable=$globals_dfStr+"getCarrierAccruals"
//	CheckBox ck_getCarrierAccruals help={"Carrier activity accrual over time prior to the end of the current selection."}
//	CheckBox ck_getEnvelopeAccruals title="Envelope",pos={90,topPos},fSize=10,variable=$globals_dfStr+"getEnvelopeAccruals"
//	CheckBox ck_getEnvelopeAccruals help={"Envelope activity accrual over time prior to the end of the current selection."}
	
	
	// Other parameters - via buttons 
	topPos += 35
	GroupBox group_OtherParams, title="Neuron & auditoy filter parameters",pos={5.00,topPos},size={205.00, 55},fSize=10,fstyle=0
	topPos += 23
	Button b_IPDNeuronParams pos={15,topPos},title="IPD",size={40,20},proc=SpHrView_IPDNeuron_ButtonProc,fSize=10
	Button b_ILDNeuronParams pos={65,topPos},title="ILD",size={40,20},proc=SpHrView_ILDNeuron_ButtonProc,fSize=10
	Button b_FilterBank pos={120,topPos},title="Filters",size={60,20},proc=SpHrView_OverTime_ButtonProc,fSize=10
	
	// envelope derivative weights
	topPos += 45
	GroupBox group_dtEnvWts, fSize=10,fstyle=0,title="Envelope Weights",pos={5.00,topPos-6},size={205.00, 87}
	topPos += 15
	CheckBox ck_usedtEnvelopeWts title="Derivative weights ",pos={25,topPos},fSize=10,side=0
	CheckBox ck_usedtEnvelopeWts variable=$globals_dfStr+"usedtEnvelopeWts"
	CheckBox ck_dtEnvelopeWeightsdB title="dB ",pos={165,topPos},fSize=10,side=1
	CheckBox ck_dtEnvelopeWeightsdB variable=$globals_dfStr+"dtEnvelopeWeightsdB"
	topPos += 22
	SetVariable sv_dtEnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=45,title="Derivative Activity Limit"
	SetVariable sv_dtEnvelopeWtActLimit,fSize=10
	SetVariable sv_dtEnvelopeWtActLimit,limits={1,100,1},value= $globals_dfStr+"dtEnvelopeWtActLimit"
	SetVariable sv_dtEnvelopeWtActLimit, help={"Envelope derivative activity activity Limit"}
	topPos += 20
	CheckBox ck_dtEnvelopeApplyToEnvelopes title="Apply to envelope cues ",pos={35,topPos},fSize=10,side=1,disable=2
	CheckBox ck_dtEnvelopeApplyToEnvelopes variable=$globals_dfStr+"dtEnvelopeApplyToEnvelopes", proc=SpHrView_Cues_CheckProc

	// envelope amplitude weights
	topPos += 32
	GroupBox group_EnvWts,pos={5.00,topPos-6},size={205.00, 52}
	CheckBox ck_useAmpEnvelopeWts title="Amplitude weights ",pos={25,topPos},fSize=10,side=0
	CheckBox ck_useAmpEnvelopeWts variable=$globals_dfStr+"useAmpEnvelopeWts"
	CheckBox ck_EnvelopeWeightsdB title="dB ",pos={165,topPos},fSize=10,side=1
	CheckBox ck_EnvelopeWeightsdB variable=$globals_dfStr+"EnvelopeWeightsdB"
	topPos += 22
	SetVariable sv_EnvelopeWtActLimit,pos={20,topPos},size={165.00,14.00},bodyWidth=45,title="Amplitude Activity Limit"
	SetVariable sv_EnvelopeWtActLimit,fSize=10
	SetVariable sv_EnvelopeWtActLimit,limits={1,100,1},value= $globals_dfStr+"EnvelopeWtActLimit"
	SetVariable sv_EnvelopeWtActLimit, help={"Envelope activity activity Limit"}


	DoUpdate/W=OverTimeOptionsWindow // for Igor 9
	SetWindow OverTimeOptionsWindow, hook(OverTimeOptionsWindowHook)=SpHrView_OverTime_WindowHook
	SetWindow OverTimeOptionsWindow note="PACKAGE:SpHrView;GROUP:OverTimeWin;"
End

Function SpHrView_OverTime_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	switch( sva.eventCode )
			
		case 1: // mouse up
		case 2: // Enter key
		//case 3: // Live update
			Variable dval = sva.dval, temp
			String sval = sva.sval
			String winStr = RemoveEnding(sva.win, "#PCBar")
			strswitch(sva.ctrlName)
				Variable index, Hz
				
				case "sv_AlphaMask_ABL_Min":
				case "sv_AlphaMask_ABL_Max":
					SpHrView_OverTime_UpdateABLMasks()	
					break	
					
				case "sv_PeakSize_ABL_Min":
				case "sv_PeakSize_ABL_Max":
				case "sv_PeaksColorTableAlpha":
					SpHrView_OverTime_PeaksWindow()		
					break
									
				case "sv_Frequency":
					NVAR Frequency = $SpHrView_OverTime_DF_Globals+"Frequency"
					NVAR FrequencyIndex = $SpHrView_OverTime_DF_Globals+"FrequencyIndex"
					wave/Z CFs = $SpHrView_df_filter+"CFs"
					Hz = Frequency
					Hz = CFs[SetVarProcIndex(CFs, dval, sva.eventCode==2)]
					[index, Hz] = SpHrView_getCFindex(CFs, Hz)
					if(Hz != Frequency)
						FrequencyIndex = index
						Frequency = Hz
						SpHrView_OverTime_FreqImageReplace(winStr)

					endif					
					break


				case "sv_minPointFrequency":
					NVAR minPointFrequency =  $SpHrView_OverTime_DF_Globals+"minPointFrequency"
					NVAR maxPointFrequency = $SpHrView_OverTime_DF_Globals+"maxPointFrequency"
					if(minPointFrequency > maxPointFrequency) // swap values in min < max
						temp = minPointFrequency
						minPointFrequency = maxPointFrequency
						maxPointFrequency = temp
					endif
					wave/Z CFs = $SpHrView_df_filter+"CFs"
					Hz = minPointFrequency
					Hz = CFs[SetVarProcIndex(CFs, dval, sva.eventCode==2)]
					if(Hz != Frequency)
						minPointFrequency = Hz
					endif
					SpHrView_OverTime_PeaksWindow()			
					break
					
				case "sv_maxPointFrequency":
					NVAR minPointFrequency =  $SpHrView_OverTime_DF_Globals+"minPointFrequency"
					NVAR maxPointFrequency = $SpHrView_OverTime_DF_Globals+"maxPointFrequency"
					if(minPointFrequency > maxPointFrequency) // swap values in min < max
						temp = minPointFrequency
						minPointFrequency = maxPointFrequency
						maxPointFrequency = temp
					endif
					wave/Z CFs = $SpHrView_df_filter+"CFs"
					Hz = maxPointFrequency
					Hz = CFs[SetVarProcIndex(CFs, dval, sva.eventCode==2)]
					if(Hz != Frequency)
						maxPointFrequency = Hz
					endif
					SpHrView_OverTime_PeaksWindow()		
					break
					
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	return 0
End


// PNG: width= 75, height= 15
Picture SpHrView_pict_OverTime
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!$[!!!!`#R18/!1V<L=9&=$$#iF<ErZ1m,6.]r,6<%c5B[#,!#]lI=EI
	J[Aor6*Eb,5:A8bpg+A$EYB4XtP@:XY'a^mR7!&R#66pXdsg?bAUOBkqYhgbCW\%ge3e_O-4e<4"$j
	UL/`@q4k6$SZSA5UM_n.V?]<<%=;08EPtlLD1RBTND6rVEt:iN/a#01B@p&Qt<L]D2e3`Z7K4c/ZH/
	N^@tk#P2H$3IcoPA/_S>VZpUO6\o,45pUte=G0]9"J'0k(M5#gSP*WJNjYsTWkp].r>1/R#/hLd/93
	P67V'R^-8P9E$[%o!"Bh9J7QF*G6/\e<Kq8`DHIUVK<g%j_?Kona*'9U>6F<.)0+ppYl*+%e5%Q/Js
	nCA+]IDE#urs%B(GS+M40qS\Q-gS;]$;'NW./psV2\?==S=%aWSn#4ta;=NU>UH7UNjn%<Xm]aa:p<
	aJDQ@*MT+3^\fq,1tOmV(Jm&S;KbB'3l=8";6M->&]fPjMD(YHTk^\Bg7n)uJPc40(;oVXn3XOfnSH
	Z/MQcT/NHiS<3M0?:=P8+^$A7$A(ST,\rHs1%Y+]qLAJr&36CjZnii?`;3olIa;Gs.'+740SM`,4>h
	ers<"\b0+s7H?n2c97`EE?AcC7h/jMf-!i4^@m6B\at7G@8MnW6ft9M(D=P/Oo!\6njSJQ@GD:C\V;
	(behFIDS0B_rD^S*23A%YM+Eh&ILn8^`HTB2nJ[R33*m63p[OMC8S_2Ni5?b-08%h_%IqtB1@&_2>k
	kQ_J`%kJ>6WtRYfAYKP#7gC.%N%aA]P'3Q?Hp!TtcW<=L3@Q#p@)r?Y9/Y<d!?Jef[<N)m!2AF6k5@
	p.V5:ajoqopuM-p'AItlhbgjY.6OP97K"3mNSK,=ML9E5>`#k8f>5k*VhOH@cO\cN6jJ;N)G5-nY]/
	-XP\*`/96KC@a)C;Vo:CN.1oo"Ooc$rQ@]Kg3Vl!_,1GJ;N0KEZmf0W/KsmA-L7qL!XWXa49,*!2ol
	>^gHhA!Mf'-NWJ=_dJ[@sK'cTe3<rR"(]2;N>6tFEK9PbtV9t@N]J&b?=]3<A4tD$9Ke3`*?2O^V$V
	[F8L5p<es$+EEPIqmoAV$(L$Fr2(,ltP&5&O]L_n83$r%T:7kpYt]Hk,uPLg`'#PC5"PmgB-?MnC`W
	k^_O'C:rIC*)akkNR-Q3D\=b;Pa?=PG8Q:,kIA63;P/;(f!k1`FCsV.H2`4n=oMdhof6*6($?p=36U
	o/<gU1`iK.i0!kCeY)J'SNc7L.@,gaYF<a;(rc7nUhNYdH,$@c)l$FJM)&A?j+!Od\3JETm]N^a(B/
	:\8\@+1J"!+I\DGiof`fNsm&;H$BnJ7tj5SN`$NBMo@Z#O2[>>HA1mQ2tEC?e=[1"lfQ-?<6jR!3/@
	<C8nG_U8Yr&/t_l$0]0qMA,@d&Hl_?2+n#pZBT!cCFm&A$<H/*pqn(,ieJ4`c%rr$oP@$:=[HrPI*[
	$5Z#H5m%=D""B?5<T&:*2_3!-;1C]0qWQoD]lLVt37Sij>Xj^l"^^W+GW:a5ni@('SfeRJ5Z&U('qK
	5NcU<(C$ML^_sdWIcEe4!hM'D1-D3ZDHUBQ,ra#j#Da_:r^#DEltcCrLO%RJ:jnR2[nUa4c8`R60XQ
	(/S_[2I_fbZXVNBh!nu`sJ<[!7C'[W_)!FT*V!6EF0c1Sg89lHK/s5/%XI;PfYBgn7+)9C?1#o.OFa
	J&D>3]>RP=m=/8*&tLed6bf^TErU=(dN&Qqn$t$r3\B6'c;2?/:03R?_Y[1gSpc/:?,Qm6t,>9kqhJ
	Il:OFfW\oYl(dtrs1tG,ENRUn5)1+3Is(g[h?UpBY_O/.rbPR!1@XkVCfH:#5E::I>P3l3s+/a9Xl2
	VO&4k'egdsp_Fl&Cn!V;AN-;)bLTl2i*?b9;!^!!-?'6I,X,@+PZP.:uhPaM3*(p<-_`W9\1@*WH!8
	s+_)&r@ldF\'PJco.*0b1j(r5q&_>QS+Yl*0)0H>Rs\He55sE?5d&rkk,)"q]+o@^!:!F[[B$865Wt
	j!DCL;[JEHoA%k+N`NZm!TPEr[VT2WP=TGNs>=F*G&=')_mQ"7tZ34>%6.P=^Y=&_W1OE5U/4p1pcQ
	d+9f%B:!6oBor$s7<KIEN:b^!V,8*5g(Y<nD:;<s5aq'B*@:Y*=1c,X0,WTm'4SN0de!:KV2WQohD,
	5$fj]uc*EKOT?ja9o4Yktdc4R2R-'1=Cs3YO-MUBnn8k5VELlNE9eUYM="'tYjsL)?kR#m^M2%CA@d
	*Te3W_1Dl='U[5g@WmkMJPNs6Q;h^BHNV,6P**7F.@"j8K@2r3Dk%jLT'`f`,CIgpl)@P*I0H*mD3\
	dJl]1+7,fZiu^0o2H&(Y@g,!llN&LYa-a15>)mergid.!A)4=\`P(("!TY_Nhk?`_$g!CrS=\MXMh-
	%'aNt,lUel+'WoS,*nD;qOG[XVl^XTfqiYM<:9NU=;__=/ZXbpsurFZ+&LB=HJ/W.;=:TJM7aAERj7
	g3oC6cs3)CC=)5H!MUkH?93d>bO*.7`!XGqMD3lQVhgj,ZH!UNcsX#PgkY(\92/Qn-%hI=Lti5@LJc
	pn@!2mOE,;_n80B(Q@e(S2cg$bjdMR(BTj`PU.*)Z"^`5\@?fPVL7\);NXi_qm04QJ]Tc\V(%?PDPo
	8&\i"YY'aEkY!jGKB[?unc1!HnW(3NZ9aeUbFC^stbkQtI+`=HE1e?8P9B7ja1oM'(Wal+Jo:n."[,
	eS0)*[c8gX\p5CoH!bkQZCPQ\*9ohf?fm>31\u+fhWBkt+m>`24>C[qG;M9I:VPs2]'R6H['A"q+:!
	UVf2/.F;ncc%X(^qrhGt1u4j@!-6;.-19s=Y!-mM\?+/'UVljC2J0f<#5DdO[>:rpIX`Asm%MOS&91
	t@g0`sb=OkZ&%CS-BpY'hT6^7>4B7fBq+"5p6L&[AfQ#+MLn+?j7G5TE5eA5?I1==&W3E2rfaX_q0Z
	H4`7o3?tga-];iq9L"m/h>AdL?G,u)[Errr7XL+gm[OZ.!?HhR"fHL6D6OJQ)n:8:V_[NCjHqk[kR"
	OB3_g6Fa=oN5Eq,TP"c4)UldCUgA_A#B?_jrX6)tb>C++m]n@]i2pg(eXY:f5&2FCXP0Wo0tX$KY`H
	@j-VJXDN]@r7VR%9tZt$5oW6sDP7+1:1%$AhtW2/GB0WA!-^e*r-l09PA[S9+atrC_uH=75^/gm3bi
	$5S<cZ/:Rh-g:L#nF0>@4RB^>:4;NjiIEZY3D$25?f+e,jhVXk-[/gA%k@*Vb4(E/LJDuB@/ddplsc
	!S`m'cH2Hn]CTI*q::1%B(59k?`no>UW3_>!Y-aY=60+h/$[a0OahnEa9$_P*hC:.U?e$*ogh(Wk(h
	<6:Y#^4tIgt!5)qX9'eZ?ELRYgJD?4d%f:e"Eh)"t>f?$+:$^N9p#1+].khL6Ir@`>SB'"BiI-L7?<
	##-h,qp5.g"dJR"?J]EiS3YMooWom^ODTI5/d8jNu#AjMigbJHf*l!@l)'oE8dqZ_::u0H7Q4%.j59
	$64`lU&8p<3NOmtHV-Q+&P?8^MQ:D9bsDp+nbIa9.)!dMh\c+5k.LU5:rRVJ)[j3*?FL6Vc"W7`OA:
	a_mDt+@C.=t\fM8:3+fb3!AEj4MNENmR;tS#Zcd:6)5=cfBJ;=PbBn0G'JW9qP!peU!i$[lYHRi*:L
	KS1]lANR3"Qu`%2^Km@jb1/Oa?e32'#%(FYN]Z3?p,WbcPh0`>[4%$M.At2ir#LAmONNf,6>@8C=^8
	Bp,[o_0a6%^)H6\f&M/1%IeNnDJ&;UfL/^"F?f?,@%Cs2#q-m+7!]YtENF3+/p=H;]hlWpLAdsde;I
	:X:6Q^pmr^p9#<OEJ1lM&Q+83k.pV-l:C+btd]T,[n=kV+l$EoIXd5Vt@A]kelP@FQ5Wb6GR$'g\PT
	W6YjoD,X3f"1Y%W_E$DJjssD:S#X#>!cij\<bUuQ*:D,IND0k4%r$k^nIX<c_QPK4'dts;hJBM@l8#
	+u3Ikim0>AZi32-D]0X'H25?aEMYn!C95@EJgdW>c1YKFOr3r9?Y1j2``ND)A?+Lb2?.'+X9Z+f0Yg
	giaKF2u/Jk5%&2\`'O^d)"+jQk#[?*0`#",EAmtJ/h84)%B9lc]DXllVQ3&'8q!S1Vih,&YYcrJLFd
	dbP9U;\IO>FQ"l%WaSeLMfVsaIQNHV\#sO$DhAh8ML$Ms'"E9P3jc^-VC`:BlbMqGK\5O.!;,qYXkF
	31,FlW=/jZ'>q@+Cc+X&7oR'FZGOO>_Y($s%H:"j&8^RKm5Uoe9Y^p&:3WLkQhu&Kl[JJ6&?*TVLEG
	>RYQkE=V_TUpIJf%_JMHlf6\:i#H>o(#%3I_]:.7L#<rJ3+n08gbC5Mc6j`ir;_WReZF,MQ;qsX$GN
	sDZCThq4^QuOTe)c5`Mt=&5]0brpA!H_?6d4bCnBk%P:H1eZkAl@iSA_:]4g9.S#E*+E*Y+HPZu2fP
	n^gDn];@n7mr]K?ft1uLPf@LeSDk*OI\,qDQ&`!CB+V&*=?^SPBa>4A2"aX_`lR.OFWign]_7#TRe'
	;q0]>8&s.GlJ"M;SCf-fGJc^]@JD2@sC1B(":'1X5,75@X!P)ougpfZ\:kf>3FK%Te\(0F&k-:)n#&
	4ABNl#QBmi.b#)pX`g-JClEM';%Wb4dfjk%Y5`P8hN!A<A%efoRId-ombE#Gj+1Gd@]5!-8#F\;b77
	!chtQo*W#oKj9\-W4i+YgTlFuR$ok\qEE7f/`>3_jp\9mB;><2QIIk3gE!jkl:#?>EX<JZB[jrtq^h
	t+TrjKqIMADU1CF";U)f??U^bq[;VWZS>LI%[W/;u(3Ii'+#-'GJT/PhYUd.2J?sCIF6Z;o'FZa]f3
	h*1OiquY'f1)aLOYpG*;HGP]P]JGrRRhMoaks"Mib+5'<`bo`KcE.&$ZNh-#!bpd-)X>_/"13Odpm3
	KP0!#NEF%sZ/\2d2?4YZ<+f8`GJA`+YQRW!5GQITloSaW+Er_6s%%E^B!nY8ARa0Oq9\"-:*,^_uZW
	bOZ-9&F\DAQH1C=f+FmVMP0IReu3Gm8+OI?-:ZAO+;5m\S_,-K\2[Ul\MrFjK27V;Bm$l_oQRQt-pf
	HGLo2I)IG>hLrEHd,BJAV);6`JD>[DHSB*k?cg$\OglhDggN'!`\ad.U^lVljN'Z*6'WFnDngnijT[
	o:;cTKf0`VA*!HQgG(LdV]c[Pl1I;25/e6sAt$:+S)f<tE@;249K-ZT:)9aWmf7p>t6n/os)"EcO+f
	j"r"c?k[3m,6paI6DuIDto+>YH(H:A**A1b$*$>9O8ba]fdb#6\?mj;fP0i1/XHO!Z>\P(ptKa!2&p
	oEtt;J##hP_C)XWgp&sqD<B`;PK_A9l]%VG/6.PM94'mmK7&Y%r1._g2$,(/LqL$#Dq-6\GUlH>c'-
	_]<bET#"J.8O(64Qh_i7BQI8W-nmPDE6Ui:_#AS4u`5/+(@8[T2$(.^5Sh3P=/[rr&rT.2^?Ta?_6p
	0AK2.,G1lfj.A&6K0Khq:Af3r;.Tj`q%6SV6Q[X!+I?.UAi^;Y^2<ds\BYQP6%p#m8RglpEhs7cULV
	B([Au)FUOJ[t5ua-<3VSHRC&g1?T>0j<gqLNKcrj1FYbNHQH7+3Gs+GR"VS_qEJ_V%_ALR+urX&UBL
	A145mR6O"0BUd0YOEls&j2T6Ti4dGk@hO/pp()i%M+&OAh%"uoAh"@bfHnC$5L\+U&I.)h'^f[$7Y/
	CU=5fK(kT3pkQe)bhkr6QQsJ_oT`'M8,\5Zh3fH7GQN3+I3,Vo\?1$&0\iBHc':a65GW>)%FX`VVam
	EMj[!Y3)Ce;\5Q8I2JY5tE,N$puj0\dcn#!_]C^'7e!(i]R`7[V;F4gA:3dfKt.%a,H=:j)>DR_7r-
	>!SnX&#CiuH[skt^LjWkb:&5]\=mm_gKl6d`[M++gT1/I#Yt;"gDJg=bM<dVBe,!J?uDdmT-Gd%;C0
	?mpI,$5V@bInN_mXNfG^@h'j'F]N/!<_.b#I9?@Aj=ng=TG]pHo'1hN[8k>?pA9N:(74iZlO)ri/^8
	oIAtFYX<05iEE5P<)msc;KVQcTK+)?=AbPKaqV:<MY`7G=YJWMBo5dP3q_uASFPsia8E9G[gZ$P9KZ
	R\0I?$Ed_02e:AM*>+]8!'G1ZR*bBJ1f1TWGr2*7Fr'GHWYlBpQ4KQ_b#;p".,;]27%n#A)m>4:LE&
	H[J"8q$H@"j&U7>XXCDk_*nf2JY#0W&ZWj]H-gC7=V*a+-:@hb=LG:Dr8"d&83"FcgSJdsL3=@A<2T
	PJd(rot*+e\UO`##Vq7kOUatEo3:(ikD9pk3"i-ifT[+!8H=!,buJT[Jp[K[%_V9kWXO<8*kke&0q`
	jiD0ull?+t,KX4]qtVmF>F2R)g!a,b\BXq!N#K0LjqoC%'D2nPl6VWCL,*#_l=:`ai:ri\-5DDW70F
	^?+NpMKQb_mc+1%Q/lpB922s@?<>:Q#IPa1FW)X8>g.)WHn?Mptkq(Lcu,k%'(i2WtDi_;J2#YOVVt
	;Bs\(b"]]-Hro!03=&!05X$@.+)R0$^%k-M1:dkY&2QOFXoVd8\%MqHM/5%>,a1/;PbR/D&rZ>M4nu
	OL*n,>[Y@Pc;!K[&0$gp0d83"HN!B&qZgL7Bbc^eSs%TiEcq56Zc]EosUa4d95R3M;9Oh+PH?G3WYN
	&n$AqMfHX=NkV.J7d_u<GkCL'bk3!kj=TLVY4+`;rK[/pE4io=S6ctd@^%$=bbXlU!\.R/iO=k3bNE
	hHg-M:UiRF$XUf.W2Bao;<Bn#%M\"C+l^J-jb`9AC3/"pmiK;S2jfCer8&Dd-\q"MTQ?_7]/Eps5Na
	:2lGCK'=!PC57=Z(eB3#4B7;.g<g.&%UuJP"AMQ\W\!#2)eJ*aIgZ*8k90Sr=RSPGDq]#f2N;0(^Mi
	PD!->_EWb[_-lp3VF*O=UWZ!h/cWIu*.Cf3WE^>J&,!Rds'#'6;FYMt)0?$*upt-YI#5uPogodgl*t
	\?9i2*u:6THnq`u/'%:a#]3GHeb(h0)B!mqIQ5e-F(0l$,;i4"20aSTOo]0b<m-4!f3/%_8'olEP]q
	.A6`BJDS+5Jma![C5&ie.G%<jh#At;FQ[d_,.a"KGa7inE@#!JKm%nUE;</]W*Bb0],[3a$;@+In'X
	I24&,Q\k&6<(;SG.b0<>T/Zp-i,s')WneqjY)\!3D[#MC8E3:DEI"u@=_C/2eds6N%G9<Vd4n9J<da
	Q\qLY\5HG(8luNk9LKbr8r]4b!sC3ehd77WXO@"e8(t>K$&a\4_#.p)4m\r2"60QJg"hEMO![7[O<2
	a'Im`,jI/pGNiLWkQ89J##G6@3r*(pUhl$XJI@5j"&QU_rr!sMEa<?DK$]51Od2*E'K<E"L0$7nDJ3
	c-6.drCLqF-.h4Cu;s]eYtd'#_\u*!I<#3'`Zt5*_aj*6_g)6TY_&^8p<VkQhBkj)R).MTsi/]2]2+
	g;jlA?kY#!a>jtq6cf5s6A=6*U,k$X`P?Z]kW(nt+m3fM4UeeD+7J<p-bB1f-@8,X=1jMi5-@8\fMT
	CiAcFR`khb(^0nG+-#.(eCfueL?R%e2A4fGrDR'BJ5AR<tgOr75lo'lUoL!=]>_2-5F6[TQXjcDCgq
	6tJ@`(f<I!k/s+o^pgn&QV3CNKr:>&<Dlpom.bTY.Z5kRSaeYXcPW]fB:fBib$"+rU[cuV(UH9%Ekr
	L"2S`nj`U@SN(.4<H(-*[Ek))`5jq$"7rNWU+W"jCMr0T^'I@BWQ^0EHElR:[GP4TblMS0^`rU3_9G
	FXW5OHfc?9$q!i7fMhNi>tO7?*ZigmjNoO5JjKWFkCf0"n"9OM1^9UDh.i\a4cIaItCiK/g^SDKYVF
	@)6DYZ]bERbGeW,/qK#:MZP_Ue]u#i#N/+9:6I3.?]"+9@/.9K[Q_ZlgC;]T8tb4H)X2ZJ+@cd_!nZ
	*i,b<Q7!Td.dn3&C=3lZLCjIgZY"rmJY:hK4C!H=FH%fm!(Xc`J,0]*q!F>-eT_o$Ubhu`f02XrCUL
	E<+Qq(C:PE<0(np6+`c:c#^3mY89Q.I21VkK:bcGj>UY%Trb$8J$&6c)h-=oL9U:8.0uQ@n*6(e!d^
	s)o7GV8j,((GpJkjV:hZ'kEqrWh']D(l&B%/a,@N;9(1TZ^Y^SZ"E<ZrlH0Dn-aR+f3Oh6C5N',D(i
	o8p'QRi_?o[0i7qNTs7o$CK44:e+'P>'<?TQe2i<<__Q.9Df-V/:5luFo`]:q92Ir'2&3]26+_"!>G
	YR(JG-[ffGa0D2'/EFYbJeiB$eFbTu)cBU,)q?<\&o(C:bSr"&NjrF3C^2C#=]H^1@-EgYY&=hEdJ\
	)*c@5:,!i.2gg!hP7XYV5"_i*D)k2'#FLV>C_)4Z$W+D8t+K.MZ6EuCAl#3lYJ"2qG#N.eDKJc]u3d
	$Ug=:gfTW:-ai#oi6q=TT5V*%R#6<J`Pt(hka`C?cp<[mP8@*G#L=pTuZ*EIcN0+p0ZVQ0a]ZnEt1Q
	C>**geq>bP4DD:*fo!(nn=Z@C.c\@k,3G4SRg&FnB^ULY(b(otJlFE+cZLs-?j8,?WaE\_7aE?ak`%
	0WW-MSJfmuHjs^N52*F2,PAlf@@K1#*[p%J)YZ0Vje/V,18SO716c)h4A8=)jQj[/EJ*`hj6]Vfa2g
	*%1RuRt:#hW_ok'!:Oosn(&eXBbU_/(36ecjI5&-=jE"VB9eWYIpIco?KT8`[SP*[[io?<p>KrE7C=
	$+Aj,6lc85nGSKLPA%Ni"proe/S,m>UgJ$5jP<cW]5qu7`Ze[cT<)m3[JY[*oFJBu'W?)$EBRW0$bI
	3Bu;,WR[*]M'l6TRq`J/#pm;AOc_/bgHp@_-crcT6u]S/pJ`Q]Qb)!f</Q_enFpD'?8f:6<S8Vo3n%
	l9F#JZB4bhCfpU/IrdL;H7DI4@,>iTZ'6uK_W0s,l,u(#!QdIC.pm<(1EUnnUr?--[BDPfsY$=Z>?J
	e$#"B'JOTKk4r?^WS.@5V+6(fj(bi_F"9>#VT?*kp%7NT!mrlWqY*HPen=,O9^jhR15PQPK:i.jH7d
	ElOTLO\lI&[Bmtpml,<g=jR0X@=H'=N?Y*aDb)*.-6at=r="Bmb5rRa\TWO/d&iDif<@a`GU8;UXiY
	;_Ok\Yd47s4/<srNZ3GK&3!M7U_M"mL?8Ms5e63=]j,;tJITQ=Jb,mSrhU@3W^JS-@C?;9;]_et1Y_
	gc=lnOF)rj>nfcgi,G8Ep(".&qShS/ln_4H=>X.oc/r2hZY^!48`r@:Y#VMp^F&(YUJZ\Z?kNO!?+1
	KJ9G3:d^G!^:L0NbRDh2Pp^BW_ME[1PmW$K+$Zf@>URhZ(+pHi#lBTjXp,Y7^q[H_ChacF'j^GnB%*
	8jWrKSsAVtk.FU<]d%"-cL-nD"t^CZ-06[X;CUD581,7>lV*![XG`9N,l:d0_DIq'A^H9!n4Mf@;N5
	fkJ/9o?0PZ]S5S9J&Bm38+Pf4h#b,]h]fXbXbc7mCk'@J'F^t(,FQE\XgZa[+OK(0'lTg(2\uN.#X0
	)HDGh8Tghi05n=Nf*\o:=c[s2/K]hi]3EcXqVY+jjR.--hRWKbJaQ&JIlS=(k+;]uBT@2peeaL?kCe
	@&N081hf"Z_2B&8rb1l!L<K0HeAJ_rHu:.]'iFOkr[!Kr\4WQ5NR#(n?MY'Q?2RlIZJ.mK>#kKe^@Q
	<T:D\=WdtZBqNGQ35fLQ]2:i)5ba^2OefDO+9^_rFpC.\3`h&n6q(&DMfHf'U1nVVYlK@7((7=dIf8
	'66>rh-e1EW9blImtm0#o*i4SN`^Y!+J\$_na#3XA4>A=,&J<H6:-n[@oGH7Hh>@HC,(ji*"Bf:5'U
	)5_?/"Ar\J.5\#Tam3YUk_iD/P4lfK(1,o[h]b#5K6PKr4jM[AP98uRF"PcY/n2=8V1]T=+5B4qk2E
	SXlpl-'A1FG;%#:A9MJoCnOe;gElI0$'CcrWR:3L?7HNC\qH&[\jU-??5OFtZqlKPKfnd<Hl)JB,TC
	/G$pqL;cqD4q$V:5>FkTgV2`?O(WX;;+HVoGp@$hH/Vse>R6:)>hII5d8MEcDd*LFC&$f2N\-c^V/M
	/8/Q@XZ:]Pb:@MAPS[je]_eqAjqmONU7PTb;h!o^"a+9HI/7L[2EE&8QPNt&e"5j.f:Os>H%DkM5F7
	L3GZ?Q)Tc:tr:SNW<<HSM7Mn+ijN]B',l;-6Y=TYAR-6I'Wb:JoU.S*@<TF0C$)PtRhHY'hL_>M[F/
	mP%A>.UL7*jJHj*0n82Re5Le'alP<*G=E?u%f\nGidW@TWuS`SP+Sh";)L.*N<b5MP#))p9g6O=4te
	kR'n+*@>n".40-JuGO<_F+QDP!X\QBK>+t[H5\_9pgd`AMQ40n7k[+1"]A1bmeEiYb7T7Kr4e7<,59
	Xh"Sb(0)G8#C_cRBAW+O*tlD,?pcc-p\&-4pqu87PjYW<hf&'rNB\'mbU3N%\"_jb$l,Fe;rc@jQ^0
	dfJF+G_28\1EoDQ7EdL2orqK?b7sa2\M=Kp%E@i:fGorM=n'H@&>^>ZWf(JCfY@V&ia@0]\FWZR"oA
	oc01NN2^KF.o#+l2[<^Y*q5=VTB0_g@J@='_7M.a=E>p-D#g`Xr;5h576f2\5E:%:qoI]E4\$S3/Y\
	b<HD8Fi-`F*%S.AiP3/eUqu7aC9NsPQP5S:^tCiK8@G-Fj(7=DC/C\V>Xe-mFSnr!jOOi>^:p"U@=e
	..F,VUGjB=IZph=<uS>;Ti4^Vfg0tDA;79.WI$;5:ejaL^^5C-eFN."kFal<I8O`ND.M>j#Hd$_`;F
	7MAW'pB6)'#n&,I&ops5-BEGGQdimO?)-4o(/<=QBa//"S#qBjt`Z[[u-Q=fBu\G\3$i<=a*48)iZ8
	NS]%%@NElDY8,=K5J]5*L%*c+G`77UXJB9doEtYFmN6/[(/Cp>uO$f/p_5aL"ac.b48L2gd/h=bp`O
	T^C@tW4!SiB?'I/al@=2lOYld71NQ!E\F1&DjRZV+0?8c[/6Yh4?:6=[&nDn$Z.?)=e_8f)@EW;4/-
	Qc3b\0ZiU$D6[2SCA.bk2U(-a2Fn!YQ6T2F2p-lI1YZ%=ir$G(^/6a"d=4$+mt01N38I9EOIE4\*s3
	pUKW/.aO5"^ZJ7eYH5bjB=@]EH@R4N&?[9`(nC/n5qJPMF812)<A._KN-cGIX2+\F#P\nYDlc+\mPN
	ID3iMmT_MHSUl[2Eas*a4ErA+CIXKglr9Q+d16XX`ce6E:lS=RL0Hs\6'eKTAF0p:"-e3Ho%Q?n?IW
	Hq]1'_#P^FNGC+R=0(0/',Q!W-n1J$;aQZF?!)%6"p0g>^+k]m"q4Rs*+(M'\Y+`D?)2YpgnroQB[k
	6$@`B$o/VW]:tJ*T)!Wf'RJE5[5Aaod(_AltI;)pqg[@%='/pf^ou8"2G6Q*8.Q#JNhuh**D)A:Ll_
	N4MHZU9jOQU#Q1OME7XUJg8p?hYFWXS(#LRdLo:,Pa0q&BN+S%=rd@>RDoR#$1e4Y'Z@,Zo<$e1q=q
	uW7,_RaT!:9'Ei/`p6nP'O5BlgJC").0A;HL'-3+X83Juoh7F[co+t4mSc4J-V_.POXXeJ],UD^1?)
	S45<h:Cqei=g]-J\+Sh"1Q_BM>+7^Om$`55X"#"J>"cNP^oW#Gla`TEKmo7ZeC0!MmH1[1NT<gXQlm
	$L@95i>$EC(S1u4_7fsJOM6D.nWB%-[r#7P"F&73ZM7IA!=If&<S969jej&;Ql"\I`1=:)uO<RL$Q$
	2`:d8eMa0PW6c$I<d'JCt2!GR8HAeN.9;M*<%elOG,,);4!C(g?(U7n2M&CA`QOodY8/8pFp#mhIp`
	X45WuQIlH*Bf_49`=EI!^>"&<h!u=[IAL*`FlCHpc2![?FlUo>%Fh:T`M)Z!Alo&D%4)<!9kj)A<H9
	PLZkMZZ*B?h5^InJsKq/##9ZDJp6d?*lcfu:JfkRKgQ7&]9K%ZSo1KR]r6YPQM9l(_\N+)g)MC7:o3
	`3o@8g/YY>.p!AaD!@R&c=Virj0$MQH^hdfisLtUj-F(SKlB/7cUQ8&AOs14<Q'4RB#dbFd#_NY>O*
	ZKcuqhT4$U5p`(SH_s8]3>b.F\d:c@]/BTSee48]?d"iZ!@FmIk>_P_g;mR:tO77ro!>`tcCPU7sEC
	:c3%:mA$>VX#!+'m0u8rgCH9#/=i+eSN]g,\s8lIm6q5G0llYuomm7W5<sr[E4>;0HQ['rDdH*.WdY
	Reg5Ika5Uj'c7%J.<EoPFQ*GI148g4=e+@lq/pCCI<)3IU#FVs8OJ9TMC3pVaMBgueC>ATVSTrS!cT
	#WF(JYP:)[_>"\UYFXF)$5M:^!^ImuFW@ld?4&!ZE#=:cdW(Y)U<+8aBCC5bnfMfuaEntFTWYs,b16
	4W$Y9ho&.m'D<TE(,2.k.(Q>:i#%k5VD8%-27&C1X85hfB)PC+)`IjAlgE)>be5$Ym2@un<AZiorM=
	05G!k5>NfV!J'8<EP@8"(lgMi-/9\s#[[!L:qgrTAi,57^jk!=Q5%DUYFqt2QZ]Y/4PCRME[5on'>[
	DIi0lHgVO>PbV1;6oW)sfe76RrlXOFpnX;Q!C4_#@maG\Em\80LKCib.AGqW/99aA%JoAjRZm'Yn/B
	kljT9B'n9ZOE2(C$WdEW81`i2;*J`1F[5I+`p"(Y4X+lX?;4IZ8*UGj5#G<\27Bq*Y22Wm)UL@ZGb@
	%oM8l:SQEcM%O(X(e-?WmdR&_g[<<T]'NkI30Z_lpbrVKUfM!5/;*BS_O'm6pEr5HXo<mW&=TlF3E=
	BLjN\hV"U,hPf(&qog477BmDJQ#UcAqui.,\;M)MkS^NCb'WF^`i5-;DU>]aL(;X7]3@\m[ou!Xpp=
	\^dHUZceR8K^qkW+,93#=:`tm"N11i+b/BqQ*H"bF+%_`&C9C`$W`$'4D"tcPr%g7RC6Vt/+m1-OkG
	b1+l&Q4M2\FXC%a105In!`kNj+AT-u(csD5SYe$Ce]!Yc((G/IS*!^)q8(+1:#rEDXPjdncd@R)^?3
	eGA>+YPN6\(1J$c_jI78%.l`^O_"Ok*.d.&0?A\6J%j4U<=:/NhK'>W-,mST$cAg;,oNqZ\GKF:B#!
	B))/JQB6gO+=p,hgpIK1/b!jb3m*p1&OF"\a1q8$<QbN@$Q1'A+!+[sa&lc"uo$T(BPH*)L7,b9TFJ
	rK6C2VRHeL$NI@U=-:c.Gle@j:[Y1XS#L<5:JC[2"ZWDY*cB%;)S-'oISE_c;!8ZR]B2X'90ie^1&R
	uS]<Q^?QiKH^s2`71)bNgMgroW"-ju8*/Yogb5ZLV=J9soi&o$]:e*$LP-Be/iMg-(!i&fp;/;3:(>
	N_=%hm\-U=Bg`6',7e5I@8Y883phB`o:T$,aj0'.)>uAT>39RANgi-62luK*TY\+QLF"!&jp3$V$<i
	(rd*D1#I1M%;$l\WA!q;Ce*61V^X'dCX(P2V>d.U%+oT_JR"\iGA#Eprn^@S<tqG\+^uBZnTGmPQcV
	'#]JkBIIZmjB#6#^8pik4Foa[08@Y51=<RmMY5.B(a"">'b-.e$S8P=,QWQD/"b:s)Z806ZkTQh)/4
	2\6HYZk\1-@jQKBQZ/XF`#!p3i&<+$Ku5n6,'dm+`uAP-YsUG6.L[RJ>jScb>b;taZ)tqZTs2s3]e^
	N9BOkEs.4BpP<d>7/&3esX2fTOafI#+#mIr$k%Y9//=Cn#flA`B,3$0LE$7[pQk`B>=6I,lK'j]ni?
	`j8h1Y>pR)9!6d#;ijlhcti:eg5N.Lj8iIkMZKesd[fk1:DQ5!L$2:AqS4pf]kUJ]>Yc2)@tUL&4Rs
	VgZ3gDXg%oJ2sY'4Hu#f9NQ8]"4#W4\B`hN<AiUJ;8D.I8e$[BQ_\"D?@i;NJi*RZ,^`eC]N)17F"C
	bN\D!YDLl"Lj&hs+5Vdm5j#p3Dm"@\RAp^&%u[_k&+MY,I5.^#J_^MJoPAjEWI(dKuB*n1g:b),X!Y
	-YZR9:-R)#2`HmA`]0F,6A6qAAGAt(+,a-[3jkt3aZWk0D1lH3m0#Gj[fM,P("p&@qLb2s7t4Fg/;f
	[^lc<:3k>Ob:2\B]%lTd"cFO)M#/uDk(tAYC@[lPppm"nL!C6r=\[Ic)e'PsMMbc2^WDB[.XsP'\=V
	jmbQ,H34?G:rpWGMqVB7gbqj=i["m9G*<\L#KKFLl(Nk$04V-AkutV?OPa@efZK)*#f-95HAtF!K;E
	+s"Wh1t&ALP9t8^FS>[A6Q\1VV\P#\pmIn#P_92pl<@\ng9X`&<E=#/Ri$UA]<,/n^Q'U>\RsA?W@n
	_-nGV8Z)#fT"I]Wd8JDoHT1478f@MK]:>HN$cXn1GA,CpCq]gOHEfe66R\6aC8n\6KNY0b,8&Ve^Q>
	=/R"005p>1CJ3$'**]Sp6%+64n[jGRVm]WK[2_r,IE9@_Apkj"l/+/7?9BM!`/gobQ?1"Ya$sPg:m+
	C;_k/1PC+c+@2cu#Bpl#J=2j+r>#h0/fn*E@EWp<maPl\c2,,<!D*DS0DO$ja/_jL*'V\UQD_Gq%'.
	;nJ*(/ngajgCq$W8ni[-7.ZT8c1?9f6W1U96(jkf=#8'7?a7R9]1oKidQ5G_#0BgT+2Yg6ZLU1q$A!
	FfO'Zr7V^tRGiEPLM05I=Da7GSX(4Ff%pPZ7i!CaB$A`f<5:p/Ij#N\o%Z2[LCK'Z?J$XJglk:r.6^
	*TV,pQ_3bCJ),dp(m>kL*L13";-79YR+@Jec,)L_/d)Van0RMbf37C/>Jfog@!)_1+Mk:,I)-:alRZ
	kJ'N)cotd,+Y)I]'V2jUZdmb3$b51Fd,/.&!o+K_e=1*C0SDk[Fp`dRT4T-ir=%9LN*P[RZashK'V9
	T:gD-032^DC>oXJgP>!P7'-f2oH$lQ3cQ8hP/EHY<9I(a9=]QMdI4o?&!*lJFa-u^N,X\;&VP^6S#=
	&!W!La03P`c2S`qmQR8rY)&fRf+6-uH<SZ+3R)8AT%hE;"T=;='lK%bEc6r'#]%B`Js3R]:plEkP;(
	LEUtZ+J'1tA_d'X"@!ldc(pbPP':!SK^nog*nlm-1Q<H%1EAUWGI2Yp190EM+@Ft:-m_4f\bKSf`[U
	pM=0tD/ni4JS$f[A^pJEj'RRn\LhIe)7fZfp5Z?dG)]e",0_DF$=>!",t1^6mdDbZ<Z!>j2-Do\eT0
	:nTa7TWemF@WUhMK,d9*orqDVJ.n4F.)"_U"."5p2BoXOOI\D\1e0C^8ITsXeY'I%Xd@40e0SRRXOu
	,!tWf=ElFQDAe71g#c3c,.'Fjcbgc?;$j.`.8uN?Sd/(fTRX$rfWM^sb*62as0EA%".HWKj33V8.Si
	A&1Gri"b(5;lmbWK0J`YU\r`ka<YbUPWB?@kFpH/O^OZ%\.h"p#f]Itph5*=[)VrKT<<IUJ0G^DOD6
	N27hS>RO_t[T]0bSkL@H)l%X?e68]E:LfG6G5g6V'!:hd]``k[26Y,^J^0Mk\lpO,k-93"Q`p-"2/S
	[T5O9n&1GT(*m,(ICE&gTFH-QL5dVMECK^7EKbW,qL29h[m^rBAfOe2$:7us];P5,+Fm*>Ap;Tteo5
	^`ltZW\MAp6\i'L'i_BP@ghh2Sq2SZO4bP>k>%6rdJ71BW[-PL0CMJSb`[t]EbfSXu^P2S#C*He\p"
	&''.HnG%jpN\eA\:n"lSE0/1H%Q=h?;5)j2No`M)Q9K#sh`t-o!rGjClc9=Y9ZZ]97PZt2Fd=N>a,+
	33es3^)h(4--j:)1<7%&?-3Q].`gRVe1.qHZfF`#o(lX6>^lFAR&"N^:SuE'ld0(358b:"IoB-X[KM
	S,D_$P%g\)FaB(-=@+GoI5t,6(/gsB0JO4c=3PjOSKL$P(_DFbr(@rUM+@j87um@$!fc-l8HNoMX1j
	`!rKI4K7ndWNSU$6On#1`e0g7L0,8'$)na.Y:Qa>sEZp>,l0PjPIcpIeB6[N5+LH:CZJMC_Q_K/mYa
	Ml:Lb-W/)ahYgbi[T`7WBYK772$pJ%ac3A]qh8O!PnKDG"atBOL&,%SPI<*6Ahrqan1n]RV8oGNg?^
	Vd]p&s"$)TKKq(jSp0S+Pf5fA&X&<m&3F#Zg;S^CZJFZ6&!?LDmW3J!Lr,l$`LDkjmU/o(HR^FoMV8
	+A)Jb_cPOXMmL;eSXs3!N.I:O7j_QJI#uBtGs<;t4EkY:,R5S=2K;0cB3GmfT!7WR\MlfOo$S./(cF
	mESKLV1(Z^&p7<[$KURBdW1(0DQSbnE<L-[1$DAPFKKibN3@HudfM-_]a;5mI?YRVe4OLI.(Nk@*-l
	<"(VN4%Khbp:-Bo7DIKFO]ZT-^la8fbl"gYmaqBUBV35"+sT-r0WJQ#+A=[p8]'Ak4=0K'"6&L\q>$
	V+tZqDr2uR'QWO<I,F2eqCF\22pl1-;J?GB%h<+HZgBDEZ1l%KL=QS]8rZ^jKO-RcNY]Y7jc)fL,<N
	h.$F8_l^74:eL=6]X_1%0]7''4.hTGR"ZflYqYNt8o#_^qHAO.un\l<:o"egs4_C/+bj=-+oZZ)k1q
	3_P3/)XM$Jbl+]Gfnt18ih+mZ;[<brito/EIM&(Jb,S-;6RPD6@-\5N`.Q.ejr?dMYQ":C0/I`/a&K
	g#?F=&&p"56[;Eo5]P^)T[eU#X4Gi+5`2sd`f0EqLX!/9PA6++p<@#M=Z56^q.89m76>]A!LUiGfak
	/GJ,;+tr%])VjfZqjo\@O)r7k<\M=ttM#5\5@GEu;[XCs@9F_"ohZ),sO^W]/RF.'7D%bfuJ\T*El9
	AXKJME5H(`n*[SjY63JaT-_?I>OHGRKRJbiWki@lH?MZOVCZ%KZ;pL*"EDe`Rd3XB\Z9[/S4hQmJ!E
	$3.iB@QN-t2]fp.%bMTM5kp].r>1/T1jBb;=Uu`\!*d[%D%$u)So8m:N?gm<EQ;kts&`p$nY$+TH6@
	+(.P!\Rq[PSn^6@'Eql][VKEbS*<>10^jO@,g]kK]VoVPiWZ=0B1']$L>T,,"2nq=VHcC&.EN0:>.i
	QF*G6/ZH:LQF*G6/Lfc/P*WJN-&#T-dZTp'Ul\5B>1/S"'QRnZ93Tc,67sj(8^!N"rgs/m!6?/-$5c
	A!4obQ_!(fUS7'8jaJc
	ASCII85End
End


Function [ String prefixStr, Variable freq, String suffixStr ] SpHrView_OverTime_SplitWaveName(String nameStr, variable getSuffix)
	String FreqStr
	if(getSuffix) // left or right
		SplitString/E=("([[:alpha:]]+)_([[:digit:]]+)_Hz_([[:alpha:]]+)") nameStr, prefixStr, FreqStr, suffixStr
		if(v_flag<3)
			prefixStr=""; freq=NaN; suffixStr=""
			return
		endif
	else
		suffixStr=""
		SplitString/E=("([[:alpha:]]+)_([[:digit:]]+)_Hz") nameStr, prefixStr, FreqStr
		if(v_flag<2) // may not return suffixStr
			prefixStr=""; freq=NaN;
			return
		endif
	endif
	freq = str2num(FreqStr)
end


Function SpHrView_OverTime_FreqImageReplace(String WindowStr)//, variable Frequency)
	// Make sure Frequency value is found in CFs wave
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	NVAR Frequency = $SpHrView_OverTime_DF_Globals+"Frequency"
	NVAR FrequencyIndex = $SpHrView_OverTime_DF_Globals+"FrequencyIndex"
	FindValue /T=0.1 /V=(Frequency)/Z CFs
	if(V_value < 0 || Frequency != CFs[FrequencyIndex])
		FrequencyIndex = SetVarProcIndex(CFs, Frequency, 1)
		Frequency = CFs[FrequencyIndex]
	endif
	
	NVAR minEnvelopeFreq = $SpHrView_OverTime_DF_Globals+"minEnvelopeFreq"
	NVAR maxCarrierFreq = $SpHrView_OverTime_DF_Globals+"maxCarrierFreq"
	
	NVAR DisplayWaveformMode = $SpHrView_OverTime_DF_Globals+"DisplayWaveformMode"
	if(DisplayWaveformMode > 1) // Make sure Frequency > minEnvelopeFreq if displaying envelope cues or both carrier and envelope cues
		if(Frequency < minEnvelopeFreq)
			FrequencyIndex = ceil(BinarySearchInterp(CFs, minEnvelopeFreq)) // SetVarProcIndex(CFs, minEnvelopeFreq, 1)
			Frequency = CFs[FrequencyIndex]
		endif
	else // Make sure Frequency < maxCarrierFreq if displaying carrier cues
		if(Frequency > maxCarrierFreq)
			FrequencyIndex = floor(BinarySearchInterp(CFs, maxCarrierFreq)) // SetVarProcIndex(CFs, maxCarrierFreq, 1)
			Frequency = CFs[FrequencyIndex]
		endif
	endif
	
	SetVariable sv_Frequency win=$WindowStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(0,0,0),valueColor=(0,0,0)
	if(Frequency > maxCarrierFreq)
		if(DisplayWaveformMode != 2)
			SetVariable sv_Frequency win=$WindowStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(65535,0,0),valueColor=(65535,0,0)
		endif
		DisplayWaveformMode = 2
	elseif(Frequency < minEnvelopeFreq)
		if(DisplayWaveformMode != 1)
			SetVariable sv_Frequency win=$WindowStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(65535,0,0),valueColor=(65535,0,0)
		endif
		DisplayWaveformMode = 1
	endif
	
	String str, imageListStr= ImageNameList(WindowStr, ";"), imageInfoStr
	String XwaveStr, XwaveDFStr, ColorScaleStrGuess = ""
	int i 
	for(i=0;i<ItemsInList(imageListStr);++i)
		str = StringFromList(i,imageListStr) // first image name string
		imageInfoStr = ImageInfo(WindowStr, str, 0) // first image instance
		//Print imageInfoStr
		String prefixStr, suffixStr
		variable oldFreq
		[ prefixStr, oldFreq, suffixStr] = SpHrView_OverTime_SplitWaveName(str,1) // _left or _right suffix
		//Printf "%s, %s, %g, %s\r", str, prefixStr, oldFreq, suffixStr
		String ZwaveDFStr= StringByKey("ZWAVEDF",imageInfoStr)
		//Print ZwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr
		if(waveExists($ZwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr))
			ReplaceWave/W=$WindowStr image=$str, $ZwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr
			str = prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr // updated image name
			if(i==0)  // first wave?
				ColorScaleStrGuess = str
			endif
			
			XwaveStr= StringByKey("XWAVE",imageInfoStr)
			if(strlen(XwaveStr)>0)
				XwaveDFStr= StringByKey("XWAVEDF",imageInfoStr)
				//Printf "%s, %s\r", XwaveStr, XwaveDFStr
				[ prefixStr, oldFreq, suffixStr] = SpHrView_OverTime_SplitWaveName(XwaveStr,0) // no suffix
				//Printf "%s, %s, %g, %s\r", XwaveStr, prefixStr, oldFreq, suffixStr
				ReplaceWave/W=$WindowStr /X image=$str, $XwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz"
			endif
			
			String YwaveStr= StringByKey("YWAVE",imageInfoStr)
			if(strlen(YwaveStr)>0)
				String YwaveDFStr= StringByKey("YWAVEDF",imageInfoStr)
				//Printf "%s, %s\r", YwaveStr, YwaveDFStr
				[ prefixStr, oldFreq, suffixStr] = SpHrView_OverTime_SplitWaveName(YwaveStr,1) // _left or _right suffix
				//Printf "%s, %s, %g, %s\r", YwaveStr, prefixStr, oldFreq, suffixStr
				ReplaceWave/W=$WindowStr /Y image=$str, $YwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr
				if(i==0)  // first wave?
					wave YWave = $YwaveDFStr+prefixStr+"_"+num2str(Frequency)+"_Hz_"+suffixStr
					variable YMag = max(abs(wavemin(YWave)),abs(wavemax(YWave)))
					NVAR holdYAxisRange = $SpHrView_OverTime_DF_Globals+"holdYAxisRange"
					if(holdYAxisRange)
						NVAR heldYAxisRange = $SpHrView_OverTime_DF_Globals+"heldYAxisRange"
						if(YMag > heldYAxisRange * 1.1)
							//Printf "YMag= %g, heldYAxisRange= %g\r", YMag, heldYAxisRange
							CheckBox/Z ck_holdYAxisRange win=$WindowStr, title="\\k(65535,0,0)•"
							ModifyGraph/Z/W=Over_Time_Activities fStyle(left_L)=1,fStyle(left_R)=1
						else
							CheckBox/Z ck_holdYAxisRange win=$WindowStr, title=""
							ModifyGraph/Z/W=$WindowStr fStyle(left_L)=0,fStyle(left_R)=0
						endif	
					endif
				endif
			endif
		else
			return 0
		endif
	endfor
	
	ColorScale/W=$WindowStr/C/N=ActivityColorScale image=$ColorScaleStrGuess
	
	String YUnitsStr = WaveUnits(YWave,1)
	SpHrView_OverTime_YAxisSet(WindowStr, YUnitsStr, Frequency, FrequencyIndex)
	
	// replace 'peak' traces 
	NVAR PeaksAreABLSized = $SpHrView_OverTime_DF_Globals+"PeaksAreABLSized"
	String traceListStr= TraceNameList(WindowStr, ";",1), traceInfoStr
	variable traceLayer
	//Print traceListStr
	for(i=0;i<ItemsInList(traceListStr);++i)
		str = StringFromList(i,traceListStr) // LeftPeaks or RightPeaks
		traceInfoStr = TraceInfo(WindowStr,str,0)
		//Print traceInfoStr
		String YRANGEStr= StringByKey("YRANGE",traceInfoStr)
		traceLayer = str2num((ParseFilePath(0, YRANGEStr, "[", 0, 2))) // pass 1 as last parameter to get traceColumn...
		wave w = TraceNameToWaveRef(WindowStr, str )
		wave xw = XWaveRefFromTrace(WindowStr, str )
		XwaveStr= StringByKey("XWAVE",traceInfoStr)
		//XwaveDFStr= StringByKey("XWAVEDF",traceInfoStr)
		//wave xw = $XwaveDFStr+XwaveStr
		if(strlen(XwaveStr)>0)
			ReplaceWave/W=$WindowStr trace=$str, w[][FrequencyIndex][traceLayer][0]
			ReplaceWave/W=$WindowStr /X trace=$str, xw[][FrequencyIndex]
			NVAR ScaledCarrierActivityLimit = $SpHrView_OverTime_DF_Globals+"ScaledCarrierActivityLimit"
			//NVAR ScaledEnvelopeActivityLimit = $SpHrView_OverTime_DF_Globals+"ScaledEnvelopeActivityLimit"
			if(PeaksAreABLSized)
				NVAR ABLmin = $SpHrView_OverTime_DF_Globals+"ABL_Min"
				NVAR ABLmax = $SpHrView_OverTime_DF_Globals+"ABL_Max"
				if(strsearch(XwaveStr,"Env",0)>=0)
					Wave EnvABLs = $SpHrView_OverTime_DF+"EnvABLs"
					ModifyGraph/W=$WindowStr zmrkSize($str)={EnvABLs[][FrequencyIndex],ABLmin,ABLmax,0,4}
				else
					Wave ABLs = $SpHrView_OverTime_DF+"ABLs"
					ModifyGraph/W=$WindowStr zmrkSize($str)={ABLs[][FrequencyIndex],ABLmin,ABLmax,0,4}
				endif
			else
				ModifyGraph/W=$WindowStr zmrkSize($str)={w[][FrequencyIndex][traceLayer][1],0,ScaledCarrierActivityLimit,0,4}
			endif
		else
			// is probably filterbank wave if no XWaveRefFromTrace
			ReplaceWave/W=$WindowStr trace=$str, w[][FrequencyIndex][traceLayer]
		endif
	endfor


End


Function SpHrView_OverTime_UpdateABLMasks()
	DFREF saveDFR = GetDataFolderDFR()
	SetDataFolder $SpHrView_OverTime_DF
	
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	
	wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
	wave/Z EnvABLs = $SpHrView_OverTime_DF+"EnvABLs"
		
	NVAR ABLmin = $SpHrView_OverTime_DF_Globals+"ABL_Min"
	NVAR ABLmax = $SpHrView_OverTime_DF_Globals+"ABL_Max"
	
	wave CFs = $SpHrView_df_filter+"CFs"
	String OT_DF_Str
	if(getEdges)
		if(useCarrierCues && waveexists(ABLs))
			OT_DF_Str = SpHrView_OverTime_DF+"ActivityHalfMaxima"+":"	
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={ABLs,ABLmin,ABLmax}
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={ABLs,ABLmin,ABLmax}
		endif
		if(useEnvelopeCues && waveexists(EnvABLs))
			OT_DF_Str = SpHrView_OverTime_DF+"EnvelopeActivityHalfMaxima"+":"	
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={EnvABLs,ABLmin,ABLmax}
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={EnvABLs,ABLmin,ABLmax}
		endif
	endif
	if(getMaxima)
		if(useCarrierCues && waveexists(ABLs))
			OT_DF_Str = SpHrView_OverTime_DF+"ActivityMaxima"+":"	
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={ABLs,ABLmin,ABLmax}
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={ABLs,ABLmin,ABLmax}
		endif
		if(useEnvelopeCues && waveexists(EnvABLs))
			OT_DF_Str = SpHrView_OverTime_DF+"EnvelopeActivityMaxima"+":"	
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={EnvABLs,ABLmin,ABLmax}
			SpHr_ActivityAlpha /OT={$OT_DF_Str, CFs, "Mask"} Wts={EnvABLs,ABLmin,ABLmax}
		endif
	endif

	SetDataFolder saveDFR
End

Function SpHrView_OverTime_PeaksWindow()

	DFREF saveDFR = GetDataFolderDFR()
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	
		// ScaledCarrierActivityLimit and ScaledEnvelopeActivityLimit should both equal ActivityLimit ...
	// unless CPC was set to > 1 in operations SpHr_CrossingCarrierCues or SpHr_CrossingEnvelopeCues ...
	// and SpHr_RepOverTime
	NVAR ScaledCarrierActivityLimit = $globals_dfStr+"ScaledCarrierActivityLimit"
	NVAR ScaledEnvelopeActivityLimit = $globals_dfStr+"ScaledEnvelopeActivityLimit"
	variable ScaledActivityLimit = ScaledCarrierActivityLimit // default, reset below

	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	
	String WinTitleStr = "Peaks Over Time Activities"
	String WinNameStr = cleanupName(WinTitleStr,0)
	
	variable BottomAxisMin, BottomAxisMax
	
	// DisplayActivitiesMode 1:Halfmaximal, 2: Maximal  ( no SD: 1)
	// DisplayWaveformMode 1: Carrier, 2: Envelope, ( no 3: Carrier and Envelope)
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
	NVAR DisplayWaveformMode = $globals_dfStr+"DisplayWaveformMode"
	
	// default modes
	if(DisplayActivitiesMode <= 0)
		DisplayActivitiesMode = 1
	endif
	if(DisplayWaveformMode <= 0)
		DisplayWaveformMode = 1
	endif
		
	if(DisplayWaveformMode==1)
		if(!useCarrierCues)
			Print "Error in SpHrView_OverTime_PeaksWindow(). !useCarrierCues"; return 0
		endif
	endif
	if(DisplayWaveformMode==2)
		if(!useEnvelopeCues)
			Print "Error in SpHrView_OverTime_PeaksWindow(). !useEnvelopeCues"; return 0
		endif
	endif
	if(DisplayWaveformMode==3)
		if(!useEnvelopeCues || !useCarrierCues)
			Print "Error in SpHrView_OverTime_PeaksWindow(). !useEnvelopeCues && !useCarrierCues"; return 0
		endif
	endif
	
	
	WinNameStr = cleanupName(WinTitleStr,0)
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	///////// remove traces and images if window already wexists /////
	if(WindowExists)
	
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			GetAxis/W=SpHrViewPeaksWindow/Q bottom
			BottomAxisMin=V_min; BottomAxisMax=V_max
		endif
		
		RemoveTraces(WinNameStr)
		RemoveImages(WinNameStr)
		
	else
	///////// Display new window with controls /////
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		variable wdth=screenHoriz*ViewWidthProportion
		variable hgt = screenVert*ViewHeightProportion*2.5
		Variable  winleft=(screenHoriz/6), winRight, winTop=400, winBottom=270
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			[winleft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
			winleft = winleft
			winTop = winBottom+25
			Variable marginleft, marginRight, marginTop, marginBottom
			[marginleft, marginRight, marginTop, marginBottom] = getWindowMargins("SpHrViewPeaksWindow")	
			
			DoWindow SpHrViewPeaksWindow
			if(V_flag)
				GetAxis/W=SpHrViewPeaksWindow/Q bottom
				BottomAxisMin=V_min; BottomAxisMax=V_max
			endif
		endif
		
		variable winN, winCnt = SpHrView_CountGroupWindows("OverTimeWin") // SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:OverTimeWin"
		winN = winCnt
		if(winCnt >= 1)
			winN = 1
		endif
		if(winN >= 1)
			winTop += (winN*hgt)
			if(winCnt > 0)
				winTop += 25*winCnt
			endif
		endif
		
		Display /K=1/W=(winleft, winTop, winleft+wdth, winTop+hgt) as WinTitleStr
		DoWindow/F/C $WinNameStr
		ModifyGraph/W=$WinNameStr margin(left)=marginleft,margin(bottom)=30,margin(top)=30,margin(right)=marginRight
		
		////////////////////////////
		/// Left (axis) Control Bar
		ControlBar/W=$WinNameStr/L 20 // same width as left control bar of SpHrViewPeaksWindow
		Button b_leftAxisAuto win=$WinNameStr, pos={2, 60}, title="",size={16,16},fSize=8,proc=AxisButtonProc,help={"auto scale"}
		Button b_leftAxisAuto win=$WinNameStr, picture=ProcGlobal#SpHrView_pict_GlassZoom
		Slider sl_YAxisRange win=$WinNameStr, pos={0,hgt/4},size={3,hgt/2},side=0,proc=SpHrView_OverTime_SliderProc
		Slider sl_YAxisRange win=$WinNameStr, help={"Adjust axis range"}
		// Slider sl_YAxisRange value and limits set below where axis range is set
		TitleBox t_holdYAxisRange win=$WinNameStr, title="🔒",pos={3,hgt-40},frame=0,fSize=12
		CheckBox ck_holdYAxisRange win=$WinNameStr, title="",fSize=14,fstyle=1,fColor=(65535,0,0),pos={4,hgt-25}
		CheckBox ck_holdYAxisRange win=$WinNameStr, side=0,variable=$globals_dfStr+"holdYAxisRange"
		CheckBox ck_holdYAxisRange win=$WinNameStr, proc=SpHrView_OverTime_CheckProc, help={"Hold Y-axis range"}
	
		
		/////////////////////////////////
		/// Top (#PCBar) Control Bar
		ControlBar/W=$WinNameStr /T 58  // 37
		NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PCBar

		// Top row controls
		variable leftPos = 15
		Button b_SpHrView_OverTime win=$WinNameStr+"#PCBar",pos={leftPos,15},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_OverTime
		Button b_SpHrView_OverTime win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_ButtonProc
	
		// Activities
		leftPos += 50
		GroupBox group_Activities win=$WinNameStr+"#PCBar", title="",fSize=10,pos={leftPos,6},size={200,22}
		leftPos += 5
		TitleBox t_Activities win=$WinNameStr+"#PCBar", title="Activities:",fSize=10,pos={leftPos,5},anchor=RC,frame=0
		leftPos += 60
		CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", title="Edges",fSize=10,pos={leftPos,7},side=0,value= DisplayActivitiesMode == 1
		CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 65
		CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", title="Maxima",fSize=10,pos={leftPos,7},side=0,value= DisplayActivitiesMode == 2
		CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		
		// Cues
		leftPos += 80
		GroupBox group_Cues win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={250,22}
		leftPos -= 10
		TitleBox t_Cues win=$WinNameStr+"#PCBar", title="Cues:",fSize=10,pos={leftPos,6},anchor=RC,frame=0
		leftPos += 60
		CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", title="Carrier",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 1
		CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 65
		CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", title="Envelope",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 2
		CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 75
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", title="Both",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 3
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", disable=0   ////////   disabled ?   ///////////
		

		// Bottom row Freqeuncy controls
		leftPos = 63
		TitleBox t_frequency win=$WinNameStr+"#PCBar",pos={leftPos,33},fSize=10,title="frequency (Hz)",frame=0
		leftPos += 80
		Slider sl_minPointFrequency win=$WinNameStr+"#PCBar",pos={leftPos,32},size={125,16},vert=0,side=0,limits={log(10),log(20000),1}
		// reset carrier or envelope limits after if-endif statement
		leftPos += 115
		SetVariable sv_minPointFrequency win=$WinNameStr+"#PCBar",title=" ",fstyle=1,size={71,15},pos={leftPos,32},bodyWidth=50,focusRing=0,value=$SpHrView_OverTime_DF_Globals+"minPointFrequency"
		SetVariable sv_minPointFrequency win=$WinNameStr+"#PCBar",limits={10,20000,1},fSize=10,proc=SpHrView_OverTime_SetVarProc
		leftPos += 55
		SetVariable sv_maxPointFrequency win=$WinNameStr+"#PCBar",title="\\f00to ",fstyle=1,size={89,15},pos={leftPos,32},bodyWidth=50,focusRing=0,value=$SpHrView_OverTime_DF_Globals+"maxPointFrequency"
		SetVariable sv_maxPointFrequency win=$WinNameStr+"#PCBar",limits={10,20000,1},fSize=10,proc=SpHrView_OverTime_SetVarProc
		leftPos += 95
		Slider sl_maxPointFrequency win=$WinNameStr+"#PCBar",pos={leftPos,32},size={125,16},vert=0,side=0,limits={log(10),log(20000),1}
		// reset carrier or envelope limits after if-endif statement
		
		
		//ColorTable
		leftPos += 140
		GroupBox group_PeaksColorTable win=$WinNameStr+"#PCBar", pos={leftPos,6},size={180.00, 45}
		leftPos += 10
		SetVariable sv_PeaksColorTable win=$WinNameStr+"#PCBar", pos={leftPos,9},size={142.00,14.00},bodyWidth=125,title="🎨"
		SetVariable sv_PeaksColorTable win=$WinNameStr+"#PCBar", fSize=10
		SetVariable sv_PeaksColorTable win=$WinNameStr+"#PCBar", value= $globals_dfStr+"PeaksColorTableStr"
		leftPos += 2
		SetVariable sv_PeaksColorTableAlpha win=$WinNameStr+"#PCBar",title="α",pos={leftPos,31},size={50,14},bodyWidth=40,focusRing=0,proc=SpHrView_OverTime_SetVarProc
		SetVariable sv_PeaksColorTableAlpha win=$WinNameStr+"#PCBar",variable = $SpHrView_OverTime_DF_Globals+"PeaksColorTableAlpha",format="%.1f",limits={0.1,1,0.1}
		SetVariable sv_PeaksColorTableAlpha win=$WinNameStr+"#PCBar", help={""}
		CheckBox ck_ReversePeaksColorTable win=$WinNameStr+"#PCBar", title="reverse",pos={leftPos,30},side=1, fSize=10
		CheckBox ck_ReversePeaksColorTable win=$WinNameStr+"#PCBar", variable= $globals_dfStr+"ReversePeaksColorTable",proc=SpHrView_OverTime_CheckProc
		leftPos += 57
		CheckBox ck_ReversePeaksColorTable win=$WinNameStr+"#PCBar", title="reverse",pos={leftPos,30},side=1, fSize=10
		CheckBox ck_ReversePeaksColorTable win=$WinNameStr+"#PCBar", variable= $globals_dfStr+"ReversePeaksColorTable",proc=SpHrView_OverTime_CheckProc
		leftPos += 60
		CheckBox ck_PeaksSolidMarker win=$WinNameStr+"#PCBar", title="filled",pos={leftPos,30},side=1, fSize=10
		CheckBox ck_PeaksSolidMarker win=$WinNameStr+"#PCBar", variable= $globals_dfStr+"PeaksSolidMarker",proc=SpHrView_OverTime_CheckProc
		leftPos += 25
		Button b_PeaksColorTable win=$WinNameStr+"#PCBar", pos={leftPos,9},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
		Button b_PeaksColorTable win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_ButtonProc
		
		// Peaks Marker Size  title="Marker Size"
		leftPos += 30
		GroupBox group_PeaksSizeMode win=$WinNameStr+"#PCBar",pos={leftPos,6},size={190.00, 45}
		leftPos += 15
		TitleBox t_markerSize win=$WinNameStr+"#PCBar",pos={leftPos,9},fSize=9,title="Marker Size",frame=0
		leftPos -= 5
		SetVariable sv_PeaksSizeMode win=$WinNameStr+"#PCBar", pos={leftPos,25},size={70.00,14.00},bodyWidth=70,title=" "
		SetVariable sv_PeaksSizeMode win=$WinNameStr+"#PCBar", fSize=10
		SetVariable sv_PeaksSizeMode win=$WinNameStr+"#PCBar", value= $globals_dfStr+"PeaksSizeModeStr"
		leftPos += 70
		Button b_PeaksSizeMode win=$WinNameStr+"#PCBar", pos={leftPos,25},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
		Button b_PeaksSizeMode win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_ButtonProc
		leftPos += 25
		NVAR ABL_Min = $SpHrView_OverTime_DF_Globals+"ABL_Min"
		SetVariable sv_PeakSize_ABL_Min win=$WinNameStr+"#PCBar",title="min (dB)",pos={leftPos,10},size={79,14},bodyWidth=35,focusRing=0,proc=SpHrView_OverTime_SetVarProc
		SetVariable sv_PeakSize_ABL_Min win=$WinNameStr+"#PCBar",variable = $SpHrView_OverTime_DF_Globals+"ABL_Min",format="%.0f",limits={ABL_Min-18,ABL_Min+18,3},disable=2
		SetVariable sv_PeakSize_ABL_Min win=$WinNameStr+"#PCBar",help={"ABL (dB) below which marker size is 0 points"}
		NVAR ABL_Max = $SpHrView_OverTime_DF_Globals+"ABL_Max"
		SetVariable sv_PeakSize_ABL_Max win=$WinNameStr+"#PCBar",title="max (dB)",pos={leftPos,30},size={79,14},bodyWidth=35,focusRing=0,proc=SpHrView_OverTime_SetVarProc
		SetVariable sv_PeakSize_ABL_Max win=$WinNameStr+"#PCBar",variable = $SpHrView_OverTime_DF_Globals+"ABL_Max",format="%.0f",limits={ABL_Max-18,ABL_Max+18,3},disable=2
		SetVariable sv_PeakSize_ABL_Max win=$WinNameStr+"#PCBar", help={"ABL (dB) above which marker size is 3 points"}
			
		// ⊘ at 'label' limits
		leftPos += 90
		GroupBox group_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar",pos={leftPos,6},size={160.00, 22}
		leftPos += 15
		//NVAR setPointsAtLimitsToNaN = $globals_dfStr+"setPointsAtLimitsToNaN"
		CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar",title=" ⊘ at 'label' limits",pos={leftPos,7},variable=$globals_dfStr+"setPointsAtLimitsToNaN"
		CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_CheckProc
		
		
		SetActiveSubwindow $WinNameStr //##
		//ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
	endif
	
	// swap if max < min
	NVAR minPointFrequency = $SpHrView_OverTime_DF_Globals+"minPointFrequency"
	NVAR maxPointFrequency = $SpHrView_OverTime_DF_Globals+"maxPointFrequency"
		
	if(maxPointFrequency < minPointFrequency)
		variable temp = maxPointFrequency
		maxPointFrequency = minPointFrequency
		minPointFrequency = temp
	endif
	
	NVAR minEnvelopeFreq = $SpHrView_OverTime_DF_Globals+"minEnvelopeFreq"
	NVAR maxCarrierFreq = $SpHrView_OverTime_DF_Globals+"maxCarrierFreq"
	NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
	NVAR highFreq= $SpHrView_df_filter+"highFreq"
	
	Slider sl_minPointFrequency win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_SliderProc,limits={log(lowFreq),log(highFreq),0.0001},value=log(minPointFrequency)
	Slider sl_maxPointFrequency win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_SliderProc,limits={log(lowFreq),log(highFreq),0.0001},value=log(maxPointFrequency)
	
	if(DisplayWaveformMode <= 1)
		
		minPointFrequency = limit(minPointFrequency, lowFreq, maxCarrierFreq)
		maxPointFrequency = limit(maxPointFrequency, lowFreq, maxCarrierFreq)
		
		SetVariable sv_minPointFrequency win=$WinNameStr+"#PCBar",limits={lowFreq,maxCarrierFreq,1}
		SetVariable sv_maxPointFrequency win=$WinNameStr+"#PCBar",limits={lowFreq,maxCarrierFreq,1}

		

	elseif(DisplayWaveformMode == 2) // Make sure Frequency > minEnvelopeFreq if displaying envelope cues
	
		minPointFrequency = limit(minPointFrequency, minEnvelopeFreq, highFreq)
		maxPointFrequency = limit(maxPointFrequency, minEnvelopeFreq, highFreq)
	
		SetVariable sv_minPointFrequency win=$WinNameStr+"#PCBar",limits={minEnvelopeFreq,highFreq,1}
		SetVariable sv_maxPointFrequency win=$WinNameStr+"#PCBar",limits={minEnvelopeFreq,highFreq,1}

	elseif(DisplayWaveformMode >= 3) // Make sure Frequency > minEnvelopeFreq if displaying both carrier and envelope cues
		
		minPointFrequency = limit(minPointFrequency, lowFreq, highFreq)
		maxPointFrequency = limit(maxPointFrequency, lowFreq, highFreq)
		
		SetVariable sv_minPointFrequency win=$WinNameStr+"#PCBar",limits={lowFreq,highFreq,1}
		SetVariable sv_maxPointFrequency win=$WinNameStr+"#PCBar",limits={lowFreq,highFreq,1}

	endif
	
	
	// kludge (part 1) for displaying carrier and envelope activities...
	int NumWaveformModes = 1
	if(DisplayWaveformMode == 3) // both Carrier and Envelope
		NumWaveformModes = 2
	endif
	int WaveformMode
	for(WaveformMode=0; WaveformMode < NumWaveformModes; WaveformMode++)
		if(NumWaveformModes > 1)
			if(WaveformMode == 0)
				DisplayWaveformMode=2
			else
				DisplayWaveformMode=1
			endif
		endif
		
	
		variable limitScale = 1
		String XsStr, NsStr
		if(DisplayActivitiesMode == 1 && DisplayWaveformMode==1)
			wave PointsWave = $SpHrView_OverTime_DF+"HalfmaximalActivityPoints"
			wave XsWave = $SpHrView_OverTime_DF+"Xs"
			wave NsWave = $SpHrView_OverTime_DF+"Ns"
			limitScale = 0.5
		elseif(DisplayActivitiesMode == 1 && DisplayWaveformMode==2)
			wave PointsWave = $SpHrView_OverTime_DF+"EnvelopeHalfmaximalActivityPoints"
			wave XsWave = $SpHrView_OverTime_DF+"EnvXs"
			wave NsWave = $SpHrView_OverTime_DF+"EnvNs"
			limitScale = 0.5
		elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==1)
			wave PointsWave = $SpHrView_OverTime_DF+"MaximalActivityPoints"
			wave XsWave = $SpHrView_OverTime_DF+"Xs"
			wave NsWave = $SpHrView_OverTime_DF+"Ns"
			limitScale = 1
		elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==2)
			wave PointsWave = $SpHrView_OverTime_DF+"EnvelopeMaximalActivityPoints"
			wave XsWave = $SpHrView_OverTime_DF+"EnvXs"
			wave NsWave = $SpHrView_OverTime_DF+"EnvNs"
			limitScale = 1
		endif
		
		
		String pointsStrL, pointsStrR
		wave/Z CFs = $SpHrView_df_filter+"CFs"
		SVAR PeaksColorTableStr = $globals_dfStr+"PeaksColorTableStr"
		NVAR ReversePeaksColorTable = $globals_dfStr+"ReversePeaksColorTable"
		//Variable r,g,b,a,err
	
		variable index, Hz
		Variable maxIndex = 1, minIndex = 0
		[index, Hz] = SpHrView_getCFindex(CFs, minPointFrequency)
		minIndex=index; minPointFrequency=Hz
		[index, Hz] = SpHrView_getCFindex(CFs, maxPointFrequency)
		maxIndex=index; maxPointFrequency=Hz
		
		SVAR PeaksSizeModeStr = $SpHrView_OverTime_DF_Globals+"PeaksSizeModeStr"
		NVAR ABLmin = $SpHrView_OverTime_DF_Globals+"ABL_Min"
		NVAR ABLmax = $SpHrView_OverTime_DF_Globals+"ABL_Max"

		int64 i, TraceCnt = 0
		for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			
			if(NsWave[i]>=3) // continue if not displaying >= 3 points
				
				if(DisplayWaveformMode==2)
					SPrintf pointsStrL, "L_%.0f_Env", CFs[i]
					SPrintf pointsStrR, "R_%.0f_Env", CFs[i]
				else
					SPrintf pointsStrL, "L_%.0f", CFs[i]
					SPrintf pointsStrR, "R_%.0f", CFs[i]
				endif
				
				AppendToGraph/W=$WinNameStr/L=left_L/B=bottom_L PointsWave[0,NsWave[i]][i][0][0]/TN=$pointsStrL vs XsWave[][i]
				AppendToGraph/W=$WinNameStr/L=left_R/B=bottom_R PointsWave[0,NsWave[i]][i][1][0]/TN=$pointsStrR vs XsWave[][i]
					
				SpHr_ColorTable/R=(ReversePeaksColorTable)/RGB={i, minIndex, maxIndex+1}	PeaksColorTableStr
				//r=V_R;g=V_G;b=V_B;a=V_A
				NVAR PeaksColorTableAlpha = $SpHrView_OverTime_DF_Globals+"PeaksColorTableAlpha"
								
				ModifyGraph/W=$WinNameStr rgb($pointsStrL)=(V_R,V_G,V_B,PeaksColorTableAlpha*65535)
				ModifyGraph/W=$WinNameStr rgb($pointsStrR)=(V_R,V_G,V_B,PeaksColorTableAlpha*65535)
				
				SetVariable sv_PeakSize_ABL_Min win=$WinNameStr+"#PCBar", disable=2
				SetVariable sv_PeakSize_ABL_Max win=$WinNameStr+"#PCBar", disable=2
				strswitch(PeaksSizeModeStr)
					case "1 point":
						break
					case "1.5 points":
						break
					case "2 points":
						break
		
					case "Activity":
						ModifyGraph/W=$WinNameStr zmrkSize($pointsStrL)={PointsWave[0,NsWave[i]][i][0][1],0,ScaledActivityLimit*limitScale,0,2}
						ModifyGraph/W=$WinNameStr zmrkSize($pointsStrR)={PointsWave[0,NsWave[i]][i][0][1],0,ScaledActivityLimit*limitScale,0,2}
						break
						
					case "ABL":
						if(DisplayWaveformMode == 2) // isEnv)
							Wave/Z ABLs = $SpHrView_OverTime_DF+"EnvABLs"
						else
							Wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
						endif
						if(waveexists(ABLs))
							ModifyGraph/W=$WinNameStr zmrkSize($pointsStrL)={ABLs[0,NsWave[i]][i],ABLmin,ABLmax,0.5,2}
							ModifyGraph/W=$WinNameStr zmrkSize($pointsStrR)={ABLs[0,NsWave[i]][i],ABLmin,ABLmax,0.5,2}
						endif
						SetVariable sv_PeakSize_ABL_Min win=$WinNameStr+"#PCBar", disable=0
						SetVariable sv_PeakSize_ABL_Max win=$WinNameStr+"#PCBar", disable=0
						break
				endswitch
				
				if(TraceCnt==0) // i==maxIndex)
					// Left
					ModifyGraph/W=$WinNameStr axisEnab(left_L)={0.52,1},freePos(left_L)=0
					ModifyGraph/W=$WinNameStr freePos(bottom_L)={0.52,kwFraction}
					ModifyGraph/W=$WinNameStr lblPos(left_L)=38
					ModifyGraph/W=$WinNameStr zero(left_L)=1
					ModifyGraph/W=$WinNameStr nticks(left_L)=6
					ModifyGraph/W=$WinNameStr  noLabel(bottom_L)=1
					Label/W=$WinNameStr bottom_L "\\u#2"
					// Right
					ModifyGraph/W=$WinNameStr axisEnab(left_R)={0,0.48},freePos(left_R)=0
					ModifyGraph/W=$WinNameStr freePos(bottom_R)={0,kwFraction}
					ModifyGraph/W=$WinNameStr lblPos(left_R)=38
					ModifyGraph/W=$WinNameStr zero(left_R)=1
					ModifyGraph/W=$WinNameStr nticks(bottom_R)=6
					ModifyGraph/W=$WinNameStr lblPos(bottom_R)=27
					Label/W=$WinNameStr bottom_R "time (\\U)"
				endif
				
				TraceCnt++
				
			else
				continue
				
			endif // if(NsWave[i]>=3) // continue if not displaying >= 3 points
				
		endfor	// for(i=maxIndex;i>=minIndex;--i)
		
	endfor //  for(WaveformMode=0; WaveformMode < NumWaveformModes; WaveformMode++)
	// kludge (part 2) for displaying carrier and envelope activities...
	if(NumWaveformModes > 1)	
		DisplayWaveformMode=3
	endif
	
	if(TraceCnt <= 0)
		DoAlert/T="Warning" 0, "No activity traces displayed! Check selected frequency ranges."
		return 0
	endif
	
	NVAR PeaksSolidMarker = $globals_dfStr+"PeaksSolidMarker"
	if(PeaksSolidMarker)
		ModifyGraph/W=$WinNameStr mode=3,marker=19
	else
		ModifyGraph/W=$WinNameStr mode=3,marker=8
	endif
	
	ModifyGraph/W=$WinNameStr mode=3
	strswitch(PeaksSizeModeStr)
		case "1 point":
			ModifyGraph/W=$WinNameStr msize=1
			break
		case "1.5 points":
			ModifyGraph/W=$WinNameStr msize=1.5
			break
		case "2 points":
			ModifyGraph/W=$WinNameStr msize=2
			break
		default:
			ModifyGraph/W=$WinNameStr msize=2
			break
	endswitch
	
	ModifyGraph/W=$WinNameStr tick=2, mirror=0
	ModifyGraph/W=$WinNameStr font="Arial", fSize=10, lblMargin=2
	ModifyGraph/W=$WinNameStr standoff=0, axThick=0.5
	ModifyGraph/W=$WinNameStr ZisZ=1, zapTZ=1, zapLZ=1
	ModifyGraph/W=$WinNameStr btLen=4, btThick=0.5, stLen=2, stThick=0.5
	
	// no bottom_L axis
	ModifyGraph/W=$WinNameStr tick(bottom_L)=3,noLabel(bottom_L)=2,axThick(bottom_L)=0
	
	SetAxis/W=$WinNameStr bottom_L BottomAxisMin,BottomAxisMax
	SetAxis/W=$WinNameStr bottom_R BottomAxisMin,BottomAxisMax
	
	NVAR holdYAxisRange = $SpHrView_OverTime_DF_Globals+"holdYAxisRange"
	NVAR heldYAxisRange = $SpHrView_OverTime_DF_Globals+"heldYAxisRange"
	
	String YUnitsStr = WaveUnits(PointsWave, -1)//1)
	SpHrView_OverTime_YAxisSet(WinNameStr, YUnitsStr, minPointFrequency, minIndex)
	
	// Color scale bar
	if(TraceCnt > 10)
		ColorScaleLookUp(SpHrView_OverTime_DF_Globals, "FrequencyColorScaleLookUp", minPointFrequency, maxPointFrequency, CFs)
		wave FrequencyColorScaleLookUp = $SpHrView_OverTime_DF_Globals+"FrequencyColorScaleLookUp"
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt/F=0/B=1/A=MT/E=2/X=-2.0/Y=0.00 vert=0,width=300,height=6,frame=0.00,log=0
		if(FindListItem(PeaksColorTableStr, CTabList()) >= 0)
			ColorScale/W=$WinNameStr/C/N=TraceColorsTxt side=1, ctab={minPointFrequency,maxPointFrequency,$PeaksColorTableStr,ReversePeaksColorTable},font="Arial",fsize=9,nticks=5, lookup=$SpHrView_OverTime_DF_Globals+"FrequencyColorScaleLookUp"
		elseif(WaveExists($SpHrView_OverTime_DF_Globals+PeaksColorTableStr))
			ColorScale/W=$WinNameStr/C/N=TraceColorsTxt side=1, ctab={minPointFrequency,maxPointFrequency,$SpHrView_OverTime_DF_Globals+PeaksColorTableStr,ReversePeaksColorTable},font="Arial",fsize=9,nticks=5, lookup=$SpHrView_OverTime_DF_Globals+"FrequencyColorScaleLookUp"
		else
			SpHr_ColorTable/Dest=$SpHrView_OverTime_DF_Globals+PeaksColorTableStr PeaksColorTableStr
			ColorScale/W=$WinNameStr/C/N=TraceColorsTxt side=1, ctab={minPointFrequency,maxPointFrequency,$SpHrView_OverTime_DF_Globals+PeaksColorTableStr,ReversePeaksColorTable},font="Arial",fsize=9,nticks=5, lookup=$SpHrView_OverTime_DF_Globals+"FrequencyColorScaleLookUp"
		endif
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt tickLen=3.00,tickThick=0.5,ZisZ=1,lblMargin=18, lblLatPos=-200, tickLblRot=35
		ColorScale/W=$WinNameStr/C/N=TraceColorsTxt "\\F'Arial'\\Z10frequency (Hz)"
	// Legend
	else
		TraceListStr = TraceNameList(WinNameStr,";",1)
		String LegendStr = "\\Z10\\F'Arial'frequency (Hz)   "
		String str
		TraceCnt = 0 
		for(i=minIndex;i<=maxIndex;++i)	// low to high frequencies (high on top)
		//for(i=maxIndex;i>=minIndex;--i) 	// high to low frequencies (low on top)
			if(DisplayWaveformMode==2)
				SPrintf str, "L_%.0f_Env", CFs[i]
			else
				SPrintf str, "L_%.0f", CFs[i]
			endif
			if(FindListItem(str,TraceListStr,";",0) >= 0)  // increment 0?
				LegendStr += "\\s("+str+")"+num2str(CFs[i])+"  " // ModifyGraph mode=3,marker=19,msize=2,rgb($wStr)=(r,g,b)
				TraceCnt += 1	
			endif		
		endfor
		Legend/W=$WinNameStr/C/N=TraceColorsTxt/J/F=0/B=1/E=0/A=MT/X=0.00/Y=-6.00 LegendStr
	endif

	if(!WindowExists)
		SetWindow $WinNameStr, hook(OverTimeHook)=SpHrView_OverTime_WindowHook
		SetWindow $WinNameStr note = "PACKAGE:SpHrView;GROUP:OverTimeWin;"
	endif
	
	SetDataFolder saveDFR
	return 0
End


Function SpHrView_OverTime_FreqImageWindow()

	DFREF saveDFR = GetDataFolderDFR()
	string globals_dfStr = SpHrView_OverTime_DF_Globals

	// ScaledCarrierActivityLimit and ScaledEnvelopeActivityLimit should both equal ActivityLimit ...
	// unless CPC was set to > 1 in operations SpHr_CrossingCarrierCues or SpHr_CrossingEnvelopeCues ...
	// and SpHr_RepOverTime
	NVAR ScaledCarrierActivityLimit = $globals_dfStr+"ScaledCarrierActivityLimit"
	NVAR ScaledEnvelopeActivityLimit = $globals_dfStr+"ScaledEnvelopeActivityLimit"
	variable ScaledActivityLimit = ScaledCarrierActivityLimit // default, reset below
	
	NVAR useCarrierCues = $globals_dfStr+"useCarrierCues"
	NVAR useEnvelopeCues = $globals_dfStr+"useEnvelopeCues"
	NVAR getEdges = $globals_dfStr+"getEdges"
	NVAR getMaxima = $globals_dfStr+"getMaxima"
	
	NVAR AlphaMask_ABL = $globals_dfStr+"AlphaMask_ABL"
	int overlayAlpha = AlphaMask_ABL
	String leftAlphaStr, rightAlphaStr
	
	String WinTitleStr = "Over Time Activities"
	String WinNameStr = cleanupName(WinTitleStr,0)
	String wStr, wStrL, wStrR, XEdgesStr, YEdgesStr
	String PeaksWaveStr="", PeaksWaveXsStr="", LeftPeaksStr, RightPeaksStr
	String dfStr
	variable useHalfmaxLookup = 0
	
	// DisplayActivitiesMode 1:Halfmaximal, 2: Maximal  ( no SD: 1)
	// DisplayWaveformMode 1: Carrier, 2: Envelope, 3: Carrier and Envelope
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
	NVAR DisplayWaveformMode = $globals_dfStr+"DisplayWaveformMode"
	
	// Not using combined yet
//	if(DisplayWaveformMode > 2)
//		DisplayActivitiesMode = 1
//	endif
	
	// default modes
	if(DisplayActivitiesMode <= 0)
		DisplayActivitiesMode = 1
	endif
	if(DisplayWaveformMode <= 0)
		DisplayWaveformMode = 1
	endif
		
	// Make sure Frequency value is found in CFs wave
	wave/Z CFs = $SpHrView_df_filter+"CFs"
	NVAR Frequency = $globals_dfStr+"Frequency"
	NVAR FrequencyIndex = $globals_dfStr+"FrequencyIndex"
	FindValue /T=0.1 /V=(Frequency)/Z CFs
	if(V_value < 0 || Frequency != CFs[FrequencyIndex])
		FrequencyIndex = SetVarProcIndex(CFs, Frequency, 1)
		Frequency = CFs[FrequencyIndex]
	endif
	
	NVAR maxCarrierFreq = $globals_dfStr+"maxCarrierFreq"
	NVAR minEnvelopeFreq = $globals_dfStr+"minEnvelopeFreq"
	
	SetVariable/Z sv_Frequency win=$WinNameStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(0,0,0),valueColor=(0,0,0)
	if(Frequency > maxCarrierFreq)
		if(DisplayWaveformMode != 2)
			SetVariable/Z sv_Frequency win=$WinNameStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(65535,0,0),valueColor=(65535,0,0)
		endif
		DisplayWaveformMode = 2
	elseif(Frequency < minEnvelopeFreq)
		if(DisplayWaveformMode != 1)
			SetVariable/Z sv_Frequency win=$WinNameStr+"#PCBar",title="\\f00frequency (Hz)",fColor=(65535,0,0),valueColor=(65535,0,0)
		endif
		DisplayWaveformMode = 1
	endif
	
	if(DisplayWaveformMode <= 1) // Make sure Frequency < maxCarrierFreq if displaying carrier cues
		if(Frequency > maxCarrierFreq)
			FrequencyIndex = floor(BinarySearchInterp(CFs, maxCarrierFreq)) // SetVarProcIndex(CFs, maxCarrierFreq, 1)
			Frequency = CFs[FrequencyIndex]
		endif
	elseif(DisplayWaveformMode == 2) // Make sure Frequency > minEnvelopeFreq if displaying envelope cues or both carrier and envelope cues
		if(Frequency < minEnvelopeFreq)
			FrequencyIndex = ceil(BinarySearchInterp(CFs, minEnvelopeFreq)) // SetVarProcIndex(CFs, minEnvelopeFreq, 1)
			Frequency = CFs[FrequencyIndex]
		endif
	elseif(DisplayWaveformMode >= 3)
		if(Frequency < minEnvelopeFreq)
			FrequencyIndex = floor(BinarySearchInterp(CFs, maxCarrierFreq)) // SetVarProcIndex(CFs, maxCarrierFreq, 1)
			FrequencyIndex = ceil(BinarySearchInterp(CFs, minEnvelopeFreq)) // SetVarProcIndex(CFs, minEnvelopeFreq, 1)
			Frequency = CFs[FrequencyIndex]
		endif
	endif
	
	if(DisplayActivitiesMode == 1 && DisplayWaveformMode==1)
		if(!useCarrierCues || !getEdges)
			Print "Error in SpHrView_OverTime_FreqImageWindow()"; return 0
		endif
	elseif(DisplayActivitiesMode == 1 && DisplayWaveformMode==2)
		if(!useEnvelopeCues || !getEdges)
			Print "Error in SpHrView_OverTime_FreqImageWindow()"; return 0
		endif
	
	elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==1)
		if(!useEnvelopeCues || !getMaxima)
			Print "Error in SpHrView_OverTime_FreqImageWindow()"; return 0
		endif
	elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==2)
		if(!useEnvelopeCues || !getMaxima)
			Print "Error in SpHrView_OverTime_FreqImageWindow()"; return 0
		endif
	endif
	
	Variable BottomAxisMin, BottomAxisMax
	
	NVAR holdYAxisRange = $SpHrView_OverTime_DF_Globals+"holdYAxisRange"
	NVAR heldYAxisRange = $SpHrView_OverTime_DF_Globals+"heldYAxisRange"
	
	WinNameStr = cleanupName(WinTitleStr,0)
	DoWindow $WinNameStr
	variable WindowExists = V_flag
	String traceListStr
	///////// remove traces and images if window already wexists /////
	if(WindowExists)
	
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			GetAxis/W=SpHrViewPeaksWindow/Q bottom
			BottomAxisMin=V_min; BottomAxisMax=V_max
		endif
		
		RemoveTraces(WinNameStr)
		RemoveImages(WinNameStr)
		
	else
	///////// Display new window with controls /////
		NVAR screenHoriz= $SpHrView_df_globals+"screenHoriz"
		NVAR screenVert= $SpHrView_df_globals+"screenVert"
		NVAR ViewWidthProportion= $SpHrView_df_globals+"ViewWidthProportion"
		NVAR ViewHeightProportion= $SpHrView_df_globals+"ViewHeightProportion"
		variable wdth=screenHoriz*ViewWidthProportion
		variable hgt = screenVert*ViewHeightProportion*2.5
		Variable  winleft=(screenHoriz/6), winRight, winTop=400, winBottom=270
		DoWindow SpHrViewPeaksWindow
		if(V_flag)
			[winleft, winRight, winTop, winBottom] = getWindowSize("SpHrViewPeaksWindow")
			winleft = winleft
			winTop = winBottom+25
			Variable marginleft, marginRight, marginTop, marginBottom
			[marginleft, marginRight, marginTop, marginBottom] = getWindowMargins("SpHrViewPeaksWindow")	
			
			GetAxis/W=SpHrViewPeaksWindow/Q bottom
			BottomAxisMin=V_min; BottomAxisMax=V_max
		endif
		
		variable winN, winCnt = SpHrView_CountGroupWindows("OverTimeWin") // SetWindow $WinNameStr note="PACKAGE:SpHrView;GROUP:OverTimeWin"
		winN = winCnt
		if(winCnt >= 1)
			winN = 1
		endif
		if(winN >= 1)
			winTop += (winN*hgt)
			if(winCnt > 0)
				winTop += 25*winCnt
			endif
		endif
		
		Display /K=1/W=(winleft, winTop, winleft+wdth, winTop+hgt) as WinTitleStr
		DoWindow/F/C $WinNameStr
		ModifyGraph/W=$WinNameStr margin(left)=marginleft,margin(bottom)=30,margin(top)=25,margin(right)=marginRight
		
		////////////////////////////
		/// Left (axis) Control Bar
		ControlBar/W=$WinNameStr/L 20 // same width as left control bar of SpHrViewPeaksWindow
		Button b_leftAxisAuto win=$WinNameStr, pos={2, 60}, title="",size={16,16},fSize=8,proc=AxisButtonProc,help={"auto scale"}
		Button b_leftAxisAuto win=$WinNameStr, picture=ProcGlobal#SpHrView_pict_GlassZoom
		Slider sl_YAxisRange win=$WinNameStr, pos={0,hgt/4},size={3,hgt/2},side=0,proc=SpHrView_OverTime_SliderProc
		Slider sl_YAxisRange win=$WinNameStr, help={"Adjust axis range"}
		// Slider sl_YAxisRange value and limits set below where axis range is set
		TitleBox t_holdYAxisRange win=$WinNameStr, title="🔒",pos={3,hgt-40},frame=0,fSize=12
		CheckBox ck_holdYAxisRange win=$WinNameStr, title="",fSize=14,fstyle=1,fColor=(65535,0,0),pos={4,hgt-25}
		CheckBox ck_holdYAxisRange win=$WinNameStr, side=0,variable=$SpHrView_OverTime_DF_Globals+"holdYAxisRange"
		CheckBox ck_holdYAxisRange win=$WinNameStr, proc=SpHrView_OverTime_CheckProc, help={"Hold Y-axis range"}
	
		/////////////////////////////////
		/// Top (#PCBar) Control Bar
		ControlBar/W=$WinNameStr /T 58
		NewPanel/HOST=$WinNameStr/FG=(FL,FT,GR,GT)/HOST=# 
		RenameWindow #,PCBar

		// Top row controls
		variable leftPos = 15
		Button b_SpHrView_OverTime win=$WinNameStr+"#PCBar",pos={leftPos,15},size={(25/15)*20,20}, title="",picture=ProcGlobal#SpHrView_pict_OverTime
		Button b_SpHrView_OverTime win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_ButtonProc
	
		// Activities
		leftPos += 50
		GroupBox group_Activities win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={190,22}
		leftPos += 5
		TitleBox t_Activities win=$WinNameStr+"#PCBar", title="Activities:",fSize=10,pos={leftPos,5},anchor=RC,frame=0
		leftPos += 60
		CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", title="Edges",fSize=10,pos={leftPos,7},side=0,value= DisplayActivitiesMode == 1
		CheckBox ck_DisplayEdges win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 57
		CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", title="Maxima",fSize=10,pos={leftPos,7},side=0,value= DisplayActivitiesMode == 2
		CheckBox ck_DisplayMaxima win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		
		// Cues
		leftPos += 75
		GroupBox group_Cues win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={235,22}
		leftPos -= 10
		TitleBox t_Cues win=$WinNameStr+"#PCBar", title="Cues:",fSize=10,pos={leftPos,6},anchor=RC,frame=0
		leftPos += 60
		CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", title="Carrier",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 1
		CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 60
		CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", title="Envelope",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 2
		CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		leftPos += 70
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", title="Both",fSize=10,pos={leftPos,7},side=0,value= DisplayWaveformMode == 3
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar", disable=0   ////////   no longer disabled ?  ///////////
		
		// Append Freqeuncy 'peaks'
		leftPos += 65
		GroupBox group_AppendPeaks win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={220,45}
		leftPos += 10
		CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", title="Append 'peaks'",pos={leftPos,7},variable=$SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
		CheckBox ck_AppendPeaks win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		
		CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", title="append opposite",pos={leftPos,27},variable=$SpHrView_OverTime_DF_Globals+"appendPeaksToImageOppositeHemi"
		CheckBox ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={"Append 'peaks' from opposite hemisphere"}
		
		leftPos += 105
		CheckBox ck_PeaksAreABLSized win=$WinNameStr+"#PCBar", title="size ∝ ABL ",pos={leftPos,7},variable=$SpHrView_OverTime_DF_Globals+"PeaksAreABLSized"
		CheckBox ck_PeaksAreABLSized win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={"Marker size determined by ABL (dB) as opposed to activity level"}
	
		CheckBox ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar", title="⊘ at 'label' limits",pos={leftPos,27},variable=$SpHrView_OverTime_DF_Globals+"setPointsAtLimitsToNaN"
		CheckBox ck_setPointsAtLimitsToNaN  win=$WinNameStr+"#PCBar", help={"Remove 'peaks' at label limits (set values to NaN"},proc=SpHrView_OverTime_CheckProc
		
		NVAR appendPeaksToImage = $SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
		if(appendPeaksToImage)
			CheckBox/Z ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar",disable=0
			CheckBox/Z ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar",disable=0
			CheckBox/Z ck_PeaksAreABLSized win=$WinNameStr+"#PCBar",disable=0
		else
			CheckBox/Z ck_setPointsAtLimitsToNaN win=$WinNameStr+"#PCBar",disable=2
			CheckBox/Z ck_AppendPeaksOppositeHemi win=$WinNameStr+"#PCBar",disable=2
			CheckBox/Z ck_PeaksAreABLSized win=$WinNameStr+"#PCBar",disable=2
		endif
		
		// Append ABL Mask
		leftPos += 110
		GroupBox group_AlphaMask win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={180,45}
		leftPos += 40
		CheckBox ck_AlphaMask win=$WinNameStr+"#PCBar", title="ABL Transparency",pos={leftPos,7},side=0,variable = $SpHrView_OverTime_DF_Globals+"AlphaMask_ABL"
		CheckBox ck_AlphaMask win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		// ABL Mask settings
		leftPos -= 25
		SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",title="min (dB)",pos={leftPos,28},size={72,14},bodyWidth=35,focusRing=0,proc=SpHrView_OverTime_SetVarProc
		SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",variable = $SpHrView_OverTime_DF_Globals+"ABL_Min",format="%.0f",limits={0,120,3}
		SetVariable sv_AlphaMask_ABL_Min win=$WinNameStr+"#PCBar",help={"ABL (dB) below which the appended masking image is opaque (white)"}
		leftPos += 70
		SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar",title="max (dB)",pos={leftPos,28},size={90,14},bodyWidth=35,focusRing=0,proc=SpHrView_OverTime_SetVarProc
		SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar",variable = $SpHrView_OverTime_DF_Globals+"ABL_Max",format="%.0f",limits={1,120,3}
		SetVariable sv_AlphaMask_ABL_Max win=$WinNameStr+"#PCBar", help={"ABL (dB) above which the appended masking image is transparent"}
			
		//ColorTable
		leftPos += 100
		GroupBox group_ColorTable win=$WinNameStr+"#PCBar", pos={leftPos,6},size={175.00, 45}
		leftPos += 5
		SetVariable sv_ColorTable win=$WinNameStr+"#PCBar", pos={leftPos,9},size={142.00,14.00},bodyWidth=125,title="🎨"
		SetVariable sv_ColorTable win=$WinNameStr+"#PCBar", fSize=10
		SetVariable sv_ColorTable win=$WinNameStr+"#PCBar", value= $globals_dfStr+"ColorTableStr"
		leftPos += 35
		CheckBox ck_ReverseColorTable win=$WinNameStr+"#PCBar", title="reverse colors ",pos={leftPos,28},side=1, fSize=10
		CheckBox ck_ReverseColorTable win=$WinNameStr+"#PCBar", variable= $globals_dfStr+"ReverseColorTable",proc=SpHrView_OverTime_CheckProc
		leftPos += 110
		Button b_ColorTable win=$WinNameStr+"#PCBar", pos={leftPos,9},picture=ProcGlobal#SpHrView_pict_PopUpList, size={15.00,16.00},title=""
		Button b_ColorTable win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_ButtonProc
		
		// AppendWaves
		leftPos += 50
		GroupBox group_AppendWaves win=$WinNameStr+"#PCBar", title="",pos={leftPos,6},size={135,25}
		leftPos += 15
		CheckBox ck_AppendWaves win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", title="Append waveforms",pos={leftPos,7},side=0,variable = $SpHrView_OverTime_DF_Globals+"AppendWaves"
		CheckBox ck_AppendWaves win=$WinNameStr+"#PCBar", proc=SpHrView_OverTime_CheckProc, help={""}
		
		
		// Bottom row Freqeuncy controls
		leftPos = 75
		Slider sl_Frequency win=$WinNameStr+"#PCBar",pos={leftPos,32},size={270,16},vert=0,side=0,limits={log(20),log(20000),0.0001},value=log(Frequency)
		// reset carrier or envelope limits after if-endif statement
		leftPos += 285
		SetVariable sv_Frequency win=$WinNameStr+"#PCBar",title="\\f00frequency (Hz)",fstyle=1,size={126,15},pos={leftPos,32},bodyWidth=50,focusRing=0,value=$SpHrView_OverTime_DF_Globals+"Frequency"
		SetVariable sv_Frequency win=$WinNameStr+"#PCBar",limits={10,20000,1},fSize=10,proc=SpHrView_OverTime_SetVarProc
		// reset carrier or envelope limits after if-endif statement

		
		SetActiveSubwindow $WinNameStr //##
		//ModifyGraph/W=$WinNameStr cbRGB=(65534,65534,65534)
	endif
	
	NVAR lowFreq= $SpHrView_df_filter+"lowFreq"
	NVAR highFreq= $SpHrView_df_filter+"highFreq"
	
	CheckBox ck_DisplayCarrierActivities win=$WinNameStr+"#PCBar", win=$WinNameStr+"#PCBar", value= DisplayWaveformMode == 1	
	CheckBox ck_DisplayEnvelopeActivities win=$WinNameStr+"#PCBar", value= DisplayWaveformMode == 2
	CheckBox ck_DisplayCombinedActivities win=$WinNameStr+"#PCBar",value= DisplayWaveformMode == 3
	
	if(DisplayWaveformMode <= 1)
		SetVariable sv_Frequency win=$WinNameStr+"#PCBar",limits={lowFreq,maxCarrierFreq,1}
		Slider sl_Frequency win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_SliderProc,limits={log(lowFreq),log(maxCarrierFreq),0.0001},value=log(Frequency)
	elseif(DisplayWaveformMode == 2) // Make sure Frequency > minEnvelopeFreq if displaying envelope cues
		SetVariable sv_Frequency win=$WinNameStr+"#PCBar",limits={minEnvelopeFreq,highFreq,1}
		Slider sl_Frequency win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_SliderProc,limits={log(minEnvelopeFreq),log(highFreq),0.0001},value=log(Frequency)
	elseif(DisplayWaveformMode >= 3) // Make sure Frequency > minEnvelopeFreq if displaying both carrier and envelope cues
		SetVariable sv_Frequency win=$WinNameStr+"#PCBar",limits={minEnvelopeFreq,maxCarrierFreq,1}
		Slider sl_Frequency win=$WinNameStr+"#PCBar",proc=SpHrView_OverTime_SliderProc,limits={log(minEnvelopeFreq),log(maxCarrierFreq),0.0001},value=log(Frequency)
	endif
	
	SVAR ColorTableStr = $SpHrView_OverTime_DF_Globals+"ColorTableStr"
	NVAR ReverseColorTable = $SpHrView_OverTime_DF_Globals+"ReverseColorTable"
		
	SpHr_ColorTable/R=(ReverseColorTable)/Dest=$SpHrView_OverTime_DF+"ColorTable" ColorTableStr 
	wave ColorTable=$SpHrView_OverTime_DF+"ColorTable"
	
	Variable pnt_R=0, pnt_G=0, pnt_B=0
	NVAR appendPeaksToImage = $SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
	if(appendPeaksToImage)
		//Printf "%g, %g, %g\r", ColorTable[dimsize(ColorTable,0)-1][0], ColorTable[dimsize(ColorTable,0)-1][1], ColorTable[dimsize(ColorTable,0)-1][2]
		variable rgbSum = ColorTable[dimsize(ColorTable,0)-1][0]+ColorTable[dimsize(ColorTable,0)-1][1]+ColorTable[dimsize(ColorTable,0)-1][2]
		if(rgbSum > 30000)
			pnt_R=0; pnt_G=0; pnt_B=0
		else
			pnt_R=65535; pnt_G=65535; pnt_B=65535
		endif
		// inverse of last color
		//pnt_R = 65535 - ColorTable[dimsize(ColorTable,0)-1][0]
		//pnt_G = 65535 - ColorTable[dimsize(ColorTable,0)-1][1]
		//pnt_B = 65535 - ColorTable[dimsize(ColorTable,0)-1][2]
		//Printf "%g, %g, %g\r", pnt_R, pnt_G, pnt_B
	endif
	
	//if(AlphaMask_ABL)
		SpHr_ColorTable/Dest=$SpHrView_OverTime_DF+"AlphaColorTable"/M=(65535)/A={0,1} "Solid"
		wave AlphaColorTable=$SpHrView_OverTime_DF+"AlphaColorTable"
	//endif
	
	// kludge (part 1) for displaying carrier and envelope activities...
	int NumWaveformModes = 1
	if(DisplayWaveformMode == 3) // both Carrier and Envelope
		NumWaveformModes = 2
	endif
	int WaveformMode
	for(WaveformMode=0; WaveformMode < NumWaveformModes; WaveformMode++)
		if(NumWaveformModes > 1)
			if(WaveformMode == 0)
				DisplayWaveformMode=2
			else
				DisplayWaveformMode=1
			endif
		endif
		
		if(DisplayActivitiesMode == 1 && DisplayWaveformMode==1)
			SPrintf wStrL, "ActivityHalfMaxima_%.0f_Hz_left", Frequency
			SPrintf wStrR, "ActivityHalfMaxima_%.0f_Hz_right", Frequency
			dfStr = "ActivityHalfMaxima:"
			useHalfmaxLookup = 1	// should be 1
			ScaledActivityLimit = ScaledCarrierActivityLimit
			// Y axis edges
			YEdgesStr = "HalfMaxLabels" // Y-axis edges // YEdges DF
			// Peaks
			PeaksWaveStr = "HalfmaximalActivityPoints"
			PeaksWaveXsStr = "Xs"
			LeftPeaksStr = "LeftCarrierPeaks"
			RightPeaksStr = "RightCarrierPeaks"
			// ABL Mask
			SPrintf leftAlphaStr, "MaskActivityHalfMaxima_%.0f_Hz_left", Frequency
			SPrintf rightAlphaStr, "MaskActivityHalfMaxima_%.0f_Hz_right", Frequency
			
		elseif(DisplayActivitiesMode == 1 && DisplayWaveformMode==2)
			SPrintf wStrL, "EnvelopeActivityHalfMaxima_%.0f_Hz_left", Frequency
			SPrintf wStrR, "EnvelopeActivityHalfMaxima_%.0f_Hz_right", Frequency
			dfStr = "EnvelopeActivityHalfMaxima:"
			useHalfmaxLookup = 1	// should be 1
			ScaledActivityLimit = ScaledCarrierActivityLimit
			// Y axis edges
			YEdgesStr = "HalfMaxLabels" // Y-axis edges  // EnvelopeYEdges DF
			// Peaks
			PeaksWaveStr = "EnvelopeHalfmaximalActivityPoints"
			PeaksWaveXsStr = "EnvXs"
			LeftPeaksStr = "LeftEnvelopePeaks"
			RightPeaksStr = "RightEnvelopePeaks"
			// ABL Mask
			SPrintf leftAlphaStr, "MaskEnvelopeActivityHalfMaxima_%.0f_Hz_left", Frequency
			SPrintf rightAlphaStr, "MaskEnvelopeActivityHalfMaxima_%.0f_Hz_right", Frequency
			
		elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==1)
			SPrintf wStrL, "ActivityMaxima_%.0f_Hz_left", Frequency
			SPrintf wStrR, "ActivityMaxima_%.0f_Hz_right", Frequency
			dfStr = "ActivityMaxima:"
			useHalfmaxLookup = 0
			ScaledActivityLimit = ScaledCarrierActivityLimit
			// Y axis edges
			YEdgesStr = "MaxLabels" // Y-axis edges  // EnvelopeYEdges DF
			// Peaks
			PeaksWaveStr = "MaximalActivityPoints"
			PeaksWaveXsStr = "Xs"
			LeftPeaksStr = "LeftCarrierPeaks"
			RightPeaksStr = "RightCarrierPeaks"
			// ABL Mask
			SPrintf leftAlphaStr, "MaskActivityMaxima_%.0f_Hz_left", Frequency
			SPrintf rightAlphaStr, "MaskActivityMaxima_%.0f_Hz_right", Frequency
			
		elseif(DisplayActivitiesMode == 2 && DisplayWaveformMode==2)
			SPrintf wStrL, "EnvelopeActivityMaxima_%.0f_Hz_left", Frequency
			SPrintf wStrR, "EnvelopeActivityMaxima_%.0f_Hz_right", Frequency
			dfStr = "EnvelopeActivityMaxima:"
			useHalfmaxLookup = 0
			ScaledActivityLimit = ScaledCarrierActivityLimit
			// Y axis edges
			YEdgesStr = "MaxLabels" // Y-axis edges  // EnvelopeYEdges DF
			// Peaks
			PeaksWaveStr = "EnvelopeMaximalActivityPoints"
			PeaksWaveXsStr = "EnvXs"
			LeftPeaksStr = "LeftEnvelopePeaks"
			RightPeaksStr = "RightEnvelopePeaks"
			// ABL Mask
			SPrintf leftAlphaStr, "MaskEnvelopeActivityMaxima_%.0f_Hz_left", Frequency
			SPrintf rightAlphaStr, "MaskEnvelopeActivityMaxima_%.0f_Hz_right", Frequency
						
		endif
		
		if(useHalfmaxLookup)
			SpHr_ColorTable/Dest=M_colors ColorTableStr  // =$SpHrView_OverTime_DF+"ColorTableLookup"
			Make/O/N=(dimsize(M_colors,0)) $SpHrView_OverTime_DF+"ColorTableLookup" = 1; killwaves/z M_colors
			wave ColorTableLookup = $SpHrView_OverTime_DF+"ColorTableLookup"
			WindowFunction Bartlet, ColorTableLookup
		endif
	
		wave/Z WL = $SpHrView_OverTime_DF+dfStr+wStrL
		wave/Z WR = $SpHrView_OverTime_DF+dfStr+wStrR
		if(!waveexists(WL) || !waveexists(WR))
			DoAlert/T="Warning" 0, "Wave: "+SpHrView_OverTime_DF+dfStr+wStrL+" or "+SpHrView_OverTime_DF+dfStr+wStrR+" is missing."
			return 0
		endif
		
	
		if(DisplayWaveformMode == 1)
			SPrintf XEdgesStr, "XEdges_%.0f_Hz", Frequency
			wave XEdges = $SpHrView_OverTime_DF+"XEdges:"+XEdgesStr
		elseif(DisplayWaveformMode == 2)
			SPrintf XEdgesStr, "EnvelopeXEdges_%.0f_Hz", Frequency
			wave XEdges = $SpHrView_OverTime_DF+"EnvelopeXEdges:"+XEdgesStr
		endif
		
		
		NVAR ABLmin = $SpHrView_OverTime_DF_Globals+"ABL_Min"
		NVAR ABLmax = $SpHrView_OverTime_DF_Globals+"ABL_Max"
		
		////// Left
		if(waveexists(WL))
			AppendImage/W=$WinNameStr /G=1/L=left_L/B=bottom_L WL vs {XEdges, *} // /G to suppress rgb(t)
		
			ModifyImage/W=$WinNameStr $wStrL ctab= {0,(ScaledActivityLimit),ColorTable,0},ctabAutoscale=3,lookup= $""
			if(useHalfmaxLookup)
				ModifyImage/W=$WinNameStr $wStrL lookup=ColorTableLookup
			endif
			ModifyGraph/W=$WinNameStr axisEnab(left_L)={0.52,1},freePos(left_L)=0
			ModifyGraph/W=$WinNameStr freePos(bottom_L)={0.52,kwFraction}
		
			ModifyGraph/W=$WinNameStr lblPos(left_L)=38
			ModifyGraph/W=$WinNameStr zero(left_L)=1
			
			// Peaks
			wave Peaks = $SpHrView_OverTime_DF+PeaksWaveStr
			wave PeakXs = $SpHrView_OverTime_DF+PeaksWaveXsStr
			NVAR appendPeaksToImage = $SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
			NVAR PeaksAreABLSized = $SpHrView_OverTime_DF_Globals+"PeaksAreABLSized"
			if(appendPeaksToImage && waveexists(Peaks))  
				AppendToGraph/W=$WinNameStr/L=left_L/B=bottom_L Peaks[][FrequencyIndex][0]/TN=$LeftPeaksStr vs PeakXs[][FrequencyIndex]  // /VERT  /L=left_R
				ModifyGraph/W=$WinNameStr mode($LeftPeaksStr)=3,marker($LeftPeaksStr)=19
				ModifyGraph/W=$WinNameStr mrkThick($LeftPeaksStr)=0.5,msize($LeftPeaksStr)=2,rgb($LeftPeaksStr)=(pnt_R,pnt_G,pnt_B)
				if(PeaksAreABLSized)
					if(DisplayWaveformMode == 2) // isEnv)
						Wave/Z ABLs = $SpHrView_OverTime_DF+"EnvABLs"
					else
						Wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
					endif
					if(waveexists(ABLs))
						ModifyGraph/W=$WinNameStr zmrkSize($LeftPeaksStr)={ABLs[*][FrequencyIndex],ABLmin,ABLmax,0,3}
					endif
				else
					ModifyGraph/W=$WinNameStr zmrkSize($LeftPeaksStr)={Peaks[*][FrequencyIndex][0][1],0,ScaledActivityLimit,0,3}
				endif
				NVAR appendPeaksToImageOppositeHemi = $SpHrView_OverTime_DF_Globals+"appendPeaksToImageOppositeHemi"
				if(appendPeaksToImageOppositeHemi)
					AppendToGraph/W=$WinNameStr/L=left_L/B=bottom_L Peaks[][FrequencyIndex][1]/TN=$LeftPeaksStr+"Opposite" vs PeakXs[][FrequencyIndex]  // /VERT  /L=left_R
					ModifyGraph/W=$WinNameStr mode($LeftPeaksStr+"Opposite")=3,marker($LeftPeaksStr+"Opposite")=8
					ModifyGraph/W=$WinNameStr mrkThick($LeftPeaksStr+"Opposite")=0.5,msize($LeftPeaksStr+"Opposite")=2,rgb($LeftPeaksStr+"Opposite")=(pnt_R,pnt_G,pnt_B,32768)
					if(PeaksAreABLSized)
						if(DisplayWaveformMode == 2) // isEnv)
							Wave/Z ABLs = $SpHrView_OverTime_DF+"EnvABLs"
						else
							Wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
						endif
						if(waveexists(ABLs))
							ModifyGraph/W=$WinNameStr zmrkSize($LeftPeaksStr+"Opposite")={ABLs[*][FrequencyIndex],ABLmin,ABLmax,0,3}
						endif
					else	
						ModifyGraph/W=$WinNameStr zmrkSize($LeftPeaksStr+"Opposite")={Peaks[*][FrequencyIndex][1][1],0,ScaledActivityLimit,0,3}
					endif
				endif
			endif
			
			// ABL alpha mask
			if(AlphaMask_ABL)
				wave/Z leftAlpha = $SpHrView_OverTime_DF+dfStr+leftAlphaStr
				if(waveexists(leftAlpha))
					AppendImage/W=$WinNameStr /G=1/L=left_L/B=bottom_L leftAlpha vs {XEdges, *}
					ModifyImage/W=$WinNameStr $leftAlphaStr ctab= {1,0,AlphaColorTable,0}
				endif
			endif
		endif
			
		
		////// Right
		if(waveexists(WR))
			AppendImage/W=$WinNameStr /G=1/L=left_R/B=bottom_R WR  vs {XEdges, *} // YEdges_R}// /G to suppress rgb(t)
		
			ModifyImage/W=$WinNameStr $wStrR ctab= {0,ScaledActivityLimit,ColorTable,0},ctabAutoscale=3,lookup= $""
			if(useHalfmaxLookup)
				ModifyImage/W=$WinNameStr $wStrR lookup=ColorTableLookup
			endif
			ModifyGraph/W=$WinNameStr axisEnab(left_R)={0,0.48},freePos(left_R)=0
			ModifyGraph/W=$WinNameStr freePos(bottom_R)={0,kwFraction}
		
			ModifyGraph/W=$WinNameStr lblPos(left_R)=38
			ModifyGraph/W=$WinNameStr zero(left_R)=1
			
			// Peaks
			wave Peaks = $SpHrView_OverTime_DF+PeaksWaveStr
			wave PeakXs = $SpHrView_OverTime_DF+PeaksWaveXsStr
			NVAR appendPeaksToImage = $SpHrView_OverTime_DF_Globals+"appendPeaksToImage"
			if(appendPeaksToImage && waveexists(Peaks))  
				AppendToGraph/W=$WinNameStr/L=left_R/B=bottom_R Peaks[][FrequencyIndex][1]/TN=$RightPeaksStr vs PeakXs[][FrequencyIndex]  
				ModifyGraph/W=$WinNameStr mode($RightPeaksStr)=3,marker($RightPeaksStr)=19
				ModifyGraph/W=$WinNameStr mrkThick($RightPeaksStr)=0.5,msize($RightPeaksStr)=2,rgb($RightPeaksStr)=(pnt_R,pnt_G,pnt_B)
				if(PeaksAreABLSized)
					if(DisplayWaveformMode == 2) // isEnv)
						Wave/Z ABLs = $SpHrView_OverTime_DF+"EnvABLs"
					else
						Wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
					endif
					if(waveexists(ABLs))
						ModifyGraph/W=$WinNameStr zmrkSize($RightPeaksStr)={ABLs[*][FrequencyIndex],ABLmin,ABLmax,0,3}
					endif
				else
					ModifyGraph/W=$WinNameStr zmrkSize($RightPeaksStr)={Peaks[*][FrequencyIndex][1][1],0,ScaledActivityLimit,0,3}
				endif
				NVAR appendPeaksToImageOppositeHemi = $SpHrView_OverTime_DF_Globals+"appendPeaksToImageOppositeHemi"
				if(appendPeaksToImageOppositeHemi)
					AppendToGraph/W=$WinNameStr/L=left_R/B=bottom_R Peaks[][FrequencyIndex][0]/TN=$RightPeaksStr+"Opposite" vs PeakXs[][FrequencyIndex]
					ModifyGraph/W=$WinNameStr mode($RightPeaksStr+"Opposite")=3,marker($RightPeaksStr+"Opposite")=8
					ModifyGraph/W=$WinNameStr mrkThick($RightPeaksStr+"Opposite")=0.5,msize($RightPeaksStr+"Opposite")=2,rgb($RightPeaksStr+"Opposite")=(pnt_R,pnt_G,pnt_B,32768)
					if(PeaksAreABLSized)
						if(DisplayWaveformMode == 2 ) // isEnv)
							Wave/Z ABLs = $SpHrView_OverTime_DF+"EnvABLs"
						else
							Wave/Z ABLs = $SpHrView_OverTime_DF+"ABLs"
						endif
						if(waveexists(ABLs))
							ModifyGraph/W=$WinNameStr zmrkSize($RightPeaksStr+"Opposite")={ABLs[*][FrequencyIndex],ABLmin,ABLmax,0,3}
						endif
					else	
						ModifyGraph/W=$WinNameStr zmrkSize($RightPeaksStr+"Opposite")={Peaks[*][FrequencyIndex][0][1],0,ScaledActivityLimit,0,3}
					endif
				endif
			endif
			
			// ABL alpha mask
			if(AlphaMask_ABL)
				wave/Z rightAlpha = $SpHrView_OverTime_DF+dfStr+rightAlphaStr
				if(waveexists(rightAlpha))
					AppendImage/W=$WinNameStr /G=1/L=left_R/B=bottom_R rightAlpha vs {XEdges, *}
					ModifyImage/W=$WinNameStr $rightAlphaStr ctab= {1,0,AlphaColorTable,0}
				endif
			endif
			
		endif
		
	endfor //  for(WaveformMode=0; WaveformMode < NumWaveformModes; WaveformMode++)
	// kludge (part 2) for displaying carrier and envelope activities...
	if(NumWaveformModes > 1)	
		DisplayWaveformMode=3
	endif
	
	/////
	ModifyGraph/W=$WinNameStr lblPos(bottom_R)=27
	Label/W=$WinNameStr bottom_L "\\u#2"
	Label/W=$WinNameStr bottom_R "time (\\U)"
	ModifyGraph/W=$WinNameStr nticks(bottom_R)=10
	ModifyGraph/W=$WinNameStr noLabel(bottom_L)=1
	
	SetAxis/W=$WinNameStr bottom_L BottomAxisMin,BottomAxisMax
	SetAxis/W=$WinNameStr bottom_R BottomAxisMin,BottomAxisMax
	
	String YUnitsStr = WaveUnits(WL, 1)
	SpHrView_OverTime_YAxisSet(WinNameStr, YUnitsStr, Frequency, FrequencyIndex)
		
	
	ColorScale/W=$WinNameStr/C/N=ActivityColorScale/F=0/B=1/M/A=MT/X=0.00/Y=0.00/E=2 vert=0,width=200,height=6,frame=0.00,lowTrip=0.001,image=$wStrR
	ColorScale/W=$WinNameStr/C/N=ActivityColorScale lblLatPos=170,font="Arial",fsize=9,lblMargin=15,tickLen=2.00,tickThick=0.50,ZisZ=1
	
	if(appendPeaksToImage && waveexists(Peaks)) 
		NVAR appendPeaksToImageOppositeHemi = $SpHrView_OverTime_DF_Globals+"appendPeaksToImageOppositeHemi"
		if(appendPeaksToImageOppositeHemi)
			TextBox/W=$WinNameStr/C/N=PeaksLegend/J/F=0/B=1/M/A=LT/E/X=20.00/Y=1.00 "\\F'Arial'\\Z10\\s("+LeftPeaksStr+")activitiy 'peaks'   \\s("+LeftPeaksStr+"Opposite)opposite hemisphere"
		else
			TextBox/W=$WinNameStr/C/N=PeaksLegend/J/F=0/B=1/M/A=LT/E/X=20.00/Y=1.00 "\\F'Arial'\\Z10\\s("+LeftPeaksStr+")activitiy 'peaks'"
		endif
	else
		TextBox/W=$WinNameStr/K/N=PeaksLegend
	endif

	ModifyGraph/W=$WinNameStr tick=2, mirror=0
	ModifyGraph/W=$WinNameStr font="Arial", fSize=10, lblMargin=2
	ModifyGraph/W=$WinNameStr standoff=0, axThick=0.5
	ModifyGraph/W=$WinNameStr ZisZ=1, zapTZ=1, zapLZ=1
	ModifyGraph/W=$WinNameStr btLen=4, btThick=0.5, stLen=2, stThick=0.5
	
	// Append Waveforms or their Envelopes
	NVAR AppendWaves = $SpHrView_OverTime_DF_Globals+"AppendWaves"
	if(AppendWaves)
		//if(DisplayWaveformMode == 2) // isEnv)
			// Not generating envelopes and it doesn't seem worth doing so just to plot them
		//else
			wave/Z FilterBanks = $SpHrView_df_filter+"FilterBanks"
			if(waveexists(FilterBanks))

				appendtograph/W=$WinNameStr/R=right_L/B=bottom_L FilterBanks[][FrequencyIndex][0]
				appendtograph/W=$WinNameStr/R=right_L/B=bottom_L FilterBanks[][FrequencyIndex][1]
				SetAxis/W=$WinNameStr/A=2/E=2 right_L
				ModifyGraph/W=$WinNameStr lblPos(right_L)=35,freePos(right_L)=0,lblMargin(right_L)=5
				ModifyGraph/W=$WinNameStr axisEnab(right_L)={0.52,1}
				ModifyGraph/W=$WinNameStr rgb(FilterBanks)=(0,0,65535,32768),rgb(FilterBanks#1)=(65535,0,0,32768)
				ModifyGraph/W=$WinNameStr lsize(FilterBanks)=0.5,lsize(FilterBanks#1)=0.5
				Label/W=$WinNameStr right_L "filterbank carrier (\\U)"
				
				appendtograph/W=$WinNameStr/R=right_R/B=bottom_R FilterBanks[][FrequencyIndex][0]
				appendtograph/W=$WinNameStr/R=right_R/B=bottom_R FilterBanks[][FrequencyIndex][1]
				SetAxis/W=$WinNameStr/A=2/E=2 right_R
				ModifyGraph lblPos(right_R)=35,freePos(right_R)=0,lblMargin(right_R)=5
				ModifyGraph/W=$WinNameStr axisEnab(right_R)={0,0.48}
				ModifyGraph/W=$WinNameStr rgb(FilterBanks#2)=(0,0,65535,32768),rgb(FilterBanks#3)=(65535,0,0,32768)
				ModifyGraph/W=$WinNameStr lsize(FilterBanks#2)=0.5,lsize(FilterBanks#3)=0.5
				Label/W=$WinNameStr right_R "filterbank carrier (\\U)"
				
			else
				killwaves/Z FilterBanks
			endif
		//endif
		ModifyGraph/W=$WinNameStr tick=2,fSize=10,axThick=0.5,useTSep(right_L)=1,useTSep(right_R)=1
		ModifyGraph/W=$WinNameStr ZisZ=1,zapTZ=1,zapLZ=1,standoff=0,btLen(right_L)=3,btLen(right_R)=3,btThick=0.5,stLen=2,stThick=0.5,font="Arial"
		Label/W=$WinNameStr right_L "\\u#2"
		Label/W=$WinNameStr right_R "\\u#2"

	endif
	
	
	
	if(!WindowExists)
		SetWindow $WinNameStr, hook(OverTimeHook)=SpHrView_OverTime_WindowHook
		SetWindow $WinNameStr note = "PACKAGE:SpHrView;GROUP:OverTimeWin;"
	endif
	
	SetDataFolder saveDFR
	return 0
End



Function SpHrView_OverTime_YAxisSet(String WinNameStr, String YUnitsStr, Variable Frequency, Variable FrequencyIndex)
	//String YUnitsStr = WaveUnits(WL, 1)
	//print YUnitsStr
	string globals_dfStr = SpHrView_OverTime_DF_Globals
	NVAR holdYAxisRange = $globals_dfStr+"holdYAxisRange"
	NVAR heldYAxisRange = $globals_dfStr+"heldYAxisRange"
	// DisplayActivitiesMode 1:Halfmaximal, 2: Maximal  ( no SD: 1)
	// DisplayWaveformMode 1: Carrier, 2: Envelope, 3: Carrier and Envelope
	NVAR DisplayActivitiesMode = $globals_dfStr+"DisplayActivitiesMode"
	NVAR DisplayWaveformMode = $globals_dfStr+"DisplayWaveformMode"
	
	Variable Ymax
	if(stringmatch(YUnitsStr, "dB"))
		NVAR maxContraHalfmaxILDLabel = $SpHrView_df_ILDNeuron+"maxContraHalfmaxILDLabel"
		NVAR minIpsiHalfmaxILDLabel = $SpHrView_df_ILDNeuron+"minIpsiHalfmaxILDLabel"
		Ymax = max(abs(maxContraHalfmaxILDLabel),abs(minIpsiHalfmaxILDLabel))
		Label/W=$WinNameStr left_L "ILD (\\U), Left"
		Label/W=$WinNameStr left_R "ILD (\\U), Right"
		heldYAxisRange = Ymax
		SetAxis/W=$WinNameStr/E=2 left_L -Ymax,Ymax
		SetAxis/W=$WinNameStr/E=2 left_R -Ymax,Ymax
		Slider sl_YAxisRange win=$WinNameStr, limits={Ymax/120,Ymax*3,0}
		Slider sl_YAxisRange win=$WinNameStr, value=Ymax
		
	elseif(stringmatch(YUnitsStr, "cycles"))
		NVAR maxContraHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
		NVAR minIpsiHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
		Ymax = max(abs(maxContraHalfmaxIPDLabel),abs(minIpsiHalfmaxIPDLabel))
		Label/W=$WinNameStr left_L "IPD (\\U), Left"
		Label/W=$WinNameStr left_R "IPD (\\U), Right"
		heldYAxisRange = Ymax
		SetAxis/W=$WinNameStr/E=2 left_L -Ymax,Ymax
		SetAxis/W=$WinNameStr/E=2 left_R -Ymax,Ymax
		Slider sl_YAxisRange win=$WinNameStr, limits={Ymax/120,Ymax*3,0}
		Slider sl_YAxisRange win=$WinNameStr, value=Ymax
	
	elseif(stringmatch(YUnitsStr, "s") || stringmatch(YUnitsStr, "sec"))
		NVAR maxContraHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
		NVAR minIpsiHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
		Ymax = max(abs(maxContraHalfmaxIPDLabel),abs(minIpsiHalfmaxIPDLabel))
		Label/W=$WinNameStr left_L "ITD (\\U), Left"
		Label/W=$WinNameStr left_R "ITD (\\U), Right"

		if(DisplayWaveformMode >= 2) 
			NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
			wave FilterWidths = $SpHrView_OverTime_DF+"FilterWidths"
			Ymax = Ymax/Frequency * (FilterWidths[FrequencyIndex]/IPDneuronWidth)
		else
			Ymax = Ymax/Frequency
		endif
		Ymax = min(Ymax,0.0015)

		heldYAxisRange = Ymax / Frequency
		SetAxis/W=$WinNameStr/E=2 left_L -Ymax,Ymax
		SetAxis/W=$WinNameStr/E=2 left_R -Ymax,Ymax			
		Slider sl_YAxisRange win=$WinNameStr, limits={Ymax/120,Ymax*3,0}
		Slider sl_YAxisRange win=$WinNameStr, value=Ymax
		
	elseif(stringmatch(YUnitsStr, "cycles_dB"))
		NVAR maxContraHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
		NVAR minIpsiHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
		Ymax = max(abs(maxContraHalfmaxIPDLabel),abs(minIpsiHalfmaxIPDLabel))
		Label/W=$WinNameStr left_L "Left hemisphere (IPD ⧓ ILD)\\u#2"
		Label/W=$WinNameStr left_R "Right hemisphere (IPD ⧓ ILD)\\u#2"
		ModifyGraph/W=$WinNameStr nticks(left_L)=3,tkLblRot(left_L)=90
		ModifyGraph/W=$WinNameStr nticks(left_R)=3,tkLblRot(left_R)=90
		heldYAxisRange = Ymax / Frequency
		SetAxis/W=$WinNameStr/E=2 left_L -Ymax,Ymax
		SetAxis/W=$WinNameStr/E=2 left_R -Ymax,Ymax			
		Slider sl_YAxisRange win=$WinNameStr, limits={Ymax/120,Ymax*3,0}
		Slider sl_YAxisRange win=$WinNameStr, value=Ymax
		
	else // if(stringmatch(YUnitsStr, "s_dB"))
		Label/W=$WinNameStr left_L "Left hemisphere (ITD ⧓ ILD)\\u#2"
		Label/W=$WinNameStr left_R "Right hemisphere (ITD ⧓ ILD)\\u#2"
		ModifyGraph/W=$WinNameStr nticks(left_L)=3,tkLblRot(left_L)=90
		ModifyGraph/W=$WinNameStr nticks(left_R)=3,tkLblRot(left_R)=90

		NVAR maxContraHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"maxContraHalfmaxIPDLabel"
		NVAR minIpsiHalfmaxIPDLabel = $SpHrView_df_IPDNeuron+"minIpsiHalfmaxIPDLabel"
		Ymax = max(abs(maxContraHalfmaxIPDLabel),abs(minIpsiHalfmaxIPDLabel))
		if(DisplayWaveformMode >= 2)
			NVAR IPDneuronWidth = $SpHrView_df_IPDNeuron+"IPDneuronWidth"
			wave FilterWidths = $SpHrView_OverTime_DF+"FilterWidths"
			Ymax = Ymax/Frequency * (FilterWidths[FrequencyIndex]/IPDneuronWidth)
			Ymax = min(Ymax,0.002)
		else
			Ymax = Ymax/Frequency
			Ymax = min(Ymax,0.0015)
		endif

		if(holdYAxisRange && numtype(heldYAxisRange)==0)
			if(Ymax > heldYAxisRange)
				CheckBox/Z ck_holdYAxisRange win=$WinNameStr, title="\\k(65535,0,0)•"
				ModifyGraph/Z/W=$WinNameStr fStyle(left_L)=1,fStyle(left_R)=1
			else
				CheckBox/Z ck_holdYAxisRange win=$WinNameStr, title=""
				ModifyGraph/W=$WinNameStr fStyle(left_L)=0,fStyle(left_R)=0
			endif
			Ymax = heldYAxisRange
		else
			heldYAxisRange = Ymax / Frequency
		endif
		SetAxis/W=$WinNameStr/E=2 left_L -Ymax,Ymax
		SetAxis/W=$WinNameStr/E=2 left_R -Ymax,Ymax			
		Slider sl_YAxisRange win=$WinNameStr, limits={Ymax/120,Ymax*3,0}
		Slider sl_YAxisRange win=$WinNameStr, value=Ymax
	endif
	
End